using chilkat;
using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Ftp2 : IDisposable
	{
		public delegate void FtpPercentDoneEventHandler(object sender, FtpPercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void DataPortEventHandler(object sender, DataPortEventArgs args);

		public delegate void BeginDownloadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void EndDownloadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyDownloadDirEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void BeginUploadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void EndUploadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyUploadDirEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyDeleteFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyDeleteDirEventHandler(object sender, FtpTreeEventArgs args);

		private static Hashtable m_ftpObjects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private object m_lockImpl;

		private unsafe ClsFtp2* m_impl;

		public unsafe bool AutoFix
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AutoFix(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AutoFix(m_impl, value);
			}
		}

		public unsafe string SyncPreview
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsFtp2_002Eget_SyncPreview(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AutoGetSizeForProgress
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AutoGetSizeForProgress(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AutoGetSizeForProgress(m_impl, value);
			}
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsFtp2_002Eget_SslProtocol(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsFtp2_002Eput_SslProtocol(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_VerboseLogging(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_VerboseLogging(m_impl, value);
			}
		}

		public unsafe string Greeting
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsFtp2_002Eget_Greeting(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksHostname((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksHostname((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksPassword((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksPassword((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksUsername((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksUsername((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int SocksPort
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksPort((ClsSocksClient*)((byte*)m_impl + 120));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksPort((ClsSocksClient*)((byte*)m_impl + 120), value);
			}
		}

		public unsafe int SocksVersion
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksVersion((ClsSocksClient*)((byte*)m_impl + 120));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksVersion((ClsSocksClient*)((byte*)m_impl + 120), value);
			}
		}

		public unsafe string ForcePortIpAddress
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsFtp2_002Eget_ForcePortIpAddress(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsFtp2_002Eput_ForcePortIpAddress(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool UseEpsv
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_UseEpsv(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_UseEpsv(m_impl, value);
			}
		}

		public unsafe int SendBufferSize
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_SendBufferSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_SendBufferSize(m_impl, value);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_ftpObjects == null)
					{
						m_ftpObjects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_ftpObjects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_ftpObjects = new Hashtable();
								m_ftpObjects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					m_ftpObjects.Remove(this);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe uint AsyncBytesSent => _003CModule_003E.ClsFtp2_002Eget_AsyncBytesSent(m_impl);

		public unsafe uint AsyncBytesReceived => _003CModule_003E.ClsFtp2_002Eget_AsyncBytesReceived(m_impl);

		public unsafe bool AsyncSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AsyncSuccess(m_impl);
			}
		}

		public unsafe string AsyncLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_AsyncLog(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AsyncFinished(m_impl);
			}
		}

		public unsafe bool PartialTransfer
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_PartialTransfer(m_impl);
			}
		}

		public unsafe bool AuthSsl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AuthSsl(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AuthSsl(m_impl, value);
			}
		}

		public unsafe bool RequireSslCertVerify
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				Monitor.Enter(m_lockImpl);
				bool result = _003CModule_003E.ClsFtp2_002Eget_RequireSslCertVerify(m_impl);
				Monitor.Exit(m_lockImpl);
				return result;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.ClsFtp2_002Eput_RequireSslCertVerify(m_impl, value);
				Monitor.Exit(m_lockImpl);
			}
		}

		public unsafe bool SslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				Monitor.Enter(m_lockImpl);
				bool result = _003CModule_003E.ClsFtp2_002Eget_SslServerCertVerified(m_impl);
				Monitor.Exit(m_lockImpl);
				return result;
			}
		}

		public unsafe int ProxyMethod
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ProxyMethod(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ProxyMethod(m_impl, value);
			}
		}

		public unsafe string ProxyPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_ProxyPassword(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_ProxyPassword(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ProxyUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_ProxyUsername(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_ProxyUsername(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ProxyHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_ProxyHostname(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_ProxyHostname(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int NumFilesAndDirs
		{
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				int result = 0;
				Monitor.Enter(m_lockImpl);
				try
				{
					_FtpCallback ftpCallback;
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002Eget_NumFilesAndDirs(m_impl, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num3 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040KBIGLBG_0040NumFilesAndDirs_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num3 != 0;
						}).Invoke())
						{
							goto IL_00a9;
						}
						goto end_IL_0085;
						IL_00a9:
						if (num3 != 0)
						{
							throw;
						}
						end_IL_0085:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
					}
				}
				Monitor.Exit(m_lockImpl);
				return result;
			}
		}

		public unsafe int UploadRate => _003CModule_003E.ClsFtp2_002Eget_UploadRate(m_impl);

		public unsafe int DownloadRate => _003CModule_003E.ClsFtp2_002Eget_DownloadRate(m_impl);

		public unsafe int IdleTimeoutMs
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_IdleTimeoutMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_IdleTimeoutMs(m_impl, value);
			}
		}

		public unsafe int HeartbeatMs
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_HeartbeatMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_HeartbeatMs(m_impl, value);
			}
		}

		public unsafe int ConnectTimeout
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ConnectTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ConnectTimeout(m_impl, value);
			}
		}

		public unsafe int ReadTimeout
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ReadTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ReadTimeout(m_impl, value);
			}
		}

		public unsafe int CrlfMode
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_CrlfMode(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_CrlfMode(m_impl, value);
			}
		}

		public unsafe int ConnectFailReason => *(int*)((byte*)m_impl + 1548);

		public unsafe int ProgressMonSize
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ProgressMonSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ProgressMonSize(m_impl, value);
			}
		}

		public unsafe int BandwidthThrottleDown
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_BandwidthThrottleDown(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_BandwidthThrottleDown(m_impl, value);
			}
		}

		public unsafe int BandwidthThrottleUp
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_BandwidthThrottleUp(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_BandwidthThrottleUp(m_impl, value);
			}
		}

		public unsafe long ProgressMonSize64
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ProgressMonSize64(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ProgressMonSize64(m_impl, value);
			}
		}

		public unsafe long AsyncBytesSent64 => _003CModule_003E.ClsFtp2_002Eget_AsyncBytesSent64(m_impl);

		public unsafe long AsyncBytesReceived64 => _003CModule_003E.ClsFtp2_002Eget_AsyncBytesReceived64(m_impl);

		public unsafe bool HasModeZ
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_HasModeZ(m_impl);
			}
		}

		public unsafe bool ConnectVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ConnectVerified(m_impl);
			}
		}

		public unsafe bool LoginVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_LoginVerified(m_impl);
			}
		}

		public unsafe bool SkipFinalReply
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_SkipFinalReply(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_SkipFinalReply(m_impl, value);
			}
		}

		public unsafe bool Passive
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_Passive(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_Passive(m_impl, value);
			}
		}

		public unsafe string Hostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_Hostname(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_Hostname(m_impl, _003CModule_003E.XString_002EgetAnsi(&xString));
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe uint AllocateSize
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AllocateSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AllocateSize(m_impl, value);
			}
		}

		public unsafe int ActivePortRangeEnd
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ActivePortRangeEnd(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ActivePortRangeEnd(m_impl, value);
			}
		}

		public unsafe int ActivePortRangeStart
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ActivePortRangeStart(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ActivePortRangeStart(m_impl, value);
			}
		}

		public unsafe int ProxyPort
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_ProxyPort(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_ProxyPort(m_impl, value);
			}
		}

		public unsafe int Port
		{
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_Port(m_impl);
			}
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_Port(m_impl, value);
			}
		}

		public unsafe string Username
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_UsernameX(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_UsernameX(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Password
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_PasswordX(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
					_003CModule_003E.XString_002EsecureClear(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_PasswordX(m_impl, &xString);
					_003CModule_003E.XString_002EsecureClear(&xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Account
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_Account(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_Account(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ListPattern
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_ListPatternX(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_ListPatternUtf8(m_impl, _003CModule_003E.XString_002EgetUtf8(&xString));
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DirListingCharset
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_DirListingCharset(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eput_DirListingCharset(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool AutoSyst
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AutoSyst(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AutoSyst(m_impl, value);
			}
		}

		public unsafe bool AutoXcrc
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AutoXcrc(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AutoXcrc(m_impl, value);
			}
		}

		public unsafe bool AutoFeat
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AutoFeat(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AutoFeat(m_impl, value);
			}
		}

		public unsafe bool RestartNext
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_RestartNext(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_RestartNext(m_impl, value);
			}
		}

		public unsafe bool AuthTls
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_AuthTls(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_AuthTls(m_impl, value);
			}
		}

		public unsafe bool Ssl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_Ssl(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_Ssl(m_impl, value);
			}
		}

		public unsafe bool PassiveUseHostAddr
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_PassiveUseHostAddr(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_PassiveUseHostAddr(m_impl, value);
			}
		}

		public unsafe string Version
		{
			get
			{
				StringBuffer stringBuffer;
				_003CModule_003E.chilkat_002EStringBuffer_002E_007Bctor_007D(&stringBuffer);
				string result;
				try
				{
					_003CModule_003E.ClsFtp2_002Eget_Version(m_impl, &stringBuffer);
					result = CkMarshal.AnsiToString(_003CModule_003E.chilkat_002EStringBuffer_002EgetString(&stringBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
					throw;
				}
				_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
				return result;
			}
		}

		public unsafe bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsFtp2_002Eget_KeepSessionLog(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsFtp2_002Eput_KeepSessionLog(m_impl, value);
			}
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002Eget_SessionLogX(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool IsConnected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				bool result = false;
				Monitor.Enter(m_lockImpl);
				try
				{
					_FtpCallback ftpCallback;
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002Eget_IsConnected(m_impl, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num3 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0M_0040ILOEPEDD_0040IsConnected_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num3 != 0;
						}).Invoke())
						{
							goto IL_00a9;
						}
						goto end_IL_0085;
						IL_00a9:
						if (num3 != 0)
						{
							throw;
						}
						end_IL_0085:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
					}
				}
				Monitor.Exit(m_lockImpl);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event VerifyDeleteDirEventHandler OnVerifyDeleteDir;

		public event VerifyDeleteFileEventHandler OnVerifyDeleteFile;

		public event VerifyUploadDirEventHandler OnVerifyUploadDir;

		public event EndUploadFileEventHandler OnEndUploadFile;

		public event BeginUploadFileEventHandler OnBeginUploadFile;

		public event VerifyDownloadDirEventHandler OnVerifyDownloadDir;

		public event EndDownloadFileEventHandler OnEndDownloadFile;

		public event BeginDownloadFileEventHandler OnBeginDownloadFile;

		public event DataPortEventHandler OnDataPort;

		public event AbortCheckEventHandler OnAbortCheck;

		public event FtpPercentDoneEventHandler OnFtpPercentDone;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Ftp2 LookupFtp(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Ftp2 result = (Ftp2)m_ftpObjects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FireFtpPercentDone(object sender, FtpPercentDoneEventArgs args)
		{
			this.OnFtpPercentDone?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public void FireDataPort(object sender, DataPortEventArgs args)
		{
			this.OnDataPort?.Invoke(sender, args);
		}

		public void FireBeginDownloadFile(object sender, FtpTreeEventArgs args)
		{
			this.OnBeginDownloadFile?.Invoke(sender, args);
		}

		public void FireEndDownloadFile(object sender, FtpTreeEventArgs args)
		{
			this.OnEndDownloadFile?.Invoke(sender, args);
		}

		public void FireVerifyDownloadDir(object sender, FtpTreeEventArgs args)
		{
			this.OnVerifyDownloadDir?.Invoke(sender, args);
		}

		public void FireBeginUploadFile(object sender, FtpTreeEventArgs args)
		{
			this.OnBeginUploadFile?.Invoke(sender, args);
		}

		public void FireEndUploadFile(object sender, FtpTreeEventArgs args)
		{
			this.OnEndUploadFile?.Invoke(sender, args);
		}

		public void FireVerifyUploadDir(object sender, FtpTreeEventArgs args)
		{
			this.OnVerifyUploadDir?.Invoke(sender, args);
		}

		public void FireVerifyDeleteFile(object sender, FtpTreeEventArgs args)
		{
			this.OnVerifyDeleteFile?.Invoke(sender, args);
		}

		public void FireVerifyDeleteDir(object sender, FtpTreeEventArgs args)
		{
			this.OnVerifyDeleteDir?.Invoke(sender, args);
		}

		public unsafe Ftp2()
		{
			m_enableEvents = false;
			this.OnFtpPercentDone = null;
			this.OnAbortCheck = null;
			this.OnDataPort = null;
			this.OnBeginDownloadFile = null;
			this.OnEndDownloadFile = null;
			this.OnVerifyDownloadDir = null;
			this.OnBeginUploadFile = null;
			this.OnEndUploadFile = null;
			this.OnVerifyUploadDir = null;
			this.OnVerifyDeleteFile = null;
			this.OnVerifyDeleteDir = null;
			m_lockImpl = new object();
			Monitor.Enter(m_lockObject);
			_003CModule_003E._003FA0x1be8bb0a_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0x1be8bb0a_002ENextHashCode;
			ClsFtp2* ptr = (ClsFtp2*)_003CModule_003E.@new(1552u);
			ClsFtp2* ptr2;
			try
			{
				ptr2 = (ClsFtp2*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsFtp2_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 1544) = 2;
			Monitor.Exit(m_lockObject);
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			Monitor.Enter(m_lockImpl);
			ClsFtp2* impl = m_impl;
			if (impl != null)
			{
				if (((byte*)impl)[545] != 0)
				{
					((byte*)impl)[544] = 1;
				}
				else
				{
					ClsFtp2* ptr = impl;
					((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				}
			}
			Monitor.Exit(m_lockImpl);
			try
			{
				Monitor.Enter(m_lockObject);
				m_ftpObjects.Remove(this);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public unsafe override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			ClsFtp2* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsFtp2_002EdotNetDispose(impl);
			}
			m_ftpObjects.Remove(this);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Disconnect()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(m_lockImpl);
			try
			{
				_FtpCallback ftpCallback;
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EDisconnect(m_impl, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num3 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0L_0040CMGJAGDM_0040Disconnect_003F_0024AA_0040));
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num3 != 0;
					}).Invoke())
					{
						goto IL_00a9;
					}
					goto end_IL_0085;
					IL_00a9:
					if (num3 != 0)
					{
						throw;
					}
					end_IL_0085:;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
				}
			}
			Monitor.Exit(m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(m_lockImpl);
			try
			{
				_FtpCallback ftpCallback;
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EConnect(m_impl, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num3 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_07FJPHLACI_0040Connect_003F_0024AA_0040));
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num3 != 0;
					}).Invoke())
					{
						goto IL_00a9;
					}
					goto end_IL_0085;
					IL_00a9:
					if (num3 != 0)
					{
						throw;
					}
					end_IL_0085:;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
				}
			}
			Monitor.Exit(m_lockImpl);
			return result;
		}

		public unsafe void ClearSessionLog()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsFtp2_002EClearSessionLog(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		public unsafe int DeleteMatching(string remotePattern)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(remotePattern, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EDeleteMatchingUtf8(m_impl, _003CModule_003E.XString_002EgetUtf8(&xString), (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int MGetFiles(string remotePattern, string localDir)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(remotePattern, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(localDir, &xString2);
					Monitor.Enter(m_lockImpl);
					_FtpCallback ftpCallback;
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002EMGetFilesUtf8(m_impl, _003CModule_003E.XString_002EgetUtf8(&xString), _003CModule_003E.XString_002EgetUtf8(&xString2), (ProgressEvent*)ptr);
						Monitor.Exit(m_lockImpl);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int MPutFiles(string pattern)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(pattern, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EMPutFilesUtf8(m_impl, _003CModule_003E.XString_002EgetUtf8(&xString), (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void ClearDirCache()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsFtp2_002EClearDirCache(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ClearControlChannel()
		{
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsFtp2_002EClearControlChannel(m_impl, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Noop()
		{
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsFtp2_002ENoop(m_impl, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RenameRemoteFile(string existingFilename, string newFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(existingFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(newFilename, &xString2);
					Monitor.Enter(m_lockImpl);
					_FtpCallback ftpCallback;
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002ERenameRemoteFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						Monitor.Exit(m_lockImpl);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteRemoteFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EDeleteRemoteFile(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveRemoteDir(string dir)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dir, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002ERemoveRemoteDir(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateRemoteDir(string dir)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dir, &xString);
				result = false;
				Monitor.Enter(m_lockImpl);
				try
				{
					_FtpCallback ftpCallback;
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002ECreateRemoteDir(m_impl, &xString, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num3 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040HFOBHHFC_0040CreateRemoteDir_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num3 != 0;
						}).Invoke())
						{
							goto IL_00bb;
						}
						goto end_IL_0097;
						IL_00bb:
						if (num3 != 0)
						{
							throw;
						}
						end_IL_0097:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
					}
				}
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetXmlDirListing(string pattern)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(pattern, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					bool flag = false;
					Monitor.Enter(m_lockImpl);
					try
					{
						_FtpCallback ftpCallback;
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							flag = _003CModule_003E.ClsFtp2_002EGetXmlDirListing(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BB_0040KODMFMBC_0040GetXmlDirListing_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_00c5;
							}
							goto end_IL_00a1;
							IL_00c5:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_00a1:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_00f9;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0010;
				IL_00f9:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0110;
				end_IL_0010:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0110:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetTextDirListing(string pattern)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			_FtpCallback ftpCallback;
			string result;
			try
			{
				CkMarshal.StringToX(pattern, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						bool flag = _003CModule_003E.ClsFtp2_002EGetTextDirListing(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						Monitor.Exit(m_lockImpl);
						if (!flag)
						{
							result = null;
							goto IL_0095;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					goto end_IL_0018;
					IL_0095:
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					goto IL_00b4;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_00b4:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00cb;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00cb:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutFileFromBinaryData(string remoteFilename, byte[] content)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(content, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					Monitor.Enter(m_lockImpl);
					_FtpCallback ftpCallback;
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr2 = null;
						if (m_enableEvents)
						{
							ptr2 = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002EPutFileFromBinaryData(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr2);
						Monitor.Exit(m_lockImpl);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutFileFromTextData(string remoteFilename, string textData, string charset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(textData, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(charset, &xString3);
						Monitor.Enter(m_lockImpl);
						_FtpCallback ftpCallback;
						_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
						try
						{
							*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsFtp2_002EPutFileFromTextDataUtf8(m_impl, &xString, _003CModule_003E.XString_002EgetUtf8(&xString2), _003CModule_003E.XString_002EgetUtf8(&xString3), (ProgressEvent*)ptr);
							Monitor.Exit(m_lockImpl);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] GetRemoteFileBinaryData(string remoteFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			_FtpCallback ftpCallback;
			byte[] result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						bool flag = _003CModule_003E.ClsFtp2_002EGetRemoteFileBinaryData(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr);
						Monitor.Exit(m_lockImpl);
						if (flag)
						{
							result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
							goto IL_00a7;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					goto end_IL_0018;
					IL_00a7:
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					goto IL_00c6;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0008;
				IL_00c6:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_00dd;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					try
					{
						result2 = null;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00dd:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetRemoteFileTextData(string remoteFilename)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					bool flag = false;
					Monitor.Enter(m_lockImpl);
					try
					{
						_FtpCallback ftpCallback;
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							flag = _003CModule_003E.ClsFtp2_002EGetRemoteFileTextData(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BG_0040NAOAHMCE_0040GetRemoteFileTextData_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_00c5;
							}
							goto end_IL_00a1;
							IL_00c5:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_00a1:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_00f9;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0010;
				IL_00f9:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0110;
				end_IL_0010:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0110:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetCurrentRemoteDir()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				bool flag = false;
				Monitor.Enter(m_lockImpl);
				try
				{
					_FtpCallback ftpCallback;
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						flag = _003CModule_003E.ClsFtp2_002EGetCurrentRemoteDir(m_impl, &xString, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num3 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BE_0040DDDBAFBM_0040GetCurrentRemoteDir_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num3 != 0;
						}).Invoke())
						{
							goto IL_00b3;
						}
						goto end_IL_008f;
						IL_00b3:
						if (num3 != 0)
						{
							throw;
						}
						end_IL_008f:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
					}
				}
				Monitor.Exit(m_lockImpl);
				if (!flag)
				{
					result = null;
					goto IL_00e7;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00e7:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChangeRemoteDir(string relativeDirPath)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(relativeDirPath, &xString);
				result = false;
				Monitor.Enter(m_lockImpl);
				try
				{
					_FtpCallback ftpCallback;
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002EChangeRemoteDir(m_impl, &xString, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num3 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040BDNGPACJ_0040ChangeRemoteDir_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num3 != 0;
						}).Invoke())
						{
							goto IL_00bb;
						}
						goto end_IL_0097;
						IL_00bb:
						if (num3 != 0)
						{
							throw;
						}
						end_IL_0097:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
					}
				}
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetFile(string remoteFilename, string localFilename)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(localFilename, &xString2);
					result = false;
					Monitor.Enter(m_lockImpl);
					try
					{
						_FtpCallback ftpCallback;
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsFtp2_002EGetFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_07DIGCHPDB_0040GetFile_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_00cd;
							}
							goto end_IL_00a9;
							IL_00cd:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_00a9:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutFile(string localFilename, string remoteFilename)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xString2);
					result = false;
					Monitor.Enter(m_lockImpl);
					try
					{
						_FtpCallback ftpCallback;
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsFtp2_002EPutFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_07CJMCNLMN_0040PutFile_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_00cd;
							}
							goto end_IL_00a9;
							IL_00cd:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_00a9:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFileFromBinaryData(string remoteFilename, byte[] content)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(content, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					Monitor.Enter(m_lockImpl);
					_FtpCallback ftpCallback;
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr2 = null;
						if (m_enableEvents)
						{
							ptr2 = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002EAppendFileFromBinaryData(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr2);
						Monitor.Exit(m_lockImpl);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFileFromTextData(string remoteFilename, string textData, string charset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(textData, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(charset, &xString3);
						Monitor.Enter(m_lockImpl);
						_FtpCallback ftpCallback;
						_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
						try
						{
							*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsFtp2_002EAppendFileFromTextDataUtf8(m_impl, &xString, _003CModule_003E.XString_002EgetUtf8(&xString2), _003CModule_003E.XString_002EgetUtf8(&xString3), (ProgressEvent*)ptr);
							Monitor.Exit(m_lockImpl);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFile(string localFilename, string remoteFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xString2);
					Monitor.Enter(m_lockImpl);
					_FtpCallback ftpCallback;
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002EAppendFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						Monitor.Exit(m_lockImpl);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int GetSize(int index)
		{
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			int result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsFtp2_002EGetSize(m_impl, index, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		public unsafe string GetSizeStr(int index)
		{
			StringBuffer stringBuffer;
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bctor_007D(&stringBuffer);
			_FtpCallback ftpCallback;
			string result;
			try
			{
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					bool flag = _003CModule_003E.ClsFtp2_002EGetSizeStr(m_impl, index, &stringBuffer, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0084;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				goto end_IL_0008;
				IL_0084:
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				goto IL_00a3;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.AnsiToString(_003CModule_003E.chilkat_002EStringBuffer_002EgetString(&stringBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
				throw;
			}
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
			return result2;
			IL_00a3:
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetModeZ()
		{
			return _003CModule_003E.ClsFtp2_002ESetModeZ(m_impl, null);
		}

		public unsafe string GetRemoteFileTextC(string remoteFilename, string charset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			_FtpCallback ftpCallback;
			string result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(charset, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
						try
						{
							*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							if (!_003CModule_003E.ClsFtp2_002EGetRemoteFileTextC(m_impl, &xString, &xString2, &xString3, (ProgressEvent*)ptr))
							{
								result = null;
								goto IL_0091;
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						goto end_IL_0028;
						IL_0091:
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
						goto IL_00b0;
						end_IL_0028:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_00b0:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_00c7;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_00c7:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00de;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							result2 = CkMarshal.XToString(&xString3);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00de:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe DateTime GetCreateTimeByName(string filename)
		{
			//Discarded unreachable code: IL_010f
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DateTime result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					_003CModule_003E.ClsFtp2_002EGetLocalCreateSysTimeByName(m_impl, &xString, &chilkatSysTime, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					result = default(DateTime);
					try
					{
						DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
						result = dateTime;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								result = DateTime.Now;
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00fe;
							}
							goto end_IL_00e4;
							IL_00fe:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00e4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe DateTime GetLastAccessTimeByName(string filename)
		{
			//Discarded unreachable code: IL_010f
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DateTime result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					_003CModule_003E.ClsFtp2_002EGetLocalLastAccessSysTimeByName(m_impl, &xString, &chilkatSysTime, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					result = default(DateTime);
					try
					{
						DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
						result = dateTime;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								result = DateTime.Now;
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00fe;
							}
							goto end_IL_00e4;
							IL_00fe:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00e4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe DateTime GetLastModifiedTimeByName(string filename)
		{
			//Discarded unreachable code: IL_010f
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DateTime result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					_003CModule_003E.ClsFtp2_002EGetLocalLastModifiedSysTimeByName(m_impl, &xString, &chilkatSysTime, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					result = default(DateTime);
					try
					{
						DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
						result = dateTime;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								result = DateTime.Now;
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00fe;
							}
							goto end_IL_00e4;
							IL_00fe:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00e4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int GetSizeByName(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EGetSizeByName(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetFilename(int index)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_FtpCallback ftpCallback;
			string result;
			try
			{
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					bool flag = _003CModule_003E.ClsFtp2_002EGetFilename(m_impl, index, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0084;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				goto end_IL_0008;
				IL_0084:
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				goto IL_00a3;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00a3:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetIsDirectory(int index)
		{
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsFtp2_002EGetIsDirectory(m_impl, index, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetIsSymbolicLink(int index)
		{
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsFtp2_002EGetIsSymbolicLink(m_impl, index, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		public unsafe DateTime GetCreateTime(int index)
		{
			//Discarded unreachable code: IL_00fe
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ChilkatSysTime chilkatSysTime;
			_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			DateTime result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.ClsFtp2_002EGetLocalCreateSysTime(m_impl, index, &chilkatSysTime, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
				result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00ed;
						}
						goto end_IL_00d3;
						IL_00ed:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_00d3:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		public unsafe DateTime GetLastAccessTime(int index)
		{
			//Discarded unreachable code: IL_00fe
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ChilkatSysTime chilkatSysTime;
			_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			DateTime result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.ClsFtp2_002EGetLocalLastAccessSysTime(m_impl, index, &chilkatSysTime, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
				result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00ed;
						}
						goto end_IL_00d3;
						IL_00ed:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_00d3:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		public unsafe DateTime GetLastModifiedTime(int index)
		{
			//Discarded unreachable code: IL_00fe
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ChilkatSysTime chilkatSysTime;
			_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			DateTime result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.ClsFtp2_002EGetLocalLastModifiedSysTime(m_impl, index, &chilkatSysTime, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
				result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00ed;
						}
						goto end_IL_00d3;
						IL_00ed:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_00d3:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DownloadTree(string localRoot)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(localRoot, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EDownloadTree(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteTree()
		{
			Monitor.Enter(m_lockImpl);
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsFtp2_002EDeleteTree(m_impl, (ProgressEvent*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SyncRemoteTree(string localRoot, int mode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(localRoot, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002ESyncRemoteTree(m_impl, &xString, mode, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SyncLocalTree(string localRoot, int mode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(localRoot, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002ESyncLocalTree(m_impl, &xString, mode, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			Monitor.Enter(m_lockObject);
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsFtp2_002EUnlockComponentX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				Monitor.Exit(m_lockObject);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsFtp2* impl = m_impl;
			return ((delegate* thiscall<IntPtr, byte>)(*(int*)(*(int*)impl + 8)))((IntPtr)impl) != 0;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetTypeBinary()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(m_lockImpl);
			try
			{
				_FtpCallback ftpCallback;
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002ESetTypeBinary(m_impl, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num3 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040BLFCMLEP_0040SetTypeBinary_003F_0024AA_0040));
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num3 != 0;
					}).Invoke())
					{
						goto IL_00a9;
					}
					goto end_IL_0085;
					IL_00a9:
					if (num3 != 0)
					{
						throw;
					}
					end_IL_0085:;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
				}
			}
			Monitor.Exit(m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetTypeAscii()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(m_lockImpl);
			try
			{
				_FtpCallback ftpCallback;
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bctor_007D(&ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						int num2 = *(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002ESetTypeAscii(m_impl, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D(&ftpCallback);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num3 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0N_0040IDDMECLP_0040SetTypeAscii_003F_0024AA_0040));
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num3 != 0;
					}).Invoke())
					{
						goto IL_00a9;
					}
					goto end_IL_0085;
					IL_00a9:
					if (num3 != 0)
					{
						throw;
					}
					end_IL_0085:;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
				}
			}
			Monitor.Exit(m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Quote(string cmd)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(cmd, &xString);
				Monitor.Enter(m_lockImpl);
				_FtpCallback ftpCallback;
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsFtp2_002EQuote(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Site(string @params)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(@params, &xString);
				Monitor.Enter(m_lockImpl);
				if (m_enableEvents)
				{
					_FtpCallback* ptr = (_FtpCallback*)_003CModule_003E.@new(8u);
					_FtpCallback* ptr2;
					try
					{
						if (ptr != null)
						{
							_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)ptr);
							try
							{
								*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
								*(int*)((byte*)ptr + 4) = 0;
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), ptr);
								throw;
							}
							ptr2 = ptr;
						}
						else
						{
							ptr2 = null;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.delete(ptr);
						throw;
					}
					int num = *(int*)((byte*)ptr2 + 4) = m_myHashCode;
					result = _003CModule_003E.ClsFtp2_002ESite(m_impl, &xString, (ProgressEvent*)ptr2);
					((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
				}
				else
				{
					result = _003CModule_003E.ClsFtp2_002ESite(m_impl, &xString, null);
				}
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string Syst()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_FtpCallback ftpCallback;
			string result;
			try
			{
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					bool flag = _003CModule_003E.ClsFtp2_002ESyst(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0083;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				goto end_IL_0008;
				IL_0083:
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				goto IL_00a2;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00a2:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string Feat()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_FtpCallback ftpCallback;
			string result;
			try
			{
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					bool flag = _003CModule_003E.ClsFtp2_002EFeat(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0083;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				goto end_IL_0008;
				IL_0083:
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				goto IL_00a2;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00a2:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string Stat()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_FtpCallback ftpCallback;
			string result;
			try
			{
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
				try
				{
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &ftpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
					}
					bool flag = _003CModule_003E.ClsFtp2_002EStat(m_impl, &xString, (ProgressEvent*)ptr);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0083;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				goto end_IL_0008;
				IL_0083:
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				goto IL_00a2;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
					throw;
				}
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00a2:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string SendCommand(string cmd)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			_FtpCallback ftpCallback;
			string result;
			try
			{
				CkMarshal.StringToX(cmd, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						bool flag = _003CModule_003E.ClsFtp2_002ESendCommand(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						Monitor.Exit(m_lockImpl);
						if (!flag)
						{
							result = null;
							goto IL_0095;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					goto end_IL_0018;
					IL_0095:
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					goto IL_00b4;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_00b4:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00cb;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00cb:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string CreatePlan(string localDir)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(localDir, &xString2);
					Monitor.Enter(m_lockImpl);
					bool flag = _003CModule_003E.ClsFtp2_002EPutTree(m_impl, &xString2, &xString, true, 0, null);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0058;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0058:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_006f;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_006f:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutTree(string localDir)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(localDir, &xString2);
					Monitor.Enter(m_lockImpl);
					_FtpCallback ftpCallback;
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsFtp2_002EPutTree(m_impl, &xString2, &xString, false, 0, (ProgressEvent*)ptr);
						Monitor.Exit(m_lockImpl);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutPlan(string plan, string alreadyDoneFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(plan, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(alreadyDoneFilename, &xString3);
						Monitor.Enter(m_lockImpl);
						_FtpCallback ftpCallback;
						_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
						try
						{
							*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &ftpCallback;
								*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsFtp2_002EPutPlan(m_impl, &xString2, &xString3, &xString, (ProgressEvent*)ptr);
							Monitor.Exit(m_lockImpl);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
							throw;
						}
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert GetSslServerCert()
		{
			Monitor.Enter(m_lockImpl);
			ClsCert* ptr = _003CModule_003E.ClsFtp2_002EGetSslServerCert(m_impl);
			Monitor.Exit(m_lockImpl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		public unsafe void SetSslCertRequirement(string name, string value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(name, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(value, &xString2);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsFtp2_002ESetSslCertRequirement(m_impl, &xString, &xString2);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe string DetermineSettings()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				Monitor.Enter(m_lockImpl);
				bool flag = _003CModule_003E.ClsFtp2_002EDetermineSettings(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (!flag)
				{
					result = null;
					goto IL_0043;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0043:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int DetermineProxyMethod()
		{
			Monitor.Enter(m_lockImpl);
			int result = _003CModule_003E.ClsFtp2_002EDetermineProxyMethod(m_impl);
			Monitor.Exit(m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncGetFileStart(string remoteFilename, string localFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(localFilename, &xString2);
					Monitor.Enter(m_lockImpl);
					result = _003CModule_003E.ClsFtp2_002EAsyncGetFileStart(m_impl, &xString, &xString2);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncPutFileStart(string localFilename, string remoteFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xString2);
					Monitor.Enter(m_lockImpl);
					result = _003CModule_003E.ClsFtp2_002EAsyncPutFileStart(m_impl, &xString, &xString2);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncAppendFileStart(string localFilename, string remoteFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xString2);
					Monitor.Enter(m_lockImpl);
					result = _003CModule_003E.ClsFtp2_002EAsyncAppendFileStart(m_impl, &xString, &xString2);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void AsyncAbort()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsFtp2_002EAsyncAbort(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		public unsafe void SleepMs(int millisec)
		{
			_003CModule_003E.ClsFtp2_002ESleepMs(m_impl, millisec);
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsFtp2_002ESetSslClientCert(m_impl, ptr);
			Monitor.Exit(m_lockImpl);
		}

		public unsafe string DirTreeXml()
		{
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			XString xString;
			string result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					if (!_003CModule_003E.ClsFtp2_002EDirTreeXml(m_impl, &xString, (ProgressEvent*)ptr))
					{
						result = null;
						goto IL_006d;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_006d:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_0084;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result2;
			IL_0084:
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		public unsafe void SetOldestDate(DateTime oldestDateTime)
		{
			ChilkatSysTime chilkatSysTime;
			_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
			*(short*)(&chilkatSysTime) = (short)oldestDateTime.Year;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)oldestDateTime.Month;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)oldestDateTime.Day;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)oldestDateTime.Hour;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)oldestDateTime.Minute;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)oldestDateTime.Second;
			_003CModule_003E.ClsFtp2_002ESetOldestDate(m_impl, &chilkatSysTime);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToTls()
		{
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsFtp2_002EConvertToTls(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		public unsafe string GetSizeStrByName(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			_FtpCallback ftpCallback;
			string result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
					try
					{
						*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &ftpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
						}
						if (!_003CModule_003E.ClsFtp2_002EGetSizeStrByName(m_impl, &xString, &xString2, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					goto end_IL_0018;
					IL_007f:
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
					goto IL_009e;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_009e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00b5;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
						throw;
					}
					*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00b5:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetRemoteFileDateTime(DateTime dt, string remoteFilename)
		{
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				*(short*)(&chilkatSysTime) = (short)dt.Year;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)dt.Month;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)dt.Day;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)dt.Hour;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)dt.Minute;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)dt.Second;
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xString);
					result = _003CModule_003E.ClsFtp2_002ESetRemoteFileDateTime(m_impl, &chilkatSysTime, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		public unsafe string NlstXml(string pattern)
		{
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			string result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(pattern, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						if (!_003CModule_003E.ClsFtp2_002ENlstXml(m_impl, &xString, &xString2, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_007f:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_0096;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0096:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00ad;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result2;
			IL_00ad:
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xString3);
						result = _003CModule_003E.ClsFtp2_002ESetSslClientCertPfx(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SyncRemoteTree2(string localRoot, int mode, [MarshalAs(UnmanagedType.U1)] bool bDescend, [MarshalAs(UnmanagedType.U1)] bool bPreviewOnly)
		{
			_FtpCallback ftpCallback;
			_003CModule_003E.FtpCallback_002E_007Bctor_007D((FtpCallback*)(&ftpCallback));
			try
			{
				*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &ftpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref ftpCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(localRoot, &xString);
					result = _003CModule_003E.ClsFtp2_002ESyncRemoteTree2(m_impl, &xString, mode, bDescend, bPreviewOnly, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_FtpCallback_002E_007Bdtor_007D), &ftpCallback);
				throw;
			}
			*(int*)(&ftpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_FtpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.FtpCallback_002E_007Bdtor_007D((FtpCallback*)(&ftpCallback));
			return result;
		}

		protected void raise_OnFtpPercentDone(object i1, FtpPercentDoneEventArgs i2)
		{
			this.OnFtpPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		protected void raise_OnDataPort(object i1, DataPortEventArgs i2)
		{
			this.OnDataPort?.Invoke(i1, i2);
		}

		protected void raise_OnBeginDownloadFile(object i1, FtpTreeEventArgs i2)
		{
			this.OnBeginDownloadFile?.Invoke(i1, i2);
		}

		protected void raise_OnEndDownloadFile(object i1, FtpTreeEventArgs i2)
		{
			this.OnEndDownloadFile?.Invoke(i1, i2);
		}

		protected void raise_OnVerifyDownloadDir(object i1, FtpTreeEventArgs i2)
		{
			this.OnVerifyDownloadDir?.Invoke(i1, i2);
		}

		protected void raise_OnBeginUploadFile(object i1, FtpTreeEventArgs i2)
		{
			this.OnBeginUploadFile?.Invoke(i1, i2);
		}

		protected void raise_OnEndUploadFile(object i1, FtpTreeEventArgs i2)
		{
			this.OnEndUploadFile?.Invoke(i1, i2);
		}

		protected void raise_OnVerifyUploadDir(object i1, FtpTreeEventArgs i2)
		{
			this.OnVerifyUploadDir?.Invoke(i1, i2);
		}

		protected void raise_OnVerifyDeleteFile(object i1, FtpTreeEventArgs i2)
		{
			this.OnVerifyDeleteFile?.Invoke(i1, i2);
		}

		protected void raise_OnVerifyDeleteDir(object i1, FtpTreeEventArgs i2)
		{
			this.OnVerifyDeleteDir?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
