using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[TypeLibType(2)]
	[ClassInterface(0)]
	[Guid("0D43FE01-F093-11CF-8940-00A0C9054228")]
	public class FileSystemObjectClass : IFileSystem3, FileSystemObject
	{
		[DispId(10010)]
		public virtual Drives Drives
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10010)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		public extern FileSystemObjectClass();

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10000)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string BuildPath([In] [MarshalAs(UnmanagedType.BStr)] string Path, [In] [MarshalAs(UnmanagedType.BStr)] string Name);

		string IFileSystem3.BuildPath([In] [MarshalAs(UnmanagedType.BStr)] string Path, [In] [MarshalAs(UnmanagedType.BStr)] string Name)
		{
			//ILSpy generated this explicit interface implementation from .override directive in BuildPath
			return this.BuildPath(Path, Name);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10004)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetDriveName([In] [MarshalAs(UnmanagedType.BStr)] string Path);

		string IFileSystem3.GetDriveName([In] [MarshalAs(UnmanagedType.BStr)] string Path)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetDriveName
			return this.GetDriveName(Path);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10005)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetParentFolderName([In] [MarshalAs(UnmanagedType.BStr)] string Path);

		string IFileSystem3.GetParentFolderName([In] [MarshalAs(UnmanagedType.BStr)] string Path)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetParentFolderName
			return this.GetParentFolderName(Path);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10006)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetFileName([In] [MarshalAs(UnmanagedType.BStr)] string Path);

		string IFileSystem3.GetFileName([In] [MarshalAs(UnmanagedType.BStr)] string Path)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetFileName
			return this.GetFileName(Path);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10007)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetBaseName([In] [MarshalAs(UnmanagedType.BStr)] string Path);

		string IFileSystem3.GetBaseName([In] [MarshalAs(UnmanagedType.BStr)] string Path)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetBaseName
			return this.GetBaseName(Path);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10008)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetExtensionName([In] [MarshalAs(UnmanagedType.BStr)] string Path);

		string IFileSystem3.GetExtensionName([In] [MarshalAs(UnmanagedType.BStr)] string Path)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetExtensionName
			return this.GetExtensionName(Path);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10002)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetAbsolutePathName([In] [MarshalAs(UnmanagedType.BStr)] string Path);

		string IFileSystem3.GetAbsolutePathName([In] [MarshalAs(UnmanagedType.BStr)] string Path)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetAbsolutePathName
			return this.GetAbsolutePathName(Path);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10003)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetTempName();

		string IFileSystem3.GetTempName()
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetTempName
			return this.GetTempName();
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10015)]
		public virtual extern bool DriveExists([In] [MarshalAs(UnmanagedType.BStr)] string DriveSpec);

		bool IFileSystem3.DriveExists([In] [MarshalAs(UnmanagedType.BStr)] string DriveSpec)
		{
			//ILSpy generated this explicit interface implementation from .override directive in DriveExists
			return this.DriveExists(DriveSpec);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10016)]
		public virtual extern bool FileExists([In] [MarshalAs(UnmanagedType.BStr)] string FileSpec);

		bool IFileSystem3.FileExists([In] [MarshalAs(UnmanagedType.BStr)] string FileSpec)
		{
			//ILSpy generated this explicit interface implementation from .override directive in FileExists
			return this.FileExists(FileSpec);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10017)]
		public virtual extern bool FolderExists([In] [MarshalAs(UnmanagedType.BStr)] string FolderSpec);

		bool IFileSystem3.FolderExists([In] [MarshalAs(UnmanagedType.BStr)] string FolderSpec)
		{
			//ILSpy generated this explicit interface implementation from .override directive in FolderExists
			return this.FolderExists(FolderSpec);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10011)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern Drive GetDrive([In] [MarshalAs(UnmanagedType.BStr)] string DriveSpec);

		Drive IFileSystem3.GetDrive([In] [MarshalAs(UnmanagedType.BStr)] string DriveSpec)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetDrive
			return this.GetDrive(DriveSpec);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10012)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern File GetFile([In] [MarshalAs(UnmanagedType.BStr)] string FilePath);

		File IFileSystem3.GetFile([In] [MarshalAs(UnmanagedType.BStr)] string FilePath)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetFile
			return this.GetFile(FilePath);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10013)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern Folder GetFolder([In] [MarshalAs(UnmanagedType.BStr)] string FolderPath);

		Folder IFileSystem3.GetFolder([In] [MarshalAs(UnmanagedType.BStr)] string FolderPath)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetFolder
			return this.GetFolder(FolderPath);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10014)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern Folder GetSpecialFolder([In] [ComAliasName("IWshRuntimeLibrary.SpecialFolderConst")] SpecialFolderConst SpecialFolder);

		Folder IFileSystem3.GetSpecialFolder([In] [ComAliasName("IWshRuntimeLibrary.SpecialFolderConst")] SpecialFolderConst SpecialFolder)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetSpecialFolder
			return this.GetSpecialFolder(SpecialFolder);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1200)]
		public virtual extern void DeleteFile([In] [MarshalAs(UnmanagedType.BStr)] string FileSpec, [In] bool Force = false);

		void IFileSystem3.DeleteFile([In] [MarshalAs(UnmanagedType.BStr)] string FileSpec, [In] bool Force = false)
		{
			//ILSpy generated this explicit interface implementation from .override directive in DeleteFile
			this.DeleteFile(FileSpec, Force);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1201)]
		public virtual extern void DeleteFolder([In] [MarshalAs(UnmanagedType.BStr)] string FolderSpec, [In] bool Force = false);

		void IFileSystem3.DeleteFolder([In] [MarshalAs(UnmanagedType.BStr)] string FolderSpec, [In] bool Force = false)
		{
			//ILSpy generated this explicit interface implementation from .override directive in DeleteFolder
			this.DeleteFolder(FolderSpec, Force);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1204)]
		public virtual extern void MoveFile([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination);

		void IFileSystem3.MoveFile([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination)
		{
			//ILSpy generated this explicit interface implementation from .override directive in MoveFile
			this.MoveFile(Source, Destination);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1205)]
		public virtual extern void MoveFolder([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination);

		void IFileSystem3.MoveFolder([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination)
		{
			//ILSpy generated this explicit interface implementation from .override directive in MoveFolder
			this.MoveFolder(Source, Destination);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1202)]
		public virtual extern void CopyFile([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination, [In] bool OverWriteFiles = true);

		void IFileSystem3.CopyFile([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination, [In] bool OverWriteFiles = true)
		{
			//ILSpy generated this explicit interface implementation from .override directive in CopyFile
			this.CopyFile(Source, Destination, OverWriteFiles);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1203)]
		public virtual extern void CopyFolder([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination, [In] bool OverWriteFiles = true);

		void IFileSystem3.CopyFolder([In] [MarshalAs(UnmanagedType.BStr)] string Source, [In] [MarshalAs(UnmanagedType.BStr)] string Destination, [In] bool OverWriteFiles = true)
		{
			//ILSpy generated this explicit interface implementation from .override directive in CopyFolder
			this.CopyFolder(Source, Destination, OverWriteFiles);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1120)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern Folder CreateFolder([In] [MarshalAs(UnmanagedType.BStr)] string Path);

		Folder IFileSystem3.CreateFolder([In] [MarshalAs(UnmanagedType.BStr)] string Path)
		{
			//ILSpy generated this explicit interface implementation from .override directive in CreateFolder
			return this.CreateFolder(Path);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1101)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern TextStream CreateTextFile([In] [MarshalAs(UnmanagedType.BStr)] string FileName, [In] bool Overwrite = true, [In] bool Unicode = false);

		TextStream IFileSystem3.CreateTextFile([In] [MarshalAs(UnmanagedType.BStr)] string FileName, [In] bool Overwrite = true, [In] bool Unicode = false)
		{
			//ILSpy generated this explicit interface implementation from .override directive in CreateTextFile
			return this.CreateTextFile(FileName, Overwrite, Unicode);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1100)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern TextStream OpenTextFile([In] [MarshalAs(UnmanagedType.BStr)] string FileName, [In] IOMode IOMode = IOMode.ForReading, [In] bool Create = false, [In] Tristate Format = Tristate.TristateFalse);

		TextStream IFileSystem3.OpenTextFile([In] [MarshalAs(UnmanagedType.BStr)] string FileName, [In] IOMode IOMode = IOMode.ForReading, [In] bool Create = false, [In] Tristate Format = Tristate.TristateFalse)
		{
			//ILSpy generated this explicit interface implementation from .override directive in OpenTextFile
			return this.OpenTextFile(FileName, IOMode, Create, Format);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(20000)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern TextStream GetStandardStream([In] [ComAliasName("IWshRuntimeLibrary.StandardStreamTypes")] StandardStreamTypes StandardStreamType, [In] bool Unicode = false);

		TextStream IFileSystem3.GetStandardStream([In] [ComAliasName("IWshRuntimeLibrary.StandardStreamTypes")] StandardStreamTypes StandardStreamType, [In] bool Unicode = false)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetStandardStream
			return this.GetStandardStream(StandardStreamType, Unicode);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(20010)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string GetFileVersion([In] [MarshalAs(UnmanagedType.BStr)] string FileName);

		string IFileSystem3.GetFileVersion([In] [MarshalAs(UnmanagedType.BStr)] string FileName)
		{
			//ILSpy generated this explicit interface implementation from .override directive in GetFileVersion
			return this.GetFileVersion(FileName);
		}
	}
}
