using System;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[ClassInterface(0)]
	[DefaultMember("Path")]
	[Guid("C7C3F5B3-88A3-11D0-ABCB-00A0C90FFFC0")]
	public class FolderClass : IFolder, Folder
	{
		[DispId(0)]
		public virtual string Path
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(0)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1000)]
		public virtual string Name
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1000)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1000)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(1002)]
		public virtual string ShortPath
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1002)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1001)]
		public virtual string ShortName
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1001)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1004)]
		public virtual Drive Drive
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1004)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(1005)]
		public virtual Folder ParentFolder
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1005)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(1003)]
		[ComAliasName("IWshRuntimeLibrary.FileAttribute")]
		public virtual FileAttribute Attributes
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1003)]
			[return: ComAliasName("IWshRuntimeLibrary.FileAttribute")]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1003)]
			[param: In]
			[param: ComAliasName("IWshRuntimeLibrary.FileAttribute")]
			set;
		}

		[DispId(1006)]
		public virtual DateTime DateCreated
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1006)]
			get;
		}

		[DispId(1007)]
		public virtual DateTime DateLastModified
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1007)]
			get;
		}

		[DispId(1008)]
		public virtual DateTime DateLastAccessed
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1008)]
			get;
		}

		[DispId(1010)]
		public virtual string Type
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1010)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(10000)]
		public virtual bool IsRootFolder
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10000)]
			get;
		}

		[DispId(1009)]
		public virtual object Size
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1009)]
			[return: MarshalAs(UnmanagedType.Struct)]
			get;
		}

		[DispId(10001)]
		public virtual Folders SubFolders
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10001)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(10002)]
		public virtual Files Files
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10002)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		internal extern FolderClass();

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1201)]
		public virtual extern void Delete([In] bool Force = false);

		void IFolder.Delete([In] bool Force = false)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Delete
			this.Delete(Force);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1203)]
		public virtual extern void Copy([In] [MarshalAs(UnmanagedType.BStr)] string Destination, [In] bool OverWriteFiles = true);

		void IFolder.Copy([In] [MarshalAs(UnmanagedType.BStr)] string Destination, [In] bool OverWriteFiles = true)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Copy
			this.Copy(Destination, OverWriteFiles);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1205)]
		public virtual extern void Move([In] [MarshalAs(UnmanagedType.BStr)] string Destination);

		void IFolder.Move([In] [MarshalAs(UnmanagedType.BStr)] string Destination)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Move
			this.Move(Destination);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1101)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern TextStream CreateTextFile([In] [MarshalAs(UnmanagedType.BStr)] string FileName, [In] bool Overwrite = true, [In] bool Unicode = false);

		TextStream IFolder.CreateTextFile([In] [MarshalAs(UnmanagedType.BStr)] string FileName, [In] bool Overwrite = true, [In] bool Unicode = false)
		{
			//ILSpy generated this explicit interface implementation from .override directive in CreateTextFile
			return this.CreateTextFile(FileName, Overwrite, Unicode);
		}
	}
}
