using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class ByteBuffer : IDisposable
	{
		private unsafe DataBuffer* m_impl;

		public unsafe uint Length => _003CModule_003E.DataBuffer_002EgetSize(m_impl);

		public unsafe ByteBuffer(void* impl)
		{
			m_impl = (DataBuffer*)impl;
		}

		public unsafe ByteBuffer()
		{
			DataBuffer* ptr = (DataBuffer*)_003CModule_003E.@new(32u);
			DataBuffer* impl;
			try
			{
				impl = (DataBuffer*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.DataBuffer_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			DataBuffer* impl = m_impl;
			if (impl != null)
			{
				DataBuffer* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
		}

		public override void Dispose()
		{
		}

		public unsafe byte[] GetBytes()
		{
			return CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(m_impl), (int)_003CModule_003E.DataBuffer_002EgetSize(m_impl));
		}

		public unsafe byte[] Left(uint numBytes)
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				uint num = _003CModule_003E.DataBuffer_002EgetSize(m_impl);
				if (num > numBytes)
				{
					num = numBytes;
				}
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, _003CModule_003E.DataBuffer_002EgetData2(m_impl), num);
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] Right(uint numBytes)
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				uint num = _003CModule_003E.DataBuffer_002EgetSize(m_impl);
				if (num > numBytes)
				{
					num = numBytes;
				}
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, _003CModule_003E.DataBuffer_002EgetDataAt2(m_impl, (int)(_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer) - num)), num);
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] Mid(uint startIdx, uint numBytes)
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			uint num;
			try
			{
				num = _003CModule_003E.DataBuffer_002EgetSize(m_impl);
				if (startIdx >= num)
				{
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					goto IL_003e;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			byte[] result2;
			try
			{
				num -= startIdx;
				if (num > numBytes)
				{
					num = numBytes;
				}
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, _003CModule_003E.DataBuffer_002EgetDataAt2(m_impl, (int)startIdx), num);
				result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_003e:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe void Replace(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			_003CModule_003E.DataBuffer_002Eclear(m_impl);
			_003CModule_003E.DataBuffer_002Eappend(m_impl, ptr, (uint)num);
			CkMarshal.free(ptr);
		}

		public unsafe void Append(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			_003CModule_003E.DataBuffer_002Eappend(m_impl, ptr, (uint)num);
			CkMarshal.free(ptr);
		}

		public unsafe void Prepend(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, m_impl);
				_003CModule_003E.DataBuffer_002Eclear(m_impl);
				_003CModule_003E.DataBuffer_002Eappend(m_impl, &dataBuffer);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
		}

		public unsafe void AppendStr(string str, string charset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(charset, &xString2);
					global::Charset charset2;
					_003CModule_003E.Charset_002E_007Bctor_007D(&charset2);
					try
					{
						DataBuffer dataBuffer;
						_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
						try
						{
							_003CModule_003E.Charset_002EsetByName(&charset2, _003CModule_003E.XString_002EgetUtf8(&xString2));
							_003CModule_003E.XString_002EgetConverted(&xString, &charset2, &dataBuffer);
							_003CModule_003E.DataBuffer_002Eappend(m_impl, &dataBuffer);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
							throw;
						}
						_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Charset_002E_007Bdtor_007D), &charset2);
						throw;
					}
					_003CModule_003E.Charset_002E_007Bdtor_007D(&charset2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void PrependStr(string str, string charset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(charset, &xString2);
					global::Charset charset2;
					_003CModule_003E.Charset_002E_007Bctor_007D(&charset2);
					try
					{
						DataBuffer dataBuffer;
						_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
						try
						{
							_003CModule_003E.Charset_002EsetByName(&charset2, _003CModule_003E.XString_002EgetUtf8(&xString2));
							_003CModule_003E.XString_002EgetConverted(&xString, &charset2, &dataBuffer);
							DataBuffer dataBuffer2;
							_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
							try
							{
								_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, m_impl);
								_003CModule_003E.DataBuffer_002Eclear(m_impl);
								_003CModule_003E.DataBuffer_002Eappend(m_impl, &dataBuffer);
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
								throw;
							}
							_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
							throw;
						}
						_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Charset_002E_007Bdtor_007D), &charset2);
						throw;
					}
					_003CModule_003E.Charset_002E_007Bdtor_007D(&charset2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFromFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				if (_003CModule_003E.DataBuffer_002EgetSize(m_impl) == 0)
				{
					result = _003CModule_003E.DataBuffer_002EloadFileUtf8(m_impl, _003CModule_003E.XString_002EgetUtf8(&xString), null);
					goto IL_0043;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			bool flag;
			try
			{
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					flag = _003CModule_003E.DataBuffer_002EloadFileUtf8(&dataBuffer, _003CModule_003E.XString_002EgetUtf8(&xString), null);
					if (flag)
					{
						_003CModule_003E.DataBuffer_002Eappend(m_impl, &dataBuffer);
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return flag;
			IL_0043:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.DataBuffer_002EsaveToFileUtf8(m_impl, _003CModule_003E.XString_002EgetUtf8(&xString), null);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
