using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[TypeLibType(18)]
	[ClassInterface(0)]
	[Guid("F935DC22-1CF0-11D0-ADB9-00C04FD58A0B")]
	public class IWshShell_ClassClass : IWshShell3, IWshShell_Class
	{
		[DispId(100)]
		public virtual IWshCollection SpecialFolders
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(100)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(200)]
		public virtual IWshEnvironment Environment
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(200)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(3013)]
		public virtual string CurrentDirectory
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(3013)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(3013)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		public extern IWshShell_ClassClass();

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1000)]
		public virtual extern int Run([In] [MarshalAs(UnmanagedType.BStr)] string Command, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object WindowStyle, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object WaitOnReturn);

		int IWshShell3.Run([In] [MarshalAs(UnmanagedType.BStr)] string Command, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object WindowStyle, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object WaitOnReturn)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Run
			return this.Run(Command, ref WindowStyle, ref WaitOnReturn);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1001)]
		public virtual extern int Popup([In] [MarshalAs(UnmanagedType.BStr)] string Text, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object SecondsToWait, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Title, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Type);

		int IWshShell3.Popup([In] [MarshalAs(UnmanagedType.BStr)] string Text, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object SecondsToWait, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Title, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Type)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Popup
			return this.Popup(Text, ref SecondsToWait, ref Title, ref Type);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1002)]
		[return: MarshalAs(UnmanagedType.IDispatch)]
		public virtual extern object CreateShortcut([In] [MarshalAs(UnmanagedType.BStr)] string PathLink);

		object IWshShell3.CreateShortcut([In] [MarshalAs(UnmanagedType.BStr)] string PathLink)
		{
			//ILSpy generated this explicit interface implementation from .override directive in CreateShortcut
			return this.CreateShortcut(PathLink);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1006)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string ExpandEnvironmentStrings([In] [MarshalAs(UnmanagedType.BStr)] string Src);

		string IWshShell3.ExpandEnvironmentStrings([In] [MarshalAs(UnmanagedType.BStr)] string Src)
		{
			//ILSpy generated this explicit interface implementation from .override directive in ExpandEnvironmentStrings
			return this.ExpandEnvironmentStrings(Src);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2000)]
		[return: MarshalAs(UnmanagedType.Struct)]
		public virtual extern object RegRead([In] [MarshalAs(UnmanagedType.BStr)] string Name);

		object IWshShell3.RegRead([In] [MarshalAs(UnmanagedType.BStr)] string Name)
		{
			//ILSpy generated this explicit interface implementation from .override directive in RegRead
			return this.RegRead(Name);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2001)]
		public virtual extern void RegWrite([In] [MarshalAs(UnmanagedType.BStr)] string Name, [In] [MarshalAs(UnmanagedType.Struct)] ref object Value, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Type);

		void IWshShell3.RegWrite([In] [MarshalAs(UnmanagedType.BStr)] string Name, [In] [MarshalAs(UnmanagedType.Struct)] ref object Value, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Type)
		{
			//ILSpy generated this explicit interface implementation from .override directive in RegWrite
			this.RegWrite(Name, ref Value, ref Type);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2002)]
		public virtual extern void RegDelete([In] [MarshalAs(UnmanagedType.BStr)] string Name);

		void IWshShell3.RegDelete([In] [MarshalAs(UnmanagedType.BStr)] string Name)
		{
			//ILSpy generated this explicit interface implementation from .override directive in RegDelete
			this.RegDelete(Name);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(3000)]
		public virtual extern bool LogEvent([In] [MarshalAs(UnmanagedType.Struct)] ref object Type, [In] [MarshalAs(UnmanagedType.BStr)] string Message, [In] [MarshalAs(UnmanagedType.BStr)] string Target = "");

		bool IWshShell3.LogEvent([In] [MarshalAs(UnmanagedType.Struct)] ref object Type, [In] [MarshalAs(UnmanagedType.BStr)] string Message, [In] [MarshalAs(UnmanagedType.BStr)] string Target = "")
		{
			//ILSpy generated this explicit interface implementation from .override directive in LogEvent
			return this.LogEvent(ref Type, Message, Target);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(3010)]
		public virtual extern bool AppActivate([In] [MarshalAs(UnmanagedType.Struct)] ref object App, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Wait);

		bool IWshShell3.AppActivate([In] [MarshalAs(UnmanagedType.Struct)] ref object App, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Wait)
		{
			//ILSpy generated this explicit interface implementation from .override directive in AppActivate
			return this.AppActivate(ref App, ref Wait);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(3011)]
		public virtual extern void SendKeys([In] [MarshalAs(UnmanagedType.BStr)] string Keys, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Wait);

		void IWshShell3.SendKeys([In] [MarshalAs(UnmanagedType.BStr)] string Keys, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Wait)
		{
			//ILSpy generated this explicit interface implementation from .override directive in SendKeys
			this.SendKeys(Keys, ref Wait);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(3012)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern WshExec Exec([In] [MarshalAs(UnmanagedType.BStr)] string Command);

		WshExec IWshShell3.Exec([In] [MarshalAs(UnmanagedType.BStr)] string Command)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Exec
			return this.Exec(Command);
		}
	}
}
