using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Bz2 : IDisposable
	{
		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsBz2* m_impl;

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Bz2 LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Bz2 result = (Bz2)m_objects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public unsafe Bz2(void* impl)
		{
			m_impl = (ClsBz2*)impl;
			this.OnAbortCheck = null;
		}

		public unsafe Bz2()
		{
			m_enableEvents = false;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0x8af70974_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0x8af70974_002ENextHashCode;
			ClsBz2* ptr = (ClsBz2*)_003CModule_003E.@new(128u);
			ClsBz2* ptr2;
			try
			{
				ptr2 = (ClsBz2*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsBz2_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 120) = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsBz2* impl = m_impl;
			if (impl != null)
			{
				ClsBz2* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressFile(string inFilename, string outFilename)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(inFilename, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(outFilename, &xString2);
						result = _003CModule_003E.ClsBz2_002EUncompressFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile(string inFilename, string outFilename)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(inFilename, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(outFilename, &xString2);
						result = _003CModule_003E.ClsBz2_002ECompressFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		public unsafe byte[] UncompressFileToMem(string inFilename)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(inFilename, &xString);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.ClsBz2_002EUncompressFileToMem(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		public unsafe byte[] CompressFileToMem(string inFilename)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(inFilename, &xString);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.ClsBz2_002ECompressFileToMem(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressMemToFile(byte[] inData, string outFilename)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr2, (uint)num);
					XString xString;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString);
					try
					{
						CkMarshal.StringToX(outFilename, &xString);
						result = _003CModule_003E.ClsBz2_002ECompressMemToFile(m_impl, &dataBuffer, &xString, (ProgressEvent*)ptr);
						CkMarshal.free(ptr2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressMemToFile(byte[] inData, string outFilename)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr2, (uint)num);
					XString xString;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString);
					try
					{
						CkMarshal.StringToX(outFilename, &xString);
						result = _003CModule_003E.ClsBz2_002EUncompressMemToFile(m_impl, &dataBuffer, &xString, (ProgressEvent*)ptr);
						CkMarshal.free(ptr2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		public unsafe byte[] CompressMemory(byte[] inData)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr2, (uint)num);
					DataBuffer dataBuffer2;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
					try
					{
						_003CModule_003E.ClsBz2_002ECompressMemory(m_impl, &dataBuffer, &dataBuffer2, (ProgressEvent*)ptr);
						CkMarshal.free(ptr2);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		public unsafe byte[] UncompressMemory(byte[] inData)
		{
			_Bz2Callback bz2Callback;
			_003CModule_003E.Bz2Callback_002E_007Bctor_007D((Bz2Callback*)(&bz2Callback));
			try
			{
				*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &bz2Callback;
					*(int*)(&Unsafe.AddByteOffset(ref bz2Callback, 4)) = m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr2, (uint)num);
					DataBuffer dataBuffer2;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
					try
					{
						_003CModule_003E.ClsBz2_002EUncompressMemory(m_impl, &dataBuffer, &dataBuffer2, (ProgressEvent*)ptr);
						CkMarshal.free(ptr2);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_Bz2Callback_002E_007Bdtor_007D), &bz2Callback);
				throw;
			}
			*(int*)(&bz2Callback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_Bz2Callback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.Bz2Callback_002E_007Bdtor_007D((Bz2Callback*)(&bz2Callback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string regCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(regCode, &xString);
				int num = *(int*)m_impl + 4;
				ClsBz2* impl = m_impl;
				sbyte* intPtr = _003CModule_003E.XString_002EgetAnsi(&xString);
				result = (((delegate* thiscall<IntPtr, sbyte*, byte>)(*(int*)num))((IntPtr)impl, intPtr) != 0);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
