using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[Guid("0BB02EC0-EF49-11CF-8940-00A0C9054228")]
	[ClassInterface(0)]
	public class TextStreamClass : ITextStream, TextStream
	{
		[DispId(10000)]
		public virtual int Line
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10000)]
			get;
		}

		[DispId(-529)]
		public virtual int Column
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(-529)]
			get;
		}

		[DispId(10002)]
		public virtual bool AtEndOfStream
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10002)]
			get;
		}

		[DispId(10003)]
		public virtual bool AtEndOfLine
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10003)]
			get;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		internal extern TextStreamClass();

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10004)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string Read([In] int Characters);

		string ITextStream.Read([In] int Characters)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Read
			return this.Read(Characters);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10005)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string ReadLine();

		string ITextStream.ReadLine()
		{
			//ILSpy generated this explicit interface implementation from .override directive in ReadLine
			return this.ReadLine();
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10006)]
		[return: MarshalAs(UnmanagedType.BStr)]
		public virtual extern string ReadAll();

		string ITextStream.ReadAll()
		{
			//ILSpy generated this explicit interface implementation from .override directive in ReadAll
			return this.ReadAll();
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10007)]
		public virtual extern void Write([In] [MarshalAs(UnmanagedType.BStr)] string Text);

		void ITextStream.Write([In] [MarshalAs(UnmanagedType.BStr)] string Text)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Write
			this.Write(Text);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10008)]
		public virtual extern void WriteLine([In] [MarshalAs(UnmanagedType.BStr)] string Text = "");

		void ITextStream.WriteLine([In] [MarshalAs(UnmanagedType.BStr)] string Text = "")
		{
			//ILSpy generated this explicit interface implementation from .override directive in WriteLine
			this.WriteLine(Text);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10009)]
		public virtual extern void WriteBlankLines([In] int Lines);

		void ITextStream.WriteBlankLines([In] int Lines)
		{
			//ILSpy generated this explicit interface implementation from .override directive in WriteBlankLines
			this.WriteBlankLines(Lines);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10010)]
		public virtual extern void Skip([In] int Characters);

		void ITextStream.Skip([In] int Characters)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Skip
			this.Skip(Characters);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10011)]
		public virtual extern void SkipLine();

		void ITextStream.SkipLine()
		{
			//ILSpy generated this explicit interface implementation from .override directive in SkipLine
			this.SkipLine();
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(10012)]
		public virtual extern void Close();

		void ITextStream.Close()
		{
			//ILSpy generated this explicit interface implementation from .override directive in Close
			this.Close();
		}
	}
}
