using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Cache
	{
		private unsafe ClsCache2* m_cache;

		public unsafe bool LastHitExpired
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsCache2_002Eget_LastHitExpired(m_cache);
			}
		}

		public unsafe string LastEtagFetched
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsCache2_002Eget_LastEtagFetched(m_cache, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe DateTime LastExpirationFetched
		{
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				_003CModule_003E.ClsCache2_002Eget_LastExpirationFetched(m_cache, &chilkatSysTime);
				DateTime result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
					return result;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
							return result;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
						}
						if (num2 != 0)
						{
							throw;
						}
						return result;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
		}

		public unsafe string LastKeyFetched
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsCache2_002Eget_LastKeyFetched(m_cache, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int NumRoots => _003CModule_003E.ClsCache2_002Eget_NumRoots(m_cache);

		public unsafe int Level
		{
			get
			{
				return _003CModule_003E.ClsCache2_002Eget_Level(m_cache);
			}
			set
			{
				_003CModule_003E.ClsCache2_002Eput_Level(m_cache, value);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_cache, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_cache, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_cache, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe Cache()
		{
			ClsCache2* ptr = (ClsCache2*)_003CModule_003E.@new(352u);
			ClsCache2* cache;
			try
			{
				cache = (ClsCache2*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsCache2_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_cache = cache;
		}

		protected unsafe override void Finalize()
		{
			ClsCache2* cache = m_cache;
			if (cache != null)
			{
				ClsCache2* ptr = cache;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_cache = null;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_cache, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetRoot(int index)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_003CModule_003E.ClsCache2_002EGetRoot(m_cache, index, &xString);
				result = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void AddRoot(string path)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(path, &xString);
				_003CModule_003E.ClsCache2_002EAddRoot(m_cache, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe string GetFilename(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ClsCache2_002EGetFilenameX(m_cache, &xString, &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveToCache(string url, DateTime expire, string eTag, byte[] data)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(eTag, &xString2);
					ChilkatSysTime chilkatSysTime;
					_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
					*(short*)(&chilkatSysTime) = (short)expire.Year;
					*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)expire.Month;
					*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)expire.Day;
					*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)expire.Hour;
					*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)expire.Minute;
					*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)expire.Second;
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
						result = _003CModule_003E.ClsCache2_002ESaveToCache(m_cache, &xString, &chilkatSysTime, &xString2, &dataBuffer);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveToCacheNoExpire(string url, string eTag, byte[] data)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(eTag, &xString2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
						result = _003CModule_003E.ClsCache2_002ESaveToCacheNoExpire(m_cache, &xString, &xString2, &dataBuffer);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] FetchFromCache(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					if (!_003CModule_003E.ClsCache2_002EFetchFromCache(m_cache, &xString, &dataBuffer))
					{
						_003CModule_003E.DataBuffer_002Eclear(&dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsCached(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				result = _003CModule_003E.ClsCache2_002EIsCached(m_cache, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteFromCache(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				result = _003CModule_003E.ClsCache2_002EDeleteFromCache(m_cache, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int DeleteAllExpired()
		{
			return _003CModule_003E.ClsCache2_002EDeleteAllExpired(m_cache);
		}

		public unsafe int DeleteOlder(DateTime dt)
		{
			ChilkatSysTime chilkatSysTime;
			_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
			*(short*)(&chilkatSysTime) = (short)dt.Year;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)dt.Month;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)dt.Day;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)dt.Hour;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)dt.Minute;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)dt.Second;
			return _003CModule_003E.ClsCache2_002EDeleteOlder(m_cache, &chilkatSysTime);
		}

		public unsafe int DeleteAll()
		{
			return _003CModule_003E.ClsCache2_002EDeleteAll(m_cache);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UpdateExpiration(string url, DateTime dt)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				*(short*)(&chilkatSysTime) = (short)dt.Year;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)dt.Month;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)dt.Day;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)dt.Hour;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)dt.Minute;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)dt.Second;
				result = _003CModule_003E.ClsCache2_002EUpdateExpiration(m_cache, &xString, &chilkatSysTime);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe DateTime GetExpiration(string url)
		{
			//Discarded unreachable code: IL_00b8
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DateTime result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				_003CModule_003E.ClsCache2_002EGetExpiration(m_cache, &xString, &chilkatSysTime);
				result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00a7;
						}
						goto end_IL_008d;
						IL_00a7:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_008d:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetEtag(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ClsCache2_002EGetEtag(m_cache, &xString, &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string FetchText(string key)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(key, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsCache2_002EFetchText(m_cache, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveText(string key, DateTime expire, string eTag, string strData)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(key, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				*(short*)(&chilkatSysTime) = (short)expire.Year;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)expire.Month;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)expire.Day;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)expire.Hour;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)expire.Minute;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)expire.Second;
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(eTag, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(strData, &xString3);
						result = _003CModule_003E.ClsCache2_002ESaveText(m_cache, &xString, &chilkatSysTime, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveTextNoExpire(string key, string eTag, string strData)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(key, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(eTag, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(strData, &xString3);
						result = _003CModule_003E.ClsCache2_002ESaveTextNoExpire(m_cache, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
