using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[Guid("08FED191-BE19-11D3-A28B-00104BD35090")]
	[ClassInterface(0)]
	public class WshExecClass : IWshExec, WshExec
	{
		[DispId(1)]
		[ComAliasName("IWshRuntimeLibrary.WshExecStatus")]
		public virtual WshExecStatus Status
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1)]
			[return: ComAliasName("IWshRuntimeLibrary.WshExecStatus")]
			get;
		}

		[DispId(3)]
		public virtual TextStream StdIn
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(3)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(4)]
		public virtual TextStream StdOut
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(4)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(5)]
		public virtual TextStream StdErr
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(5)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(6)]
		public virtual int ProcessID
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(6)]
			get;
		}

		[DispId(7)]
		public virtual int ExitCode
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(7)]
			get;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		internal extern WshExecClass();

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(8)]
		public virtual extern void Terminate();

		void IWshExec.Terminate()
		{
			//ILSpy generated this explicit interface implementation from .override directive in Terminate
			this.Terminate();
		}
	}
}
