using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[ClassInterface(0)]
	[Guid("093FF999-1EA0-4079-9525-9614C3504B74")]
	[TypeLibType(2)]
	public class WshNetworkClass : IWshNetwork2, WshNetwork
	{
		[DispId(1610743808)]
		public virtual string UserDomain
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1610743808)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1610743809)]
		public virtual string UserName
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1610743809)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1610743810)]
		public virtual string UserProfile
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[TypeLibFunc(64)]
			[DispId(1610743810)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1610743811)]
		public virtual string ComputerName
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1610743811)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1610743812)]
		public virtual string Organization
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[TypeLibFunc(64)]
			[DispId(1610743812)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1610743813)]
		public virtual string Site
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1610743813)]
			[TypeLibFunc(64)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		public extern WshNetworkClass();

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1000)]
		public virtual extern void MapNetworkDrive([In] [MarshalAs(UnmanagedType.BStr)] string LocalName, [In] [MarshalAs(UnmanagedType.BStr)] string RemoteName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UserName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Password);

		void IWshNetwork2.MapNetworkDrive([In] [MarshalAs(UnmanagedType.BStr)] string LocalName, [In] [MarshalAs(UnmanagedType.BStr)] string RemoteName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UserName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Password)
		{
			//ILSpy generated this explicit interface implementation from .override directive in MapNetworkDrive
			this.MapNetworkDrive(LocalName, RemoteName, ref UpdateProfile, ref UserName, ref Password);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1001)]
		public virtual extern void RemoveNetworkDrive([In] [MarshalAs(UnmanagedType.BStr)] string Name, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Force, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile);

		void IWshNetwork2.RemoveNetworkDrive([In] [MarshalAs(UnmanagedType.BStr)] string Name, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Force, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile)
		{
			//ILSpy generated this explicit interface implementation from .override directive in RemoveNetworkDrive
			this.RemoveNetworkDrive(Name, ref Force, ref UpdateProfile);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(1002)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern IWshCollection EnumNetworkDrives();

		IWshCollection IWshNetwork2.EnumNetworkDrives()
		{
			//ILSpy generated this explicit interface implementation from .override directive in EnumNetworkDrives
			return this.EnumNetworkDrives();
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2000)]
		public virtual extern void AddPrinterConnection([In] [MarshalAs(UnmanagedType.BStr)] string LocalName, [In] [MarshalAs(UnmanagedType.BStr)] string RemoteName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UserName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Password);

		void IWshNetwork2.AddPrinterConnection([In] [MarshalAs(UnmanagedType.BStr)] string LocalName, [In] [MarshalAs(UnmanagedType.BStr)] string RemoteName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UserName, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Password)
		{
			//ILSpy generated this explicit interface implementation from .override directive in AddPrinterConnection
			this.AddPrinterConnection(LocalName, RemoteName, ref UpdateProfile, ref UserName, ref Password);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2001)]
		public virtual extern void RemovePrinterConnection([In] [MarshalAs(UnmanagedType.BStr)] string Name, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Force, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile);

		void IWshNetwork2.RemovePrinterConnection([In] [MarshalAs(UnmanagedType.BStr)] string Name, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object Force, [Optional] [In] [MarshalAs(UnmanagedType.Struct)] ref object UpdateProfile)
		{
			//ILSpy generated this explicit interface implementation from .override directive in RemovePrinterConnection
			this.RemovePrinterConnection(Name, ref Force, ref UpdateProfile);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2002)]
		[return: MarshalAs(UnmanagedType.Interface)]
		public virtual extern IWshCollection EnumPrinterConnections();

		IWshCollection IWshNetwork2.EnumPrinterConnections()
		{
			//ILSpy generated this explicit interface implementation from .override directive in EnumPrinterConnections
			return this.EnumPrinterConnections();
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2003)]
		public virtual extern void SetDefaultPrinter([In] [MarshalAs(UnmanagedType.BStr)] string Name);

		void IWshNetwork2.SetDefaultPrinter([In] [MarshalAs(UnmanagedType.BStr)] string Name)
		{
			//ILSpy generated this explicit interface implementation from .override directive in SetDefaultPrinter
			this.SetDefaultPrinter(Name);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2004)]
		public virtual extern void AddWindowsPrinterConnection([In] [MarshalAs(UnmanagedType.BStr)] string PrinterName, [In] [MarshalAs(UnmanagedType.BStr)] string DriverName = "", [In] [MarshalAs(UnmanagedType.BStr)] string Port = "LPT1");

		void IWshNetwork2.AddWindowsPrinterConnection([In] [MarshalAs(UnmanagedType.BStr)] string PrinterName, [In] [MarshalAs(UnmanagedType.BStr)] string DriverName = "", [In] [MarshalAs(UnmanagedType.BStr)] string Port = "LPT1")
		{
			//ILSpy generated this explicit interface implementation from .override directive in AddWindowsPrinterConnection
			this.AddWindowsPrinterConnection(PrinterName, DriverName, Port);
		}
	}
}
