using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CertStore : IDisposable
	{
		private unsafe ClsCertStore* m_impl;

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsCertStore_002Eget_Version(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int NumCertificates => _003CModule_003E.ClsCertStore_002Eget_NumCertificates(m_impl);

		public unsafe int NumEmailCerts => _003CModule_003E.ClsCertStore_002Eget_NumEmailCerts(m_impl);

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe CertStore(void* impl)
		{
			m_impl = (ClsCertStore*)impl;
		}

		public unsafe CertStore()
		{
			ClsCertStore* ptr = (ClsCertStore*)_003CModule_003E.@new(128u);
			ClsCertStore* impl;
			try
			{
				impl = (ClsCertStore*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsCertStore_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsCertStore* impl = m_impl;
			if (impl != null)
			{
				ClsCertStore* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
			}
		}

		public unsafe override void Dispose()
		{
			_003CModule_003E.ClsCertStore_002EdotNetDispose(m_impl);
		}

		public unsafe void* GetImplementation()
		{
			return m_impl;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadPfxFile(string pfxFilename, string password)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(password, &xString2);
					result = _003CModule_003E.ClsCertStore_002ELoadPfxFile(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadPfxData(byte[] pfxData, string password)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(password, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(pfxData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
					result = _003CModule_003E.ClsCertStore_002ELoadPfxData(m_impl, &dataBuffer, &xString);
					CkMarshal.free(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertBySerial(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				ptr = _003CModule_003E.ClsCertStore_002EFindCertBySerial(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertBySubjectE(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				ptr = _003CModule_003E.ClsCertStore_002EFindCertBySubjectE(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertBySubjectO(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				ptr = _003CModule_003E.ClsCertStore_002EFindCertBySubjectO(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertBySubjectCN(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				ptr = _003CModule_003E.ClsCertStore_002EFindCertBySubjectCN(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertBySubject(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				ptr = _003CModule_003E.ClsCertStore_002EFindCertBySubject(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertForEmail(string emailAddress)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(emailAddress, &xString);
				ptr = null;
				try
				{
					ptr = _003CModule_003E.ClsCertStore_002EFindCertForEmail(m_impl, &xString);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BB_0040BHGJEPDH_0040FindCertForEmail_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_0074;
						}
						goto end_IL_0050;
						IL_0074:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0050:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				if (ptr == null)
				{
					result = null;
					goto IL_009d;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_009d:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert GetEmailCert(int index)
		{
			ClsCert* ptr = _003CModule_003E.ClsCertStore_002EGetEmailCert(m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		public unsafe Cert GetCertificate(int index)
		{
			ClsCert* ptr = _003CModule_003E.ClsCertStore_002EGetCertificate(m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveCertificate(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			return _003CModule_003E.ClsCertStore_002ERemoveCertificate(m_impl, implementation);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddCertificate(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			return _003CModule_003E.ClsCertStore_002EAddCertificate(m_impl, implementation);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateFileStore(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsCertStore_002ECreateFileStore(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateMemoryStore()
		{
			return _003CModule_003E.ClsCertStore_002ECreateMemoryStore(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateRegistryStore(string regRoot, string regPath)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(regRoot, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(regPath, &xString2);
					result = _003CModule_003E.ClsCertStore_002ECreateRegistryStore(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertByRfc822Name(string name)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(name, &xString);
				ptr = _003CModule_003E.ClsCertStore_002EFindCertByRfc822Name(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenChilkatStore([MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			return _003CModule_003E.ClsCertStore_002EOpenChilkatStore(m_impl, readOnly);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenCurrentUserStore([MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			return _003CModule_003E.ClsCertStore_002EOpenCurrentUserStore(m_impl, readOnly);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFileStore(string filename, [MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsCertStore_002EOpenFileStore(m_impl, &xString, readOnly);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenOutlookStore([MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			return _003CModule_003E.ClsCertStore_002EOpenOutlookStore(m_impl, readOnly);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenRegistryStore(string regRoot, string regPath, [MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(regRoot, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(regPath, &xString2);
					result = _003CModule_003E.ClsCertStore_002EOpenRegistryStore(m_impl, &xString, &xString2, readOnly);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert FindCertBySha1Thumbprint(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsCert* ptr;
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				ptr = _003CModule_003E.ClsCertStore_002EFindCertBySha1Thumbprint(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Cert result2;
			try
			{
				result2 = new Cert(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
