using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[Guid("A548B8E4-51D5-4661-8824-DAA1D893DFB2")]
	[ClassInterface(0)]
	[DefaultMember("FullName")]
	public class WshShortcutClass : IWshShortcut, WshShortcut
	{
		[DispId(0)]
		public virtual string FullName
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(0)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(1000)]
		public virtual string Arguments
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1000)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1000)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(1001)]
		public virtual string Description
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1001)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1001)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(1002)]
		public virtual string Hotkey
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1002)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1002)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(1003)]
		public virtual string IconLocation
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1003)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1003)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(1004)]
		public virtual string RelativePath
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1004)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(1005)]
		public virtual string TargetPath
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1005)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1005)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(1006)]
		public virtual int WindowStyle
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1006)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1006)]
			[param: In]
			set;
		}

		[DispId(1007)]
		public virtual string WorkingDirectory
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1007)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(1007)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		internal extern WshShortcutClass();

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2000)]
		[TypeLibFunc(64)]
		public virtual extern void Load([In] [MarshalAs(UnmanagedType.BStr)] string PathLink);

		void IWshShortcut.Load([In] [MarshalAs(UnmanagedType.BStr)] string PathLink)
		{
			//ILSpy generated this explicit interface implementation from .override directive in Load
			this.Load(PathLink);
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		[DispId(2001)]
		public virtual extern void Save();

		void IWshShortcut.Save()
		{
			//ILSpy generated this explicit interface implementation from .override directive in Save
			this.Save();
		}
	}
}
