using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Compression : IDisposable
	{
		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsCompression* m_impl;

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsCompression_002Eget_Version(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string EncodingMode
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsEncode_002Eget_EncodingMode((ClsEncode*)m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsEncode_002Eput_EncodingMode((ClsEncode*)m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Charset
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsCompression_002Eget_Charset(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsCompression_002Eput_Charset(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe string Algorithm
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsCompression_002Eget_Algorithm(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsCompression_002Eput_Algorithm(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public event PercentDoneEventHandler OnPercentDone;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Compression LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Compression result = (Compression)m_objects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			this.OnPercentDone?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public unsafe Compression(void* impl)
		{
			m_impl = (ClsCompression*)impl;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
		}

		public unsafe Compression()
		{
			m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0xb34c3790_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0xb34c3790_002ENextHashCode;
			ClsCompression* ptr = (ClsCompression*)_003CModule_003E.@new(744u);
			ClsCompression* ptr2;
			try
			{
				ptr2 = (ClsCompression*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsCompression_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 736) = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsCompression* impl = m_impl;
			if (impl != null)
			{
				ClsCompression* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)((byte*)m_impl + 192), &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string DecompressStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsCompression_002EDecompressStringENC(m_impl, &xString, &xString2, null))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string DecompressString(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsCompression_002EDecompressString(m_impl, &dataBuffer, &xString, null);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] DecompressBytesENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsCompression_002EDecompressBytesENC(m_impl, &xString, &dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] DecompressBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					_003CModule_003E.ClsCompression_002EDecompressBytes(m_impl, &dataBuffer, &dataBuffer2, null);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string CompressStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsCompression_002ECompressStringENC(m_impl, &xString, &xString2, null))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string CompressBytesENC(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsCompression_002ECompressBytesENC(m_impl, &dataBuffer, &xString, null);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] CompressString(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsCompression_002ECompressString(m_impl, &xString, &dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] CompressBytes(byte[] data)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			int num2 = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num2);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num2);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					try
					{
						_003CModule_003E.ClsCompression_002ECompressBytes(m_impl, &dataBuffer, &dataBuffer2, null);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)((byte*)m_impl + 192), (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040HBNGJEAL_0040CompressBytes_003F_0024AA_0040));
								_003CModule_003E.DataBuffer_002Eclear(&dataBuffer2);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_0098;
							}
							goto end_IL_0067;
							IL_0098:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_0067:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile(string inFile, string outFile)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inFile, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(outFile, &xString2);
					_CompressCallback compressCallback;
					_003CModule_003E.CompressCallback_002E_007Bctor_007D((CompressCallback*)(&compressCallback));
					try
					{
						*(int*)(&compressCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_CompressCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref compressCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.CompressCallback_002E_007Bdtor_007D), &compressCallback);
						throw;
					}
					try
					{
						_CompressCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &compressCallback;
							*(int*)(&Unsafe.AddByteOffset(ref compressCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsCompression_002ECompressFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_CompressCallback_002E_007Bdtor_007D), &compressCallback);
						throw;
					}
					*(int*)(&compressCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_CompressCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.CompressCallback_002E_007Bdtor_007D((CompressCallback*)(&compressCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DecompressFile(string inFile, string outFile)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inFile, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(outFile, &xString2);
					_CompressCallback compressCallback;
					_003CModule_003E.CompressCallback_002E_007Bctor_007D((CompressCallback*)(&compressCallback));
					try
					{
						*(int*)(&compressCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_CompressCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref compressCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.CompressCallback_002E_007Bdtor_007D), &compressCallback);
						throw;
					}
					try
					{
						_CompressCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &compressCallback;
							*(int*)(&Unsafe.AddByteOffset(ref compressCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsCompression_002EDecompressFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_CompressCallback_002E_007Bdtor_007D), &compressCallback);
						throw;
					}
					*(int*)(&compressCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_CompressCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.CompressCallback_002E_007Bdtor_007D((CompressCallback*)(&compressCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string BeginDecompressStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsCompression_002EBeginDecompressStringENC(m_impl, &xString, &xString2, null))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string BeginDecompressString(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsCompression_002EBeginDecompressString(m_impl, &dataBuffer, &xString, null);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] BeginDecompressBytesENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsCompression_002EBeginDecompressBytesENC(m_impl, &xString, &dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] BeginDecompressBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					_003CModule_003E.ClsCompression_002EBeginDecompressBytes(m_impl, &dataBuffer, &dataBuffer2, null);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string BeginCompressStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsCompression_002EBeginCompressStringENC(m_impl, &xString, &xString2, null))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string BeginCompressBytesENC(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsCompression_002EBeginCompressBytesENC(m_impl, &dataBuffer, &xString, null);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] BeginCompressString(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsCompression_002EBeginCompressString(m_impl, &xString, &dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] BeginCompressBytes(byte[] data)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			int num2 = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num2);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num2);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					try
					{
						_003CModule_003E.ClsCompression_002EBeginCompressBytes(m_impl, &dataBuffer, &dataBuffer2, null);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)((byte*)m_impl + 192), (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BD_0040FIOIJCEH_0040BeginCompressBytes_003F_0024AA_0040));
								_003CModule_003E.DataBuffer_002Eclear(&dataBuffer2);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_0098;
							}
							goto end_IL_0067;
							IL_0098:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_0067:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string MoreDecompressStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsCompression_002EMoreDecompressStringENC(m_impl, &xString, &xString2, null))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string MoreDecompressString(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsCompression_002EMoreDecompressString(m_impl, &dataBuffer, &xString, null);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] MoreDecompressBytesENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsCompression_002EMoreDecompressBytesENC(m_impl, &xString, &dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] MoreDecompressBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					_003CModule_003E.ClsCompression_002EMoreDecompressBytes(m_impl, &dataBuffer, &dataBuffer2, null);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string MoreCompressStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsCompression_002EMoreCompressStringENC(m_impl, &xString, &xString2, null))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string MoreCompressBytesENC(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsCompression_002EMoreCompressBytesENC(m_impl, &dataBuffer, &xString, null);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] MoreCompressString(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsCompression_002EMoreCompressString(m_impl, &xString, &dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] MoreCompressBytes(byte[] data)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			int num2 = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num2);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num2);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					try
					{
						_003CModule_003E.ClsCompression_002EMoreCompressBytes(m_impl, &dataBuffer, &dataBuffer2, null);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)((byte*)m_impl + 192), (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BC_0040BCEIJEMD_0040MoreCompressBytes_003F_0024AA_0040));
								_003CModule_003E.DataBuffer_002Eclear(&dataBuffer2);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_0098;
							}
							goto end_IL_0067;
							IL_0098:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_0067:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string EndDecompressStringENC()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsCompression_002EEndDecompressStringENC(m_impl, &xString, null))
				{
					result = null;
					goto IL_002e;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string EndDecompressString()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsCompression_002EEndDecompressString(m_impl, &xString, null))
				{
					result = null;
					goto IL_002e;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] EndDecompressBytesENC()
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.ClsCompression_002EEndDecompressBytesENC(m_impl, &dataBuffer, null);
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] EndDecompressBytes()
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.ClsCompression_002EEndDecompressBytes(m_impl, &dataBuffer, null);
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string EndCompressStringENC()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsCompression_002EEndCompressStringENC(m_impl, &xString, null))
				{
					result = null;
					goto IL_002e;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string EndCompressBytesENC()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsCompression_002EEndCompressBytesENC(m_impl, &xString, null))
				{
					result = null;
					goto IL_002e;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] EndCompressString()
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.ClsCompression_002EEndCompressString(m_impl, &dataBuffer, null);
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] EndCompressBytes()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				try
				{
					_003CModule_003E.ClsCompression_002EEndCompressBytes(m_impl, &dataBuffer, null);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)((byte*)m_impl + 192), (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BB_0040BBOLMOKF_0040EndCompressBytes_003F_0024AA_0040));
							_003CModule_003E.DataBuffer_002Eclear(&dataBuffer);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_0077;
						}
						goto end_IL_0046;
						IL_0077:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0046:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				result = _003CModule_003E.ClsCompression_002EUnlockComponent(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		protected void raise_OnPercentDone(object i1, PercentDoneEventArgs i2)
		{
			this.OnPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
