using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Dkim : IDisposable
	{
		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsDkim* m_impl;

		public unsafe int DkimBodyLengthCount
		{
			get
			{
				return (int)_003CModule_003E.ClsDkim_002Eget_DkimBodyLengthCount(m_impl);
			}
			set
			{
				_003CModule_003E.ClsDkim_002Eput_DkimBodyLengthCount(m_impl, (uint)value);
			}
		}

		public unsafe string DomainKeySelector
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DomainKeySelector(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DomainKeySelector(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DkimSelector
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DkimSelector(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DkimSelector(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DomainKeyDomain
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DomainKeyDomain(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DomainKeyDomain(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DkimDomain
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DkimDomain(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DkimDomain(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DomainKeyHeaders
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DomainKeyHeaders(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DomainKeyHeaders(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DkimHeaders
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DkimHeaders(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DkimHeaders(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DomainKeyAlg
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DomainKeyAlg(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DomainKeyAlg(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DkimAlg
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DkimAlg(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DkimAlg(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DomainKeyCanon
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DomainKeyCanon(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DomainKeyCanon(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DkimCanon
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsDkim_002Eget_DkimCanon(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsDkim_002Eput_DkimCanon(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Dkim LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			object result = m_objects[key];
			Monitor.Exit(m_lockObject);
			return (Dkim)result;
		}

		public unsafe Dkim(void* impl)
		{
			m_impl = (ClsDkim*)impl;
			this.OnAbortCheck = null;
		}

		public unsafe Dkim()
		{
			m_enableEvents = false;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0x9f1bd334_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0x9f1bd334_002ENextHashCode;
			ClsDkim* ptr = (ClsDkim*)_003CModule_003E.@new(1840u);
			ClsDkim* impl;
			try
			{
				impl = (ClsDkim*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsDkim_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
			_003CModule_003E._003Fm_progLang_0040ClsDkim_0040_00402HA = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsDkim* impl = m_impl;
			if (impl != null)
			{
				ClsDkim* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public unsafe override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			ClsDkim* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsDkim_002EdotNetDispose(impl);
			}
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				result = _003CModule_003E.ClsDkim_002EUnlockComponent(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadDkimPk(string privateKey, string optionalPassword)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(privateKey, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(optionalPassword, &xString2);
					result = _003CModule_003E.ClsDkim_002ELoadDkimPk(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadDomainKeyPk(string privateKey, string optionalPassword)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(privateKey, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(optionalPassword, &xString2);
					result = _003CModule_003E.ClsDkim_002ELoadDomainKeyPk(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadDkimPkFile(string privateKeyFilepath, string optionalPassword)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(privateKeyFilepath, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(optionalPassword, &xString2);
					result = _003CModule_003E.ClsDkim_002ELoadDkimPkFile(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadDomainKeyPkFile(string privateKeyFilepath, string optionalPassword)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(privateKeyFilepath, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(optionalPassword, &xString2);
					result = _003CModule_003E.ClsDkim_002ELoadDomainKeyPkFile(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadPublicKey(string selector, string domain, string publicKey)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(selector, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(domain, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(publicKey, &xString3);
						result = _003CModule_003E.ClsDkim_002ELoadPublicKey(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadPublicKeyFile(string selector, string domain, string publicKeyFilepath)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(selector, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(domain, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(publicKeyFilepath, &xString3);
						result = _003CModule_003E.ClsDkim_002ELoadPublicKeyFile(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PrefetchPublicKey(string selector, string domain)
		{
			_DkimCallback dkimCallback;
			_003CModule_003E.DkimCallback_002E_007Bctor_007D((DkimCallback*)(&dkimCallback));
			try
			{
				*(int*)(&dkimCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_DkimCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref dkimCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DkimCallback_002E_007Bdtor_007D), &dkimCallback);
				throw;
			}
			bool result;
			try
			{
				_DkimCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &dkimCallback;
					*(int*)(&Unsafe.AddByteOffset(ref dkimCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(selector, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(domain, &xString2);
						result = _003CModule_003E.ClsDkim_002EPrefetchPublicKey(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_DkimCallback_002E_007Bdtor_007D), &dkimCallback);
				throw;
			}
			*(int*)(&dkimCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_DkimCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.DkimCallback_002E_007Bdtor_007D((DkimCallback*)(&dkimCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyDkimSignature(int sigIdx, byte[] mimeData)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			_DkimCallback dkimCallback;
			_003CModule_003E.DkimCallback_002E_007Bctor_007D((DkimCallback*)(&dkimCallback));
			try
			{
				*(int*)(&dkimCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_DkimCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref dkimCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DkimCallback_002E_007Bdtor_007D), &dkimCallback);
				throw;
			}
			bool result;
			try
			{
				_DkimCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &dkimCallback;
					*(int*)(&Unsafe.AddByteOffset(ref dkimCallback, 4)) = m_myHashCode;
				}
				int num2 = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(mimeData, &num2);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr2, (uint)num2);
					result = false;
					try
					{
						result = _003CModule_003E.ClsDkim_002EVerifyDkimSignature(m_impl, sigIdx, &dataBuffer, (ProgressEvent*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BE_0040NABEANDH_0040VerifyDkimSignature_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_00c6;
							}
							goto end_IL_00a2;
							IL_00c6:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_00a2:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					CkMarshal.free(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_DkimCallback_002E_007Bdtor_007D), &dkimCallback);
				throw;
			}
			*(int*)(&dkimCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_DkimCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.DkimCallback_002E_007Bdtor_007D((DkimCallback*)(&dkimCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyDomainKeySignature(int sigIdx, byte[] mimeData)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			_DkimCallback dkimCallback;
			_003CModule_003E.DkimCallback_002E_007Bctor_007D((DkimCallback*)(&dkimCallback));
			try
			{
				*(int*)(&dkimCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_DkimCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref dkimCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DkimCallback_002E_007Bdtor_007D), &dkimCallback);
				throw;
			}
			bool result;
			try
			{
				_DkimCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &dkimCallback;
					*(int*)(&Unsafe.AddByteOffset(ref dkimCallback, 4)) = m_myHashCode;
				}
				int num2 = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(mimeData, &num2);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr2, (uint)num2);
					result = false;
					try
					{
						result = _003CModule_003E.ClsDkim_002EVerifyDomainKeySignature(m_impl, sigIdx, &dataBuffer, (ProgressEvent*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BJ_0040CLDFHPIL_0040VerifyDomainKeySignature_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_00c6;
							}
							goto end_IL_00a2;
							IL_00c6:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_00a2:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					CkMarshal.free(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_DkimCallback_002E_007Bdtor_007D), &dkimCallback);
				throw;
			}
			*(int*)(&dkimCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_DkimCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.DkimCallback_002E_007Bdtor_007D((DkimCallback*)(&dkimCallback));
			return result;
		}

		public unsafe int NumDkimSignatures(byte[] mimeData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(mimeData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			int result;
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
				result = _003CModule_003E.ClsDkim_002ENumDkimSignatures(m_impl, &dataBuffer);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe int NumDomainKeySignatures(byte[] mimeData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(mimeData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			int result;
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
				result = _003CModule_003E.ClsDkim_002ENumDomainKeySignatures(m_impl, &dataBuffer);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] AddDkimSignature(byte[] mimeIn)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			int num2 = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(mimeIn, &num2);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num2);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					try
					{
						_003CModule_003E.ClsDkim_002EAddDkimSignature(m_impl, &dataBuffer, &dataBuffer2);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BB_0040CJPGKMOI_0040AddDkimSignature_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_008b;
							}
							goto end_IL_0067;
							IL_008b:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_0067:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] AddDomainKeySignature(byte[] mimeIn)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			int num2 = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(mimeIn, &num2);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num2);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					try
					{
						_003CModule_003E.ClsDkim_002EAddDomainKeySignature(m_impl, &dataBuffer, &dataBuffer2);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BG_0040LKFPLHFJ_0040AddDomainKeySignature_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_008b;
							}
							goto end_IL_0067;
							IL_008b:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_0067:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
