using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class EmailBundle : IDisposable
	{
		private unsafe ClsEmailBundle* m_impl;

		public unsafe int MessageCount
		{
			get
			{
				ClsEmailBundle* impl = m_impl;
				if (impl == null)
				{
					return 0;
				}
				return _003CModule_003E.ClsEmailBundle_002Eget_MessageCount(impl);
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe void* GetImplementation()
		{
			return m_impl;
		}

		public unsafe EmailBundle(void* b)
		{
			m_impl = (ClsEmailBundle*)b;
			if (b == null)
			{
				ClsEmailBundle* ptr = (ClsEmailBundle*)_003CModule_003E.@new(176u);
				ClsEmailBundle* impl;
				try
				{
					impl = (ClsEmailBundle*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsEmailBundle_002E_007Bctor_007D(ptr)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				m_impl = impl;
			}
		}

		public unsafe EmailBundle()
		{
			ClsEmailBundle* ptr = (ClsEmailBundle*)_003CModule_003E.@new(176u);
			ClsEmailBundle* impl;
			try
			{
				impl = (ClsEmailBundle*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsEmailBundle_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsEmailBundle* impl = m_impl;
			if (impl != null)
			{
				ClsEmailBundle* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
		}

		public unsafe override void Dispose()
		{
			ClsEmailBundle* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsEmailBundle_002EdotNetDispose(impl);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe StringArray GetUidls()
		{
			ClsEmailBundle* impl = m_impl;
			if (impl == null)
			{
				return null;
			}
			ClsStringArray* ptr = _003CModule_003E.ClsEmailBundle_002EGetUidls(impl);
			if (ptr == null)
			{
				return null;
			}
			return new StringArray(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveEmail(Email email)
		{
			if (email == null)
			{
				return false;
			}
			if (m_impl == null)
			{
				return false;
			}
			bool result = _003CModule_003E.ClsEmailBundle_002ERemoveEmail(m_impl, (ClsEmail*)email.LockImpl());
			email.ReleaseImpl();
			return result;
		}

		public unsafe Email GetEmail(int index)
		{
			ClsEmailBundle* impl = m_impl;
			if (impl == null)
			{
				return null;
			}
			ClsEmail* ptr = _003CModule_003E.ClsEmailBundle_002EGetCopyOfEmail(impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Email(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddEmail(Email email)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				return false;
			}
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			if (ptr == null)
			{
				email.ReleaseImpl();
				return false;
			}
			bool result = false;
			try
			{
				result = _003CModule_003E.ClsEmailBundle_002ECopyAndAddEmail2(m_impl, ptr);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08MIKEFGOD_0040AddEmail_003F_0024AA_0040));
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
						goto IL_0084;
					}
					goto end_IL_0060;
					IL_0084:
					if (num2 != 0)
					{
						throw;
					}
					end_IL_0060:;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
			email.ReleaseImpl();
			return result;
		}

		public unsafe Email FindByHeader(string name, string value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			ClsEmailBundle* impl;
			Email result;
			try
			{
				CkMarshal.StringToX(name, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(value, &xString2);
					impl = m_impl;
					if (impl == null)
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ClsEmail* ptr;
			Email result2;
			try
			{
				try
				{
					ptr = _003CModule_003E.ClsEmailBundle_002EFindByHeader(impl, &xString, &xString2);
					if (ptr == null)
					{
						result2 = null;
						goto IL_0083;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0061;
				IL_0083:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_009a;
				end_IL_0061:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result3;
			try
			{
				try
				{
					result3 = new Email(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result3;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
			IL_009a:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
		}

		public unsafe string GetXml()
		{
			if (m_impl == null)
			{
				return null;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_003CModule_003E.ClsEmailBundle_002EGetXml(m_impl, &xString);
				result = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveXml(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmailBundle* impl;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				impl = m_impl;
				if (impl != null)
				{
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return false;
			IL_0035:
			bool result;
			try
			{
				result = _003CModule_003E.ClsEmailBundle_002ESaveXml(impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXml(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsEmailBundle_002ELoadXml(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXmlString(string xmlStr)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(xmlStr, &xString);
				result = _003CModule_003E.ClsEmailBundle_002ELoadXmlString(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void SortBySubject([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsEmailBundle_002ESortBySubject(impl, ascending);
			}
		}

		public unsafe void SortBySender([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsEmailBundle_002ESortBySender(impl, ascending);
			}
		}

		public unsafe void SortByRecipient([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsEmailBundle_002ESortByRecipient(impl, ascending);
			}
		}

		public unsafe void SortByDate([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsEmailBundle_002ESortByDate(impl, ascending);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveEmailByIndex(int index)
		{
			return _003CModule_003E.ClsEmailBundle_002ERemoveEmailByIndex(m_impl, index);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
