using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class FileZippedEventArgs : EventArgs
	{
		private string m_fileName;

		private uint m_compressedSize;

		private uint m_fileSize;

		private bool m_abort;

		public bool Abort
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_abort;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				m_abort = value;
			}
		}

		public uint FileSize => m_fileSize;

		public uint CompressedSize => m_compressedSize;

		public string FileName => m_fileName;

		public unsafe FileZippedEventArgs(sbyte* fileName, uint fileSize, uint compressedSize)
		{
			m_compressedSize = compressedSize;
			m_fileSize = fileSize;
			m_abort = false;
			m_fileName = CkMarshal.Utf8ToString(fileName);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
