using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class FtpTreeEventArgs : EventArgs
	{
		private string m_path;

		private bool m_skip;

		private uint m_numBytes;

		public bool Skip
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_skip;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				m_skip = value;
			}
		}

		public uint NumBytes => m_numBytes;

		public string Path => m_path;

		public unsafe FtpTreeEventArgs(sbyte* path, uint numBytes)
		{
			m_path = CkMarshal.Utf8ToString(path);
			m_numBytes = numBytes;
			m_skip = false;
		}

		public unsafe FtpTreeEventArgs(sbyte* path)
		{
			m_path = CkMarshal.Utf8ToString(path);
			m_numBytes = 0u;
			m_skip = false;
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
