using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Gzip : IDisposable
	{
		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsGzip* m_impl;

		public unsafe bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsGzip_002Eget_VerboseLogging(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsGzip_002Eput_VerboseLogging(m_impl, value);
			}
		}

		public unsafe bool UseCurrentDate
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsGzip_002Eget_UseCurrentDate(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsGzip_002Eput_UseCurrentDate(m_impl, value);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsGzip_002Eget_Version(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe DateTime LastMod
		{
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				_003CModule_003E.ClsGzip_002Eget_LocalLastMod(m_impl, &chilkatSysTime);
				DateTime result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
					return result;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
							return result;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
						}
						if (num2 != 0)
						{
							throw;
						}
						return result;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			set
			{
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				*(short*)(&chilkatSysTime) = (short)value.Year;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)value.Month;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)value.Day;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)value.Hour;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)value.Minute;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)value.Second;
				_003CModule_003E.ClsGzip_002Eput_LocalLastMod(m_impl, &chilkatSysTime);
			}
		}

		public unsafe byte[] ExtraData
		{
			get
			{
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				byte[] result;
				try
				{
					_003CModule_003E.ClsGzip_002Eget_ExtraData(m_impl, &dataBuffer);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				return result;
			}
			set
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(value, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
					_003CModule_003E.ClsGzip_002Eput_ExtraData(m_impl, &dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
		}

		public unsafe string Comment
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsGzip_002Eget_Comment(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsGzip_002Eput_Comment(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Filename
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsGzip_002Eget_Filename(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsGzip_002Eput_Filename(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public event PercentDoneEventHandler OnPercentDone;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Gzip LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Gzip result = (Gzip)m_objects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			this.OnPercentDone?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public unsafe Gzip(void* impl)
		{
			m_impl = (ClsGzip*)impl;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
		}

		public unsafe Gzip()
		{
			m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0xa9cfcf01_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0xa9cfcf01_002ENextHashCode;
			ClsGzip* ptr = (ClsGzip*)_003CModule_003E.@new(912u);
			ClsGzip* impl;
			try
			{
				impl = (ClsGzip*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsGzip_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsGzip* impl = m_impl;
			if (impl != null)
			{
				ClsGzip* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		public unsafe void* GetImplementation()
		{
			return m_impl;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)((byte*)m_impl + 192), &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				int num = *(int*)((byte*)m_impl + 192) + 4;
				byte* intPtr = (byte*)m_impl + 192;
				sbyte* intPtr2 = _003CModule_003E.XString_002EgetUtf8(&xString);
				result = (((delegate* thiscall<IntPtr, sbyte*, byte>)(*(int*)num))((IntPtr)intPtr, intPtr2) != 0);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			byte* intPtr = (byte*)m_impl + 192;
			return ((delegate* thiscall<IntPtr, byte>)(*(int*)(*(int*)intPtr + 8)))((IntPtr)intPtr) != 0;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile(string inFilename, string outFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(outFilename, &xString2);
					_GzipCallback gzipCallback;
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsGzip_002ECompressFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile2(string inFilename, string embeddedFilename, string outFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(embeddedFilename, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(outFilename, &xString3);
						_GzipCallback gzipCallback;
						_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
						try
						{
							*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
							throw;
						}
						try
						{
							_GzipCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &gzipCallback;
								*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsGzip_002ECompressFile2(m_impl, &xString, &xString2, &xString3, (ProgressEvent*)ptr);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
							throw;
						}
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressFile(string inFilename, string outFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(outFilename, &xString2);
					_GzipCallback gzipCallback;
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsGzip_002EUncompressFile(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] CompressFileToMem(string inFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			_GzipCallback gzipCallback;
			byte[] result;
			try
			{
				CkMarshal.StringToX(inFilename, &xString);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						if (!_003CModule_003E.ClsGzip_002ECompressFileToMem(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					goto end_IL_0018;
					IL_007f:
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
					goto IL_009e;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0008;
				IL_009e:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_00b5;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00b5:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] UncompressFileToMem(string inFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			_GzipCallback gzipCallback;
			byte[] result;
			try
			{
				CkMarshal.StringToX(inFilename, &xString);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						if (!_003CModule_003E.ClsGzip_002EUncompressFileToMem(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					goto end_IL_0018;
					IL_007f:
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
					goto IL_009e;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0008;
				IL_009e:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_00b5;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00b5:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressMemToFile(byte[] inData, string outFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(outFilename, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					_GzipCallback gzipCallback;
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsGzip_002ECompressMemToFile(m_impl, &dataBuffer, &xString, (ProgressEvent*)ptr2);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressMemToFile(byte[] inData, string outFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(outFilename, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					_GzipCallback gzipCallback;
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsGzip_002EUncompressMemToFile(m_impl, &dataBuffer, &xString, (ProgressEvent*)ptr2);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] CompressMemory(byte[] inData)
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			DataBuffer dataBuffer2;
			_GzipCallback gzipCallback;
			byte[] result;
			try
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer2, ptr, (uint)num);
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						bool flag = _003CModule_003E.ClsGzip_002ECompressMemory(m_impl, &dataBuffer2, &dataBuffer, (ProgressEvent*)ptr2);
						CkMarshal.free(ptr);
						if (!flag)
						{
							result = null;
							goto IL_0095;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					goto end_IL_001c;
					IL_0095:
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
					goto IL_00b4;
					end_IL_001c:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				goto end_IL_0008;
				IL_00b4:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				goto IL_00cb;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_00cb:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] UncompressMemory(byte[] inData)
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			DataBuffer dataBuffer2;
			_GzipCallback gzipCallback;
			byte[] result;
			try
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer2, ptr, (uint)num);
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						bool flag = _003CModule_003E.ClsGzip_002EUncompressMemory(m_impl, &dataBuffer2, &dataBuffer, (ProgressEvent*)ptr2);
						CkMarshal.free(ptr);
						if (!flag)
						{
							result = null;
							goto IL_0095;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					goto end_IL_001c;
					IL_0095:
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
					goto IL_00b4;
					end_IL_001c:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				goto end_IL_0008;
				IL_00b4:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				goto IL_00cb;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_00cb:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string DeflateStringENC(string strIn, string charset, string encoding)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(strIn, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(charset, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(encoding, &xString3);
						XString xString4;
						_003CModule_003E.XString_002E_007Bctor_007D(&xString4);
						try
						{
							_003CModule_003E.ClsGzip_002EDeflateStringENC(m_impl, &xString, &xString2, &xString3, &xString4);
							result = CkMarshal.XToString(&xString4);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString4);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString4);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string InflateStringENC(string strIn, string charset, string encoding)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(strIn, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(charset, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(encoding, &xString3);
						XString xString4;
						_003CModule_003E.XString_002E_007Bctor_007D(&xString4);
						try
						{
							_003CModule_003E.ClsGzip_002EInflateStringENC(m_impl, &xString, &xString2, &xString3, &xString4);
							result = CkMarshal.XToString(&xString4);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString4);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString4);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnTarGz(string gzFilename, string destDir, [MarshalAs(UnmanagedType.U1)] bool bNoAbsolute)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(gzFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(destDir, &xString2);
					_GzipCallback gzipCallback;
					_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
					try
					{
						*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &gzipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsGzip_002EUnTarGz(m_impl, &xString, &xString2, bNoAbsolute, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
						throw;
					}
					*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] ReadFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsGzip_002EReadFile(m_impl, &xString, &dataBuffer);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFile(string filename, byte[] binaryData)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(binaryData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					result = _003CModule_003E.ClsGzip_002EWriteFile(m_impl, &xString, &dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] CompressString(string inStr, string outCharset)
		{
			_GzipCallback gzipCallback;
			_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
			try
			{
				*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			byte[] result;
			try
			{
				_GzipCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &gzipCallback;
					*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(inStr, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(outCharset, &xString2);
						DataBuffer dataBuffer;
						_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
						try
						{
							_003CModule_003E.ClsGzip_002ECompressString(m_impl, &xString, &xString2, &dataBuffer, (ProgressEvent*)ptr);
							result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
							throw;
						}
						_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressStringToFile(string inStr, string outCharset, string outFilename)
		{
			_GzipCallback gzipCallback;
			_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
			try
			{
				*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			bool result;
			try
			{
				_GzipCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &gzipCallback;
					*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(inStr, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(outCharset, &xString2);
						XString xString3;
						_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
						try
						{
							CkMarshal.StringToX(outFilename, &xString3);
							result = _003CModule_003E.ClsGzip_002ECompressStringToFile(m_impl, &xString, &xString2, &xString3, (ProgressEvent*)ptr);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
			return result;
		}

		public unsafe string UncompressFileToString(string inFilename, string inCharset)
		{
			_GzipCallback gzipCallback;
			_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
			try
			{
				*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			XString xString;
			XString xString2;
			XString xString3;
			string result;
			try
			{
				_GzipCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &gzipCallback;
					*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(inFilename, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(inCharset, &xString2);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
						try
						{
							if (!_003CModule_003E.ClsGzip_002EUncompressFileToString(m_impl, &xString, &xString2, &xString3, (ProgressEvent*)ptr))
							{
								result = null;
								goto IL_0091;
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						goto end_IL_0057;
						IL_0091:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
						goto IL_00a8;
						end_IL_0057:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_00a8:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_00bf;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_00bf:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00d6;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							result2 = CkMarshal.XToString(&xString3);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
			return result2;
			IL_00d6:
			*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
			return result;
		}

		public unsafe string UncompressString(byte[] inData, string inCharset)
		{
			_GzipCallback gzipCallback;
			_003CModule_003E.GzipCallback_002E_007Bctor_007D((GzipCallback*)(&gzipCallback));
			try
			{
				*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			DataBuffer dataBuffer;
			XString xString;
			XString xString2;
			string result;
			try
			{
				_GzipCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &gzipCallback;
					*(int*)(&Unsafe.AddByteOffset(ref gzipCallback, 4)) = m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, &num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr2, (uint)num);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString);
					try
					{
						CkMarshal.StringToX(inCharset, &xString);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
						try
						{
							bool flag = _003CModule_003E.ClsGzip_002EUncompressString(m_impl, &dataBuffer, &xString, &xString2, (ProgressEvent*)ptr);
							CkMarshal.free(ptr2);
							if (!flag)
							{
								result = null;
								goto IL_00a7;
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
							throw;
						}
						goto end_IL_0065;
						IL_00a7:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
						goto IL_00be;
						end_IL_0065:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
						throw;
					}
					goto end_IL_0053;
					IL_00be:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
					goto IL_00d5;
					end_IL_0053:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0027;
				IL_00d5:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_00ec;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							result2 = CkMarshal.XToString(&xString2);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_GzipCallback_002E_007Bdtor_007D), &gzipCallback);
				throw;
			}
			*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
			return result2;
			IL_00ec:
			*(int*)(&gzipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_GzipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.GzipCallback_002E_007Bdtor_007D((GzipCallback*)(&gzipCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExamineFile(string inGzFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inGzFilename, &xString);
				result = _003CModule_003E.ClsGzip_002EExamineFile(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExamineMemory(byte[] inGzData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inGzData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			bool result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				result = _003CModule_003E.ClsGzip_002EExamineMemory(m_impl, &dataBuffer);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] Decode(string str, string encoding)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(encoding, &xString2);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.ClsEncode_002EDecode((ClsEncode*)m_impl, &xString, &xString2, &dataBuffer, true);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string XfdlToXml(string xfdl)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(xfdl, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsGzip_002EXfdlToXml(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string Encode(byte[] byteData, string encoding)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(byteData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(encoding, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						_003CModule_003E.ClsEncode_002EEncode((ClsEncode*)m_impl, &dataBuffer, &xString, &xString2, false);
						CkMarshal.free(ptr);
						result = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		protected void raise_OnPercentDone(object i1, PercentDoneEventArgs i2)
		{
			this.OnPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
