using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class HtmlToXml
	{
		private static object m_lockImpl = new object();

		private unsafe ClsHtmlToXml* m_impl;

		public unsafe bool DropCustomTags
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHtmlToXml_002Eget_DropCustomTags(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				Monitor.Enter(m_lockImpl);
				if (value)
				{
					_003CModule_003E.ClsHtmlToXml_002EDropCustomTags(m_impl);
				}
				else
				{
					_003CModule_003E.ClsHtmlToXml_002EUndropCustomTags(m_impl);
				}
				Monitor.Exit(m_lockImpl);
			}
		}

		public unsafe string XmlCharset
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					ClsHtmlToXml* impl = m_impl;
					if (impl != null)
					{
						_003CModule_003E.ClsHtmlToXml_002Eget_XmlCharset(impl, &xString);
					}
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					ClsHtmlToXml* impl = m_impl;
					if (impl != null)
					{
						_003CModule_003E.ClsHtmlToXml_002Eput_XmlCharset(impl, &xString);
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Html
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					ClsHtmlToXml* impl = m_impl;
					if (impl != null)
					{
						_003CModule_003E.ClsHtmlToXml_002Eget_Html(impl, &xString);
					}
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					ClsHtmlToXml* impl = m_impl;
					if (impl != null)
					{
						_003CModule_003E.ClsHtmlToXml_002Eput_Html(impl, &xString);
					}
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int Nbsp
		{
			get
			{
				return _003CModule_003E.ClsHtmlToXml_002Eget_Nbsp(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHtmlToXml_002Eput_Nbsp(m_impl, value);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					ClsHtmlToXml* impl = m_impl;
					if (impl != null)
					{
						_003CModule_003E.ClsHtmlToXml_002Eget_VersionX(impl, &xString);
					}
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe HtmlToXml()
		{
			Monitor.Enter(m_lockImpl);
			ClsHtmlToXml* ptr = (ClsHtmlToXml*)_003CModule_003E.@new(592u);
			ClsHtmlToXml* impl;
			try
			{
				impl = (ClsHtmlToXml*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsHtmlToXml_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
			_003CModule_003E._003Fm_progLang_0040ClsHtmlToXml_0040_00402HA = 2;
			Monitor.Exit(m_lockImpl);
		}

		protected unsafe override void Finalize()
		{
			Monitor.Enter(m_lockImpl);
			ClsHtmlToXml* impl = m_impl;
			if (impl != null)
			{
				ClsHtmlToXml* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			Monitor.Exit(m_lockImpl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsHtmlToXml_002EUnlockComponentX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsHtmlToXml* impl = m_impl;
			return ((delegate* thiscall<IntPtr, byte>)(*(int*)(*(int*)impl + 8)))((IntPtr)impl) != 0;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetHtmlFromFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsHtmlToXml_002ESetHtmlFromFile(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void SetHtmlBytes(byte[] inData)
		{
			Monitor.Enter(m_lockImpl);
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.ClsHtmlToXml_002ESetHtmlBytes(m_impl, &dataBuffer);
				CkMarshal.free(ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
		}

		public unsafe string ToXml()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			Monitor.Enter(m_lockImpl);
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				bool flag = false;
				try
				{
					flag = _003CModule_003E.ClsHtmlToXml_002EToXml(m_impl, &xString);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_05EFLOKPLE_0040ToXml_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_0076;
						}
						goto end_IL_0052;
						IL_0076:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0052:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				Monitor.Exit(m_lockImpl);
				if (!flag)
				{
					result = null;
					goto IL_00a9;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00a9:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] ReadFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			byte[] result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					bool flag = _003CModule_003E.ClsHtmlToXml_002EReadFileX(m_impl, &xString, &dataBuffer);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0053;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0008;
				IL_0053:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_006a;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_006a:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string ReadFileToString(string filename, string srcCharset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			string result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(srcCharset, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						if (!_003CModule_003E.XString_002EreadFile(&xString3, &xString, &xString2))
						{
							result = null;
							goto IL_004b;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_004b:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0062;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0062:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0079;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0079:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFile(string filename, byte[] fileData)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(fileData, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
					result = _003CModule_003E.ClsHtmlToXml_002EWriteFileX(m_impl, &xString, &dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteStringToFile(string str, string filename, string charset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(filename, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(charset, &xString3);
						result = _003CModule_003E.XString_002EwriteToFile(&xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertFile(string inHtmlFilename, string outXmlFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inHtmlFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(outXmlFilename, &xString2);
					Monitor.Enter(m_lockImpl);
					result = _003CModule_003E.ClsHtmlToXml_002EConvertFile(m_impl, &xString, &xString2);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void DropTagType(string tagName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tagName, &xString);
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.ClsHtmlToXml_002EDropTagType(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void UndropTagType(string tagName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tagName, &xString);
				Monitor.Enter(m_lockImpl);
				_003CModule_003E.ClsHtmlToXml_002EUndropTagType(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void DropTextFormattingTags()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsHtmlToXml_002EDropTextFormattingTags(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		public unsafe void UndropTextFormattingTags()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsHtmlToXml_002EUndropTextFormattingTags(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
