using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Http : IDisposable
	{
		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void ProgressInfoEventHandler(object sender, ProgressInfoEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void ReceiveRateEventHandler(object sender, DataRateEventArgs args);

		public delegate void HttpChunkedEventHandler(object sender, EventArgs args);

		public delegate void HttpRedirectEventHandler(object sender, HttpRedirectEventArgs args);

		public delegate void HttpBeginReceiveEventHandler(object sender, EventArgs args);

		public delegate void HttpBeginSendEventHandler(object sender, EventArgs args);

		public delegate void HttpEndReceiveEventHandler(object sender, StatusEventArgs args);

		public delegate void HttpEndSendEventHandler(object sender, StatusEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsHttp* m_impl;

		public unsafe string ProxyAuthMethod
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_ProxyAuthMethod(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_ProxyAuthMethod(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ClientIpAddress
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_ClientIpAddress(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_ClientIpAddress(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool UseBgThread
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsBgTask_002Eget_UseBgThread((ClsBgTask*)((byte*)m_impl + 152));
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsBgTask_002Eput_UseBgThread((ClsBgTask*)((byte*)m_impl + 152), value);
			}
		}

		public unsafe bool KeepEventLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsBgTask_002Eget_KeepEventLog((ClsBgTask*)((byte*)m_impl + 152));
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsBgTask_002Eput_KeepEventLog((ClsBgTask*)((byte*)m_impl + 152), value);
			}
		}

		public unsafe int EventLogCount => _003CModule_003E.ClsBgTask_002Eget_EventLogCount((ClsBgTask*)((byte*)m_impl + 152));

		public unsafe bool BgTaskSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsBgTask_002Eget_BgTaskSuccess((ClsBgTask*)((byte*)m_impl + 152));
			}
		}

		public unsafe bool BgTaskRunning
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsBgTask_002Eget_BgTaskRunning((ClsBgTask*)((byte*)m_impl + 152));
			}
		}

		public unsafe bool BgTaskFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsBgTask_002Eget_BgTaskFinished((ClsBgTask*)((byte*)m_impl + 152));
			}
		}

		public unsafe string BgResultString
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBgTask_002Eget_BgResultString((ClsBgTask*)((byte*)m_impl + 152), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int BgResultInt => _003CModule_003E.ClsBgTask_002Eget_BgResultInt((ClsBgTask*)((byte*)m_impl + 152));

		public unsafe byte[] BgResultData
		{
			get
			{
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				byte[] result;
				try
				{
					_003CModule_003E.ClsBgTask_002Eget_BgResultData((ClsBgTask*)((byte*)m_impl + 152), &dataBuffer);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				return result;
			}
		}

		public unsafe string BgLastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBgTask_002Eget_BgLastErrorText((ClsBgTask*)((byte*)m_impl + 152), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string SessionLogFilename
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_SessionLogFilename(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_SessionLogFilename(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_VerboseLogging(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_VerboseLogging(m_impl, value);
			}
		}

		public unsafe bool DigestAuth
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_DigestAuth(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_DigestAuth(m_impl, value);
			}
		}

		public unsafe bool ProxyPartialUrl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_ProxyPartialUrl(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_ProxyPartialUrl(m_impl, value);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_SocksHostname(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_SocksHostname(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_SocksPassword(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_SocksPassword(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_SocksUsername(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_SocksUsername(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int SocksPort
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_SocksPort(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_SocksPort(m_impl, value);
			}
		}

		public unsafe int SocksVersion
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_SocksVersion(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_SocksVersion(m_impl, value);
			}
		}

		public unsafe string LoginDomain
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_LoginDomain(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_LoginDomain(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool NegotiateAuth
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_NegotiateAuth(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_NegotiateAuth(m_impl, value);
			}
		}

		public unsafe int SendBufferSize
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_SendBufferSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_SendBufferSize(m_impl, value);
			}
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_SslProtocol(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_SslProtocol(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string RequiredContentType
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_RequiredContentType(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_RequiredContentType(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe string LastHeader
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_LastHeader(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_VersionX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int MinFreshPeriod
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_MinFreshPeriod(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_MinFreshPeriod(m_impl, value);
			}
		}

		public unsafe int MaxFreshPeriod
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_MaxFreshPeriod(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_MaxFreshPeriod(m_impl, value);
			}
		}

		public unsafe int LMFactor
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_LMFactor(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_LMFactor(m_impl, value);
			}
		}

		public unsafe int FreshnessAlgorithm
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_FreshnessAlgorithm(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_FreshnessAlgorithm(m_impl, value);
			}
		}

		public unsafe int DefaultFreshPeriod
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_DefaultFreshPeriod(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_DefaultFreshPeriod(m_impl, value);
			}
		}

		public unsafe bool IgnoreMustRevalidate
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_IgnoreMustRevalidate(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_IgnoreMustRevalidate(m_impl, value);
			}
		}

		public unsafe bool IgnoreNoCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_IgnoreNoCache(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_IgnoreNoCache(m_impl, value);
			}
		}

		public unsafe bool FetchFromCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_FetchFromCache(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_FetchFromCache(m_impl, value);
			}
		}

		public unsafe bool UpdateCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_UpdateCache(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_UpdateCache(m_impl, value);
			}
		}

		public unsafe int NumCacheRoots => _003CModule_003E.ClsHttp_002Eget_NumCacheRoots(m_impl);

		public unsafe int NumCacheLevels
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_NumCacheLevels(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_NumCacheLevels(m_impl, value);
			}
		}

		public unsafe bool FollowRedirects
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_FollowRedirects(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_FollowRedirects(m_impl, value);
			}
		}

		public unsafe string FinalRedirectUrl
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_FinalRedirectUrlX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool WasRedirected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_WasRedirected(m_impl);
			}
		}

		public unsafe int ReadTimeout
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_ReadTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_ReadTimeout(m_impl, value);
			}
		}

		public unsafe int ConnectTimeout
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_ConnectTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_ConnectTimeout(m_impl, value);
			}
		}

		public unsafe bool AutoAddHostHeader
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_AutoAddHostHeader(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_AutoAddHostHeader(m_impl, value);
			}
		}

		public unsafe bool MimicFireFox
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_MimicFireFox(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_MimicFireFox(m_impl, value);
			}
		}

		public unsafe bool MimicIE
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_MimicIE(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_MimicIE(m_impl, value);
			}
		}

		public unsafe int MaxResponseSize
		{
			get
			{
				return (int)_003CModule_003E.ClsHttp_002Eget_MaxResponseSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_MaxResponseSize(m_impl, (uint)value);
			}
		}

		public unsafe int MaxUrlLen
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_MaxUrlLen(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_MaxUrlLen(m_impl, value);
			}
		}

		public unsafe string Connection
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_ConnectionX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_ConnectionX(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string AcceptLanguage
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_AcceptLanguageX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_AcceptLanguageX(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string AcceptCharset
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_AcceptCharsetX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_AcceptCharsetX(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Accept
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_Accept(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_Accept(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Referer
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_RefererX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_RefererX(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string UserAgent
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_UserAgent(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_UserAgent(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Password
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_Password(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_Password(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Login
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_Login(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_Login(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ProxyDomain
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_ProxyDomain(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_ProxyDomain(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int ProxyPort
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_ProxyPort(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_ProxyPort(m_impl, value);
			}
		}

		public unsafe int HeartbeatMs
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_HeartbeatMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_HeartbeatMs(m_impl, value);
			}
		}

		public unsafe bool UseIEProxy
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_UseIEProxy(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_UseIEProxy(m_impl, value);
			}
		}

		public unsafe bool SendCookies
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_SendCookies(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_SendCookies(m_impl, value);
			}
		}

		public unsafe bool SaveCookies
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_SaveCookies(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_SaveCookies(m_impl, value);
			}
		}

		public unsafe string CookieDir
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_CookieDirX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_CookieDirX(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastModDate
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_LastModDateX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastResponseHeader
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_LastResponseHeaderX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastContentType
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_LastContentTypeX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int LastStatus => _003CModule_003E.ClsHttp_002Eget_LastStatus(m_impl);

		public unsafe bool NtlmAuth
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_NtlmAuth(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsHttp_002Eput_NtlmAuth(m_impl, value);
			}
		}

		public unsafe int MaxConnections
		{
			get
			{
				return _003CModule_003E.ClsHttp_002Eget_MaxConnections(m_impl);
			}
			set
			{
				_003CModule_003E.ClsHttp_002Eput_MaxConnections(m_impl, value);
			}
		}

		public unsafe string ProxyPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_ProxyPassword(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_ProxyPassword(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ProxyLogin
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttp_002Eget_ProxyLogin(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttp_002Eput_ProxyLogin(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event HttpEndSendEventHandler OnHttpEndSend;

		public event HttpEndReceiveEventHandler OnHttpEndReceive;

		public event HttpBeginSendEventHandler OnHttpBeginSend;

		public event HttpBeginReceiveEventHandler OnHttpBeginReceive;

		public event HttpRedirectEventHandler OnHttpRedirect;

		public event HttpChunkedEventHandler OnHttpChunked;

		public event ReceiveRateEventHandler OnReceiveRate;

		public event AbortCheckEventHandler OnAbortCheck;

		public event ProgressInfoEventHandler OnProgressInfo;

		public event PercentDoneEventHandler OnPercentDone;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Http LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Http result = (Http)m_objects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			this.OnPercentDone?.Invoke(sender, args);
		}

		public void FireProgressInfo(object sender, ProgressInfoEventArgs args)
		{
			this.OnProgressInfo?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public void FireReceiveRate(object sender, DataRateEventArgs args)
		{
			this.OnReceiveRate?.Invoke(sender, args);
		}

		public void FireHttpChunked(object sender, EventArgs args)
		{
			this.OnHttpChunked?.Invoke(sender, args);
		}

		public void FireHttpRedirect(object sender, HttpRedirectEventArgs args)
		{
			this.OnHttpRedirect?.Invoke(sender, args);
		}

		public void FireHttpBeginReceive(object sender, EventArgs args)
		{
			this.OnHttpBeginReceive?.Invoke(sender, args);
		}

		public void FireHttpBeginSend(object sender, EventArgs args)
		{
			this.OnHttpBeginSend?.Invoke(sender, args);
		}

		public void FireHttpEndReceive(object sender, StatusEventArgs args)
		{
			this.OnHttpEndReceive?.Invoke(sender, args);
		}

		public void FireHttpEndSend(object sender, StatusEventArgs args)
		{
			this.OnHttpEndSend?.Invoke(sender, args);
		}

		public unsafe Http()
		{
			m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnProgressInfo = null;
			this.OnAbortCheck = null;
			this.OnReceiveRate = null;
			this.OnHttpChunked = null;
			this.OnHttpRedirect = null;
			this.OnHttpBeginReceive = null;
			this.OnHttpBeginSend = null;
			this.OnHttpEndReceive = null;
			this.OnHttpEndSend = null;
			_003CModule_003E._003FA0x65f5efec_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0x65f5efec_002ENextHashCode;
			ClsHttp* ptr = (ClsHttp*)_003CModule_003E.@new(3320u);
			ClsHttp* ptr2;
			try
			{
				ptr2 = (ClsHttp*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsHttp_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 3312) = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsHttp* impl = m_impl;
			if (impl != null)
			{
				ClsHttp* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public unsafe override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			ClsHttp* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsHttp_002EdotNetDispose(impl);
			}
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			//Discarded unreachable code: IL_00c5
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				result = false;
				if (m_impl == null)
				{
					ClsHttp* ptr = (ClsHttp*)_003CModule_003E.@new(3320u);
					ClsHttp* ptr2;
					try
					{
						ptr2 = (ClsHttp*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsHttp_002E_007Bctor_007D(ptr)));
					}
					catch
					{
						//try-fault
						_003CModule_003E.delete(ptr);
						throw;
					}
					m_impl = ptr2;
					*(int*)((byte*)ptr2 + 3312) = 2;
				}
				try
				{
					result = _003CModule_003E.ClsHttp_002EUnlockComponentX(m_impl, &xString);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040CGAIPMHI_0040UnlockComponent_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00b3;
						}
						goto end_IL_008f;
						IL_00b3:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_008f:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsHttp* impl = m_impl;
			return ((delegate* thiscall<IntPtr, byte>)(*(int*)(*(int*)impl + 8)))((IntPtr)impl) != 0;
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			_003CModule_003E.ClsHttp_002ESetSslClientCert(m_impl, ptr);
		}

		public unsafe byte[] QuickGet(string url)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			_HttpCallback httpCallback;
			byte[] result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
					try
					{
						*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &httpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
						}
						bool flag = false;
						try
						{
							flag = _003CModule_003E.ClsHttp_002EQuickGetX(m_impl, &xString, &dataBuffer, (ProgressEvent*)ptr);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08OFEPMGLD_0040QuickGet_003F_0024AA_0040));
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_00be;
								}
								goto end_IL_009a;
								IL_00be:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_009a:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
						if (!flag)
						{
							result = new byte[0];
							goto IL_00ec;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					goto end_IL_0020;
					IL_00ec:
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
					goto IL_010b;
					end_IL_0020:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0010;
				IL_010b:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_0122;
				end_IL_0010:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0122:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string QuickGetStr(string url)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			_HttpCallback httpCallback;
			string result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
					try
					{
						*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &httpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
						}
						bool flag = false;
						try
						{
							flag = _003CModule_003E.ClsHttp_002EQuickGetStr(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0M_0040CLJCBHNB_0040QuickGetStr_003F_0024AA_0040));
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_00be;
								}
								goto end_IL_009a;
								IL_00be:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_009a:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
						if (!flag && _003CModule_003E.XString_002EgetNumChars(&xString2) == 0)
						{
							result = null;
							goto IL_00f2;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					goto end_IL_0020;
					IL_00f2:
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
					goto IL_0111;
					end_IL_0020:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0010;
				IL_0111:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0128;
				end_IL_0010:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0128:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string UrlEncode(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ClsHttp_002EUrlEncode(m_impl, &xString, &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string UrlDecode(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ClsHttp_002EUrlDecode(m_impl, &xString, &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Download(string url, string filename)
		{
			//Discarded unreachable code: IL_00d7
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(filename, &xString2);
					_HttpCallback httpCallback;
					_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
					try
					{
						*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &httpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
						}
						result = false;
						try
						{
							result = _003CModule_003E.ClsHttp_002EDownload(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08PPHBPJGP_0040Download_003F_0024AA_0040));
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_00c6;
								}
								goto end_IL_00a2;
								IL_00c6:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_00a2:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DownloadAppend(string url, string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(filename, &xString2);
					_HttpCallback httpCallback;
					_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
					try
					{
						*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &httpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsHttp_002EDownloadAppend(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ResumeDownload(string url, string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(filename, &xString2);
					_HttpCallback httpCallback;
					_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
					try
					{
						*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &httpCallback;
							*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsHttp_002EResumeDownload(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
						throw;
					}
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe HttpResponse SynchronousRequest(string domain, int port, [MarshalAs(UnmanagedType.U1)] bool ssl, HttpRequest req)
		{
			if (req == null)
			{
				return null;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_HttpCallback httpCallback;
			ClsHttpResponse* ptr2;
			HttpResponse result;
			try
			{
				CkMarshal.StringToX(domain, &xString);
				ClsHttpRequest* implementation = (ClsHttpRequest*)req.GetImplementation();
				_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
				try
				{
					*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
					throw;
				}
				try
				{
					_HttpCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &httpCallback;
						*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
					}
					ptr2 = _003CModule_003E.ClsHttp_002ESynchronousRequest(m_impl, _003CModule_003E.XString_002EgetAnsi(&xString), port, ssl, implementation, (ProgressEvent*)ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_008d;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
					throw;
				}
				goto end_IL_000e;
				IL_008d:
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
				goto IL_00ac;
				end_IL_000e:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			HttpResponse result2;
			try
			{
				try
				{
					result2 = new HttpResponse(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
					throw;
				}
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00ac:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void SetRequestHeader(string name, string value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(name, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(value, &xString2);
					_003CModule_003E.ClsHttp_002ESetRequestHeader(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe string GetRequestHeader(string name)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(name, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsHttp_002EGetRequestHeader(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasRequestHeader(string name)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xString);
				result = _003CModule_003E.ClsHttp_002EHasRequestHeader(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void RemoveRequestHeader(string name)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(name, &xString);
				_003CModule_003E.ClsHttp_002ERemoveRequestHeader(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe string GetDomain(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ClsHttp_002EExtractDomain(m_impl, &xString, &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetCacheRoot(int index)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsHttp_002EGetCacheRoot(m_impl, index, &xString))
				{
					result = null;
					goto IL_002e;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void AddCacheRoot(string dir)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(dir, &xString);
				_003CModule_003E.ClsHttp_002EAddCacheRoot(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe string GetUrlPath(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ClsHttp_002EGetUrlPath(m_impl, &xString, &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string RenderGet(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsHttp_002ERenderGet(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetCookieXml(string domain)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(domain, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsHttp_002EGetCookieXml(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe HttpResponse PostMime(string url, string mime)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			ClsHttpResponse* ptr2;
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(mime, &xString2);
						ptr2 = _003CModule_003E.ClsHttp_002EPostMime(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						if (ptr2 == null)
						{
							result = null;
							goto IL_0087;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_0087:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_009e;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_009e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00b5;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			HttpResponse result2;
			try
			{
				try
				{
					try
					{
						result2 = new HttpResponse(ptr2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_00b5:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe HttpResponse GetHead(string url)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			ClsHttpResponse* ptr2;
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					ptr2 = _003CModule_003E.ClsHttp_002EGetHead(m_impl, &xString, (ProgressEvent*)ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_0075;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0075:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_008c;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			HttpResponse result2;
			try
			{
				try
				{
					result2 = new HttpResponse(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_008c:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe string XmlRpc(string urlEndpoint, string xmlIn)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			XString xString3;
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(urlEndpoint, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(xmlIn, &xString2);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
						try
						{
							if (!_003CModule_003E.ClsHttp_002EXmlRpc(m_impl, &xString, &xString2, &xString3, (ProgressEvent*)ptr) && _003CModule_003E.XString_002EgetNumChars(&xString3) == 0)
							{
								result = null;
								goto IL_009c;
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						goto end_IL_0057;
						IL_009c:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
						goto IL_00b3;
						end_IL_0057:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_00b3:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_00ca;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_00ca:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00e1;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							result2 = CkMarshal.XToString(&xString3);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_00e1:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe string GenTimeStamp()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_003CModule_003E.ClsHttp_002EGenTimeStamp(m_impl, &xString);
				result = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string XmlRpcPut(string urlEndpoint, string xmlIn)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			XString xString3;
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(urlEndpoint, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(xmlIn, &xString2);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
						try
						{
							if (!_003CModule_003E.ClsHttp_002EXmlRpcPut(m_impl, &xString, &xString2, &xString3, (ProgressEvent*)ptr) && _003CModule_003E.XString_002EgetNumChars(&xString3) == 0)
							{
								result = null;
								goto IL_009c;
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						goto end_IL_0057;
						IL_009c:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
						goto IL_00b3;
						end_IL_0057:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_00b3:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_00ca;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_00ca:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00e1;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							result2 = CkMarshal.XToString(&xString3);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_00e1:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe string QuickPutStr(string url)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						if (!_003CModule_003E.ClsHttp_002EQuickPutStr(m_impl, &xString, &xString2, (ProgressEvent*)ptr) && _003CModule_003E.XString_002EgetNumChars(&xString2) == 0)
						{
							result = null;
							goto IL_008a;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_008a:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_00a1;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_00a1:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00b8;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_00b8:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe string QuickDeleteStr(string url)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						if (!_003CModule_003E.ClsHttp_002EQuickDeleteStr(m_impl, &xString, &xString2, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_007f:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_0096;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0096:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00ad;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_00ad:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe string PutText(string url, string textData, string charset, string contentType, [MarshalAs(UnmanagedType.U1)] bool md5, [MarshalAs(UnmanagedType.U1)] bool gzip)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			XString xString3;
			XString xString4;
			XString xString5;
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(textData, &xString2);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
						try
						{
							CkMarshal.StringToX(charset, &xString3);
							_003CModule_003E.XString_002E_007Bctor_007D(&xString4);
							try
							{
								CkMarshal.StringToX(contentType, &xString4);
								_003CModule_003E.XString_002E_007Bctor_007D(&xString5);
								try
								{
									if (!_003CModule_003E.ClsHttp_002EPutText(m_impl, &xString, &xString2, &xString3, &xString4, md5, gzip, &xString5, (ProgressEvent*)ptr))
									{
										result = null;
										goto IL_00bd;
									}
								}
								catch
								{
									//try-fault
									_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString5);
									throw;
								}
								goto end_IL_0077;
								IL_00bd:
								_003CModule_003E.XString_002E_007Bdtor_007D(&xString5);
								goto IL_00d4;
								end_IL_0077:;
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString4);
								throw;
							}
							goto end_IL_0067;
							IL_00d4:
							_003CModule_003E.XString_002E_007Bdtor_007D(&xString4);
							goto IL_00eb;
							end_IL_0067:;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						goto end_IL_0057;
						IL_00eb:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
						goto IL_0102;
						end_IL_0057:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_0102:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_0119;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0119:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_0130;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							try
							{
								try
								{
									result2 = CkMarshal.XToString(&xString5);
								}
								catch
								{
									//try-fault
									_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString5);
									throw;
								}
								_003CModule_003E.XString_002E_007Bdtor_007D(&xString5);
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString4);
								throw;
							}
							_003CModule_003E.XString_002E_007Bdtor_007D(&xString4);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_0130:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe string PutBinary(string url, byte[] byteData, string contentType, [MarshalAs(UnmanagedType.U1)] bool md5, [MarshalAs(UnmanagedType.U1)] bool gzip)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			DataBuffer dataBuffer;
			XString xString2;
			XString xString3;
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					int num2 = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(byteData, &num2);
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr2, (uint)num2);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
						try
						{
							CkMarshal.StringToX(contentType, &xString2);
							_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
							try
							{
								bool flag = false;
								try
								{
									flag = _003CModule_003E.ClsHttp_002EPutBinary(m_impl, &xString, &dataBuffer, &xString2, md5, gzip, &xString3, (ProgressEvent*)ptr);
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									uint exceptionCode = (uint)Marshal.GetExceptionCode();
									return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
								}).Invoke())
								{
									uint num3 = 0u;
									_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
									try
									{
										try
										{
											_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09MHDABFDI_0040PutBinary_003F_0024AA_0040));
										}
										catch when (((Func<bool>)delegate
										{
											// Could not convert BlockContainer to single expression
											num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
											return (byte)num3 != 0;
										}).Invoke())
										{
											goto IL_00f6;
										}
										goto end_IL_00d2;
										IL_00f6:
										if (num3 != 0)
										{
											throw;
										}
										end_IL_00d2:;
									}
									finally
									{
										_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
									}
								}
								CkMarshal.free(ptr2);
								if (!flag)
								{
									result = null;
									goto IL_0129;
								}
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
								throw;
							}
							goto end_IL_007e;
							IL_0129:
							_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
							goto IL_0140;
							end_IL_007e:;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
							throw;
						}
						goto end_IL_006c;
						IL_0140:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
						goto IL_0157;
						end_IL_006c:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					goto end_IL_0050;
					IL_0157:
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
					goto IL_016e;
					end_IL_0050:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0030;
				IL_016e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_0185;
				end_IL_0030:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							try
							{
								result2 = CkMarshal.XToString(&xString3);
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
								throw;
							}
							_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_0185:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe HttpResponse PostXml(string url, string xmlDoc, string charset)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			XString xString2;
			XString xString3;
			ClsHttpResponse* ptr2;
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(xmlDoc, &xString2);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
						try
						{
							CkMarshal.StringToX(charset, &xString3);
							ptr2 = _003CModule_003E.ClsHttp_002EPostXml(m_impl, &xString, &xString2, &xString3, (ProgressEvent*)ptr);
							if (ptr2 == null)
							{
								result = null;
								goto IL_0099;
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						goto end_IL_0057;
						IL_0099:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
						goto IL_00b0;
						end_IL_0057:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_00b0:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_00c7;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_00c7:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00de;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			HttpResponse result2;
			try
			{
				try
				{
					try
					{
						try
						{
							result2 = new HttpResponse(ptr2);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_00de:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe Cert GetServerSslCert(string domain, int port)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			ClsCert* ptr2;
			Cert result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(domain, &xString);
					ptr2 = _003CModule_003E.ClsHttp_002EGetServerSslCert(m_impl, &xString, port, (ProgressEvent*)ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_0076;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0076:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_008d;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			Cert result2;
			try
			{
				try
				{
					result2 = new Cert(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_008d:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xString3);
						result = _003CModule_003E.ClsHttp_002ESetSslClientCertPfx(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void ClearInMemoryCookies()
		{
			_003CModule_003E.ClsHttp_002EClearInMemoryCookies(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetCookieXml(string domain, string cookieXml)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(domain, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(cookieXml, &xString2);
					result = _003CModule_003E.ClsHttp_002ESetCookieXml(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe HttpResponse PostUrlEncoded(string url, HttpRequest req)
		{
			if (req == null)
			{
				return null;
			}
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			ClsHttpResponse* ptr2;
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					ClsHttpRequest* implementation = (ClsHttpRequest*)req.GetImplementation();
					ptr2 = _003CModule_003E.ClsHttp_002EPostUrlEncoded(m_impl, &xString, implementation, (ProgressEvent*)ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_0084;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_002c;
				IL_0084:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_009b;
				end_IL_002c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			HttpResponse result2;
			try
			{
				try
				{
					result2 = new HttpResponse(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_009b:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe string PostBinary(string url, byte[] byteData, string contentType, [MarshalAs(UnmanagedType.U1)] bool md5, [MarshalAs(UnmanagedType.U1)] bool gzip)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			DataBuffer dataBuffer;
			XString xString2;
			XString xString3;
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					int num = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(byteData, &num);
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr2, (uint)num);
						_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
						try
						{
							CkMarshal.StringToX(contentType, &xString2);
							_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
							try
							{
								bool flag = _003CModule_003E.ClsHttp_002EPostBinary(m_impl, &xString, &dataBuffer, &xString2, md5, gzip, &xString3, (ProgressEvent*)ptr);
								CkMarshal.free(ptr2);
								if (!flag)
								{
									result = null;
									goto IL_00c1;
								}
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
								throw;
							}
							goto end_IL_0076;
							IL_00c1:
							_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
							goto IL_00d8;
							end_IL_0076:;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
							throw;
						}
						goto end_IL_0063;
						IL_00d8:
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
						goto IL_00ef;
						end_IL_0063:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					goto end_IL_0047;
					IL_00ef:
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
					goto IL_0106;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0106:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_011d;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						try
						{
							try
							{
								result2 = CkMarshal.XToString(&xString3);
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
								throw;
							}
							_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_011d:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe HttpResponse QuickGetObj(string url)
		{
			_HttpCallback httpCallback;
			_003CModule_003E.HttpCallback_002E_007Bctor_007D((HttpCallback*)(&httpCallback));
			try
			{
				*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			XString xString;
			ClsHttpResponse* ptr2;
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &httpCallback;
					*(int*)(&Unsafe.AddByteOffset(ref httpCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					ptr2 = _003CModule_003E.ClsHttp_002EQuickGetObj(m_impl, &xString, (ProgressEvent*)ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_0075;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0075:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_008c;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			HttpResponse result2;
			try
			{
				try
				{
					result2 = new HttpResponse(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_HttpCallback_002E_007Bdtor_007D), &httpCallback);
				throw;
			}
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result2;
			IL_008c:
			*(int*)(&httpCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_HttpCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.HttpCallback_002E_007Bdtor_007D((HttpCallback*)(&httpCallback));
			return result;
		}

		public unsafe HttpResponse BgResponseObject()
		{
			ClsHttpResponse* ptr = _003CModule_003E.ClsHttp_002EBgResponseObject(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new HttpResponse(ptr);
		}

		public unsafe void BgTaskAbort()
		{
			_003CModule_003E.ClsBgTask_002EBgTaskAbort((ClsBgTask*)((byte*)m_impl + 152));
		}

		public unsafe void ClearEventLog()
		{
			_003CModule_003E.ClsBgTask_002EClearEventLog((ClsBgTask*)((byte*)m_impl + 152));
		}

		public unsafe string EventLogName(int index)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsBgTask_002EEventLogName((ClsBgTask*)((byte*)m_impl + 152), index, &xString))
				{
					result = null;
					goto IL_0034;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0034:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string EventLogValue(int index)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsBgTask_002EEventLogValue((ClsBgTask*)((byte*)m_impl + 152), index, &xString))
				{
					result = null;
					goto IL_0034;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0034:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void SleepMs(int millisec)
		{
			_003CModule_003E.ClsHttp_002ESleepMs(m_impl, millisec);
		}

		protected void raise_OnPercentDone(object i1, PercentDoneEventArgs i2)
		{
			this.OnPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnProgressInfo(object i1, ProgressInfoEventArgs i2)
		{
			this.OnProgressInfo?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		protected void raise_OnReceiveRate(object i1, DataRateEventArgs i2)
		{
			this.OnReceiveRate?.Invoke(i1, i2);
		}

		protected void raise_OnHttpChunked(object i1, EventArgs i2)
		{
			this.OnHttpChunked?.Invoke(i1, i2);
		}

		protected void raise_OnHttpRedirect(object i1, HttpRedirectEventArgs i2)
		{
			this.OnHttpRedirect?.Invoke(i1, i2);
		}

		protected void raise_OnHttpBeginReceive(object i1, EventArgs i2)
		{
			this.OnHttpBeginReceive?.Invoke(i1, i2);
		}

		protected void raise_OnHttpBeginSend(object i1, EventArgs i2)
		{
			this.OnHttpBeginSend?.Invoke(i1, i2);
		}

		protected void raise_OnHttpEndReceive(object i1, StatusEventArgs i2)
		{
			this.OnHttpEndReceive?.Invoke(i1, i2);
		}

		protected void raise_OnHttpEndSend(object i1, StatusEventArgs i2)
		{
			this.OnHttpEndSend?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
