using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class HttpRedirectEventArgs : EventArgs
	{
		private string m_originalUrl;

		private string m_redirectUrl;

		private bool m_abort;

		public bool Abort
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_abort;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				m_abort = value;
			}
		}

		public string RedirectUrl => m_redirectUrl;

		public string OriginalUrl => m_originalUrl;

		public unsafe HttpRedirectEventArgs(sbyte* originalUrl, sbyte* redirectUrl)
		{
			m_abort = false;
			m_originalUrl = CkMarshal.Utf8ToString(originalUrl);
			m_redirectUrl = CkMarshal.Utf8ToString(redirectUrl);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
