using chilkat;
using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Imap : IDisposable
	{
		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsImap* m_impl;

		public unsafe bool AutoFix
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_AutoFix(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsImap_002Eput_AutoFix(m_impl, value);
			}
		}

		public unsafe int UidNext => _003CModule_003E.ClsImap_002Eget_UidNext(m_impl);

		public unsafe int HttpProxyPort
		{
			get
			{
				return _003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyPort((ClsHttpProxyClient*)((byte*)m_impl + 544));
			}
			set
			{
				_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyPort((ClsHttpProxyClient*)((byte*)m_impl + 544), value);
			}
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyHostname((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyHostname((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyAuthMethod((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyAuthMethod((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyPassword((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyPassword((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyUsername((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyUsername((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002Eget_SslProtocol(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsImap_002Eput_SslProtocol(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool StartTls
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_StartTls(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsImap_002Eput_StartTls(m_impl, value);
			}
		}

		public unsafe int SocksVersion
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksVersion((ClsSocksClient*)((byte*)m_impl + 120));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksVersion((ClsSocksClient*)((byte*)m_impl + 120), value);
			}
		}

		public unsafe int SocksPort
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksPort((ClsSocksClient*)((byte*)m_impl + 120));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksPort((ClsSocksClient*)((byte*)m_impl + 120), value);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksPassword((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksPassword((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksUsername((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksUsername((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksHostname((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksHostname((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int SendBufferSize
		{
			get
			{
				return _003CModule_003E.ClsImap_002Eget_SendBufferSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsImap_002Eput_SendBufferSize(m_impl, value);
			}
		}

		public unsafe string AuthzId
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002Eget_AuthzId(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsImap_002Eput_AuthzId(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int AppendUid => _003CModule_003E.ClsImap_002Eget_AppendUid(m_impl);

		public unsafe string SelectedMailbox
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002Eget_SelectedMailbox(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002Eget_Version(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AppendSeen
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_AppendSeen(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsImap_002Eput_AppendSeen(m_impl, value);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe bool SslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_SslServerCertVerified(m_impl);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EGetHtmlLogX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EGetXmlLogX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				if (m_impl == null)
				{
					return new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0CC_0040GICFJEDK_0040Error_003F5_003F9_003F9_003F5internal_003F5object_003F5deleted_0040));
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EGetTextLogX(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool PeekMode
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_PeekMode(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsImap_002Eput_PeekMode(m_impl, value);
			}
		}

		public unsafe bool Ssl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_Ssl(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsImap_002Eput_Ssl(m_impl, value);
			}
		}

		public unsafe int Port
		{
			get
			{
				return _003CModule_003E.ClsImap_002Eget_Port(m_impl);
			}
			set
			{
				_003CModule_003E.ClsImap_002Eput_Port(m_impl, value);
			}
		}

		public unsafe bool AutoUnwrapSecurity
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_AutoUnwrap(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsImap_002Eput_AutoUnwrap(m_impl, value);
			}
		}

		public unsafe int ConnectTimeout
		{
			get
			{
				return _003CModule_003E.ClsImap_002Eget_ConnectTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsImap_002Eput_ConnectTimeout(m_impl, value);
			}
		}

		public unsafe sbyte SeparatorChar
		{
			get
			{
				if (_003CModule_003E.chilkat_002EStringBuffer_002EgetSize((StringBuffer*)((byte*)m_impl + 2960)) != 0)
				{
					return _003CModule_003E.chilkat_002EStringBuffer_002EcharAt((StringBuffer*)((byte*)m_impl + 2960), 0);
				}
				return 46;
			}
			set
			{
				_003CModule_003E.chilkat_002EStringBuffer_002Eclear((StringBuffer*)((byte*)m_impl + 2960));
				_003CModule_003E.chilkat_002EStringBuffer_002EappendChar((StringBuffer*)((byte*)m_impl + 2960), value);
			}
		}

		public unsafe int ReadTimeout
		{
			get
			{
				return _003CModule_003E.ClsImap_002Eget_ReadTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsImap_002Eput_ReadTimeout(m_impl, value);
			}
		}

		public unsafe int NumMessages => _003CModule_003E.ClsImap_002Eget_NumMessages(m_impl);

		public unsafe string Domain
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002Eget_Domain(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsImap_002Eput_Domain(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string AuthMethod
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002Eget_AuthMethod(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsImap_002Eput_AuthMethod(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastIntermediateResponse
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EgetLastIntermediateResponse(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastAppendedMime
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EgetLastAppendedMime(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastCommand
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EgetLastCommand(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastResponse
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EgetLastResponse(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string ConnectedToHost
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EgetConnectedToHost(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LoggedInUser
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002EgetLoggedInUser(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int HeartbeatMs
		{
			get
			{
				return _003CModule_003E.ClsImap_002Eget_HeartbeatMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsImap_002Eput_HeartbeatMs(m_impl, value);
			}
		}

		public unsafe bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsImap_002Eget_KeepSessionLog(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsImap_002Eput_KeepSessionLog(m_impl, value);
			}
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsImap_002Eget_SessionLog(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public event PercentDoneEventHandler OnPercentDone;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Imap LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Imap result = (Imap)m_objects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			this.OnPercentDone?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public unsafe Imap()
		{
			m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0x249c62c6_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0x249c62c6_002ENextHashCode;
			ClsImap* ptr = (ClsImap*)_003CModule_003E.@new(3000u);
			ClsImap* ptr2;
			try
			{
				ptr2 = (ClsImap*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsImap_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 2952) = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsImap* impl = m_impl;
			if (impl != null)
			{
				ClsImap* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public unsafe override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			ClsImap* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsImap_002EdotNetDispose(impl);
			}
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				result = _003CModule_003E.ClsImap_002EUnlockComponent(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			return _003CModule_003E.ClsImap_002EIsUnlocked(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect(string hostname)
		{
			//Discarded unreachable code: IL_00cf
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				return false;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = false;
					try
					{
						result = _003CModule_003E.ClsImap_002EConnect(m_impl, &xString, (ProgressEvent*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_07FJPHLACI_0040Connect_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00be;
							}
							goto end_IL_009a;
							IL_00be:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_009a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Disconnect()
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.ClsImap_002EDisconnect(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return true;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsConnected()
		{
			return _003CModule_003E.ClsImap_002EIsConnected(m_impl);
		}

		public unsafe void ClearSessionLog()
		{
			_003CModule_003E.ClsImap_002EClearSessionLog(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Login(string login, string password)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(login, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(password, &xString2);
					_ImapCallback imapCallback;
					_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
					try
					{
						*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &imapCallback;
							*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
						}
						result = false;
						try
						{
							result = _003CModule_003E.ClsImap_002ELogin(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_05DHEMANOL_0040Login_003F_0024AA_0040));
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_00c6;
								}
								goto end_IL_00a2;
								IL_00c6:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_00a2:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
						_003CModule_003E.XString_002EsecureClear(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Logout()
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsImap_002ELogout(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsLoggedIn()
		{
			return _003CModule_003E.ClsImap_002EIsLoggedIn(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateMailbox(string mailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ECreateMailbox(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteMailbox(string mailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002EDeleteMailbox(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RenameMailbox(string fromMailbox, string toMailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(fromMailbox, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(toMailbox, &xString2);
					_ImapCallback imapCallback;
					_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
					try
					{
						*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &imapCallback;
							*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsImap_002ERenameMailbox(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Mailboxes ListMailboxes(string reference, string wildcardedMailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			ClsMailboxes* ptr2;
			_ImapCallback imapCallback;
			Mailboxes result;
			try
			{
				CkMarshal.StringToX(reference, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(wildcardedMailbox, &xString2);
					ClsMailboxes* ptr = (ClsMailboxes*)_003CModule_003E.@new(24u);
					try
					{
						ptr2 = (ClsMailboxes*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsMailboxes_002E_007Bctor_007D(ptr)));
					}
					catch
					{
						//try-fault
						_003CModule_003E.delete(ptr);
						throw;
					}
					_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
					try
					{
						*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					try
					{
						_ImapCallback* ptr3 = null;
						if (m_enableEvents)
						{
							ptr3 = &imapCallback;
							*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
						}
						if (!_003CModule_003E.ClsImap_002EListMailboxes(m_impl, &xString, &xString2, ptr2, (ProgressEvent*)ptr3))
						{
							if (ptr2 != null)
							{
								((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
							}
							goto IL_00a6;
						}
						if (ptr2 == null)
						{
							goto IL_00a6;
						}
						goto end_IL_0066;
						IL_00a6:
						result = null;
						goto IL_00b9;
						end_IL_0066:;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					goto end_IL_0018;
					IL_00b9:
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
					goto IL_00d8;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_00d8:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00ef;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Mailboxes result2;
			try
			{
				try
				{
					try
					{
						result2 = new Mailboxes(ptr2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00ef:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SelectMailbox(string mailbox)
		{
			if (m_impl == null)
			{
				return false;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ESelectMailbox(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExamineMailbox(string mailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002EExamineMailbox(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Subscribe(string mailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ESubscribe(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Unsubscribe(string mailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002EUnsubscribe(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe MessageSet Search(string criteria, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			if (m_impl == null)
			{
				return null;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_ImapCallback imapCallback;
			ClsMessageSet* ptr2;
			MessageSet result;
			try
			{
				CkMarshal.StringToX(criteria, &xString);
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					ptr2 = _003CModule_003E.ClsImap_002ESearch(m_impl, &xString, bUid, (ProgressEvent*)ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_0080;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				goto end_IL_0012;
				IL_0080:
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				goto IL_009f;
				end_IL_0012:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			MessageSet result2;
			try
			{
				try
				{
					result2 = new MessageSet(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_009f:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe MessageSet GetAllUids()
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsMessageSet* ptr2;
			MessageSet result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsImap_002EGetAllUids(m_impl, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0063;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			MessageSet result2;
			try
			{
				result2 = new MessageSet(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0063:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe Email FetchSingle(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			_003CModule_003E.ClsImap_002EClearLog(m_impl);
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsEmail* ptr2;
			Email result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsImap_002EFetchSingle(m_impl, msgId, bUid, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0070;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0070:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe Email FetchSingleHeader(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			_003CModule_003E.ClsImap_002EClearLog(m_impl);
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsEmail* ptr2;
			Email result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsImap_002EFetchSingleHeader(m_impl, msgId, bUid, (ProgressEvent*)ptr, true);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0071;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0071:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe EmailBundle FetchBundle(MessageSet messageSet)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				return null;
			}
			if (messageSet == null)
			{
				return null;
			}
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsEmailBundle* ptr2;
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = null;
				try
				{
					ptr2 = _003CModule_003E.ClsImap_002EFetchBundle(m_impl, impl, (ProgressEvent*)ptr);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0M_0040KAMPMOIL_0040FetchBundle_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00bb;
						}
						goto end_IL_0097;
						IL_00bb:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0097:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				if (ptr2 == null)
				{
					result = null;
					goto IL_00e4;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_00e4:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe EmailBundle FetchHeaders(MessageSet messageSet)
		{
			if (messageSet == null)
			{
				return null;
			}
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsEmailBundle* ptr2;
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsImap_002EFetchHeaders(m_impl, impl, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0072;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0072:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe EmailBundle FetchSequence(int startSeqNum, int numMessages)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsEmailBundle* ptr2;
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = null;
				try
				{
					ptr2 = _003CModule_003E.ClsImap_002EFetchSequence(m_impl, startSeqNum, numMessages, null, null, (ProgressEvent*)ptr);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040LCLNFLBD_0040FetchSequence_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00a6;
						}
						goto end_IL_0082;
						IL_00a6:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0082:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				if (ptr2 == null)
				{
					result = null;
					goto IL_00cf;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_00cf:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe EmailBundle FetchSequenceHeaders(int startSeqNum, int numMessages)
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsEmailBundle* ptr2;
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsImap_002EFetchSequenceHeaders(m_impl, startSeqNum, numMessages, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0065;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0065:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe string FetchSingleAsMime(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_ImapCallback imapCallback;
			string result;
			try
			{
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					if (!_003CModule_003E.ClsImap_002EFetchSingleAsMime(m_impl, msgId, bUid, &xString, (ProgressEvent*)ptr))
					{
						result = null;
						goto IL_006f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				goto end_IL_0008;
				IL_006f:
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				goto IL_008e;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_008e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe StringArray FetchBundleAsMime(MessageSet messageSet)
		{
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsStringArray* ptr2;
			StringArray result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsImap_002EFetchBundleAsMime(m_impl, impl, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_006d;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			StringArray result2;
			try
			{
				result2 = new StringArray(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_006d:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe StringArray FetchSequenceAsMime(int startSeqNum, int numMessages)
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsStringArray* ptr2;
			StringArray result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsImap_002EFetchSequenceAsMime(m_impl, startSeqNum, numMessages, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0065;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			StringArray result2;
			try
			{
				result2 = new StringArray(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0065:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetDecryptCert2(Cert cert, PrivateKey key)
		{
			if (cert == null)
			{
				return false;
			}
			if (key == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			ClsPrivateKey* implementation2 = (ClsPrivateKey*)key.GetImplementation();
			if (implementation != null && implementation2 != null)
			{
				return _003CModule_003E.ClsImap_002ESetDecryptCert(m_impl, implementation, implementation2);
			}
			return false;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Expunge()
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsImap_002EExpunge(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExpungeAndClose()
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsImap_002EExpungeAndClose(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetFlag(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid, string flagName, int value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(flagName, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ESetFlag(m_impl, msgId, bUid, &xString, value, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetFlags(MessageSet messageSet, string flagName, int value)
		{
			if (messageSet == null)
			{
				return false;
			}
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(flagName, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ESetFlags(m_impl, impl, &xString, value, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMime(string mailbox, string mimeText)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(mimeText, &xString2);
					_ImapCallback imapCallback;
					_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
					try
					{
						*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &imapCallback;
							*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
						}
						result = _003CModule_003E.ClsImap_002EAppendMime(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMail(string mailbox, Email email)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr2 = null;
					if (m_enableEvents)
					{
						ptr2 = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002EAppendMail(m_impl, &xString, ptr, (ProgressEvent*)ptr2);
					email.ReleaseImpl();
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Copy(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid, string copyToMailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(copyToMailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ECopy(m_impl, msgId, bUid, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CopySequence(int startSeqNum, int count, string copyToMailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(copyToMailbox, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ECopySequence(m_impl, startSeqNum, count, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CopyMultiple(MessageSet messageSet, string copyToMailbox)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(copyToMailbox, &xString);
				ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ECopyMultiple(m_impl, impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetMailFlag(Email email, string flagName, int value)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(flagName, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr2 = null;
					if (m_enableEvents)
					{
						ptr2 = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002ESetMailFlag(m_impl, ptr, &xString, value, (ProgressEvent*)ptr2);
					email.ReleaseImpl();
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int GetMailFlag(Email email, string flagName)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(flagName, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr2 = null;
					if (m_enableEvents)
					{
						ptr2 = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002EGetMailFlag(m_impl, ptr, &xString, (ProgressEvent*)ptr2);
					email.ReleaseImpl();
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RefetchMailFlags(Email email)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr2 = null;
				if (m_enableEvents)
				{
					ptr2 = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsImap_002ERefetchMailFlags(m_impl, ptr, (ProgressEvent*)ptr2);
				email.ReleaseImpl();
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool StoreFlags(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid, string flagNames, int value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(flagNames, &xString);
				_ImapCallback imapCallback;
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsImap_002EStoreFlags(m_impl, msgId, bUid, &xString, value, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string FetchFlags(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_ImapCallback imapCallback;
			string result;
			try
			{
				_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
				try
				{
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &imapCallback;
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
					}
					if (!_003CModule_003E.ClsImap_002EFetchFlagsStr(m_impl, msgId, bUid, &xString, (ProgressEvent*)ptr))
					{
						result = null;
						goto IL_006f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				goto end_IL_0008;
				IL_006f:
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				goto IL_008e;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
					throw;
				}
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_008e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int GetMailSize(Email email)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			if (!_003CModule_003E.ClsEmail_002EHasHeaderField(ptr, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BD_0040GBIJOIIM_0040ckx_003F9imap_003F9totalsize_003F_0024AA_0040)))
			{
				int result = _003CModule_003E.ClsEmail_002Eget_Size(ptr);
				email.ReleaseImpl();
				return result;
			}
			int result2 = _003CModule_003E.ClsEmail_002EGetHeaderFieldInt(ptr, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BD_0040GBIJOIIM_0040ckx_003F9imap_003F9totalsize_003F_0024AA_0040));
			email.ReleaseImpl();
			return result2;
		}

		public unsafe int GetMailNumAttach(Email email)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			int result = _003CModule_003E.ClsImap_002EGetMailNumAttach(m_impl, ptr);
			email.ReleaseImpl();
			return result;
		}

		public unsafe int GetMailAttachSize(Email email, int attachIndex)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			int result = _003CModule_003E.ClsImap_002EGetMailAttachSize(m_impl, ptr, attachIndex);
			email.ReleaseImpl();
			return result;
		}

		public unsafe string GetMailAttachFilename(Email email, int attachIndex)
		{
			if (email == null)
			{
				return null;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				bool flag = _003CModule_003E.ClsImap_002EGetMailAttachFilename(m_impl, ptr, attachIndex, &xString);
				email.ReleaseImpl();
				if (!flag)
				{
					result = null;
					goto IL_0041;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0041:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsImap_002ESaveXmlLogX(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string SendRawCommand(string cmd)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			_ImapCallback imapCallback;
			string result;
			try
			{
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(cmd, &xString2);
					_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
					try
					{
						*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &imapCallback;
							*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
						}
						if (!_003CModule_003E.ClsImap_002ESendRawCommand(m_impl, &xString2, &xString, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					goto end_IL_0010;
					IL_007f:
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
					goto IL_009e;
					end_IL_0010:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_009e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00b5;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
						throw;
					}
					*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00b5:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			_003CModule_003E.ClsImap_002ESetSslClientCert(m_impl, ptr);
		}

		public unsafe Cert GetSslServerCert()
		{
			ClsCert* ptr = _003CModule_003E.ClsImap_002EGetSslServerCert(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMimeWithFlags(string mailbox, string mimeText, [MarshalAs(UnmanagedType.U1)] bool seen, [MarshalAs(UnmanagedType.U1)] bool flagged, [MarshalAs(UnmanagedType.U1)] bool answered, [MarshalAs(UnmanagedType.U1)] bool draft)
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(mailbox, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(mimeText, &xString2);
						result = _003CModule_003E.ClsImap_002EAppendMimeWithFlags(m_impl, &xString, &xString2, seen, flagged, answered, draft, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe EmailBundle FetchChunk(int startSeqNum, int count, MessageSet failedSet, MessageSet fetchedSet)
		{
			if (failedSet == null)
			{
				return null;
			}
			if (fetchedSet == null)
			{
				return null;
			}
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			ClsEmailBundle* ptr2;
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				ClsMessageSet* impl = (ClsMessageSet*)failedSet.GetImpl();
				ClsMessageSet* impl2 = (ClsMessageSet*)fetchedSet.GetImpl();
				ptr2 = _003CModule_003E.ClsImap_002EFetchSequence(m_impl, startSeqNum, count, impl, impl2, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0085;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0085:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		public unsafe string FetchSingleHeaderAsMime(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUID)
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			XString xString;
			string result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					if (!_003CModule_003E.ClsImap_002EFetchSingleHeaderAsMime(m_impl, msgId, bUID, &xString, (ProgressEvent*)ptr))
					{
						result = null;
						goto IL_006f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_006f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_0086;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result2;
			IL_0086:
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMimeWithDate(string mailbox, string mimeText, DateTime internalDate)
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(mailbox, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(mimeText, &xString2);
						ChilkatSysTime chilkatSysTime;
						_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
						*(short*)(&chilkatSysTime) = (short)internalDate.Year;
						*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)internalDate.Month;
						*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)internalDate.Day;
						*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)internalDate.Hour;
						*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)internalDate.Minute;
						*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)internalDate.Second;
						result = _003CModule_003E.ClsImap_002EAppendMimeWithDate(m_impl, &xString, &xString2, &chilkatSysTime, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshTunnel(string sshServerHostname, int sshServerPort)
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(sshServerHostname, &xString);
					result = _003CModule_003E.ClsImap_002ESshTunnel(m_impl, &xString, sshServerPort, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePw(string sshLogin, string sshPassword)
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(sshLogin, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(sshPassword, &xString2);
						result = _003CModule_003E.ClsImap_002ESshAuthenticatePw(m_impl, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePk(string sshLogin, SshKey privateKey)
		{
			if (privateKey == null)
			{
				return false;
			}
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(sshLogin, &xString);
					ClsSshKey* implementation = (ClsSshKey*)privateKey.GetImplementation();
					result = _003CModule_003E.ClsImap_002ESshAuthenticatePk(m_impl, &xString, implementation, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Noop()
		{
			_ImapCallback imapCallback;
			_003CModule_003E.ImapCallback_002E_007Bctor_007D((ImapCallback*)(&imapCallback));
			try
			{
				*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &imapCallback;
					*(int*)(&Unsafe.AddByteOffset(ref imapCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsImap_002ENoop(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ImapCallback_002E_007Bdtor_007D), &imapCallback);
				throw;
			}
			*(int*)(&imapCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ImapCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ImapCallback_002E_007Bdtor_007D((ImapCallback*)(&imapCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xString3);
						result = _003CModule_003E.ClsImap_002ESetSslClientCertPfx(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		protected void raise_OnPercentDone(object i1, PercentDoneEventArgs i2)
		{
			this.OnPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
