using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class MailMan : IDisposable
	{
		public delegate void SendPercentDoneEventHandler(object sender, MailPercentDoneEventArgs args);

		public delegate void ReadPercentDoneEventHandler(object sender, MailPercentDoneEventArgs args);

		public delegate void EmailReceivedEventHandler(object sender, EmailEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_mmObjects = new Hashtable();

		private int m_myHashCode;

		private bool m_enableEvents;

		private object m_lockImpl;

		private unsafe ClsMailMan* m_impl;

		private static object m_lockObject = new object();

		public unsafe bool AutoFix
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_AutoFix(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_AutoFix(m_impl, value);
			}
		}

		public unsafe int HttpProxyPort
		{
			get
			{
				return _003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyPort((ClsHttpProxyClient*)((byte*)m_impl + 544));
			}
			set
			{
				_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyPort((ClsHttpProxyClient*)((byte*)m_impl + 544), value);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyPassword((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyPassword((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyUsername((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyUsername((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyAuthMethod((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyAuthMethod((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyHostname((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyHostname((ClsHttpProxyClient*)((byte*)m_impl + 544), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int SocksVersion
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksVersion((ClsSocksClient*)((byte*)m_impl + 120));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksVersion((ClsSocksClient*)((byte*)m_impl + 120), value);
			}
		}

		public unsafe int SocksPort
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksPort((ClsSocksClient*)((byte*)m_impl + 120));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksPort((ClsSocksClient*)((byte*)m_impl + 120), value);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksPassword((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksPassword((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksUsername((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksUsername((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksHostname((ClsSocksClient*)((byte*)m_impl + 120), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksHostname((ClsSocksClient*)((byte*)m_impl + 120), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool IncludeRootCert
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_IncludeRootCert(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_IncludeRootCert(m_impl, value);
			}
		}

		public unsafe int SendBufferSize
		{
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_SendBufferSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_SendBufferSize(m_impl, value);
			}
		}

		public unsafe int Pop3SessionId => _003CModule_003E.ClsMailMan_002Eget_Pop3SessionId(m_impl);

		public unsafe string ClientIpAddress
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsMailMan_002Eget_ClientIpAddress(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsMailMan_002Eput_ClientIpAddress(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool SmtpSslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_SmtpSslServerCertVerified(m_impl);
			}
		}

		public unsafe bool Pop3SslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_Pop3SslServerCertVerified(m_impl);
			}
		}

		public unsafe string Pop3SessionLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_Pop3SessionLog(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string SmtpSessionLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_SmtpSessionLog(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string SmtpHost
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					ClsMailMan* impl = m_impl;
					if (impl != null)
					{
						_003CModule_003E.ClsMailMan_002Eget_SmtpHost(impl, &xString);
					}
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					ClsMailMan* impl = m_impl;
					if (impl != null)
					{
						_003CModule_003E.ClsMailMan_002Eput_SmtpHost(impl, &xString);
					}
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_Version(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string MailHost
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_MailHost(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (value != null && value.Length <= 400)
				{
					XString xString;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString);
					try
					{
						CkMarshal.StringToX(value, &xString);
						Monitor.Enter(m_lockImpl);
						_003CModule_003E.ClsMailMan_002Eput_MailHost(m_impl, &xString);
						Monitor.Exit(m_lockImpl);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				}
			}
		}

		public unsafe string PopUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_PopUsername(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_PopUsername(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string PopPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_PopPassword(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_PopPassword(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int SmtpPort
		{
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_SmtpPort(m_impl);
			}
			set
			{
				Monitor.Enter(m_lockImpl);
				ClsMailMan* impl = m_impl;
				if (impl != null)
				{
					_003CModule_003E.ClsMailMan_002Eput_SmtpPort(impl, value);
				}
				Monitor.Exit(m_lockImpl);
			}
		}

		public unsafe bool OpaqueSigning
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_OpaqueSigning(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_OpaqueSigning(m_impl, value);
			}
		}

		public unsafe bool ResetDateOnLoad
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_ResetDateOnLoad(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_ResetDateOnLoad(m_impl, value);
			}
		}

		public unsafe int MailPort
		{
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_MailPort(m_impl);
			}
			set
			{
				ClsMailMan* impl = m_impl;
				if (impl != null)
				{
					_003CModule_003E.ClsMailMan_002Eput_MailPort(impl, value);
				}
			}
		}

		public unsafe int MaxCount
		{
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_MaxCount(m_impl);
			}
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_MaxCount(m_impl, value);
			}
		}

		public unsafe int SizeLimit
		{
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_SizeLimit(m_impl);
			}
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_SizeLimit(m_impl, value);
			}
		}

		public unsafe string Filter
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_Filter(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_Filter(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SmtpLoginDomain
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_SmtpLoginDomain(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_SmtpLoginDomain(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SmtpAuthMethod
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_SmtpAuthMethod(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_SmtpAuthMethod(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HeloHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_HeloHostname(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_HeloHostname(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DsnEnvid
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_DsnEnvid(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_DsnEnvid(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DsnRet
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_DsnRet(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_DsnRet(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DsnNotify
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_DsnNotify(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_DsnNotify(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool SendIndividual
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_SendIndividual(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_SendIndividual(m_impl, value);
			}
		}

		public unsafe bool AutoUnwrapSecurity
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_AutoUnwrapSecurity(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_AutoUnwrapSecurity(m_impl, value);
			}
		}

		public unsafe bool AutoGenMessageId
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_AutoGenMessageId(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_AutoGenMessageId(m_impl, value);
			}
		}

		public unsafe bool SmtpSsl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_SmtpSsl(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_SmtpSsl(m_impl, value);
			}
		}

		public unsafe bool ImmediateDelete
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_ImmediateDelete(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_ImmediateDelete(m_impl, value);
			}
		}

		public unsafe bool PopSsl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_PopSsl(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_PopSsl(m_impl, value);
			}
		}

		public unsafe bool EmbedCertChain
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_EmbedCertChain(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_EmbedCertChain(m_impl, value);
			}
		}

		public unsafe bool AllOrNone
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_AllOrNone(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_AllOrNone(m_impl, value);
			}
		}

		public unsafe bool StartTLS
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_StartTLS(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_StartTLS(m_impl, value);
			}
		}

		public unsafe bool Pop3SPA
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_Pop3SPA(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_Pop3SPA(m_impl, value);
			}
		}

		public unsafe bool AutoSaveCerts
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_AutoSaveCerts(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_AutoSaveCerts(m_impl, value);
			}
		}

		public unsafe int ConnectTimeout
		{
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_ConnectTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_ConnectTimeout(m_impl, value);
			}
		}

		public unsafe int LastSmtpStatus => _003CModule_003E.ClsMailMan_002Eget_LastSmtpStatus(m_impl);

		public unsafe int HeartbeatMs
		{
			get
			{
				return (int)_003CModule_003E.ClsMailMan_002Eget_HeartbeatMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_HeartbeatMs(m_impl, (uint)value);
			}
		}

		public unsafe int ReadTimeout
		{
			get
			{
				return _003CModule_003E.ClsMailMan_002Eget_ReadTimeout(m_impl);
			}
			set
			{
				_003CModule_003E.ClsMailMan_002Eput_ReadTimeout(m_impl, value);
			}
		}

		public unsafe string SmtpUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_SmtpUsername(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_SmtpUsername(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SmtpPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_SmtpPassword(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_SmtpPassword(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastSendQFilename
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_LastSendQFilename(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LogMailSentFilename
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_LogMailSentFilename(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_LogMailSentFilename(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LogMailReceivedFilename
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eget_LogMailReceivedFilename(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002Eput_LogMailReceivedFilename(m_impl, &xString);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				Monitor.Enter(m_lockObject);
				if (value)
				{
					if (m_mmObjects == null)
					{
						m_mmObjects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_mmObjects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_mmObjects = new Hashtable();
								m_mmObjects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				else
				{
					m_mmObjects.Remove(this);
				}
				Monitor.Exit(m_lockObject);
				m_enableEvents = value;
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public event EmailReceivedEventHandler OnEmailReceived;

		public event ReadPercentDoneEventHandler OnReadPercentDone;

		public event SendPercentDoneEventHandler OnSendPercentDone;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static MailMan LookupMailMan(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			MailMan result = (MailMan)m_mmObjects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FireSendPercentDone(object sender, MailPercentDoneEventArgs args)
		{
			this.OnSendPercentDone?.Invoke(sender, args);
		}

		public void FireReadPercentDone(object sender, MailPercentDoneEventArgs args)
		{
			this.OnReadPercentDone?.Invoke(sender, args);
		}

		public void FireEmailReceived(object sender, EmailEventArgs args)
		{
			this.OnEmailReceived?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public unsafe MailMan()
		{
			this.OnSendPercentDone = null;
			this.OnReadPercentDone = null;
			this.OnEmailReceived = null;
			this.OnAbortCheck = null;
			m_lockImpl = new object();
			ClsMailMan* ptr = (ClsMailMan*)_003CModule_003E.@new(4424u);
			ClsMailMan* ptr2;
			try
			{
				ptr2 = (ClsMailMan*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsMailMan_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 4416) = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			Monitor.Enter(m_lockObject);
			ClsMailMan* impl = m_impl;
			if (impl != null)
			{
				ClsMailMan* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				m_mmObjects.Remove(this);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
						goto IL_0078;
					}
					goto end_IL_0064;
					IL_0078:
					if (num2 != 0)
					{
						throw;
					}
					end_IL_0064:;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
			Monitor.Exit(m_lockObject);
		}

		public unsafe override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			ClsMailMan* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsMailMan_002EdotNetDispose(impl);
			}
			m_mmObjects.Remove(this);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void ClearSmtpSessionLog()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsMailMan_002EClearSmtpSessionLog(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		public unsafe void ClearPop3SessionLog()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsMailMan_002EClearPop3SessionLog(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		public unsafe string GetMailboxInfoXml()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_MailManCallback mailManCallback;
				_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
				try
				{
					*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
					throw;
				}
				try
				{
					_MailManCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &mailManCallback;
						*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
					}
					Monitor.Enter(m_lockImpl);
					_003CModule_003E.ClsMailMan_002EGetMailboxInfoXml(m_impl, &xString, (MailManCallback*)ptr);
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
					throw;
				}
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			_003CModule_003E.ClsMailMan_002ESetSslClientCert(m_impl, ptr);
		}

		public unsafe Cert GetPop3SslServerCert()
		{
			ClsCert* ptr = _003CModule_003E.ClsMailMan_002EGetPop3SslServerCert(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		public unsafe Cert GetSmtpSslServerCert()
		{
			ClsCert* ptr = _003CModule_003E.ClsMailMan_002EGetSmtpSslServerCert(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetDecryptCert2(Cert cert, PrivateKey key)
		{
			if (cert == null)
			{
				return false;
			}
			if (key == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			ClsPrivateKey* implementation2 = (ClsPrivateKey*)key.GetImplementation();
			if (implementation != null && implementation2 != null)
			{
				Monitor.Enter(m_lockImpl);
				bool result = _003CModule_003E.ClsMailMan_002ESetDecryptCert(m_impl, implementation, implementation2);
				Monitor.Exit(m_lockImpl);
				return result;
			}
			return false;
		}

		public unsafe uint GetMailboxSize()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			uint result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EGetMailboxSize(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe int GetMailboxCount()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			int result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EGetMailboxCount(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3BeginSession()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EPop3BeginSession(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3EndSession()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EPop3EndSession(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3Noop()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EPop3Noop(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3Reset()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EPop3Reset(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe void ClearBadEmailAddresses()
		{
			Monitor.Enter(m_lockImpl);
			_003CModule_003E.ClsMailMan_002EClearBadEmailAddresses(m_impl);
			Monitor.Exit(m_lockImpl);
		}

		public unsafe StringArray GetBadEmailAddresses()
		{
			Monitor.Enter(m_lockImpl);
			ClsStringArray* ptr = _003CModule_003E.ClsMailMan_002EGetBadEmailAddresses(m_impl);
			Monitor.Exit(m_lockImpl);
			if (ptr == null)
			{
				return null;
			}
			return new StringArray(ptr);
		}

		public unsafe StringArray GetUidls()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			ClsStringArray* ptr2;
			StringArray result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				ptr2 = _003CModule_003E.ClsMailMan_002EGetUidls(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0079;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			StringArray result2;
			try
			{
				result2 = new StringArray(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result2;
			IL_0079:
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsSmtpDsnCapable()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EIsSmtpDsnCapable(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifySmtpLogin()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EVerifySmtpLogin(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifySmtpConnection()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EVerifySmtpConnection(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyPopLogin()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EVerifyPopLogin(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyPopConnection()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EVerifyPopConnection(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe EmailBundle FetchMultiple(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(m_lockImpl);
			ClsEmailBundle* ptr3;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
						try
						{
							*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)((byte*)ptr + 8) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = null;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultiple(m_impl, implementation, (MailManCallback*)ptr2);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultiple(m_impl, implementation, null);
			}
			Monitor.Exit(m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle(ptr3);
		}

		public unsafe StringArray FetchMultipleMime(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(m_lockImpl);
			ClsStringArray* ptr3;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
						try
						{
							*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)((byte*)ptr + 8) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = null;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultipleMime(m_impl, implementation, (MailManCallback*)ptr2, false);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultipleMime(m_impl, implementation, null, false);
			}
			Monitor.Exit(m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new StringArray(ptr3);
		}

		public unsafe StringArray TransferMultipleMime(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(m_lockImpl);
			ClsStringArray* ptr3;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
						try
						{
							*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)((byte*)ptr + 8) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = null;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultipleMime(m_impl, implementation, (MailManCallback*)ptr2, true);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultipleMime(m_impl, implementation, null, true);
			}
			Monitor.Exit(m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new StringArray(ptr3);
		}

		public unsafe EmailBundle FetchMultipleHeaders(StringArray uidlArray, int numBodyLines)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(m_lockImpl);
			ClsEmailBundle* ptr3;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
						try
						{
							*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)((byte*)ptr + 8) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = null;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultipleHeaders(m_impl, implementation, numBodyLines, (MailManCallback*)ptr2);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				ptr3 = _003CModule_003E.ClsMailMan_002EFetchMultipleHeaders(m_impl, implementation, numBodyLines, null);
			}
			Monitor.Exit(m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle(ptr3);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteByUidl(string uidl)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(uidl, &xString);
				_MailManCallback mailManCallback;
				_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
				try
				{
					*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
					throw;
				}
				try
				{
					_MailManCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &mailManCallback;
						*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
					}
					Monitor.Enter(m_lockImpl);
					result = _003CModule_003E.ClsMailMan_002EDeleteByUidlX(m_impl, &xString, (MailManCallback*)ptr);
					Monitor.Exit(m_lockImpl);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
					throw;
				}
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Email FetchEmail(string uidl)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmail* ptr3;
			Email result;
			try
			{
				CkMarshal.StringToX(uidl, &xString);
				Monitor.Enter(m_lockImpl);
				if (m_enableEvents)
				{
					_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
					_MailManCallback* ptr2;
					try
					{
						if (ptr != null)
						{
							_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
							try
							{
								*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
								*(int*)((byte*)ptr + 8) = 0;
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
								throw;
							}
							ptr2 = ptr;
						}
						else
						{
							ptr2 = null;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.delete(ptr);
						throw;
					}
					int num = *(int*)((byte*)ptr2 + 8) = m_myHashCode;
					ptr3 = _003CModule_003E.ClsMailMan_002EFetchEmailX(m_impl, &xString, (MailManCallback*)ptr2);
					((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
				}
				else
				{
					ptr3 = _003CModule_003E.ClsMailMan_002EFetchEmailX(m_impl, &xString, null);
				}
				Monitor.Exit(m_lockImpl);
				if (ptr3 == null)
				{
					result = null;
					goto IL_00be;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr3);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00be:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] FetchMime(string uidl)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(uidl, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					Monitor.Enter(m_lockImpl);
					if (m_enableEvents)
					{
						_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
						_MailManCallback* ptr2;
						try
						{
							if (ptr != null)
							{
								_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
								try
								{
									*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
									*(int*)((byte*)ptr + 8) = 0;
								}
								catch
								{
									//try-fault
									_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
									throw;
								}
								ptr2 = ptr;
							}
							else
							{
								ptr2 = null;
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.delete(ptr);
							throw;
						}
						int num = *(int*)((byte*)ptr2 + 8) = m_myHashCode;
						_003CModule_003E.ClsMailMan_002EFetchMimeX(m_impl, &xString, (MailManCallback*)ptr2, &dataBuffer);
						((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
					}
					else
					{
						_003CModule_003E.ClsMailMan_002EFetchMimeX(m_impl, &xString, null, &dataBuffer);
					}
					Monitor.Exit(m_lockImpl);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteMultiple(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EDeleteMultiple(m_impl, uidlArray.GetImplementation(), (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteBundle(EmailBundle bundle)
		{
			if (bundle == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EDeleteBundle(m_impl, (ClsEmailBundle*)bundle.GetImplementation(), (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe Email GetFullEmail(Email email)
		{
			if (email == null)
			{
				return null;
			}
			Monitor.Enter(m_lockImpl);
			ClsEmail* ptr3;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
						try
						{
							*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)((byte*)ptr + 8) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = null;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				ptr3 = _003CModule_003E.ClsMailMan_002EGetFullEmail(m_impl, (ClsEmail*)email.LockImpl(), (MailManCallback*)ptr2);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				ptr3 = _003CModule_003E.ClsMailMan_002EGetFullEmail(m_impl, (ClsEmail*)email.LockImpl(), null);
			}
			Monitor.Exit(m_lockImpl);
			email.ReleaseImpl();
			if (ptr3 == null)
			{
				return null;
			}
			return new Email(ptr3);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyRecipients(Email email, StringArray badAddrs)
		{
			if (email == null)
			{
				return false;
			}
			if (badAddrs == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			ClsStringArray* implementation = badAddrs.GetImplementation();
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr2 = null;
				if (m_enableEvents)
				{
					ptr2 = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EVerifyRecipients(m_impl, ptr, implementation, (MailManCallback*)ptr2);
				Monitor.Exit(m_lockImpl);
				email.ReleaseImpl();
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe EmailBundle GetHeaders(int numBodyLines, int fromIndex, int toIndex)
		{
			Monitor.Enter(m_lockImpl);
			ClsEmailBundle* ptr3;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
						try
						{
							*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)((byte*)ptr + 8) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = null;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				ptr3 = _003CModule_003E.ClsMailMan_002EGetHeaders(m_impl, numBodyLines, fromIndex, toIndex, (MailManCallback*)ptr2);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				ptr3 = _003CModule_003E.ClsMailMan_002EGetHeaders(m_impl, numBodyLines, fromIndex, toIndex, null);
			}
			Monitor.Exit(m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle(ptr3);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteEmail(Email email)
		{
			if (email == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			_MailManCallback* ptr;
			ClsEmail* ptr2;
			try
			{
				ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				ptr2 = (ClsEmail*)email.LockImpl();
				if (ptr2 == null)
				{
					email.ReleaseImpl();
					goto IL_0066;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EDeleteEmail(m_impl, ptr2, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
				email.ReleaseImpl();
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
			IL_0066:
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return false;
		}

		public unsafe EmailBundle GetAllHeaders(int numBodyLines)
		{
			Monitor.Enter(m_lockImpl);
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			ClsEmailBundle* ptr2;
			EmailBundle result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsMailMan_002EGetAllHeaders(m_impl, numBodyLines, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
				if (ptr2 == null)
				{
					result = null;
					goto IL_007a;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result2;
			IL_007a:
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe EmailBundle LoadXmlString(string xmlString)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmailBundle* ptr;
			EmailBundle result;
			try
			{
				CkMarshal.StringToX(xmlString, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadXmlStringX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe EmailBundle LoadXmlFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmailBundle* ptr;
			EmailBundle result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadXmlFileX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Email LoadXmlEmail(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmail* ptr;
			Email result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadXmlEmailX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Email LoadXmlEmailString(string xmlString)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmail* ptr;
			Email result;
			try
			{
				CkMarshal.StringToX(xmlString, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadXmlEmailStringX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string RenderToMime(Email email)
		{
			if (email == null)
			{
				return null;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				Monitor.Enter(m_lockImpl);
				bool flag = _003CModule_003E.ClsMailMan_002ERenderToMimeX(m_impl, (ClsEmail*)email.LockImpl(), &xString);
				Monitor.Exit(m_lockImpl);
				email.ReleaseImpl();
				if (!flag)
				{
					result = null;
					goto IL_0054;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0054:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string MxLookup(string emailAddress)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(emailAddress, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					Monitor.Enter(m_lockImpl);
					bool flag = _003CModule_003E.ClsMailMan_002EMxLookup(m_impl, &xString, &xString2);
					Monitor.Exit(m_lockImpl);
					if (!flag)
					{
						result = null;
						goto IL_0055;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0055:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_006c;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_006c:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool QuickSend(string from, string to, string subject, string body, string smtpServer)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(to, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(subject, &xString3);
						XString xString4;
						_003CModule_003E.XString_002E_007Bctor_007D(&xString4);
						try
						{
							CkMarshal.StringToX(body, &xString4);
							XString xString5;
							_003CModule_003E.XString_002E_007Bctor_007D(&xString5);
							try
							{
								CkMarshal.StringToX(smtpServer, &xString5);
								Monitor.Enter(m_lockImpl);
								_MailManCallback mailManCallback;
								_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
								try
								{
									*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
									*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
								}
								catch
								{
									//try-fault
									_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
									throw;
								}
								try
								{
									_MailManCallback* ptr = null;
									if (m_enableEvents)
									{
										ptr = &mailManCallback;
										*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
									}
									result = _003CModule_003E.ClsMailMan_002EQuickSendX(m_impl, &xString, &xString2, &xString3, &xString4, &xString5, (MailManCallback*)ptr);
									Monitor.Exit(m_lockImpl);
								}
								catch
								{
									//try-fault
									_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
									throw;
								}
								*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
								_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
							}
							catch
							{
								//try-fault
								_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString5);
								throw;
							}
							_003CModule_003E.XString_002E_007Bdtor_007D(&xString5);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString4);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString4);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string code)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(code, &xString);
				Monitor.Enter(m_lockImpl);
				result = false;
				try
				{
					result = _003CModule_003E.ClsMailMan_002EUnlockComponentX(m_impl, &xString);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040CGAIPMHI_0040UnlockComponent_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_007e;
						}
						goto end_IL_005a;
						IL_007e:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_005a:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			Monitor.Enter(m_lockImpl);
			ClsMailMan* impl = m_impl;
			bool result = ((delegate* thiscall<IntPtr, byte>)(*(int*)(*(int*)impl + 8)))((IntPtr)impl) != 0;
			Monitor.Exit(m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenSmtpConnection()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002EOpenSmtpConnection(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CloseSmtpConnection()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002ECloseSmtpConnection(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SmtpReset()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002ESmtpReset(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SmtpNoop()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002ESmtpNoop(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe int CheckMail()
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			int result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002ECheckMail(m_impl, (MailManCallback*)ptr);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe EmailBundle TransferMail()
		{
			Monitor.Enter(m_lockImpl);
			ClsEmailBundle* ptr3;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)ptr);
						try
						{
							*(int*)ptr = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)((byte*)ptr + 8) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = null;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				ptr3 = _003CModule_003E.ClsMailMan_002ETransferMail(m_impl, (MailManCallback*)ptr2);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				ptr3 = _003CModule_003E.ClsMailMan_002ETransferMail(m_impl, null);
			}
			Monitor.Exit(m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle(ptr3);
		}

		public unsafe EmailBundle CopyMail()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsEmailBundle* ptr = null;
			Monitor.Enter(m_lockImpl);
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			EmailBundle result;
			try
			{
				_MailManCallback* ptr2 = null;
				if (m_enableEvents)
				{
					ptr2 = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				try
				{
					ptr = _003CModule_003E.ClsMailMan_002ECopyMail(m_impl, (MailManCallback*)ptr2);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							ptr = null;
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08JKNADCDM_0040CopyMail_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00b2;
						}
						goto end_IL_008c;
						IL_00b2:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_008c:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_00e6;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result2;
			IL_00e6:
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendBundle(EmailBundle bundle)
		{
			if (m_impl == null)
			{
				return false;
			}
			if (bundle == null)
			{
				return false;
			}
			ClsEmailBundle* implementation = (ClsEmailBundle*)bundle.GetImplementation();
			if (implementation == null)
			{
				return false;
			}
			Monitor.Enter(m_lockImpl);
			bool result;
			if (m_enableEvents)
			{
				_MailManCallback* ptr = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr2;
				try
				{
					ptr2 = (_MailManCallback*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bctor_007D(ptr)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				*(int*)((byte*)ptr2 + 8) = m_myHashCode;
				result = _003CModule_003E.ClsMailMan_002ESendBundle(m_impl, implementation, (MailManCallback*)ptr2);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
			}
			else
			{
				result = _003CModule_003E.ClsMailMan_002ESendBundle(m_impl, implementation, null);
			}
			Monitor.Exit(m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendEmail(Email email)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			bool result = false;
			Monitor.Enter(m_lockImpl);
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			try
			{
				_MailManCallback* ptr2 = null;
				if (m_enableEvents)
				{
					ptr2 = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				try
				{
					result = _003CModule_003E.ClsMailMan_002ESendEmail(m_impl, ptr, (MailManCallback*)ptr2);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09NBNJNIBH_0040SendEmail_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00bf;
						}
						goto end_IL_009b;
						IL_00bf:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_009b:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
				email.ReleaseImpl();
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendQ(Email email)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			Monitor.Enter(m_lockImpl);
			bool result = _003CModule_003E.ClsMailMan_002ESendQ(m_impl, ptr);
			Monitor.Exit(m_lockImpl);
			email.ReleaseImpl();
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendQ2(Email email, string queueDir)
		{
			if (email == null)
			{
				return false;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(queueDir, &xString);
				ClsEmail* ptr = (ClsEmail*)email.LockImpl();
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ClsMailMan_002ESendQ2(m_impl, ptr, &xString);
				Monitor.Exit(m_lockImpl);
				email.ReleaseImpl();
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe EmailBundle LoadMbx(string mbxFileName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmailBundle* ptr;
			EmailBundle result;
			try
			{
				CkMarshal.StringToX(mbxFileName, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadMbxX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Email LoadEml(string emlFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmail* ptr;
			Email result;
			try
			{
				CkMarshal.StringToX(emlFilename, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadEmlX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Email LoadQueuedEmail(string emlFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmail* ptr;
			Email result;
			try
			{
				CkMarshal.StringToX(emlFilename, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadQueuedEmailX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Email LoadMime(string mimeText)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsEmail* ptr;
			Email result;
			try
			{
				CkMarshal.StringToX(mimeText, &xString);
				Monitor.Enter(m_lockImpl);
				ptr = _003CModule_003E.ClsMailMan_002ELoadMimeX(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
				if (ptr == null)
				{
					result = null;
					goto IL_004b;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMime(string from, string recipients, string mimeText)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(recipients, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(mimeText, &xString3);
						Monitor.Enter(m_lockImpl);
						_MailManCallback mailManCallback;
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
						try
						{
							*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
							throw;
						}
						try
						{
							_MailManCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &mailManCallback;
								*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsMailMan_002ESendMimeX(m_impl, &xString, &xString2, &xString3, (MailManCallback*)ptr);
							Monitor.Exit(m_lockImpl);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
							throw;
						}
						*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeQ(string from, string recipients, string mimeText)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(recipients, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(mimeText, &xString3);
						Monitor.Enter(m_lockImpl);
						result = _003CModule_003E.ClsMailMan_002ESendMimeQX(m_impl, &xString, &xString2, &xString3);
						Monitor.Exit(m_lockImpl);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeToList(string from, string distListFile, string mimeText)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(distListFile, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(mimeText, &xString3);
						Monitor.Enter(m_lockImpl);
						_MailManCallback mailManCallback;
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
						try
						{
							*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
							throw;
						}
						try
						{
							_MailManCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &mailManCallback;
								*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsMailMan_002ESendMimeToListX(m_impl, &xString, &xString2, &xString3, (MailManCallback*)ptr);
							Monitor.Exit(m_lockImpl);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
							throw;
						}
						*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendToDistributionList(Email email, StringArray array)
		{
			if (array == null)
			{
				return false;
			}
			if (email == null)
			{
				return false;
			}
			ClsStringArray* implementation = array.GetImplementation();
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			Monitor.Enter(m_lockImpl);
			bool result;
			if (m_enableEvents)
			{
				_MailManCallback* ptr2 = (_MailManCallback*)_003CModule_003E.@new(12u);
				_MailManCallback* ptr3;
				try
				{
					ptr3 = (_MailManCallback*)(long)((ptr2 == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bctor_007D(ptr2)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr2);
					throw;
				}
				*(int*)((byte*)ptr3 + 8) = m_myHashCode;
				result = _003CModule_003E.ClsMailMan_002ESendToDistributionList(m_impl, ptr, implementation, (MailManCallback*)ptr3);
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr3)))((IntPtr)ptr3, 1u);
			}
			else
			{
				result = _003CModule_003E.ClsMailMan_002ESendToDistributionList(m_impl, ptr, implementation, null);
			}
			Monitor.Exit(m_lockImpl);
			email.ReleaseImpl();
			return result;
		}

		public unsafe Email FetchSingleHeader(int numBodyLines, int index)
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			ClsEmail* ptr2;
			Email result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsMailMan_002EFetchSingleHeader(m_impl, numBodyLines, index, (MailManCallback*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0065;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result2;
			IL_0065:
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe Email FetchSingleHeaderByUidl(int numBodyLines, string uidl)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_MailManCallback mailManCallback;
			ClsEmail* ptr2;
			Email result;
			try
			{
				CkMarshal.StringToX(uidl, &xString);
				_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
				try
				{
					*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
					throw;
				}
				try
				{
					_MailManCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &mailManCallback;
						*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
					}
					ptr2 = _003CModule_003E.ClsMailMan_002EFetchSingleHeaderByUidl(m_impl, numBodyLines, &xString, (MailManCallback*)ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_0076;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
					throw;
				}
				goto end_IL_0008;
				IL_0076:
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
				goto IL_0095;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Email result2;
			try
			{
				try
				{
					result2 = new Email(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
					throw;
				}
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0095:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int GetSizeByUidl(string uidl)
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			int result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(uidl, &xString);
					result = _003CModule_003E.ClsMailMan_002EGetSizeByUidl(m_impl, &xString, (MailManCallback*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe StringArray MxLookupAll(string emailAddress)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ClsStringArray* ptr;
			StringArray result;
			try
			{
				CkMarshal.StringToX(emailAddress, &xString);
				ptr = _003CModule_003E.ClsMailMan_002EMxLookupAll(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			StringArray result2;
			try
			{
				result2 = new StringArray(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0035:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteByMsgnum(int msgnum)
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsMailMan_002EDeleteByMsgnum(m_impl, msgnum, (MailManCallback*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe Email FetchByMsgnum(int msgnum)
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			ClsEmail* ptr2;
			Email result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsMailMan_002EFetchByMsgnum(m_impl, msgnum, (MailManCallback*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0064;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			Email result2;
			try
			{
				result2 = new Email(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result2;
			IL_0064:
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		public unsafe byte[] FetchMimeByMsgnum(int msgnum)
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			byte[] result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsMailMan_002EFetchMimeByMsgnum(m_impl, msgnum, &dataBuffer, (MailManCallback*)ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshTunnel([MarshalAs(UnmanagedType.U1)] bool bSmtp, string sshServerHostname, int sshServerPort)
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(sshServerHostname, &xString);
					result = _003CModule_003E.ClsMailMan_002ESshTunnel(m_impl, bSmtp, &xString, sshServerPort, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePw([MarshalAs(UnmanagedType.U1)] bool bSmtp, string sshLogin, string sshPassword)
		{
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(sshLogin, &xString);
					XString xString2;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						CkMarshal.StringToX(sshPassword, &xString2);
						result = _003CModule_003E.ClsMailMan_002ESshAuthenticatePw(m_impl, bSmtp, &xString, &xString2, (ProgressEvent*)ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePk([MarshalAs(UnmanagedType.U1)] bool bSmtp, string sshLogin, SshKey privateKey)
		{
			if (privateKey == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
			try
			{
				*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &mailManCallback;
					*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(sshLogin, &xString);
					ClsSshKey* implementation = (ClsSshKey*)privateKey.GetImplementation();
					result = _003CModule_003E.ClsMailMan_002ESshAuthenticatePk(m_impl, bSmtp, &xString, implementation, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
				throw;
			}
			*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshCloseTunnel([MarshalAs(UnmanagedType.U1)] bool bSmtp)
		{
			return _003CModule_003E.ClsMailMan_002ESshCloseTunnel(m_impl, bSmtp, null);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xString3);
						result = _003CModule_003E.ClsMailMan_002ESetSslClientCertPfx(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeBytes(string from, string recipients, byte[] mimeData)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(recipients, &xString2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(mimeData, &num);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
						_MailManCallback mailManCallback;
						_003CModule_003E.MailManCallback_002E_007Bctor_007D((MailManCallback*)(&mailManCallback));
						try
						{
							*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.MailManCallback_002E_007Bdtor_007D), &mailManCallback);
							throw;
						}
						try
						{
							_MailManCallback* ptr2 = null;
							if (m_enableEvents)
							{
								ptr2 = &mailManCallback;
								*(int*)(&Unsafe.AddByteOffset(ref mailManCallback, 8)) = m_myHashCode;
							}
							result = _003CModule_003E.ClsMailMan_002ESendMimeBytes(m_impl, &xString, &xString2, &dataBuffer, (MailManCallback*)ptr2);
							CkMarshal.free(ptr);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_MailManCallback_002E_007Bdtor_007D), &mailManCallback);
							throw;
						}
						*(int*)(&mailManCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_MailManCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.MailManCallback_002E_007Bdtor_007D((MailManCallback*)(&mailManCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] RenderToMimeBytes(Email email)
		{
			if (email == null)
			{
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				byte[] result;
				try
				{
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				return result;
			}
			Monitor.Enter(m_lockImpl);
			DataBuffer dataBuffer2;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
			byte[] result2;
			try
			{
				_003CModule_003E.ClsMailMan_002ERenderToMimeBytes(m_impl, (ClsEmail*)email.LockImpl(), &dataBuffer2);
				Monitor.Exit(m_lockImpl);
				email.ReleaseImpl();
				result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeBytesQ(string from, string recipients, byte[] mimeData)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(recipients, &xString2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(mimeData, &num);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
						result = _003CModule_003E.ClsMailMan_002ESendMimeBytesQ(m_impl, &xString, &xString2, &dataBuffer);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		protected void raise_OnSendPercentDone(object i1, MailPercentDoneEventArgs i2)
		{
			this.OnSendPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnReadPercentDone(object i1, MailPercentDoneEventArgs i2)
		{
			this.OnReadPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnEmailReceived(object i1, EmailEventArgs i2)
		{
			this.OnEmailReceived?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
