using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Mailboxes : IDisposable
	{
		private unsafe ClsMailboxes* m_boxes;

		public unsafe int Count => _003CModule_003E.ClsMailboxes_002EgetCount(m_boxes);

		public unsafe Mailboxes(void* mboxes)
		{
			m_boxes = (ClsMailboxes*)mboxes;
		}

		public unsafe Mailboxes()
		{
			ClsMailboxes* ptr = (ClsMailboxes*)_003CModule_003E.@new(24u);
			ClsMailboxes* boxes;
			try
			{
				boxes = (ClsMailboxes*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsMailboxes_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_boxes = boxes;
		}

		protected unsafe override void Finalize()
		{
			ClsMailboxes* boxes = m_boxes;
			if (boxes != null)
			{
				ClsMailboxes* ptr = boxes;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_boxes = null;
			}
		}

		public override void Dispose()
		{
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsMarked(int index)
		{
			ClsMailbox* ptr = _003CModule_003E.ClsMailboxes_002EgetMailbox(m_boxes, index);
			if (ptr == null)
			{
				return false;
			}
			return _003CModule_003E.ClsMailbox_002EisMarked(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasInferiors(int index)
		{
			ClsMailbox* ptr = _003CModule_003E.ClsMailboxes_002EgetMailbox(m_boxes, index);
			if (ptr == null)
			{
				return false;
			}
			return _003CModule_003E.ClsMailbox_002EhasInferiors(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsSelectable(int index)
		{
			ClsMailbox* ptr = _003CModule_003E.ClsMailboxes_002EgetMailbox(m_boxes, index);
			if (ptr == null)
			{
				return false;
			}
			return _003CModule_003E.ClsMailbox_002EisSelectable(ptr);
		}

		public unsafe string GetName(int index)
		{
			ClsMailbox* ptr = _003CModule_003E.ClsMailboxes_002EgetMailbox(m_boxes, index);
			if (ptr == null)
			{
				return null;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_003CModule_003E.ClsMailbox_002EgetNameX(ptr, &xString);
				result = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
