using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class NextTarFileEventArgs : EventArgs
	{
		private string m_fileName;

		private long m_fileSize;

		private bool m_isDirectory;

		private bool m_skip;

		public bool Skip
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_skip;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				m_skip = value;
			}
		}

		public bool IsDirectory
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_isDirectory;
			}
		}

		public long FileSize => m_fileSize;

		public string FileName => m_fileName;

		public unsafe NextTarFileEventArgs(sbyte* fileName, long fileSize, [MarshalAs(UnmanagedType.U1)] bool bIsDirectory)
		{
			m_fileSize = fileSize;
			m_isDirectory = bIsDirectory;
			m_skip = false;
			m_fileName = CkMarshal.Utf8ToString(fileName);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
