using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class RarEntry : IDisposable
	{
		private unsafe ClsRarEntry* m_impl;

		public unsafe bool IsReadOnly
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsRarEntry_002Eget_IsReadOnly(m_impl);
			}
		}

		public unsafe bool IsDirectory
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsRarEntry_002Eget_IsDirectory(m_impl);
			}
		}

		public unsafe DateTime LastModified
		{
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				_003CModule_003E.ClsRarEntry_002Eget_LastModified(m_impl, &chilkatSysTime);
				DateTime result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
					return result;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
							return result;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
						}
						if (num2 != 0)
						{
							throw;
						}
						return result;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
		}

		public unsafe uint Crc => _003CModule_003E.ClsRarEntry_002Eget_Crc(m_impl);

		public unsafe uint CompressedSize => _003CModule_003E.ClsRarEntry_002Eget_CompressedSize(m_impl);

		public unsafe uint UncompressedSize => _003CModule_003E.ClsRarEntry_002Eget_UncompressedSize(m_impl);

		public unsafe string Filename
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsRarEntry_002Eget_Filename(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe RarEntry(void* impl)
		{
			m_impl = (ClsRarEntry*)impl;
			*(int*)((byte*)impl + 256) = 2;
		}

		public unsafe RarEntry()
		{
			ClsRarEntry* ptr = (ClsRarEntry*)_003CModule_003E.@new(264u);
			ClsRarEntry* ptr2;
			try
			{
				ptr2 = (ClsRarEntry*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsRarEntry_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 256) = 2;
		}

		protected unsafe override void Finalize()
		{
			ClsRarEntry* impl = m_impl;
			if (impl != null)
			{
				ClsRarEntry* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
		}

		public override void Dispose()
		{
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Unrar(string dirPath)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				result = _003CModule_003E.ClsRarEntry_002EUnrar(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
