using System;
using System.Runtime.InteropServices;
using System.Security.Cryptography;

namespace Chilkat
{
	public class Rsa : IDisposable
	{
		private unsafe ClsRsa* m_impl;

		public unsafe bool NoUnpad
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsRsa_002Eget_NoUnpad(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsRsa_002Eput_NoUnpad(m_impl, value);
			}
		}

		public unsafe bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsRsa_002Eget_VerboseLogging(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsRsa_002Eput_VerboseLogging(m_impl, value);
			}
		}

		public unsafe string Charset
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsRsa_002Eget_Charset(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsRsa_002Eput_Charset(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string EncodingMode
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsRsa_002Eget_EncodingMode(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsRsa_002Eput_EncodingMode(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool OaepPadding
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsRsa_002Eget_OaepPadding(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsRsa_002Eput_OaepPadding(m_impl, value);
			}
		}

		public unsafe int NumBits => _003CModule_003E.ClsRsa_002Eget_NumBits(m_impl);

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsRsa_002Eget_Version(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool LittleEndian
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsRsa_002Eget_LittleEndian(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsRsa_002Eput_LittleEndian(m_impl, value);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)((byte*)m_impl + 192), &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe Rsa(void* impl)
		{
			m_impl = (ClsRsa*)impl;
		}

		public unsafe Rsa()
		{
			ClsRsa* ptr = (ClsRsa*)_003CModule_003E.@new(720u);
			ClsRsa* ptr2;
			try
			{
				ptr2 = (ClsRsa*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsRsa_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 712) = 2;
		}

		protected unsafe override void Finalize()
		{
			ClsRsa* impl = m_impl;
			if (impl != null)
			{
				ClsRsa* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
		}

		public override void Dispose()
		{
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)((byte*)m_impl + 192), &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				result = _003CModule_003E.ClsRsa_002EUnlockComponent(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GenerateKey(int numBits)
		{
			CspParameters parameters = new CspParameters(1);
			bool flag;
			bool flag2;
			do
			{
				flag = _003CModule_003E.ClsRsa_002EGenerateKey(m_impl, numBits);
				RSACryptoServiceProvider rSACryptoServiceProvider = new RSACryptoServiceProvider(parameters);
				try
				{
					rSACryptoServiceProvider.FromXmlString(ExportPrivateKey());
					flag2 = true;
				}
				catch (CryptographicException)
				{
					flag2 = false;
				}
			}
			while (!flag2 && flag);
			return flag;
		}

		public unsafe string ExportPublicKey()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsRsa_002EExportPublicKey(m_impl, &xString))
				{
					result = null;
					goto IL_002d;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002d:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string ExportPrivateKey()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsRsa_002EExportPrivateKey(m_impl, &xString))
				{
					result = null;
					goto IL_002d;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002d:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPublicKey(string xml)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(xml, &xString);
				result = _003CModule_003E.ClsRsa_002EImportPublicKey(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPrivateKey(string xml)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(xml, &xString);
				result = _003CModule_003E.ClsRsa_002EImportPrivateKey(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string SnkToXml(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsRsa_002ESnkToXml(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] EncryptBytes(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			DataBuffer dataBuffer2;
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					bool flag = _003CModule_003E.ClsRsa_002EEncryptBytes(m_impl, &dataBuffer, bUsePrivateKey, &dataBuffer2);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = new byte[0];
						goto IL_0059;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				goto end_IL_0014;
				IL_0059:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				goto IL_0070;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_0070:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] DecryptBytes(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			DataBuffer dataBuffer2;
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					bool flag = _003CModule_003E.ClsRsa_002EDecryptBytes(m_impl, &dataBuffer, bUsePrivateKey, &dataBuffer2);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = new byte[0];
						goto IL_0059;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				goto end_IL_0014;
				IL_0059:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				goto IL_0070;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_0070:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string DecryptStringENC(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsRsa_002EDecryptStringENC(m_impl, &xString, bUsePrivateKey, &xString2))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string DecryptString(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsRsa_002EDecryptString(m_impl, &dataBuffer, bUsePrivateKey, &xString);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] DecryptBytesENC(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					if (!_003CModule_003E.ClsRsa_002EDecryptBytesENC(m_impl, &xString, bUsePrivateKey, &dataBuffer))
					{
						result = new byte[0];
						goto IL_0045;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0008;
				IL_0045:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_005c;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_005c:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string EncryptStringENC(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsRsa_002EEncryptStringENC(m_impl, &xString, bUsePrivateKey, &xString2))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string EncryptBytesENC(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsRsa_002EEncryptBytesENC(m_impl, &dataBuffer, bUsePrivateKey, &xString);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0054;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0054:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006b;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006b:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] EncryptString(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					if (!_003CModule_003E.ClsRsa_002EEncryptString(m_impl, &xString, bUsePrivateKey, &dataBuffer))
					{
						result = new byte[0];
						goto IL_0045;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_0008;
				IL_0045:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_005c;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			byte[] result2;
			try
			{
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_005c:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyStringENC(string str, string hashAlg, string sig)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(sig, &xString3);
						result = _003CModule_003E.ClsRsa_002EVerifyStringENC(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyString(string str, string hashAlg, byte[] sig)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(sig, &num);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
						result = _003CModule_003E.ClsRsa_002EVerifyString(m_impl, &xString, &xString2, &dataBuffer);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyBytesENC(byte[] data, string hashAlg, string encodedSig)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(encodedSig, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
						result = _003CModule_003E.ClsRsa_002EVerifyBytesENC(m_impl, &dataBuffer, &xString2, &xString);
						CkMarshal.free(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyBytes(byte[] data, string hashAlg, byte[] sig)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(hashAlg, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					int num2 = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(sig, &num2);
					DataBuffer dataBuffer2;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
					try
					{
						_003CModule_003E.DataBuffer_002Eappend(&dataBuffer2, ptr2, (uint)num2);
						result = _003CModule_003E.ClsRsa_002EVerifyBytes(m_impl, &dataBuffer, &xString, &dataBuffer2);
						CkMarshal.free(ptr);
						CkMarshal.free(ptr2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string SignStringENC(string str, string hashAlg)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						if (!_003CModule_003E.ClsRsa_002ESignStringENC(m_impl, &xString, &xString2, &xString3))
						{
							result = null;
							goto IL_0051;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_0051:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0068;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0068:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_007f;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_007f:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string SignBytesENC(byte[] data, string hashAlg)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			DataBuffer dataBuffer;
			string result;
			try
			{
				CkMarshal.StringToX(hashAlg, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
						bool flag = _003CModule_003E.ClsRsa_002ESignBytesENC(m_impl, &dataBuffer, &xString, &xString2);
						CkMarshal.free(ptr);
						if (!flag)
						{
							result = null;
							goto IL_0065;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					goto end_IL_0018;
					IL_0065:
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
					goto IL_007c;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_007c:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0093;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0093:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] SignString(string str, string hashAlg)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString2);
					DataBuffer dataBuffer;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
					try
					{
						_003CModule_003E.ClsRsa_002ESignString(m_impl, &xString, &xString2, &dataBuffer);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] SignBytes(byte[] data, string hashAlg)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(hashAlg, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					DataBuffer dataBuffer2;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
					try
					{
						_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer2, ptr, (uint)num);
						_003CModule_003E.ClsRsa_002ESignBytes(m_impl, &dataBuffer2, &xString, &dataBuffer);
						CkMarshal.free(ptr);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] OpenSslVerifyBytes(byte[] signature)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(signature, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					_003CModule_003E.ClsRsa_002EOpenSslVerifyBytes(m_impl, &dataBuffer, &dataBuffer2);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] OpenSslSignBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				DataBuffer dataBuffer2;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
				try
				{
					_003CModule_003E.ClsRsa_002EOpenSslSignBytes(m_impl, &dataBuffer, &dataBuffer2);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string OpenSslSignBytesENC(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsRsa_002EOpenSslSignBytesENC(m_impl, &dataBuffer, &xString);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0053;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0053:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006a;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006a:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] OpenSslSignString(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsRsa_002EOpenSslSignString(m_impl, &xString, &dataBuffer);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string OpenSslSignStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsRsa_002EOpenSslSignStringENC(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] OpenSslVerifyBytesENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ClsRsa_002EOpenSslVerifyBytesENC(m_impl, &xString, &dataBuffer);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string OpenSslVerifyString(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			XString xString;
			string result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					bool flag = _003CModule_003E.ClsRsa_002EOpenSslVerifyString(m_impl, &dataBuffer, &xString);
					CkMarshal.free(ptr);
					if (!flag)
					{
						result = null;
						goto IL_0053;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0014;
				IL_0053:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_006a;
				end_IL_0014:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result2;
			IL_006a:
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string OpenSslVerifyStringENC(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsRsa_002EOpenSslVerifyStringENC(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyPrivateKey(string xml)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(xml, &xString);
				result = _003CModule_003E.ClsRsa_002EVerifyPrivateKey(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyHash(byte[] hashBytes, string hashAlg, byte[] sigBytes)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(hashBytes, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			bool result;
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString);
					int num2 = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(sigBytes, &num2);
					DataBuffer dataBuffer2;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
					try
					{
						_003CModule_003E.DataBuffer_002Eappend(&dataBuffer2, ptr2, (uint)num2);
						result = _003CModule_003E.ClsRsa_002EVerifyHash(m_impl, &dataBuffer, &xString, &dataBuffer2);
						CkMarshal.free(ptr);
						CkMarshal.free(ptr2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyHashENC(string encodedHash, string hashAlg, string encodedSig)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(encodedHash, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(encodedSig, &xString3);
						result = _003CModule_003E.ClsRsa_002EVerifyHashENC(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] SignHash(byte[] hashBytes, string hashAlg)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(hashBytes, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002Eappend(&dataBuffer, ptr, (uint)num);
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString);
					DataBuffer dataBuffer2;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
					try
					{
						_003CModule_003E.ClsRsa_002ESignHash(m_impl, &dataBuffer, &xString, &dataBuffer2);
						CkMarshal.free(ptr);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string SignHashENC(string encodedHash, string hashAlg)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			string result;
			try
			{
				CkMarshal.StringToX(encodedHash, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						if (!_003CModule_003E.ClsRsa_002ESignHashENC(m_impl, &xString, &xString2, &xString3))
						{
							result = null;
							goto IL_0051;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_0051:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0068;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0068:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_007f;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_007f:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
