using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Rss : IDisposable
	{
		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsRss* m_impl;

		public unsafe int NumItems => _003CModule_003E.ClsRss_002Eget_NumItems(m_impl);

		public unsafe int NumChannels => _003CModule_003E.ClsRss_002Eget_NumChannels(m_impl);

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Rss LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Rss result = (Rss)m_objects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public unsafe Rss(void* impl)
		{
			m_impl = (ClsRss*)impl;
			this.OnAbortCheck = null;
		}

		public unsafe Rss()
		{
			m_enableEvents = false;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0xa7d0a445_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0xa7d0a445_002ENextHashCode;
			ClsRss* ptr = (ClsRss*)_003CModule_003E.@new(280u);
			ClsRss* impl;
			try
			{
				impl = (ClsRss*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsRss_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
			_003CModule_003E._003Fm_progLang_0040ClsRss_0040_00402HA = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsRss* impl = m_impl;
			if (impl != null)
			{
				ClsRss* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Rss AddNewChannel()
		{
			ClsRss* ptr = _003CModule_003E.ClsRss_002EAddNewChannel(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Rss(ptr);
		}

		public unsafe Rss AddNewImage()
		{
			ClsRss* ptr = _003CModule_003E.ClsRss_002EAddNewImage(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Rss(ptr);
		}

		public unsafe Rss AddNewItem()
		{
			ClsRss* ptr = _003CModule_003E.ClsRss_002EAddNewItem(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Rss(ptr);
		}

		public unsafe string GetAttr(string tag, string attrName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			string result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(attrName, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						if (!_003CModule_003E.ClsRss_002EGetAttr(m_impl, &xString, &xString2, &xString3))
						{
							result = null;
							goto IL_0051;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_0051:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0068;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0068:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_007f;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_007f:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Rss GetChannel(int index)
		{
			ClsRss* ptr = _003CModule_003E.ClsRss_002EGetChannel(m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Rss(ptr);
		}

		public unsafe int GetCount(string tag)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				result = _003CModule_003E.ClsRss_002EGetCount(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe DateTime GetDate(string tag)
		{
			//Discarded unreachable code: IL_00b8
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DateTime result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				_003CModule_003E.ClsRss_002EGetDate(m_impl, &xString, &chilkatSysTime);
				result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00a7;
						}
						goto end_IL_008d;
						IL_00a7:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_008d:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Rss GetImage()
		{
			ClsRss* ptr = _003CModule_003E.ClsRss_002EGetImage(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Rss(ptr);
		}

		public unsafe int GetInt(string tag)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				result = _003CModule_003E.ClsRss_002EGetInt(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Rss GetItem(int index)
		{
			ClsRss* ptr = _003CModule_003E.ClsRss_002EGetItem(m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Rss(ptr);
		}

		public unsafe string GetString(string tag)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsRss_002EGetString(m_impl, &xString, &xString2))
					{
						result = null;
						goto IL_003f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_003f:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0056;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0056:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadRssFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsRss_002ELoadRssFile(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadRssString(string rssString)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(rssString, &xString);
				result = _003CModule_003E.ClsRss_002ELoadRssString(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string MGetAttr(string tag, int idx, string attrName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			string result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(attrName, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						if (!_003CModule_003E.ClsRss_002EMGetAttr(m_impl, &xString, idx, &xString2, &xString3))
						{
							result = null;
							goto IL_0052;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_0052:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0069;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0069:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0080;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0080:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string MGetString(string tag, int idx)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsRss_002EMGetString(m_impl, &xString, idx, &xString2))
					{
						result = null;
						goto IL_0040;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0040:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0057;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0057:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool MSetAttr(string tag, int idx, string attrName, string value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(attrName, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(value, &xString3);
						result = _003CModule_003E.ClsRss_002EMSetAttr(m_impl, &xString, idx, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool MSetString(string tag, int idx, string value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(value, &xString2);
					result = _003CModule_003E.ClsRss_002EMSetString(m_impl, &xString, idx, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void NewRss()
		{
			_003CModule_003E.ClsRss_002ENewRss(m_impl);
		}

		public unsafe void Remove(string tag)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tag, &xString);
				_003CModule_003E.ClsRss_002ERemove(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void SetAttr(string tag, string attrName, string value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tag, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(attrName, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(value, &xString3);
						_003CModule_003E.ClsRss_002ESetAttr(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void SetDate(string tag, DateTime d)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tag, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				*(short*)(&chilkatSysTime) = (short)d.Year;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)d.Month;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)d.Day;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)d.Hour;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)d.Minute;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)d.Second;
				_003CModule_003E.ClsRss_002ESetDate(m_impl, &xString, &chilkatSysTime);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void SetDateNow(string tag)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tag, &xString);
				_003CModule_003E.ClsRss_002ESetDateNow(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void SetInt(string tag, int value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tag, &xString);
				_003CModule_003E.ClsRss_002ESetInt(m_impl, &xString, value);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void SetString(string tag, string value)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(tag, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(value, &xString2);
					_003CModule_003E.ClsRss_002ESetString(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe string ToXmlString()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsRss_002EToXmlString(m_impl, &xString))
				{
					result = null;
					goto IL_002d;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002d:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DownloadRss(string url)
		{
			_RssCallback rssCallback;
			_003CModule_003E.RssCallback_002E_007Bctor_007D((RssCallback*)(&rssCallback));
			try
			{
				*(int*)(&rssCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_RssCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref rssCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.RssCallback_002E_007Bdtor_007D), &rssCallback);
				throw;
			}
			bool result;
			try
			{
				_RssCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &rssCallback;
					*(int*)(&Unsafe.AddByteOffset(ref rssCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(url, &xString);
					result = _003CModule_003E.ClsRss_002EDownloadRss(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_RssCallback_002E_007Bdtor_007D), &rssCallback);
				throw;
			}
			*(int*)(&rssCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_RssCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.RssCallback_002E_007Bdtor_007D((RssCallback*)(&rssCallback));
			return result;
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
