using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Socket : IDisposable
	{
		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsSocket* m_impl;

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public unsafe int ReceivePacketSize
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_ReceivePacketSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_ReceivePacketSize(m_impl, value);
			}
		}

		public unsafe int SendPacketSize
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_SendPacketSize(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_SendPacketSize(m_impl, value);
			}
		}

		public unsafe bool AsyncAcceptSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncAcceptSuccess(m_impl);
			}
		}

		public unsafe string AsyncAcceptLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002EAsyncAcceptLog(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncAcceptFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				bool result = false;
				try
				{
					result = _003CModule_003E.ClsSocket_002EAsyncAcceptFinished(m_impl);
					return result;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BE_0040HAMJFIKH_0040AsyncAcceptFinished_003F_0024AA_0040));
							return result;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
						}
						if (num2 != 0)
						{
							throw;
						}
						return result;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
		}

		public unsafe string RemoteIpAddress
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_RemoteIpAddress(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int RemotePort => _003CModule_003E.ClsSocket_002Eget_RemotePort(m_impl);

		public unsafe bool IsConnected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_IsConnected(m_impl);
			}
		}

		public unsafe int DebugConnectDelayMs
		{
			get
			{
				return *(int*)((byte*)m_impl + 3632);
			}
			set
			{
				*(int*)((byte*)m_impl + 3632) = value;
			}
		}

		public unsafe int DebugDnsDelayMs
		{
			get
			{
				return *(int*)((byte*)m_impl + 3628);
			}
			set
			{
				*(int*)((byte*)m_impl + 3628) = value;
			}
		}

		public unsafe string StringCharset
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_StringCharset(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocket_002Eput_StringCharset(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int MaxReadIdleMs
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_MaxReadIdleMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_MaxReadIdleMs(m_impl, value);
			}
		}

		public unsafe int MaxSendIdleMs
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_MaxSendIdleMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_MaxSendIdleMs(m_impl, value);
			}
		}

		public unsafe int HeartbeatMs
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_HeartbeatMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_HeartbeatMs(m_impl, value);
			}
		}

		public unsafe int ConnectFailReason => _003CModule_003E.ClsSocket_002Eget_ConnectFailReason(m_impl);

		public unsafe string MyIpAddress
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_MyIpAddress(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncConnectSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncConnectSuccess(m_impl);
			}
		}

		public unsafe string AsyncConnectLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002EAsyncConnectLog(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncConnectFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncConnectFinished(m_impl);
			}
		}

		public unsafe bool AsyncDnsSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncDnsSuccess(m_impl);
			}
		}

		public unsafe string AsyncDnsLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002EAsyncDnsLog(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string AsyncDnsResult
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002EAsyncDnsResult(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncDnsFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncDnsFinished(m_impl);
			}
		}

		public unsafe int ObjectId => _003CModule_003E.ClsSocket_002Eget_ObjectId(m_impl);

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_Version(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe byte[] AsyncReceivedBytes
		{
			get
			{
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				byte[] result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_AsyncReceivedBytes(m_impl, &dataBuffer);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				return result;
			}
		}

		public unsafe string AsyncReceivedString
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_AsyncReceivedString(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncReceiveSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncReceiveSuccess(m_impl);
			}
		}

		public unsafe string AsyncReceiveLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002EAsyncReceiveLog(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncReceiveFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				bool result = false;
				try
				{
					result = _003CModule_003E.ClsSocket_002EAsyncReceiveFinished(m_impl);
					return result;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BF_0040BNAOJGDA_0040AsyncReceiveFinished_003F_0024AA_0040));
							return result;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
						}
						if (num2 != 0)
						{
							throw;
						}
						return result;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
		}

		public unsafe bool AsyncSendSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncSendSuccess(m_impl);
			}
		}

		public unsafe string AsyncSendLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002EAsyncSendLog(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool AsyncSendFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002EAsyncSendFinished(m_impl);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Esock_LastErrorHtml(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Esock_LastErrorXml(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Esock_LastErrorText(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int HttpProxyPort
		{
			get
			{
				return _003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyPort((ClsHttpProxyClient*)((byte*)m_impl + 552));
			}
			set
			{
				_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyPort((ClsHttpProxyClient*)((byte*)m_impl + 552), value);
			}
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyHostname((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyHostname((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyAuthMethod((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyAuthMethod((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyPassword((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyPassword((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsHttpProxyClient_002Eget_HttpProxyUsername((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsHttpProxyClient_002Eput_HttpProxyUsername((ClsHttpProxyClient*)((byte*)m_impl + 552), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int ElapsedSeconds => (int)_003CModule_003E.ClsSocket_002Eget_ElapsedSeconds(m_impl);

		public unsafe string UserData
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_UserData(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocket_002Eput_UserData(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int NumSocketsInSet => _003CModule_003E.ClsSocket_002Eget_NumSocketsInSet(m_impl);

		public unsafe int SelectorWriteIndex
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_SelectorWriteIndex(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_SelectorWriteIndex(m_impl, value);
			}
		}

		public unsafe int SelectorReadIndex
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_SelectorReadIndex(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_SelectorReadIndex(m_impl, value);
			}
		}

		public unsafe int SelectorIndex
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_SelectorIndex(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_SelectorIndex(m_impl, value);
			}
		}

		public unsafe bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_VerboseLogging(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsSocket_002Eput_VerboseLogging(m_impl, value);
			}
		}

		public unsafe bool BigEndian
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_BigEndian(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsSocket_002Eput_BigEndian(m_impl, value);
			}
		}

		public unsafe bool TcpNoDelay
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_TcpNoDelay(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsSocket_002Eput_TcpNoDelay(m_impl, value);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksHostname((ClsSocksClient*)((byte*)m_impl + 128), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksHostname((ClsSocksClient*)((byte*)m_impl + 128), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksPassword((ClsSocksClient*)((byte*)m_impl + 128), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksPassword((ClsSocksClient*)((byte*)m_impl + 128), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocksClient_002Eget_SocksUsername((ClsSocksClient*)((byte*)m_impl + 128), &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocksClient_002Eput_SocksUsername((ClsSocksClient*)((byte*)m_impl + 128), &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int SocksVersion
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksVersion((ClsSocksClient*)((byte*)m_impl + 128));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksVersion((ClsSocksClient*)((byte*)m_impl + 128), value);
			}
		}

		public unsafe int SocksPort
		{
			get
			{
				return _003CModule_003E.ClsSocksClient_002Eget_SocksPort((ClsSocksClient*)((byte*)m_impl + 128));
			}
			set
			{
				_003CModule_003E.ClsSocksClient_002Eput_SocksPort((ClsSocksClient*)((byte*)m_impl + 128), value);
			}
		}

		public unsafe int LocalPort => _003CModule_003E.ClsSocket_002Eget_LocalPort(m_impl);

		public unsafe string LocalIpAddress
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_LocalIpAddress(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe int ClientPort
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_ClientPort(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_ClientPort(m_impl, value);
			}
		}

		public unsafe int SoRcvBuf
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_SoRcvBuf(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_SoRcvBuf(m_impl, value);
			}
		}

		public unsafe int SoSndBuf
		{
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_SoSndBuf(m_impl);
			}
			set
			{
				_003CModule_003E.ClsSocket_002Eput_SoSndBuf(m_impl, value);
			}
		}

		public unsafe bool LastMethodFailed
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_LastMethodFailed(m_impl);
			}
		}

		public unsafe string ClientIpAddress
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_ClientIpAddress(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocket_002Eput_ClientIpAddress(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_SslProtocol(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocket_002Eput_SslProtocol(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string SessionLogEncoding
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_SessionLogEncoding(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsSocket_002Eput_SessionLogEncoding(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_KeepSessionLog(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsSocket_002Eput_KeepSessionLog(m_impl, value);
			}
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsSocket_002Eget_SessionLog(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool Ssl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsSocket_002Eget_Ssl(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsSocket_002Eput_Ssl(m_impl, value);
			}
		}

		public event AbortCheckEventHandler OnAbortCheck;

		public event PercentDoneEventHandler OnPercentDone;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Socket LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Socket result = (Socket)m_objects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			this.OnPercentDone?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public unsafe Socket(void* impl)
		{
			m_impl = (ClsSocket*)impl;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0xe9ccccd5_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0xe9ccccd5_002ENextHashCode;
			if (impl == null)
			{
				ClsSocket* ptr = (ClsSocket*)_003CModule_003E.@new(3640u);
				ClsSocket* impl2;
				try
				{
					impl2 = (ClsSocket*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsSocket_002E_007Bctor_007D(ptr)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				m_impl = impl2;
			}
			*(int*)((byte*)m_impl + 3624) = 2;
		}

		public unsafe Socket()
		{
			m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			_003CModule_003E._003FA0xe9ccccd5_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0xe9ccccd5_002ENextHashCode;
			ClsSocket* ptr = (ClsSocket*)_003CModule_003E.@new(3640u);
			ClsSocket* ptr2;
			try
			{
				ptr2 = (ClsSocket*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsSocket_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = ptr2;
			*(int*)((byte*)ptr2 + 3624) = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsSocket* impl = m_impl;
			if (impl != null)
			{
				ClsSocket* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public unsafe override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			_003CModule_003E.ClsSocket_002EDispose(m_impl);
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		public unsafe void* GetImplementation()
		{
			return m_impl;
		}

		public unsafe string DnsLookup(string hostname, int maxWaitMs)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			string result;
			try
			{
				CkMarshal.StringToX(hostname, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					if (!_003CModule_003E.ClsSocket_002EDnsLookup(m_impl, &xString, maxWaitMs, null, &xString2))
					{
						result = null;
						goto IL_0041;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0041:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0058;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0058:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Cert GetMyCert()
		{
			ClsCert* ptr = _003CModule_003E.ClsSocket_002EGetMyCert(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		public unsafe Cert GetSslServerCert()
		{
			ClsCert* ptr = _003CModule_003E.ClsSocket_002EGetSslServerCert(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			return _003CModule_003E.ClsSocket_002EIsUnlocked(m_impl);
		}

		public unsafe string ReceiveToCRLF()
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_SocketCallback socketCallback;
			string result;
			try
			{
				_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
				try
				{
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &socketCallback;
						*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
					}
					if (!_003CModule_003E.ClsSocket_002EReceiveToCRLF(m_impl, &xString, (ProgressEvent*)ptr))
					{
						result = null;
						goto IL_006d;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				goto end_IL_0008;
				IL_006d:
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
				goto IL_008c;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_008c:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] ReceiveUntilByte(int byteValue)
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_SocketCallback socketCallback;
				_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
				try
				{
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &socketCallback;
						*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
					}
					_003CModule_003E.ClsSocket_002EReceiveUntilByte(m_impl, byteValue, &dataBuffer, (ProgressEvent*)ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe void ClearSessionLog()
		{
			_003CModule_003E.ClsSocket_002EClearSessionLog(m_impl);
		}

		public unsafe string ReceiveStringUntilByte(int byteValue)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			XString xString;
			string result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					if (!_003CModule_003E.ClsSocket_002EReceiveStringUntilByte(m_impl, byteValue, &xString, (ProgressEvent*)ptr))
					{
						result = null;
						goto IL_006e;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_006e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_0085;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result2;
			IL_0085:
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe string ReceiveStringMaxN(int maxBytes)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			XString xString;
			string result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					if (!_003CModule_003E.ClsSocket_002EReceiveStringMaxN(m_impl, maxBytes, &xString, (ProgressEvent*)ptr))
					{
						result = null;
						goto IL_006e;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_006e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_0085;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result2;
			IL_0085:
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			if (cert == null)
			{
				_003CModule_003E.ClsSocket_002ESetSslClientCert(m_impl, null);
			}
			else
			{
				_003CModule_003E.ClsSocket_002ESetSslClientCert(m_impl, (ClsCert*)cert.GetImplementation());
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendCount(int byteCount)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002ESendCount(m_impl, byteCount, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe int ReceiveCount()
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002EReceiveCount(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToSsl()
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002EConvertToSsl(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertFromSsl()
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002EConvertFromSsl(m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe int CheckWriteable(int maxWaitMs)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002ECheckWriteable(m_impl, maxWaitMs, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xString3);
						result = _003CModule_003E.ClsSocket_002ESetSslClientCertPfx(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PollDataAvailable()
		{
			return _003CModule_003E.ClsSocket_002EPollDataAvailable(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool TakeSocket(Socket sock)
		{
			if (sock == null)
			{
				return false;
			}
			ClsSocket* impl = sock.m_impl;
			return _003CModule_003E.ClsSocket_002ETakeSocket(m_impl, impl);
		}

		public unsafe int SelectForReading(int timeoutMs)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002ESelectForReading(m_impl, timeoutMs, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe int SelectForWriting(int timeoutMs)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002ESelectForWriting(m_impl, timeoutMs, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe void StartTiming()
		{
			_003CModule_003E.ClsSocket_002EStartTiming(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ReceiveBytesToFile(string appendFilename)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(appendFilename, &xString);
					result = _003CModule_003E.ClsSocket_002EReceiveBytesToFile(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsSocket_002Esock_SaveLastError(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				result = _003CModule_003E.ClsSocket_002EUnlockComponent(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncSendBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			bool result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				result = _003CModule_003E.ClsSocket_002EAsyncSendBytes(m_impl, &dataBuffer, null);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncSendString(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				result = _003CModule_003E.ClsSocket_002EAsyncSendString(m_impl, &xString, null);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void AsyncSendAbort()
		{
			_003CModule_003E.ClsSocket_002EAsyncSendAbort(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncReceiveBytes()
		{
			return _003CModule_003E.ClsSocket_002EAsyncReceiveBytes(m_impl, null);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncReceiveBytesN(uint numBytes)
		{
			return _003CModule_003E.ClsSocket_002EAsyncReceiveBytesN(m_impl, numBytes, null, false);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncReceiveString()
		{
			return _003CModule_003E.ClsSocket_002EAsyncReceiveString(m_impl, null);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncReceiveToCRLF()
		{
			return _003CModule_003E.ClsSocket_002EAsyncReceiveToCRLF(m_impl, null);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncReceiveUntilMatch(string matchStr)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(matchStr, &xString);
				result = _003CModule_003E.ClsSocket_002EAsyncReceiveUntilMatch(m_impl, &xString, null);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void AsyncReceiveAbort()
		{
			_003CModule_003E.ClsSocket_002EAsyncReceiveAbort(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool InitSslServer(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			if (implementation == null)
			{
				return false;
			}
			return _003CModule_003E.ClsSocket_002EInitSslServer(m_impl, implementation);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncDnsStart(string hostname, int maxWaitMs)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xString);
				result = _003CModule_003E.ClsSocket_002EAsyncDnsStart(m_impl, &xString, maxWaitMs, null);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void AsyncDnsAbort()
		{
			_003CModule_003E.ClsSocket_002EAsyncDnsAbort(m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncConnectStart(string hostname, int port, [MarshalAs(UnmanagedType.U1)] bool ssl, int maxWaitMs)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xString);
				result = _003CModule_003E.ClsSocket_002EAsyncConnectStart(m_impl, &xString, port, ssl, maxWaitMs, null);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void AsyncConnectAbort()
		{
			_003CModule_003E.ClsSocket_002EAsyncConnectAbort(m_impl);
		}

		public unsafe void SleepMs(int millisec)
		{
			_003CModule_003E.ClsSocket_002ESleepMs(m_impl, millisec);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool BindAndListen(int port, int backlog)
		{
			return _003CModule_003E.ClsSocket_002EBindAndListen(m_impl, port, backlog);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect(string hostname, int port, [MarshalAs(UnmanagedType.U1)] bool ssl, int maxWaitMs)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xString);
				_SocketCallback socketCallback;
				_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
				try
				{
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &socketCallback;
						*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsSocket_002EConnect(m_impl, &xString, port, ssl, maxWaitMs, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Socket AcceptNextConnection(int maxWaitMs)
		{
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			ClsSocket* ptr2;
			Socket result;
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				ptr2 = _003CModule_003E.ClsSocket_002EAcceptNextConnection(m_impl, maxWaitMs, (ProgressEvent*)ptr);
				if (ptr2 == null)
				{
					result = null;
					goto IL_0064;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			Socket result2;
			try
			{
				result2 = new Socket(ptr2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result2;
			IL_0064:
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe void Close(int maxWaitMs)
		{
			if (m_impl == null)
			{
				return;
			}
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			try
			{
				_SocketCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.ClsSocket_002EClose(m_impl, maxWaitMs, (ProgressEvent*)ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncAcceptStart(int maxWaitMs)
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			bool result = false;
			try
			{
				result = _003CModule_003E.ClsSocket_002EAsyncAcceptStart(m_impl, maxWaitMs, null);
				return result;
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BB_0040HNFILPIO_0040AsyncAcceptStart_003F_0024AA_0040));
						return result;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
					return result;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public unsafe void AsyncAcceptAbort()
		{
			_003CModule_003E.ClsSocket_002EAsyncAcceptAbort(m_impl);
		}

		public unsafe Socket AsyncAcceptSocket()
		{
			ClsSocket* ptr = _003CModule_003E.ClsSocket_002EAsyncAcceptSocket(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Socket(ptr);
		}

		public unsafe string BuildHttpGetRequest(string url)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(url, &xString2);
					_003CModule_003E.ClsSocket_002EBuildHttpGet(m_impl, &xString2, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendString(string str)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				_SocketCallback socketCallback;
				_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
				try
				{
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &socketCallback;
						*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsSocket_002ESendString(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
			_SocketCallback socketCallback;
			_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
			try
			{
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr2 = null;
				if (m_enableEvents)
				{
					ptr2 = &socketCallback;
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
				}
				result = _003CModule_003E.ClsSocket_002ESendBytes2(m_impl, (byte*)ptr, (uint)num, (ProgressEvent*)ptr2);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
				throw;
			}
			*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			return result;
		}

		public unsafe string ReceiveString()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			_SocketCallback socketCallback;
			string result;
			try
			{
				_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
				try
				{
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &socketCallback;
						*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
					}
					bool flag = false;
					try
					{
						flag = _003CModule_003E.ClsSocket_002EReceiveString(m_impl, &xString, (ProgressEvent*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ClsBase_002ECreateExceptionLog((ClsBase*)m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040JMLFPDGM_0040ReceiveString_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00ac;
							}
							goto end_IL_0088;
							IL_00ac:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_0088:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					if (!flag)
					{
						result = null;
						goto IL_00d5;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				goto end_IL_0010;
				IL_00d5:
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
				goto IL_00f4;
				end_IL_0010:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					result2 = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00f4:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string ReceiveUntilMatch(string matchStr)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			_SocketCallback socketCallback;
			string result;
			try
			{
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(matchStr, &xString2);
					_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
					try
					{
						*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
						throw;
					}
					try
					{
						_SocketCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &socketCallback;
							*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
						}
						if (!_003CModule_003E.ClsSocket_002EReceiveUntilMatch(m_impl, &xString2, &xString, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
						throw;
					}
					goto end_IL_0010;
					IL_007f:
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
					goto IL_009e;
					end_IL_0010:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_009e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00b5;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
						throw;
					}
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_00b5:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] ReceiveBytes()
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_SocketCallback socketCallback;
				_003CModule_003E.SocketCallback_002E_007Bctor_007D((SocketCallback*)(&socketCallback));
				try
				{
					*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &socketCallback;
						*(int*)(&Unsafe.AddByteOffset(ref socketCallback, 4)) = m_myHashCode;
					}
					_003CModule_003E.ClsSocket_002EReceiveBytes(m_impl, &dataBuffer, (ProgressEvent*)ptr);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_SocketCallback_002E_007Bdtor_007D), &socketCallback);
					throw;
				}
				*(int*)(&socketCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_SocketCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.SocketCallback_002E_007Bdtor_007D((SocketCallback*)(&socketCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] ReceiveBytesN(uint numBytes)
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.ClsSocket_002EReceiveBytesN(m_impl, numBytes, &dataBuffer, null, false);
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		protected void raise_OnPercentDone(object i1, PercentDoneEventArgs i2)
		{
			this.OnPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
