using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Tar : IDisposable
	{
		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void NextTarFileEventHandler(object sender, NextTarFileEventArgs args);

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsTar* m_impl;

		public unsafe int HeartbeatMs
		{
			get
			{
				return _003CModule_003E.ClsTar_002Eget_HeartbeatMs(m_impl);
			}
			set
			{
				_003CModule_003E.ClsTar_002Eput_HeartbeatMs(m_impl, value);
			}
		}

		public unsafe string WriteFormat
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsTar_002Eget_WriteFormat(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsTar_002Eput_WriteFormat(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ClsTar_002Eget_VerboseLogging(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ClsTar_002Eput_VerboseLogging(m_impl, value);
			}
		}

		public unsafe int FileMode
		{
			get
			{
				return _003CModule_003E.ClsTar_002Eget_FileMode(m_impl);
			}
			set
			{
				_003CModule_003E.ClsTar_002Eput_FileMode(m_impl, value);
			}
		}

		public unsafe int DirMode
		{
			get
			{
				return _003CModule_003E.ClsTar_002Eget_DirMode(m_impl);
			}
			set
			{
				_003CModule_003E.ClsTar_002Eput_DirMode(m_impl, value);
			}
		}

		public unsafe int GroupId
		{
			get
			{
				return _003CModule_003E.ClsTar_002Eget_GroupId(m_impl);
			}
			set
			{
				_003CModule_003E.ClsTar_002Eput_GroupId(m_impl, value);
			}
		}

		public unsafe int UserId
		{
			get
			{
				return _003CModule_003E.ClsTar_002Eget_UserId(m_impl);
			}
			set
			{
				_003CModule_003E.ClsTar_002Eput_UserId(m_impl, value);
			}
		}

		public unsafe string GroupName
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsTar_002Eget_GroupName(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsTar_002Eput_GroupName(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string UserName
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsTar_002Eget_UserName(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsTar_002Eput_UserName(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Charset
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsTar_002Eget_Charset(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ClsTar_002Eput_Charset(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int NumDirRoots => _003CModule_003E.ClsTar_002Eget_NumDirRoots(m_impl);

		public unsafe bool UntarDebugLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return ((byte*)m_impl)[1178] != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				((byte*)m_impl)[1178] = (value ? ((byte)1) : ((byte)0));
			}
		}

		public unsafe string UntarMatchPattern
		{
			get
			{
				return CkMarshal.XToString((XString*)((byte*)m_impl + 1032));
			}
			set
			{
				CkMarshal.StringToX(value, (XString*)((byte*)m_impl + 1032));
			}
		}

		public unsafe int UntarMaxCount
		{
			get
			{
				return *(int*)((byte*)m_impl + 1172);
			}
			set
			{
				*(int*)((byte*)m_impl + 1172) = value;
			}
		}

		public unsafe bool UntarCaseSensitive
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return ((byte*)m_impl)[1168] != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				((byte*)m_impl)[1168] = (value ? ((byte)1) : ((byte)0));
			}
		}

		public unsafe bool UntarDiscardPaths
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return ((byte*)m_impl)[1176] != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				((byte*)m_impl)[1176] = (value ? ((byte)1) : ((byte)0));
			}
		}

		public unsafe bool NoAbsolutePaths
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return ((byte*)m_impl)[1177] != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				((byte*)m_impl)[1177] = (value ? ((byte)1) : ((byte)0));
			}
		}

		public unsafe string UntarFromDir
		{
			get
			{
				return CkMarshal.XToString((XString*)((byte*)m_impl + 896));
			}
			set
			{
				CkMarshal.StringToX(value, (XString*)((byte*)m_impl + 896));
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				if (value)
				{
					Monitor.Enter(m_lockObject);
					if (m_objects == null)
					{
						m_objects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_objects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_objects = new Hashtable();
								m_objects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					Monitor.Exit(m_lockObject);
				}
				else
				{
					Monitor.Enter(m_lockObject);
					object key = m_myHashCode;
					m_objects.Remove(key);
					Monitor.Exit(m_lockObject);
				}
				m_enableEvents = value;
			}
		}

		public event NextTarFileEventHandler OnNextTarFile;

		public event PercentDoneEventHandler OnPercentDone;

		public event AbortCheckEventHandler OnAbortCheck;

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Tar LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			object result = m_objects[key];
			Monitor.Exit(m_lockObject);
			return (Tar)result;
		}

		public unsafe Tar(void* impl)
		{
			m_impl = (ClsTar*)impl;
			this.OnAbortCheck = null;
			this.OnPercentDone = null;
			this.OnNextTarFile = null;
		}

		public unsafe Tar()
		{
			m_enableEvents = false;
			this.OnAbortCheck = null;
			this.OnPercentDone = null;
			this.OnNextTarFile = null;
			_003CModule_003E._003FA0x5aa2f380_002ENextHashCode++;
			m_myHashCode = _003CModule_003E._003FA0x5aa2f380_002ENextHashCode;
			ClsTar* ptr = (ClsTar*)_003CModule_003E.@new(1184u);
			ClsTar* impl;
			try
			{
				impl = (ClsTar*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsTar_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
			_003CModule_003E._003Fm_progLang_0040ClsTar_0040_00402HA = 2;
		}

		protected unsafe override void Finalize()
		{
			object obj = null;
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			ClsTar* impl = m_impl;
			if (impl != null)
			{
				ClsTar* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				Monitor.Enter(m_lockObject);
				obj = m_myHashCode;
				m_objects.Remove(obj);
				Monitor.Exit(m_lockObject);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
						return;
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
					}
					if (num2 != 0)
					{
						throw;
					}
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
		}

		public unsafe override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			ClsTar* impl = m_impl;
			if (impl != null)
			{
				_003CModule_003E.ClsTar_002EdotNetDispose(impl);
			}
			object key = m_myHashCode;
			m_objects.Remove(key);
			Monitor.Exit(m_lockObject);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			this.OnPercentDone?.Invoke(sender, args);
		}

		public void FireNextTarFile(object sender, NextTarFileEventArgs args)
		{
			this.OnNextTarFile?.Invoke(sender, args);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int Untar(string tarFilename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(tarFilename, &xString);
				_TarCallback tarCallback;
				_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
				try
				{
					*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
					throw;
				}
				try
				{
					_TarCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &tarCallback;
						*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsTar_002EUntar(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
					throw;
				}
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xString);
				int num = *(int*)m_impl + 4;
				ClsTar* impl = m_impl;
				sbyte* intPtr = _003CModule_003E.XString_002EgetUtf8(&xString);
				result = (((delegate* thiscall<IntPtr, sbyte*, byte>)(*(int*)num))((IntPtr)impl, intPtr) != 0);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int UntarFromMemory(byte[] tarFileBytes)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(tarFileBytes, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			int result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				_TarCallback tarCallback;
				_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
				try
				{
					*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
					throw;
				}
				try
				{
					_TarCallback* ptr2 = null;
					if (m_enableEvents)
					{
						ptr2 = &tarCallback;
						*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
					}
					result = _003CModule_003E.ClsTar_002EUntarFromMemory(m_impl, &dataBuffer, (ProgressEvent*)ptr2);
					CkMarshal.free(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
					throw;
				}
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] UntarFirstMatchingToMemory(byte[] tarFileBytes, string matchPattern)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(tarFileBytes, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(matchPattern, &xString);
					DataBuffer dataBuffer2;
					_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer2);
					try
					{
						_003CModule_003E.ClsTar_002EUntarFirstMatchingToMemory(m_impl, &dataBuffer, &xString, &dataBuffer2);
						CkMarshal.free(ptr);
						result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer2), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer2));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer2);
						throw;
					}
					_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddDirRoot(string dirPath)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				result = _003CModule_003E.ClsTar_002EAddDirRoot(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetDirRoot(int index)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				if (!_003CModule_003E.ClsTar_002EGetDirRoot(m_impl, index, &xString))
				{
					result = null;
					goto IL_002e;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_002e:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTar(string tarFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(tarFilename, &xString);
					result = _003CModule_003E.ClsTar_002EWriteTar(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTarGz(string outFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(outFilename, &xString);
					result = _003CModule_003E.ClsTar_002EWriteTarGz(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTarBz2(string outFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(outFilename, &xString);
					result = _003CModule_003E.ClsTar_002EWriteTarBz2(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTarZ(string outFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(outFilename, &xString);
					result = _003CModule_003E.ClsTar_002EWriteTarZ(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		public unsafe string ListXml(string tarFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			XString xString;
			XString xString2;
			string result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(tarFilename, &xString);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
					try
					{
						if (!_003CModule_003E.ClsTar_002EListXml(m_impl, &xString, &xString2, (ProgressEvent*)ptr))
						{
							result = null;
							goto IL_007f;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					goto end_IL_0047;
					IL_007f:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					goto IL_0096;
					end_IL_0047:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				goto end_IL_0027;
				IL_0096:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				goto IL_00ad;
				end_IL_0027:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			string result2;
			try
			{
				try
				{
					try
					{
						result2 = CkMarshal.XToString(&xString2);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result2;
			IL_00ad:
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UntarZ(string tarFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(tarFilename, &xString);
					result = _003CModule_003E.ClsTar_002EUntarZ(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UntarGz(string tarFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(tarFilename, &xString);
					result = _003CModule_003E.ClsTar_002EUntarGz(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UntarBz2(string tarFilename)
		{
			_TarCallback tarCallback;
			_003CModule_003E.TarCallback_002E_007Bctor_007D((TarCallback*)(&tarCallback));
			try
			{
				*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &tarCallback;
					*(int*)(&Unsafe.AddByteOffset(ref tarCallback, 4)) = m_myHashCode;
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(tarFilename, &xString);
					result = _003CModule_003E.ClsTar_002EUntarBz2(m_impl, &xString, (ProgressEvent*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_TarCallback_002E_007Bdtor_007D), &tarCallback);
				throw;
			}
			*(int*)(&tarCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_TarCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.TarCallback_002E_007Bdtor_007D((TarCallback*)(&tarCallback));
			return result;
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		protected void raise_OnPercentDone(object i1, PercentDoneEventArgs i2)
		{
			this.OnPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnNextTarFile(object i1, NextTarFileEventArgs i2)
		{
			this.OnNextTarFile?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
