using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class ToBeAddedEventArgs : EventArgs
	{
		private string m_fileName;

		private uint m_fileSize;

		private bool m_exclude;

		public bool Exclude
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_exclude;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				m_exclude = value;
			}
		}

		public uint FileSize => m_fileSize;

		public string FileName => m_fileName;

		public unsafe ToBeAddedEventArgs(sbyte* fileName, uint fileSize)
		{
			m_fileSize = fileSize;
			m_exclude = false;
			m_fileName = CkMarshal.Utf8ToString(fileName);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
