using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class ToBeUnzippedEventArgs : EventArgs
	{
		private string m_fileName;

		private uint m_compressedSize;

		private uint m_fileSize;

		private bool m_isDirectory;

		private bool m_exclude;

		public bool Exclude
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_exclude;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				m_exclude = value;
			}
		}

		public bool IsDirectory
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_isDirectory;
			}
		}

		public uint FileSize => m_fileSize;

		public uint CompressedSize => m_compressedSize;

		public string FileName => m_fileName;

		public unsafe ToBeUnzippedEventArgs(sbyte* fileName, uint compressedSize, uint fileSize, [MarshalAs(UnmanagedType.U1)] bool isDirectory)
		{
			m_compressedSize = compressedSize;
			m_fileSize = fileSize;
			m_isDirectory = isDirectory;
			m_exclude = false;
			m_fileName = CkMarshal.Utf8ToString(fileName);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
