using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Text;

namespace Chilkat
{
	public class Xmp : IDisposable
	{
		private bool m_structInnerDescrip;

		private string m_errorInfo;

		private unsafe ClsXmp* m_impl;

		private Xml[] m_xml;

		public bool StructInnerDescrip
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_structInnerDescrip;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				m_structInnerDescrip = value;
			}
		}

		public unsafe int NumEmbedded => _003CModule_003E.ClsXmp_002Eget_NumEmbedded(m_impl);

		public unsafe string Version
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsXmp_002Eget_Version(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetHtmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetXmlLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ClsBase_002EGetTextLogX((ClsBase*)m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public string ErrorInfo => m_errorInfo;

		private unsafe Xml findDescrip(Xml xml, string ns)
		{
			Xml root = xml.GetRoot();
			string text = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_06PNFLLAEF_0040xmlns_003F3_003F_0024AA_0040)) + ns;
			if (!root.FirstChild2())
			{
				m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BN_0040INKMLCCE_0040Failed_003F5to_003F5find_003F51st_003F5child_003F5_003F_0024CI1_003F_0024CJ_003F_0024AA_0040));
				return null;
			}
			if (!root.FirstChild2())
			{
				m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BN_0040IPOKAMHN_0040Failed_003F5to_003F5find_003F51st_003F5child_003F5_003F_0024CI2_003F_0024CJ_003F_0024AA_0040));
				return null;
			}
			do
			{
				if (root.HasAttribute(text))
				{
					return root;
				}
			}
			while (root.NextSibling2());
			m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0CE_0040ODLAADHN_0040Failed_003F5to_003F5find_003F5matching_003F5attribut_0040)) + text;
			return null;
		}

		private unsafe Xml addDescrip(Xml xml, string ns)
		{
			Xml root = xml.GetRoot();
			string name = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_06PNFLLAEF_0040xmlns_003F3_003F_0024AA_0040)) + ns;
			if (!root.FirstChild2())
			{
				m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BO_0040GEBALPA_0040Failed_003F5to_003F5find_003F51st_003F5child_003F5_003F_0024CI1a_003F_0024CJ_003F_0024AA_0040));
				return null;
			}
			Xml xml2 = root.NewChild(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040KJHPNOGB_0040rdf_003F3Description_003F_0024AA_0040)), new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040)));
			if (xml2 == null)
			{
				m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BO_0040HAGNBEJI_0040Failed_003F5to_003F5add_003F5rdf_003F3Description_003F_0024AA_0040));
				return null;
			}
			string text = getAbout(xml);
			if (text == null)
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					_003CModule_003E.ClsXmp_002EGenerateAboutUuid(&xString);
					text = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
			xml2.AddAttribute(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09KPKHEIGK_0040rdf_003F3about_003F_0024AA_0040)), text);
			XString xString2;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
			try
			{
				XString xString3;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
				try
				{
					CkMarshal.StringToX(ns, &xString2);
					_003CModule_003E.ClsXmp_002EGetNamespaceURIX(m_impl, &xString2, &xString3);
					string value = CkMarshal.XToString(&xString3);
					xml2.AddAttribute(name, value);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			return xml2;
		}

		private unsafe void getNamespace(XString* xProperty, XString* xNamespace)
		{
			_003CModule_003E.XString_002Eclear(xNamespace);
			_003CModule_003E.XString_002EappendUtf8(xNamespace, _003CModule_003E.XString_002EgetUtf8(xProperty));
			_003CModule_003E.XString_002EchopAtFirstChar(xNamespace, 58);
		}

		private unsafe string getAbout(Xml xml)
		{
			Xml root = xml.GetRoot();
			if (!root.FirstChild2())
			{
				m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BO_0040EAHLFKJ_0040Failed_003F5to_003F5find_003F51st_003F5child_003F5_003F_0024CI1b_003F_0024CJ_003F_0024AA_0040));
				return null;
			}
			if (!root.FirstChild2())
			{
				m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BO_0040BGLCBKEH_0040Failed_003F5to_003F5find_003F51st_003F5child_003F5_003F_0024CI2b_003F_0024CJ_003F_0024AA_0040));
				return null;
			}
			string attrValue = root.GetAttrValue(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09KPKHEIGK_0040rdf_003F3about_003F_0024AA_0040)));
			if (attrValue != null && attrValue.Length > 0)
			{
				return attrValue;
			}
			attrValue = root.GetAttrValue(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_05BEELFHJC_0040about_003F_0024AA_0040)));
			if (attrValue != null && attrValue.Length > 0)
			{
				return attrValue;
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_003CModule_003E.ClsXmp_002EGenerateAboutUuid(&xString);
				result = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		private StringArray buildArray(Xml xml)
		{
			StringArray stringArray = new StringArray();
			int numChildren = xml.NumChildren;
			int num = 0;
			if (0 < numChildren)
			{
				do
				{
					stringArray.Append(xml.GetChildContentByIndex(num));
					num++;
				}
				while (num < numChildren);
			}
			return stringArray;
		}

		public unsafe Xmp(void* impl)
		{
			m_impl = (ClsXmp*)impl;
		}

		public unsafe Xmp()
		{
			m_structInnerDescrip = true;
			ClsXmp* ptr = (ClsXmp*)_003CModule_003E.@new(1640u);
			ClsXmp* impl;
			try
			{
				impl = (ClsXmp*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.ClsXmp_002E_007Bctor_007D(ptr)));
			}
			catch
			{
				//try-fault
				_003CModule_003E.delete(ptr);
				throw;
			}
			m_impl = impl;
			Xml[] array = m_xml = new Xml[256];
			int num = 0;
			do
			{
				array[num] = null;
				num++;
			}
			while (num < 256);
			m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040));
		}

		protected unsafe override void Finalize()
		{
			ClsXmp* impl = m_impl;
			if (impl != null)
			{
				ClsXmp* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			int num = 0;
			do
			{
				m_xml[num] = null;
				num++;
			}
			while (num < 256);
		}

		public override void Dispose()
		{
		}

		public unsafe string GetNamespace(string propName)
		{
			m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040));
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe Xml FindDescrip(Xml xml, string nmSpace)
		{
			m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040));
			return findDescrip(xml, nmSpace);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsBase_002ESaveXmlLogX((ClsBase*)m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string b1)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(b1, &xString);
				result = _003CModule_003E.ClsXmp_002EUnlockComponent(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadAppFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ClsXmp_002ELoadAppFile(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveAppFile(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool flag;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				int num = 0;
				do
				{
					Xml[] xml = m_xml;
					if (xml[num] != null)
					{
						string xml2 = xml[num].GetXml();
						XString xString2;
						_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
						try
						{
							CkMarshal.StringToX(xml2, &xString2);
							_003CModule_003E.ClsXmp_002EReplaceXml(m_impl, num, &xString2);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
					}
					num++;
				}
				while (num < 256);
				flag = _003CModule_003E.ClsXmp_002ESaveAppFile(m_impl, &xString);
				if (flag)
				{
					_003CModule_003E.ClsXmp_002EClear(m_impl);
					flag = _003CModule_003E.ClsXmp_002EReloadAppFile(m_impl, &xString);
				}
				int num2 = 0;
				do
				{
					m_xml[num2] = null;
					num2++;
				}
				while (num2 < 256);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return flag;
		}

		public unsafe Xml GetEmbedded(int index)
		{
			if ((uint)index <= 255u)
			{
				Xml[] xml = m_xml;
				if (xml[index] != null)
				{
					return xml[index];
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				Xml xml2;
				try
				{
					_003CModule_003E.ClsXmp_002EGetEmbedded2(m_impl, index, &xString);
					xml2 = new Xml();
					string xmlData = CkMarshal.XToString(&xString);
					xml2.LoadXml(xmlData);
					m_xml[index] = xml2;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return xml2;
			}
			return null;
		}

		public unsafe string GetSimpleStr(Xml xml, string propName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			string result;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 == null)
					{
						result = null;
						goto IL_005e;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_005e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0075;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string text;
			try
			{
				try
				{
					text = xml2.GetChildContent(propName);
					if (text == null || text.Length == 0)
					{
						text = xml2.GetAttrValue(propName);
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return text;
			IL_0075:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int GetSimpleInt(Xml xml, string propName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 != null)
					{
						goto IL_007c;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return 0;
			IL_00cd:
			string text;
			int result;
			try
			{
				try
				{
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(text, &xString3);
						result = _003CModule_003E.XString_002EintValue(&xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
			IL_007c:
			try
			{
				try
				{
					text = xml2.GetChildContent(propName);
					if (text == null || text.Length == 0)
					{
						text = xml2.GetAttrValue(propName);
					}
					if (text != null)
					{
						goto IL_00cd;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return 0;
		}

		public unsafe DateTime GetSimpleDate(Xml xml, string propName)
		{
			//Discarded unreachable code: IL_0195
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			DateTime now;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 == null)
					{
						now = DateTime.Now;
						goto IL_006e;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0011;
				IL_006e:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0085;
				end_IL_0011:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string text;
			DateTime now2;
			try
			{
				try
				{
					text = xml2.GetChildContent(propName);
					if (text == null || text.Length == 0)
					{
						text = xml2.GetAttrValue(propName);
					}
					if (text == null)
					{
						now2 = DateTime.Now;
						goto IL_00c7;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0090;
				IL_00c7:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00de;
				end_IL_0090:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			DateTime result;
			try
			{
				try
				{
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(text, &xString3);
						ChilkatSysTime chilkatSysTime;
						_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
						_003CModule_003E.XString_002EgetSystemTime(&xString3, &chilkatSysTime);
						result = default(DateTime);
						try
						{
							DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
							result = dateTime;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									result = DateTime.Now;
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_0183;
								}
								goto end_IL_0169;
								IL_0183:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_0169:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
			IL_0085:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return now;
			IL_00de:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return now2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddSimpleStr(Xml xml, string propName, string propVal)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			Xml xml2;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(propVal, &xString3);
						xml2 = findDescrip(xml, ns);
						if (xml2 == null)
						{
							xml2 = addDescrip(xml, ns);
							if (xml2 == null)
							{
								goto IL_007a;
							}
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_007a:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0091;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0091:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00a8;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			try
			{
				try
				{
					try
					{
						if (xml2.HasAttribute(propName))
						{
							xml2.UpdateAttribute(propName, propVal);
						}
						else
						{
							xml2.UpdateChildContent(propName, propVal);
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_00a8:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return false;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddSimpleInt(Xml xml, string propName, int propVal)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 == null)
					{
						xml2 = addDescrip(xml, ns);
						if (xml2 == null)
						{
							goto IL_006a;
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_006a:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0081;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			try
			{
				try
				{
					if (xml2.HasAttribute(propName))
					{
						xml2.UpdateAttributeInt(propName, propVal);
					}
					else
					{
						xml2.UpdateChildContentInt(propName, propVal);
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_0081:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return false;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool AddSimpleDate(Xml xml, string propName, DateTime propVal)
		{
			string propVal2 = DateToString(propVal);
			return AddSimpleStr(xml, propName, propVal2);
		}

		public unsafe void AddNsMapping(string ns, string uri)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(ns, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(uri, &xString2);
					_003CModule_003E.ClsXmp_002EAddNsMapping(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void RemoveNsMapping(string ns)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(ns, &xString);
				_003CModule_003E.ClsXmp_002ERemoveNsMapping(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe Xml NewXmp()
		{
			string xmlData = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0KD_0040DNHINBFK_0040_003F_0024DM_003F_0024DPxml_003F5version_003F_0024DN_003F_0024CC1_003F40_003F_0024CC_003F5encoding_003F_0024DN_003F_0024CCut_0040));
			Xml xml = new Xml();
			xml.LoadXml(xmlData);
			return xml;
		}

		public unsafe DateTime StringToDate(string str)
		{
			//Discarded unreachable code: IL_00b1
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DateTime result;
			try
			{
				CkMarshal.StringToX(str, &xString);
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				_003CModule_003E.XString_002EgetSystemTime(&xString, &chilkatSysTime);
				result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00a0;
						}
						goto end_IL_0086;
						IL_00a0:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0086:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string DateToString(DateTime dt)
		{
			ChilkatSysTime chilkatSysTime;
			_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
			*(short*)(&chilkatSysTime) = (short)dt.Year;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)dt.Month;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)dt.Day;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)dt.Hour;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)dt.Minute;
			*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)dt.Second;
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_003CModule_003E.XString_002EloadSystemTime(&xString, &chilkatSysTime);
				result = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveSimple(Xml xml, string propName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 != null)
					{
						goto IL_007c;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_007c:
			try
			{
				try
				{
					Xml childWithTag = xml2.GetChildWithTag(propName);
					if (childWithTag != null)
					{
						childWithTag.RemoveFromTree();
						if (xml2.NumChildren == 0)
						{
							xml2.RemoveFromTree();
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Append(Xml xml)
		{
			int num = _003CModule_003E.ClsXmp_002Eget_NumEmbeddedInFile(m_impl);
			Xml[] xml2 = m_xml;
			if (xml2[num] != null)
			{
				while (num < 256)
				{
					num++;
					if (xml2[num] == null)
					{
						break;
					}
				}
			}
			if (num == 256)
			{
				return false;
			}
			xml2[num] = xml;
			return true;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveAllEmbedded()
		{
			_003CModule_003E.ClsXmp_002ERemoveAllEmbedded(m_impl);
			return true;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveEmbedded(int index)
		{
			_003CModule_003E.ClsXmp_002ERemoveEmbedded(m_impl, index);
			return true;
		}

		public unsafe StringArray GetArray(Xml xml, string propName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			StringArray result;
			try
			{
				CkMarshal.StringToX(propName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 == null)
					{
						result = null;
						goto IL_0061;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0061:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0078;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Xml childWithTag;
			StringArray result2;
			try
			{
				try
				{
					childWithTag = xml2.GetChildWithTag(propName);
					if (childWithTag == null)
					{
						m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BB_0040OHMPMNDK_0040Array_003F5not_003F5found_003F4_003F_0024AA_0040));
						result2 = null;
						goto IL_00b3;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0083;
				IL_00b3:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00ca;
				end_IL_0083:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			StringArray result3;
			try
			{
				try
				{
					if (!childWithTag.FirstChild2())
					{
						m_errorInfo = new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BD_0040MELMIFK_0040Array_003F5not_003F5found_003F52_003F4_003F_0024AA_0040));
						result3 = null;
						goto IL_0101;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_00d5;
				IL_0101:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0118;
				end_IL_00d5:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			StringArray result4;
			try
			{
				try
				{
					result4 = buildArray(childWithTag);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result4;
			IL_0078:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
			IL_0118:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result3;
			IL_00ca:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool RemoveArray(Xml xml, string propName)
		{
			return RemoveSimple(xml, propName);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddArray(Xml xml, string arrType, string propName, StringArray values)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			Xml xml2;
			try
			{
				CkMarshal.StringToX(arrType, &xString);
				_003CModule_003E.XString_002EtoLowerCase(&xString);
				if (_003CModule_003E.XString_002EbeginsWithUtf8(&xString, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_04GHHILCPC_0040rdf_003F3_003F_0024AA_0040)))
				{
					_003CModule_003E.XString_002EreplaceFirstOccuranceUtf8(&xString, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_04GHHILCPC_0040rdf_003F3_003F_0024AA_0040), (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040));
				}
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(propName, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						_003CModule_003E.XString_002Eclear(&xString3);
						_003CModule_003E.XString_002EappendUtf8(&xString3, _003CModule_003E.XString_002EgetUtf8(&xString2));
						_003CModule_003E.XString_002EchopAtFirstChar(&xString3, 58);
						string ns = CkMarshal.XToString(&xString3);
						xml2 = findDescrip(xml, ns);
						if (xml2 == null)
						{
							xml2 = addDescrip(xml, ns);
							if (xml2 == null)
							{
								goto IL_00a4;
							}
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_003f;
					IL_00a4:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_00bb;
					end_IL_003f:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_00bb:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00d2;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			try
			{
				try
				{
					try
					{
						xml2.GetChildWithTag(propName)?.RemoveFromTree();
						StringBuilder stringBuilder = new StringBuilder();
						stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_01MNNFJEPP_0040_003F_0024DM_003F_0024AA_0040)));
						stringBuilder.Append(propName);
						stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_01PPODPGHN_0040_003F_0024DO_003F_0024AA_0040)));
						if (_003CModule_003E.XString_002EequalsUtf8(&xString, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_03CMDNEDBM_0040bag_003F_0024AA_0040)))
						{
							stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09EDNLAKO_0040_003F_0024DMrdf_003F3Bag_003F_0024DO_003F_0024AA_0040)));
						}
						else if (_003CModule_003E.XString_002EequalsUtf8(&xString, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_03NPAJGOON_0040seq_003F_0024AA_0040)))
						{
							stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09MOHEEGAJ_0040_003F_0024DMrdf_003F3Seq_003F_0024DO_003F_0024AA_0040)));
						}
						else
						{
							stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09KPJHAPIK_0040_003F_0024DMrdf_003F3Alt_003F_0024DO_003F_0024AA_0040)));
						}
						int count = values.Count;
						int num = 0;
						if (0 < count)
						{
							do
							{
								stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08CHAMJIF_0040_003F_0024DMrdf_003F3li_003F_0024DO_003F_0024AA_0040)));
								stringBuilder.Append(values.GetString(num));
								stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09OAHBKJFP_0040_003F_0024DM_003F1rdf_003F3li_003F_0024DO_003F_0024AA_0040)));
								num++;
							}
							while (num < count);
						}
						if (_003CModule_003E.XString_002EequalsUtf8(&xString, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_03CMDNEDBM_0040bag_003F_0024AA_0040)))
						{
							stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0L_0040GCNJIKAE_0040_003F_0024DM_003F1rdf_003F3Bag_003F_0024DO_003F_0024AA_0040)));
						}
						else if (_003CModule_003E.XString_002EequalsUtf8(&xString, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_03NPAJGOON_0040seq_003F_0024AA_0040)))
						{
							stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0L_0040KIJAHMKD_0040_003F_0024DM_003F1rdf_003F3Seq_003F_0024DO_003F_0024AA_0040)));
						}
						else
						{
							stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0L_0040MJHDDFCA_0040_003F_0024DM_003F1rdf_003F3Alt_003F_0024DO_003F_0024AA_0040)));
						}
						stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_02DPNDACHE_0040_003F_0024DM_003F1_003F_0024AA_0040)));
						stringBuilder.Append(propName);
						stringBuilder.Append(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_01PPODPGHN_0040_003F_0024DO_003F_0024AA_0040)));
						Xml xml3 = new Xml();
						xml3.LoadXml(stringBuilder.ToString());
						xml2.AddChildTree(xml3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_00d2:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return false;
		}

		public unsafe string GetStructValue(Xml xml, string structName, string propName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			Xml xml2;
			string result;
			try
			{
				CkMarshal.StringToX(structName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(propName, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						_003CModule_003E.XString_002Eclear(&xString3);
						_003CModule_003E.XString_002EappendUtf8(&xString3, _003CModule_003E.XString_002EgetUtf8(&xString));
						_003CModule_003E.XString_002EchopAtFirstChar(&xString3, 58);
						string ns = CkMarshal.XToString(&xString3);
						xml2 = findDescrip(xml, ns);
						if (xml2 == null)
						{
							result = null;
							goto IL_0071;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0018;
					IL_0071:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0088;
					end_IL_0018:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0088:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_009f;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Xml childWithTag;
			string result2;
			try
			{
				try
				{
					try
					{
						childWithTag = xml2.GetChildWithTag(structName);
						if (childWithTag == null)
						{
							result2 = null;
							goto IL_00ca;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_00aa;
					IL_00ca:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_00e1;
					end_IL_00aa:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_00aa;
				IL_00e1:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00f8;
				end_IL_00aa:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string childContent;
			try
			{
				try
				{
					try
					{
						if (childWithTag.NumChildren == 1 && childWithTag.HasChildWithTag(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040KJHPNOGB_0040rdf_003F3Description_003F_0024AA_0040))))
						{
							Xml xml3 = childWithTag.FirstChild();
							if (xml3 == null)
							{
								goto IL_0185;
							}
							childContent = xml3.GetChildContent(propName);
							goto IL_014d;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_0103;
					IL_014d:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0164;
					end_IL_0103:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0103;
				IL_0164:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_017b;
				end_IL_0103:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			string childContent2;
			try
			{
				try
				{
					try
					{
						childContent2 = childWithTag.GetChildContent(propName);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return childContent2;
			IL_009f:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
			IL_017b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return childContent;
			IL_00f8:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0185:
			string result3;
			try
			{
				try
				{
					try
					{
						result3 = null;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result3;
		}

		public unsafe StringArray GetStructPropNames(Xml xml, string structName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			StringArray result;
			try
			{
				CkMarshal.StringToX(structName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 == null)
					{
						result = null;
						goto IL_0063;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_0063:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_007a;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Xml xml3;
			StringArray result2;
			try
			{
				try
				{
					xml3 = xml2.GetChildWithTag(structName);
					if (xml3 == null)
					{
						result2 = null;
						goto IL_00a6;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0085;
				IL_00a6:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_00bd;
				end_IL_0085:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			StringArray stringArray;
			try
			{
				try
				{
					if (xml3.NumChildren == 1 && xml3.HasChildWithTag(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040KJHPNOGB_0040rdf_003F3Description_003F_0024AA_0040))))
					{
						Xml xml4 = xml3.FirstChild();
						if (xml4 != null)
						{
							xml3 = xml4;
						}
					}
					stringArray = new StringArray();
					int numChildren = xml3.NumChildren;
					int num = 0;
					if (0 < numChildren)
					{
						do
						{
							stringArray.Append(xml3.GetChildTagByIndex(num));
							num++;
						}
						while (num < numChildren);
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return stringArray;
			IL_007a:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
			IL_00bd:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool RemoveStruct(Xml xml, string structName)
		{
			return RemoveSimple(xml, structName);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveStructProp(Xml xml, string structName, string propName)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			try
			{
				CkMarshal.StringToX(structName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 != null)
					{
						goto IL_007c;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_00ba:
			Xml xml3;
			try
			{
				try
				{
					if (xml3.NumChildren == 1 && xml3.HasChildWithTag(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040KJHPNOGB_0040rdf_003F3Description_003F_0024AA_0040))))
					{
						Xml xml4 = xml3.FirstChild();
						if (xml4 != null)
						{
							xml3 = xml4;
						}
					}
					xml3?.RemoveChild(propName);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_007c:
			try
			{
				try
				{
					xml3 = xml2.GetChildWithTag(structName);
					if (xml3 != null)
					{
						goto IL_00ba;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddStructProp(Xml xml, string structName, string propName, string propVal)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			Xml xml2;
			try
			{
				CkMarshal.StringToX(structName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.XString_002Eclear(&xString2);
					_003CModule_003E.XString_002EappendUtf8(&xString2, _003CModule_003E.XString_002EgetUtf8(&xString));
					_003CModule_003E.XString_002EchopAtFirstChar(&xString2, 58);
					string ns = CkMarshal.XToString(&xString2);
					xml2 = findDescrip(xml, ns);
					if (xml2 == null)
					{
						xml2 = addDescrip(xml, ns);
						if (xml2 == null)
						{
							goto IL_006a;
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_0008;
				IL_006a:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0081;
				end_IL_0008:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			Xml xml3;
			try
			{
				try
				{
					xml3 = xml2.GetChildWithTag(structName);
					if (xml3 == null)
					{
						if (!m_structInnerDescrip)
						{
							goto IL_0109;
						}
						xml3 = xml2.NewChild(structName, new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040)));
						xml3.NewChild(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040KJHPNOGB_0040rdf_003F3Description_003F_0024AA_0040)), new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040))).NewChild2(propName, propVal);
						goto IL_00e9;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_008b;
				IL_00e9:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0100;
				end_IL_008b:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			try
			{
				try
				{
					if (xml3.NumChildren == 1 && xml3.HasChildWithTag(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040KJHPNOGB_0040rdf_003F3Description_003F_0024AA_0040))))
					{
						Xml xml4 = xml3.FirstChild();
						if (xml4 != null)
						{
							xml3 = xml4;
						}
					}
					xml3?.UpdateChildContent(propName, propVal);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_0081:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return false;
			IL_0109:
			try
			{
				try
				{
					xml3 = xml2.NewChild(structName, new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_00CNPNBAHC_0040_003F_0024AA_0040)));
					xml3.AddAttribute(new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040KHOHDIAK_0040rdf_003F3parseType_003F_0024AA_0040)), new string((sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08FLGELGHE_0040Resource_003F_0024AA_0040)));
					xml3.NewChild2(propName, propVal);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
			IL_0100:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return true;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadFromBuffer(byte[] data, string ext)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(ext, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(data, &num);
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					result = _003CModule_003E.ClsXmp_002ELoadFromBuffer(m_impl, &dataBuffer, &xString);
					CkMarshal.free(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] SaveToBuffer()
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				int num = 0;
				do
				{
					Xml[] xml = m_xml;
					if (xml[num] != null)
					{
						string xml2 = xml[num].GetXml();
						XString xString;
						_003CModule_003E.XString_002E_007Bctor_007D(&xString);
						try
						{
							CkMarshal.StringToX(xml2, &xString);
							_003CModule_003E.ClsXmp_002EReplaceXml(m_impl, num, &xString);
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
							throw;
						}
						_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
					}
					num++;
				}
				while (num < 256);
				_003CModule_003E.ClsXmp_002ESaveToBuffer(m_impl, &dataBuffer);
				int num2 = 0;
				do
				{
					m_xml[num2] = null;
					num2++;
				}
				while (num2 < 256);
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
