using chilkat;
using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Zip : IDisposable
	{
		public delegate void WriteZipPercentDoneEventHandler(object sender, WriteZipPercentDoneEventArgs args);

		public delegate void UnzipPercentDoneEventHandler(object sender, UnzipPercentDoneEventArgs args);

		public delegate void ToBeAddedEventHandler(object sender, ToBeAddedEventArgs args);

		public delegate void DirToBeAddedEventHandler(object sender, DirToBeAddedEventArgs args);

		public delegate void FileAddedEventHandler(object sender, FileAddedEventArgs args);

		public delegate void ToBeZippedEventHandler(object sender, ToBeZippedEventArgs args);

		public delegate void FileZippedEventHandler(object sender, FileZippedEventArgs args);

		public delegate void ToBeUnzippedEventHandler(object sender, ToBeUnzippedEventArgs args);

		public delegate void FileUnzippedEventHandler(object sender, FileUnzippedEventArgs args);

		public delegate void AddFilesBeginEventHandler(object sender, EventArgs args);

		public delegate void AddFilesEndEventHandler(object sender, EventArgs args);

		public delegate void WriteZipBeginEventHandler(object sender, EventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void WriteZipEndEventHandler(object sender, EventArgs args);

		public delegate void UnzipBeginEventHandler(object sender, EventArgs args);

		public delegate void UnzipEndEventHandler(object sender, EventArgs args);

		private static Hashtable m_zipObjects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private object m_lockImpl;

		private unsafe ZipDn* m_impl;

		public unsafe bool ClearReadOnlyAttr
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ZipDn_002Eget_ClearReadOnlyAttr(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ZipDn_002Eput_ClearReadOnlyAttr(m_impl, value);
			}
		}

		public unsafe bool IgnoreAccessDenied
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ZipDn_002Eget_IgnoreAccessDenied(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ZipDn_002Eput_IgnoreAccessDenied(m_impl, value);
			}
		}

		public unsafe bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ZipDn_002Eget_VerboseLogging(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ZipDn_002Eput_VerboseLogging(m_impl, value);
			}
		}

		public unsafe bool OverwriteExisting
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ZipDn_002Eget_OverwriteExisting(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ZipDn_002Eput_OverwriteExisting(m_impl, value);
			}
		}

		public unsafe bool CaseSensitive
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_CaseSensitive(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_CaseSensitive(m_impl, value);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				object obj = null;
				object obj2 = null;
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				if (value == m_enableEvents)
				{
					return;
				}
				Monitor.Enter(m_lockObject);
				if (value)
				{
					if (m_zipObjects == null)
					{
						m_zipObjects = new Hashtable();
					}
					try
					{
						obj = m_myHashCode;
						m_zipObjects.Add(obj, this);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								obj2 = m_myHashCode;
								m_zipObjects = new Hashtable();
								m_zipObjects.Add(obj2, this);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00b0;
							}
							goto end_IL_007a;
							IL_00b0:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_007a:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				else
				{
					m_zipObjects.Remove(this);
				}
				m_enableEvents = value;
				Monitor.Exit(m_lockObject);
			}
		}

		public unsafe string ExeXmlConfig
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_ExeXmlConfig(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_ExeXmlConfig(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ExeSourceUrl
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_ExeSourceUrl(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_ExeSourceUrl(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ExeDefaultDir
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_ExeDefaultDir(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_ExeDefaultDir(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool ExeFinishNotifier
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_ExeFinishNotifier(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_ExeFinishNotifier(m_impl, value);
			}
		}

		public unsafe bool ExeSilentProgress
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_ExeSilentProgress(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_ExeSilentProgress(m_impl, value);
			}
		}

		public unsafe bool ExeWaitForSetup
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_ExeWaitForSetup(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_ExeWaitForSetup(m_impl, value);
			}
		}

		public unsafe bool ExeNoInterface
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_ExeNoInterface(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_ExeNoInterface(m_impl, value);
			}
		}

		public unsafe string AutoRunParams
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_AutoRunParams(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_AutoRunParams(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ExeIconFile
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_ExeIconFile(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_ExeIconFile(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ExeUnzipCaption
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_ExeUnzipCaption(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_ExeUnzipCaption(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ExeTitle
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_ExeTitle(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_ExeTitle(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string ExeUnzipDir
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_ExeUnzipDir(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_ExeUnzipDir(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string AutoRun
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_AutoRun(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_AutoRun(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string PathPrefix
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_PathPrefix(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_PathPrefix(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe bool DiscardPaths
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_DiscardPaths(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_DiscardPaths(m_impl, value);
			}
		}

		public unsafe bool TextFlag
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_TextFlag(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_TextFlag(m_impl, value);
			}
		}

		public unsafe bool ClearArchiveAttribute
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_ClearArchiveAttribute(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_ClearArchiveAttribute(m_impl, value);
			}
		}

		public unsafe bool AutoTemp
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_AutoTemp(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_AutoTemp(m_impl, value);
			}
		}

		public unsafe string Proxy
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_Proxy(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_Proxy(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Comment
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_Comment(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_Comment(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string FileName
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_FileName(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_FileName(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe int FileCount
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_FileCount(m_impl);
			}
		}

		public unsafe int NumEntries
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_NumEntries(m_impl);
			}
		}

		public unsafe string EncryptPassword
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_EncryptPassword(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_EncryptPassword(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string DecryptPassword
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_DecryptPassword(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_DecryptPassword(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string AppendFromDir
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_AppendFromDir(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_AppendFromDir(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string TempDir
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_TempDir(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipDn_002Eput_TempDir(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string Version
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				StringBuffer stringBuffer;
				_003CModule_003E.chilkat_002EStringBuffer_002E_007Bctor_007D(&stringBuffer);
				string result;
				try
				{
					_003CModule_003E.ZipDn_002Eget_Version(m_impl, &stringBuffer);
					result = CkMarshal.AnsiToString(_003CModule_003E.chilkat_002EStringBuffer_002EgetString(&stringBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
					throw;
				}
				_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
				return result;
			}
		}

		public unsafe int OemCodePage
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_OemCodePage(m_impl);
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_OemCodePage(m_impl, value);
			}
		}

		public unsafe int EncryptKeyLength
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_EncryptKeyLength(m_impl);
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_EncryptKeyLength(m_impl, value);
			}
		}

		public unsafe int Encryption
		{
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_Encryption(m_impl);
			}
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_Encryption(m_impl, value);
			}
		}

		public unsafe bool HasZipFormatErrors
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_HasZipFormatErrors(m_impl);
			}
		}

		public unsafe bool PasswordProtect
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				return _003CModule_003E.ZipDn_002Eget_PasswordProtect(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_003CModule_003E.ZipDn_002Eput_PasswordProtect(m_impl, value);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString* ptr = (XString*)_003CModule_003E.@new(136u);
				XString* ptr2;
				try
				{
					ptr2 = (XString*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.XString_002E_007Bctor_007D(ptr)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				ZipDn* impl = m_impl;
				if (impl != null)
				{
					_003CModule_003E.ZipDn_002EGetLogHtml(impl, ptr2, true);
				}
				string result = CkMarshal.XToString(ptr2);
				if (ptr2 != null)
				{
					((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
				}
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString* ptr = (XString*)_003CModule_003E.@new(136u);
				XString* ptr2;
				try
				{
					ptr2 = (XString*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.XString_002E_007Bctor_007D(ptr)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				ZipDn* impl = m_impl;
				if (impl != null)
				{
					_003CModule_003E.ZipDn_002EGetLogXml(impl, ptr2, true);
				}
				string result = CkMarshal.XToString(ptr2);
				if (ptr2 != null)
				{
					((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
				}
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString* ptr = (XString*)_003CModule_003E.@new(136u);
				XString* ptr2;
				try
				{
					ptr2 = (XString*)(long)((ptr == null) ? ((IntPtr)0) : ((IntPtr)_003CModule_003E.XString_002E_007Bctor_007D(ptr)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.delete(ptr);
					throw;
				}
				ZipDn* impl = m_impl;
				if (impl != null)
				{
					_003CModule_003E.ZipDn_002EGetLogText(impl, ptr2, true);
				}
				string result = CkMarshal.XToString(ptr2);
				if (ptr2 != null)
				{
					((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr2)))((IntPtr)ptr2, 1u);
				}
				return result;
			}
		}

		public event UnzipEndEventHandler OnUnzipEnd;

		public event UnzipBeginEventHandler OnUnzipBegin;

		public event WriteZipEndEventHandler OnWriteZipEnd;

		public event AbortCheckEventHandler OnAbortCheck;

		public event WriteZipBeginEventHandler OnWriteZipBegin;

		public event AddFilesEndEventHandler OnAddFilesEnd;

		public event AddFilesBeginEventHandler OnAddFilesBegin;

		public event FileUnzippedEventHandler OnFileUnzipped;

		public event ToBeUnzippedEventHandler OnToBeUnzipped;

		public event FileZippedEventHandler OnFileZipped;

		public event ToBeZippedEventHandler OnToBeZipped;

		public event FileAddedEventHandler OnFileAdded;

		public event DirToBeAddedEventHandler OnDirToBeAdded;

		public event ToBeAddedEventHandler OnToBeAdded;

		public event UnzipPercentDoneEventHandler OnUnzipPercentDone;

		public event WriteZipPercentDoneEventHandler OnWriteZipPercentDone;

		private unsafe void checkCreateImpl()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
		}

		public int GetMyHashCode()
		{
			return m_myHashCode;
		}

		public static Zip LookupZip(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(m_lockObject);
			Zip result = (Zip)m_zipObjects[key];
			Monitor.Exit(m_lockObject);
			return result;
		}

		public void FireWriteZipPercentDone(object sender, WriteZipPercentDoneEventArgs args)
		{
			this.OnWriteZipPercentDone?.Invoke(sender, args);
		}

		public void FireUnzipPercentDone(object sender, UnzipPercentDoneEventArgs args)
		{
			this.OnUnzipPercentDone?.Invoke(sender, args);
		}

		public void FireToBeAdded(object sender, ToBeAddedEventArgs args)
		{
			this.OnToBeAdded?.Invoke(sender, args);
		}

		public void FireDirToBeAdded(object sender, DirToBeAddedEventArgs args)
		{
			this.OnDirToBeAdded?.Invoke(sender, args);
		}

		public void FireFileAdded(object sender, FileAddedEventArgs args)
		{
			this.OnFileAdded?.Invoke(sender, args);
		}

		public void FireToBeZipped(object sender, ToBeZippedEventArgs args)
		{
			this.OnToBeZipped?.Invoke(sender, args);
		}

		public void FireFileZipped(object sender, FileZippedEventArgs args)
		{
			this.OnFileZipped?.Invoke(sender, args);
		}

		public void FireToBeUnzipped(object sender, ToBeUnzippedEventArgs args)
		{
			this.OnToBeUnzipped?.Invoke(sender, args);
		}

		public void FireFileUnzipped(object sender, FileUnzippedEventArgs args)
		{
			this.OnFileUnzipped?.Invoke(sender, args);
		}

		public void FireAddFilesBegin(object sender, EventArgs args)
		{
			this.OnAddFilesBegin?.Invoke(sender, args);
		}

		public void FireAddFilesEnd(object sender, EventArgs args)
		{
			this.OnAddFilesEnd?.Invoke(sender, args);
		}

		public void FireWriteZipBegin(object sender, EventArgs args)
		{
			this.OnWriteZipBegin?.Invoke(sender, args);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			this.OnAbortCheck?.Invoke(sender, args);
		}

		public void FireWriteZipEnd(object sender, EventArgs args)
		{
			this.OnWriteZipEnd?.Invoke(sender, args);
		}

		public void FireUnzipBegin(object sender, EventArgs args)
		{
			this.OnUnzipBegin?.Invoke(sender, args);
		}

		public void FireUnzipEnd(object sender, EventArgs args)
		{
			this.OnUnzipEnd?.Invoke(sender, args);
		}

		public unsafe Zip(void* impl)
		{
			m_enableEvents = false;
			m_impl = (ZipDn*)impl;
			this.OnWriteZipPercentDone = null;
			this.OnUnzipPercentDone = null;
			this.OnToBeAdded = null;
			this.OnDirToBeAdded = null;
			this.OnFileAdded = null;
			this.OnToBeZipped = null;
			this.OnFileZipped = null;
			this.OnToBeUnzipped = null;
			this.OnFileUnzipped = null;
			this.OnAddFilesBegin = null;
			this.OnAddFilesEnd = null;
			this.OnWriteZipBegin = null;
			this.OnAbortCheck = null;
			this.OnWriteZipEnd = null;
			this.OnUnzipBegin = null;
			this.OnUnzipEnd = null;
			Monitor.Enter(m_lockObject);
			_003CModule_003E.Chilkat_002E_003FA0x310f0ede_002ENextHashCode++;
			m_myHashCode = _003CModule_003E.Chilkat_002E_003FA0x310f0ede_002ENextHashCode;
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			Monitor.Exit(m_lockObject);
		}

		public unsafe Zip()
		{
			m_enableEvents = false;
			this.OnWriteZipPercentDone = null;
			this.OnUnzipPercentDone = null;
			this.OnToBeAdded = null;
			this.OnDirToBeAdded = null;
			this.OnFileAdded = null;
			this.OnToBeZipped = null;
			this.OnFileZipped = null;
			this.OnToBeUnzipped = null;
			this.OnFileUnzipped = null;
			this.OnAddFilesBegin = null;
			this.OnAddFilesEnd = null;
			this.OnWriteZipBegin = null;
			this.OnAbortCheck = null;
			this.OnWriteZipEnd = null;
			this.OnUnzipBegin = null;
			this.OnUnzipEnd = null;
			Monitor.Enter(m_lockObject);
			m_lockImpl = new object();
			_003CModule_003E.Chilkat_002E_003FA0x310f0ede_002ENextHashCode++;
			m_myHashCode = _003CModule_003E.Chilkat_002E_003FA0x310f0ede_002ENextHashCode;
			m_impl = null;
			m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			Monitor.Exit(m_lockObject);
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			Monitor.Enter(m_lockObject);
			ZipDn* impl = m_impl;
			if (impl != null)
			{
				ZipDn* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
				m_impl = null;
			}
			try
			{
				m_zipObjects.Remove(this);
			}
			catch when (((Func<bool>)delegate
			{
				// Could not convert BlockContainer to single expression
				uint exceptionCode = (uint)Marshal.GetExceptionCode();
				return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
			}).Invoke())
			{
				uint num2 = 0u;
				_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
				try
				{
					try
					{
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
						return (byte)num2 != 0;
					}).Invoke())
					{
						goto IL_0078;
					}
					goto end_IL_0064;
					IL_0078:
					if (num2 != 0)
					{
						throw;
					}
					end_IL_0064:;
				}
				finally
				{
					_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
				}
			}
			Monitor.Exit(m_lockObject);
		}

		public override void Dispose()
		{
			Monitor.Enter(m_lockObject);
			m_zipObjects.Remove(this);
			Monitor.Exit(m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ZipDn* impl;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				impl = m_impl;
				if (impl != null)
				{
					goto IL_0035;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return false;
			IL_0035:
			bool result;
			try
			{
				result = _003CModule_003E.ZipDn_002ESaveXmlLog(impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteExe(string exeFilename)
		{
			//Discarded unreachable code: IL_00dc
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xString);
				result = false;
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					try
					{
						result = _003CModule_003E.ZipDn_002EWriteExe(m_impl, &xString, (ZipCallback*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08NAFNOBNK_0040WriteExe_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00cb;
							}
							goto end_IL_00a7;
							IL_00cb:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00a7:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteExe2(string inExeFilename, string outExeFilename, [MarshalAs(UnmanagedType.U1)] bool bEncrypt, int keyLength, string password)
		{
			//Discarded unreachable code: IL_0104
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(inExeFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(outExeFilename, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(password, &xString3);
						result = false;
						_ZipCallback zipCallback;
						_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
						try
						{
							*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
							*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
							throw;
						}
						try
						{
							_ZipCallback* ptr = null;
							if (m_enableEvents)
							{
								ptr = &zipCallback;
								*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
							}
							try
							{
								result = _003CModule_003E.ZipDn_002EWriteExe2(m_impl, &xString, &xString2, bEncrypt, keyLength, &xString3, (ZipCallback*)ptr);
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								uint exceptionCode = (uint)Marshal.GetExceptionCode();
								return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
							}).Invoke())
							{
								uint num2 = 0u;
								_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
								try
								{
									try
									{
										_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09ILKGDCFK_0040WriteExe2_003F_0024AA_0040));
									}
									catch when (((Func<bool>)delegate
									{
										// Could not convert BlockContainer to single expression
										num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
										return (byte)num2 != 0;
									}).Invoke())
									{
										goto IL_00f3;
									}
									goto end_IL_00cf;
									IL_00f3:
									if (num2 != 0)
									{
										throw;
									}
									end_IL_00cf:;
								}
								finally
								{
									_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
								}
							}
						}
						catch
						{
							//try-fault
							_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
							throw;
						}
						*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
						_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry FirstEntry()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			Monitor.Enter(m_lockImpl);
			ZipEntryDn* ptr = _003CModule_003E.ZipDn_002EFirstEntry(m_impl);
			Monitor.Exit(m_lockImpl);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractOne(ZipEntry entry, string dirPath)
		{
			//Discarded unreachable code: IL_00fa
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				if (entry != null)
				{
					goto IL_0036;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return false;
			IL_0036:
			bool result;
			try
			{
				if (m_impl == null)
				{
					m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
				}
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					ZipEntryDn* implementation = (ZipEntryDn*)entry.GetImplementation();
					try
					{
						result = _003CModule_003E.ZipEntryDn_002EExtract(implementation, &xString, (ProgressEvent*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0L_0040KDIEHHOP_0040ExtractOne_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00e9;
							}
							goto end_IL_00c5;
							IL_00e9:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00c5:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void ExcludeDir(string dirName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(dirName, &xString);
				_003CModule_003E.ZipDn_002EExcludeDir(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void SetCompressionLevel(int level)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			_003CModule_003E.ZipDn_002ESetCompressionLevel(m_impl, level);
		}

		public unsafe void SetExeConfigParam(string name, string value)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(name, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(value, &xString2);
					_003CModule_003E.ZipDn_002ESetExeConfigParam(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe string GetExeConfigParam(string name)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(name, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ZipDn_002EGetExeConfigParam(m_impl, &xString, &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsPasswordProtected(string zipFilename)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(zipFilename, &xString);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ZipDn_002EIsPasswordProtected(m_impl, &xString);
				Monitor.Exit(m_lockImpl);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFromMemory(byte[] inData)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			bool result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				Monitor.Enter(m_lockImpl);
				result = _003CModule_003E.ZipDn_002EOpenFromMemory(m_impl, _003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), _003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				Monitor.Exit(m_lockImpl);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenEmbedded(string exeFilename, string resourceName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(resourceName, &xString2);
					result = _003CModule_003E.ZipDn_002EOpenEmbedded(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenMyEmbedded(string resourceName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(resourceName, &xString);
				result = _003CModule_003E.ZipDn_002EOpenMyEmbedded(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddEmbedded(string exeFilename, string resourceName, string zipFilename)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(resourceName, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(zipFilename, &xString3);
						result = _003CModule_003E.ZipDn_002EAddEmbedded(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ReplaceEmbedded(string exeFilename, string resourceName, string zipFilename)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(resourceName, &xString2);
					XString xString3;
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(zipFilename, &xString3);
						result = _003CModule_003E.ZipDn_002EReplaceEmbedded(m_impl, &xString, &xString2, &xString3);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveEmbedded(string exeFilename, string resourceName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(resourceName, &xString2);
					result = _003CModule_003E.ZipDn_002ERemoveEmbedded(m_impl, &xString, &xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void SetPassword(string password)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(password, &xString);
				_003CModule_003E.ZipDn_002ESetPassword(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void SetExclusions(StringArray excludePatterns)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			_003CModule_003E.ZipDn_002ESetExclusions(m_impl, excludePatterns.GetImplementation());
		}

		public unsafe StringArray GetExclusions()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			ClsStringArray* ptr = _003CModule_003E.ZipDn_002EGetExclusions(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new StringArray(ptr);
		}

		public unsafe ZipEntry FirstMatchingEntry(string pattern)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(pattern, &xString);
				ptr = _003CModule_003E.ZipDn_002EFirstMatchingEntry(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0049;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				result2 = new ZipEntry(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0049:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string GetDirectoryAsXML()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				_003CModule_003E.ZipDn_002EGetDirectoryAsXML(m_impl, &xString);
				result = CkMarshal.XToString(&xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractMatching(string dirPath, string pattern)
		{
			//Discarded unreachable code: IL_00ec
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pattern, &xString2);
					_ZipCallback zipCallback;
					_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
					try
					{
						*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
						throw;
					}
					try
					{
						_ZipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &zipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
						}
						try
						{
							result = _003CModule_003E.ZipDn_002EExtractMatching(m_impl, &xString, &xString2, (ZipCallback*)ptr);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BA_0040PMNLLG_0040ExtractMatching_003F_0024AA_0040));
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_00db;
								}
								goto end_IL_00b7;
								IL_00db:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_00b7:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
						throw;
					}
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry GetEntryByID(int entryID)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			ZipEntryDn* ptr = _003CModule_003E.ZipDn_002EGetEntryByID(m_impl, entryID);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteZip()
		{
			//Discarded unreachable code: IL_00c8
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			_ZipCallback zipCallback;
			_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
			try
			{
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			bool result;
			try
			{
				_ZipCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &zipCallback;
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
				}
				try
				{
					result = _003CModule_003E.ZipDn_002EWriteZip(m_impl, (ZipCallback*)ptr);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_08PCHGIJEA_0040WriteZip_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00b7;
						}
						goto end_IL_0093;
						IL_00b7:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0093:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteZipAndClose()
		{
			//Discarded unreachable code: IL_00c7
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			_ZipCallback zipCallback;
			_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
			try
			{
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			bool result;
			try
			{
				_ZipCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &zipCallback;
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
				}
				result = false;
				try
				{
					result = _003CModule_003E.ZipDn_002EWriteZipAndClose(m_impl, (ZipCallback*)ptr);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BB_0040FAJLABCG_0040WriteZipAndClose_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_00b6;
						}
						goto end_IL_0092;
						IL_00b6:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0092:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			return result;
		}

		public unsafe byte[] WriteToMemory()
		{
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				bool flag = false;
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					try
					{
						flag = _003CModule_003E.ZipDn_002EWriteToMemory(m_impl, &dataBuffer, (ZipCallback*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040IKBLJEGD_0040WriteToMemory_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00c3;
							}
							goto end_IL_009f;
							IL_00c3:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_009f:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
					if (!flag)
					{
						_003CModule_003E.DataBuffer_002Eclear(&dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool QuickAppend(string ZipFileName)
		{
			//Discarded unreachable code: IL_0098
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(ZipFileName, &xString);
				result = false;
				try
				{
					result = _003CModule_003E.ZipDn_002EQuickAppend(m_impl, &xString);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0M_0040DGLACDAP_0040QuickAppend_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_0087;
						}
						goto end_IL_0063;
						IL_0087:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0063:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenZip(string ZipFileName)
		{
			//Discarded unreachable code: IL_0098
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(ZipFileName, &xString);
				result = false;
				try
				{
					result = _003CModule_003E.ZipDn_002EOpenZip(m_impl, &xString);
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_07DELKBBKG_0040OpenZip_003F_0024AA_0040));
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
							goto IL_0087;
						}
						goto end_IL_0063;
						IL_0087:
						if (num2 != 0)
						{
							throw;
						}
						end_IL_0063:;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool NewZip(string ZipFileName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(ZipFileName, &xString);
				result = _003CModule_003E.ZipDn_002ENewZip(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe void CloseZip()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			_003CModule_003E.ZipDn_002ECloseZip(m_impl);
		}

		public unsafe ZipEntry GetEntryByName(string entryName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(entryName, &xString);
				ptr = _003CModule_003E.ZipDn_002EGetEntryByName(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0049;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				result2 = new ZipEntry(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0049:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry GetEntryByIndex(int index)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			ZipEntryDn* ptr = _003CModule_003E.ZipDn_002EGetEntryByIndex(m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry(ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteEntry(ZipEntry entry)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			if (entry == null)
			{
				return false;
			}
			ZipEntryDn* implementation = (ZipEntryDn*)entry.GetImplementation();
			Monitor.Enter(m_lockImpl);
			bool result = _003CModule_003E.ZipDn_002EDeleteEntry(m_impl, implementation);
			Monitor.Exit(m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Extract(string dirPath)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = _003CModule_003E.ZipDn_002EExtract(m_impl, &xString, (ZipCallback*)ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractInto(string dirPath)
		{
			//Discarded unreachable code: IL_00d9
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = false;
					try
					{
						result = _003CModule_003E.ZipDn_002EExtractInto(m_impl, &xString, (ZipCallback*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0M_0040EANHDABB_0040ExtractInto_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00c8;
							}
							goto end_IL_00a4;
							IL_00c8:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00a4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractNewer(string dirPath)
		{
			//Discarded unreachable code: IL_00d9
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = false;
					try
					{
						result = _003CModule_003E.ZipDn_002EExtractNewer(m_impl, &xString, (ZipCallback*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0N_0040CAOMHCH_0040ExtractNewer_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00c8;
							}
							goto end_IL_00a4;
							IL_00c8:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00a4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendZip(string zipFileName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(zipFileName, &xString);
				result = _003CModule_003E.ZipDn_002EAppendZip(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFromWeb(string url)
		{
			//Discarded unreachable code: IL_00d9
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = false;
					try
					{
						result = _003CModule_003E.ZipDn_002EOpenFromWeb(m_impl, &xString, (ProgressEvent*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0M_0040NIJIOFAO_0040OpenFromWeb_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00c8;
							}
							goto end_IL_00a4;
							IL_00c8:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00a4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFilesEx(string filePattern, [MarshalAs(UnmanagedType.U1)] bool recurse, [MarshalAs(UnmanagedType.U1)] bool saveExtraPath, [MarshalAs(UnmanagedType.U1)] bool archiveOnly, [MarshalAs(UnmanagedType.U1)] bool includeHidden, [MarshalAs(UnmanagedType.U1)] bool includeSystem)
		{
			//Discarded unreachable code: IL_00e3
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filePattern, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = false;
					try
					{
						int num2;
						result = _003CModule_003E.ZipDn_002EAppendFilesEx(m_impl, &xString, recurse, saveExtraPath, archiveOnly, includeHidden, includeSystem, (ZipCallback*)ptr, &num2);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num3 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040LEGLPFDJ_0040AppendFilesEx_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num3 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num3 != 0;
							}).Invoke())
							{
								goto IL_00d2;
							}
							goto end_IL_00ae;
							IL_00d2:
							if (num3 != 0)
							{
								throw;
							}
							end_IL_00ae:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num3);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFiles(string filePattern, [MarshalAs(UnmanagedType.U1)] bool recurse)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			Monitor.Enter(m_lockObject);
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filePattern, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					int num;
					result = _003CModule_003E.ZipDn_002EAppendFiles(m_impl, &xString, recurse, (ZipCallback*)ptr, &num);
					Monitor.Exit(m_lockObject);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendOneFileOrDir(string fileOrDirName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(fileOrDirName, &xString);
				result = _003CModule_003E.ZipDn_002EAppendOneFileOrDir(m_impl, &xString, false);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendOneFileOrDir(string fileOrDirName, [MarshalAs(UnmanagedType.U1)] bool saveExtraPath)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(fileOrDirName, &xString);
				result = _003CModule_003E.ZipDn_002EAppendOneFileOrDir(m_impl, &xString, saveExtraPath);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMultiple(StringArray fileSpecs, [MarshalAs(UnmanagedType.U1)] bool recurse)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			if (fileSpecs == null)
			{
				return false;
			}
			_ZipCallback zipCallback;
			_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
			try
			{
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			bool result;
			try
			{
				_ZipCallback* ptr = null;
				if (m_enableEvents)
				{
					ptr = &zipCallback;
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
				}
				ClsStringArray* implementation = fileSpecs.GetImplementation();
				int num;
				result = _003CModule_003E.ZipDn_002EAppendMultiple(m_impl, implementation, recurse, (ZipCallback*)ptr, &num);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			return result;
		}

		public unsafe ZipEntry AppendData(string fileName, byte[] inData)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			ZipEntryDn* ptr2;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					ptr2 = _003CModule_003E.ZipDn_002EAppendData(m_impl, &xString, &dataBuffer);
					CkMarshal.free(ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_006f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_001c;
				IL_006f:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_0086;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					result2 = new ZipEntry(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0086:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendString2(string fileName, string str, string charset)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			XString xString3;
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(str, &xString2);
					_003CModule_003E.XString_002E_007Bctor_007D(&xString3);
					try
					{
						CkMarshal.StringToX(charset, &xString3);
						ptr = _003CModule_003E.ZipDn_002EAppendString2(m_impl, &xString, &xString2, &xString3);
						if (ptr == null)
						{
							result = null;
							goto IL_006d;
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					goto end_IL_002c;
					IL_006d:
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
					goto IL_0084;
					end_IL_002c:;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_001c;
				IL_0084:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_009b;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					try
					{
						result2 = new ZipEntry(ptr);
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString3);
						throw;
					}
					_003CModule_003E.XString_002E_007Bdtor_007D(&xString3);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_009b:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendUnicode(string fileName, string str)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(str, &xString2);
					ptr = _003CModule_003E.ZipDn_002EAppendUnicode(m_impl, &xString, &xString2);
					if (ptr == null)
					{
						result = null;
						goto IL_005b;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_001c;
				IL_005b:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0072;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					result2 = new ZipEntry(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0072:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendAnsi(string fileName, string str)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(str, &xString2);
					ptr = _003CModule_003E.ZipDn_002EAppendAnsi(m_impl, &xString, &xString2);
					if (ptr == null)
					{
						result = null;
						goto IL_005b;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_001c;
				IL_005b:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0072;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					result2 = new ZipEntry(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0072:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendData2(string fileName, byte[] inData, uint numBytes)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			ZipEntryDn* ptr2;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				int num = (int)numBytes;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, numBytes);
					ptr2 = _003CModule_003E.ZipDn_002EAppendData(m_impl, &xString, &dataBuffer);
					CkMarshal.free(ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_006e;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_001c;
				IL_006e:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_0085;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					result2 = new ZipEntry(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0085:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendNew(string fileName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				ptr = _003CModule_003E.ZipDn_002EAppendNew(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0049;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				result2 = new ZipEntry(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0049:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendNewDir(string dirName)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(dirName, &xString);
				ptr = _003CModule_003E.ZipDn_002EAppendNewDir(m_impl, &xString);
				if (ptr == null)
				{
					result = null;
					goto IL_0049;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				result2 = new ZipEntry(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0049:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry InsertNew(string fileName, int beforeIndex)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				ptr = _003CModule_003E.ZipDn_002EInsertNew(m_impl, &xString, beforeIndex);
				if (ptr == null)
				{
					result = null;
					goto IL_004a;
				}
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				result2 = new ZipEntry(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_004a:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendCompressed(string fileName, byte[] inData)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			DataBuffer dataBuffer;
			ZipEntryDn* ptr2;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
					ptr2 = _003CModule_003E.ZipDn_002EAppendCompressed(m_impl, &xString, &dataBuffer);
					CkMarshal.free(ptr);
					if (ptr2 == null)
					{
						result = null;
						goto IL_006f;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				goto end_IL_001c;
				IL_006f:
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
				goto IL_0086;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					result2 = new ZipEntry(ptr2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0086:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendHex(string fileName, string encodedCompressedData)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(encodedCompressedData, &xString2);
					ptr = _003CModule_003E.ZipDn_002EAppendHexX(m_impl, &xString, &xString2);
					if (ptr == null)
					{
						result = null;
						goto IL_005b;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_001c;
				IL_005b:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0072;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					result2 = new ZipEntry(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0072:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendBase64(string fileName, string encodedCompressedData)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			XString xString2;
			ZipEntryDn* ptr;
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(encodedCompressedData, &xString2);
					ptr = _003CModule_003E.ZipDn_002EAppendBase64X(m_impl, &xString, &xString2);
					if (ptr == null)
					{
						result = null;
						goto IL_005b;
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				goto end_IL_001c;
				IL_005b:
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
				goto IL_0072;
				end_IL_001c:;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			ZipEntry result2;
			try
			{
				try
				{
					result2 = new ZipEntry(ptr);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result2;
			IL_0072:
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string regCode)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(regCode, &xString);
				result = _003CModule_003E.ZipDn_002EUnlockComponentX(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			return _003CModule_003E.ZipDn_002EIsUnlocked(m_impl);
		}

		public unsafe int Unzip(string dirPath)
		{
			//Discarded unreachable code: IL_00d9
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = -1;
					try
					{
						result = _003CModule_003E.ZipDn_002EUnzip(m_impl, &xString, (ZipCallback*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_05FIMHMHJF_0040Unzip_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00c8;
							}
							goto end_IL_00a4;
							IL_00c8:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00a4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int UnzipInto(string dirPath)
		{
			//Discarded unreachable code: IL_00d9
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = -1;
					try
					{
						result = _003CModule_003E.ZipDn_002EUnzipInto(m_impl, &xString, (ZipCallback*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_09MAPCAEPA_0040UnzipInto_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00c8;
							}
							goto end_IL_00a4;
							IL_00c8:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00a4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int UnzipNewer(string dirPath)
		{
			//Discarded unreachable code: IL_00d9
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				_ZipCallback zipCallback;
				_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
				try
				{
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (m_enableEvents)
					{
						ptr = &zipCallback;
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
					}
					result = -1;
					try
					{
						result = _003CModule_003E.ZipDn_002EUnzipNewer(m_impl, &xString, (ZipCallback*)ptr);
					}
					catch when (((Func<bool>)delegate
					{
						// Could not convert BlockContainer to single expression
						uint exceptionCode = (uint)Marshal.GetExceptionCode();
						return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
					}).Invoke())
					{
						uint num2 = 0u;
						_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
						try
						{
							try
							{
								_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0L_0040NFIDDAPN_0040UnzipNewer_003F_0024AA_0040));
							}
							catch when (((Func<bool>)delegate
							{
								// Could not convert BlockContainer to single expression
								num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
								return (byte)num2 != 0;
							}).Invoke())
							{
								goto IL_00c8;
							}
							goto end_IL_00a4;
							IL_00c8:
							if (num2 != 0)
							{
								throw;
							}
							end_IL_00a4:;
						}
						finally
						{
							_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
						}
					}
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
					throw;
				}
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int UnzipMatching(string dirPath, string pattern, [MarshalAs(UnmanagedType.U1)] bool verbose)
		{
			//Discarded unreachable code: IL_00ec
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pattern, &xString2);
					_ZipCallback zipCallback;
					_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
					try
					{
						*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
						throw;
					}
					try
					{
						_ZipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &zipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
						}
						result = -1;
						try
						{
							result = _003CModule_003E.ZipDn_002EUnzipMatching(m_impl, &xString, &xString2, verbose, (ZipCallback*)ptr);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0O_0040EIBGODGA_0040UnzipMatching_003F_0024AA_0040));
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_00db;
								}
								goto end_IL_00b7;
								IL_00db:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_00b7:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
						throw;
					}
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe int UnzipMatchingInto(string dirPath, string pattern, [MarshalAs(UnmanagedType.U1)] bool verbose)
		{
			//Discarded unreachable code: IL_00ec
			int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(pattern, &xString2);
					_ZipCallback zipCallback;
					_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
					try
					{
						*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
						*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
						throw;
					}
					try
					{
						_ZipCallback* ptr = null;
						if (m_enableEvents)
						{
							ptr = &zipCallback;
							*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = m_myHashCode;
						}
						result = -1;
						try
						{
							result = _003CModule_003E.ZipDn_002EUnzipMatchingInto(m_impl, &xString, &xString2, verbose, (ZipCallback*)ptr);
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							uint exceptionCode = (uint)Marshal.GetExceptionCode();
							return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
						}).Invoke())
						{
							uint num2 = 0u;
							_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
							try
							{
								try
								{
									_003CModule_003E.ZipDn_002ECreateExceptionLog(m_impl, (sbyte*)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_C_0040_0BC_0040MLJKOIGD_0040UnzipMatchingInto_003F_0024AA_0040));
								}
								catch when (((Func<bool>)delegate
								{
									// Could not convert BlockContainer to single expression
									num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
									return (byte)num2 != 0;
								}).Invoke())
								{
									goto IL_00db;
								}
								goto end_IL_00b7;
								IL_00db:
								if (num2 != 0)
								{
									throw;
								}
								end_IL_00b7:;
							}
							finally
							{
								_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
							}
						}
					}
					catch
					{
						//try-fault
						_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
						throw;
					}
					*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
					_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe ZipEntry AppendString(string fileName, string str)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					CkMarshal.StringToX(str, &xString2);
					result = new ZipEntry(_003CModule_003E.ZipDn_002EAppendData(m_impl, &xString, (byte*)_003CModule_003E.XString_002EgetAnsi(&xString2), (uint)_003CModule_003E.XString_002EgetSizeAnsi(&xString2)));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFromByteData(byte[] byteData)
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(byteData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			bool result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				result = _003CModule_003E.ZipDn_002EOpenFromMemory(m_impl, _003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), _003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyPassword()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			return _003CModule_003E.ZipDn_002EVerifyPassword(m_impl);
		}

		public unsafe byte[] WriteExeToMemory()
		{
			if (m_impl == null)
			{
				m_impl = _003CModule_003E.ZipDn_002ECreateZipDn(2);
			}
			_ZipCallback zipCallback;
			_003CModule_003E.ZipCallback_002E_007Bctor_007D((ZipCallback*)(&zipCallback));
			try
			{
				*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
				*(int*)(&Unsafe.AddByteOffset(ref zipCallback, 8)) = 0;
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			byte[] result;
			try
			{
				DataBuffer dataBuffer;
				_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
				try
				{
					_003CModule_003E.ZipDn_002EWriteExeToMemory(m_impl, &dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
					throw;
				}
				_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.Chilkat_002E_ZipCallback_002E_007Bdtor_007D), &zipCallback);
				throw;
			}
			*(int*)(&zipCallback) = (int)Unsafe.AsPointer(ref _003CModule_003E._003F_003F_7_ZipCallback_0040Chilkat_0040_00406B_0040);
			_003CModule_003E.ZipCallback_002E_007Bdtor_007D((ZipCallback*)(&zipCallback));
			return result;
		}

		public unsafe void AddNoCompressExtension(string fileExtension)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(fileExtension, &xString);
				_003CModule_003E.ZipDn_002EAddNoCompressExtension(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		public unsafe void RemoveNoCompressExtension(string fileExtension)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			try
			{
				CkMarshal.StringToX(fileExtension, &xString);
				_003CModule_003E.ZipDn_002ERemoveNoCompressExtension(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsNoCompressExtension(string fileExtension)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(fileExtension, &xString);
				result = _003CModule_003E.ZipDn_002EIsNoCompressExtension(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		protected void raise_OnWriteZipPercentDone(object i1, WriteZipPercentDoneEventArgs i2)
		{
			this.OnWriteZipPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnUnzipPercentDone(object i1, UnzipPercentDoneEventArgs i2)
		{
			this.OnUnzipPercentDone?.Invoke(i1, i2);
		}

		protected void raise_OnToBeAdded(object i1, ToBeAddedEventArgs i2)
		{
			this.OnToBeAdded?.Invoke(i1, i2);
		}

		protected void raise_OnDirToBeAdded(object i1, DirToBeAddedEventArgs i2)
		{
			this.OnDirToBeAdded?.Invoke(i1, i2);
		}

		protected void raise_OnFileAdded(object i1, FileAddedEventArgs i2)
		{
			this.OnFileAdded?.Invoke(i1, i2);
		}

		protected void raise_OnToBeZipped(object i1, ToBeZippedEventArgs i2)
		{
			this.OnToBeZipped?.Invoke(i1, i2);
		}

		protected void raise_OnFileZipped(object i1, FileZippedEventArgs i2)
		{
			this.OnFileZipped?.Invoke(i1, i2);
		}

		protected void raise_OnToBeUnzipped(object i1, ToBeUnzippedEventArgs i2)
		{
			this.OnToBeUnzipped?.Invoke(i1, i2);
		}

		protected void raise_OnFileUnzipped(object i1, FileUnzippedEventArgs i2)
		{
			this.OnFileUnzipped?.Invoke(i1, i2);
		}

		protected void raise_OnAddFilesBegin(object i1, EventArgs i2)
		{
			this.OnAddFilesBegin?.Invoke(i1, i2);
		}

		protected void raise_OnAddFilesEnd(object i1, EventArgs i2)
		{
			this.OnAddFilesEnd?.Invoke(i1, i2);
		}

		protected void raise_OnWriteZipBegin(object i1, EventArgs i2)
		{
			this.OnWriteZipBegin?.Invoke(i1, i2);
		}

		protected void raise_OnAbortCheck(object i1, AbortCheckEventArgs i2)
		{
			this.OnAbortCheck?.Invoke(i1, i2);
		}

		protected void raise_OnWriteZipEnd(object i1, EventArgs i2)
		{
			this.OnWriteZipEnd?.Invoke(i1, i2);
		}

		protected void raise_OnUnzipBegin(object i1, EventArgs i2)
		{
			this.OnUnzipBegin?.Invoke(i1, i2);
		}

		protected void raise_OnUnzipEnd(object i1, EventArgs i2)
		{
			this.OnUnzipEnd?.Invoke(i1, i2);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
