using chilkat;
using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class ZipEntry : IDisposable
	{
		private unsafe ZipEntryDn* m_impl;

		public unsafe long UncompressedLength64 => _003CModule_003E.ZipEntryDn_002Eget_UncompressedLength64(m_impl);

		public unsafe long CompressedLength64 => _003CModule_003E.ZipEntryDn_002Eget_CompressedLength64(m_impl);

		public unsafe int EntryID => _003CModule_003E.ZipEntryDn_002Eget_EntryID(m_impl);

		public unsafe bool IsDirectory
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ZipEntryDn_002Eget_IsDirectory(m_impl);
			}
		}

		public unsafe DateTime FileDateTime
		{
			get
			{
				int num = (int)stackalloc byte[_003CModule_003E.__CxxQueryExceptionSize()];
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				_003CModule_003E.ZipEntryDn_002Eget_FileDateTime(m_impl, &chilkatSysTime);
				DateTime result = default(DateTime);
				try
				{
					DateTime dateTime = new DateTime(*(ushort*)(&chilkatSysTime), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)), *(ushort*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 14)));
					result = dateTime;
					return result;
				}
				catch when (((Func<bool>)delegate
				{
					// Could not convert BlockContainer to single expression
					uint exceptionCode = (uint)Marshal.GetExceptionCode();
					return (byte)_003CModule_003E.__CxxExceptionFilter((void*)(long)Marshal.GetExceptionPointers(), null, 0, null) != 0;
				}).Invoke())
				{
					uint num2 = 0u;
					_003CModule_003E.__CxxRegisterExceptionObject((void*)(long)Marshal.GetExceptionPointers(), (void*)num);
					try
					{
						try
						{
							result = DateTime.Now;
							return result;
						}
						catch when (((Func<bool>)delegate
						{
							// Could not convert BlockContainer to single expression
							num2 = (uint)_003CModule_003E.__CxxDetectRethrow((void*)(long)Marshal.GetExceptionPointers());
							return (byte)num2 != 0;
						}).Invoke())
						{
						}
						if (num2 != 0)
						{
							throw;
						}
						return result;
					}
					finally
					{
						_003CModule_003E.__CxxUnregisterExceptionObject((void*)num, (int)num2);
					}
				}
			}
			set
			{
				ChilkatSysTime chilkatSysTime;
				_003CModule_003E.ChilkatSysTime_002E_007Bctor_007D(&chilkatSysTime);
				*(short*)(&chilkatSysTime) = (short)value.Year;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 2)) = (short)value.Month;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 6)) = (short)value.Day;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 8)) = (short)value.Hour;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 10)) = (short)value.Minute;
				*(short*)(&Unsafe.AddByteOffset(ref chilkatSysTime, 12)) = (short)value.Second;
				_003CModule_003E.ZipEntryDn_002Eput_FileDateTime(m_impl, &chilkatSysTime);
			}
		}

		public unsafe int EntryType => _003CModule_003E.ZipEntryDn_002Eget_EntryType(m_impl);

		public unsafe string Comment
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipEntryDn_002Eget_Comment(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipEntryDn_002Eput_Comment(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe uint Crc => _003CModule_003E.ZipEntryDn_002Eget_Crc(m_impl);

		public unsafe uint CompressedLength => _003CModule_003E.ZipEntryDn_002Eget_CompressedLength(m_impl);

		public unsafe int CompressionMethod
		{
			get
			{
				return _003CModule_003E.ZipEntryDn_002Eget_CompressionMethod(m_impl);
			}
			set
			{
				_003CModule_003E.ZipEntryDn_002Eput_CompressionMethod(m_impl, value);
			}
		}

		public unsafe int CompressionLevel
		{
			get
			{
				return _003CModule_003E.ZipEntryDn_002Eget_CompressionLevel(m_impl);
			}
			set
			{
				_003CModule_003E.ZipEntryDn_002Eput_CompressionLevel(m_impl, value);
			}
		}

		public unsafe bool TextFlag
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return _003CModule_003E.ZipEntryDn_002Eget_TextFlag(m_impl);
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				_003CModule_003E.ZipEntryDn_002Eput_TextFlag(m_impl, value);
			}
		}

		public unsafe uint UncompressedLength => _003CModule_003E.ZipEntryDn_002Eget_UncompressedLength(m_impl);

		public unsafe string FileName
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipEntryDn_002Eget_FileName(m_impl, &xString);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
			set
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				try
				{
					CkMarshal.StringToX(value, &xString);
					_003CModule_003E.ZipEntryDn_002Eput_FileName(m_impl, &xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipEntryDn_002EGetLogHtml(m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipEntryDn_002EGetLogXml(m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xString;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString);
				string result;
				try
				{
					_003CModule_003E.ZipEntryDn_002EGetLogText(m_impl, &xString, true);
					result = CkMarshal.XToString(&xString);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
				return result;
			}
		}

		public unsafe ZipEntry(void* impl)
		{
			m_impl = (ZipEntryDn*)impl;
		}

		private unsafe ZipEntry()
		{
			m_impl = null;
		}

		protected unsafe override void Finalize()
		{
			ZipEntryDn* impl = m_impl;
			if (impl != null)
			{
				ZipEntryDn* ptr = impl;
				((delegate* thiscall<IntPtr, uint, void*>)(*(int*)(*(int*)ptr)))((IntPtr)ptr, 1u);
			}
		}

		public override void Dispose()
		{
		}

		public unsafe void* GetImplementation()
		{
			return m_impl;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xString);
				result = _003CModule_003E.ZipEntryDn_002ESaveXmlLog(m_impl, &xString);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Extract(string dirPath)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				result = _003CModule_003E.ZipEntryDn_002EExtract(m_impl, &xString, null);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractInto(string dirPath)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xString);
				result = _003CModule_003E.ZipEntryDn_002EExtractInto(m_impl, &xString, null);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe string InflateToString([MarshalAs(UnmanagedType.U1)] bool addCR)
		{
			StringBuffer stringBuffer;
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bctor_007D(&stringBuffer);
			string result;
			try
			{
				_003CModule_003E.ZipEntryDn_002EInflateToStringAnsi(m_impl, addCR, &stringBuffer);
				result = CkMarshal.AnsiToString(_003CModule_003E.chilkat_002EStringBuffer_002EgetString(&stringBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
				throw;
			}
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
			return result;
		}

		public unsafe string InflateToString2()
		{
			StringBuffer stringBuffer;
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bctor_007D(&stringBuffer);
			string result;
			try
			{
				_003CModule_003E.ZipEntryDn_002EInflateToStringAnsi2(m_impl, &stringBuffer);
				result = CkMarshal.AnsiToString(_003CModule_003E.chilkat_002EStringBuffer_002EgetString(&stringBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
				throw;
			}
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
			return result;
		}

		public unsafe string InflateToString3(string srcCharset)
		{
			XString xString;
			_003CModule_003E.XString_002E_007Bctor_007D(&xString);
			string result;
			try
			{
				CkMarshal.StringToX(srcCharset, &xString);
				XString xString2;
				_003CModule_003E.XString_002E_007Bctor_007D(&xString2);
				try
				{
					_003CModule_003E.ZipEntryDn_002EInflateToUnicode(m_impl, _003CModule_003E.XString_002EgetUtf8(&xString), &xString2);
					result = CkMarshal.XToString(&xString2);
				}
				catch
				{
					//try-fault
					_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString2);
					throw;
				}
				_003CModule_003E.XString_002E_007Bdtor_007D(&xString2);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.XString_002E_007Bdtor_007D), &xString);
				throw;
			}
			_003CModule_003E.XString_002E_007Bdtor_007D(&xString);
			return result;
		}

		public unsafe byte[] Inflate()
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				if (!_003CModule_003E.ZipEntryDn_002EInflate(m_impl, &dataBuffer))
				{
					_003CModule_003E.DataBuffer_002Eclear(&dataBuffer);
				}
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe byte[] Copy()
		{
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			byte[] result;
			try
			{
				if (!_003CModule_003E.ZipEntryDn_002ECopy(m_impl, &dataBuffer))
				{
					_003CModule_003E.DataBuffer_002Eclear(&dataBuffer);
				}
				result = CkMarshal.UnmanagedToManaged(_003CModule_003E.DataBuffer_002EgetData2(&dataBuffer), (int)_003CModule_003E.DataBuffer_002EgetSize(&dataBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ReplaceData(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			bool result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				result = _003CModule_003E.ZipEntryDn_002EReplaceData(m_impl, &dataBuffer);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendData(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, &num);
			DataBuffer dataBuffer;
			_003CModule_003E.DataBuffer_002E_007Bctor_007D(&dataBuffer);
			bool result;
			try
			{
				_003CModule_003E.DataBuffer_002EborrowData(&dataBuffer, ptr, (uint)num);
				result = _003CModule_003E.ZipEntryDn_002EAppendData(m_impl, &dataBuffer);
				CkMarshal.free(ptr);
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.DataBuffer_002E_007Bdtor_007D), &dataBuffer);
				throw;
			}
			_003CModule_003E.DataBuffer_002E_007Bdtor_007D(&dataBuffer);
			return result;
		}

		public unsafe string CopyToBase64()
		{
			StringBuffer stringBuffer;
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bctor_007D(&stringBuffer);
			string result;
			try
			{
				_003CModule_003E.ZipEntryDn_002ECopyToBase64(m_impl, &stringBuffer);
				result = CkMarshal.AnsiToString(_003CModule_003E.chilkat_002EStringBuffer_002EgetString(&stringBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
				throw;
			}
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
			return result;
		}

		public unsafe string CopyToHex()
		{
			StringBuffer stringBuffer;
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bctor_007D(&stringBuffer);
			string result;
			try
			{
				_003CModule_003E.ZipEntryDn_002ECopyToHex(m_impl, &stringBuffer);
				result = CkMarshal.AnsiToString(_003CModule_003E.chilkat_002EStringBuffer_002EgetString(&stringBuffer));
			}
			catch
			{
				//try-fault
				_003CModule_003E.___CxxCallUnwindDtor(__ldftn(_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D), &stringBuffer);
				throw;
			}
			_003CModule_003E.chilkat_002EStringBuffer_002E_007Bdtor_007D(&stringBuffer);
			return result;
		}

		public unsafe ZipEntry NextEntry()
		{
			ZipEntryDn* ptr = _003CModule_003E.ZipEntryDn_002ENextEntry(m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry(ptr);
		}

		public void _007Bdtor_007D()
		{
			GC.SuppressFinalize(this);
			Finalize();
		}
	}
}
