using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace IWshRuntimeLibrary
{
	[ComImport]
	[Guid("C7C3F5B1-88A3-11D0-ABCB-00A0C90FFFC0")]
	[DefaultMember("Path")]
	[ClassInterface(0)]
	public class DriveClass : IDrive, Drive
	{
		[DispId(0)]
		public virtual string Path
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(0)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(10000)]
		public virtual string DriveLetter
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10000)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(10001)]
		public virtual string ShareName
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10001)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[ComAliasName("IWshRuntimeLibrary.DriveTypeConst")]
		[DispId(10002)]
		public virtual DriveTypeConst DriveType
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10002)]
			[return: ComAliasName("IWshRuntimeLibrary.DriveTypeConst")]
			get;
		}

		[DispId(10003)]
		public virtual Folder RootFolder
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10003)]
			[return: MarshalAs(UnmanagedType.Interface)]
			get;
		}

		[DispId(10005)]
		public virtual object AvailableSpace
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10005)]
			[return: MarshalAs(UnmanagedType.Struct)]
			get;
		}

		[DispId(10004)]
		public virtual object FreeSpace
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10004)]
			[return: MarshalAs(UnmanagedType.Struct)]
			get;
		}

		[DispId(10006)]
		public virtual object TotalSize
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10006)]
			[return: MarshalAs(UnmanagedType.Struct)]
			get;
		}

		[DispId(10007)]
		public virtual string VolumeName
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10007)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10007)]
			[param: In]
			[param: MarshalAs(UnmanagedType.BStr)]
			set;
		}

		[DispId(10008)]
		public virtual string FileSystem
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10008)]
			[return: MarshalAs(UnmanagedType.BStr)]
			get;
		}

		[DispId(10009)]
		public virtual int SerialNumber
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10009)]
			get;
		}

		[DispId(10010)]
		public virtual bool IsReady
		{
			[MethodImpl(MethodImplOptions.InternalCall)]
			[DispId(10010)]
			get;
		}

		[MethodImpl(MethodImplOptions.InternalCall)]
		internal extern DriveClass();
	}
}
