using System;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Net.Sockets;
using System.Threading;
using System.Windows.Forms;

namespace Server
{
	public class Form1 : Form
	{
		private TcpListener tcpListener;

		private Socket socketForClient;

		private NetworkStream networkStream;

		private StreamWriter streamWriter;

		private StreamReader streamReader;

		private Thread tsend;

		private Thread tsock;

		private IContainer components = null;

		private Button button1;

		private ListBox listBox1;

		private TextBox textBox1;

		private Button button2;

		private Label label1;

		private TextBox textBox2;

		public Form1()
		{
			InitializeComponent();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			if (textBox2.Text.Length > 0)
			{
				if (button1.Text == "Start")
				{
					tcpListener = new TcpListener(Convert.ToInt32(textBox2.Text));
					tcpListener.Start();
					button1.Text = "Stop";
					listBox1.Items.Clear();
					listBox1.ForeColor = Color.White;
					listBox1.Items.Add("Server Start");
					tsend = new Thread(send);
					tsock = new Thread(sock);
					tsock.Start();
				}
				else
				{
					if (socketForClient == null)
					{
						tsend.Abort();
					}
					else if (socketForClient.Connected)
					{
						tsend.Abort();
						socketForClient.Shutdown(SocketShutdown.Both);
					}
					tcpListener.Stop();
					button1.Text = "Start";
				}
			}
			else
			{
				MessageBox.Show("Введите порт", "Ошыбка", MessageBoxButtons.OK, MessageBoxIcon.Hand);
			}
		}

		public void send()
		{
			try
			{
				Application.DoEvents();
				if (socketForClient.Connected)
				{
					while (true)
					{
						bool flag = true;
						listBox1.TopIndex = listBox1.Items.Count - 1;
						listBox1.Items.Add(streamReader.ReadLine());
					}
				}
			}
			catch
			{
				socketForClient.Close();
				listBox1.Items.Add("Client disconnected");
				listBox1.ForeColor = Color.White;
				listBox1.TopIndex = listBox1.Items.Count - 1;
				tsend = null;
				tsock = null;
				tsend = new Thread(send);
				tsock = new Thread(sock);
				tsock.Start();
			}
		}

		public void sock()
		{
			try
			{
				socketForClient = tcpListener.AcceptSocket();
				listBox1.ForeColor = Color.YellowGreen;
				listBox1.Items.Add("Client Find");
				networkStream = new NetworkStream(socketForClient);
				streamWriter = new StreamWriter(networkStream);
				streamReader = new StreamReader(networkStream);
				tsend.Start();
			}
			catch (Exception)
			{
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			try
			{
				if (socketForClient.Connected)
				{
					tsend = null;
					tsock = null;
					socketForClient.Disconnect(reuseSocket: false);
					socketForClient.Shutdown(SocketShutdown.Both);
					tsend = new Thread(send);
					tsock = new Thread(sock);
					tsock.Start();
				}
			}
			catch (Exception)
			{
			}
		}

		private void textBox1_KeyDown(object sender, KeyEventArgs e)
		{
			try
			{
				if (e.KeyValue == 13)
				{
					streamWriter.WriteLine(textBox1.Text);
					listBox1.Items.Add(textBox1.Text);
					streamWriter.Flush();
					textBox1.Text = null;
				}
			}
			catch
			{
			}
		}

		private void Form1_FormClosing(object sender, FormClosingEventArgs e)
		{
			try
			{
				if (socketForClient.Connected)
				{
					tsend.Abort();
					socketForClient.Shutdown(SocketShutdown.Both);
				}
				else
				{
					tcpListener.Stop();
				}
			}
			catch
			{
			}
		}

		private void button3_Click(object sender, EventArgs e)
		{
		}

		protected override void Dispose(bool disposing)
		{
			if (disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);
		}

		private void InitializeComponent()
		{
			button1 = new System.Windows.Forms.Button();
			listBox1 = new System.Windows.Forms.ListBox();
			textBox1 = new System.Windows.Forms.TextBox();
			button2 = new System.Windows.Forms.Button();
			label1 = new System.Windows.Forms.Label();
			textBox2 = new System.Windows.Forms.TextBox();
			SuspendLayout();
			button1.BackColor = System.Drawing.SystemColors.ControlText;
			button1.FlatAppearance.BorderColor = System.Drawing.Color.Black;
			button1.ForeColor = System.Drawing.SystemColors.ControlLightLight;
			button1.Location = new System.Drawing.Point(267, 248);
			button1.Name = "button1";
			button1.Size = new System.Drawing.Size(75, 23);
			button1.TabIndex = 0;
			button1.Text = "Start";
			button1.UseVisualStyleBackColor = false;
			button1.Click += new System.EventHandler(button1_Click);
			listBox1.BackColor = System.Drawing.SystemColors.WindowText;
			listBox1.ForeColor = System.Drawing.Color.White;
			listBox1.FormattingEnabled = true;
			listBox1.Items.AddRange(new object[1]
			{
				"Server Socket"
			});
			listBox1.Location = new System.Drawing.Point(-2, -1);
			listBox1.Name = "listBox1";
			listBox1.Size = new System.Drawing.Size(463, 225);
			listBox1.TabIndex = 1;
			textBox1.BackColor = System.Drawing.Color.Black;
			textBox1.ForeColor = System.Drawing.SystemColors.Window;
			textBox1.Location = new System.Drawing.Point(-2, 222);
			textBox1.Name = "textBox1";
			textBox1.Size = new System.Drawing.Size(463, 20);
			textBox1.TabIndex = 2;
			textBox1.KeyDown += new System.Windows.Forms.KeyEventHandler(textBox1_KeyDown);
			button2.BackColor = System.Drawing.SystemColors.ControlText;
			button2.FlatAppearance.BorderColor = System.Drawing.Color.White;
			button2.ForeColor = System.Drawing.SystemColors.Control;
			button2.Location = new System.Drawing.Point(348, 248);
			button2.Name = "button2";
			button2.Size = new System.Drawing.Size(99, 23);
			button2.TabIndex = 3;
			button2.Text = "Disconnected";
			button2.UseVisualStyleBackColor = false;
			button2.Click += new System.EventHandler(button2_Click);
			label1.AutoSize = true;
			label1.BackColor = System.Drawing.SystemColors.ControlText;
			label1.ForeColor = System.Drawing.SystemColors.Info;
			label1.Location = new System.Drawing.Point(12, 253);
			label1.Name = "label1";
			label1.Size = new System.Drawing.Size(32, 13);
			label1.TabIndex = 4;
			label1.Text = "Порт";
			textBox2.BackColor = System.Drawing.SystemColors.WindowText;
			textBox2.ForeColor = System.Drawing.SystemColors.Window;
			textBox2.Location = new System.Drawing.Point(50, 251);
			textBox2.Name = "textBox2";
			textBox2.Size = new System.Drawing.Size(44, 20);
			textBox2.TabIndex = 5;
			base.AutoScaleDimensions = new System.Drawing.SizeF(6f, 13f);
			base.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
			BackColor = System.Drawing.SystemColors.ControlText;
			base.ClientSize = new System.Drawing.Size(459, 275);
			base.Controls.Add(textBox2);
			base.Controls.Add(label1);
			base.Controls.Add(button2);
			base.Controls.Add(textBox1);
			base.Controls.Add(listBox1);
			base.Controls.Add(button1);
			base.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			base.Name = "Form1";
			Text = "Server";
			base.FormClosing += new System.Windows.Forms.FormClosingEventHandler(Form1_FormClosing);
			ResumeLayout(false);
			PerformLayout();
		}
	}
}
