using System.Security;
using System.Security.Permissions;

namespace System.Net.PeerToPeer.Collaboration
{
	[Serializable]
	[AttributeUsage(AttributeTargets.Assembly | AttributeTargets.Class | AttributeTargets.Struct | AttributeTargets.Constructor | AttributeTargets.Method, AllowMultiple = true, Inherited = false)]
	public sealed class PeerCollaborationPermissionAttribute : CodeAccessSecurityAttribute
	{
		public PeerCollaborationPermissionAttribute(SecurityAction action)
			: base(action)
		{
		}

		public override IPermission CreatePermission()
		{
			if (base.Unrestricted)
			{
				return new PeerCollaborationPermission(PermissionState.Unrestricted);
			}
			return new PeerCollaborationPermission(PermissionState.None);
		}
	}
}
