using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;

namespace System.Net.PeerToPeer.Collaboration
{
	[Serializable]
	public class PeerObjectCollection : Collection<PeerObject>
	{
		internal PeerObjectCollection()
		{
		}

		protected override void SetItem(int index, PeerObject item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.SetItem(index, item);
		}

		protected override void InsertItem(int index, PeerObject item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.InsertItem(index, item);
		}

		public override string ToString()
		{
			bool flag = true;
			StringBuilder stringBuilder = new StringBuilder();
			using (IEnumerator<PeerObject> enumerator = GetEnumerator())
			{
				while (enumerator.MoveNext())
				{
					PeerObject current = enumerator.Current;
					if (!flag)
					{
						stringBuilder.Append(", ");
					}
					else
					{
						flag = false;
					}
					stringBuilder.Append(current.ToString());
				}
			}
			return stringBuilder.ToString();
		}
	}
}
