using Microsoft.Win32.SafeHandles;
using System.Security;

namespace System.Net.PeerToPeer.Collaboration
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafeCollabEnum : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafeCollabEnum()
			: base(ownsHandle: true)
		{
		}

		protected override bool ReleaseHandle()
		{
			if (!IsInvalid)
			{
				UnsafeCollabNativeMethods.PeerEndEnumeration(handle);
			}
			SetHandleAsInvalid();
			SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
