using Microsoft.Win32.SafeHandles;
using System.Security;

namespace System.Net.PeerToPeer.Collaboration
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafeCollabEvent : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafeCollabEvent()
			: base(ownsHandle: true)
		{
		}

		protected override bool ReleaseHandle()
		{
			UnsafeCollabNativeMethods.PeerCollabUnregisterEvent(handle);
			SetHandleAsInvalid();
			SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
