using Microsoft.Win32.SafeHandles;
using System.Runtime.InteropServices;
using System.Security;

namespace System.Net.PeerToPeer.Collaboration
{
	[SuppressUnmanagedCodeSecurity]
	internal static class UnsafeCollabNativeMethods
	{
		private const string P2P = "p2p.dll";

		private const string CRYPT32 = "crypt32.dll";

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabStartup(short wVersionRequested);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabSignin(IntPtr hwndParent, PeerScope dwSignInOptions);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		public static extern void PeerFreeData(IntPtr dataToFree);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabSignout(PeerScope dwSignInOptions);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabGetSigninOptions(ref PeerScope dwSignInOptions);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabSetPresenceInfo(ref PEER_PRESENCE_INFO ppi);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabGetPresenceInfo(IntPtr endpoint, out SafeCollabData pPresenceInfo);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabRegisterApplication(ref PEER_APPLICATION_REGISTRATION_INFO appRegInfo, PeerApplicationRegistrationType appRegType);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabUnregisterApplication(ref GUID pApplicationId, PeerApplicationRegistrationType appRegType);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabSetObject(ref PEER_OBJECT pcObject);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabDeleteObject(ref GUID pObjectId);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabEnumObjects(IntPtr pcEndpoint, IntPtr pObjectId, out SafeCollabEnum phPeerEnum);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabEnumApplications(IntPtr pcEndpoint, IntPtr pObjectId, out SafeCollabEnum phPeerEnum);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabEnumPeopleNearMe(out SafeCollabEnum phPeerEnum);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabEnumEndpoints(ref PEER_CONTACT pcContact, out SafeCollabEnum phPeerEnum);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabEnumContacts(out SafeCollabEnum phPeerEnum);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		[SecurityCritical]
		internal static extern int PeerGetItemCount(SafeCollabEnum hPeerEnum, ref uint pCount);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		[SecurityCritical]
		internal static extern int PeerGetNextItem(SafeCollabEnum hPeerEnum, ref uint pCount, out SafeCollabData pppvItems);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerEndEnumeration(IntPtr hPeerEnum);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabGetAppLaunchInfo(out SafeCollabData ppLaunchInfo);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabGetApplicationRegistrationInfo(ref GUID pApplicationId, PeerApplicationRegistrationType registrationType, out SafeCollabData ppApplication);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabExportContact(string pwzPeerNAme, ref string ppwzContactData);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabParseContact(string pwzContactData, out SafeCollabData ppContactData);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabGetContact(string pwzPeerName, out SafeCollabData ppwzContactData);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabQueryContactData(IntPtr pcEndpoint, ref string ppwzContactData);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabAddContact(string pwzContactData, out SafeCollabData ppContact);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabDeleteContact(string pwzPeerName);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabUpdateContact(ref PEER_CONTACT pc);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabRefreshEndpointData(IntPtr pcEndpoint);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabRegisterEvent(SafeWaitHandle hEvent, uint cEventRegistration, ref PEER_COLLAB_EVENT_REGISTRATION pEventRegistrations, out SafeCollabEvent phPeerEvent);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		[SecurityCritical]
		internal static extern int PeerCollabGetEventData(SafeCollabEvent hPeerEvent, out SafeCollabData ppEventData);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabUnregisterEvent(IntPtr handle);

		[DllImport("crypt32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		[SecurityCritical]
		internal static extern SafeCertStore CertOpenStore(IntPtr lpszStoreProvider, uint dwMsgAndCertEncodingType, IntPtr hCryptProv, uint dwFlags, ref PEER_DATA pvPara);

		[DllImport("crypt32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		[SecurityCritical]
		internal static extern SafeCertStore CertOpenStore(IntPtr lpszStoreProvider, uint dwMsgAndCertEncodingType, IntPtr hCryptProv, uint dwFlags, IntPtr pvPara);

		[DllImport("crypt32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		[return: MarshalAs(UnmanagedType.U1)]
		internal static extern bool CertCloseStore(IntPtr hCertStore, uint dwFlags);

		[DllImport("crypt32.dll", CharSet = CharSet.Auto, SetLastError = true)]
		[SecurityCritical]
		[return: MarshalAs(UnmanagedType.U1)]
		internal static extern bool CertSaveStore(SafeCertStore hCertStore, uint dwMsgAndCertEncodingType, uint dwSaveAs, uint dwSaveTo, ref PEER_DATA pvSafeToPara, uint dwFlags);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabGetEndpointName(ref string ppwzEndpointName);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabSetEndpointName(string pwzEndpointName);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		[SecurityCritical]
		internal static extern int PeerCollabGetInvitationResponse(SafeCollabInvite hInvitation, out SafeCollabData ppInvitationResponse);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		[SecurityCritical]
		internal static extern int PeerCollabCancelInvitation(SafeCollabInvite hInvitation);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabCloseHandle(IntPtr hInvitation);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabInviteContact(ref PEER_CONTACT pcContact, IntPtr pcEndpoint, ref PEER_INVITATION pcInvitation, out SafeCollabData ppResponse);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabAsyncInviteContact(ref PEER_CONTACT pcContact, IntPtr pcEndpoint, ref PEER_INVITATION pcInvitation, SafeWaitHandle hEvent, out SafeCollabInvite phInvitation);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabInviteEndpoint(IntPtr pcEndpoint, ref PEER_INVITATION pcInvitation, out SafeCollabData ppResponse);

		[DllImport("p2p.dll", CharSet = CharSet.Unicode)]
		internal static extern int PeerCollabAsyncInviteEndpoint(IntPtr pcEndpoint, ref PEER_INVITATION pcInvitation, SafeWaitHandle hEvent, out SafeCollabInvite phInvitation);
	}
}
