using System.Security;
using System.Security.Permissions;

namespace System.Net.PeerToPeer
{
	[Serializable]
	[AttributeUsage(AttributeTargets.Assembly | AttributeTargets.Class | AttributeTargets.Struct | AttributeTargets.Constructor | AttributeTargets.Method, AllowMultiple = true, Inherited = false)]
	public sealed class PnrpPermissionAttribute : CodeAccessSecurityAttribute
	{
		public PnrpPermissionAttribute(SecurityAction action)
			: base(action)
		{
		}

		public override IPermission CreatePermission()
		{
			if (base.Unrestricted)
			{
				return new PnrpPermission(PermissionState.Unrestricted);
			}
			return new PnrpPermission(PermissionState.None);
		}
	}
}
