using Microsoft.Win32.SafeHandles;
using System.Runtime.InteropServices;
using System.Security;

namespace System.Net.PeerToPeer
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafePeerData : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal string UnicodeString => Marshal.PtrToStringUni(handle);

		private SafePeerData()
			: base(ownsHandle: true)
		{
		}

		protected override bool ReleaseHandle()
		{
			UnsafeP2PNativeMethods.PeerFreeData(handle);
			SetHandleAsInvalid();
			SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
