using Microsoft.Win32.SafeHandles;
using System.Security;

namespace System.Net.PeerToPeer
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafePeerNameEndResolve : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafePeerNameEndResolve()
			: base(ownsHandle: true)
		{
		}

		protected override bool ReleaseHandle()
		{
			UnsafeP2PNativeMethods.PeerPnrpEndResolve(handle);
			SetHandleAsInvalid();
			SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
