using Microsoft.Win32.SafeHandles;
using System.Security;

namespace System.Net.PeerToPeer
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafePeerNameUnregister : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafePeerNameUnregister()
			: base(ownsHandle: true)
		{
		}

		protected override bool ReleaseHandle()
		{
			UnsafeP2PNativeMethods.PeerPnrpUnregister(handle);
			SetHandleAsInvalid();
			SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
