using Microsoft.Win32.SafeHandles;
using System.Security;

namespace System.Net
{
	[SuppressUnmanagedCodeSecurity]
	[SecurityCritical(SecurityCriticalScope.Everything)]
	internal sealed class SafeLoadLibrary : SafeHandleZeroOrMinusOneIsInvalid
	{
		private const string KERNEL32 = "kernel32.dll";

		private SafeLoadLibrary()
			: base(ownsHandle: true)
		{
		}

		internal static SafeLoadLibrary LoadLibraryEx(string library)
		{
			SafeLoadLibrary safeLoadLibrary = UnsafeSystemNativeMethods.LoadLibraryExW(library, null, 0u);
			if (safeLoadLibrary.IsInvalid)
			{
				safeLoadLibrary.SetHandleAsInvalid();
			}
			return safeLoadLibrary;
		}

		protected override bool ReleaseHandle()
		{
			return UnsafeSystemNativeMethods.FreeLibrary(handle);
		}
	}
}
