﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class ByteBuffer : IDisposable
	{
		public unsafe ByteBuffer(void* impl)
		{
			this.m_impl = (DataBuffer*)impl;
		}

		public unsafe ByteBuffer()
		{
			DataBuffer* ptr = <Module>.@new(32U);
			DataBuffer* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.DataBuffer.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			DataBuffer* impl = this.m_impl;
			if (impl != null)
			{
				DataBuffer* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public uint Length
		{
			get
			{
				return <Module>.DataBuffer.getSize(this.m_impl);
			}
		}

		public byte[] GetBytes()
		{
			return CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(this.m_impl), <Module>.DataBuffer.getSize(this.m_impl));
		}

		public unsafe byte[] Left(uint numBytes)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				uint num = <Module>.DataBuffer.getSize(this.m_impl);
				if (num > numBytes)
				{
					num = numBytes;
				}
				<Module>.DataBuffer.append(ref dataBuffer, <Module>.DataBuffer.getData2(this.m_impl), num);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] Right(uint numBytes)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				uint num = <Module>.DataBuffer.getSize(this.m_impl);
				if (num > numBytes)
				{
					num = numBytes;
				}
				<Module>.DataBuffer.append(ref dataBuffer, <Module>.DataBuffer.getDataAt2(this.m_impl, <Module>.DataBuffer.getSize(ref dataBuffer) - num), num);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] Mid(uint startIdx, uint numBytes)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				uint num = <Module>.DataBuffer.getSize(this.m_impl);
				if (startIdx < num)
				{
					goto IL_47;
				}
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_47:
			byte[] result2;
			try
			{
				uint num;
				num -= startIdx;
				if (num > numBytes)
				{
					num = numBytes;
				}
				<Module>.DataBuffer.append(ref dataBuffer, <Module>.DataBuffer.getDataAt2(this.m_impl, startIdx), num);
				result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe void Replace(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			<Module>.DataBuffer.clear(this.m_impl);
			<Module>.DataBuffer.append(this.m_impl, (void*)ptr, num);
			CkMarshal.free(ptr);
		}

		public unsafe void Append(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			<Module>.DataBuffer.append(this.m_impl, (void*)ptr, num);
			CkMarshal.free(ptr);
		}

		public unsafe void Prepend(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				<Module>.DataBuffer.append(ref dataBuffer, this.m_impl);
				<Module>.DataBuffer.clear(this.m_impl);
				<Module>.DataBuffer.append(this.m_impl, ref dataBuffer);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
		}

		public unsafe void AppendStr(string str, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					Charset charset2;
					<Module>.Charset.{ctor}(ref charset2);
					try
					{
						DataBuffer dataBuffer;
						<Module>.DataBuffer.{ctor}(ref dataBuffer);
						try
						{
							<Module>.Charset.setByName(ref charset2, <Module>.XString.getUtf8(ref xstring2));
							<Module>.XString.getConverted(ref xstring, ref charset2, ref dataBuffer);
							<Module>.DataBuffer.append(this.m_impl, ref dataBuffer);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
							throw;
						}
						<Module>.DataBuffer.{dtor}(ref dataBuffer);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Charset.{dtor}), (void*)(&charset2));
						throw;
					}
					<Module>.Charset.{dtor}(ref charset2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void PrependStr(string str, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					Charset charset2;
					<Module>.Charset.{ctor}(ref charset2);
					try
					{
						DataBuffer dataBuffer;
						<Module>.DataBuffer.{ctor}(ref dataBuffer);
						try
						{
							<Module>.Charset.setByName(ref charset2, <Module>.XString.getUtf8(ref xstring2));
							<Module>.XString.getConverted(ref xstring, ref charset2, ref dataBuffer);
							DataBuffer dataBuffer2;
							<Module>.DataBuffer.{ctor}(ref dataBuffer2);
							try
							{
								<Module>.DataBuffer.append(ref dataBuffer, this.m_impl);
								<Module>.DataBuffer.clear(this.m_impl);
								<Module>.DataBuffer.append(this.m_impl, ref dataBuffer);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
								throw;
							}
							<Module>.DataBuffer.{dtor}(ref dataBuffer2);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
							throw;
						}
						<Module>.DataBuffer.{dtor}(ref dataBuffer);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Charset.{dtor}), (void*)(&charset2));
						throw;
					}
					<Module>.Charset.{dtor}(ref charset2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFromFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				if (<Module>.DataBuffer.getSize(this.m_impl) != null)
				{
					goto IL_4C;
				}
				result = (<Module>.DataBuffer.loadFileUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring), null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_4C:
			bool flag;
			try
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					flag = (<Module>.DataBuffer.loadFileUtf8(ref dataBuffer, <Module>.XString.getUtf8(ref xstring), null) != null);
					if (flag)
					{
						<Module>.DataBuffer.append(this.m_impl, ref dataBuffer);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return flag;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.DataBuffer.saveToFileUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring), null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe DataBuffer* m_impl;
	}
}
