﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Bz2 : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Bz2 LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Bz2.m_lockObject);
			Bz2 result = (Bz2)Bz2.m_objects[key];
			Monitor.Exit(Bz2.m_lockObject);
			return result;
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Bz2.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe Bz2(void* impl)
		{
			this.m_impl = (ClsBz2*)impl;
			this.OnAbortCheck = null;
		}

		public unsafe Bz2()
		{
			this.m_enableEvents = false;
			this.OnAbortCheck = null;
			<Module>.?A0x8af70974.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x8af70974.NextHashCode;
			ClsBz2* ptr = <Module>.@new(128U);
			ClsBz2* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsBz2.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 120) = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsBz2* impl = this.m_impl;
			if (impl != null)
			{
				ClsBz2* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Bz2.m_lockObject);
				object key = this.m_myHashCode;
				Bz2.m_objects.Remove(key);
				Monitor.Exit(Bz2.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public virtual void Dispose()
		{
			Monitor.Enter(Bz2.m_lockObject);
			object key = this.m_myHashCode;
			Bz2.m_objects.Remove(key);
			Monitor.Exit(Bz2.m_lockObject);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Bz2.m_lockObject);
						if (Bz2.m_objects == null)
						{
							Bz2.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Bz2.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Bz2.m_objects = new Hashtable();
									Bz2.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Bz2.m_lockObject);
					}
					else
					{
						Monitor.Enter(Bz2.m_lockObject);
						object key3 = this.m_myHashCode;
						Bz2.m_objects.Remove(key3);
						Monitor.Exit(Bz2.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressFile(string inFilename, string outFilename)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inFilename, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(outFilename, &xstring2);
						result = (<Module>.ClsBz2.UncompressFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile(string inFilename, string outFilename)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inFilename, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(outFilename, &xstring2);
						result = (<Module>.ClsBz2.CompressFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		public unsafe byte[] UncompressFileToMem(string inFilename)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inFilename, &xstring);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.ClsBz2.UncompressFileToMem(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		public unsafe byte[] CompressFileToMem(string inFilename)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inFilename, &xstring);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.ClsBz2.CompressFileToMem(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressMemToFile(byte[] inData, string outFilename)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
					XString xstring;
					<Module>.XString.{ctor}(ref xstring);
					try
					{
						CkMarshal.StringToX(outFilename, &xstring);
						result = (<Module>.ClsBz2.CompressMemToFile(this.m_impl, ref dataBuffer, ref xstring, (ProgressEvent*)ptr) != null);
						CkMarshal.free(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressMemToFile(byte[] inData, string outFilename)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bool result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
					XString xstring;
					<Module>.XString.{ctor}(ref xstring);
					try
					{
						CkMarshal.StringToX(outFilename, &xstring);
						result = (<Module>.ClsBz2.UncompressMemToFile(this.m_impl, ref dataBuffer, ref xstring, (ProgressEvent*)ptr) != null);
						CkMarshal.free(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		public unsafe byte[] CompressMemory(byte[] inData)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
					DataBuffer dataBuffer2;
					<Module>.DataBuffer.{ctor}(ref dataBuffer2);
					try
					{
						<Module>.ClsBz2.CompressMemory(this.m_impl, ref dataBuffer, ref dataBuffer2, (ProgressEvent*)ptr);
						CkMarshal.free(ptr2);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		public unsafe byte[] UncompressMemory(byte[] inData)
		{
			_Bz2Callback bz2Callback;
			<Module>.Bz2Callback.{ctor}(ref bz2Callback);
			try
			{
				bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
				*(ref bz2Callback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			byte[] result;
			try
			{
				_Bz2Callback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &bz2Callback;
					*(ref bz2Callback + 4) = this.m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
					DataBuffer dataBuffer2;
					<Module>.DataBuffer.{ctor}(ref dataBuffer2);
					try
					{
						<Module>.ClsBz2.UncompressMemory(this.m_impl, ref dataBuffer, ref dataBuffer2, (ProgressEvent*)ptr);
						CkMarshal.free(ptr2);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._Bz2Callback.{dtor}), (void*)(&bz2Callback));
				throw;
			}
			bz2Callback = ref <Module>.??_7_Bz2Callback@Chilkat@@6B@;
			<Module>.Bz2Callback.{dtor}(ref bz2Callback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string regCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(regCode, &xstring);
				int num = *(int*)this.m_impl + 4;
				result = calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.SByte modopt(System.Runtime.CompilerServices.IsSignUnspecifiedByte) modopt(System.Runtime.CompilerServices.IsConst)*), this.m_impl, <Module>.XString.getAnsi(ref xstring), *num);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public event Bz2.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsBz2* m_impl;

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
