﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CertChain : IDisposable
	{
		public unsafe CertChain(void* impl)
		{
			this.m_chain = (ClsCertChain*)impl;
		}

		public unsafe CertChain()
		{
			ClsCertChain* ptr = <Module>.@new(160U);
			ClsCertChain* chain;
			try
			{
				if (ptr != null)
				{
					chain = <Module>.ClsCertChain.{ctor}(ptr);
				}
				else
				{
					chain = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_chain = chain;
		}

		protected unsafe override void Finalize()
		{
			ClsCertChain* chain = this.m_chain;
			if (chain != null)
			{
				ClsCertChain* ptr = chain;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_chain, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_chain, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_chain, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_chain, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Cert GetCert(int index)
		{
			ClsCert* ptr = <Module>.ClsCertChain.GetCert(this.m_chain, index);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool BuildChain(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			return implementation != null && <Module>.ClsCertChain.BuildChain(this.m_chain, implementation, null) != null;
		}

		public int NumCerts
		{
			get
			{
				return <Module>.ClsCertChain.get_NumCerts(this.m_chain);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsCertChain* m_chain;
	}
}
