﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CertStore : IDisposable
	{
		public unsafe CertStore(void* impl)
		{
			this.m_impl = (ClsCertStore*)impl;
		}

		public unsafe CertStore()
		{
			ClsCertStore* ptr = <Module>.@new(128U);
			ClsCertStore* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsCertStore.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsCertStore* impl = this.m_impl;
			if (impl != null)
			{
				ClsCertStore* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
			}
		}

		public virtual void Dispose()
		{
			<Module>.ClsCertStore.dotNetDispose(this.m_impl);
		}

		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadPfxFile(string pfxFilename, string password)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(password, &xstring2);
					result = (<Module>.ClsCertStore.LoadPfxFile(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadPfxData(byte[] pfxData, string password)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(password, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(pfxData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
					result = (<Module>.ClsCertStore.LoadPfxData(this.m_impl, ref dataBuffer, ref xstring) != null);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Cert FindCertBySerial(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				ClsCert* ptr = <Module>.ClsCertStore.FindCertBySerial(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Cert FindCertBySubjectE(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				ClsCert* ptr = <Module>.ClsCertStore.FindCertBySubjectE(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Cert FindCertBySubjectO(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				ClsCert* ptr = <Module>.ClsCertStore.FindCertBySubjectO(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Cert FindCertBySubjectCN(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				ClsCert* ptr = <Module>.ClsCertStore.FindCertBySubjectCN(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Cert FindCertBySubject(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				ClsCert* ptr = <Module>.ClsCertStore.FindCertBySubject(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Cert FindCertForEmail(string emailAddress)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(emailAddress, &xstring);
				ClsCert* ptr = null;
				uint exceptionCode;
				try
				{
					ptr = <Module>.ClsCertStore.FindCertForEmail(this.m_impl, ref xstring);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BB@BHGJEPDH@FindCertForEmail?$AA@));
							goto IL_85;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_85:
				if (ptr != null)
				{
					goto IL_A7;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_A7:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Cert GetEmailCert(int index)
		{
			ClsCert* ptr = <Module>.ClsCertStore.GetEmailCert(this.m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		public unsafe Cert GetCertificate(int index)
		{
			ClsCert* ptr = <Module>.ClsCertStore.GetCertificate(this.m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveCertificate(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			return <Module>.ClsCertStore.RemoveCertificate(this.m_impl, implementation) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddCertificate(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			return <Module>.ClsCertStore.AddCertificate(this.m_impl, implementation) != null;
		}

		public int NumEmailCerts
		{
			get
			{
				return <Module>.ClsCertStore.get_NumEmailCerts(this.m_impl);
			}
		}

		public int NumCertificates
		{
			get
			{
				return <Module>.ClsCertStore.get_NumCertificates(this.m_impl);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCertStore.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateFileStore(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsCertStore.CreateFileStore(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool CreateMemoryStore()
		{
			return <Module>.ClsCertStore.CreateMemoryStore(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateRegistryStore(string regRoot, string regPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(regRoot, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(regPath, &xstring2);
					result = (<Module>.ClsCertStore.CreateRegistryStore(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Cert FindCertByRfc822Name(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				ClsCert* ptr = <Module>.ClsCertStore.FindCertByRfc822Name(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool OpenChilkatStore([MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			return <Module>.ClsCertStore.OpenChilkatStore(this.m_impl, readOnly) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool OpenCurrentUserStore([MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			return <Module>.ClsCertStore.OpenCurrentUserStore(this.m_impl, readOnly) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFileStore(string filename, [MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsCertStore.OpenFileStore(this.m_impl, ref xstring, readOnly) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool OpenOutlookStore([MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			return <Module>.ClsCertStore.OpenOutlookStore(this.m_impl, readOnly) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenRegistryStore(string regRoot, string regPath, [MarshalAs(UnmanagedType.U1)] bool readOnly)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(regRoot, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(regPath, &xstring2);
					result = (<Module>.ClsCertStore.OpenRegistryStore(this.m_impl, ref xstring, ref xstring2, readOnly) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Cert FindCertBySha1Thumbprint(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Cert result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				ClsCert* ptr = <Module>.ClsCertStore.FindCertBySha1Thumbprint(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			Cert result2;
			try
			{
				ClsCert* ptr;
				result2 = new Cert((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsCertStore* m_impl;
	}
}
