﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CkMarshal
	{
		protected override void Finalize()
		{
		}

		public unsafe static string AnsiToString(sbyte* x)
		{
			if (x == null)
			{
				return new string((sbyte*)(&<Module>.??_C@_00CNPNBAHC@?$AA@));
			}
			return new string((sbyte*)x);
		}

		public unsafe static string Utf8ToString(sbyte* x)
		{
			if (x == null)
			{
				return new string((sbyte*)(&<Module>.??_C@_00CNPNBAHC@?$AA@));
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.XString.setFromUtf8(ref xstring, x);
				IntPtr ptr = new IntPtr(<Module>.XString.getUnicode(ref xstring));
				result = Marshal.PtrToStringUni(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe static void* ManagedToUnmanaged(byte[] x, int* length)
		{
			if (x == null)
			{
				*length = 0;
				return null;
			}
			int num = x.Length;
			if (*length > num)
			{
				*length = num;
			}
			if (*length == 0)
			{
				num = x.Length;
				*length = num;
				if (num == 0)
				{
					return null;
				}
			}
			IntPtr destination = Marshal.AllocHGlobal(*length);
			Marshal.Copy(x, 0, destination, *length);
			return destination.ToPointer();
		}

		public unsafe static byte[] UnmanagedToManaged(byte* x, int length)
		{
			if (length != 0 && x != null)
			{
				IntPtr source = new IntPtr((void*)x);
				byte[] array = new byte[length];
				Marshal.Copy(source, array, 0, length);
				return array;
			}
			return new byte[0];
		}

		public unsafe static void StringToX(string s, XString* x)
		{
			if (x != null)
			{
				<Module>.XString.clear(x);
				if (s != null && s.Length != 0)
				{
					byte* ptr = (byte*)Marshal.StringToHGlobalUni(s).ToPointer();
					<Module>.XString.setFromUnicode2(x, (ushort*)ptr, s.Length);
					IntPtr hglobal = new IntPtr((void*)ptr);
					Marshal.FreeHGlobal(hglobal);
				}
			}
		}

		public unsafe static string XToString(XString* x)
		{
			if (x == null)
			{
				return string.Empty;
			}
			IntPtr ptr = new IntPtr(<Module>.XString.getUnicode(x));
			return Marshal.PtrToStringUni(ptr);
		}

		public unsafe static void free(void* x)
		{
			if (x != null)
			{
				IntPtr hglobal = new IntPtr(x);
				Marshal.FreeHGlobal(hglobal);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}
	}
}
