﻿using System;
using System.Runtime.InteropServices;
using chilkat;

namespace Chilkat
{
	public class CkString : IDisposable
	{
		public unsafe CkString(void* impl)
		{
			this.m_impl = (XString*)impl;
		}

		public unsafe CkString()
		{
			XString* ptr = <Module>.@new(136U);
			XString* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.XString.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			XString* impl = this.m_impl;
			if (impl != null)
			{
				XString* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool loadFile(string fileName, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					result = (<Module>.XString.readFile(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public sbyte charAt(int idx)
		{
			return <Module>.XString.ansiCharAt(this.m_impl, idx);
		}

		public int intValue()
		{
			return <Module>.XString.intValue(this.m_impl);
		}

		public double doubleValue()
		{
			return <Module>.XString.doubleValue(this.m_impl);
		}

		public void obfuscate()
		{
			<Module>.XString.obfus(this.m_impl);
		}

		public void unobfuscate()
		{
			<Module>.XString.unobfus(this.m_impl);
		}

		public unsafe void urlDecode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.urlDecode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void urlEncode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.urlEncode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void base64Decode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.base64Decode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void base64Encode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.base64Encode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void qpDecode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.qpDecode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void qpEncode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.qpEncode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void hexDecode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.hexDecode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void hexEncode(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.XString.hexEncode(this.m_impl, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void entityDecode()
		{
			<Module>.XString.entityDecode_A(this.m_impl);
		}

		public void entityEncode()
		{
			<Module>.XString.entityEncode_A(this.m_impl);
		}

		public void autoLinkUrls()
		{
			<Module>.XString.autoLinkUrls(this.m_impl);
		}

		public void clear()
		{
			<Module>.XString.clear(this.m_impl);
		}

		public unsafe void prepend(string s)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(s, &xstring);
				<Module>.XString.prependUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void appendInt(int n)
		{
			<Module>.XString.appendInt(this.m_impl, n);
		}

		public unsafe void append(string s)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(s, &xstring);
				<Module>.XString.appendUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void appendObfuscated(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(str, &xstring);
				<Module>.XString.unobfus(ref xstring);
				<Module>.XString.appendUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void setString(string s)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(s, &xstring);
				<Module>.XString.setFromUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public string getString()
		{
			return CkMarshal.XToString(this.m_impl);
		}

		public int getSizeUtf8()
		{
			return <Module>.XString.getSizeUtf8(this.m_impl);
		}

		public int getSizeAnsi()
		{
			return <Module>.XString.getSizeAnsi(this.m_impl);
		}

		public int getSizeUnicode()
		{
			return <Module>.XString.getSizeUnicode(this.m_impl);
		}

		public int getNumChars()
		{
			return <Module>.XString.getNumChars(this.m_impl);
		}

		public void trim()
		{
			<Module>.XString.trim(this.m_impl);
		}

		public void trim2()
		{
			<Module>.XString.trim2(this.m_impl);
		}

		public void trimInsideSpaces()
		{
			<Module>.XString.trimInsideSpaces(this.m_impl);
		}

		public unsafe int replaceAllOccurances(string pattern, string replacement)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(replacement, &xstring2);
					result = <Module>.XString.replaceAllOccurancesUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring), <Module>.XString.getUtf8(ref xstring2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool replaceFirstOccurance(string pattern, string replacement)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(replacement, &xstring2);
					result = (<Module>.XString.replaceFirstOccuranceUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring), <Module>.XString.getUtf8(ref xstring2)) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void toCRLF()
		{
			<Module>.XString.toCRLF(this.m_impl);
		}

		public void toLF()
		{
			<Module>.XString.toLF(this.m_impl);
		}

		public void eliminateChar(sbyte ansiChar, int startIndex)
		{
			<Module>.XString.eliminateAnsiChar_A(this.m_impl, ansiChar, startIndex);
		}

		public sbyte lastChar()
		{
			return <Module>.XString.lastAnsiChar_CAREFUL(this.m_impl);
		}

		public void shorten(int n)
		{
			<Module>.XString.shortenNumChars(this.m_impl, n);
		}

		public void toLowerCase()
		{
			<Module>.XString.toLowerCase(this.m_impl);
		}

		public void toUpperCase()
		{
			<Module>.XString.toUpperCase(this.m_impl);
		}

		public void encodeXMLSpecial()
		{
			<Module>.XString.encodeXMLSpecial(this.m_impl);
		}

		public void decodeXMLSpecial()
		{
			<Module>.XString.decodeXMLSpecial(this.m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool containsSubstring(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				result = (<Module>.XString.containsSubstringUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring)) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool containsSubstringNoCase(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				result = (<Module>.XString.containsSubstringNoCaseUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring)) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool equals(string s)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(s, &xstring);
				result = (<Module>.XString.equalsUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring)) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool equalsIgnoreCase(string s)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(s, &xstring);
				result = (<Module>.XString.equalsIgnoreCaseUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring)) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void removeChunk(int charStartPos, int numChars)
		{
			<Module>.XString.removeChunk(this.m_impl, charStartPos, numChars);
		}

		public void removeCharOccurances(sbyte c)
		{
			<Module>.XString.removeCharOccurances(this.m_impl, c);
		}

		public void replaceChar(sbyte c1, sbyte c2)
		{
			<Module>.XString.replaceChar(this.m_impl, c1, c2);
		}

		public void chopAtFirstChar(sbyte c1)
		{
			<Module>.XString.chopAtFirstChar(this.m_impl, c1);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool saveToFile(string filename, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					result = (<Module>.XString.saveToFile(this.m_impl, <Module>.XString.getUtf8(ref xstring), <Module>.XString.getAnsi(ref xstring2)) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool beginsWith(string s)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(s, &xstring);
				result = (<Module>.XString.beginsWithUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring)) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool loadXmlFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.DataBuffer.loadFileUtf8(ref dataBuffer, <Module>.XString.getUtf8(ref xstring), null) != null;
					if (flag)
					{
						goto IL_5D;
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return false;
			IL_5D:
			try
			{
				DataBuffer dataBuffer;
				try
				{
					<Module>.XString.clear(this.m_impl);
					StringBuffer stringBuffer;
					<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
					try
					{
						<Module>.DataBuffer.getXmlCharset(ref dataBuffer, ref stringBuffer);
						if (<Module>.chilkat.StringBuffer.getSize(ref stringBuffer) == null)
						{
							<Module>.chilkat.StringBuffer.setString(ref stringBuffer, (sbyte*)(&<Module>.??_C@_04KEPONAMI@ansi?$AA@));
						}
						<Module>.chilkat.StringBuffer.toLowerCase(ref stringBuffer);
						<Module>.XString.appendFromEncoding(this.m_impl, <Module>.DataBuffer.getData2(ref dataBuffer), <Module>.chilkat.StringBuffer.getString(ref stringBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
						throw;
					}
					<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return true;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe XString* m_impl;
	}
}
