﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class CreateCS : IDisposable
	{
		public unsafe CreateCS()
		{
			ClsCreateCS* ptr = <Module>.@new(128U);
			ClsCreateCS* ccs;
			try
			{
				if (ptr != null)
				{
					ccs = <Module>.ClsCreateCS.{ctor}(ptr);
				}
				else
				{
					ccs = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_ccs = ccs;
		}

		protected unsafe override void Finalize()
		{
			ClsCreateCS* ccs = this.m_ccs;
			if (ccs != null)
			{
				ClsCreateCS* ptr = ccs;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_ccs = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_ccs, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_ccs, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_ccs, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_ccs, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool ReadOnly
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsCreateCS.get_ReadOnly(this.m_ccs) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsCreateCS.put_ReadOnly(this.m_ccs, value);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCreateCS.get_VersionX(this.m_ccs, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe CertStore CreateRegistryStore(string regRoot, string regPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			CertStore result;
			try
			{
				CkMarshal.StringToX(regRoot, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(regPath, &xstring2);
					ClsCertStore* ptr = <Module>.ClsCreateCS.CreateRegistryStoreX(this.m_ccs, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_67;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_67:
			CertStore result2;
			try
			{
				XString xstring2;
				try
				{
					ClsCertStore* ptr;
					result2 = new CertStore((void*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe CertStore OpenRegistryStore(string regRoot, string regPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			CertStore result;
			try
			{
				CkMarshal.StringToX(regRoot, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(regPath, &xstring2);
					ClsCertStore* ptr = <Module>.ClsCreateCS.OpenRegistryStoreX(this.m_ccs, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_67;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_67:
			CertStore result2;
			try
			{
				XString xstring2;
				try
				{
					ClsCertStore* ptr;
					result2 = new CertStore((void*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe CertStore CreateFileStore(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			CertStore result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ClsCertStore* ptr = <Module>.ClsCreateCS.CreateFileStoreX(this.m_ccs, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			CertStore result2;
			try
			{
				ClsCertStore* ptr;
				result2 = new CertStore((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe CertStore OpenFileStore(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			CertStore result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ClsCertStore* ptr = <Module>.ClsCreateCS.OpenFileStoreX(this.m_ccs, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			CertStore result2;
			try
			{
				ClsCertStore* ptr;
				result2 = new CertStore((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public CertStore CreateMemoryStore()
		{
			return new CertStore(<Module>.ClsCreateCS.CreateMemoryStore(this.m_ccs));
		}

		public CertStore OpenChilkatStore()
		{
			return new CertStore(<Module>.ClsCreateCS.OpenChilkatStore(this.m_ccs));
		}

		public CertStore OpenOutlookStore()
		{
			return new CertStore(<Module>.ClsCreateCS.OpenOutlookStore(this.m_ccs));
		}

		public CertStore OpenLocalSystemStore()
		{
			return new CertStore(<Module>.ClsCreateCS.OpenLocalSystemStore(this.m_ccs));
		}

		public CertStore OpenCurrentUserStore()
		{
			return new CertStore(<Module>.ClsCreateCS.OpenCurrentUserStore(this.m_ccs));
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsCreateCS* m_ccs;
	}
}
