﻿using System;
using System.Runtime.InteropServices;
using chilkat;

namespace Chilkat
{
	public class Crypt : IDisposable
	{
		public unsafe Crypt(void* impl)
		{
			this.m_crypt = (ClsCrypt*)impl;
		}

		public unsafe Crypt()
		{
			ClsCrypt* ptr = <Module>.@new(1800U);
			ClsCrypt* crypt;
			try
			{
				if (ptr != null)
				{
					crypt = <Module>.ClsCrypt.{ctor}(ptr);
				}
				else
				{
					crypt = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_crypt = crypt;
		}

		protected unsafe override void Finalize()
		{
			ClsCrypt* crypt = this.m_crypt;
			if (crypt != null)
			{
				ClsCrypt* ptr = crypt;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_crypt + 224 / sizeof(ClsCrypt), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_crypt + 224 / sizeof(ClsCrypt), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_crypt + 224 / sizeof(ClsCrypt), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_crypt + 224 / sizeof(ClsCrypt), ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetCSP(Csp csp)
		{
			if (csp == null)
			{
				return false;
			}
			ClsCSP* implementation = (ClsCSP*)csp.GetImplementation();
			return implementation != null && <Module>.ClsCrypt.SetCSP(this.m_crypt, implementation) != null;
		}

		public void SetAlgorithmRSA()
		{
			<Module>.ClsCrypt.SetAlgorithmRSA(this.m_crypt);
		}

		public void SetAlgorithmTwofish()
		{
			<Module>.ClsCrypt.SetAlgorithmTwofish(this.m_crypt);
		}

		public void SetAlgorithmBlowfish()
		{
			<Module>.ClsCrypt.SetAlgorithmBlowfish(this.m_crypt);
		}

		public void SetAlgorithmRijndael()
		{
			<Module>.ClsCrypt.SetAlgorithmRijndael(this.m_crypt);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddSearchCertStore(CertStore certStore)
		{
			if (certStore == null)
			{
				return false;
			}
			ClsCertStore* implementation = (ClsCertStore*)certStore.GetImplementation();
			return implementation != null && <Module>.ClsCrypt.AddSearchCertStore(this.m_crypt, implementation) != null;
		}

		public unsafe void SetEncryptCertificate(Cert cert)
		{
			if (cert != null)
			{
				ClsCert* implementation = (ClsCert*)cert.GetImplementation();
				if (implementation != null)
				{
					<Module>.ClsCrypt.SetEncryptCert(this.m_crypt, implementation);
				}
			}
		}

		public unsafe void SetSigningCertificate(Cert cert)
		{
			if (cert != null)
			{
				ClsCert* implementation = (ClsCert*)cert.GetImplementation();
				if (implementation != null)
				{
					<Module>.ClsCrypt.SetSigningCert(this.m_crypt, implementation);
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsCrypt.UnlockComponentX(this.m_crypt, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsCrypt* ptr = this.m_crypt + 224 / sizeof(ClsCrypt);
			return calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), ptr, *(*(int*)ptr + 8));
		}

		public unsafe Cert LastCert
		{
			get
			{
				ClsCert* ptr = <Module>.ClsCrypt.GetLastCert(this.m_crypt);
				if (ptr == null)
				{
					return null;
				}
				return new Cert((void*)ptr);
			}
		}

		public unsafe string LastCertSubject
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCrypt.get_LastCertSubject(this.m_crypt, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastAlgorithm
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCrypt.get_LastAlgorithm(this.m_crypt, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string SigningCertSubject
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCrypt.get_SigningCertSubject(this.m_crypt, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsCrypt.put_SigningCertSubject(this.m_crypt, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string EncryptCertSubject
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCrypt.get_EncryptCertSubject(this.m_crypt, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsCrypt.put_EncryptCertSubject(this.m_crypt, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool UseStandardSearchCertStores
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsCrypt.get_UseStandardSearchCertStores(this.m_crypt) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsCrypt.put_UseStandardSearchCertStores(this.m_crypt, value);
			}
		}

		public unsafe byte[] SecretKey
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsCrypt.get_SecretKey(this.m_crypt, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
			set
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(value, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					<Module>.ClsCrypt.put_SecretKey(this.m_crypt, ref dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
		}

		public void SetModeECB()
		{
			<Module>.ClsCrypt.put_CipherMode(this.m_crypt, 1);
		}

		public void SetModeCBC()
		{
			<Module>.ClsCrypt.put_CipherMode(this.m_crypt, 0);
		}

		public unsafe string Charset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCrypt.get_Charset(this.m_crypt, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsCrypt.put_Charset(this.m_crypt, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe void SetSecretKeyViaPassPhrase(string newVal)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(newVal, &xstring);
				<Module>.ClsCrypt.PassPhraseToSecretKeyAnsi(this.m_crypt, <Module>.XString.getAnsi(ref xstring));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCrypt.get_VersionX(this.m_crypt, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int KeyLength
		{
			get
			{
				return <Module>.ClsCrypt.get_KeyLength(this.m_crypt);
			}
			set
			{
				<Module>.ClsCrypt.put_KeyLength(this.m_crypt, value);
			}
		}

		public unsafe byte[] CreateSignature(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					if (<Module>.ClsCrypt.CreateSignature(this.m_crypt, ref dataBuffer, ref dataBuffer2) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer2);
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] Encrypt(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					if (<Module>.ClsCrypt.Encrypt(this.m_crypt, ref dataBuffer, ref dataBuffer2) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer2);
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] Decrypt(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					if (<Module>.ClsCrypt.Decrypt(this.m_crypt, ref dataBuffer, ref dataBuffer2) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer2);
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifySignature(byte[] inData, byte[] sigData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			int num2 = 0;
			void* ptr2 = CkMarshal.ManagedToUnmanaged(sigData, ref num2);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer2, ptr2, num2);
					result = (<Module>.ClsCrypt.VerifySignature(this.m_crypt, ref dataBuffer, ref dataBuffer2) != null);
					CkMarshal.free(ptr);
					CkMarshal.free(ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] CreateSignatureStr(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					if (<Module>.ClsCrypt.CreateSignatureFromStr(this.m_crypt, ref xstring, ref dataBuffer) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] EncryptStr(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					if (<Module>.ClsCrypt.EncryptStringX(this.m_crypt, ref xstring, ref dataBuffer) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string DecryptStr(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					<Module>.ClsCrypt.DecryptToStringX(this.m_crypt, ref dataBuffer, ref xstring);
					CkMarshal.free(ptr);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifySignatureStr(string inData, byte[] sigData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(sigData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					result = (<Module>.ClsCrypt.VerifySignatureStr(this.m_crypt, ref xstring, ref dataBuffer) != null);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string EncodeHex(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				StringBuffer stringBuffer;
				<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
				try
				{
					<Module>.DataBuffer.toHexString(ref dataBuffer, ref stringBuffer);
					CkMarshal.free(ptr);
					result = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
					throw;
				}
				<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] DecodeHex(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.chilkat.StringBuffer.hexStringToBinary(<Module>.XString.getUtf8Sb(ref xstring), ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string EncodeBase64Str(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsCrypt.Base64EncodeStrX(this.m_crypt, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string EncodeBase64(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					<Module>.ClsCrypt.Base64EncodeX(this.m_crypt, ref dataBuffer, ref xstring);
					CkMarshal.free(ptr);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] DecodeBase64(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.ClsCrypt.Base64DecodeX(this.m_crypt, ref xstring, ref dataBuffer) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string EncodeQuotedPrintableStr(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsCrypt.QuotedPrintableEncodeStrX(this.m_crypt, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string EncodeQuotedPrintable(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					<Module>.ClsCrypt.QuotedPrintableEncodeX(this.m_crypt, ref dataBuffer, ref xstring);
					CkMarshal.free(ptr);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] DecodeQuotedPrintable(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.ClsCrypt.QuotedPrintableDecodeX(this.m_crypt, ref xstring, ref dataBuffer) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] HashSHA1(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					if (<Module>.ClsCrypt.CalcSha1Hash(this.m_crypt, ref dataBuffer, ref dataBuffer2) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer2);
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] DigestMD5(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.ClsCrypt.CalcDigestMD5(this.m_crypt, ref dataBuffer, ref dataBuffer2);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] DigestMD2(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					if (<Module>.ClsCrypt.CalcMd2Hash(this.m_crypt, ref dataBuffer, ref dataBuffer2) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer2);
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] HashSHA1Str(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					if (<Module>.ClsCrypt.CalcSha1HashStrX(this.m_crypt, ref xstring, ref dataBuffer) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] DigestMD5Str(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.ClsCrypt.CalcDigestMD5StrX(this.m_crypt, ref xstring, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] DigestMD2Str(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.ClsCrypt.CalcMd2HashStrX(this.m_crypt, ref xstring, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] IV
		{
			get
			{
				if (<Module>.ClsCrypt.get_HasIV(this.m_crypt) == null)
				{
					return null;
				}
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsCrypt.get_IV(this.m_crypt, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
			set
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(value, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					<Module>.ClsCrypt.put_IV(this.m_crypt, ref dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
		}

		public void GenerateRandomIV()
		{
			<Module>.ClsCrypt.GenerateRandomIV(this.m_crypt);
		}

		public unsafe byte[] ZipAndEncrypt(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					if (<Module>.ClsCrypt.ZipAndEncrypt(this.m_crypt, ref dataBuffer, ref dataBuffer2) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer2);
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] DecryptAndUnzip(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					if (<Module>.ClsCrypt.DecryptAndUnzip(this.m_crypt, ref dataBuffer, ref dataBuffer2) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer2);
					}
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] ZipAndEncryptStr(string inData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inData, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					if (<Module>.ClsCrypt.ZipAndEncryptStrX(this.m_crypt, ref xstring, ref dataBuffer) == null)
					{
						<Module>.DataBuffer.clear(ref dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string DecryptAndUnzipStr(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					<Module>.ClsCrypt.DecryptAndUnzipStrX(this.m_crypt, ref dataBuffer, ref xstring);
					CkMarshal.free(ptr);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsCrypt* m_crypt;
	}
}
