﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Csp : IDisposable
	{
		public unsafe Csp()
		{
			ClsCSP* ptr = <Module>.@new(272U);
			ClsCSP* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsCSP.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsCSP* impl = this.m_impl;
			if (impl != null)
			{
				ClsCSP* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Initialize()
		{
			return <Module>.ClsCSP.Initialize2(this.m_impl, true) != null;
		}

		public bool MachineKeyset
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsCSP.get_MachineKeyset(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsCSP.put_MachineKeyset(this.m_impl, value);
			}
		}

		public int ProviderType
		{
			get
			{
				return <Module>.ClsCSP.get_ProviderType(this.m_impl);
			}
		}

		public int HashAlgorithmID
		{
			get
			{
				return <Module>.ClsCSP.get_HashAlgorithmID(this.m_impl);
			}
		}

		public int EncryptAlgorithmID
		{
			get
			{
				return <Module>.ClsCSP.get_EncryptAlgorithmID(this.m_impl);
			}
		}

		public int HashNumBits
		{
			get
			{
				return <Module>.ClsCSP.get_HashNumBits(this.m_impl);
			}
		}

		public int EncryptNumBits
		{
			get
			{
				return <Module>.ClsCSP.get_EncryptNumBits(this.m_impl);
			}
		}

		public unsafe string HashAlgorithm
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCSP.get_HashAlgorithmX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string EncryptAlgorithm
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCSP.get_EncryptAlgorithmX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int NumKeyContainers
		{
			get
			{
				return <Module>.ClsCSP.get_NumKeyContainers(this.m_impl);
			}
		}

		public unsafe string KeyContainerName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCSP.get_KeyContainerNameX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsCSP.put_KeyContainerNameX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProviderName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsCSP.get_ProviderNameX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsCSP.put_ProviderNameX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int NumKeyExchangeAlgorithms
		{
			get
			{
				return <Module>.ClsCSP.get_NumKeyExchangeAlgorithms(this.m_impl);
			}
		}

		public int NumSignatureAlgorithms
		{
			get
			{
				return <Module>.ClsCSP.get_NumSignatureAlgorithms(this.m_impl);
			}
		}

		public int NumEncryptAlgorithms
		{
			get
			{
				return <Module>.ClsCSP.get_NumEncryptAlgorithms(this.m_impl);
			}
		}

		public int NumHashAlgorithms
		{
			get
			{
				return <Module>.ClsCSP.get_NumHashAlgorithms(this.m_impl);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SetProviderMicrosoftBase()
		{
			return <Module>.ClsCSP.SetProviderMicrosoftBase(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SetProviderMicrosoftStrong()
		{
			return <Module>.ClsCSP.SetProviderMicrosoftStrong(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SetProviderMicrosoftEnhanced()
		{
			return <Module>.ClsCSP.SetProviderMicrosoftEnhanced(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SetProviderMicrosoftRsaAes()
		{
			return <Module>.ClsCSP.SetProviderMicrosoftRsaAes(this.m_impl) != null;
		}

		public unsafe StringArray GetKeyContainerNames()
		{
			ClsStringArray* ptr = <Module>.ClsCSP.GetKeyContainerNames2(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new StringArray((void*)ptr);
		}

		public unsafe int SetHashAlgorithm(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = <Module>.ClsCSP.SetHashAlgorithmX(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasHashAlgorithm(string name, int numBits)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = (<Module>.ClsCSP.HasHashAlgorithmX(this.m_impl, ref xstring, numBits) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int SetEncryptAlgorithm(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = <Module>.ClsCSP.SetEncryptAlgorithmX(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasEncryptAlgorithm(string name, int numBits)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = (<Module>.ClsCSP.HasEncryptAlgorithmX(this.m_impl, ref xstring, numBits) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetKeyContainerName(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsCSP.GetKeyContainerNameX(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int GetSignatureNumBits(int index)
		{
			return <Module>.ClsCSP.GetSignatureNumBits(this.m_impl, index);
		}

		public unsafe string GetSignatureAlgorithm(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsCSP.GetSignatureAlgorithmX(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int GetKeyExchangeNumBits(int index)
		{
			return <Module>.ClsCSP.GetKeyExchangeNumBits(this.m_impl, index);
		}

		public unsafe string GetKeyExchangeAlgorithm(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsCSP.GetKeyExchangeAlgorithmX(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int GetHashNumBits(int index)
		{
			return <Module>.ClsCSP.GetHashNumBits(this.m_impl, index);
		}

		public unsafe string GetHashAlgorithm(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsCSP.GetHashAlgorithmX(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int GetEncryptionNumBits(int index)
		{
			return <Module>.ClsCSP.GetEncryptionNumBits(this.m_impl, index);
		}

		public unsafe string GetEncryptionAlgorithm(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsCSP.GetEncryptionAlgorithmX(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsCSP* m_impl;
	}
}
