﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Dsa : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Dsa LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Dsa.m_lockObject);
			Dsa result = (Dsa)Dsa.m_objects[key];
			Monitor.Exit(Dsa.m_lockObject);
			return result;
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Dsa.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe Dsa(void* impl)
		{
			this.m_impl = (ClsDsa*)impl;
			this.OnAbortCheck = null;
		}

		public unsafe Dsa()
		{
			this.m_enableEvents = false;
			this.OnAbortCheck = null;
			<Module>.?A0x531a3f79.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x531a3f79.NextHashCode;
			ClsDsa* ptr = <Module>.@new(496U);
			ClsDsa* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsDsa.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
			<Module>.?m_progLang@ClsDsa@@2HA = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsDsa* impl = this.m_impl;
			if (impl != null)
			{
				ClsDsa* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Dsa.m_lockObject);
				object key = this.m_myHashCode;
				Dsa.m_objects.Remove(key);
				Monitor.Exit(Dsa.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public virtual void Dispose()
		{
			Monitor.Enter(Dsa.m_lockObject);
			object key = this.m_myHashCode;
			Dsa.m_objects.Remove(key);
			Monitor.Exit(Dsa.m_lockObject);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl + 192 / sizeof(ClsDsa), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl + 192 / sizeof(ClsDsa), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl + 192 / sizeof(ClsDsa), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl + 192 / sizeof(ClsDsa), ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Dsa.m_lockObject);
						if (Dsa.m_objects == null)
						{
							Dsa.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Dsa.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Dsa.m_objects = new Hashtable();
									Dsa.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Dsa.m_lockObject);
					}
					else
					{
						Monitor.Enter(Dsa.m_lockObject);
						object key3 = this.m_myHashCode;
						Dsa.m_objects.Remove(key3);
						Monitor.Exit(Dsa.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public int GroupSize
		{
			get
			{
				return <Module>.ClsDsa.get_GroupSize(this.m_impl);
			}
			set
			{
				<Module>.ClsDsa.put_GroupSize(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GenKey(int numBits)
		{
			_DsaCallback dsaCallback;
			<Module>.DsaCallback.{ctor}(ref dsaCallback);
			try
			{
				dsaCallback = ref <Module>.??_7_DsaCallback@Chilkat@@6B@;
				*(ref dsaCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DsaCallback.{dtor}), (void*)(&dsaCallback));
				throw;
			}
			bool result;
			try
			{
				_DsaCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &dsaCallback;
					*(ref dsaCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsDsa.GenKey(this.m_impl, numBits, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._DsaCallback.{dtor}), (void*)(&dsaCallback));
				throw;
			}
			dsaCallback = ref <Module>.??_7_DsaCallback@Chilkat@@6B@;
			<Module>.DsaCallback.{dtor}(ref dsaCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GenKeyFromParamsDerFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsDsa.GenKeyFromParamsDerFile(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GenKeyFromParamsPemFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsDsa.GenKeyFromParamsPemFile(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GenKeyFromParamsDer(byte[] derBytes)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(derBytes, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				result = (<Module>.ClsDsa.GenKeyFromParamsDer(this.m_impl, ref dataBuffer) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GenKeyFromParamsPem(string pem)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pem, &xstring);
				result = (<Module>.ClsDsa.GenKeyFromParamsPem(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsDsa.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool VerifyKey()
		{
			return <Module>.ClsDsa.VerifyKey(this.m_impl) != null;
		}

		public unsafe string ToXml([MarshalAs(UnmanagedType.U1)] bool bPublicOnly)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsDsa.ToXml(this.m_impl, bPublicOnly, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromXml(string xmlKey)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xmlKey, &xstring);
				result = (<Module>.ClsDsa.FromXml(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromEncryptedPem(string password, string pemData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(password, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pemData, &xstring2);
					result = (<Module>.ClsDsa.FromEncryptedPem(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromPem(string pemData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pemData, &xstring);
				result = (<Module>.ClsDsa.FromPem(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveText(string strToSave, string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(strToSave, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(filename, &xstring2);
					result = (<Module>.ClsDsa.SaveText(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string ToEncryptedPem(string password)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(password, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsDsa.ToEncryptedPem(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string ToPem()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsDsa.ToPem(this.m_impl, ref xstring) != null;
				if (flag)
				{
					goto IL_36;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_36:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] ToDer()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.ClsDsa.ToDer(this.m_impl, ref dataBuffer);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ToDerFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsDsa.ToDerFile(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromDer(byte[] derData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(derData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				result = (<Module>.ClsDsa.FromDer(this.m_impl, ref dataBuffer) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromDerFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsDsa.FromDerFile(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromPublicPem(string pemData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pemData, &xstring);
				result = (<Module>.ClsDsa.FromPublicPem(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string ToPublicPem()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsDsa.ToPublicPem(this.m_impl, ref xstring) != null;
				if (flag)
				{
					goto IL_36;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_36:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] Hash
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsDsa.get_Hash(this.m_impl, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
			set
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(value, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
					<Module>.ClsDsa.put_Hash(this.m_impl, ref dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
		}

		public unsafe byte[] Signature
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsDsa.get_Signature(this.m_impl, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
			set
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(value, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
					<Module>.ClsDsa.put_Signature(this.m_impl, ref dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetEncodedHash(string encoding, string encodedHash)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(encoding, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(encodedHash, &xstring2);
					result = (<Module>.ClsDsa.SetEncodedHash(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetEncodedSignature(string encoding, string encodedSig)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(encoding, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(encodedSig, &xstring2);
					result = (<Module>.ClsDsa.SetEncodedSignature(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetEncodedSignature(string encoding)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(encoding, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsDsa.GetEncodedSignature(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetEncodedHash(string encoding)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(encoding, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsDsa.GetEncodedHash(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SignHash()
		{
			return <Module>.ClsDsa.SignHash(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Verify()
		{
			return <Module>.ClsDsa.Verify(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetKeyExplicit(int groupSizeInBytes, string pHex, string qHex, string gHex, string xHex)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pHex, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(qHex, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(gHex, &xstring3);
						XString xstring4;
						<Module>.XString.{ctor}(ref xstring4);
						try
						{
							CkMarshal.StringToX(xHex, &xstring4);
							result = (<Module>.ClsDsa.SetKeyExplicit(this.m_impl, groupSizeInBytes, ref xstring, ref xstring2, ref xstring3, ref xstring4) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring4);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ToPublicDerFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsDsa.ToPublicDerFile(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] ToPublicDer()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.ClsDsa.ToPublicDer(this.m_impl, ref dataBuffer);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromPublicDer(byte[] derData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(derData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				result = (<Module>.ClsDsa.FromPublicDer(this.m_impl, ref dataBuffer) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromPublicDerFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsDsa.FromPublicDerFile(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string HexP
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsDsa.get_HexP(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string HexQ
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsDsa.get_HexQ(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string HexG
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsDsa.get_HexG(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string HexX
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsDsa.get_HexX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string HexY
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsDsa.get_HexY(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetPubKeyExplicit(int groupSizeInBytes, string pHex, string qHex, string gHex, string yHex)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pHex, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(qHex, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(gHex, &xstring3);
						XString xstring4;
						<Module>.XString.{ctor}(ref xstring4);
						try
						{
							CkMarshal.StringToX(yHex, &xstring4);
							result = (<Module>.ClsDsa.SetPubKeyExplicit(this.m_impl, groupSizeInBytes, ref xstring, ref xstring2, ref xstring3, ref xstring4) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring4);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsDsa.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadText(string filename, string outStr)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outStr, &xstring2);
					result = (<Module>.ClsDsa.LoadText(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public event Dsa.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsDsa* m_impl;

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
