﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class EmailBundle : IDisposable
	{
		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public unsafe EmailBundle(void* b)
		{
			this.m_impl = (ClsEmailBundle*)b;
			if (b == null)
			{
				ClsEmailBundle* ptr = <Module>.@new(176U);
				ClsEmailBundle* impl;
				try
				{
					if (ptr != null)
					{
						impl = <Module>.ClsEmailBundle.{ctor}(ptr);
					}
					else
					{
						impl = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				this.m_impl = impl;
			}
		}

		public unsafe EmailBundle()
		{
			ClsEmailBundle* ptr = <Module>.@new(176U);
			ClsEmailBundle* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsEmailBundle.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl != null)
			{
				ClsEmailBundle* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public unsafe virtual void Dispose()
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsEmailBundle.dotNetDispose(impl);
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe StringArray GetUidls()
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl == null)
			{
				return null;
			}
			ClsStringArray* ptr = <Module>.ClsEmailBundle.GetUidls(impl);
			if (ptr == null)
			{
				return null;
			}
			return new StringArray((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveEmail(Email email)
		{
			if (email == null)
			{
				return false;
			}
			if (this.m_impl == null)
			{
				return false;
			}
			bool result = <Module>.ClsEmailBundle.RemoveEmail(this.m_impl, (ClsEmail*)email.LockImpl()) != null;
			email.ReleaseImpl();
			return result;
		}

		public unsafe Email GetEmail(int index)
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl == null)
			{
				return null;
			}
			ClsEmail* ptr = <Module>.ClsEmailBundle.GetCopyOfEmail(impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Email((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddEmail(Email email)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			if (ptr == null)
			{
				email.ReleaseImpl();
				return false;
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsEmailBundle.CopyAndAddEmail2(this.m_impl, ptr) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08MIKEFGOD@AddEmail?$AA@));
						goto IL_95;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_95:
			email.ReleaseImpl();
			return result;
		}

		public unsafe Email FindByHeader(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					ClsEmailBundle* impl = this.m_impl;
					if (impl != null)
					{
						goto IL_60;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_60:
			Email result2;
			try
			{
				XString xstring2;
				try
				{
					ClsEmailBundle* impl;
					ClsEmail* ptr = <Module>.ClsEmailBundle.FindByHeader(impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_A3;
					}
					result2 = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_A3:
			Email result3;
			try
			{
				XString xstring2;
				try
				{
					ClsEmail* ptr;
					result3 = new Email((void*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		public unsafe int MessageCount
		{
			get
			{
				ClsEmailBundle* impl = this.m_impl;
				if (impl == null)
				{
					return 0;
				}
				return <Module>.ClsEmailBundle.get_MessageCount(impl);
			}
		}

		public unsafe string GetXml()
		{
			if (this.m_impl == null)
			{
				return null;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsEmailBundle.GetXml(this.m_impl, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveXml(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ClsEmailBundle* impl = this.m_impl;
				if (impl != null)
				{
					goto IL_35;
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return false;
			IL_35:
			bool result;
			try
			{
				ClsEmailBundle* impl;
				result = (<Module>.ClsEmailBundle.SaveXml(impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXml(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsEmailBundle.LoadXml(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXmlString(string xmlStr)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xmlStr, &xstring);
				result = (<Module>.ClsEmailBundle.LoadXmlString(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void SortBySubject([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsEmailBundle.SortBySubject(impl, ascending);
			}
		}

		public unsafe void SortBySender([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsEmailBundle.SortBySender(impl, ascending);
			}
		}

		public unsafe void SortByRecipient([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsEmailBundle.SortByRecipient(impl, ascending);
			}
		}

		public unsafe void SortByDate([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			ClsEmailBundle* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsEmailBundle.SortByDate(impl, ascending);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool RemoveEmailByIndex(int index)
		{
			return <Module>.ClsEmailBundle.RemoveEmailByIndex(this.m_impl, index) != null;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsEmailBundle* m_impl;
	}
}
