﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class FileAddedEventArgs : EventArgs
	{
		public unsafe FileAddedEventArgs(sbyte* fileName, uint fileSize)
		{
			this.m_fileSize = fileSize;
			this.m_abort = false;
			this.m_fileName = CkMarshal.Utf8ToString(fileName);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public string FileName
		{
			get
			{
				return this.m_fileName;
			}
		}

		public uint FileSize
		{
			get
			{
				return this.m_fileSize;
			}
		}

		public bool Abort
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_abort;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				this.m_abort = value;
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private string m_fileName;

		private uint m_fileSize;

		private bool m_abort;
	}
}
