﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;
using chilkat;

namespace Chilkat
{
	public class Ftp2 : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Ftp2 LookupFtp(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Ftp2.m_lockObject);
			Ftp2 result = (Ftp2)Ftp2.m_ftpObjects[key];
			Monitor.Exit(Ftp2.m_lockObject);
			return result;
		}

		public void FireFtpPercentDone(object sender, FtpPercentDoneEventArgs args)
		{
			Ftp2.FtpPercentDoneEventHandler onFtpPercentDone = this.OnFtpPercentDone;
			if (onFtpPercentDone != null)
			{
				onFtpPercentDone(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Ftp2.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public void FireDataPort(object sender, DataPortEventArgs args)
		{
			Ftp2.DataPortEventHandler onDataPort = this.OnDataPort;
			if (onDataPort != null)
			{
				onDataPort(sender, args);
			}
		}

		public void FireBeginDownloadFile(object sender, FtpTreeEventArgs args)
		{
			Ftp2.BeginDownloadFileEventHandler onBeginDownloadFile = this.OnBeginDownloadFile;
			if (onBeginDownloadFile != null)
			{
				onBeginDownloadFile(sender, args);
			}
		}

		public void FireEndDownloadFile(object sender, FtpTreeEventArgs args)
		{
			Ftp2.EndDownloadFileEventHandler onEndDownloadFile = this.OnEndDownloadFile;
			if (onEndDownloadFile != null)
			{
				onEndDownloadFile(sender, args);
			}
		}

		public void FireVerifyDownloadDir(object sender, FtpTreeEventArgs args)
		{
			Ftp2.VerifyDownloadDirEventHandler onVerifyDownloadDir = this.OnVerifyDownloadDir;
			if (onVerifyDownloadDir != null)
			{
				onVerifyDownloadDir(sender, args);
			}
		}

		public void FireBeginUploadFile(object sender, FtpTreeEventArgs args)
		{
			Ftp2.BeginUploadFileEventHandler onBeginUploadFile = this.OnBeginUploadFile;
			if (onBeginUploadFile != null)
			{
				onBeginUploadFile(sender, args);
			}
		}

		public void FireEndUploadFile(object sender, FtpTreeEventArgs args)
		{
			Ftp2.EndUploadFileEventHandler onEndUploadFile = this.OnEndUploadFile;
			if (onEndUploadFile != null)
			{
				onEndUploadFile(sender, args);
			}
		}

		public void FireVerifyUploadDir(object sender, FtpTreeEventArgs args)
		{
			Ftp2.VerifyUploadDirEventHandler onVerifyUploadDir = this.OnVerifyUploadDir;
			if (onVerifyUploadDir != null)
			{
				onVerifyUploadDir(sender, args);
			}
		}

		public void FireVerifyDeleteFile(object sender, FtpTreeEventArgs args)
		{
			Ftp2.VerifyDeleteFileEventHandler onVerifyDeleteFile = this.OnVerifyDeleteFile;
			if (onVerifyDeleteFile != null)
			{
				onVerifyDeleteFile(sender, args);
			}
		}

		public void FireVerifyDeleteDir(object sender, FtpTreeEventArgs args)
		{
			Ftp2.VerifyDeleteDirEventHandler onVerifyDeleteDir = this.OnVerifyDeleteDir;
			if (onVerifyDeleteDir != null)
			{
				onVerifyDeleteDir(sender, args);
			}
		}

		public unsafe Ftp2()
		{
			this.m_enableEvents = false;
			this.OnFtpPercentDone = null;
			this.OnAbortCheck = null;
			this.OnDataPort = null;
			this.OnBeginDownloadFile = null;
			this.OnEndDownloadFile = null;
			this.OnVerifyDownloadDir = null;
			this.OnBeginUploadFile = null;
			this.OnEndUploadFile = null;
			this.OnVerifyUploadDir = null;
			this.OnVerifyDeleteFile = null;
			this.OnVerifyDeleteDir = null;
			this.m_lockImpl = new object();
			Monitor.Enter(Ftp2.m_lockObject);
			<Module>.?A0x1be8bb0a.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x1be8bb0a.NextHashCode;
			ClsFtp2* ptr = <Module>.@new(1552U);
			ClsFtp2* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsFtp2.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 1544) = 2;
			Monitor.Exit(Ftp2.m_lockObject);
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			Monitor.Enter(this.m_lockImpl);
			ClsFtp2* impl = this.m_impl;
			if (impl != null)
			{
				if (*(byte*)(impl + 545 / sizeof(ClsFtp2)) != 0)
				{
					*(byte*)(impl + 544 / sizeof(ClsFtp2)) = 1;
				}
				else
				{
					ClsFtp2* ptr = impl;
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				}
			}
			Monitor.Exit(this.m_lockImpl);
			uint exceptionCode;
			try
			{
				Monitor.Enter(Ftp2.m_lockObject);
				Ftp2.m_ftpObjects.Remove(this);
				Monitor.Exit(Ftp2.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(Ftp2.m_lockObject);
			ClsFtp2* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsFtp2.dotNetDispose(impl);
			}
			Ftp2.m_ftpObjects.Remove(this);
			Monitor.Exit(Ftp2.m_lockObject);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Disconnect()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(this.m_lockImpl);
			uint exceptionCode;
			try
			{
				_FtpCallback ftpCallback;
				<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						int myHashCode = this.m_myHashCode;
						*(ref ftpCallback + 4) = myHashCode;
					}
					result = (<Module>.ClsFtp2.Disconnect(this.m_impl, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0L@CMGJAGDM@Disconnect?$AA@));
						goto IL_BA;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_BA:
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(this.m_lockImpl);
			uint exceptionCode;
			try
			{
				_FtpCallback ftpCallback;
				<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						int myHashCode = this.m_myHashCode;
						*(ref ftpCallback + 4) = myHashCode;
					}
					result = (<Module>.ClsFtp2.Connect(this.m_impl, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07FJPHLACI@Connect?$AA@));
						goto IL_BA;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_BA:
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		public unsafe bool IsConnected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				bool result = false;
				Monitor.Enter(this.m_lockImpl);
				uint exceptionCode;
				try
				{
					_FtpCallback ftpCallback;
					<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							int myHashCode = this.m_myHashCode;
							*(ref ftpCallback + 4) = myHashCode;
						}
						result = (<Module>.ClsFtp2.get_IsConnected(this.m_impl, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0M@ILOEPEDD@IsConnected?$AA@));
							goto IL_BA;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_BA:
				Monitor.Exit(this.m_lockImpl);
				return result;
			}
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_SessionLogX(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public void ClearSessionLog()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsFtp2.ClearSessionLog(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_KeepSessionLog(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_KeepSessionLog(this.m_impl, value);
			}
		}

		public unsafe int DeleteMatching(string remotePattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(remotePattern, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = <Module>.ClsFtp2.DeleteMatchingUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring), (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int MGetFiles(string remotePattern, string localDir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(remotePattern, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(localDir, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						result = <Module>.ClsFtp2.MGetFilesUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring), <Module>.XString.getUtf8(ref xstring2), (ProgressEvent*)ptr);
						Monitor.Exit(this.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int MPutFiles(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = <Module>.ClsFtp2.MPutFilesUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring), (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string Version
		{
			get
			{
				StringBuffer stringBuffer;
				<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
				string result;
				try
				{
					<Module>.ClsFtp2.get_Version(this.m_impl, ref stringBuffer);
					result = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
					throw;
				}
				<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
				return result;
			}
		}

		public void ClearDirCache()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsFtp2.ClearDirCache(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ClearControlChannel()
		{
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsFtp2.ClearControlChannel(this.m_impl, (ProgressEvent*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Noop()
		{
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsFtp2.Noop(this.m_impl, (ProgressEvent*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RenameRemoteFile(string existingFilename, string newFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(existingFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(newFilename, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsFtp2.RenameRemoteFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						Monitor.Exit(this.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteRemoteFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsFtp2.DeleteRemoteFile(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveRemoteDir(string dir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dir, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsFtp2.RemoveRemoteDir(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateRemoteDir(string dir)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dir, &xstring);
				result = false;
				Monitor.Enter(this.m_lockImpl);
				uint exceptionCode;
				try
				{
					_FtpCallback ftpCallback;
					<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							int myHashCode = this.m_myHashCode;
							*(ref ftpCallback + 4) = myHashCode;
						}
						result = (<Module>.ClsFtp2.CreateRemoteDir(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BA@HFOBHHFC@CreateRemoteDir?$AA@));
							goto IL_CC;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_CC:
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetXmlDirListing(string pattern)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = false;
					Monitor.Enter(this.m_lockImpl);
					uint exceptionCode;
					try
					{
						_FtpCallback ftpCallback;
						<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								int myHashCode = this.m_myHashCode;
								*(ref ftpCallback + 4) = myHashCode;
							}
							flag = (<Module>.ClsFtp2.GetXmlDirListing(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BB@KODMFMBC@GetXmlDirListing?$AA@));
								goto IL_D6;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
					IL_D6:
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_11A;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_11A:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetTextDirListing(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsFtp2.GetTextDirListing(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						Monitor.Exit(this.m_lockImpl);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_D4:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_FtpCallback ftpCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutFileFromBinaryData(string remoteFilename, byte[] content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(content, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr2 = null;
						if (this.m_enableEvents)
						{
							ptr2 = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsFtp2.PutFileFromBinaryData(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr2) != null);
						Monitor.Exit(this.m_lockImpl);
						CkMarshal.free(ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutFileFromTextData(string remoteFilename, string textData, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(textData, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(charset, &xstring3);
						Monitor.Enter(this.m_lockImpl);
						_FtpCallback ftpCallback;
						<Module>.FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
							*(ref ftpCallback + 4) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								*(ref ftpCallback + 4) = this.m_myHashCode;
							}
							result = (<Module>.ClsFtp2.PutFileFromTextDataUtf8(this.m_impl, ref xstring, <Module>.XString.getUtf8(ref xstring2), <Module>.XString.getUtf8(ref xstring3), (ProgressEvent*)ptr) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						<Module>.FtpCallback.{dtor}(ref ftpCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] GetRemoteFileBinaryData(string remoteFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsFtp2.GetRemoteFileBinaryData(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr) != null;
						Monitor.Exit(this.m_lockImpl);
						if (!flag)
						{
							goto IL_E6;
						}
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_E6:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					_FtpCallback ftpCallback;
					try
					{
						result2 = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetRemoteFileTextData(string remoteFilename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = false;
					Monitor.Enter(this.m_lockImpl);
					uint exceptionCode;
					try
					{
						_FtpCallback ftpCallback;
						<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								int myHashCode = this.m_myHashCode;
								*(ref ftpCallback + 4) = myHashCode;
							}
							flag = (<Module>.ClsFtp2.GetRemoteFileTextData(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BG@NAOAHMCE@GetRemoteFileTextData?$AA@));
								goto IL_D6;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
					IL_D6:
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_11A;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_11A:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetCurrentRemoteDir()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = false;
				Monitor.Enter(this.m_lockImpl);
				uint exceptionCode;
				try
				{
					_FtpCallback ftpCallback;
					<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							int myHashCode = this.m_myHashCode;
							*(ref ftpCallback + 4) = myHashCode;
						}
						flag = (<Module>.ClsFtp2.GetCurrentRemoteDir(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BE@DDDBAFBM@GetCurrentRemoteDir?$AA@));
							goto IL_C4;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_C4:
				Monitor.Exit(this.m_lockImpl);
				if (flag)
				{
					goto IL_F1;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_F1:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChangeRemoteDir(string relativeDirPath)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(relativeDirPath, &xstring);
				result = false;
				Monitor.Enter(this.m_lockImpl);
				uint exceptionCode;
				try
				{
					_FtpCallback ftpCallback;
					<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							int myHashCode = this.m_myHashCode;
							*(ref ftpCallback + 4) = myHashCode;
						}
						result = (<Module>.ClsFtp2.ChangeRemoteDir(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BA@BDNGPACJ@ChangeRemoteDir?$AA@));
							goto IL_CC;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_CC:
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetFile(string remoteFilename, string localFilename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(localFilename, &xstring2);
					result = false;
					Monitor.Enter(this.m_lockImpl);
					uint exceptionCode;
					try
					{
						_FtpCallback ftpCallback;
						<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								int myHashCode = this.m_myHashCode;
								*(ref ftpCallback + 4) = myHashCode;
							}
							result = (<Module>.ClsFtp2.GetFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07DIGCHPDB@GetFile?$AA@));
								goto IL_DE;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
					IL_DE:
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutFile(string localFilename, string remoteFilename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xstring2);
					result = false;
					Monitor.Enter(this.m_lockImpl);
					uint exceptionCode;
					try
					{
						_FtpCallback ftpCallback;
						<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								int myHashCode = this.m_myHashCode;
								*(ref ftpCallback + 4) = myHashCode;
							}
							result = (<Module>.ClsFtp2.PutFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07CJMCNLMN@PutFile?$AA@));
								goto IL_DE;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
					IL_DE:
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFileFromBinaryData(string remoteFilename, byte[] content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(content, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr2 = null;
						if (this.m_enableEvents)
						{
							ptr2 = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsFtp2.AppendFileFromBinaryData(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr2) != null);
						Monitor.Exit(this.m_lockImpl);
						CkMarshal.free(ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFileFromTextData(string remoteFilename, string textData, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(textData, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(charset, &xstring3);
						Monitor.Enter(this.m_lockImpl);
						_FtpCallback ftpCallback;
						<Module>.FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
							*(ref ftpCallback + 4) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								*(ref ftpCallback + 4) = this.m_myHashCode;
							}
							result = (<Module>.ClsFtp2.AppendFileFromTextDataUtf8(this.m_impl, ref xstring, <Module>.XString.getUtf8(ref xstring2), <Module>.XString.getUtf8(ref xstring3), (ProgressEvent*)ptr) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						<Module>.FtpCallback.{dtor}(ref ftpCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFile(string localFilename, string remoteFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsFtp2.AppendFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						Monitor.Exit(this.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool PassiveUseHostAddr
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_PassiveUseHostAddr(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_PassiveUseHostAddr(this.m_impl, value);
			}
		}

		public bool Ssl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_Ssl(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_Ssl(this.m_impl, value);
			}
		}

		public bool AuthTls
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AuthTls(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_AuthTls(this.m_impl, value);
			}
		}

		public bool RestartNext
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_RestartNext(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_RestartNext(this.m_impl, value);
			}
		}

		public bool AutoFeat
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AutoFeat(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_AutoFeat(this.m_impl, value);
			}
		}

		public bool AutoXcrc
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AutoXcrc(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_AutoXcrc(this.m_impl, value);
			}
		}

		public bool AutoSyst
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AutoSyst(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_AutoSyst(this.m_impl, value);
			}
		}

		public unsafe string DirListingCharset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_DirListingCharset(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_DirListingCharset(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ListPattern
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_ListPatternX(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_ListPatternUtf8(this.m_impl, <Module>.XString.getUtf8(ref xstring));
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Account
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_Account(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_Account(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Password
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_PasswordX(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
					<Module>.XString.secureClear(ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_PasswordX(this.m_impl, ref xstring);
					<Module>.XString.secureClear(ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Username
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_UsernameX(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_UsernameX(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int Port
		{
			get
			{
				return <Module>.ClsFtp2.get_Port(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_Port(this.m_impl, value);
			}
		}

		public int ProxyPort
		{
			get
			{
				return <Module>.ClsFtp2.get_ProxyPort(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ProxyPort(this.m_impl, value);
			}
		}

		public int ActivePortRangeStart
		{
			get
			{
				return <Module>.ClsFtp2.get_ActivePortRangeStart(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ActivePortRangeStart(this.m_impl, value);
			}
		}

		public int ActivePortRangeEnd
		{
			get
			{
				return <Module>.ClsFtp2.get_ActivePortRangeEnd(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ActivePortRangeEnd(this.m_impl, value);
			}
		}

		public uint AllocateSize
		{
			get
			{
				return <Module>.ClsFtp2.get_AllocateSize(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_AllocateSize(this.m_impl, value);
			}
		}

		public unsafe string Hostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_Hostname(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_Hostname(this.m_impl, <Module>.XString.getAnsi(ref xstring));
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool Passive
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_Passive(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_Passive(this.m_impl, value);
			}
		}

		public bool SkipFinalReply
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_SkipFinalReply(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_SkipFinalReply(this.m_impl, value);
			}
		}

		public unsafe int GetSize(int index)
		{
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			int result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsFtp2.GetSize(this.m_impl, index, (ProgressEvent*)ptr);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public unsafe string GetSizeStr(int index)
		{
			StringBuffer stringBuffer;
			<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
			string result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsFtp2.GetSizeStr(this.m_impl, index, ref stringBuffer, (ProgressEvent*)ptr) != null;
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_AC;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
				throw;
			}
			<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
			return result;
			IL_AC:
			string result2;
			try
			{
				_FtpCallback ftpCallback;
				try
				{
					result2 = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
				throw;
			}
			<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
			return result2;
		}

		public bool LoginVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_LoginVerified(this.m_impl) != null;
			}
		}

		public bool ConnectVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_ConnectVerified(this.m_impl) != null;
			}
		}

		public bool HasModeZ
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_HasModeZ(this.m_impl) != null;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SetModeZ()
		{
			return <Module>.ClsFtp2.SetModeZ(this.m_impl, null) != null;
		}

		public long AsyncBytesReceived64
		{
			get
			{
				return <Module>.ClsFtp2.get_AsyncBytesReceived64(this.m_impl);
			}
		}

		public long AsyncBytesSent64
		{
			get
			{
				return <Module>.ClsFtp2.get_AsyncBytesSent64(this.m_impl);
			}
		}

		public long ProgressMonSize64
		{
			get
			{
				return <Module>.ClsFtp2.get_ProgressMonSize64(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ProgressMonSize64(this.m_impl, value);
			}
		}

		public int BandwidthThrottleUp
		{
			get
			{
				return <Module>.ClsFtp2.get_BandwidthThrottleUp(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_BandwidthThrottleUp(this.m_impl, value);
			}
		}

		public int BandwidthThrottleDown
		{
			get
			{
				return <Module>.ClsFtp2.get_BandwidthThrottleDown(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_BandwidthThrottleDown(this.m_impl, value);
			}
		}

		public unsafe string GetRemoteFileTextC(string remoteFilename, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						_FtpCallback ftpCallback;
						<Module>.FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
							*(ref ftpCallback + 4) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								*(ref ftpCallback + 4) = this.m_myHashCode;
							}
							bool flag = <Module>.ClsFtp2.GetRemoteFileTextC(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_E7;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						<Module>.FtpCallback.{dtor}(ref ftpCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_E7:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						_FtpCallback ftpCallback;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						<Module>.FtpCallback.{dtor}(ref ftpCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int ProgressMonSize
		{
			get
			{
				return <Module>.ClsFtp2.get_ProgressMonSize(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ProgressMonSize(this.m_impl, value);
			}
		}

		public unsafe int ConnectFailReason
		{
			get
			{
				return *(int*)(this.m_impl + 1548 / sizeof(ClsFtp2));
			}
		}

		public int CrlfMode
		{
			get
			{
				return <Module>.ClsFtp2.get_CrlfMode(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_CrlfMode(this.m_impl, value);
			}
		}

		public int ReadTimeout
		{
			get
			{
				return <Module>.ClsFtp2.get_ReadTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ReadTimeout(this.m_impl, value);
			}
		}

		public int ConnectTimeout
		{
			get
			{
				return <Module>.ClsFtp2.get_ConnectTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ConnectTimeout(this.m_impl, value);
			}
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsFtp2.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_HeartbeatMs(this.m_impl, value);
			}
		}

		public int IdleTimeoutMs
		{
			get
			{
				return <Module>.ClsFtp2.get_IdleTimeoutMs(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_IdleTimeoutMs(this.m_impl, value);
			}
		}

		public int DownloadRate
		{
			get
			{
				return <Module>.ClsFtp2.get_DownloadRate(this.m_impl);
			}
		}

		public int UploadRate
		{
			get
			{
				return <Module>.ClsFtp2.get_UploadRate(this.m_impl);
			}
		}

		public unsafe DateTime GetCreateTimeByName(string filename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			DateTime result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					<Module>.ClsFtp2.GetLocalCreateSysTimeByName(this.m_impl, ref xstring, ref year, (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
					result = default(DateTime);
					uint exceptionCode;
					try
					{
						DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
						result = dateTime;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								result = DateTime.Now;
								goto IL_11F;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				IL_11F:
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe DateTime GetLastAccessTimeByName(string filename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			DateTime result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					<Module>.ClsFtp2.GetLocalLastAccessSysTimeByName(this.m_impl, ref xstring, ref year, (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
					result = default(DateTime);
					uint exceptionCode;
					try
					{
						DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
						result = dateTime;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								result = DateTime.Now;
								goto IL_11F;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				IL_11F:
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe DateTime GetLastModifiedTimeByName(string filename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			DateTime result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					<Module>.ClsFtp2.GetLocalLastModifiedSysTimeByName(this.m_impl, ref xstring, ref year, (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
					result = default(DateTime);
					uint exceptionCode;
					try
					{
						DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
						result = dateTime;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								result = DateTime.Now;
								goto IL_11F;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				IL_11F:
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int GetSizeByName(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = <Module>.ClsFtp2.GetSizeByName(this.m_impl, ref xstring, (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetFilename(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsFtp2.GetFilename(this.m_impl, index, ref xstring, (ProgressEvent*)ptr) != null;
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_AC;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_AC:
			string result2;
			try
			{
				_FtpCallback ftpCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetIsDirectory(int index)
		{
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsFtp2.GetIsDirectory(this.m_impl, index, (ProgressEvent*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetIsSymbolicLink(int index)
		{
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsFtp2.GetIsSymbolicLink(this.m_impl, index, (ProgressEvent*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public unsafe DateTime GetCreateTime(int index)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ChilkatSysTime year;
			<Module>.ChilkatSysTime.{ctor}(ref year);
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			DateTime result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				<Module>.ClsFtp2.GetLocalCreateSysTime(this.m_impl, index, ref year, (ProgressEvent*)ptr);
				Monitor.Exit(this.m_lockImpl);
				result = default(DateTime);
				uint exceptionCode;
				try
				{
					DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
					result = dateTime;
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							result = DateTime.Now;
							goto IL_10E;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			IL_10E:
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public unsafe DateTime GetLastAccessTime(int index)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ChilkatSysTime year;
			<Module>.ChilkatSysTime.{ctor}(ref year);
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			DateTime result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				<Module>.ClsFtp2.GetLocalLastAccessSysTime(this.m_impl, index, ref year, (ProgressEvent*)ptr);
				Monitor.Exit(this.m_lockImpl);
				result = default(DateTime);
				uint exceptionCode;
				try
				{
					DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
					result = dateTime;
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							result = DateTime.Now;
							goto IL_10E;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			IL_10E:
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public unsafe DateTime GetLastModifiedTime(int index)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ChilkatSysTime year;
			<Module>.ChilkatSysTime.{ctor}(ref year);
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			DateTime result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				<Module>.ClsFtp2.GetLocalLastModifiedSysTime(this.m_impl, index, ref year, (ProgressEvent*)ptr);
				Monitor.Exit(this.m_lockImpl);
				result = default(DateTime);
				uint exceptionCode;
				try
				{
					DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
					result = dateTime;
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							result = DateTime.Now;
							goto IL_10E;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			IL_10E:
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public unsafe int NumFilesAndDirs
		{
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				int result = 0;
				Monitor.Enter(this.m_lockImpl);
				uint exceptionCode;
				try
				{
					_FtpCallback ftpCallback;
					<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							int myHashCode = this.m_myHashCode;
							*(ref ftpCallback + 4) = myHashCode;
						}
						result = <Module>.ClsFtp2.get_NumFilesAndDirs(this.m_impl, (ProgressEvent*)ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BA@KBIGLBG@NumFilesAndDirs?$AA@));
							goto IL_BA;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_BA:
				Monitor.Exit(this.m_lockImpl);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DownloadTree(string localRoot)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(localRoot, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsFtp2.DownloadTree(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteTree()
		{
			Monitor.Enter(this.m_lockImpl);
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsFtp2.DeleteTree(this.m_impl, (ProgressEvent*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SyncRemoteTree(string localRoot, int mode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(localRoot, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsFtp2.SyncRemoteTree(this.m_impl, ref xstring, mode, (ProgressEvent*)ptr) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SyncLocalTree(string localRoot, int mode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(localRoot, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsFtp2.SyncLocalTree(this.m_impl, ref xstring, mode, (ProgressEvent*)ptr) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string ProxyHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_ProxyHostname(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_ProxyHostname(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_ProxyUsername(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_ProxyUsername(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_ProxyPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.put_ProxyPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int ProxyMethod
		{
			get
			{
				return <Module>.ClsFtp2.get_ProxyMethod(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_ProxyMethod(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			Monitor.Enter(Ftp2.m_lockObject);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsFtp2.UnlockComponentX(this.m_impl, ref xstring) != null);
				Monitor.Exit(this.m_lockImpl);
				Monitor.Exit(Ftp2.m_lockObject);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsFtp2* impl = this.m_impl;
			return calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), impl, *(*(int*)impl + 8));
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetTypeBinary()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(this.m_lockImpl);
			uint exceptionCode;
			try
			{
				_FtpCallback ftpCallback;
				<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						int myHashCode = this.m_myHashCode;
						*(ref ftpCallback + 4) = myHashCode;
					}
					result = (<Module>.ClsFtp2.SetTypeBinary(this.m_impl, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0O@BLFCMLEP@SetTypeBinary?$AA@));
						goto IL_BA;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_BA:
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetTypeAscii()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			bool result = false;
			Monitor.Enter(this.m_lockImpl);
			uint exceptionCode;
			try
			{
				_FtpCallback ftpCallback;
				<Module>.Chilkat._FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						int myHashCode = this.m_myHashCode;
						*(ref ftpCallback + 4) = myHashCode;
					}
					result = (<Module>.ClsFtp2.SetTypeAscii(this.m_impl, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				<Module>.Chilkat._FtpCallback.{dtor}(ref ftpCallback);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0N@IDDMECLP@SetTypeAscii?$AA@));
						goto IL_BA;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_BA:
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Quote(string cmd)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(cmd, &xstring);
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsFtp2.Quote(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Site(string @params)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(@params, &xstring);
				Monitor.Enter(this.m_lockImpl);
				if (this.m_enableEvents)
				{
					_FtpCallback* ptr = <Module>.@new(8U);
					_FtpCallback* ptr2;
					try
					{
						if (ptr != null)
						{
							<Module>.FtpCallback.{ctor}(ptr);
							try
							{
								*(int*)ptr = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
								*(int*)(ptr + 4 / sizeof(_FtpCallback)) = 0;
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)ptr);
								throw;
							}
							ptr2 = ptr;
						}
						else
						{
							ptr2 = 0;
						}
					}
					catch
					{
						<Module>.delete((void*)ptr);
						throw;
					}
					int myHashCode = this.m_myHashCode;
					*(ptr2 + 4) = myHashCode;
					result = (<Module>.ClsFtp2.Site(this.m_impl, ref xstring, ptr2) != null);
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
				}
				else
				{
					result = (<Module>.ClsFtp2.Site(this.m_impl, ref xstring, null) != null);
				}
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string Syst()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsFtp2.Syst(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null;
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_AB;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_AB:
			string result2;
			try
			{
				_FtpCallback ftpCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string Feat()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsFtp2.Feat(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null;
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_AB;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_AB:
			string result2;
			try
			{
				_FtpCallback ftpCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string Stat()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				_FtpCallback ftpCallback;
				<Module>.FtpCallback.{ctor}(ref ftpCallback);
				try
				{
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					*(ref ftpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				try
				{
					_FtpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &ftpCallback;
						*(ref ftpCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsFtp2.Stat(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null;
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_AB;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_AB:
			string result2;
			try
			{
				_FtpCallback ftpCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
					throw;
				}
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				<Module>.FtpCallback.{dtor}(ref ftpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string SendCommand(string cmd)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(cmd, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsFtp2.SendCommand(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						Monitor.Exit(this.m_lockImpl);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_D4:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_FtpCallback ftpCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string CreatePlan(string localDir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(localDir, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					bool flag = <Module>.ClsFtp2.PutTree(this.m_impl, ref xstring2, ref xstring, true, 0, null) != null;
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_78;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_78:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutTree(string localDir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(localDir, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsFtp2.PutTree(this.m_impl, ref xstring2, ref xstring, false, 0, (ProgressEvent*)ptr) != null);
						Monitor.Exit(this.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool PutPlan(string plan, string alreadyDoneFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(plan, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(alreadyDoneFilename, &xstring3);
						Monitor.Enter(this.m_lockImpl);
						_FtpCallback ftpCallback;
						<Module>.FtpCallback.{ctor}(ref ftpCallback);
						try
						{
							ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
							*(ref ftpCallback + 4) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						try
						{
							_FtpCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &ftpCallback;
								*(ref ftpCallback + 4) = this.m_myHashCode;
							}
							result = (<Module>.ClsFtp2.PutPlan(this.m_impl, ref xstring2, ref xstring3, ref xstring, (ProgressEvent*)ptr) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
							throw;
						}
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						<Module>.FtpCallback.{dtor}(ref ftpCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool SslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				Monitor.Enter(this.m_lockImpl);
				bool result = <Module>.ClsFtp2.get_SslServerCertVerified(this.m_impl) != null;
				Monitor.Exit(this.m_lockImpl);
				return result;
			}
		}

		public unsafe Cert GetSslServerCert()
		{
			Monitor.Enter(this.m_lockImpl);
			ClsCert* ptr = <Module>.ClsFtp2.GetSslServerCert(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		public bool RequireSslCertVerify
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				Monitor.Enter(this.m_lockImpl);
				bool result = <Module>.ClsFtp2.get_RequireSslCertVerify(this.m_impl) != null;
				Monitor.Exit(this.m_lockImpl);
				return result;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				Monitor.Enter(this.m_lockImpl);
				<Module>.ClsFtp2.put_RequireSslCertVerify(this.m_impl, value);
				Monitor.Exit(this.m_lockImpl);
			}
		}

		public unsafe void SetSslCertRequirement(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.SetSslCertRequirement(this.m_impl, ref xstring, ref xstring2);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public bool AuthSsl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AuthSsl(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_AuthSsl(this.m_impl, value);
			}
		}

		public unsafe string DetermineSettings()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				bool flag = <Module>.ClsFtp2.DetermineSettings(this.m_impl, ref xstring) != null;
				Monitor.Exit(this.m_lockImpl);
				if (flag)
				{
					goto IL_4C;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_4C:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int DetermineProxyMethod()
		{
			Monitor.Enter(this.m_lockImpl);
			int result = <Module>.ClsFtp2.DetermineProxyMethod(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncGetFileStart(string remoteFilename, string localFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(remoteFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(localFilename, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					result = (<Module>.ClsFtp2.AsyncGetFileStart(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncPutFileStart(string localFilename, string remoteFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					result = (<Module>.ClsFtp2.AsyncPutFileStart(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncAppendFileStart(string localFilename, string remoteFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(localFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					result = (<Module>.ClsFtp2.AsyncAppendFileStart(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void AsyncAbort()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsFtp2.AsyncAbort(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public void SleepMs(int millisec)
		{
			<Module>.ClsFtp2.SleepMs(this.m_impl, millisec);
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsFtp2.SetSslClientCert(this.m_impl, ptr);
			Monitor.Exit(this.m_lockImpl);
		}

		public bool PartialTransfer
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_PartialTransfer(this.m_impl) != null;
			}
		}

		public bool AsyncFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AsyncFinished(this.m_impl) != null;
			}
		}

		public unsafe string AsyncLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsFtp2.get_AsyncLog(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool AsyncSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AsyncSuccess(this.m_impl) != null;
			}
		}

		public uint AsyncBytesReceived
		{
			get
			{
				return <Module>.ClsFtp2.get_AsyncBytesReceived(this.m_impl);
			}
		}

		public uint AsyncBytesSent
		{
			get
			{
				return <Module>.ClsFtp2.get_AsyncBytesSent(this.m_impl);
			}
		}

		public unsafe string DirTreeXml()
		{
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			string result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsFtp2.DirTreeXml(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						goto IL_95;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
			IL_95:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result2;
		}

		public unsafe void SetOldestDate(DateTime oldestDateTime)
		{
			ChilkatSysTime year;
			<Module>.ChilkatSysTime.{ctor}(ref year);
			year = oldestDateTime.Year;
			*(ref year + 2) = (short)oldestDateTime.Month;
			*(ref year + 6) = (short)oldestDateTime.Day;
			*(ref year + 8) = (short)oldestDateTime.Hour;
			*(ref year + 10) = (short)oldestDateTime.Minute;
			*(ref year + 12) = (short)oldestDateTime.Second;
			<Module>.ClsFtp2.SetOldestDate(this.m_impl, ref year);
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Ftp2.m_lockObject);
						if (Ftp2.m_ftpObjects == null)
						{
							Ftp2.m_ftpObjects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Ftp2.m_ftpObjects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Ftp2.m_ftpObjects = new Hashtable();
									Ftp2.m_ftpObjects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Ftp2.m_lockObject);
					}
					else
					{
						Monitor.Enter(Ftp2.m_lockObject);
						Ftp2.m_ftpObjects.Remove(this);
						Monitor.Exit(Ftp2.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToTls()
		{
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsFtp2.ConvertToTls(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public unsafe string GetSizeStrByName(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					_FtpCallback ftpCallback;
					<Module>.FtpCallback.{ctor}(ref ftpCallback);
					try
					{
						ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
						*(ref ftpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					try
					{
						_FtpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &ftpCallback;
							*(ref ftpCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsFtp2.GetSizeStrByName(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_BE:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_FtpCallback ftpCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
						throw;
					}
					ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
					<Module>.FtpCallback.{dtor}(ref ftpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetRemoteFileDateTime(DateTime dt, string remoteFilename)
		{
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				year = dt.Year;
				*(ref year + 2) = (short)dt.Month;
				*(ref year + 6) = (short)dt.Day;
				*(ref year + 8) = (short)dt.Hour;
				*(ref year + 10) = (short)dt.Minute;
				*(ref year + 12) = (short)dt.Second;
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(remoteFilename, &xstring);
					result = (<Module>.ClsFtp2.SetRemoteFileDateTime(this.m_impl, ref year, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public int SendBufferSize
		{
			get
			{
				return <Module>.ClsFtp2.get_SendBufferSize(this.m_impl);
			}
			set
			{
				<Module>.ClsFtp2.put_SendBufferSize(this.m_impl, value);
			}
		}

		public bool UseEpsv
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_UseEpsv(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_UseEpsv(this.m_impl, value);
			}
		}

		public unsafe string ForcePortIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsFtp2.get_ForcePortIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsFtp2.put_ForcePortIpAddress(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string NlstXml(string pattern)
		{
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			string result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(pattern, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsFtp2.NlstXml(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
			IL_BE:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result2;
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksVersion(this.m_impl + 120 / sizeof(ClsFtp2));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksVersion(this.m_impl + 120 / sizeof(ClsFtp2), value);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksPort(this.m_impl + 120 / sizeof(ClsFtp2));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksPort(this.m_impl + 120 / sizeof(ClsFtp2), value);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksUsername(this.m_impl + 120 / sizeof(ClsFtp2), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksUsername(this.m_impl + 120 / sizeof(ClsFtp2), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksPassword(this.m_impl + 120 / sizeof(ClsFtp2), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksPassword(this.m_impl + 120 / sizeof(ClsFtp2), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksHostname(this.m_impl + 120 / sizeof(ClsFtp2), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksHostname(this.m_impl + 120 / sizeof(ClsFtp2), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Greeting
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsFtp2.get_Greeting(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xstring3);
						result = (<Module>.ClsFtp2.SetSslClientCertPfx(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_VerboseLogging(this.m_impl, value);
			}
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsFtp2.get_SslProtocol(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsFtp2.put_SslProtocol(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool AutoGetSizeForProgress
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AutoGetSizeForProgress(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_AutoGetSizeForProgress(this.m_impl, value);
			}
		}

		public unsafe string SyncPreview
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsFtp2.get_SyncPreview(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SyncRemoteTree2(string localRoot, int mode, [MarshalAs(UnmanagedType.U1)] bool bDescend, [MarshalAs(UnmanagedType.U1)] bool bPreviewOnly)
		{
			_FtpCallback ftpCallback;
			<Module>.FtpCallback.{ctor}(ref ftpCallback);
			try
			{
				ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
				*(ref ftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			bool result;
			try
			{
				_FtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &ftpCallback;
					*(ref ftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(localRoot, &xstring);
					result = (<Module>.ClsFtp2.SyncRemoteTree2(this.m_impl, ref xstring, mode, bDescend, bPreviewOnly, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._FtpCallback.{dtor}), (void*)(&ftpCallback));
				throw;
			}
			ftpCallback = ref <Module>.??_7_FtpCallback@Chilkat@@6B@;
			<Module>.FtpCallback.{dtor}(ref ftpCallback);
			return result;
		}

		public bool AutoFix
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsFtp2.get_AutoFix(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsFtp2.put_AutoFix(this.m_impl, value);
			}
		}

		public event Ftp2.FtpPercentDoneEventHandler OnFtpPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnFtpPercentDone = Delegate.Combine(this.OnFtpPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnFtpPercentDone = Delegate.Remove(this.OnFtpPercentDone, value);
			}
		}

		public event Ftp2.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public event Ftp2.DataPortEventHandler OnDataPort
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnDataPort = Delegate.Combine(this.OnDataPort, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnDataPort = Delegate.Remove(this.OnDataPort, value);
			}
		}

		public event Ftp2.BeginDownloadFileEventHandler OnBeginDownloadFile
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnBeginDownloadFile = Delegate.Combine(this.OnBeginDownloadFile, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnBeginDownloadFile = Delegate.Remove(this.OnBeginDownloadFile, value);
			}
		}

		public event Ftp2.EndDownloadFileEventHandler OnEndDownloadFile
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnEndDownloadFile = Delegate.Combine(this.OnEndDownloadFile, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnEndDownloadFile = Delegate.Remove(this.OnEndDownloadFile, value);
			}
		}

		public event Ftp2.VerifyDownloadDirEventHandler OnVerifyDownloadDir
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnVerifyDownloadDir = Delegate.Combine(this.OnVerifyDownloadDir, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnVerifyDownloadDir = Delegate.Remove(this.OnVerifyDownloadDir, value);
			}
		}

		public event Ftp2.BeginUploadFileEventHandler OnBeginUploadFile
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnBeginUploadFile = Delegate.Combine(this.OnBeginUploadFile, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnBeginUploadFile = Delegate.Remove(this.OnBeginUploadFile, value);
			}
		}

		public event Ftp2.EndUploadFileEventHandler OnEndUploadFile
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnEndUploadFile = Delegate.Combine(this.OnEndUploadFile, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnEndUploadFile = Delegate.Remove(this.OnEndUploadFile, value);
			}
		}

		public event Ftp2.VerifyUploadDirEventHandler OnVerifyUploadDir
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnVerifyUploadDir = Delegate.Combine(this.OnVerifyUploadDir, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnVerifyUploadDir = Delegate.Remove(this.OnVerifyUploadDir, value);
			}
		}

		public event Ftp2.VerifyDeleteFileEventHandler OnVerifyDeleteFile
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnVerifyDeleteFile = Delegate.Combine(this.OnVerifyDeleteFile, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnVerifyDeleteFile = Delegate.Remove(this.OnVerifyDeleteFile, value);
			}
		}

		public event Ftp2.VerifyDeleteDirEventHandler OnVerifyDeleteDir
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnVerifyDeleteDir = Delegate.Combine(this.OnVerifyDeleteDir, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnVerifyDeleteDir = Delegate.Remove(this.OnVerifyDeleteDir, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_ftpObjects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private object m_lockImpl;

		private unsafe ClsFtp2* m_impl;

		public delegate void FtpPercentDoneEventHandler(object sender, FtpPercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void DataPortEventHandler(object sender, DataPortEventArgs args);

		public delegate void BeginDownloadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void EndDownloadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyDownloadDirEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void BeginUploadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void EndUploadFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyUploadDirEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyDeleteFileEventHandler(object sender, FtpTreeEventArgs args);

		public delegate void VerifyDeleteDirEventHandler(object sender, FtpTreeEventArgs args);
	}
}
