﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class FtpTreeEventArgs : EventArgs
	{
		public unsafe FtpTreeEventArgs(sbyte* path, uint numBytes)
		{
			this.m_path = CkMarshal.Utf8ToString(path);
			this.m_numBytes = numBytes;
			this.m_skip = false;
		}

		public unsafe FtpTreeEventArgs(sbyte* path)
		{
			this.m_path = CkMarshal.Utf8ToString(path);
			this.m_numBytes = 0U;
			this.m_skip = false;
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public string Path
		{
			get
			{
				return this.m_path;
			}
		}

		public uint NumBytes
		{
			get
			{
				return this.m_numBytes;
			}
		}

		public bool Skip
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_skip;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				this.m_skip = value;
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private string m_path;

		private bool m_skip;

		private uint m_numBytes;
	}
}
