﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Gzip : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Gzip LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Gzip.m_lockObject);
			Gzip result = (Gzip)Gzip.m_objects[key];
			Monitor.Exit(Gzip.m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			Gzip.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Gzip.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe Gzip(void* impl)
		{
			this.m_impl = (ClsGzip*)impl;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
		}

		public unsafe Gzip()
		{
			this.m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			<Module>.?A0xa9cfcf01.NextHashCode++;
			this.m_myHashCode = <Module>.?A0xa9cfcf01.NextHashCode;
			ClsGzip* ptr = <Module>.@new(912U);
			ClsGzip* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsGzip.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsGzip* impl = this.m_impl;
			if (impl != null)
			{
				ClsGzip* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Gzip.m_lockObject);
				object key = this.m_myHashCode;
				Gzip.m_objects.Remove(key);
				Monitor.Exit(Gzip.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public virtual void Dispose()
		{
			Monitor.Enter(Gzip.m_lockObject);
			object key = this.m_myHashCode;
			Gzip.m_objects.Remove(key);
			Monitor.Exit(Gzip.m_lockObject);
		}

		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl + 192 / sizeof(ClsGzip), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl + 192 / sizeof(ClsGzip), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl + 192 / sizeof(ClsGzip), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl + 192 / sizeof(ClsGzip), ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				int num = *(int*)(this.m_impl + 192 / sizeof(ClsGzip)) + 4;
				result = calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.SByte modopt(System.Runtime.CompilerServices.IsSignUnspecifiedByte) modopt(System.Runtime.CompilerServices.IsConst)*), this.m_impl + 192 / sizeof(ClsGzip), <Module>.XString.getUtf8(ref xstring), *num);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsGzip* ptr = this.m_impl + 192 / sizeof(ClsGzip);
			return calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), ptr, *(*(int*)ptr + 8));
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile(string inFilename, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outFilename, &xstring2);
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsGzip.CompressFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile2(string inFilename, string embeddedFilename, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(embeddedFilename, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(outFilename, &xstring3);
						_GzipCallback gzipCallback;
						<Module>.GzipCallback.{ctor}(ref gzipCallback);
						try
						{
							gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
							*(ref gzipCallback + 4) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
							throw;
						}
						try
						{
							_GzipCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &gzipCallback;
								*(ref gzipCallback + 4) = this.m_myHashCode;
							}
							result = (<Module>.ClsGzip.CompressFile2(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
							throw;
						}
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						<Module>.GzipCallback.{dtor}(ref gzipCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressFile(string inFilename, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outFilename, &xstring2);
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsGzip.UncompressFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] CompressFileToMem(string inFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsGzip.CompressFileToMem(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_BE:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					_GzipCallback gzipCallback;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] UncompressFileToMem(string inFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsGzip.UncompressFileToMem(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_BE:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					_GzipCallback gzipCallback;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressMemToFile(byte[] inData, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(outFilename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (this.m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsGzip.CompressMemToFile(this.m_impl, ref dataBuffer, ref xstring, (ProgressEvent*)ptr2) != null);
						CkMarshal.free(ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressMemToFile(byte[] inData, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(outFilename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (this.m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsGzip.UncompressMemToFile(this.m_impl, ref dataBuffer, ref xstring, (ProgressEvent*)ptr2) != null);
						CkMarshal.free(ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] CompressMemory(byte[] inData)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer2, ptr, num);
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (this.m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsGzip.CompressMemory(this.m_impl, ref dataBuffer2, ref dataBuffer, (ProgressEvent*)ptr2) != null;
						CkMarshal.free(ptr);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_D4:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer2;
				try
				{
					_GzipCallback gzipCallback;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe byte[] UncompressMemory(byte[] inData)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer2, ptr, num);
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr2 = null;
						if (this.m_enableEvents)
						{
							ptr2 = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsGzip.UncompressMemory(this.m_impl, ref dataBuffer2, ref dataBuffer, (ProgressEvent*)ptr2) != null;
						CkMarshal.free(ptr);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_D4:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer2;
				try
				{
					_GzipCallback gzipCallback;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe string DeflateStringENC(string strIn, string charset, string encoding)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(strIn, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(encoding, &xstring3);
						XString xstring4;
						<Module>.XString.{ctor}(ref xstring4);
						try
						{
							<Module>.ClsGzip.DeflateStringENC(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4);
							result = CkMarshal.XToString(&xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring4);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string InflateStringENC(string strIn, string charset, string encoding)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(strIn, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(encoding, &xstring3);
						XString xstring4;
						<Module>.XString.{ctor}(ref xstring4);
						try
						{
							<Module>.ClsGzip.InflateStringENC(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4);
							result = CkMarshal.XToString(&xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring4);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnTarGz(string gzFilename, string destDir, [MarshalAs(UnmanagedType.U1)] bool bNoAbsolute)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(gzFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(destDir, &xstring2);
					_GzipCallback gzipCallback;
					<Module>.GzipCallback.{ctor}(ref gzipCallback);
					try
					{
						gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
						*(ref gzipCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					try
					{
						_GzipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &gzipCallback;
							*(ref gzipCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsGzip.UnTarGz(this.m_impl, ref xstring, ref xstring2, bNoAbsolute, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
						throw;
					}
					gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
					<Module>.GzipCallback.{dtor}(ref gzipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string Filename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsGzip.get_Filename(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsGzip.put_Filename(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Comment
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsGzip.get_Comment(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsGzip.put_Comment(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe byte[] ExtraData
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsGzip.get_ExtraData(this.m_impl, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
			set
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(value, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
					<Module>.ClsGzip.put_ExtraData(this.m_impl, ref dataBuffer);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
		}

		public unsafe DateTime LastMod
		{
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				<Module>.ClsGzip.get_LocalLastMod(this.m_impl, ref year);
				DateTime result = default(DateTime);
				uint exceptionCode;
				try
				{
					DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
					result = dateTime;
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							return DateTime.Now;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				return result;
			}
			set
			{
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				year = value.Year;
				*(ref year + 2) = (short)value.Month;
				*(ref year + 6) = (short)value.Day;
				*(ref year + 8) = (short)value.Hour;
				*(ref year + 10) = (short)value.Minute;
				*(ref year + 12) = (short)value.Second;
				<Module>.ClsGzip.put_LocalLastMod(this.m_impl, ref year);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Gzip.m_lockObject);
						if (Gzip.m_objects == null)
						{
							Gzip.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Gzip.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Gzip.m_objects = new Hashtable();
									Gzip.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Gzip.m_lockObject);
					}
					else
					{
						Monitor.Enter(Gzip.m_lockObject);
						object key3 = this.m_myHashCode;
						Gzip.m_objects.Remove(key3);
						Monitor.Exit(Gzip.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsGzip.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe byte[] ReadFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.ClsGzip.ReadFile(this.m_impl, ref xstring, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFile(string filename, byte[] binaryData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(binaryData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					result = (<Module>.ClsGzip.WriteFile(this.m_impl, ref xstring, ref dataBuffer) != null);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] CompressString(string inStr, string outCharset)
		{
			_GzipCallback gzipCallback;
			<Module>.GzipCallback.{ctor}(ref gzipCallback);
			try
			{
				gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
				*(ref gzipCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			byte[] result;
			try
			{
				_GzipCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &gzipCallback;
					*(ref gzipCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inStr, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(outCharset, &xstring2);
						DataBuffer dataBuffer;
						<Module>.DataBuffer.{ctor}(ref dataBuffer);
						try
						{
							<Module>.ClsGzip.CompressString(this.m_impl, ref xstring, ref xstring2, ref dataBuffer, (ProgressEvent*)ptr);
							result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
							throw;
						}
						<Module>.DataBuffer.{dtor}(ref dataBuffer);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
			<Module>.GzipCallback.{dtor}(ref gzipCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressStringToFile(string inStr, string outCharset, string outFilename)
		{
			_GzipCallback gzipCallback;
			<Module>.GzipCallback.{ctor}(ref gzipCallback);
			try
			{
				gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
				*(ref gzipCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			bool result;
			try
			{
				_GzipCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &gzipCallback;
					*(ref gzipCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inStr, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(outCharset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(outFilename, &xstring3);
							result = (<Module>.ClsGzip.CompressStringToFile(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
			<Module>.GzipCallback.{dtor}(ref gzipCallback);
			return result;
		}

		public unsafe string UncompressFileToString(string inFilename, string inCharset)
		{
			_GzipCallback gzipCallback;
			<Module>.GzipCallback.{ctor}(ref gzipCallback);
			try
			{
				gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
				*(ref gzipCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			string result;
			try
			{
				_GzipCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &gzipCallback;
					*(ref gzipCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inFilename, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(inCharset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							bool flag = <Module>.ClsGzip.UncompressFileToString(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_E7;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
			<Module>.GzipCallback.{dtor}(ref gzipCallback);
			return result;
			IL_E7:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
			<Module>.GzipCallback.{dtor}(ref gzipCallback);
			return result2;
		}

		public unsafe string UncompressString(byte[] inData, string inCharset)
		{
			_GzipCallback gzipCallback;
			<Module>.GzipCallback.{ctor}(ref gzipCallback);
			try
			{
				gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
				*(ref gzipCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			string result;
			try
			{
				_GzipCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &gzipCallback;
					*(ref gzipCallback + 4) = this.m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
					XString xstring;
					<Module>.XString.{ctor}(ref xstring);
					try
					{
						CkMarshal.StringToX(inCharset, &xstring);
						XString xstring2;
						<Module>.XString.{ctor}(ref xstring2);
						try
						{
							bool flag = <Module>.ClsGzip.UncompressString(this.m_impl, ref dataBuffer, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
							CkMarshal.free(ptr2);
							if (flag)
							{
								goto IL_FD;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
			<Module>.GzipCallback.{dtor}(ref gzipCallback);
			return result;
			IL_FD:
			string result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					XString xstring;
					try
					{
						XString xstring2;
						try
						{
							result2 = CkMarshal.XToString(&xstring2);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._GzipCallback.{dtor}), (void*)(&gzipCallback));
				throw;
			}
			gzipCallback = ref <Module>.??_7_GzipCallback@Chilkat@@6B@;
			<Module>.GzipCallback.{dtor}(ref gzipCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExamineFile(string inGzFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inGzFilename, &xstring);
				result = (<Module>.ClsGzip.ExamineFile(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExamineMemory(byte[] inGzData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inGzData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				result = (<Module>.ClsGzip.ExamineMemory(this.m_impl, ref dataBuffer) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] Decode(string str, string encoding)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(encoding, &xstring2);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.ClsEncode.Decode(this.m_impl, ref xstring, ref xstring2, ref dataBuffer, true);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool UseCurrentDate
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsGzip.get_UseCurrentDate(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsGzip.put_UseCurrentDate(this.m_impl, value);
			}
		}

		public unsafe string XfdlToXml(string xfdl)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(xfdl, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsGzip.XfdlToXml(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string Encode(byte[] byteData, string encoding)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(byteData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(encoding, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						<Module>.ClsEncode.Encode(this.m_impl, ref dataBuffer, ref xstring, ref xstring2, false);
						CkMarshal.free(ptr);
						result = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsGzip.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsGzip.put_VerboseLogging(this.m_impl, value);
			}
		}

		public event Gzip.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public event Gzip.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsGzip* m_impl;

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
