﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class HtmlToXml
	{
		public unsafe HtmlToXml()
		{
			Monitor.Enter(HtmlToXml.m_lockImpl);
			ClsHtmlToXml* ptr = <Module>.@new(592U);
			ClsHtmlToXml* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsHtmlToXml.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
			<Module>.?m_progLang@ClsHtmlToXml@@2HA = 2;
			Monitor.Exit(HtmlToXml.m_lockImpl);
		}

		protected unsafe override void Finalize()
		{
			Monitor.Enter(HtmlToXml.m_lockImpl);
			ClsHtmlToXml* impl = this.m_impl;
			if (impl != null)
			{
				ClsHtmlToXml* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			Monitor.Exit(HtmlToXml.m_lockImpl);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(HtmlToXml.m_lockImpl);
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(HtmlToXml.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(HtmlToXml.m_lockImpl);
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(HtmlToXml.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(HtmlToXml.m_lockImpl);
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(HtmlToXml.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(HtmlToXml.m_lockImpl);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
				Monitor.Exit(HtmlToXml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				Monitor.Enter(HtmlToXml.m_lockImpl);
				result = (<Module>.ClsHtmlToXml.UnlockComponentX(this.m_impl, ref xstring) != null);
				Monitor.Exit(HtmlToXml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsHtmlToXml* impl = this.m_impl;
			return calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), impl, *(*(int*)impl + 8));
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsHtmlToXml* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsHtmlToXml.get_VersionX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int Nbsp
		{
			get
			{
				return <Module>.ClsHtmlToXml.get_Nbsp(this.m_impl);
			}
			set
			{
				<Module>.ClsHtmlToXml.put_Nbsp(this.m_impl, value);
			}
		}

		public unsafe string Html
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(HtmlToXml.m_lockImpl);
					ClsHtmlToXml* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsHtmlToXml.get_Html(impl, ref xstring);
					}
					Monitor.Exit(HtmlToXml.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(HtmlToXml.m_lockImpl);
					ClsHtmlToXml* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsHtmlToXml.put_Html(impl, ref xstring);
					}
					Monitor.Exit(HtmlToXml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string XmlCharset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsHtmlToXml* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsHtmlToXml.get_XmlCharset(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsHtmlToXml* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsHtmlToXml.put_XmlCharset(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetHtmlFromFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(HtmlToXml.m_lockImpl);
				result = (<Module>.ClsHtmlToXml.SetHtmlFromFile(this.m_impl, ref xstring) != null);
				Monitor.Exit(HtmlToXml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void SetHtmlBytes(byte[] inData)
		{
			Monitor.Enter(HtmlToXml.m_lockImpl);
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				<Module>.ClsHtmlToXml.SetHtmlBytes(this.m_impl, ref dataBuffer);
				CkMarshal.free(ptr);
				Monitor.Exit(HtmlToXml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
		}

		public unsafe string ToXml()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			Monitor.Enter(HtmlToXml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = false;
				uint exceptionCode;
				try
				{
					flag = (<Module>.ClsHtmlToXml.ToXml(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_05EFLOKPLE@ToXml?$AA@));
							goto IL_87;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_87:
				Monitor.Exit(HtmlToXml.m_lockImpl);
				if (flag)
				{
					goto IL_B3;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_B3:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] ReadFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(HtmlToXml.m_lockImpl);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.ClsHtmlToXml.ReadFileX(this.m_impl, ref xstring, ref dataBuffer) != null;
					Monitor.Exit(HtmlToXml.m_lockImpl);
					if (flag)
					{
						goto IL_73;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_73:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string ReadFileToString(string filename, string srcCharset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(srcCharset, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						bool flag = <Module>.XString.readFile(ref xstring3, ref xstring, ref xstring2) != null;
						if (flag)
						{
							goto IL_82;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_82:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						result2 = CkMarshal.XToString(&xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFile(string filename, byte[] fileData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(fileData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
					result = (<Module>.ClsHtmlToXml.WriteFileX(this.m_impl, ref xstring, ref dataBuffer) != null);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteStringToFile(string str, string filename, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(filename, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(charset, &xstring3);
						result = (<Module>.XString.writeToFile(ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertFile(string inHtmlFilename, string outXmlFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inHtmlFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outXmlFilename, &xstring2);
					Monitor.Enter(HtmlToXml.m_lockImpl);
					result = (<Module>.ClsHtmlToXml.ConvertFile(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(HtmlToXml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void DropTagType(string tagName)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tagName, &xstring);
				Monitor.Enter(HtmlToXml.m_lockImpl);
				<Module>.ClsHtmlToXml.DropTagType(this.m_impl, ref xstring);
				Monitor.Exit(HtmlToXml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void UndropTagType(string tagName)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tagName, &xstring);
				Monitor.Enter(HtmlToXml.m_lockImpl);
				<Module>.ClsHtmlToXml.UndropTagType(this.m_impl, ref xstring);
				Monitor.Exit(HtmlToXml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void DropTextFormattingTags()
		{
			Monitor.Enter(HtmlToXml.m_lockImpl);
			<Module>.ClsHtmlToXml.DropTextFormattingTags(this.m_impl);
			Monitor.Exit(HtmlToXml.m_lockImpl);
		}

		public void UndropTextFormattingTags()
		{
			Monitor.Enter(HtmlToXml.m_lockImpl);
			<Module>.ClsHtmlToXml.UndropTextFormattingTags(this.m_impl);
			Monitor.Exit(HtmlToXml.m_lockImpl);
		}

		public bool DropCustomTags
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHtmlToXml.get_DropCustomTags(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				Monitor.Enter(HtmlToXml.m_lockImpl);
				if (value)
				{
					<Module>.ClsHtmlToXml.DropCustomTags(this.m_impl);
				}
				else
				{
					<Module>.ClsHtmlToXml.UndropCustomTags(this.m_impl);
				}
				Monitor.Exit(HtmlToXml.m_lockImpl);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static object m_lockImpl = new object();

		private unsafe ClsHtmlToXml* m_impl;
	}
}
