﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Http : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Http LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Http.m_lockObject);
			Http result = (Http)Http.m_objects[key];
			Monitor.Exit(Http.m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			Http.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public void FireProgressInfo(object sender, ProgressInfoEventArgs args)
		{
			Http.ProgressInfoEventHandler onProgressInfo = this.OnProgressInfo;
			if (onProgressInfo != null)
			{
				onProgressInfo(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Http.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public void FireReceiveRate(object sender, DataRateEventArgs args)
		{
			Http.ReceiveRateEventHandler onReceiveRate = this.OnReceiveRate;
			if (onReceiveRate != null)
			{
				onReceiveRate(sender, args);
			}
		}

		public void FireHttpChunked(object sender, EventArgs args)
		{
			Http.HttpChunkedEventHandler onHttpChunked = this.OnHttpChunked;
			if (onHttpChunked != null)
			{
				onHttpChunked(sender, args);
			}
		}

		public void FireHttpRedirect(object sender, HttpRedirectEventArgs args)
		{
			Http.HttpRedirectEventHandler onHttpRedirect = this.OnHttpRedirect;
			if (onHttpRedirect != null)
			{
				onHttpRedirect(sender, args);
			}
		}

		public void FireHttpBeginReceive(object sender, EventArgs args)
		{
			Http.HttpBeginReceiveEventHandler onHttpBeginReceive = this.OnHttpBeginReceive;
			if (onHttpBeginReceive != null)
			{
				onHttpBeginReceive(sender, args);
			}
		}

		public void FireHttpBeginSend(object sender, EventArgs args)
		{
			Http.HttpBeginSendEventHandler onHttpBeginSend = this.OnHttpBeginSend;
			if (onHttpBeginSend != null)
			{
				onHttpBeginSend(sender, args);
			}
		}

		public void FireHttpEndReceive(object sender, StatusEventArgs args)
		{
			Http.HttpEndReceiveEventHandler onHttpEndReceive = this.OnHttpEndReceive;
			if (onHttpEndReceive != null)
			{
				onHttpEndReceive(sender, args);
			}
		}

		public void FireHttpEndSend(object sender, StatusEventArgs args)
		{
			Http.HttpEndSendEventHandler onHttpEndSend = this.OnHttpEndSend;
			if (onHttpEndSend != null)
			{
				onHttpEndSend(sender, args);
			}
		}

		public unsafe Http()
		{
			this.m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnProgressInfo = null;
			this.OnAbortCheck = null;
			this.OnReceiveRate = null;
			this.OnHttpChunked = null;
			this.OnHttpRedirect = null;
			this.OnHttpBeginReceive = null;
			this.OnHttpBeginSend = null;
			this.OnHttpEndReceive = null;
			this.OnHttpEndSend = null;
			<Module>.?A0x65f5efec.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x65f5efec.NextHashCode;
			ClsHttp* ptr = <Module>.@new(3320U);
			ClsHttp* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsHttp.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 3312) = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsHttp* impl = this.m_impl;
			if (impl != null)
			{
				ClsHttp* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Http.m_lockObject);
				object key = this.m_myHashCode;
				Http.m_objects.Remove(key);
				Monitor.Exit(Http.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(Http.m_lockObject);
			ClsHttp* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsHttp.dotNetDispose(impl);
			}
			object key = this.m_myHashCode;
			Http.m_objects.Remove(key);
			Monitor.Exit(Http.m_lockObject);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = false;
				if (this.m_impl == null)
				{
					ClsHttp* ptr = <Module>.@new(3320U);
					ClsHttp* ptr2;
					try
					{
						if (ptr != null)
						{
							ptr2 = <Module>.ClsHttp.{ctor}(ptr);
						}
						else
						{
							ptr2 = 0;
						}
					}
					catch
					{
						<Module>.delete((void*)ptr);
						throw;
					}
					this.m_impl = ptr2;
					*(ptr2 + 3312) = 2;
				}
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsHttp.UnlockComponentX(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BA@CGAIPMHI@UnlockComponent?$AA@));
							goto IL_D5;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			IL_D5:
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsHttp* impl = this.m_impl;
			return calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), impl, *(*(int*)impl + 8));
		}

		public unsafe string ProxyLogin
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_ProxyLogin(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_ProxyLogin(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_ProxyPassword(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_ProxyPassword(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int MaxConnections
		{
			get
			{
				return <Module>.ClsHttp.get_MaxConnections(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_MaxConnections(this.m_impl, value);
			}
		}

		public bool NtlmAuth
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_NtlmAuth(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_NtlmAuth(this.m_impl, value);
			}
		}

		public int LastStatus
		{
			get
			{
				return <Module>.ClsHttp.get_LastStatus(this.m_impl);
			}
		}

		public unsafe string LastContentType
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_LastContentTypeX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastResponseHeader
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_LastResponseHeaderX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastModDate
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_LastModDateX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			<Module>.ClsHttp.SetSslClientCert(this.m_impl, ptr);
		}

		public unsafe string CookieDir
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_CookieDirX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_CookieDirX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool SaveCookies
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_SaveCookies(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_SaveCookies(this.m_impl, value);
			}
		}

		public bool SendCookies
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_SendCookies(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_SendCookies(this.m_impl, value);
			}
		}

		public bool UseIEProxy
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_UseIEProxy(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_UseIEProxy(this.m_impl, value);
			}
		}

		public unsafe byte[] QuickGet(string url)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					_HttpCallback httpCallback;
					<Module>.HttpCallback.{ctor}(ref httpCallback);
					try
					{
						httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
						*(ref httpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &httpCallback;
							*(ref httpCallback + 4) = this.m_myHashCode;
						}
						bool flag = false;
						uint exceptionCode;
						try
						{
							flag = (<Module>.ClsHttp.QuickGetX(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr) != null);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08OFEPMGLD@QuickGet?$AA@));
									goto IL_CF;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_CF:
						if (flag)
						{
							goto IL_12C;
						}
						result = new byte[0];
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					<Module>.HttpCallback.{dtor}(ref httpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_12C:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					_HttpCallback httpCallback;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					<Module>.HttpCallback.{dtor}(ref httpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string QuickGetStr(string url)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					_HttpCallback httpCallback;
					<Module>.HttpCallback.{ctor}(ref httpCallback);
					try
					{
						httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
						*(ref httpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &httpCallback;
							*(ref httpCallback + 4) = this.m_myHashCode;
						}
						bool flag = false;
						uint exceptionCode;
						try
						{
							flag = (<Module>.ClsHttp.QuickGetStr(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0M@CLJCBHNB@QuickGetStr?$AA@));
									goto IL_CF;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_CF:
						if (flag)
						{
							goto IL_132;
						}
						if (<Module>.XString.getNumChars(ref xstring2) != null)
						{
							goto IL_132;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					<Module>.HttpCallback.{dtor}(ref httpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_132:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_HttpCallback httpCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					<Module>.HttpCallback.{dtor}(ref httpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string UrlEncode(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsHttp.UrlEncode(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string UrlDecode(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsHttp.UrlDecode(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Download(string url, string filename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(filename, &xstring2);
					_HttpCallback httpCallback;
					<Module>.HttpCallback.{ctor}(ref httpCallback);
					try
					{
						httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
						*(ref httpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &httpCallback;
							*(ref httpCallback + 4) = this.m_myHashCode;
						}
						result = false;
						uint exceptionCode;
						try
						{
							result = (<Module>.ClsHttp.Download(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08PPHBPJGP@Download?$AA@));
									goto IL_E7;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					IL_E7:
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					<Module>.HttpCallback.{dtor}(ref httpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DownloadAppend(string url, string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(filename, &xstring2);
					_HttpCallback httpCallback;
					<Module>.HttpCallback.{ctor}(ref httpCallback);
					try
					{
						httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
						*(ref httpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &httpCallback;
							*(ref httpCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsHttp.DownloadAppend(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					<Module>.HttpCallback.{dtor}(ref httpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ResumeDownload(string url, string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(filename, &xstring2);
					_HttpCallback httpCallback;
					<Module>.HttpCallback.{ctor}(ref httpCallback);
					try
					{
						httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
						*(ref httpCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					try
					{
						_HttpCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &httpCallback;
							*(ref httpCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsHttp.ResumeDownload(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
						throw;
					}
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					<Module>.HttpCallback.{dtor}(ref httpCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe HttpResponse SynchronousRequest(string domain, int port, [MarshalAs(UnmanagedType.U1)] bool ssl, HttpRequest req)
		{
			if (req == null)
			{
				return null;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			HttpResponse result;
			try
			{
				CkMarshal.StringToX(domain, &xstring);
				ClsHttpRequest* implementation = (ClsHttpRequest*)req.GetImplementation();
				_HttpCallback httpCallback;
				<Module>.HttpCallback.{ctor}(ref httpCallback);
				try
				{
					httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
					*(ref httpCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
					throw;
				}
				try
				{
					_HttpCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &httpCallback;
						*(ref httpCallback + 4) = this.m_myHashCode;
					}
					ClsHttpResponse* ptr2 = <Module>.ClsHttp.SynchronousRequest(this.m_impl, <Module>.XString.getAnsi(ref xstring), port, ssl, implementation, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_B5;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
					throw;
				}
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				<Module>.HttpCallback.{dtor}(ref httpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_B5:
			HttpResponse result2;
			try
			{
				_HttpCallback httpCallback;
				try
				{
					ClsHttpResponse* ptr2;
					result2 = new HttpResponse((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
					throw;
				}
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				<Module>.HttpCallback.{dtor}(ref httpCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsHttp.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_HeartbeatMs(this.m_impl, value);
			}
		}

		public int ProxyPort
		{
			get
			{
				return <Module>.ClsHttp.get_ProxyPort(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_ProxyPort(this.m_impl, value);
			}
		}

		public unsafe string ProxyDomain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_ProxyDomain(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_ProxyDomain(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Login
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_Login(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_Login(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Password
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_Password(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_Password(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe void SetRequestHeader(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					<Module>.ClsHttp.SetRequestHeader(this.m_impl, ref xstring, ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string GetRequestHeader(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsHttp.GetRequestHeader(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasRequestHeader(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = (<Module>.ClsHttp.HasRequestHeader(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void RemoveRequestHeader(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				<Module>.ClsHttp.RemoveRequestHeader(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string UserAgent
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_UserAgent(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_UserAgent(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Referer
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_RefererX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_RefererX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Accept
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_Accept(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_Accept(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string AcceptCharset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_AcceptCharsetX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_AcceptCharsetX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string AcceptLanguage
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_AcceptLanguageX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_AcceptLanguageX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Connection
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_ConnectionX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_ConnectionX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int MaxUrlLen
		{
			get
			{
				return <Module>.ClsHttp.get_MaxUrlLen(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_MaxUrlLen(this.m_impl, value);
			}
		}

		public int MaxResponseSize
		{
			get
			{
				return <Module>.ClsHttp.get_MaxResponseSize(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_MaxResponseSize(this.m_impl, value);
			}
		}

		public bool MimicIE
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_MimicIE(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_MimicIE(this.m_impl, value);
			}
		}

		public bool MimicFireFox
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_MimicFireFox(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_MimicFireFox(this.m_impl, value);
			}
		}

		public bool AutoAddHostHeader
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_AutoAddHostHeader(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_AutoAddHostHeader(this.m_impl, value);
			}
		}

		public int ConnectTimeout
		{
			get
			{
				return <Module>.ClsHttp.get_ConnectTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_ConnectTimeout(this.m_impl, value);
			}
		}

		public int ReadTimeout
		{
			get
			{
				return <Module>.ClsHttp.get_ReadTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_ReadTimeout(this.m_impl, value);
			}
		}

		public unsafe string GetDomain(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsHttp.ExtractDomain(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool WasRedirected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_WasRedirected(this.m_impl) != null;
			}
		}

		public unsafe string FinalRedirectUrl
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_FinalRedirectUrlX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool FollowRedirects
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_FollowRedirects(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_FollowRedirects(this.m_impl, value);
			}
		}

		public int NumCacheLevels
		{
			get
			{
				return <Module>.ClsHttp.get_NumCacheLevels(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_NumCacheLevels(this.m_impl, value);
			}
		}

		public int NumCacheRoots
		{
			get
			{
				return <Module>.ClsHttp.get_NumCacheRoots(this.m_impl);
			}
		}

		public unsafe string GetCacheRoot(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttp.GetCacheRoot(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe void AddCacheRoot(string dir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(dir, &xstring);
				<Module>.ClsHttp.AddCacheRoot(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public bool UpdateCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_UpdateCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_UpdateCache(this.m_impl, value);
			}
		}

		public bool FetchFromCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_FetchFromCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_FetchFromCache(this.m_impl, value);
			}
		}

		public bool IgnoreNoCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_IgnoreNoCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_IgnoreNoCache(this.m_impl, value);
			}
		}

		public bool IgnoreMustRevalidate
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_IgnoreMustRevalidate(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_IgnoreMustRevalidate(this.m_impl, value);
			}
		}

		public int DefaultFreshPeriod
		{
			get
			{
				return <Module>.ClsHttp.get_DefaultFreshPeriod(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_DefaultFreshPeriod(this.m_impl, value);
			}
		}

		public int FreshnessAlgorithm
		{
			get
			{
				return <Module>.ClsHttp.get_FreshnessAlgorithm(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_FreshnessAlgorithm(this.m_impl, value);
			}
		}

		public int LMFactor
		{
			get
			{
				return <Module>.ClsHttp.get_LMFactor(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_LMFactor(this.m_impl, value);
			}
		}

		public int MaxFreshPeriod
		{
			get
			{
				return <Module>.ClsHttp.get_MaxFreshPeriod(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_MaxFreshPeriod(this.m_impl, value);
			}
		}

		public int MinFreshPeriod
		{
			get
			{
				return <Module>.ClsHttp.get_MinFreshPeriod(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_MinFreshPeriod(this.m_impl, value);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_VersionX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastHeader
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_LastHeader(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string GetUrlPath(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsHttp.GetUrlPath(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Http.m_lockObject);
						if (Http.m_objects == null)
						{
							Http.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Http.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Http.m_objects = new Hashtable();
									Http.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Http.m_lockObject);
					}
					else
					{
						Monitor.Enter(Http.m_lockObject);
						object key3 = this.m_myHashCode;
						Http.m_objects.Remove(key3);
						Monitor.Exit(Http.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public unsafe string RenderGet(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsHttp.RenderGet(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetCookieXml(string domain)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(domain, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsHttp.GetCookieXml(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string RequiredContentType
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_RequiredContentType(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_RequiredContentType(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe HttpResponse PostMime(string url, string mime)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(mime, &xstring2);
						ClsHttpResponse* ptr2 = <Module>.ClsHttp.PostMime(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr);
						if (ptr2 != null)
						{
							goto IL_C6;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_C6:
			HttpResponse result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						ClsHttpResponse* ptr2;
						result2 = new HttpResponse((void*)ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_SslProtocol(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_SslProtocol(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe HttpResponse GetHead(string url)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					ClsHttpResponse* ptr2 = <Module>.ClsHttp.GetHead(this.m_impl, ref xstring, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_9D;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_9D:
			HttpResponse result2;
			try
			{
				XString xstring;
				try
				{
					ClsHttpResponse* ptr2;
					result2 = new HttpResponse((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string XmlRpc(string urlEndpoint, string xmlIn)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(urlEndpoint, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(xmlIn, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							bool flag = <Module>.ClsHttp.XmlRpc(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_F2;
							}
							if (<Module>.XString.getNumChars(ref xstring3) != null)
							{
								goto IL_F2;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_F2:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string GenTimeStamp()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsHttp.GenTimeStamp(this.m_impl, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string XmlRpcPut(string urlEndpoint, string xmlIn)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(urlEndpoint, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(xmlIn, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							bool flag = <Module>.ClsHttp.XmlRpcPut(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_F2;
							}
							if (<Module>.XString.getNumChars(ref xstring3) != null)
							{
								goto IL_F2;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_F2:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string QuickPutStr(string url)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsHttp.QuickPutStr(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_C9;
						}
						if (<Module>.XString.getNumChars(ref xstring2) != null)
						{
							goto IL_C9;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_C9:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string QuickDeleteStr(string url)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsHttp.QuickDeleteStr(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_BE:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string PutText(string url, string textData, string charset, string contentType, [MarshalAs(UnmanagedType.U1)] bool md5, [MarshalAs(UnmanagedType.U1)] bool gzip)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(textData, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(charset, &xstring3);
							XString xstring4;
							<Module>.XString.{ctor}(ref xstring4);
							try
							{
								CkMarshal.StringToX(contentType, &xstring4);
								XString xstring5;
								<Module>.XString.{ctor}(ref xstring5);
								try
								{
									bool flag = <Module>.ClsHttp.PutText(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4, md5, gzip, ref xstring5, (ProgressEvent*)ptr) != null;
									if (flag)
									{
										goto IL_141;
									}
									result = null;
								}
								catch
								{
									<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring5));
									throw;
								}
								<Module>.XString.{dtor}(ref xstring5);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_141:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							XString xstring4;
							try
							{
								XString xstring5;
								try
								{
									result2 = CkMarshal.XToString(&xstring5);
								}
								catch
								{
									<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring5));
									throw;
								}
								<Module>.XString.{dtor}(ref xstring5);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string PutBinary(string url, byte[] byteData, string contentType, [MarshalAs(UnmanagedType.U1)] bool md5, [MarshalAs(UnmanagedType.U1)] bool gzip)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					int num2 = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(byteData, ref num2);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num2);
						XString xstring2;
						<Module>.XString.{ctor}(ref xstring2);
						try
						{
							CkMarshal.StringToX(contentType, &xstring2);
							XString xstring3;
							<Module>.XString.{ctor}(ref xstring3);
							try
							{
								bool flag = false;
								uint exceptionCode;
								try
								{
									flag = (<Module>.ClsHttp.PutBinary(this.m_impl, ref xstring, ref dataBuffer, ref xstring2, md5, gzip, ref xstring3, (ProgressEvent*)ptr) != null);
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									exceptionCode = (uint)Marshal.GetExceptionCode();
									endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
								})
								{
									uint num3 = 0U;
									<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
									try
									{
										try
										{
											<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_09MHDABFDI@PutBinary?$AA@));
											goto IL_108;
										}
										catch when (delegate
										{
											// Failed to create a 'catch-when' expression
											num3 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
											endfilter(num3 != 0U);
										})
										{
										}
										if (num3 != 0U)
										{
											throw;
										}
									}
									finally
									{
										<Module>.__CxxUnregisterExceptionObject(num, (int)num3);
									}
								}
								IL_108:
								CkMarshal.free(ptr2);
								if (flag)
								{
									goto IL_197;
								}
								result = null;
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_197:
			string result2;
			try
			{
				XString xstring;
				try
				{
					DataBuffer dataBuffer;
					try
					{
						XString xstring2;
						try
						{
							XString xstring3;
							try
							{
								result2 = CkMarshal.XToString(&xstring3);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public int SendBufferSize
		{
			get
			{
				return <Module>.ClsHttp.get_SendBufferSize(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_SendBufferSize(this.m_impl, value);
			}
		}

		public bool NegotiateAuth
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_NegotiateAuth(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_NegotiateAuth(this.m_impl, value);
			}
		}

		public unsafe string LoginDomain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_LoginDomain(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_LoginDomain(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsHttp.get_SocksVersion(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_SocksVersion(this.m_impl, value);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsHttp.get_SocksPort(this.m_impl);
			}
			set
			{
				<Module>.ClsHttp.put_SocksPort(this.m_impl, value);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_SocksUsername(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_SocksUsername(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_SocksPassword(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_SocksPassword(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_SocksHostname(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_SocksHostname(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe HttpResponse PostXml(string url, string xmlDoc, string charset)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(xmlDoc, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(charset, &xstring3);
							ClsHttpResponse* ptr2 = <Module>.ClsHttp.PostXml(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr);
							if (ptr2 != null)
							{
								goto IL_EF;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_EF:
			HttpResponse result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							ClsHttpResponse* ptr2;
							result2 = new HttpResponse((void*)ptr2);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public bool ProxyPartialUrl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_ProxyPartialUrl(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_ProxyPartialUrl(this.m_impl, value);
			}
		}

		public unsafe Cert GetServerSslCert(string domain, int port)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			Cert result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(domain, &xstring);
					ClsCert* ptr2 = <Module>.ClsHttp.GetServerSslCert(this.m_impl, ref xstring, port, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_9E;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_9E:
			Cert result2;
			try
			{
				XString xstring;
				try
				{
					ClsCert* ptr2;
					result2 = new Cert((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public bool DigestAuth
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_DigestAuth(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_DigestAuth(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xstring3);
						result = (<Module>.ClsHttp.SetSslClientCertPfx(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsHttp.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsHttp.put_VerboseLogging(this.m_impl, value);
			}
		}

		public void ClearInMemoryCookies()
		{
			<Module>.ClsHttp.ClearInMemoryCookies(this.m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetCookieXml(string domain, string cookieXml)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(domain, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(cookieXml, &xstring2);
					result = (<Module>.ClsHttp.SetCookieXml(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe HttpResponse PostUrlEncoded(string url, HttpRequest req)
		{
			if (req == null)
			{
				return null;
			}
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					ClsHttpRequest* implementation = (ClsHttpRequest*)req.GetImplementation();
					ClsHttpResponse* ptr2 = <Module>.ClsHttp.PostUrlEncoded(this.m_impl, ref xstring, implementation, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_AC;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_AC:
			HttpResponse result2;
			try
			{
				XString xstring;
				try
				{
					ClsHttpResponse* ptr2;
					result2 = new HttpResponse((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string PostBinary(string url, byte[] byteData, string contentType, [MarshalAs(UnmanagedType.U1)] bool md5, [MarshalAs(UnmanagedType.U1)] bool gzip)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			string result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					int num = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(byteData, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr2, num);
						XString xstring2;
						<Module>.XString.{ctor}(ref xstring2);
						try
						{
							CkMarshal.StringToX(contentType, &xstring2);
							XString xstring3;
							<Module>.XString.{ctor}(ref xstring3);
							try
							{
								bool flag = <Module>.ClsHttp.PostBinary(this.m_impl, ref xstring, ref dataBuffer, ref xstring2, md5, gzip, ref xstring3, (ProgressEvent*)ptr) != null;
								CkMarshal.free(ptr2);
								if (flag)
								{
									goto IL_12E;
								}
								result = null;
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_12E:
			string result2;
			try
			{
				XString xstring;
				try
				{
					DataBuffer dataBuffer;
					try
					{
						XString xstring2;
						try
						{
							XString xstring3;
							try
							{
								result2 = CkMarshal.XToString(&xstring3);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe HttpResponse QuickGetObj(string url)
		{
			_HttpCallback httpCallback;
			<Module>.HttpCallback.{ctor}(ref httpCallback);
			try
			{
				httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
				*(ref httpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			HttpResponse result;
			try
			{
				_HttpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &httpCallback;
					*(ref httpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(url, &xstring);
					ClsHttpResponse* ptr2 = <Module>.ClsHttp.QuickGetObj(this.m_impl, ref xstring, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_9D;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result;
			IL_9D:
			HttpResponse result2;
			try
			{
				XString xstring;
				try
				{
					ClsHttpResponse* ptr2;
					result2 = new HttpResponse((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._HttpCallback.{dtor}), (void*)(&httpCallback));
				throw;
			}
			httpCallback = ref <Module>.??_7_HttpCallback@Chilkat@@6B@;
			<Module>.HttpCallback.{dtor}(ref httpCallback);
			return result2;
		}

		public unsafe string SessionLogFilename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_SessionLogFilename(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_SessionLogFilename(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string BgLastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBgTask.get_BgLastErrorText(this.m_impl + 152 / sizeof(ClsHttp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe byte[] BgResultData
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsBgTask.get_BgResultData(this.m_impl + 152 / sizeof(ClsHttp), ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
		}

		public int BgResultInt
		{
			get
			{
				return <Module>.ClsBgTask.get_BgResultInt(this.m_impl + 152 / sizeof(ClsHttp));
			}
		}

		public unsafe string BgResultString
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBgTask.get_BgResultString(this.m_impl + 152 / sizeof(ClsHttp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool BgTaskFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsBgTask.get_BgTaskFinished(this.m_impl + 152 / sizeof(ClsHttp)) != null;
			}
		}

		public bool BgTaskRunning
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsBgTask.get_BgTaskRunning(this.m_impl + 152 / sizeof(ClsHttp)) != null;
			}
		}

		public bool BgTaskSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsBgTask.get_BgTaskSuccess(this.m_impl + 152 / sizeof(ClsHttp)) != null;
			}
		}

		public int EventLogCount
		{
			get
			{
				return <Module>.ClsBgTask.get_EventLogCount(this.m_impl + 152 / sizeof(ClsHttp));
			}
		}

		public bool KeepEventLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsBgTask.get_KeepEventLog(this.m_impl + 152 / sizeof(ClsHttp)) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsBgTask.put_KeepEventLog(this.m_impl + 152 / sizeof(ClsHttp), value);
			}
		}

		public bool UseBgThread
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsBgTask.get_UseBgThread(this.m_impl + 152 / sizeof(ClsHttp)) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsBgTask.put_UseBgThread(this.m_impl + 152 / sizeof(ClsHttp), value);
			}
		}

		public unsafe HttpResponse BgResponseObject()
		{
			ClsHttpResponse* ptr = <Module>.ClsHttp.BgResponseObject(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new HttpResponse((void*)ptr);
		}

		public void BgTaskAbort()
		{
			<Module>.ClsBgTask.BgTaskAbort(this.m_impl + 152 / sizeof(ClsHttp));
		}

		public void ClearEventLog()
		{
			<Module>.ClsBgTask.ClearEventLog(this.m_impl + 152 / sizeof(ClsHttp));
		}

		public unsafe string EventLogName(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsBgTask.EventLogName(this.m_impl + 152 / sizeof(ClsHttp), index, ref xstring) != null;
				if (flag)
				{
					goto IL_3D;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3D:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string EventLogValue(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsBgTask.EventLogValue(this.m_impl + 152 / sizeof(ClsHttp), index, ref xstring) != null;
				if (flag)
				{
					goto IL_3D;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3D:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public void SleepMs(int millisec)
		{
			<Module>.ClsHttp.SleepMs(this.m_impl, millisec);
		}

		public unsafe string ClientIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_ClientIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_ClientIpAddress(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyAuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttp.get_ProxyAuthMethod(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttp.put_ProxyAuthMethod(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public event Http.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public event Http.ProgressInfoEventHandler OnProgressInfo
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnProgressInfo = Delegate.Combine(this.OnProgressInfo, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnProgressInfo = Delegate.Remove(this.OnProgressInfo, value);
			}
		}

		public event Http.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public event Http.ReceiveRateEventHandler OnReceiveRate
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnReceiveRate = Delegate.Combine(this.OnReceiveRate, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnReceiveRate = Delegate.Remove(this.OnReceiveRate, value);
			}
		}

		public event Http.HttpChunkedEventHandler OnHttpChunked
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnHttpChunked = Delegate.Combine(this.OnHttpChunked, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnHttpChunked = Delegate.Remove(this.OnHttpChunked, value);
			}
		}

		public event Http.HttpRedirectEventHandler OnHttpRedirect
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnHttpRedirect = Delegate.Combine(this.OnHttpRedirect, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnHttpRedirect = Delegate.Remove(this.OnHttpRedirect, value);
			}
		}

		public event Http.HttpBeginReceiveEventHandler OnHttpBeginReceive
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnHttpBeginReceive = Delegate.Combine(this.OnHttpBeginReceive, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnHttpBeginReceive = Delegate.Remove(this.OnHttpBeginReceive, value);
			}
		}

		public event Http.HttpBeginSendEventHandler OnHttpBeginSend
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnHttpBeginSend = Delegate.Combine(this.OnHttpBeginSend, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnHttpBeginSend = Delegate.Remove(this.OnHttpBeginSend, value);
			}
		}

		public event Http.HttpEndReceiveEventHandler OnHttpEndReceive
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnHttpEndReceive = Delegate.Combine(this.OnHttpEndReceive, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnHttpEndReceive = Delegate.Remove(this.OnHttpEndReceive, value);
			}
		}

		public event Http.HttpEndSendEventHandler OnHttpEndSend
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnHttpEndSend = Delegate.Combine(this.OnHttpEndSend, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnHttpEndSend = Delegate.Remove(this.OnHttpEndSend, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsHttp* m_impl;

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void ProgressInfoEventHandler(object sender, ProgressInfoEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void ReceiveRateEventHandler(object sender, DataRateEventArgs args);

		public delegate void HttpChunkedEventHandler(object sender, EventArgs args);

		public delegate void HttpRedirectEventHandler(object sender, HttpRedirectEventArgs args);

		public delegate void HttpBeginReceiveEventHandler(object sender, EventArgs args);

		public delegate void HttpBeginSendEventHandler(object sender, EventArgs args);

		public delegate void HttpEndReceiveEventHandler(object sender, StatusEventArgs args);

		public delegate void HttpEndSendEventHandler(object sender, StatusEventArgs args);
	}
}
