﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class HttpRedirectEventArgs : EventArgs
	{
		public unsafe HttpRedirectEventArgs(sbyte* originalUrl, sbyte* redirectUrl)
		{
			this.m_abort = false;
			this.m_originalUrl = CkMarshal.Utf8ToString(originalUrl);
			this.m_redirectUrl = CkMarshal.Utf8ToString(redirectUrl);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public string OriginalUrl
		{
			get
			{
				return this.m_originalUrl;
			}
		}

		public string RedirectUrl
		{
			get
			{
				return this.m_redirectUrl;
			}
		}

		public bool Abort
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_abort;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				this.m_abort = value;
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private string m_originalUrl;

		private string m_redirectUrl;

		private bool m_abort;
	}
}
