﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class HttpResponse
	{
		public unsafe HttpResponse(void* impl)
		{
			this.m_impl = (ClsHttpResponse*)impl;
		}

		public unsafe HttpResponse()
		{
			ClsHttpResponse* ptr = <Module>.@new(552U);
			ClsHttpResponse* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsHttpResponse.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsHttpResponse* impl = this.m_impl;
			if (impl != null)
			{
				ClsHttpResponse* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public unsafe string Header
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpResponse.get_Header(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe byte[] Body
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsHttpResponse.copyBody(this.m_impl, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
		}

		public unsafe string BodyStr
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpResponse.get_BodyStr(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string StatusLine
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpResponse.get_StatusText(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int StatusCode
		{
			get
			{
				return <Module>.ClsHttpResponse.get_StatusCode(this.m_impl);
			}
		}

		public unsafe string Charset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpResponse.get_Charset(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string Domain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpResponse.get_Domain(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int ContentLength
		{
			get
			{
				return <Module>.ClsHttpResponse.get_ContentLength(this.m_impl);
			}
		}

		public unsafe DateTime Date
		{
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				<Module>.ClsHttpResponse.get_Date(this.m_impl, ref year);
				DateTime result = default(DateTime);
				uint exceptionCode;
				try
				{
					DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
					result = dateTime;
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							return DateTime.Now;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				return result;
			}
		}

		public unsafe string GetHeaderField(string fieldName)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(fieldName, &xstring2);
					bool flag = <Module>.ClsHttpResponse.GetHeaderField(this.m_impl, ref xstring2, ref xstring) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetHeaderFieldAttr(string fieldName, string attrName)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(fieldName, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(attrName, &xstring3);
						bool flag = <Module>.ClsHttpResponse.GetHeaderAttribute(this.m_impl, ref xstring2, ref xstring3, ref xstring) != null;
						if (flag)
						{
							goto IL_88;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_88:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						result2 = CkMarshal.XToString(&xstring);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int NumHeaderFields
		{
			get
			{
				return <Module>.ClsHttpResponse.get_NumHeaderFields(this.m_impl);
			}
		}

		public unsafe string GetHeaderName(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttpResponse.GetHeaderName(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetHeaderValue(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttpResponse.GetHeaderValue(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int NumCookies
		{
			get
			{
				return <Module>.ClsHttpResponse.get_NumCookies(this.m_impl);
			}
		}

		public unsafe string GetCookieDomain(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttpResponse.GetCookieDomain(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetCookiePath(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttpResponse.GetCookiePath(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetCookieExpiresStr(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttpResponse.GetCookieExpiresStr(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe DateTime GetCookieExpires(int index)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ChilkatSysTime year;
			<Module>.ChilkatSysTime.{ctor}(ref year);
			<Module>.ClsHttpResponse.GetCookieExpires(this.m_impl, index, ref year);
			DateTime result = default(DateTime);
			uint exceptionCode;
			try
			{
				DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
				result = dateTime;
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return DateTime.Now;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		public unsafe string GetCookieName(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttpResponse.GetCookieName(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetCookieValue(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsHttpResponse.GetCookieValue(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsHttpResponse* m_impl;
	}
}
