﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Imap : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Imap LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Imap.m_lockObject);
			Imap result = (Imap)Imap.m_objects[key];
			Monitor.Exit(Imap.m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			Imap.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Imap.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe Imap()
		{
			this.m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			<Module>.?A0x249c62c6.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x249c62c6.NextHashCode;
			ClsImap* ptr = <Module>.@new(3000U);
			ClsImap* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsImap.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 2952) = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsImap* impl = this.m_impl;
			if (impl != null)
			{
				ClsImap* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Imap.m_lockObject);
				object key = this.m_myHashCode;
				Imap.m_objects.Remove(key);
				Monitor.Exit(Imap.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(Imap.m_lockObject);
			ClsImap* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsImap.dotNetDispose(impl);
			}
			object key = this.m_myHashCode;
			Imap.m_objects.Remove(key);
			Monitor.Exit(Imap.m_lockObject);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsImap.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool IsUnlocked()
		{
			return <Module>.ClsImap.IsUnlocked(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect(string hostname)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = false;
					uint exceptionCode;
					try
					{
						result = (<Module>.ClsImap.Connect(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07FJPHLACI@Connect?$AA@));
								goto IL_DF;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				IL_DF:
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Disconnect()
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				<Module>.ClsImap.Disconnect(this.m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return true;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool IsConnected()
		{
			return <Module>.ClsImap.IsConnected(this.m_impl) != null;
		}

		public void ClearSessionLog()
		{
			<Module>.ClsImap.ClearSessionLog(this.m_impl);
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.get_SessionLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_KeepSessionLog(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsImap.put_KeepSessionLog(this.m_impl, value);
			}
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsImap.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsImap.put_HeartbeatMs(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Login(string login, string password)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(login, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(password, &xstring2);
					_ImapCallback imapCallback;
					<Module>.ImapCallback.{ctor}(ref imapCallback);
					try
					{
						imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
						*(ref imapCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &imapCallback;
							*(ref imapCallback + 4) = this.m_myHashCode;
						}
						result = false;
						uint exceptionCode;
						try
						{
							result = (<Module>.ClsImap.Login(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_05DHEMANOL@Login?$AA@));
									goto IL_D7;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_D7:
						<Module>.XString.secureClear(ref xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					<Module>.ImapCallback.{dtor}(ref imapCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Logout()
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsImap.Logout(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool IsLoggedIn()
		{
			return <Module>.ClsImap.IsLoggedIn(this.m_impl) != null;
		}

		public unsafe string LoggedInUser
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.getLoggedInUser(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string ConnectedToHost
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.getConnectedToHost(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateMailbox(string mailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.CreateMailbox(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteMailbox(string mailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.DeleteMailbox(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RenameMailbox(string fromMailbox, string toMailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fromMailbox, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(toMailbox, &xstring2);
					_ImapCallback imapCallback;
					<Module>.ImapCallback.{ctor}(ref imapCallback);
					try
					{
						imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
						*(ref imapCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &imapCallback;
							*(ref imapCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsImap.RenameMailbox(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					<Module>.ImapCallback.{dtor}(ref imapCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string LastResponse
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.getLastResponse(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastCommand
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.getLastCommand(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastAppendedMime
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.getLastAppendedMime(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastIntermediateResponse
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.getLastIntermediateResponse(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe Mailboxes ListMailboxes(string reference, string wildcardedMailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Mailboxes result;
			try
			{
				CkMarshal.StringToX(reference, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(wildcardedMailbox, &xstring2);
					ClsMailboxes* ptr = <Module>.@new(24U);
					ClsMailboxes* ptr2;
					try
					{
						if (ptr != null)
						{
							ptr2 = <Module>.ClsMailboxes.{ctor}(ptr);
						}
						else
						{
							ptr2 = 0;
						}
					}
					catch
					{
						<Module>.delete((void*)ptr);
						throw;
					}
					_ImapCallback imapCallback;
					<Module>.ImapCallback.{ctor}(ref imapCallback);
					try
					{
						imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
						*(ref imapCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					try
					{
						_ImapCallback* ptr3 = null;
						if (this.m_enableEvents)
						{
							ptr3 = &imapCallback;
							*(ref imapCallback + 4) = this.m_myHashCode;
						}
						if (<Module>.ClsImap.ListMailboxes(this.m_impl, ref xstring, ref xstring2, ptr2, (ProgressEvent*)ptr3) == null)
						{
							if (ptr2 != null)
							{
								object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
							}
						}
						else if (ptr2 != null)
						{
							goto IL_F9;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					<Module>.ImapCallback.{dtor}(ref imapCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_F9:
			Mailboxes result2;
			try
			{
				XString xstring2;
				try
				{
					_ImapCallback imapCallback;
					try
					{
						ClsMailboxes* ptr2;
						result2 = new Mailboxes(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					<Module>.ImapCallback.{dtor}(ref imapCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SelectMailbox(string mailbox)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.SelectMailbox(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExamineMailbox(string mailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.ExamineMailbox(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Subscribe(string mailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.Subscribe(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Unsubscribe(string mailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.Unsubscribe(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe MessageSet Search(string criteria, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			if (this.m_impl == null)
			{
				return null;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			MessageSet result;
			try
			{
				CkMarshal.StringToX(criteria, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					ClsMessageSet* ptr2 = <Module>.ClsImap.Search(this.m_impl, ref xstring, bUid, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_A8;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_A8:
			MessageSet result2;
			try
			{
				_ImapCallback imapCallback;
				try
				{
					ClsMessageSet* ptr2;
					result2 = new MessageSet((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe MessageSet GetAllUids()
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			MessageSet result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsMessageSet* ptr2 = <Module>.ClsImap.GetAllUids(this.m_impl, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_74;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_74:
			MessageSet result2;
			try
			{
				ClsMessageSet* ptr2;
				result2 = new MessageSet((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe Email FetchSingle(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			<Module>.ClsImap.ClearLog(this.m_impl);
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			Email result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsEmail* ptr2 = <Module>.ClsImap.FetchSingle(this.m_impl, msgId, bUid, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_81;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_81:
			Email result2;
			try
			{
				ClsEmail* ptr2;
				result2 = new Email((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe Email FetchSingleHeader(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			<Module>.ClsImap.ClearLog(this.m_impl);
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			Email result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsEmail* ptr2 = <Module>.ClsImap.FetchSingleHeader(this.m_impl, msgId, bUid, (ProgressEvent*)ptr, true);
				if (ptr2 != null)
				{
					goto IL_82;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_82:
			Email result2;
			try
			{
				ClsEmail* ptr2;
				result2 = new Email((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe EmailBundle FetchBundle(MessageSet messageSet)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return null;
			}
			if (messageSet == null)
			{
				return null;
			}
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsEmailBundle* ptr2 = null;
				uint exceptionCode;
				try
				{
					ptr2 = <Module>.ClsImap.FetchBundle(this.m_impl, impl, (ProgressEvent*)ptr);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0M@KAMPMOIL@FetchBundle?$AA@));
							goto IL_CC;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_CC:
				if (ptr2 != null)
				{
					goto IL_F6;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_F6:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr2;
				result2 = new EmailBundle((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe EmailBundle FetchHeaders(MessageSet messageSet)
		{
			if (messageSet == null)
			{
				return null;
			}
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsEmailBundle* ptr2 = <Module>.ClsImap.FetchHeaders(this.m_impl, impl, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_83;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_83:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr2;
				result2 = new EmailBundle((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe EmailBundle FetchSequence(int startSeqNum, int numMessages)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsEmailBundle* ptr2 = null;
				uint exceptionCode;
				try
				{
					ptr2 = <Module>.ClsImap.FetchSequence(this.m_impl, startSeqNum, numMessages, null, null, (ProgressEvent*)ptr);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0O@LCLNFLBD@FetchSequence?$AA@));
							goto IL_B7;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_B7:
				if (ptr2 != null)
				{
					goto IL_E1;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_E1:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr2;
				result2 = new EmailBundle((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe EmailBundle FetchSequenceHeaders(int startSeqNum, int numMessages)
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsEmailBundle* ptr2 = <Module>.ClsImap.FetchSequenceHeaders(this.m_impl, startSeqNum, numMessages, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_76;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_76:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr2;
				result2 = new EmailBundle((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe string FetchSingleAsMime(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsImap.FetchSingleAsMime(this.m_impl, msgId, bUid, ref xstring, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						goto IL_97;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_97:
			string result2;
			try
			{
				_ImapCallback imapCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe StringArray FetchBundleAsMime(MessageSet messageSet)
		{
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			StringArray result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsStringArray* ptr2 = <Module>.ClsImap.FetchBundleAsMime(this.m_impl, impl, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_7E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_7E:
			StringArray result2;
			try
			{
				ClsStringArray* ptr2;
				result2 = new StringArray((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe StringArray FetchSequenceAsMime(int startSeqNum, int numMessages)
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			StringArray result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsStringArray* ptr2 = <Module>.ClsImap.FetchSequenceAsMime(this.m_impl, startSeqNum, numMessages, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_76;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_76:
			StringArray result2;
			try
			{
				ClsStringArray* ptr2;
				result2 = new StringArray((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetDecryptCert2(Cert cert, PrivateKey key)
		{
			if (cert == null)
			{
				return false;
			}
			if (key == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			ClsPrivateKey* implementation2 = (ClsPrivateKey*)key.GetImplementation();
			return implementation != null && implementation2 != null && <Module>.ClsImap.SetDecryptCert(this.m_impl, implementation, implementation2) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Expunge()
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsImap.Expunge(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExpungeAndClose()
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsImap.ExpungeAndClose(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetFlag(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid, string flagName, int value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(flagName, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.SetFlag(this.m_impl, msgId, bUid, ref xstring, value, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetFlags(MessageSet messageSet, string flagName, int value)
		{
			if (messageSet == null)
			{
				return false;
			}
			ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(flagName, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.SetFlags(this.m_impl, impl, ref xstring, value, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string AuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.get_AuthMethod(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsImap.put_AuthMethod(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Domain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.get_Domain(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsImap.put_Domain(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int NumMessages
		{
			get
			{
				return <Module>.ClsImap.get_NumMessages(this.m_impl);
			}
		}

		public int ReadTimeout
		{
			get
			{
				return <Module>.ClsImap.get_ReadTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsImap.put_ReadTimeout(this.m_impl, value);
			}
		}

		public sbyte SeparatorChar
		{
			get
			{
				if (<Module>.chilkat.StringBuffer.getSize(this.m_impl + 2960 / sizeof(ClsImap)) != null)
				{
					return <Module>.chilkat.StringBuffer.charAt(this.m_impl + 2960 / sizeof(ClsImap), 0);
				}
				return 46;
			}
			set
			{
				<Module>.chilkat.StringBuffer.clear(this.m_impl + 2960 / sizeof(ClsImap));
				<Module>.chilkat.StringBuffer.appendChar(this.m_impl + 2960 / sizeof(ClsImap), value);
			}
		}

		public int ConnectTimeout
		{
			get
			{
				return <Module>.ClsImap.get_ConnectTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsImap.put_ConnectTimeout(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMime(string mailbox, string mimeText)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(mimeText, &xstring2);
					_ImapCallback imapCallback;
					<Module>.ImapCallback.{ctor}(ref imapCallback);
					try
					{
						imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
						*(ref imapCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &imapCallback;
							*(ref imapCallback + 4) = this.m_myHashCode;
						}
						result = (<Module>.ClsImap.AppendMime(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					<Module>.ImapCallback.{dtor}(ref imapCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMail(string mailbox, Email email)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr2 = null;
					if (this.m_enableEvents)
					{
						ptr2 = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.AppendMail(this.m_impl, ref xstring, ptr, (ProgressEvent*)ptr2) != null);
					email.ReleaseImpl();
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Copy(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid, string copyToMailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(copyToMailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.Copy(this.m_impl, msgId, bUid, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CopySequence(int startSeqNum, int count, string copyToMailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(copyToMailbox, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.CopySequence(this.m_impl, startSeqNum, count, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CopyMultiple(MessageSet messageSet, string copyToMailbox)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(copyToMailbox, &xstring);
				ClsMessageSet* impl = (ClsMessageSet*)messageSet.GetImpl();
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.CopyMultiple(this.m_impl, impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetMailFlag(Email email, string flagName, int value)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(flagName, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr2 = null;
					if (this.m_enableEvents)
					{
						ptr2 = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.SetMailFlag(this.m_impl, ptr, ref xstring, value, (ProgressEvent*)ptr2) != null);
					email.ReleaseImpl();
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int GetMailFlag(Email email, string flagName)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(flagName, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr2 = null;
					if (this.m_enableEvents)
					{
						ptr2 = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = <Module>.ClsImap.GetMailFlag(this.m_impl, ptr, ref xstring, (ProgressEvent*)ptr2);
					email.ReleaseImpl();
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RefetchMailFlags(Email email)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr2 = null;
				if (this.m_enableEvents)
				{
					ptr2 = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsImap.RefetchMailFlags(this.m_impl, ptr, (ProgressEvent*)ptr2) != null);
				email.ReleaseImpl();
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool StoreFlags(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid, string flagNames, int value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(flagNames, &xstring);
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsImap.StoreFlags(this.m_impl, msgId, bUid, ref xstring, value, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string FetchFlags(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUid)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				_ImapCallback imapCallback;
				<Module>.ImapCallback.{ctor}(ref imapCallback);
				try
				{
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					*(ref imapCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				try
				{
					_ImapCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &imapCallback;
						*(ref imapCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsImap.FetchFlagsStr(this.m_impl, msgId, bUid, ref xstring, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						goto IL_97;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_97:
			string result2;
			try
			{
				_ImapCallback imapCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
					throw;
				}
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				<Module>.ImapCallback.{dtor}(ref imapCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe int GetMailSize(Email email)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			if (<Module>.ClsEmail.HasHeaderField(ptr, (sbyte*)(&<Module>.??_C@_0BD@GBIJOIIM@ckx?9imap?9totalsize?$AA@)) == null)
			{
				int result = <Module>.ClsEmail.get_Size(ptr);
				email.ReleaseImpl();
				return result;
			}
			int result2 = <Module>.ClsEmail.GetHeaderFieldInt(ptr, (sbyte*)(&<Module>.??_C@_0BD@GBIJOIIM@ckx?9imap?9totalsize?$AA@));
			email.ReleaseImpl();
			return result2;
		}

		public unsafe int GetMailNumAttach(Email email)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			int result = <Module>.ClsImap.GetMailNumAttach(this.m_impl, ptr);
			email.ReleaseImpl();
			return result;
		}

		public unsafe int GetMailAttachSize(Email email, int attachIndex)
		{
			if (email == null)
			{
				return 0;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			int result = <Module>.ClsImap.GetMailAttachSize(this.m_impl, ptr, attachIndex);
			email.ReleaseImpl();
			return result;
		}

		public unsafe string GetMailAttachFilename(Email email, int attachIndex)
		{
			if (email == null)
			{
				return null;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsImap.GetMailAttachFilename(this.m_impl, ptr, attachIndex, ref xstring) != null;
				email.ReleaseImpl();
				if (flag)
				{
					goto IL_4A;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_4A:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public bool AutoUnwrapSecurity
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_AutoUnwrap(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsImap.put_AutoUnwrap(this.m_impl, value);
			}
		}

		public int Port
		{
			get
			{
				return <Module>.ClsImap.get_Port(this.m_impl);
			}
			set
			{
				<Module>.ClsImap.put_Port(this.m_impl, value);
			}
		}

		public bool Ssl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_Ssl(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsImap.put_Ssl(this.m_impl, value);
			}
		}

		public bool PeekMode
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_PeekMode(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsImap.put_PeekMode(this.m_impl, value);
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				if (this.m_impl == null)
				{
					return new string((sbyte*)(&<Module>.??_C@_0CC@GICFJEDK@Error?5?9?9?5internal?5object?5deleted@));
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.GetTextLogX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.GetXmlLogX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.GetHtmlLogX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsImap.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string SendRawCommand(string cmd)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(cmd, &xstring2);
					_ImapCallback imapCallback;
					<Module>.ImapCallback.{ctor}(ref imapCallback);
					try
					{
						imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
						*(ref imapCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					try
					{
						_ImapCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &imapCallback;
							*(ref imapCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsImap.SendRawCommand(this.m_impl, ref xstring2, ref xstring, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					<Module>.ImapCallback.{dtor}(ref imapCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_BE:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_ImapCallback imapCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
						throw;
					}
					imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
					<Module>.ImapCallback.{dtor}(ref imapCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			<Module>.ClsImap.SetSslClientCert(this.m_impl, ptr);
		}

		public bool SslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_SslServerCertVerified(this.m_impl) != null;
			}
		}

		public unsafe Cert GetSslServerCert()
		{
			ClsCert* ptr = <Module>.ClsImap.GetSslServerCert(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Imap.m_lockObject);
						if (Imap.m_objects == null)
						{
							Imap.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Imap.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Imap.m_objects = new Hashtable();
									Imap.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Imap.m_lockObject);
					}
					else
					{
						Monitor.Enter(Imap.m_lockObject);
						object key3 = this.m_myHashCode;
						Imap.m_objects.Remove(key3);
						Monitor.Exit(Imap.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public bool AppendSeen
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_AppendSeen(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsImap.put_AppendSeen(this.m_impl, value);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMimeWithFlags(string mailbox, string mimeText, [MarshalAs(UnmanagedType.U1)] bool seen, [MarshalAs(UnmanagedType.U1)] bool flagged, [MarshalAs(UnmanagedType.U1)] bool answered, [MarshalAs(UnmanagedType.U1)] bool draft)
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(mailbox, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(mimeText, &xstring2);
						result = (<Module>.ClsImap.AppendMimeWithFlags(this.m_impl, ref xstring, ref xstring2, seen, flagged, answered, draft, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		public unsafe EmailBundle FetchChunk(int startSeqNum, int count, MessageSet failedSet, MessageSet fetchedSet)
		{
			if (failedSet == null)
			{
				return null;
			}
			if (fetchedSet == null)
			{
				return null;
			}
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			EmailBundle result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				ClsMessageSet* impl = (ClsMessageSet*)failedSet.GetImpl();
				ClsMessageSet* impl2 = (ClsMessageSet*)fetchedSet.GetImpl();
				ClsEmailBundle* ptr2 = <Module>.ClsImap.FetchSequence(this.m_impl, startSeqNum, count, impl, impl2, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_96;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_96:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr2;
				result2 = new EmailBundle((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		public unsafe string FetchSingleHeaderAsMime(int msgId, [MarshalAs(UnmanagedType.U1)] bool bUID)
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			string result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsImap.FetchSingleHeaderAsMime(this.m_impl, msgId, bUID, ref xstring, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						goto IL_97;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
			IL_97:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMimeWithDate(string mailbox, string mimeText, DateTime internalDate)
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(mailbox, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(mimeText, &xstring2);
						ChilkatSysTime year;
						<Module>.ChilkatSysTime.{ctor}(ref year);
						year = internalDate.Year;
						*(ref year + 2) = (short)internalDate.Month;
						*(ref year + 6) = (short)internalDate.Day;
						*(ref year + 8) = (short)internalDate.Hour;
						*(ref year + 10) = (short)internalDate.Minute;
						*(ref year + 12) = (short)internalDate.Second;
						result = (<Module>.ClsImap.AppendMimeWithDate(this.m_impl, ref xstring, ref xstring2, ref year, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		public unsafe string SelectedMailbox
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.get_SelectedMailbox(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int AppendUid
		{
			get
			{
				return <Module>.ClsImap.get_AppendUid(this.m_impl);
			}
		}

		public unsafe string AuthzId
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.get_AuthzId(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsImap.put_AuthzId(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int SendBufferSize
		{
			get
			{
				return <Module>.ClsImap.get_SendBufferSize(this.m_impl);
			}
			set
			{
				<Module>.ClsImap.put_SendBufferSize(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshTunnel(string sshServerHostname, int sshServerPort)
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(sshServerHostname, &xstring);
					result = (<Module>.ClsImap.SshTunnel(this.m_impl, ref xstring, sshServerPort, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePw(string sshLogin, string sshPassword)
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(sshLogin, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(sshPassword, &xstring2);
						result = (<Module>.ClsImap.SshAuthenticatePw(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePk(string sshLogin, SshKey privateKey)
		{
			if (privateKey == null)
			{
				return false;
			}
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(sshLogin, &xstring);
					ClsSshKey* implementation = (ClsSshKey*)privateKey.GetImplementation();
					result = (<Module>.ClsImap.SshAuthenticatePk(this.m_impl, ref xstring, implementation, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Noop()
		{
			_ImapCallback imapCallback;
			<Module>.ImapCallback.{ctor}(ref imapCallback);
			try
			{
				imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
				*(ref imapCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			bool result;
			try
			{
				_ImapCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &imapCallback;
					*(ref imapCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsImap.Noop(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ImapCallback.{dtor}), (void*)(&imapCallback));
				throw;
			}
			imapCallback = ref <Module>.??_7_ImapCallback@Chilkat@@6B@;
			<Module>.ImapCallback.{dtor}(ref imapCallback);
			return result;
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksHostname(this.m_impl + 120 / sizeof(ClsImap), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksHostname(this.m_impl + 120 / sizeof(ClsImap), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksUsername(this.m_impl + 120 / sizeof(ClsImap), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksUsername(this.m_impl + 120 / sizeof(ClsImap), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksPassword(this.m_impl + 120 / sizeof(ClsImap), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksPassword(this.m_impl + 120 / sizeof(ClsImap), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksPort(this.m_impl + 120 / sizeof(ClsImap));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksPort(this.m_impl + 120 / sizeof(ClsImap), value);
			}
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksVersion(this.m_impl + 120 / sizeof(ClsImap));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksVersion(this.m_impl + 120 / sizeof(ClsImap), value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xstring3);
						result = (<Module>.ClsImap.SetSslClientCertPfx(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool StartTls
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_StartTls(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsImap.put_StartTls(this.m_impl, value);
			}
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsImap.get_SslProtocol(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsImap.put_SslProtocol(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyUsername(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyUsername(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyPassword(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyPassword(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyAuthMethod(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyAuthMethod(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyHostname(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyHostname(this.m_impl + 544 / sizeof(ClsImap), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int HttpProxyPort
		{
			get
			{
				return <Module>.ClsHttpProxyClient.get_HttpProxyPort(this.m_impl + 544 / sizeof(ClsImap));
			}
			set
			{
				<Module>.ClsHttpProxyClient.put_HttpProxyPort(this.m_impl + 544 / sizeof(ClsImap), value);
			}
		}

		public int UidNext
		{
			get
			{
				return <Module>.ClsImap.get_UidNext(this.m_impl);
			}
		}

		public bool AutoFix
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsImap.get_AutoFix(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsImap.put_AutoFix(this.m_impl, value);
			}
		}

		public event Imap.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public event Imap.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsImap* m_impl;

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
