﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class KeyContainer : IDisposable
	{
		public unsafe KeyContainer(void* impl)
		{
			this.m_impl = (ClsKeyContainer*)impl;
		}

		public unsafe KeyContainer()
		{
			ClsKeyContainer* ptr = <Module>.@new(240U);
			ClsKeyContainer* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsKeyContainer.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsKeyContainer* impl = this.m_impl;
			if (impl != null)
			{
				ClsKeyContainer* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool IsOpen
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsKeyContainer.get_IsOpen(this.m_impl) != null;
			}
		}

		public bool IsMachineKeyset
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsKeyContainer.get_IsMachineKeyset(this.m_impl) != null;
			}
		}

		public unsafe string ContainerName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsKeyContainer.get_ContainerName(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string GenerateUuid()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsKeyContainer.GenerateUuid(this.m_impl, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateContainer(string name, [MarshalAs(UnmanagedType.U1)] bool machineKeyset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = (<Module>.ClsKeyContainer.CreateContainer(this.m_impl, ref xstring, machineKeyset) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenContainer(string name, [MarshalAs(UnmanagedType.U1)] bool needPrivateKeyAccess, [MarshalAs(UnmanagedType.U1)] bool machineKeyset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = (<Module>.ClsKeyContainer.OpenContainer(this.m_impl, ref xstring, needPrivateKeyAccess, machineKeyset) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool DeleteContainer()
		{
			return <Module>.ClsKeyContainer.DeleteContainer(this.m_impl) != null;
		}

		public void CloseContainer()
		{
			<Module>.ClsKeyContainer.CloseContainer(this.m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool GenerateKeyPair([MarshalAs(UnmanagedType.U1)] bool bKeyExchangePair, int keyLengthInBits)
		{
			return <Module>.ClsKeyContainer.GenerateKeyPair(this.m_impl, bKeyExchangePair, keyLengthInBits) != null;
		}

		public unsafe PrivateKey GetPrivateKey([MarshalAs(UnmanagedType.U1)] bool bKeyExchangePair)
		{
			ClsPrivateKey* ptr = <Module>.ClsKeyContainer.GetPrivateKey(this.m_impl, bKeyExchangePair);
			if (ptr == null)
			{
				return null;
			}
			return new PrivateKey((void*)ptr);
		}

		public unsafe PublicKey GetPublicKey([MarshalAs(UnmanagedType.U1)] bool bKeyExchangePair)
		{
			ClsPublicKey* ptr = <Module>.ClsKeyContainer.GetPublicKey(this.m_impl, bKeyExchangePair);
			if (ptr == null)
			{
				return null;
			}
			return new PublicKey((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPublicKey(PublicKey key, [MarshalAs(UnmanagedType.U1)] bool bKeyExchangePair)
		{
			if (key == null)
			{
				return false;
			}
			ClsPublicKey* implementation = (ClsPublicKey*)key.GetImplementation();
			return implementation != null && <Module>.ClsKeyContainer.ImportPublicKey(this.m_impl, implementation, bKeyExchangePair) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPrivateKey(PrivateKey key, [MarshalAs(UnmanagedType.U1)] bool bKeyExchangePair)
		{
			if (key == null)
			{
				return false;
			}
			ClsPrivateKey* implementation = (ClsPrivateKey*)key.GetImplementation();
			return implementation != null && <Module>.ClsKeyContainer.ImportPrivateKey(this.m_impl, implementation, bKeyExchangePair) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool FetchContainerNames([MarshalAs(UnmanagedType.U1)] bool bMachineKeyset)
		{
			return <Module>.ClsKeyContainer.FetchContainerNames(this.m_impl, bMachineKeyset) != null;
		}

		public int GetNumContainers([MarshalAs(UnmanagedType.U1)] bool bMachineKeyset)
		{
			return <Module>.ClsKeyContainer.GetNumContainers(this.m_impl, bMachineKeyset);
		}

		public unsafe string GetContainerName([MarshalAs(UnmanagedType.U1)] bool bMachineKeyset, int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsKeyContainer.GetContainerName(this.m_impl, bMachineKeyset, index, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsKeyContainer* m_impl;
	}
}
