﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class MailMan : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static MailMan LookupMailMan(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(MailMan.m_lockObject);
			MailMan result = (MailMan)MailMan.m_mmObjects[key];
			Monitor.Exit(MailMan.m_lockObject);
			return result;
		}

		public void FireSendPercentDone(object sender, MailPercentDoneEventArgs args)
		{
			MailMan.SendPercentDoneEventHandler onSendPercentDone = this.OnSendPercentDone;
			if (onSendPercentDone != null)
			{
				onSendPercentDone(sender, args);
			}
		}

		public void FireReadPercentDone(object sender, MailPercentDoneEventArgs args)
		{
			MailMan.ReadPercentDoneEventHandler onReadPercentDone = this.OnReadPercentDone;
			if (onReadPercentDone != null)
			{
				onReadPercentDone(sender, args);
			}
		}

		public void FireEmailReceived(object sender, EmailEventArgs args)
		{
			MailMan.EmailReceivedEventHandler onEmailReceived = this.OnEmailReceived;
			if (onEmailReceived != null)
			{
				onEmailReceived(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			MailMan.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe MailMan()
		{
			this.OnSendPercentDone = null;
			this.OnReadPercentDone = null;
			this.OnEmailReceived = null;
			this.OnAbortCheck = null;
			this.m_lockImpl = new object();
			ClsMailMan* ptr = <Module>.@new(4424U);
			ClsMailMan* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsMailMan.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 4416) = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			Monitor.Enter(MailMan.m_lockObject);
			ClsMailMan* impl = this.m_impl;
			if (impl != null)
			{
				ClsMailMan* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				MailMan.m_mmObjects.Remove(this);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						goto IL_89;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_89:
			Monitor.Exit(MailMan.m_lockObject);
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(MailMan.m_lockObject);
			ClsMailMan* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsMailMan.dotNetDispose(impl);
			}
			MailMan.m_mmObjects.Remove(this);
			Monitor.Exit(MailMan.m_lockObject);
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					Monitor.Enter(MailMan.m_lockObject);
					if (value)
					{
						if (MailMan.m_mmObjects == null)
						{
							MailMan.m_mmObjects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							MailMan.m_mmObjects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									MailMan.m_mmObjects = new Hashtable();
									MailMan.m_mmObjects.Add(key2, this);
									goto IL_CE;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
					}
					else
					{
						MailMan.m_mmObjects.Remove(this);
					}
					IL_CE:
					Monitor.Exit(MailMan.m_lockObject);
					this.m_enableEvents = value;
				}
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string LogMailReceivedFilename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_LogMailReceivedFilename(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_LogMailReceivedFilename(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string LogMailSentFilename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_LogMailSentFilename(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_LogMailSentFilename(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string LastSendQFilename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_LastSendQFilename(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string SmtpPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_SmtpPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_SmtpPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SmtpUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_SmtpUsername(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_SmtpUsername(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int ReadTimeout
		{
			get
			{
				return <Module>.ClsMailMan.get_ReadTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsMailMan.put_ReadTimeout(this.m_impl, value);
			}
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsMailMan.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsMailMan.put_HeartbeatMs(this.m_impl, value);
			}
		}

		public int LastSmtpStatus
		{
			get
			{
				return <Module>.ClsMailMan.get_LastSmtpStatus(this.m_impl);
			}
		}

		public int ConnectTimeout
		{
			get
			{
				return <Module>.ClsMailMan.get_ConnectTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsMailMan.put_ConnectTimeout(this.m_impl, value);
			}
		}

		public bool AutoSaveCerts
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_AutoSaveCerts(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_AutoSaveCerts(this.m_impl, value);
			}
		}

		public bool Pop3SPA
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_Pop3SPA(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_Pop3SPA(this.m_impl, value);
			}
		}

		public bool StartTLS
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_StartTLS(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_StartTLS(this.m_impl, value);
			}
		}

		public bool AllOrNone
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_AllOrNone(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_AllOrNone(this.m_impl, value);
			}
		}

		public bool EmbedCertChain
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_EmbedCertChain(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_EmbedCertChain(this.m_impl, value);
			}
		}

		public bool PopSsl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_PopSsl(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_PopSsl(this.m_impl, value);
			}
		}

		public bool ImmediateDelete
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_ImmediateDelete(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_ImmediateDelete(this.m_impl, value);
			}
		}

		public bool SmtpSsl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_SmtpSsl(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_SmtpSsl(this.m_impl, value);
			}
		}

		public bool AutoGenMessageId
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_AutoGenMessageId(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_AutoGenMessageId(this.m_impl, value);
			}
		}

		public bool AutoUnwrapSecurity
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_AutoUnwrapSecurity(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_AutoUnwrapSecurity(this.m_impl, value);
			}
		}

		public bool SendIndividual
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_SendIndividual(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_SendIndividual(this.m_impl, value);
			}
		}

		public unsafe string DsnNotify
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_DsnNotify(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_DsnNotify(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string DsnRet
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_DsnRet(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_DsnRet(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string DsnEnvid
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_DsnEnvid(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_DsnEnvid(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HeloHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_HeloHostname(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_HeloHostname(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SmtpAuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_SmtpAuthMethod(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_SmtpAuthMethod(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SmtpLoginDomain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_SmtpLoginDomain(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_SmtpLoginDomain(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Filter
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_Filter(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_Filter(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int SizeLimit
		{
			get
			{
				return <Module>.ClsMailMan.get_SizeLimit(this.m_impl);
			}
			set
			{
				<Module>.ClsMailMan.put_SizeLimit(this.m_impl, value);
			}
		}

		public int MaxCount
		{
			get
			{
				return <Module>.ClsMailMan.get_MaxCount(this.m_impl);
			}
			set
			{
				<Module>.ClsMailMan.put_MaxCount(this.m_impl, value);
			}
		}

		public unsafe int MailPort
		{
			get
			{
				return <Module>.ClsMailMan.get_MailPort(this.m_impl);
			}
			set
			{
				ClsMailMan* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ClsMailMan.put_MailPort(impl, value);
				}
			}
		}

		public bool ResetDateOnLoad
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_ResetDateOnLoad(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_ResetDateOnLoad(this.m_impl, value);
			}
		}

		public bool OpaqueSigning
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_OpaqueSigning(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_OpaqueSigning(this.m_impl, value);
			}
		}

		public unsafe int SmtpPort
		{
			get
			{
				return <Module>.ClsMailMan.get_SmtpPort(this.m_impl);
			}
			set
			{
				Monitor.Enter(this.m_lockImpl);
				ClsMailMan* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ClsMailMan.put_SmtpPort(impl, value);
				}
				Monitor.Exit(this.m_lockImpl);
			}
		}

		public unsafe string PopPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_PopPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_PopPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string PopUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_PopUsername(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.put_PopUsername(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string MailHost
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_MailHost(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (value != null && value.Length <= 400)
				{
					XString xstring;
					<Module>.XString.{ctor}(ref xstring);
					try
					{
						CkMarshal.StringToX(value, &xstring);
						Monitor.Enter(this.m_lockImpl);
						<Module>.ClsMailMan.put_MailHost(this.m_impl, ref xstring);
						Monitor.Exit(this.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring);
				}
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_Version(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string SmtpHost
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					ClsMailMan* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMailMan.get_SmtpHost(impl, ref xstring);
					}
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					ClsMailMan* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMailMan.put_SmtpHost(impl, ref xstring);
					}
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SmtpSessionLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_SmtpSessionLog(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public void ClearSmtpSessionLog()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsMailMan.ClearSmtpSessionLog(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public unsafe string Pop3SessionLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.get_Pop3SessionLog(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public void ClearPop3SessionLog()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsMailMan.ClearPop3SessionLog(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public unsafe string GetMailboxInfoXml()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				_MailManCallback mailManCallback;
				<Module>.MailManCallback.{ctor}(ref mailManCallback);
				try
				{
					mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
					*(ref mailManCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
					throw;
				}
				try
				{
					_MailManCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &mailManCallback;
						*(ref mailManCallback + 8) = this.m_myHashCode;
					}
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMailMan.GetMailboxInfoXml(this.m_impl, ref xstring, (MailManCallback*)ptr);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
					throw;
				}
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				<Module>.MailManCallback.{dtor}(ref mailManCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			<Module>.ClsMailMan.SetSslClientCert(this.m_impl, ptr);
		}

		public bool Pop3SslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_Pop3SslServerCertVerified(this.m_impl) != null;
			}
		}

		public unsafe Cert GetPop3SslServerCert()
		{
			ClsCert* ptr = <Module>.ClsMailMan.GetPop3SslServerCert(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		public bool SmtpSslServerCertVerified
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_SmtpSslServerCertVerified(this.m_impl) != null;
			}
		}

		public unsafe Cert GetSmtpSslServerCert()
		{
			ClsCert* ptr = <Module>.ClsMailMan.GetSmtpSslServerCert(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetDecryptCert2(Cert cert, PrivateKey key)
		{
			if (cert == null)
			{
				return false;
			}
			if (key == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			ClsPrivateKey* implementation2 = (ClsPrivateKey*)key.GetImplementation();
			if (implementation != null && implementation2 != null)
			{
				Monitor.Enter(this.m_lockImpl);
				bool result = <Module>.ClsMailMan.SetDecryptCert(this.m_impl, implementation, implementation2) != null;
				Monitor.Exit(this.m_lockImpl);
				return result;
			}
			return false;
		}

		public unsafe uint GetMailboxSize()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			uint result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = <Module>.ClsMailMan.GetMailboxSize(this.m_impl, (MailManCallback*)ptr);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe int GetMailboxCount()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			int result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = <Module>.ClsMailMan.GetMailboxCount(this.m_impl, (MailManCallback*)ptr);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3BeginSession()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.Pop3BeginSession(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3EndSession()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.Pop3EndSession(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3Noop()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.Pop3Noop(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Pop3Reset()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.Pop3Reset(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public void ClearBadEmailAddresses()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsMailMan.ClearBadEmailAddresses(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public unsafe StringArray GetBadEmailAddresses()
		{
			Monitor.Enter(this.m_lockImpl);
			ClsStringArray* ptr = <Module>.ClsMailMan.GetBadEmailAddresses(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
			if (ptr == null)
			{
				return null;
			}
			return new StringArray((void*)ptr);
		}

		public unsafe StringArray GetUidls()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			StringArray result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				ClsStringArray* ptr2 = <Module>.ClsMailMan.GetUidls(this.m_impl, (MailManCallback*)ptr);
				Monitor.Exit(this.m_lockImpl);
				if (ptr2 != null)
				{
					goto IL_8A;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
			IL_8A:
			StringArray result2;
			try
			{
				ClsStringArray* ptr2;
				result2 = new StringArray((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsSmtpDsnCapable()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.IsSmtpDsnCapable(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifySmtpLogin()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.VerifySmtpLogin(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifySmtpConnection()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.VerifySmtpConnection(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyPopLogin()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.VerifyPopLogin(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyPopConnection()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.VerifyPopConnection(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe EmailBundle FetchMultiple(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(this.m_lockImpl);
			ClsEmailBundle* ptr3;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						<Module>.MailManCallback.{ctor}(ptr);
						try
						{
							*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				ptr3 = <Module>.ClsMailMan.FetchMultiple(this.m_impl, implementation, ptr2);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				ptr3 = <Module>.ClsMailMan.FetchMultiple(this.m_impl, implementation, null);
			}
			Monitor.Exit(this.m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle((void*)ptr3);
		}

		public unsafe StringArray FetchMultipleMime(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(this.m_lockImpl);
			ClsStringArray* ptr3;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						<Module>.MailManCallback.{ctor}(ptr);
						try
						{
							*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				ptr3 = <Module>.ClsMailMan.FetchMultipleMime(this.m_impl, implementation, ptr2, false);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				ptr3 = <Module>.ClsMailMan.FetchMultipleMime(this.m_impl, implementation, null, false);
			}
			Monitor.Exit(this.m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new StringArray((void*)ptr3);
		}

		public unsafe StringArray TransferMultipleMime(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(this.m_lockImpl);
			ClsStringArray* ptr3;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						<Module>.MailManCallback.{ctor}(ptr);
						try
						{
							*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				ptr3 = <Module>.ClsMailMan.FetchMultipleMime(this.m_impl, implementation, ptr2, true);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				ptr3 = <Module>.ClsMailMan.FetchMultipleMime(this.m_impl, implementation, null, true);
			}
			Monitor.Exit(this.m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new StringArray((void*)ptr3);
		}

		public unsafe EmailBundle FetchMultipleHeaders(StringArray uidlArray, int numBodyLines)
		{
			if (uidlArray == null)
			{
				return null;
			}
			ClsStringArray* implementation = uidlArray.GetImplementation();
			Monitor.Enter(this.m_lockImpl);
			ClsEmailBundle* ptr3;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						<Module>.MailManCallback.{ctor}(ptr);
						try
						{
							*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				ptr3 = <Module>.ClsMailMan.FetchMultipleHeaders(this.m_impl, implementation, numBodyLines, ptr2);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				ptr3 = <Module>.ClsMailMan.FetchMultipleHeaders(this.m_impl, implementation, numBodyLines, null);
			}
			Monitor.Exit(this.m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle((void*)ptr3);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteByUidl(string uidl)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(uidl, &xstring);
				_MailManCallback mailManCallback;
				<Module>.MailManCallback.{ctor}(ref mailManCallback);
				try
				{
					mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
					*(ref mailManCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
					throw;
				}
				try
				{
					_MailManCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &mailManCallback;
						*(ref mailManCallback + 8) = this.m_myHashCode;
					}
					Monitor.Enter(this.m_lockImpl);
					result = (<Module>.ClsMailMan.DeleteByUidlX(this.m_impl, ref xstring, (MailManCallback*)ptr) != null);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
					throw;
				}
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				<Module>.MailManCallback.{dtor}(ref mailManCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Email FetchEmail(string uidl)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(uidl, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmail* ptr3;
				if (this.m_enableEvents)
				{
					_MailManCallback* ptr = <Module>.@new(12U);
					_MailManCallback* ptr2;
					try
					{
						if (ptr != null)
						{
							<Module>.MailManCallback.{ctor}(ptr);
							try
							{
								*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
								*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
								throw;
							}
							ptr2 = ptr;
						}
						else
						{
							ptr2 = 0;
						}
					}
					catch
					{
						<Module>.delete((void*)ptr);
						throw;
					}
					int myHashCode = this.m_myHashCode;
					*(ptr2 + 8) = myHashCode;
					ptr3 = <Module>.ClsMailMan.FetchEmailX(this.m_impl, ref xstring, ptr2);
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
				}
				else
				{
					ptr3 = <Module>.ClsMailMan.FetchEmailX(this.m_impl, ref xstring, null);
				}
				Monitor.Exit(this.m_lockImpl);
				if (ptr3 != null)
				{
					goto IL_C8;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_C8:
			Email result2;
			try
			{
				ClsEmail* ptr3;
				result2 = new Email((void*)ptr3);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] FetchMime(string uidl)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(uidl, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					Monitor.Enter(this.m_lockImpl);
					if (this.m_enableEvents)
					{
						_MailManCallback* ptr = <Module>.@new(12U);
						_MailManCallback* ptr2;
						try
						{
							if (ptr != null)
							{
								<Module>.MailManCallback.{ctor}(ptr);
								try
								{
									*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
									*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
								}
								catch
								{
									<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
									throw;
								}
								ptr2 = ptr;
							}
							else
							{
								ptr2 = 0;
							}
						}
						catch
						{
							<Module>.delete((void*)ptr);
							throw;
						}
						int myHashCode = this.m_myHashCode;
						*(ptr2 + 8) = myHashCode;
						<Module>.ClsMailMan.FetchMimeX(this.m_impl, ref xstring, ptr2, ref dataBuffer);
						object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
					}
					else
					{
						<Module>.ClsMailMan.FetchMimeX(this.m_impl, ref xstring, null, ref dataBuffer);
					}
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteMultiple(StringArray uidlArray)
		{
			if (uidlArray == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.DeleteMultiple(this.m_impl, uidlArray.GetImplementation(), (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteBundle(EmailBundle bundle)
		{
			if (bundle == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.DeleteBundle(this.m_impl, (ClsEmailBundle*)bundle.GetImplementation(), (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe Email GetFullEmail(Email email)
		{
			if (email == null)
			{
				return null;
			}
			Monitor.Enter(this.m_lockImpl);
			ClsEmail* ptr3;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						<Module>.MailManCallback.{ctor}(ptr);
						try
						{
							*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				ptr3 = <Module>.ClsMailMan.GetFullEmail(this.m_impl, (ClsEmail*)email.LockImpl(), ptr2);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				ptr3 = <Module>.ClsMailMan.GetFullEmail(this.m_impl, (ClsEmail*)email.LockImpl(), null);
			}
			Monitor.Exit(this.m_lockImpl);
			email.ReleaseImpl();
			if (ptr3 == null)
			{
				return null;
			}
			return new Email((void*)ptr3);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyRecipients(Email email, StringArray badAddrs)
		{
			if (email == null)
			{
				return false;
			}
			if (badAddrs == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			ClsStringArray* implementation = badAddrs.GetImplementation();
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr2 = null;
				if (this.m_enableEvents)
				{
					ptr2 = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.VerifyRecipients(this.m_impl, ptr, implementation, (MailManCallback*)ptr2) != null);
				Monitor.Exit(this.m_lockImpl);
				email.ReleaseImpl();
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe EmailBundle GetHeaders(int numBodyLines, int fromIndex, int toIndex)
		{
			Monitor.Enter(this.m_lockImpl);
			ClsEmailBundle* ptr3;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						<Module>.MailManCallback.{ctor}(ptr);
						try
						{
							*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				ptr3 = <Module>.ClsMailMan.GetHeaders(this.m_impl, numBodyLines, fromIndex, toIndex, ptr2);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				ptr3 = <Module>.ClsMailMan.GetHeaders(this.m_impl, numBodyLines, fromIndex, toIndex, null);
			}
			Monitor.Exit(this.m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle((void*)ptr3);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteEmail(Email email)
		{
			if (email == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				ClsEmail* ptr2 = (ClsEmail*)email.LockImpl();
				if (ptr2 != null)
				{
					goto IL_77;
				}
				email.ReleaseImpl();
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return false;
			IL_77:
			bool result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				_MailManCallback* ptr;
				ClsEmail* ptr2;
				result = (<Module>.ClsMailMan.DeleteEmail(this.m_impl, ptr2, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
				email.ReleaseImpl();
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe EmailBundle GetAllHeaders(int numBodyLines)
		{
			Monitor.Enter(this.m_lockImpl);
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			EmailBundle result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				ClsEmailBundle* ptr2 = <Module>.ClsMailMan.GetAllHeaders(this.m_impl, numBodyLines, (MailManCallback*)ptr);
				Monitor.Exit(this.m_lockImpl);
				if (ptr2 != null)
				{
					goto IL_8B;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
			IL_8B:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr2;
				result2 = new EmailBundle((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result2;
		}

		public unsafe EmailBundle LoadXmlString(string xmlString)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			EmailBundle result;
			try
			{
				CkMarshal.StringToX(xmlString, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmailBundle* ptr = <Module>.ClsMailMan.LoadXmlStringX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr;
				result2 = new EmailBundle((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe EmailBundle LoadXmlFile(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			EmailBundle result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmailBundle* ptr = <Module>.ClsMailMan.LoadXmlFileX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr;
				result2 = new EmailBundle((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Email LoadXmlEmail(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmail* ptr = <Module>.ClsMailMan.LoadXmlEmailX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			Email result2;
			try
			{
				ClsEmail* ptr;
				result2 = new Email((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Email LoadXmlEmailString(string xmlString)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(xmlString, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmail* ptr = <Module>.ClsMailMan.LoadXmlEmailStringX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			Email result2;
			try
			{
				ClsEmail* ptr;
				result2 = new Email((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string RenderToMime(Email email)
		{
			if (email == null)
			{
				return null;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(this.m_lockImpl);
				bool flag = <Module>.ClsMailMan.RenderToMimeX(this.m_impl, (ClsEmail*)email.LockImpl(), ref xstring) != null;
				Monitor.Exit(this.m_lockImpl);
				email.ReleaseImpl();
				if (flag)
				{
					goto IL_5D;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5D:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string MxLookup(string emailAddress)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(emailAddress, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					Monitor.Enter(this.m_lockImpl);
					bool flag = <Module>.ClsMailMan.MxLookup(this.m_impl, ref xstring, ref xstring2) != null;
					Monitor.Exit(this.m_lockImpl);
					if (flag)
					{
						goto IL_75;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_75:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool QuickSend(string from, string to, string subject, string body, string smtpServer)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(to, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(subject, &xstring3);
						XString xstring4;
						<Module>.XString.{ctor}(ref xstring4);
						try
						{
							CkMarshal.StringToX(body, &xstring4);
							XString xstring5;
							<Module>.XString.{ctor}(ref xstring5);
							try
							{
								CkMarshal.StringToX(smtpServer, &xstring5);
								Monitor.Enter(this.m_lockImpl);
								_MailManCallback mailManCallback;
								<Module>.MailManCallback.{ctor}(ref mailManCallback);
								try
								{
									mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
									*(ref mailManCallback + 8) = 0;
								}
								catch
								{
									<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
									throw;
								}
								try
								{
									_MailManCallback* ptr = null;
									if (this.m_enableEvents)
									{
										ptr = &mailManCallback;
										*(ref mailManCallback + 8) = this.m_myHashCode;
									}
									result = (<Module>.ClsMailMan.QuickSendX(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4, ref xstring5, (MailManCallback*)ptr) != null);
									Monitor.Exit(this.m_lockImpl);
								}
								catch
								{
									<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
									throw;
								}
								mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
								<Module>.MailManCallback.{dtor}(ref mailManCallback);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring5));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring5);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring4);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string code)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(code, &xstring);
				Monitor.Enter(this.m_lockImpl);
				result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsMailMan.UnlockComponentX(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BA@CGAIPMHI@UnlockComponent?$AA@));
							goto IL_8F;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_8F:
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			Monitor.Enter(this.m_lockImpl);
			ClsMailMan* impl = this.m_impl;
			bool result = calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), impl, *(*(int*)impl + 8));
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenSmtpConnection()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.OpenSmtpConnection(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CloseSmtpConnection()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.CloseSmtpConnection(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SmtpReset()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.SmtpReset(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SmtpNoop()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.SmtpNoop(this.m_impl, (MailManCallback*)ptr) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe int CheckMail()
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			int result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				Monitor.Enter(this.m_lockImpl);
				result = <Module>.ClsMailMan.CheckMail(this.m_impl, (MailManCallback*)ptr);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe EmailBundle TransferMail()
		{
			Monitor.Enter(this.m_lockImpl);
			ClsEmailBundle* ptr3;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						<Module>.MailManCallback.{ctor}(ptr);
						try
						{
							*(int*)ptr = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(int*)(ptr + 8 / sizeof(_MailManCallback)) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)ptr);
							throw;
						}
						ptr2 = ptr;
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				ptr3 = <Module>.ClsMailMan.TransferMail(this.m_impl, ptr2);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				ptr3 = <Module>.ClsMailMan.TransferMail(this.m_impl, null);
			}
			Monitor.Exit(this.m_lockImpl);
			if (ptr3 == null)
			{
				return null;
			}
			return new EmailBundle((void*)ptr3);
		}

		public unsafe EmailBundle CopyMail()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsEmailBundle* ptr = null;
			Monitor.Enter(this.m_lockImpl);
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			EmailBundle result;
			try
			{
				_MailManCallback* ptr2 = null;
				if (this.m_enableEvents)
				{
					ptr2 = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				uint exceptionCode;
				try
				{
					ptr = <Module>.ClsMailMan.CopyMail(this.m_impl, (MailManCallback*)ptr2);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							ptr = null;
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08JKNADCDM@CopyMail?$AA@));
							goto IL_C3;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_C3:
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_F8;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
			IL_F8:
			EmailBundle result2;
			try
			{
				result2 = new EmailBundle((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendBundle(EmailBundle bundle)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			if (bundle == null)
			{
				return false;
			}
			ClsEmailBundle* implementation = (ClsEmailBundle*)bundle.GetImplementation();
			if (implementation == null)
			{
				return false;
			}
			Monitor.Enter(this.m_lockImpl);
			bool result;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr = <Module>.@new(12U);
				_MailManCallback* ptr2;
				try
				{
					if (ptr != null)
					{
						ptr2 = <Module>.Chilkat._MailManCallback.{ctor}(ptr);
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				*(ptr2 + 8) = this.m_myHashCode;
				result = (<Module>.ClsMailMan.SendBundle(this.m_impl, implementation, ptr2) != null);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
			}
			else
			{
				result = (<Module>.ClsMailMan.SendBundle(this.m_impl, implementation, null) != null);
			}
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendEmail(Email email)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			bool result = false;
			Monitor.Enter(this.m_lockImpl);
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			try
			{
				_MailManCallback* ptr2 = null;
				if (this.m_enableEvents)
				{
					ptr2 = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsMailMan.SendEmail(this.m_impl, ptr, (MailManCallback*)ptr2) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_09NBNJNIBH@SendEmail?$AA@));
							goto IL_D0;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_D0:
				email.ReleaseImpl();
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendQ(Email email)
		{
			if (email == null)
			{
				return false;
			}
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			Monitor.Enter(this.m_lockImpl);
			bool result = <Module>.ClsMailMan.SendQ(this.m_impl, ptr) != null;
			Monitor.Exit(this.m_lockImpl);
			email.ReleaseImpl();
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendQ2(Email email, string queueDir)
		{
			if (email == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(queueDir, &xstring);
				ClsEmail* ptr = (ClsEmail*)email.LockImpl();
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMailMan.SendQ2(this.m_impl, ptr, ref xstring) != null);
				Monitor.Exit(this.m_lockImpl);
				email.ReleaseImpl();
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe EmailBundle LoadMbx(string mbxFileName)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			EmailBundle result;
			try
			{
				CkMarshal.StringToX(mbxFileName, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmailBundle* ptr = <Module>.ClsMailMan.LoadMbxX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			EmailBundle result2;
			try
			{
				ClsEmailBundle* ptr;
				result2 = new EmailBundle((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Email LoadEml(string emlFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(emlFilename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmail* ptr = <Module>.ClsMailMan.LoadEmlX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			Email result2;
			try
			{
				ClsEmail* ptr;
				result2 = new Email((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Email LoadQueuedEmail(string emlFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(emlFilename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmail* ptr = <Module>.ClsMailMan.LoadQueuedEmailX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			Email result2;
			try
			{
				ClsEmail* ptr;
				result2 = new Email((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Email LoadMime(string mimeText)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(mimeText, &xstring);
				Monitor.Enter(this.m_lockImpl);
				ClsEmail* ptr = <Module>.ClsMailMan.LoadMimeX(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
				if (ptr != null)
				{
					goto IL_54;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_54:
			Email result2;
			try
			{
				ClsEmail* ptr;
				result2 = new Email((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMime(string from, string recipients, string mimeText)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(recipients, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(mimeText, &xstring3);
						Monitor.Enter(this.m_lockImpl);
						_MailManCallback mailManCallback;
						<Module>.MailManCallback.{ctor}(ref mailManCallback);
						try
						{
							mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(ref mailManCallback + 8) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
							throw;
						}
						try
						{
							_MailManCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &mailManCallback;
								*(ref mailManCallback + 8) = this.m_myHashCode;
							}
							result = (<Module>.ClsMailMan.SendMimeX(this.m_impl, ref xstring, ref xstring2, ref xstring3, (MailManCallback*)ptr) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
							throw;
						}
						mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
						<Module>.MailManCallback.{dtor}(ref mailManCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeQ(string from, string recipients, string mimeText)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(recipients, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(mimeText, &xstring3);
						Monitor.Enter(this.m_lockImpl);
						result = (<Module>.ClsMailMan.SendMimeQX(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
						Monitor.Exit(this.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeToList(string from, string distListFile, string mimeText)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(distListFile, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(mimeText, &xstring3);
						Monitor.Enter(this.m_lockImpl);
						_MailManCallback mailManCallback;
						<Module>.MailManCallback.{ctor}(ref mailManCallback);
						try
						{
							mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(ref mailManCallback + 8) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
							throw;
						}
						try
						{
							_MailManCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &mailManCallback;
								*(ref mailManCallback + 8) = this.m_myHashCode;
							}
							result = (<Module>.ClsMailMan.SendMimeToListX(this.m_impl, ref xstring, ref xstring2, ref xstring3, (MailManCallback*)ptr) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
							throw;
						}
						mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
						<Module>.MailManCallback.{dtor}(ref mailManCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendToDistributionList(Email email, StringArray array)
		{
			if (array == null)
			{
				return false;
			}
			if (email == null)
			{
				return false;
			}
			ClsStringArray* implementation = array.GetImplementation();
			ClsEmail* ptr = (ClsEmail*)email.LockImpl();
			Monitor.Enter(this.m_lockImpl);
			bool result;
			if (this.m_enableEvents)
			{
				_MailManCallback* ptr2 = <Module>.@new(12U);
				_MailManCallback* ptr3;
				try
				{
					if (ptr2 != null)
					{
						ptr3 = <Module>.Chilkat._MailManCallback.{ctor}(ptr2);
					}
					else
					{
						ptr3 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr2);
					throw;
				}
				*(ptr3 + 8) = this.m_myHashCode;
				result = (<Module>.ClsMailMan.SendToDistributionList(this.m_impl, ptr, implementation, ptr3) != null);
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr3, 1, *(*ptr3));
			}
			else
			{
				result = (<Module>.ClsMailMan.SendToDistributionList(this.m_impl, ptr, implementation, null) != null);
			}
			Monitor.Exit(this.m_lockImpl);
			email.ReleaseImpl();
			return result;
		}

		public unsafe Email FetchSingleHeader(int numBodyLines, int index)
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			Email result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				ClsEmail* ptr2 = <Module>.ClsMailMan.FetchSingleHeader(this.m_impl, numBodyLines, index, (MailManCallback*)ptr);
				if (ptr2 != null)
				{
					goto IL_76;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
			IL_76:
			Email result2;
			try
			{
				ClsEmail* ptr2;
				result2 = new Email((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result2;
		}

		public unsafe Email FetchSingleHeaderByUidl(int numBodyLines, string uidl)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(uidl, &xstring);
				_MailManCallback mailManCallback;
				<Module>.MailManCallback.{ctor}(ref mailManCallback);
				try
				{
					mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
					*(ref mailManCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
					throw;
				}
				try
				{
					_MailManCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &mailManCallback;
						*(ref mailManCallback + 8) = this.m_myHashCode;
					}
					ClsEmail* ptr2 = <Module>.ClsMailMan.FetchSingleHeaderByUidl(this.m_impl, numBodyLines, ref xstring, (MailManCallback*)ptr);
					if (ptr2 != null)
					{
						goto IL_9E;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
					throw;
				}
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				<Module>.MailManCallback.{dtor}(ref mailManCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_9E:
			Email result2;
			try
			{
				_MailManCallback mailManCallback;
				try
				{
					ClsEmail* ptr2;
					result2 = new Email((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
					throw;
				}
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				<Module>.MailManCallback.{dtor}(ref mailManCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe int GetSizeByUidl(string uidl)
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			int result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(uidl, &xstring);
					result = <Module>.ClsMailMan.GetSizeByUidl(this.m_impl, ref xstring, (MailManCallback*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe string ClientIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMailMan.get_ClientIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsMailMan.put_ClientIpAddress(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int Pop3SessionId
		{
			get
			{
				return <Module>.ClsMailMan.get_Pop3SessionId(this.m_impl);
			}
		}

		public unsafe StringArray MxLookupAll(string emailAddress)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			StringArray result;
			try
			{
				CkMarshal.StringToX(emailAddress, &xstring);
				ClsStringArray* ptr = <Module>.ClsMailMan.MxLookupAll(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			StringArray result2;
			try
			{
				ClsStringArray* ptr;
				result2 = new StringArray((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteByMsgnum(int msgnum)
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				result = (<Module>.ClsMailMan.DeleteByMsgnum(this.m_impl, msgnum, (MailManCallback*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public unsafe Email FetchByMsgnum(int msgnum)
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			Email result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				ClsEmail* ptr2 = <Module>.ClsMailMan.FetchByMsgnum(this.m_impl, msgnum, (MailManCallback*)ptr);
				if (ptr2 != null)
				{
					goto IL_75;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
			IL_75:
			Email result2;
			try
			{
				ClsEmail* ptr2;
				result2 = new Email((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result2;
		}

		public unsafe byte[] FetchMimeByMsgnum(int msgnum)
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			byte[] result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.ClsMailMan.FetchMimeByMsgnum(this.m_impl, msgnum, ref dataBuffer, (MailManCallback*)ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		public int SendBufferSize
		{
			get
			{
				return <Module>.ClsMailMan.get_SendBufferSize(this.m_impl);
			}
			set
			{
				<Module>.ClsMailMan.put_SendBufferSize(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshTunnel([MarshalAs(UnmanagedType.U1)] bool bSmtp, string sshServerHostname, int sshServerPort)
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(sshServerHostname, &xstring);
					result = (<Module>.ClsMailMan.SshTunnel(this.m_impl, bSmtp, ref xstring, sshServerPort, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePw([MarshalAs(UnmanagedType.U1)] bool bSmtp, string sshLogin, string sshPassword)
		{
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(sshLogin, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(sshPassword, &xstring2);
						result = (<Module>.ClsMailMan.SshAuthenticatePw(this.m_impl, bSmtp, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SshAuthenticatePk([MarshalAs(UnmanagedType.U1)] bool bSmtp, string sshLogin, SshKey privateKey)
		{
			if (privateKey == null)
			{
				return false;
			}
			_MailManCallback mailManCallback;
			<Module>.MailManCallback.{ctor}(ref mailManCallback);
			try
			{
				mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
				*(ref mailManCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			bool result;
			try
			{
				_MailManCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mailManCallback;
					*(ref mailManCallback + 8) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(sshLogin, &xstring);
					ClsSshKey* implementation = (ClsSshKey*)privateKey.GetImplementation();
					result = (<Module>.ClsMailMan.SshAuthenticatePk(this.m_impl, bSmtp, ref xstring, implementation, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
				throw;
			}
			mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
			<Module>.MailManCallback.{dtor}(ref mailManCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SshCloseTunnel([MarshalAs(UnmanagedType.U1)] bool bSmtp)
		{
			return <Module>.ClsMailMan.SshCloseTunnel(this.m_impl, bSmtp, null) != null;
		}

		public bool IncludeRootCert
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_IncludeRootCert(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_IncludeRootCert(this.m_impl, value);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksHostname(this.m_impl + 120 / sizeof(ClsMailMan), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksHostname(this.m_impl + 120 / sizeof(ClsMailMan), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksUsername(this.m_impl + 120 / sizeof(ClsMailMan), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksUsername(this.m_impl + 120 / sizeof(ClsMailMan), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksPassword(this.m_impl + 120 / sizeof(ClsMailMan), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksPassword(this.m_impl + 120 / sizeof(ClsMailMan), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksPort(this.m_impl + 120 / sizeof(ClsMailMan));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksPort(this.m_impl + 120 / sizeof(ClsMailMan), value);
			}
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksVersion(this.m_impl + 120 / sizeof(ClsMailMan));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksVersion(this.m_impl + 120 / sizeof(ClsMailMan), value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xstring3);
						result = (<Module>.ClsMailMan.SetSslClientCertPfx(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeBytes(string from, string recipients, byte[] mimeData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(recipients, &xstring2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(mimeData, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
						_MailManCallback mailManCallback;
						<Module>.MailManCallback.{ctor}(ref mailManCallback);
						try
						{
							mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
							*(ref mailManCallback + 8) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MailManCallback.{dtor}), (void*)(&mailManCallback));
							throw;
						}
						try
						{
							_MailManCallback* ptr2 = null;
							if (this.m_enableEvents)
							{
								ptr2 = &mailManCallback;
								*(ref mailManCallback + 8) = this.m_myHashCode;
							}
							result = (<Module>.ClsMailMan.SendMimeBytes(this.m_impl, ref xstring, ref xstring2, ref dataBuffer, (MailManCallback*)ptr2) != null);
							CkMarshal.free(ptr);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MailManCallback.{dtor}), (void*)(&mailManCallback));
							throw;
						}
						mailManCallback = ref <Module>.??_7_MailManCallback@Chilkat@@6B@;
						<Module>.MailManCallback.{dtor}(ref mailManCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] RenderToMimeBytes(Email email)
		{
			if (email == null)
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
			Monitor.Enter(this.m_lockImpl);
			DataBuffer dataBuffer2;
			<Module>.DataBuffer.{ctor}(ref dataBuffer2);
			byte[] result2;
			try
			{
				<Module>.ClsMailMan.RenderToMimeBytes(this.m_impl, (ClsEmail*)email.LockImpl(), ref dataBuffer2);
				Monitor.Exit(this.m_lockImpl);
				email.ReleaseImpl();
				result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendMimeBytesQ(string from, string recipients, byte[] mimeData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(from, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(recipients, &xstring2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(mimeData, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
						result = (<Module>.ClsMailMan.SendMimeBytesQ(this.m_impl, ref xstring, ref xstring2, ref dataBuffer) != null);
						CkMarshal.free(ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyHostname(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyHostname(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyAuthMethod(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyAuthMethod(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyUsername(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyUsername(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyPassword(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyPassword(this.m_impl + 544 / sizeof(ClsMailMan), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int HttpProxyPort
		{
			get
			{
				return <Module>.ClsHttpProxyClient.get_HttpProxyPort(this.m_impl + 544 / sizeof(ClsMailMan));
			}
			set
			{
				<Module>.ClsHttpProxyClient.put_HttpProxyPort(this.m_impl + 544 / sizeof(ClsMailMan), value);
			}
		}

		public bool AutoFix
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMailMan.get_AutoFix(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMailMan.put_AutoFix(this.m_impl, value);
			}
		}

		public event MailMan.SendPercentDoneEventHandler OnSendPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnSendPercentDone = Delegate.Combine(this.OnSendPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnSendPercentDone = Delegate.Remove(this.OnSendPercentDone, value);
			}
		}

		public event MailMan.ReadPercentDoneEventHandler OnReadPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnReadPercentDone = Delegate.Combine(this.OnReadPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnReadPercentDone = Delegate.Remove(this.OnReadPercentDone, value);
			}
		}

		public event MailMan.EmailReceivedEventHandler OnEmailReceived
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnEmailReceived = Delegate.Combine(this.OnEmailReceived, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnEmailReceived = Delegate.Remove(this.OnEmailReceived, value);
			}
		}

		public event MailMan.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_mmObjects = new Hashtable();

		private int m_myHashCode;

		private bool m_enableEvents;

		private object m_lockImpl;

		private unsafe ClsMailMan* m_impl;

		private static object m_lockObject = new object();

		public delegate void SendPercentDoneEventHandler(object sender, MailPercentDoneEventArgs args);

		public delegate void ReadPercentDoneEventHandler(object sender, MailPercentDoneEventArgs args);

		public delegate void EmailReceivedEventHandler(object sender, EmailEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
