﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Mailboxes : IDisposable
	{
		public unsafe Mailboxes(void* mboxes)
		{
			this.m_boxes = (ClsMailboxes*)mboxes;
		}

		public unsafe Mailboxes()
		{
			ClsMailboxes* ptr = <Module>.@new(24U);
			ClsMailboxes* boxes;
			try
			{
				if (ptr != null)
				{
					boxes = <Module>.ClsMailboxes.{ctor}(ptr);
				}
				else
				{
					boxes = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_boxes = boxes;
		}

		protected unsafe override void Finalize()
		{
			ClsMailboxes* boxes = this.m_boxes;
			if (boxes != null)
			{
				ClsMailboxes* ptr = boxes;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_boxes = null;
			}
		}

		public virtual void Dispose()
		{
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsMarked(int index)
		{
			ClsMailbox* ptr = <Module>.ClsMailboxes.getMailbox(this.m_boxes, index);
			return ptr != null && <Module>.ClsMailbox.isMarked(ptr) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasInferiors(int index)
		{
			ClsMailbox* ptr = <Module>.ClsMailboxes.getMailbox(this.m_boxes, index);
			return ptr != null && <Module>.ClsMailbox.hasInferiors(ptr) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsSelectable(int index)
		{
			ClsMailbox* ptr = <Module>.ClsMailboxes.getMailbox(this.m_boxes, index);
			return ptr != null && <Module>.ClsMailbox.isSelectable(ptr) != null;
		}

		public unsafe string GetName(int index)
		{
			ClsMailbox* ptr = <Module>.ClsMailboxes.getMailbox(this.m_boxes, index);
			if (ptr == null)
			{
				return null;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsMailbox.getNameX(ptr, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public int Count
		{
			get
			{
				return <Module>.ClsMailboxes.getCount(this.m_boxes);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsMailboxes* m_boxes;
	}
}
