﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class MessageSet : IDisposable
	{
		public unsafe MessageSet(void* mset)
		{
			this.m_impl = (ClsMessageSet*)mset;
		}

		public unsafe MessageSet()
		{
			ClsMessageSet* ptr = <Module>.@new(28U);
			ClsMessageSet* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsMessageSet.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ClsMessageSet* impl = this.m_impl;
			if (impl != null)
			{
				ClsMessageSet* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe void* GetImpl()
		{
			return (void*)this.m_impl;
		}

		public unsafe override string ToString()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsMessageSet.ToString(this.m_impl, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool ContainsId(int id)
		{
			return <Module>.ClsMessageSet.ContainsId(this.m_impl, id) != null;
		}

		public void RemoveId(int id)
		{
			<Module>.ClsMessageSet.RemoveId(this.m_impl, id);
		}

		public void InsertId(int id)
		{
			<Module>.ClsMessageSet.InsertId(this.m_impl, id);
		}

		public bool HasUids
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMessageSet.get_HasUids(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMessageSet.put_HasUids(this.m_impl, value);
			}
		}

		public int GetId(int index)
		{
			return <Module>.ClsMessageSet.GetId(this.m_impl, index);
		}

		public int Count
		{
			get
			{
				return <Module>.ClsMessageSet.get_Count(this.m_impl);
			}
		}

		public unsafe string ToCompactString()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsMessageSet.ToCompactString(this.m_impl, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FromCompactString(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				result = (<Module>.ClsMessageSet.FromCompactString(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsMessageSet* m_impl;
	}
}
