﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Mht : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Mht LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Mht.m_lockObject);
			Mht result = (Mht)Mht.m_objects[key];
			Monitor.Exit(Mht.m_lockObject);
			return result;
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Mht.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe Mht(void* impl)
		{
			this.m_impl = (ClsMht*)impl;
			this.OnAbortCheck = null;
			this.m_lockImpl = new object();
		}

		public unsafe Mht()
		{
			this.m_enableEvents = false;
			this.OnAbortCheck = null;
			<Module>.?A0x7a977f4e.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x7a977f4e.NextHashCode;
			this.m_lockImpl = new object();
			ClsMht* ptr = <Module>.@new(4464U);
			ClsMht* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsMht.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 4456) = 2;
		}

		protected unsafe override void Finalize()
		{
			Monitor.Enter(this.m_lockImpl);
			ClsMht* impl = this.m_impl;
			if (impl != null)
			{
				ClsMht* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			Monitor.Exit(this.m_lockImpl);
			Monitor.Enter(Mht.m_lockObject);
			object key = this.m_myHashCode;
			Mht.m_objects.Remove(key);
			Monitor.Exit(Mht.m_lockObject);
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(Mht.m_lockObject);
			ClsMht* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsMht.dotNetDispose(impl);
			}
			object key = this.m_myHashCode;
			Mht.m_objects.Remove(key);
			Monitor.Exit(Mht.m_lockObject);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnpackMHT(string mhtFilename, string unpackDir, string htmlFilename, string partsSubDir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mhtFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(unpackDir, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(htmlFilename, &xstring3);
						XString xstring4;
						<Module>.XString.{ctor}(ref xstring4);
						try
						{
							CkMarshal.StringToX(partsSubDir, &xstring4);
							Monitor.Enter(this.m_lockImpl);
							result = (<Module>.ClsMht.UnpackMHT(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring4);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnpackMHTString(string mhtString, string unpackDir, string htmlFilename, string partsSubDir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mhtString, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(unpackDir, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(htmlFilename, &xstring3);
						XString xstring4;
						<Module>.XString.{ctor}(ref xstring4);
						try
						{
							CkMarshal.StringToX(partsSubDir, &xstring4);
							Monitor.Enter(this.m_lockImpl);
							result = (<Module>.ClsMht.UnpackMHTStringX(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring4);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetAndZipMHT(string url, string zipEntryFilename, string zipFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(zipEntryFilename, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(zipFilename, &xstring3);
						_MhtCallback mhtCallback;
						<Module>.MhtCallback.{ctor}(ref mhtCallback);
						try
						{
							mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
							*(ref mhtCallback + 4) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
							throw;
						}
						try
						{
							_MhtCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &mhtCallback;
								*(ref mhtCallback + 4) = this.m_myHashCode;
							}
							Monitor.Enter(this.m_lockImpl);
							result = (<Module>.ClsMht.GetAndZipMHT(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
							throw;
						}
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						<Module>.MhtCallback.{dtor}(ref mhtCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetAndZipEML(string url, string zipEntryFilename, string zipFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(zipEntryFilename, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(zipFilename, &xstring3);
						_MhtCallback mhtCallback;
						<Module>.MhtCallback.{ctor}(ref mhtCallback);
						try
						{
							mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
							*(ref mhtCallback + 4) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
							throw;
						}
						try
						{
							_MhtCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &mhtCallback;
								*(ref mhtCallback + 4) = this.m_myHashCode;
							}
							Monitor.Enter(this.m_lockImpl);
							result = (<Module>.ClsMht.GetAndZipEML(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
							Monitor.Exit(this.m_lockImpl);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
							throw;
						}
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						<Module>.MhtCallback.{dtor}(ref mhtCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Mime GetMime(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Mime result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				_MhtCallback mhtCallback;
				<Module>.MhtCallback.{ctor}(ref mhtCallback);
				try
				{
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					*(ref mhtCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
					throw;
				}
				try
				{
					_MhtCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &mhtCallback;
						*(ref mhtCallback + 4) = this.m_myHashCode;
					}
					Monitor.Enter(this.m_lockImpl);
					ClsMime* ptr2 = <Module>.ClsMht.GetMime(this.m_impl, ref xstring, (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
					result = null;
					if (ptr2 != null)
					{
						result = new Mime((void*)ptr2);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
					throw;
				}
				mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
				<Module>.MhtCallback.{dtor}(ref mhtCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Email GetEmail(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Email result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				_MhtCallback mhtCallback;
				<Module>.MhtCallback.{ctor}(ref mhtCallback);
				try
				{
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					*(ref mhtCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
					throw;
				}
				try
				{
					_MhtCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &mhtCallback;
						*(ref mhtCallback + 4) = this.m_myHashCode;
					}
					Monitor.Enter(this.m_lockImpl);
					ClsEmail* ptr2 = <Module>.ClsMht.GetEmail(this.m_impl, ref xstring, (ProgressEvent*)ptr);
					Monitor.Exit(this.m_lockImpl);
					result = null;
					if (ptr2 != null)
					{
						result = new Email((void*)ptr2);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
					throw;
				}
				mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
				<Module>.MhtCallback.{dtor}(ref mhtCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetAndSaveMHT(string url, string mhtFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(mhtFilename, &xstring2);
					_MhtCallback mhtCallback;
					<Module>.MhtCallback.{ctor}(ref mhtCallback);
					try
					{
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						*(ref mhtCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					try
					{
						_MhtCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &mhtCallback;
							*(ref mhtCallback + 4) = this.m_myHashCode;
						}
						Monitor.Enter(this.m_lockImpl);
						result = (<Module>.ClsMht.GetAndSaveMHT(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
						Monitor.Exit(this.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetAndSaveEML(string url, string emlFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(emlFilename, &xstring2);
					_MhtCallback mhtCallback;
					<Module>.MhtCallback.{ctor}(ref mhtCallback);
					try
					{
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						*(ref mhtCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					try
					{
						_MhtCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &mhtCallback;
							*(ref mhtCallback + 4) = this.m_myHashCode;
						}
						Monitor.Enter(Mht.m_lockObject);
						result = (<Module>.ClsMht.GetAndSaveEML(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetMHT(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					_MhtCallback mhtCallback;
					<Module>.MhtCallback.{ctor}(ref mhtCallback);
					try
					{
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						*(ref mhtCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					try
					{
						_MhtCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &mhtCallback;
							*(ref mhtCallback + 4) = this.m_myHashCode;
						}
						Monitor.Enter(this.m_lockImpl);
						bool flag = <Module>.ClsMht.GetMHTX(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						Monitor.Exit(this.m_lockImpl);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_D4:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_MhtCallback mhtCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetEML(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					_MhtCallback mhtCallback;
					<Module>.MhtCallback.{ctor}(ref mhtCallback);
					try
					{
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						*(ref mhtCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					try
					{
						_MhtCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &mhtCallback;
							*(ref mhtCallback + 4) = this.m_myHashCode;
						}
						Monitor.Enter(this.m_lockImpl);
						bool flag = <Module>.ClsMht.GetEMLX(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						Monitor.Exit(this.m_lockImpl);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_D4:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_MhtCallback mhtCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string HtmlToMHT(string htmlText)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(htmlText, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					_MhtCallback mhtCallback;
					<Module>.MhtCallback.{ctor}(ref mhtCallback);
					try
					{
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						*(ref mhtCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					try
					{
						_MhtCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &mhtCallback;
							*(ref mhtCallback + 4) = this.m_myHashCode;
						}
						Monitor.Enter(this.m_lockImpl);
						bool flag = <Module>.ClsMht.HtmlToMHTX(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						Monitor.Exit(this.m_lockImpl);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_D4:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_MhtCallback mhtCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string HtmlToEML(string htmlText)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(htmlText, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					_MhtCallback mhtCallback;
					<Module>.MhtCallback.{ctor}(ref mhtCallback);
					try
					{
						mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
						*(ref mhtCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					try
					{
						_MhtCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &mhtCallback;
							*(ref mhtCallback + 4) = this.m_myHashCode;
						}
						Monitor.Enter(this.m_lockImpl);
						bool flag = <Module>.ClsMht.HtmlToEMLX(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						Monitor.Exit(this.m_lockImpl);
						if (flag)
						{
							goto IL_D4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_D4:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_MhtCallback mhtCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
						throw;
					}
					mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
					<Module>.MhtCallback.{dtor}(ref mhtCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ClsMht.UnlockComponent(this.m_impl, ref xstring) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsMht* impl = this.m_impl;
			return calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), impl, *(*(int*)impl + 8));
		}

		public unsafe void AddExternalStyleSheet(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(url, &xstring);
				Monitor.Enter(this.m_lockImpl);
				<Module>.ClsMht.AddExternalStyleSheet(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void ExcludeImagesMatching(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				Monitor.Enter(this.m_lockImpl);
				<Module>.ClsMht.ExcludeImagesMatching(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void RestoreDefaults()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsMht.RestoreDefaults(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public bool PreferMHTScripts
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_PreferMHTScripts(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_PreferMHTScripts(this.m_impl, value);
			}
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsMht.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsMht.put_HeartbeatMs(this.m_impl, value);
			}
		}

		public bool NoScripts
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_NoScripts(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_NoScripts(this.m_impl, value);
			}
		}

		public bool NtlmAuth
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_NtlmAuth(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_NtlmAuth(this.m_impl, value);
			}
		}

		public bool EmbedImages
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_EmbedImages(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_EmbedImages(this.m_impl, value);
			}
		}

		public bool DebugTagCleaning
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_DebugTagCleaning(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_DebugTagCleaning(this.m_impl, value);
			}
		}

		public unsafe string DebugHtmlBefore
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_DebugHtmlBefore(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_DebugHtmlBefore(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string DebugHtmlAfter
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_DebugHtmlAfter(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_DebugHtmlAfter(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string BaseUrl
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_BaseUrl(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_BaseUrl(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_Version(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string Proxy
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_Proxy(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_Proxy(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string WebSiteLogin
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_WebSiteLogin(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_WebSiteLogin(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string WebSitePassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_WebSitePassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_WebSitePassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyLogin
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_ProxyLogin(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_ProxyLogin(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.get_ProxyPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.put_ProxyPassword(this.m_impl, ref xstring);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int ReadTimeout
		{
			get
			{
				return <Module>.ClsMht.get_ReadTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsMht.put_ReadTimeout(this.m_impl, value);
			}
		}

		public int ConnectTimeout
		{
			get
			{
				return <Module>.ClsMht.get_ConnectTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsMht.put_ConnectTimeout(this.m_impl, value);
			}
		}

		public unsafe void AddCustomHeader(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					Monitor.Enter(this.m_lockImpl);
					<Module>.ClsMht.AddCustomHeader(this.m_impl, ref xstring, ref xstring2);
					Monitor.Exit(this.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void RemoveCustomHeader(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				Monitor.Enter(this.m_lockImpl);
				<Module>.ClsMht.RemoveCustomHeader(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void ClearCustomHeaders()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsMht.ClearCustomHeaders(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public bool UseCids
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_UseCids(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_UseCids(this.m_impl, value);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Mht.m_lockObject);
						if (Mht.m_objects == null)
						{
							Mht.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Mht.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Mht.m_objects = new Hashtable();
									Mht.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Mht.m_lockObject);
					}
					else
					{
						Monitor.Enter(Mht.m_lockObject);
						object key3 = this.m_myHashCode;
						Mht.m_objects.Remove(key3);
						Monitor.Exit(Mht.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public int NumCacheLevels
		{
			get
			{
				return <Module>.ClsMht.get_NumCacheLevels(this.m_impl);
			}
			set
			{
				<Module>.ClsMht.put_NumCacheLevels(this.m_impl, value);
			}
		}

		public int NumCacheRoots
		{
			get
			{
				return <Module>.ClsMht.get_NumCacheRoots(this.m_impl);
			}
		}

		public unsafe string GetCacheRoot(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsMht.GetCacheRoot(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe void AddCacheRoot(string dir)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(dir, &xstring);
				<Module>.ClsMht.AddCacheRoot(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public bool UpdateCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_UpdateCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_UpdateCache(this.m_impl, value);
			}
		}

		public bool FetchFromCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_FetchFromCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_FetchFromCache(this.m_impl, value);
			}
		}

		public bool IgnoreNoCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_IgnoreNoCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_IgnoreNoCache(this.m_impl, value);
			}
		}

		public bool IgnoreMustRevalidate
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_IgnoreMustRevalidate(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_IgnoreMustRevalidate(this.m_impl, value);
			}
		}

		public bool UseIEProxy
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_UseIEProxy(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				bool flag = value;
				<Module>.ClsMht.put_UseIEProxy(this.m_impl, flag);
			}
		}

		public bool UseFilename
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_UseFilename(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_UseFilename(this.m_impl, value);
			}
		}

		public bool UseInline
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_UseInline(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_UseInline(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HtmlToEMLFile(string html, string emlFilename)
		{
			_MhtCallback mhtCallback;
			<Module>.MhtCallback.{ctor}(ref mhtCallback);
			try
			{
				mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
				*(ref mhtCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
				throw;
			}
			bool result;
			try
			{
				_MhtCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mhtCallback;
					*(ref mhtCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(html, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(emlFilename, &xstring2);
						result = (<Module>.ClsMht.HtmlToEMLFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
				throw;
			}
			mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
			<Module>.MhtCallback.{dtor}(ref mhtCallback);
			return result;
		}

		public unsafe Email HtmlToEmail(string html)
		{
			_MhtCallback mhtCallback;
			<Module>.MhtCallback.{ctor}(ref mhtCallback);
			try
			{
				mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
				*(ref mhtCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
				throw;
			}
			Email result;
			try
			{
				_MhtCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mhtCallback;
					*(ref mhtCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(html, &xstring);
					ClsEmail* ptr2 = <Module>.ClsMht.HtmlToEmailX(this.m_impl, ref xstring, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_9D;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
				throw;
			}
			mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
			<Module>.MhtCallback.{dtor}(ref mhtCallback);
			return result;
			IL_9D:
			Email result2;
			try
			{
				XString xstring;
				try
				{
					ClsEmail* ptr2;
					result2 = new Email((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
				throw;
			}
			mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
			<Module>.MhtCallback.{dtor}(ref mhtCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HtmlToMHTFile(string html, string mhtFilename)
		{
			_MhtCallback mhtCallback;
			<Module>.MhtCallback.{ctor}(ref mhtCallback);
			try
			{
				mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
				*(ref mhtCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(MhtCallback.{dtor}), (void*)(&mhtCallback));
				throw;
			}
			bool result;
			try
			{
				_MhtCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &mhtCallback;
					*(ref mhtCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(html, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(mhtFilename, &xstring2);
						result = (<Module>.ClsMht.HtmlToMHTFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._MhtCallback.{dtor}), (void*)(&mhtCallback));
				throw;
			}
			mhtCallback = ref <Module>.??_7_MhtCallback@Chilkat@@6B@;
			<Module>.MhtCallback.{dtor}(ref mhtCallback);
			return result;
		}

		public bool EmbedLocalOnly
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_EmbedLocalOnly(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_EmbedLocalOnly(this.m_impl, value);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMht.get_SocksUsername(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsMht.put_SocksUsername(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMht.get_SocksPassword(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsMht.put_SocksPassword(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMht.get_SocksHostname(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsMht.put_SocksHostname(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsMht.get_SocksPort(this.m_impl);
			}
			set
			{
				<Module>.ClsMht.put_SocksPort(this.m_impl, value);
			}
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsMht.get_SocksVersion(this.m_impl);
			}
			set
			{
				<Module>.ClsMht.put_SocksVersion(this.m_impl, value);
			}
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMht.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMht.put_VerboseLogging(this.m_impl, value);
			}
		}

		public event Mht.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private object m_lockImpl;

		private unsafe ClsMht* m_impl;

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
