﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Mime : IDisposable
	{
		public unsafe Mime(void* impl)
		{
			this.m_impl = (ClsMime*)impl;
			if (impl == null)
			{
				ClsMime* ptr = <Module>.@new(400U);
				ClsMime* impl2;
				try
				{
					if (ptr != null)
					{
						impl2 = <Module>.ClsMime.{ctor}(ptr);
					}
					else
					{
						impl2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				this.m_impl = impl2;
			}
		}

		public unsafe Mime()
		{
			ClsMime* ptr = <Module>.@new(400U);
			ClsMime* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsMime.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 396) = 2;
		}

		protected unsafe override void Finalize()
		{
			ClsMime* impl = this.m_impl;
			if (impl != null)
			{
				ClsMime* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsBase.GetTextLogX(impl, ref xstring, true);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsBase.GetXmlLogX(impl, ref xstring, true);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsBase.GetHtmlLogX(impl, ref xstring, true);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ClsMime* impl = this.m_impl;
				if (impl != null)
				{
					goto IL_35;
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return false;
			IL_35:
			bool result;
			try
			{
				ClsMime* impl;
				result = (<Module>.ClsBase.SaveXmlLogX(impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int NumHeaderFields
		{
			get
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					return 0;
				}
				return <Module>.ClsMime.get_NumHeaderFields(impl);
			}
		}

		public unsafe int NumSignerCerts
		{
			get
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					return 0;
				}
				return <Module>.ClsMime.get_NumSignerCerts(impl);
			}
		}

		public unsafe int NumEncryptCerts
		{
			get
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					return 0;
				}
				return <Module>.ClsMime.get_NumEncryptCerts(impl);
			}
		}

		public unsafe string Protocol
		{
			get
			{
				if (this.m_impl == null)
				{
					return new string((sbyte*)(&<Module>.??_C@_00CNPNBAHC@?$AA@));
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMime.get_ProtocolX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_ProtocolX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Micalg
		{
			get
			{
				if (this.m_impl == null)
				{
					return new string((sbyte*)(&<Module>.??_C@_00CNPNBAHC@?$AA@));
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMime.get_MicalgX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_MicalgX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Boundary
		{
			get
			{
				if (this.m_impl == null)
				{
					return new string((sbyte*)(&<Module>.??_C@_00CNPNBAHC@?$AA@));
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMime.get_BoundaryX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_BoundaryX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe bool UnwrapExtras
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				ClsMime* impl = this.m_impl;
				return impl != null && <Module>.ClsMime.get_UnwrapExtras(impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				ClsMime* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ClsMime.put_UnwrapExtras(impl, value);
				}
			}
		}

		public unsafe string Name
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.get_NameX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_NameX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Filename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.get_FilenameX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_FilenameX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Charset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.get_CharsetX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_CharsetX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Disposition
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.get_DispositionX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_DispositionX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Encoding
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.get_EncodingX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_EncodingX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ContentType
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.get_ContentTypeX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.put_ContentTypeX(impl, ref xstring);
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe int NumParts
		{
			get
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					return 0;
				}
				return <Module>.ClsMime.get_NumParts(impl);
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.get_VersionX(impl, ref xstring);
					}
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe bool UseMmDescription
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				ClsMime* impl = this.m_impl;
				return impl != null && <Module>.ClsMime.get_UseMmMessage(impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				ClsMime* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ClsMime.put_UseMmMessage(impl, value);
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetCSP(Csp csp)
		{
			ClsMime* impl = this.m_impl;
			if (impl == null)
			{
				return false;
			}
			if (csp == null)
			{
				return false;
			}
			ClsCSP* implementation = (ClsCSP*)csp.GetImplementation();
			return <Module>.ClsMime.SetCSP(impl, implementation) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendPart(Mime mime)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			ClsMime* impl = mime.m_impl;
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.AppendPart(this.m_impl, impl) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0L@PCBMEFDL@AppendPart?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendPartFromFile(string filename)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsMime.AppendPartFromFileX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool NewMultipartMixed()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.NewMultipartMixed(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool NewMultipartRelated()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.NewMultipartRelated(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool NewMultipartAlternative()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.NewMultipartAlternative(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToMultipartMixed()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.ConvertToMultipartMixed(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToMultipartAlt()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.ConvertToMultipartAlt(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool NewMessageRfc822(Mime mimeObject)
		{
			ClsMime* impl = this.m_impl;
			if (impl == null)
			{
				return false;
			}
			if (mimeObject == null)
			{
				return false;
			}
			ClsMime* impl2 = mimeObject.m_impl;
			return <Module>.ClsMime.NewMessageRfc822(impl, impl2) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveBody(string filename)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsMime.SaveBodyX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemovePart(int index)
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.RemovePart(impl, index) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsMultipart()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsMultipart(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsPlainText()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsPlainText(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsHtml()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsHtml(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsXml()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsXml(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsSigned()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsSigned(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsEncrypted()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsEncrypted(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsMultipartMixed()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsMultipartMixed(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsMultipartAlternative()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsMultipartAlternative(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsMultipartRelated()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsMultipartRelated(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsAttachment()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsAttachment(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsText()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsText(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsApplicationData()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsApplicationData(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsImage()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsImage(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsAudio()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsAudio(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsVideo()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.IsVideo(impl) != null;
		}

		public unsafe string GetBodyEncoded()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					goto IL_61;
				}
				bool flag = <Module>.ClsMime.GetBodyEncodedX(impl, ref xstring) != null;
				if (flag)
				{
					goto IL_3F;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3F:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_61:
			string result3;
			try
			{
				result3 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		public unsafe string GetBodyDecoded()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				if (this.m_impl == null)
				{
					goto IL_D0;
				}
				bool flag = false;
				uint exceptionCode;
				try
				{
					flag = (<Module>.ClsMime.GetBodyDecodedX(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0P@IKAPBADN@GetBodyDecoded?$AA@));
							goto IL_8A;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_8A:
				if (flag)
				{
					goto IL_AC;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_AC:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_D0:
			string result3;
			try
			{
				result3 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		public unsafe string GetEntireHead()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					goto IL_61;
				}
				bool flag = <Module>.ClsMime.GetEntireHeadX(impl, ref xstring) != null;
				if (flag)
				{
					goto IL_3F;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3F:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_61:
			string result3;
			try
			{
				result3 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		public unsafe string GetEntireBody()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ClsMime.GetEntireBodyX(impl, ref xstring);
				}
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBodyFromEncoded(string encoding, string str)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(encoding, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(str, &xstring2);
					result = (<Module>.ClsMime.SetBodyFromEncodedX(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBodyFromHtml(string str)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				result = (<Module>.ClsMime.SetBodyFromHtml2(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBodyFromXml(string str)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				result = (<Module>.ClsMime.SetBodyFromXml2(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] GetBodyBinary()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				uint exceptionCode;
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl != null)
					{
						<Module>.ClsMime.GetBodyBinary(impl, ref dataBuffer);
					}
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0O@NCIHLAAG@GetBodyBinary?$AA@));
							goto IL_80;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_80:
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBodyFromBinary(byte[] binData)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(binData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				result = (<Module>.ClsMime.SetBodyFromBinary(this.m_impl, ref dataBuffer) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBodyFromPlainText(string str)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsMime.SetBodyFromPlainText2(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BF@DJPFJNII@SetBodyFromPlainText?$AA@));
							goto IL_9E;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			IL_9E:
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBodyFromFile(string fileName)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				result = (<Module>.ClsMime.SetBodyFromFileX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Encrypt(Cert cert)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			if (implementation == null)
			{
				return false;
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.Encrypt(this.m_impl, implementation) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07CEMOCOEI@Encrypt?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToSigned(Cert cert)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			if (implementation == null)
			{
				return false;
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.ConvertToSigned(this.m_impl, implementation, null) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BA@BCNLFPDE@ConvertToSigned?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddDetachedSignature(Cert cert)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			if (implementation == null)
			{
				return false;
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.AddDetachedSignature(this.m_impl, implementation, null, false) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BF@HLCBCFLP@AddDetachedSignature?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveMime(string filename)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsMime.SaveMimeX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveXml(string filename)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsMime.SaveXmlX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetMime()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					goto IL_61;
				}
				bool flag = <Module>.ClsMime.GetMimeX(impl, ref xstring) != null;
				if (flag)
				{
					goto IL_3F;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3F:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_61:
			string result3;
			try
			{
				result3 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXml(string xml)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xml, &xstring);
				result = (<Module>.ClsMime.LoadXmlX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetXml()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					goto IL_61;
				}
				bool flag = <Module>.ClsMime.GetXmlX(impl, ref xstring) != null;
				if (flag)
				{
					goto IL_3F;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3F:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_61:
			string result3;
			try
			{
				result3 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetHeaderField(string name, string value)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					result = (<Module>.ClsMime.SetHeaderFieldX(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetHeaderField(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					ClsMime* impl = this.m_impl;
					if (impl == null)
					{
						goto IL_A4;
					}
					bool flag = <Module>.ClsMime.GetHeaderField(impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_6B;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_6B:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_A4:
			string result3;
			try
			{
				XString xstring2;
				try
				{
					result3 = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		public unsafe Mime GetPart(int index)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return null;
			}
			ClsMime* ptr = null;
			uint exceptionCode;
			try
			{
				ptr = <Module>.ClsMime.GetPart(this.m_impl, index);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07FHBHJIJG@GetPart?$AA@));
						goto IL_7D;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_7D:
			if (ptr == null)
			{
				return null;
			}
			return new Mime((void*)ptr);
		}

		public unsafe Cert GetEncryptCert(int index)
		{
			ClsMime* impl = this.m_impl;
			if (impl == null)
			{
				return null;
			}
			ClsCert* ptr = <Module>.ClsMime.GetEncryptCert(impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		public unsafe Cert GetSignerCert(int index)
		{
			ClsMime* impl = this.m_impl;
			if (impl == null)
			{
				return null;
			}
			ClsCert* ptr = <Module>.ClsMime.GetSignerCert(impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnwrapSecurity()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.UnwrapSecurity(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXmlFile(string fileName)
		{
			if (this.m_impl == null)
			{
				ClsMime* ptr = <Module>.@new(400U);
				ClsMime* impl;
				try
				{
					if (ptr != null)
					{
						impl = <Module>.ClsMime.{ctor}(ptr);
					}
					else
					{
						impl = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				this.m_impl = impl;
			}
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				result = (<Module>.ClsMime.LoadXmlFileX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadMimeFile(string fileName)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				ClsMime* ptr = <Module>.@new(400U);
				ClsMime* impl;
				try
				{
					if (ptr != null)
					{
						impl = <Module>.ClsMime.{ctor}(ptr);
					}
					else
					{
						impl = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				this.m_impl = impl;
			}
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsMime.LoadMimeFile(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0N@FONHNLGM@LoadMimeFile?$AA@));
							goto IL_D3;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			IL_D3:
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadMime(string mimeMsg)
		{
			if (this.m_impl == null)
			{
				ClsMime* ptr = <Module>.@new(400U);
				ClsMime* impl;
				try
				{
					if (ptr != null)
					{
						impl = <Module>.ClsMime.{ctor}(ptr);
					}
					else
					{
						impl = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				this.m_impl = impl;
			}
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(mimeMsg, &xstring);
				result = (<Module>.ClsMime.LoadMimeX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			if (this.m_impl == null)
			{
				ClsMime* ptr = <Module>.@new(400U);
				ClsMime* impl;
				try
				{
					if (ptr != null)
					{
						impl = <Module>.ClsMime.{ctor}(ptr);
					}
					else
					{
						impl = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				this.m_impl = impl;
			}
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsMime.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool IsUnlocked()
		{
			return this.m_impl != null && <Module>.ClsMime.IsUnlocked() != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ContainsEncryptedParts()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.ContainsEncryptedParts(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ContainsSignedParts()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.ContainsSignedParts(impl) != null;
		}

		public unsafe string GetHeaderFieldName(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					goto IL_62;
				}
				bool flag = <Module>.ClsMime.GetHeaderFieldNameX(impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_40;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_40:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_62:
			string result3;
			try
			{
				result3 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		public unsafe string GetHeaderFieldValue(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl == null)
				{
					goto IL_62;
				}
				bool flag = <Module>.ClsMime.GetHeaderFieldValueX(impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_40;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_40:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_62:
			string result3;
			try
			{
				result3 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddDetachedSignaturePk(Cert cert, PrivateKey privateKey)
		{
			ClsMime* impl = this.m_impl;
			if (impl == null)
			{
				return false;
			}
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			ClsPrivateKey* ptr2 = null;
			if (privateKey != null)
			{
				ptr2 = (ClsPrivateKey*)privateKey.GetImplementation();
			}
			return <Module>.ClsMime.AddDetachedSignature(impl, ptr, ptr2, false) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddDetachedSignaturePk2(Cert cert, PrivateKey privateKey, [MarshalAs(UnmanagedType.U1)] bool transferHeaderFields)
		{
			ClsMime* impl = this.m_impl;
			if (impl == null)
			{
				return false;
			}
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			ClsPrivateKey* ptr2 = null;
			if (privateKey != null)
			{
				ptr2 = (ClsPrivateKey*)privateKey.GetImplementation();
			}
			return <Module>.ClsMime.AddDetachedSignature(impl, ptr, ptr2, transferHeaderFields) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToSignedPk(Cert cert, PrivateKey privateKey)
		{
			ClsMime* impl = this.m_impl;
			if (impl == null)
			{
				return false;
			}
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			ClsPrivateKey* ptr2 = null;
			if (privateKey != null)
			{
				ptr2 = (ClsPrivateKey*)privateKey.GetImplementation();
			}
			return <Module>.ClsMime.ConvertToSigned(impl, ptr, ptr2) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Decrypt()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.Decrypt(this.m_impl, null, null) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07OKGDHKCM@Decrypt?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Decrypt2(Cert cert, PrivateKey privateKey)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			ClsCert* ptr = null;
			if (cert != null)
			{
				ptr = (ClsCert*)cert.GetImplementation();
			}
			ClsPrivateKey* ptr2 = null;
			if (privateKey != null)
			{
				ptr2 = (ClsPrivateKey*)privateKey.GetImplementation();
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.Decrypt(this.m_impl, ptr, ptr2) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08NPECFLOI@Decrypt2?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Verify()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.Verify(this.m_impl) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_06NDEBMOO@Verify?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		public unsafe void SetVerifyCert(Cert cert)
		{
			ClsMime* impl = this.m_impl;
			if (impl != null && cert != null)
			{
				ClsCert* implementation = (ClsCert*)cert.GetImplementation();
				if (implementation != null)
				{
					<Module>.ClsMime.SetVerifyCert(impl, implementation);
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadMimeBinary(byte[] binData)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			int num2 = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(binData, ref num2);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num2);
				result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsMime.LoadMimeBinary(this.m_impl, ref dataBuffer) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num3 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0P@HACMOPIF@LoadMimeBinary?$AA@));
							goto IL_9D;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num3 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num3 != 0U);
						})
						{
						}
						if (num3 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num3);
					}
				}
				IL_9D:
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddDetachedSignature2(Cert cert, [MarshalAs(UnmanagedType.U1)] bool transferHeaderFields)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				return false;
			}
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			if (implementation == null)
			{
				return false;
			}
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsMime.AddDetachedSignature(this.m_impl, implementation, null, true) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BG@LGNFNLEJ@AddDetachedSignature2?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddHeaderField(string name, string value)
		{
			if (this.m_impl == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					result = (<Module>.ClsMime.AddHeaderField(this.m_impl, <Module>.XString.getUtf8(ref xstring), <Module>.XString.getUtf8(ref xstring2)) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void Convert8Bit()
		{
			ClsMime* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsMime.Convert8Bit(impl);
			}
		}

		public unsafe byte[] GetMimeBytes()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ClsMime.GetMimeBytes(impl, ref dataBuffer);
				}
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe StringArray ExtractPartsToFiles(string dirPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			StringArray result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				ClsStringArray* ptr = <Module>.ClsMime.ExtractPartsToFiles(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_3E;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_3E:
			StringArray result2;
			try
			{
				ClsStringArray* ptr;
				result2 = new StringArray((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string AsnBodyToXml()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				ClsMime* impl = this.m_impl;
				if (impl != null)
				{
					goto IL_31;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_31:
			string result2;
			try
			{
				ClsMime* impl;
				bool flag = <Module>.ClsMime.AsnBodyToXml(impl, ref xstring) != null;
				if (flag)
				{
					goto IL_5B;
				}
				result2 = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
			IL_5B:
			string result3;
			try
			{
				result3 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result3;
		}

		public unsafe string CurrentDateTime
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsMime.get_CurrentDateTime(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool EncryptN()
		{
			ClsMime* impl = this.m_impl;
			return impl != null && <Module>.ClsMime.EncryptN(impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddEncryptCert(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			return <Module>.ClsMime.AddEncryptCert(this.m_impl, implementation) != null;
		}

		public void ClearEncryptCerts()
		{
			<Module>.ClsMime.ClearEncryptCerts(this.m_impl);
		}

		public unsafe void SetBody(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(str, &xstring);
				<Module>.ClsMime.SetBody(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void UrlEncodeBody(string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				<Module>.ClsMime.UrlEncodeBody(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void AddContentLength()
		{
			<Module>.ClsMime.AddContentLength(this.m_impl);
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsMime.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsMime.put_VerboseLogging(this.m_impl, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsMime* m_impl;

		private static object m_lockObject = new object();
	}
}
