﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class NextTarFileEventArgs : EventArgs
	{
		public unsafe NextTarFileEventArgs(sbyte* fileName, long fileSize, [MarshalAs(UnmanagedType.U1)] bool bIsDirectory)
		{
			this.m_fileSize = fileSize;
			this.m_isDirectory = bIsDirectory;
			this.m_skip = false;
			this.m_fileName = CkMarshal.Utf8ToString(fileName);
		}

		protected override void Finalize()
		{
			base.Finalize();
		}

		public string FileName
		{
			get
			{
				return this.m_fileName;
			}
		}

		public long FileSize
		{
			get
			{
				return this.m_fileSize;
			}
		}

		public bool IsDirectory
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_isDirectory;
			}
		}

		public bool Skip
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_skip;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				this.m_skip = value;
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private string m_fileName;

		private long m_fileSize;

		private bool m_isDirectory;

		private bool m_skip;
	}
}
