﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Pfx : IDisposable
	{
		public unsafe Pfx()
		{
			ClsPfx* ptr = <Module>.@new(120U);
			ClsPfx* pfx;
			try
			{
				if (ptr != null)
				{
					pfx = <Module>.ClsPfx.{ctor}(ptr);
				}
				else
				{
					pfx = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_pfx = pfx;
		}

		protected unsafe override void Finalize()
		{
			ClsPfx* pfx = this.m_pfx;
			if (pfx != null)
			{
				ClsPfx* ptr = pfx;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_pfx = null;
			}
		}

		public virtual void Dispose()
		{
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				int num = *(int*)this.m_pfx + 4;
				result = calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.SByte modopt(System.Runtime.CompilerServices.IsSignUnspecifiedByte) modopt(System.Runtime.CompilerServices.IsConst)*), this.m_pfx, <Module>.XString.getUtf8(ref xstring), *num);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPfxBytes(byte[] data, string password, [MarshalAs(UnmanagedType.U1)] bool bMachineKeyset, [MarshalAs(UnmanagedType.U1)] bool bLocalMachineCertStore, [MarshalAs(UnmanagedType.U1)] bool bExportable, [MarshalAs(UnmanagedType.U1)] bool bUseWarningDialog)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(password, &xstring);
					result = (<Module>.ClsPfx.ImportPfxBytes(this.m_pfx, ref dataBuffer, ref xstring, bMachineKeyset, bLocalMachineCertStore, bExportable, bUseWarningDialog) != null);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPfxFile(string filename, string password, [MarshalAs(UnmanagedType.U1)] bool bMachineKeyset, [MarshalAs(UnmanagedType.U1)] bool bLocalMachineCertStore, [MarshalAs(UnmanagedType.U1)] bool bExportable, [MarshalAs(UnmanagedType.U1)] bool bUseWarningDialog)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(password, &xstring2);
					result = (<Module>.ClsPfx.ImportPfxFile(this.m_pfx, ref xstring, ref xstring2, bMachineKeyset, bLocalMachineCertStore, bExportable, bUseWarningDialog) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_pfx, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_pfx, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_pfx, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_pfx, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsPfx* m_pfx;
	}
}
