﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class RarEntry : IDisposable
	{
		public unsafe RarEntry(void* impl)
		{
			this.m_impl = (ClsRarEntry*)impl;
			*(int*)((byte*)impl + 256) = 2;
		}

		public unsafe RarEntry()
		{
			ClsRarEntry* ptr = <Module>.@new(264U);
			ClsRarEntry* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsRarEntry.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 256) = 2;
		}

		protected unsafe override void Finalize()
		{
			ClsRarEntry* impl = this.m_impl;
			if (impl != null)
			{
				ClsRarEntry* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string Filename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsRarEntry.get_Filename(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public uint UncompressedSize
		{
			get
			{
				return <Module>.ClsRarEntry.get_UncompressedSize(this.m_impl);
			}
		}

		public uint CompressedSize
		{
			get
			{
				return <Module>.ClsRarEntry.get_CompressedSize(this.m_impl);
			}
		}

		public uint Crc
		{
			get
			{
				return <Module>.ClsRarEntry.get_Crc(this.m_impl);
			}
		}

		public unsafe DateTime LastModified
		{
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				<Module>.ClsRarEntry.get_LastModified(this.m_impl, ref year);
				DateTime result = default(DateTime);
				uint exceptionCode;
				try
				{
					DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
					result = dateTime;
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							return DateTime.Now;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				return result;
			}
		}

		public bool IsDirectory
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsRarEntry.get_IsDirectory(this.m_impl) != null;
			}
		}

		public bool IsReadOnly
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsRarEntry.get_IsReadOnly(this.m_impl) != null;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Unrar(string dirPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				result = (<Module>.ClsRarEntry.Unrar(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsRarEntry* m_impl;
	}
}
