﻿using System;
using System.Runtime.InteropServices;
using System.Security.Cryptography;

namespace Chilkat
{
	public class Rsa : IDisposable
	{
		public unsafe Rsa(void* impl)
		{
			this.m_impl = (ClsRsa*)impl;
		}

		public unsafe Rsa()
		{
			ClsRsa* ptr = <Module>.@new(720U);
			ClsRsa* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsRsa.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 712) = 2;
		}

		protected unsafe override void Finalize()
		{
			ClsRsa* impl = this.m_impl;
			if (impl != null)
			{
				ClsRsa* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl + 192 / sizeof(ClsRsa), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl + 192 / sizeof(ClsRsa), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl + 192 / sizeof(ClsRsa), ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl + 192 / sizeof(ClsRsa), ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsRsa.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool LittleEndian
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsRsa.get_LittleEndian(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsRsa.put_LittleEndian(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool GenerateKey(int numBits)
		{
			CspParameters parameters = new CspParameters(1);
			bool flag;
			bool flag2;
			do
			{
				flag = (<Module>.ClsRsa.GenerateKey(this.m_impl, numBits) != null);
				RSACryptoServiceProvider rsacryptoServiceProvider = new RSACryptoServiceProvider(parameters);
				try
				{
					rsacryptoServiceProvider.FromXmlString(this.ExportPrivateKey());
					flag2 = true;
				}
				catch (CryptographicException ex)
				{
					flag2 = false;
				}
			}
			while (!flag2 && flag);
			return flag;
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsRsa.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string ExportPublicKey()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsRsa.ExportPublicKey(this.m_impl, ref xstring) != null;
				if (flag)
				{
					goto IL_36;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_36:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string ExportPrivateKey()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsRsa.ExportPrivateKey(this.m_impl, ref xstring) != null;
				if (flag)
				{
					goto IL_36;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_36:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPublicKey(string xml)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xml, &xstring);
				result = (<Module>.ClsRsa.ImportPublicKey(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ImportPrivateKey(string xml)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xml, &xstring);
				result = (<Module>.ClsRsa.ImportPrivateKey(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string SnkToXml(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsRsa.SnkToXml(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int NumBits
		{
			get
			{
				return <Module>.ClsRsa.get_NumBits(this.m_impl);
			}
		}

		public bool OaepPadding
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsRsa.get_OaepPadding(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsRsa.put_OaepPadding(this.m_impl, value);
			}
		}

		public unsafe byte[] EncryptBytes(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					bool flag = <Module>.ClsRsa.EncryptBytes(this.m_impl, ref dataBuffer, bUsePrivateKey, ref dataBuffer2) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_79;
					}
					result = new byte[0];
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_79:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer2;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe byte[] DecryptBytes(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					bool flag = <Module>.ClsRsa.DecryptBytes(this.m_impl, ref dataBuffer, bUsePrivateKey, ref dataBuffer2) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_79;
					}
					result = new byte[0];
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_79:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer2;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe string DecryptStringENC(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsRsa.DecryptStringENC(this.m_impl, ref xstring, bUsePrivateKey, ref xstring2) != null;
					if (flag)
					{
						goto IL_60;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_60:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string DecryptString(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsRsa.DecryptString(this.m_impl, ref dataBuffer, bUsePrivateKey, ref xstring) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_74;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_74:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe byte[] DecryptBytesENC(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.ClsRsa.DecryptBytesENC(this.m_impl, ref xstring, bUsePrivateKey, ref dataBuffer) != null;
					if (flag)
					{
						goto IL_65;
					}
					result = new byte[0];
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_65:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string EncryptStringENC(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsRsa.EncryptStringENC(this.m_impl, ref xstring, bUsePrivateKey, ref xstring2) != null;
					if (flag)
					{
						goto IL_60;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_60:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string EncryptBytesENC(byte[] data, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsRsa.EncryptBytesENC(this.m_impl, ref dataBuffer, bUsePrivateKey, ref xstring) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_74;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_74:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe byte[] EncryptString(string str, [MarshalAs(UnmanagedType.U1)] bool bUsePrivateKey)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.ClsRsa.EncryptString(this.m_impl, ref xstring, bUsePrivateKey, ref dataBuffer) != null;
					if (flag)
					{
						goto IL_65;
					}
					result = new byte[0];
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_65:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string EncodingMode
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsRsa.get_EncodingMode(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsRsa.put_EncodingMode(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Charset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsRsa.get_Charset(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsRsa.put_Charset(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyStringENC(string str, string hashAlg, string sig)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(sig, &xstring3);
						result = (<Module>.ClsRsa.VerifyStringENC(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyString(string str, string hashAlg, byte[] sig)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(sig, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
						result = (<Module>.ClsRsa.VerifyString(this.m_impl, ref xstring, ref xstring2, ref dataBuffer) != null);
						CkMarshal.free(ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyBytesENC(byte[] data, string hashAlg, string encodedSig)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(encodedSig, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring2);
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
						result = (<Module>.ClsRsa.VerifyBytesENC(this.m_impl, ref dataBuffer, ref xstring2, ref xstring) != null);
						CkMarshal.free(ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyBytes(byte[] data, string hashAlg, byte[] sig)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(hashAlg, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					int num2 = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(sig, ref num2);
					DataBuffer dataBuffer2;
					<Module>.DataBuffer.{ctor}(ref dataBuffer2);
					try
					{
						<Module>.DataBuffer.append(ref dataBuffer2, (void*)ptr2, num2);
						result = (<Module>.ClsRsa.VerifyBytes(this.m_impl, ref dataBuffer, ref xstring, ref dataBuffer2) != null);
						CkMarshal.free(ptr);
						CkMarshal.free(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string SignStringENC(string str, string hashAlg)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						bool flag = <Module>.ClsRsa.SignStringENC(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null;
						if (flag)
						{
							goto IL_88;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_88:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						result2 = CkMarshal.XToString(&xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string SignBytesENC(byte[] data, string hashAlg)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(hashAlg, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					int num = 0;
					void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
						bool flag = <Module>.ClsRsa.SignBytesENC(this.m_impl, ref dataBuffer, ref xstring, ref xstring2) != null;
						CkMarshal.free(ptr);
						if (flag)
						{
							goto IL_9C;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_9C:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					DataBuffer dataBuffer;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] SignString(string str, string hashAlg)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring2);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.ClsRsa.SignString(this.m_impl, ref xstring, ref xstring2, ref dataBuffer);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] SignBytes(byte[] data, string hashAlg)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(hashAlg, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					DataBuffer dataBuffer2;
					<Module>.DataBuffer.{ctor}(ref dataBuffer2);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer2, ptr, num);
						<Module>.ClsRsa.SignBytes(this.m_impl, ref dataBuffer2, ref xstring, ref dataBuffer);
						CkMarshal.free(ptr);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] OpenSslVerifyBytes(byte[] signature)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(signature, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.ClsRsa.OpenSslVerifyBytes(this.m_impl, ref dataBuffer, ref dataBuffer2);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] OpenSslSignBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.ClsRsa.OpenSslSignBytes(this.m_impl, ref dataBuffer, ref dataBuffer2);
					CkMarshal.free(ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe string OpenSslSignBytesENC(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsRsa.OpenSslSignBytesENC(this.m_impl, ref dataBuffer, ref xstring) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_73;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_73:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe byte[] OpenSslSignString(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.ClsRsa.OpenSslSignString(this.m_impl, ref xstring, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string OpenSslSignStringENC(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsRsa.OpenSslSignStringENC(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] OpenSslVerifyBytesENC(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.ClsRsa.OpenSslVerifyBytesENC(this.m_impl, ref xstring, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string OpenSslVerifyString(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsRsa.OpenSslVerifyString(this.m_impl, ref dataBuffer, ref xstring) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_73;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_73:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe string OpenSslVerifyStringENC(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsRsa.OpenSslVerifyStringENC(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyPrivateKey(string xml)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xml, &xstring);
				result = (<Module>.ClsRsa.VerifyPrivateKey(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyHash(byte[] hashBytes, string hashAlg, byte[] sigBytes)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(hashBytes, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring);
					int num2 = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(sigBytes, ref num2);
					DataBuffer dataBuffer2;
					<Module>.DataBuffer.{ctor}(ref dataBuffer2);
					try
					{
						<Module>.DataBuffer.append(ref dataBuffer2, (void*)ptr2, num2);
						result = (<Module>.ClsRsa.VerifyHash(this.m_impl, ref dataBuffer, ref xstring, ref dataBuffer2) != null);
						CkMarshal.free(ptr);
						CkMarshal.free(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool VerifyHashENC(string encodedHash, string hashAlg, string encodedSig)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(encodedHash, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(encodedSig, &xstring3);
						result = (<Module>.ClsRsa.VerifyHashENC(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] SignHash(byte[] hashBytes, string hashAlg)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(hashBytes, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.append(ref dataBuffer, (void*)ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring);
					DataBuffer dataBuffer2;
					<Module>.DataBuffer.{ctor}(ref dataBuffer2);
					try
					{
						<Module>.ClsRsa.SignHash(this.m_impl, ref dataBuffer, ref xstring, ref dataBuffer2);
						CkMarshal.free(ptr);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe string SignHashENC(string encodedHash, string hashAlg)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(encodedHash, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(hashAlg, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						bool flag = <Module>.ClsRsa.SignHashENC(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null;
						if (flag)
						{
							goto IL_88;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_88:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						result2 = CkMarshal.XToString(&xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsRsa.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsRsa.put_VerboseLogging(this.m_impl, value);
			}
		}

		public bool NoUnpad
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsRsa.get_NoUnpad(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsRsa.put_NoUnpad(this.m_impl, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsRsa* m_impl;
	}
}
