﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;
using chilkat;

namespace Chilkat
{
	public class SFtp : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static SFtp LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(SFtp.m_lockObject);
			SFtp result = SFtp.m_objects[key];
			Monitor.Exit(SFtp.m_lockObject);
			return result;
		}

		public unsafe SFtp(void* impl)
		{
			this.m_impl = (ClsSFtp*)impl;
			this.OnAbortCheck = null;
			this.OnPercentDone = null;
		}

		public unsafe SFtp()
		{
			this.m_enableEvents = false;
			this.OnAbortCheck = null;
			this.OnPercentDone = null;
			<Module>.?A0x75fe0516.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x75fe0516.NextHashCode;
			ClsSFtp* ptr = <Module>.@new(1856U);
			ClsSFtp* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsSFtp.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
			<Module>.?m_progLang@ClsSFtp@@2HA = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsSFtp* impl = this.m_impl;
			if (impl != null)
			{
				ClsSFtp* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(SFtp.m_lockObject);
				object key = this.m_myHashCode;
				SFtp.m_objects.Remove(key);
				Monitor.Exit(SFtp.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(SFtp.m_lockObject);
			ClsSFtp* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsSFtp.dotNetDispose(impl);
			}
			object key = this.m_myHashCode;
			SFtp.m_objects.Remove(key);
			Monitor.Exit(SFtp.m_lockObject);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			SFtp.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			SFtp.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(SFtp.m_lockObject);
						if (SFtp.m_objects == null)
						{
							SFtp.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							SFtp.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									SFtp.m_objects = new Hashtable();
									SFtp.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(SFtp.m_lockObject);
					}
					else
					{
						Monitor.Enter(SFtp.m_lockObject);
						object key3 = this.m_myHashCode;
						SFtp.m_objects.Remove(key3);
						Monitor.Exit(SFtp.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsSFtp.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public int ConnectTimeoutMs
		{
			get
			{
				return <Module>.ClsSFtp.get_ConnectTimeoutMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSFtp.put_ConnectTimeoutMs(this.m_impl, value);
			}
		}

		public int DisconnectCode
		{
			get
			{
				return <Module>.ClsSFtp.get_DisconnectCode(this.m_impl);
			}
		}

		public int InitializeFailCode
		{
			get
			{
				return <Module>.ClsSFtp.get_InitializeFailCode(this.m_impl);
			}
		}

		public int MaxPacketSize
		{
			get
			{
				return <Module>.ClsSFtp.get_MaxPacketSize(this.m_impl);
			}
			set
			{
				<Module>.ClsSFtp.put_MaxPacketSize(this.m_impl, value);
			}
		}

		public int IdleTimeoutMs
		{
			get
			{
				return <Module>.ClsSFtp.get_IdleTimeoutMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSFtp.put_IdleTimeoutMs(this.m_impl, value);
			}
		}

		public unsafe string InitializeFailReason
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSFtp.get_InitializeFailReason(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string DisconnectReason
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSFtp.get_DisconnectReason(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSFtp.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool IsConnected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_IsConnected(this.m_impl) != null;
			}
		}

		public bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_KeepSessionLog(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSFtp.put_KeepSessionLog(this.m_impl, value);
			}
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSFtp.get_SessionLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public void Disconnect()
		{
			<Module>.ClsSFtp.Disconnect(this.m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect(string hostname, int port)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(hostname, &xstring);
					result = (<Module>.ClsSFtp.Connect(this.m_impl, ref xstring, port, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AuthenticatePk(string username, SshKey privateKey)
		{
			if (privateKey == null)
			{
				return false;
			}
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(username, &xstring);
					ClsSshKey* implementation = (ClsSshKey*)privateKey.GetImplementation();
					result = (<Module>.ClsSFtp.AuthenticatePk(this.m_impl, ref xstring, implementation, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AuthenticatePw(string login, string password)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(login, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(password, &xstring2);
						result = (<Module>.ClsSFtp.AuthenticatePw(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool InitializeSftp()
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSFtp.InitializeSftp(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe string OpenFile(string filename, string access, string createDisp)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filename, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(access, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(createDisp, &xstring3);
							XString xstring4;
							<Module>.XString.{ctor}(ref xstring4);
							try
							{
								bool flag = <Module>.ClsSFtp.OpenFile(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4, (ProgressEvent*)ptr) != null;
								if (flag)
								{
									goto IL_113;
								}
								result = null;
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_113:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							XString xstring4;
							try
							{
								result2 = CkMarshal.XToString(&xstring4);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe string OpenDir(string path)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(path, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsSFtp.OpenDir(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_BE:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CloseHandle(string handle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					result = (<Module>.ClsSFtp.CloseHandle(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe uint GetFileSize32(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			uint result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					result = <Module>.ClsSFtp.GetFileSize(this.m_impl, ref xstring, bFollowLinks, bIsHandle, (ProgressEvent*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe long GetFileSize64(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			long result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					result = <Module>.ClsSFtp.GetFileSize(this.m_impl, ref xstring, bFollowLinks, bIsHandle, (ProgressEvent*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe string GetFileSizeStr(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						long num = <Module>.ClsSFtp.GetFileSize(this.m_impl, ref xstring, bFollowLinks, bIsHandle, (ProgressEvent*)ptr);
						if (num >= 0L)
						{
							goto IL_C0;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_C0:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						StringBuffer stringBuffer;
						<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
						try
						{
							long num;
							<Module>.ck64.Int64ToString(num, ref stringBuffer);
							<Module>.XString.setFromAnsi(ref xstring2, <Module>.chilkat.StringBuffer.getString(ref stringBuffer));
							result2 = CkMarshal.XToString(&xstring2);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
							throw;
						}
						<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe DateTime GetFileLastAccess(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			DateTime result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					ChilkatSysTime year;
					<Module>.ChilkatSysTime.{ctor}(ref year);
					<Module>.ClsSFtp.GetFileLastAccess(this.m_impl, ref xstring, bFollowLinks, bIsHandle, ref year, (ProgressEvent*)ptr);
					result = default(DateTime);
					uint exceptionCode;
					try
					{
						DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
						result = dateTime;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								result = DateTime.Now;
								goto IL_10B;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				IL_10B:
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe DateTime GetFileLastModified(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			DateTime result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					ChilkatSysTime year;
					<Module>.ChilkatSysTime.{ctor}(ref year);
					<Module>.ClsSFtp.GetFileLastModified(this.m_impl, ref xstring, bFollowLinks, bIsHandle, ref year, (ProgressEvent*)ptr);
					result = default(DateTime);
					uint exceptionCode;
					try
					{
						DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
						result = dateTime;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								result = DateTime.Now;
								goto IL_10B;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				IL_10B:
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe DateTime GetFileCreateTime(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			DateTime result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					ChilkatSysTime year;
					<Module>.ChilkatSysTime.{ctor}(ref year);
					<Module>.ClsSFtp.GetFileCreateTime(this.m_impl, ref xstring, bFollowLinks, bIsHandle, ref year, (ProgressEvent*)ptr);
					result = default(DateTime);
					uint exceptionCode;
					try
					{
						DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
						result = dateTime;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								result = DateTime.Now;
								goto IL_10B;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				IL_10B:
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe string GetFileOwner(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsSFtp.GetFileOwner(this.m_impl, ref xstring, bFollowLinks, bIsHandle, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_C0;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_C0:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe string GetFileGroup(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsSFtp.GetFileGroup(this.m_impl, ref xstring, bFollowLinks, bIsHandle, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_C0;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_C0:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe int GetFilePermissions(string filenameOrHandle, [MarshalAs(UnmanagedType.U1)] bool bFollowLinks, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			int result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filenameOrHandle, &xstring);
					int num = 0;
					bool flag = <Module>.ClsSFtp.GetFilePermissions(this.m_impl, ref xstring, bFollowLinks, bIsHandle, ref num, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						result = num;
					}
					else
					{
						result = -1;
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe string Add64(string n1, string n2)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(n1, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(n2, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						<Module>.ClsSFtp.Add64(this.m_impl, ref xstring, ref xstring2, ref xstring3);
						result = CkMarshal.XToString(&xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] ReadFileBytes32(string handle, int offset, int numBytes)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			byte[] result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						bool flag = <Module>.ClsSFtp.ReadFileBytes32(this.m_impl, ref xstring, offset, numBytes, ref dataBuffer, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_C0;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_C0:
			byte[] result2;
			try
			{
				XString xstring;
				try
				{
					DataBuffer dataBuffer;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe byte[] ReadFileBytes64(string handle, long offset64, int numBytes)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			byte[] result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						bool flag = <Module>.ClsSFtp.ReadFileBytes64(this.m_impl, ref xstring, offset64, numBytes, ref dataBuffer, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_C0;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_C0:
			byte[] result2;
			try
			{
				XString xstring;
				try
				{
					DataBuffer dataBuffer;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe byte[] ReadFileBytes64s(string handle, string offset64, int numBytes)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			byte[] result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(offset64, &xstring2);
						DataBuffer dataBuffer;
						<Module>.DataBuffer.{ctor}(ref dataBuffer);
						try
						{
							bool flag = <Module>.ClsSFtp.ReadFileBytes64s(this.m_impl, ref xstring, ref xstring2, numBytes, ref dataBuffer, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_E8;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
							throw;
						}
						<Module>.DataBuffer.{dtor}(ref dataBuffer);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_E8:
			byte[] result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						DataBuffer dataBuffer;
						try
						{
							result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
							throw;
						}
						<Module>.DataBuffer.{dtor}(ref dataBuffer);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe string ReadFileText64s(string handle, string offset64, int numBytes, string charset)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(offset64, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(charset, &xstring3);
							XString xstring4;
							<Module>.XString.{ctor}(ref xstring4);
							try
							{
								bool flag = <Module>.ClsSFtp.ReadFileText64s(this.m_impl, ref xstring, ref xstring2, numBytes, ref xstring3, ref xstring4, (ProgressEvent*)ptr) != null;
								if (flag)
								{
									goto IL_115;
								}
								result = null;
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_115:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							XString xstring4;
							try
							{
								result2 = CkMarshal.XToString(&xstring4);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe string ReadFileText64(string handle, long offset64, int numBytes, string charset)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							bool flag = <Module>.ClsSFtp.ReadFileText64(this.m_impl, ref xstring, offset64, numBytes, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_EA;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_EA:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe string ReadFileText32(string handle, int offset32, int numBytes, string charset)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							bool flag = <Module>.ClsSFtp.ReadFileText32(this.m_impl, ref xstring, offset32, numBytes, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_EA;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_EA:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DownloadFile(string handle, string toFilename)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(toFilename, &xstring2);
						result = (<Module>.ClsSFtp.DownloadFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Eof(string handle)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(handle, &xstring);
				result = (<Module>.ClsSFtp.Eof(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] ReadFileBytes(string handle, int numBytes)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			byte[] result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						bool flag = <Module>.ClsSFtp.ReadFileBytes(this.m_impl, ref xstring, numBytes, ref dataBuffer, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BF;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_BF:
			byte[] result2;
			try
			{
				XString xstring;
				try
				{
					DataBuffer dataBuffer;
					try
					{
						result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe string ReadFileText(string handle, int numBytes, string charset)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							bool flag = <Module>.ClsSFtp.ReadFileText(this.m_impl, ref xstring, numBytes, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_E8;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_E8:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LastReadFailed(string handle)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(handle, &xstring);
				result = (<Module>.ClsSFtp.LastReadFailed(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int LastReadNumBytes(string handle)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(handle, &xstring);
				result = <Module>.ClsSFtp.LastReadNumBytes(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileBytes(string handle, byte[] data)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					int num = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(data, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
						result = (<Module>.ClsSFtp.WriteFileBytes(this.m_impl, ref xstring, ref dataBuffer, (ProgressEvent*)ptr) != null);
						CkMarshal.free(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileBytes32(string handle, int offset, byte[] data)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					int num = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(data, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
						result = (<Module>.ClsSFtp.WriteFileBytes32(this.m_impl, ref xstring, offset, ref dataBuffer, (ProgressEvent*)ptr) != null);
						CkMarshal.free(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileBytes64(string handle, long offset64, byte[] data)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					int num = 0;
					void* ptr2 = CkMarshal.ManagedToUnmanaged(data, ref num);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
						result = (<Module>.ClsSFtp.WriteFileBytes64(this.m_impl, ref xstring, offset64, ref dataBuffer, (ProgressEvent*)ptr) != null);
						CkMarshal.free(ptr2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileBytes64s(string handle, string offset64, byte[] data)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(offset64, &xstring2);
						int num = 0;
						void* ptr2 = CkMarshal.ManagedToUnmanaged(data, ref num);
						DataBuffer dataBuffer;
						<Module>.DataBuffer.{ctor}(ref dataBuffer);
						try
						{
							<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
							result = (<Module>.ClsSFtp.WriteFileBytes64s(this.m_impl, ref xstring, ref xstring2, ref dataBuffer, (ProgressEvent*)ptr) != null);
							CkMarshal.free(ptr2);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
							throw;
						}
						<Module>.DataBuffer.{dtor}(ref dataBuffer);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileText(string handle, string charset, string textData)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(textData, &xstring3);
							result = (<Module>.ClsSFtp.WriteFileText(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileText32(string handle, int offset32, string charset, string textData)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(textData, &xstring3);
							result = (<Module>.ClsSFtp.WriteFileText32(this.m_impl, ref xstring, offset32, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileText64(string handle, long offset64, string charset, string textData)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(textData, &xstring3);
							result = (<Module>.ClsSFtp.WriteFileText64(this.m_impl, ref xstring, offset64, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteFileText64s(string handle, string offset64, string charset, string textData)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(offset64, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(charset, &xstring3);
							XString xstring4;
							<Module>.XString.{ctor}(ref xstring4);
							try
							{
								CkMarshal.StringToX(textData, &xstring4);
								result = (<Module>.ClsSFtp.WriteFileText64s(this.m_impl, ref xstring, ref xstring2, ref xstring3, ref xstring4, (ProgressEvent*)ptr) != null);
							}
							catch
							{
								<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring4));
								throw;
							}
							<Module>.XString.{dtor}(ref xstring4);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UploadFile(string handle, string fromFilename)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(fromFilename, &xstring2);
						result = (<Module>.ClsSFtp.UploadFile(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public unsafe string RealPath(string originalPath, string composePath)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			string result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(originalPath, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(composePath, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							bool flag = <Module>.ClsSFtp.RealPath(this.m_impl, ref xstring, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null;
							if (flag)
							{
								goto IL_E7;
							}
							result = null;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_E7:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						XString xstring3;
						try
						{
							result2 = CkMarshal.XToString(&xstring3);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		public unsafe SFtpDir ReadDir(string handle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			SFtpDir result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					ClsSFtpDir* ptr2 = <Module>.ClsSFtp.ReadDir(this.m_impl, ref xstring, (ProgressEvent*)ptr);
					if (ptr2 != null)
					{
						goto IL_9D;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
			IL_9D:
			SFtpDir result2;
			try
			{
				XString xstring;
				try
				{
					ClsSFtpDir* ptr2;
					result2 = new SFtpDir((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveFile(string filename)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(filename, &xstring);
					result = (<Module>.ClsSFtp.RemoveFile(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveDir(string path)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(path, &xstring);
					result = (<Module>.ClsSFtp.RemoveDir(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RenameFileOrDir(string oldPath, string newPath)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(oldPath, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(newPath, &xstring2);
						result = (<Module>.ClsSFtp.RenameFileOrDir(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CreateDir(string path)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(path, &xstring);
					result = (<Module>.ClsSFtp.CreateDir(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetCreateTime(string pathOrHandle, [MarshalAs(UnmanagedType.U1)] bool bIsHandle, DateTime createTime)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(pathOrHandle, &xstring);
					ChilkatSysTime year;
					<Module>.ChilkatSysTime.{ctor}(ref year);
					year = createTime.Year;
					*(ref year + 2) = (short)createTime.Month;
					*(ref year + 6) = (short)createTime.Day;
					*(ref year + 8) = (short)createTime.Hour;
					*(ref year + 10) = (short)createTime.Minute;
					*(ref year + 12) = (short)createTime.Second;
					result = (<Module>.ClsSFtp.SetCreateTime(this.m_impl, ref xstring, bIsHandle, ref year, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetLastModifiedTime(string pathOrHandle, [MarshalAs(UnmanagedType.U1)] bool bIsHandle, DateTime createTime)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(pathOrHandle, &xstring);
					ChilkatSysTime year;
					<Module>.ChilkatSysTime.{ctor}(ref year);
					year = createTime.Year;
					*(ref year + 2) = (short)createTime.Month;
					*(ref year + 6) = (short)createTime.Day;
					*(ref year + 8) = (short)createTime.Hour;
					*(ref year + 10) = (short)createTime.Minute;
					*(ref year + 12) = (short)createTime.Second;
					result = (<Module>.ClsSFtp.SetLastModifiedTime(this.m_impl, ref xstring, bIsHandle, ref year, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetLastAccessTime(string pathOrHandle, [MarshalAs(UnmanagedType.U1)] bool bIsHandle, DateTime createTime)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(pathOrHandle, &xstring);
					ChilkatSysTime year;
					<Module>.ChilkatSysTime.{ctor}(ref year);
					year = createTime.Year;
					*(ref year + 2) = (short)createTime.Month;
					*(ref year + 6) = (short)createTime.Day;
					*(ref year + 8) = (short)createTime.Hour;
					*(ref year + 10) = (short)createTime.Minute;
					*(ref year + 12) = (short)createTime.Second;
					result = (<Module>.ClsSFtp.SetLastAccessTime(this.m_impl, ref xstring, bIsHandle, ref year, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetOwnerAndGroup(string pathOrHandle, [MarshalAs(UnmanagedType.U1)] bool bIsHandle, string owner, string group)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(pathOrHandle, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(owner, &xstring2);
						XString xstring3;
						<Module>.XString.{ctor}(ref xstring3);
						try
						{
							CkMarshal.StringToX(group, &xstring3);
							result = (<Module>.ClsSFtp.SetOwnerAndGroup(this.m_impl, ref xstring, bIsHandle, ref xstring2, ref xstring3, (ProgressEvent*)ptr) != null);
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
							throw;
						}
						<Module>.XString.{dtor}(ref xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetPermissions(string pathOrHandle, [MarshalAs(UnmanagedType.U1)] bool bIsHandle, int perm)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(pathOrHandle, &xstring);
					result = (<Module>.ClsSFtp.SetPermissions(this.m_impl, ref xstring, bIsHandle, perm, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CopyFileAttr(string localFilename, string remoteFilename, [MarshalAs(UnmanagedType.U1)] bool bIsHandle)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(localFilename, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(remoteFilename, &xstring2);
						result = (<Module>.ClsSFtp.CopyFileAttr(this.m_impl, ref xstring, ref xstring2, bIsHandle, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public int ProtocolVersion
		{
			get
			{
				return <Module>.ClsSFtp.get_ProtocolVersion(this.m_impl);
			}
		}

		public bool EnableCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_EnableCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSFtp.put_EnableCache(this.m_impl, value);
			}
		}

		public void ClearCache()
		{
			<Module>.ClsSFtp.ClearCache(this.m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DownloadFileByName(string remoteFilePath, string localFilePath)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(remoteFilePath, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(localFilePath, &xstring2);
						result = (<Module>.ClsSFtp.DownloadFileByName(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsSFtp.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSFtp.put_HeartbeatMs(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UploadFileByName(string remoteFilePath, string localFilePath)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(remoteFilePath, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(localFilePath, &xstring2);
						result = (<Module>.ClsSFtp.UploadFileByName(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ResumeUploadFileByName(string remoteFilePath, string localFilePath)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(remoteFilePath, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(localFilePath, &xstring2);
						result = (<Module>.ClsSFtp.ResumeUploadFileByName(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ResumeDownloadFileByName(string remoteFilePath, string localFilePath)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			bool result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(remoteFilePath, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(localFilePath, &xstring2);
						result = (<Module>.ClsSFtp.ResumeDownloadFileByName(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSFtp.put_VerboseLogging(this.m_impl, value);
			}
		}

		public unsafe string FilenameCharset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSFtp.get_FilenameCharset(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSFtp.put_FilenameCharset(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public void ClearSessionLog()
		{
			<Module>.ClsSFtp.ClearSessionLog(this.m_impl);
		}

		public bool ForceV3
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_ForceV3(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSFtp.put_ForceV3(this.m_impl, value);
			}
		}

		public bool UtcMode
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_UtcMode(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSFtp.put_UtcMode(this.m_impl, value);
			}
		}

		public bool PreserveDate
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_PreserveDate(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSFtp.put_PreserveDate(this.m_impl, value);
			}
		}

		public unsafe string ClientIdentifier
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSFtp.get_ClientIdentifier(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSFtp.put_ClientIdentifier(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HostKeyFingerprint
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSFtp.get_HostKeyFingerprint(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksHostname(this.m_impl + 120 / sizeof(ClsSFtp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksHostname(this.m_impl + 120 / sizeof(ClsSFtp), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksUsername(this.m_impl + 120 / sizeof(ClsSFtp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksUsername(this.m_impl + 120 / sizeof(ClsSFtp), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksPassword(this.m_impl + 120 / sizeof(ClsSFtp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksPassword(this.m_impl + 120 / sizeof(ClsSFtp), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksPort(this.m_impl + 120 / sizeof(ClsSFtp));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksPort(this.m_impl + 120 / sizeof(ClsSFtp), value);
			}
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksVersion(this.m_impl + 120 / sizeof(ClsSFtp));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksVersion(this.m_impl + 120 / sizeof(ClsSFtp), value);
			}
		}

		public int HttpProxyPort
		{
			get
			{
				return <Module>.ClsHttpProxyClient.get_HttpProxyPort(this.m_impl + 544 / sizeof(ClsSFtp));
			}
			set
			{
				<Module>.ClsHttpProxyClient.put_HttpProxyPort(this.m_impl + 544 / sizeof(ClsSFtp), value);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyAuthMethod(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyAuthMethod(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyUsername(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyUsername(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyPassword(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyPassword(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyHostname(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyHostname(this.m_impl + 544 / sizeof(ClsSFtp), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool TcpNoDelay
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSFtp.get_TcpNoDelay(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSFtp.put_TcpNoDelay(this.m_impl, value);
			}
		}

		public unsafe byte[] AccumulateBuffer
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsSFtp.get_AccumulateBuffer(this.m_impl, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
		}

		public void ClearAccumulateBuffer()
		{
			<Module>.ClsSFtp.ClearAccumulateBuffer(this.m_impl);
		}

		public unsafe int AccumulateBytes(string handle, int maxBytes)
		{
			_SFtpCallback sftpCallback;
			<Module>.SFtpCallback.{ctor}(ref sftpCallback);
			try
			{
				sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
				*(ref sftpCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			int result;
			try
			{
				_SFtpCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sftpCallback;
					*(ref sftpCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(handle, &xstring);
					result = <Module>.ClsSFtp.AccumulateBytes(this.m_impl, ref xstring, maxBytes, (ProgressEvent*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SFtpCallback.{dtor}), (void*)(&sftpCallback));
				throw;
			}
			sftpCallback = ref <Module>.??_7_SFtpCallback@Chilkat@@6B@;
			<Module>.SFtpCallback.{dtor}(ref sftpCallback);
			return result;
		}

		public event SFtp.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public event SFtp.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsSFtp* m_impl;

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);
	}
}
