﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Service : IDisposable
	{
		public unsafe Service(void* impl)
		{
			this.m_impl = (ClsService*)impl;
		}

		public unsafe Service()
		{
			ClsService* ptr = <Module>.@new(536U);
			ClsService* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsService.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
			<Module>.?m_progLang@ClsService@@2HA = 2;
		}

		protected unsafe override void Finalize()
		{
			ClsService* impl = this.m_impl;
			if (impl != null)
			{
				ClsService* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Install()
		{
			return <Module>.ClsService.Install(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Uninstall()
		{
			return <Module>.ClsService.Uninstall(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Start()
		{
			return <Module>.ClsService.Start(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Stop()
		{
			return <Module>.ClsService.Stop(this.m_impl) != null;
		}

		public unsafe string ServiceName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsService.get_ServiceName(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsService.put_ServiceName(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string DisplayName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsService.get_DisplayName(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsService.put_DisplayName(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ExeFilename
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsService.get_ExeFilename(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsService.put_ExeFilename(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool AutoStart
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsService.get_AutoStart(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsService.put_AutoStart(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SetAutoStart()
		{
			return <Module>.ClsService.SetAutoStart(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool SetDemandStart()
		{
			return <Module>.ClsService.SetDemandStart(this.m_impl) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Disable()
		{
			return <Module>.ClsService.Disable(this.m_impl) != null;
		}

		public int IsAutoStart()
		{
			return <Module>.ClsService.IsAutoStart(this.m_impl);
		}

		public int IsDemandStart()
		{
			return <Module>.ClsService.IsDemandStart(this.m_impl);
		}

		public int IsDisabled()
		{
			return <Module>.ClsService.IsDisabled(this.m_impl);
		}

		public int IsInstalled()
		{
			return <Module>.ClsService.IsInstalled(this.m_impl);
		}

		public int IsRunning()
		{
			return <Module>.ClsService.IsRunning(this.m_impl);
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsService* m_impl;
	}
}
