﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Socket : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Socket LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Socket.m_lockObject);
			Socket result = (Socket)Socket.m_objects[key];
			Monitor.Exit(Socket.m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			Socket.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Socket.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe Socket(void* impl)
		{
			this.m_impl = (ClsSocket*)impl;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			<Module>.?A0xe9ccccd5.NextHashCode++;
			this.m_myHashCode = <Module>.?A0xe9ccccd5.NextHashCode;
			if (impl == null)
			{
				ClsSocket* ptr = <Module>.@new(3640U);
				ClsSocket* impl2;
				try
				{
					if (ptr != null)
					{
						impl2 = <Module>.ClsSocket.{ctor}(ptr);
					}
					else
					{
						impl2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				this.m_impl = impl2;
			}
			*(int*)(this.m_impl + 3624 / sizeof(ClsSocket)) = 2;
		}

		public unsafe Socket()
		{
			this.m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			<Module>.?A0xe9ccccd5.NextHashCode++;
			this.m_myHashCode = <Module>.?A0xe9ccccd5.NextHashCode;
			ClsSocket* ptr = <Module>.@new(3640U);
			ClsSocket* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsSocket.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 3624) = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsSocket* impl = this.m_impl;
			if (impl != null)
			{
				ClsSocket* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Socket.m_lockObject);
				object key = this.m_myHashCode;
				Socket.m_objects.Remove(key);
				Monitor.Exit(Socket.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public virtual void Dispose()
		{
			Monitor.Enter(Socket.m_lockObject);
			<Module>.ClsSocket.Dispose(this.m_impl);
			object key = this.m_myHashCode;
			Socket.m_objects.Remove(key);
			Monitor.Exit(Socket.m_lockObject);
		}

		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public bool Ssl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.get_Ssl(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSocket.put_Ssl(this.m_impl, value);
			}
		}

		public unsafe string DnsLookup(string hostname, int maxWaitMs)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(hostname, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsSocket.DnsLookup(this.m_impl, ref xstring, maxWaitMs, null, ref xstring2) != null;
					if (flag)
					{
						goto IL_61;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_61:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Cert GetMyCert()
		{
			ClsCert* ptr = <Module>.ClsSocket.GetMyCert(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		public unsafe Cert GetSslServerCert()
		{
			ClsCert* ptr = <Module>.ClsSocket.GetSslServerCert(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Cert((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool IsUnlocked()
		{
			return <Module>.ClsSocket.IsUnlocked(this.m_impl) != null;
		}

		public unsafe string ReceiveToCRLF()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				_SocketCallback socketCallback;
				<Module>.SocketCallback.{ctor}(ref socketCallback);
				try
				{
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					*(ref socketCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &socketCallback;
						*(ref socketCallback + 4) = this.m_myHashCode;
					}
					bool flag = <Module>.ClsSocket.ReceiveToCRLF(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						goto IL_95;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_95:
			string result2;
			try
			{
				_SocketCallback socketCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_SessionLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.get_KeepSessionLog(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSocket.put_KeepSessionLog(this.m_impl, value);
			}
		}

		public unsafe string SessionLogEncoding
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_SessionLogEncoding(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocket.put_SessionLogEncoding(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe byte[] ReceiveUntilByte(int byteValue)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				_SocketCallback socketCallback;
				<Module>.SocketCallback.{ctor}(ref socketCallback);
				try
				{
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					*(ref socketCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &socketCallback;
						*(ref socketCallback + 4) = this.m_myHashCode;
					}
					<Module>.ClsSocket.ReceiveUntilByte(this.m_impl, byteValue, ref dataBuffer, (ProgressEvent*)ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public void ClearSessionLog()
		{
			<Module>.ClsSocket.ClearSessionLog(this.m_impl);
		}

		public unsafe string ReceiveStringUntilByte(int byteValue)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			string result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsSocket.ReceiveStringUntilByte(this.m_impl, byteValue, ref xstring, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						goto IL_96;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
			IL_96:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result2;
		}

		public unsafe string ReceiveStringMaxN(int maxBytes)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			string result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					bool flag = <Module>.ClsSocket.ReceiveStringMaxN(this.m_impl, maxBytes, ref xstring, (ProgressEvent*)ptr) != null;
					if (flag)
					{
						goto IL_96;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
			IL_96:
			string result2;
			try
			{
				XString xstring;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result2;
		}

		public unsafe string SslProtocol
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_SslProtocol(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocket.put_SslProtocol(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe void SetSslClientCert(Cert cert)
		{
			if (cert == null)
			{
				<Module>.ClsSocket.SetSslClientCert(this.m_impl, null);
			}
			else
			{
				<Module>.ClsSocket.SetSslClientCert(this.m_impl, (ClsCert*)cert.GetImplementation());
			}
		}

		public unsafe string ClientIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_ClientIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocket.put_ClientIpAddress(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendCount(int byteCount)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocket.SendCount(this.m_impl, byteCount, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		public unsafe int ReceiveCount()
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSocket.ReceiveCount(this.m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		public bool LastMethodFailed
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.get_LastMethodFailed(this.m_impl) != null;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertToSsl()
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocket.ConvertToSsl(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ConvertFromSsl()
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocket.ConvertFromSsl(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		public int SoSndBuf
		{
			get
			{
				return <Module>.ClsSocket.get_SoSndBuf(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_SoSndBuf(this.m_impl, value);
			}
		}

		public int SoRcvBuf
		{
			get
			{
				return <Module>.ClsSocket.get_SoRcvBuf(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_SoRcvBuf(this.m_impl, value);
			}
		}

		public int ClientPort
		{
			get
			{
				return <Module>.ClsSocket.get_ClientPort(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_ClientPort(this.m_impl, value);
			}
		}

		public unsafe string LocalIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_LocalIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int LocalPort
		{
			get
			{
				return <Module>.ClsSocket.get_LocalPort(this.m_impl);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksPort(this.m_impl + 128 / sizeof(ClsSocket));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksPort(this.m_impl + 128 / sizeof(ClsSocket), value);
			}
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksVersion(this.m_impl + 128 / sizeof(ClsSocket));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksVersion(this.m_impl + 128 / sizeof(ClsSocket), value);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksUsername(this.m_impl + 128 / sizeof(ClsSocket), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksUsername(this.m_impl + 128 / sizeof(ClsSocket), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksPassword(this.m_impl + 128 / sizeof(ClsSocket), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksPassword(this.m_impl + 128 / sizeof(ClsSocket), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksHostname(this.m_impl + 128 / sizeof(ClsSocket), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksHostname(this.m_impl + 128 / sizeof(ClsSocket), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe int CheckWriteable(int maxWaitMs)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSocket.CheckWriteable(this.m_impl, maxWaitMs, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetSslClientCertPfx(string pfxFilename, string pfxPassword, string certSubjectCN)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pfxFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pfxPassword, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(certSubjectCN, &xstring3);
						result = (<Module>.ClsSocket.SetSslClientCertPfx(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool TcpNoDelay
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.get_TcpNoDelay(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSocket.put_TcpNoDelay(this.m_impl, value);
			}
		}

		public bool BigEndian
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.get_BigEndian(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSocket.put_BigEndian(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool PollDataAvailable()
		{
			return <Module>.ClsSocket.PollDataAvailable(this.m_impl) != null;
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSocket.put_VerboseLogging(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool TakeSocket(Socket sock)
		{
			if (sock == null)
			{
				return false;
			}
			ClsSocket* impl = sock.m_impl;
			return <Module>.ClsSocket.TakeSocket(this.m_impl, impl) != null;
		}

		public unsafe int SelectForReading(int timeoutMs)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSocket.SelectForReading(this.m_impl, timeoutMs, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		public unsafe int SelectForWriting(int timeoutMs)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			int result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSocket.SelectForWriting(this.m_impl, timeoutMs, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		public int SelectorIndex
		{
			get
			{
				return <Module>.ClsSocket.get_SelectorIndex(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_SelectorIndex(this.m_impl, value);
			}
		}

		public int SelectorReadIndex
		{
			get
			{
				return <Module>.ClsSocket.get_SelectorReadIndex(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_SelectorReadIndex(this.m_impl, value);
			}
		}

		public int SelectorWriteIndex
		{
			get
			{
				return <Module>.ClsSocket.get_SelectorWriteIndex(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_SelectorWriteIndex(this.m_impl, value);
			}
		}

		public int NumSocketsInSet
		{
			get
			{
				return <Module>.ClsSocket.get_NumSocketsInSet(this.m_impl);
			}
		}

		public unsafe string UserData
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_UserData(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocket.put_UserData(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public void StartTiming()
		{
			<Module>.ClsSocket.StartTiming(this.m_impl);
		}

		public int ElapsedSeconds
		{
			get
			{
				return <Module>.ClsSocket.get_ElapsedSeconds(this.m_impl);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ReceiveBytesToFile(string appendFilename)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(appendFilename, &xstring);
					result = (<Module>.ClsSocket.ReceiveBytesToFile(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyUsername(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyUsername(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyPassword(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyPassword(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyAuthMethod(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyAuthMethod(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyHostname(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyHostname(this.m_impl + 552 / sizeof(ClsSocket), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int HttpProxyPort
		{
			get
			{
				return <Module>.ClsHttpProxyClient.get_HttpProxyPort(this.m_impl + 552 / sizeof(ClsSocket));
			}
			set
			{
				<Module>.ClsHttpProxyClient.put_HttpProxyPort(this.m_impl + 552 / sizeof(ClsSocket), value);
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.sock_LastErrorText(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.sock_LastErrorXml(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.sock_LastErrorHtml(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsSocket.sock_SaveLastError(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsSocket.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncSendBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				result = (<Module>.ClsSocket.AsyncSendBytes(this.m_impl, ref dataBuffer, null) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncSendString(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				result = (<Module>.ClsSocket.AsyncSendString(this.m_impl, ref xstring, null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool AsyncSendFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncSendFinished(this.m_impl) != null;
			}
		}

		public void AsyncSendAbort()
		{
			<Module>.ClsSocket.AsyncSendAbort(this.m_impl);
		}

		public unsafe string AsyncSendLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.AsyncSendLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool AsyncSendSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncSendSuccess(this.m_impl) != null;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool AsyncReceiveBytes()
		{
			return <Module>.ClsSocket.AsyncReceiveBytes(this.m_impl, null) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool AsyncReceiveBytesN(uint numBytes)
		{
			return <Module>.ClsSocket.AsyncReceiveBytesN(this.m_impl, numBytes, null, false) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool AsyncReceiveString()
		{
			return <Module>.ClsSocket.AsyncReceiveString(this.m_impl, null) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool AsyncReceiveToCRLF()
		{
			return <Module>.ClsSocket.AsyncReceiveToCRLF(this.m_impl, null) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncReceiveUntilMatch(string matchStr)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(matchStr, &xstring);
				result = (<Module>.ClsSocket.AsyncReceiveUntilMatch(this.m_impl, ref xstring, null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool AsyncReceiveFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				bool result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsSocket.AsyncReceiveFinished(this.m_impl) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BF@BNAOJGDA@AsyncReceiveFinished?$AA@));
							return result;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				return result;
			}
		}

		public void AsyncReceiveAbort()
		{
			<Module>.ClsSocket.AsyncReceiveAbort(this.m_impl);
		}

		public unsafe string AsyncReceiveLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.AsyncReceiveLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool AsyncReceiveSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncReceiveSuccess(this.m_impl) != null;
			}
		}

		public unsafe string AsyncReceivedString
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_AsyncReceivedString(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe byte[] AsyncReceivedBytes
		{
			get
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				byte[] result;
				try
				{
					<Module>.ClsSocket.get_AsyncReceivedBytes(this.m_impl, ref dataBuffer);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool InitSslServer(Cert cert)
		{
			if (cert == null)
			{
				return false;
			}
			ClsCert* implementation = (ClsCert*)cert.GetImplementation();
			return implementation != null && <Module>.ClsSocket.InitSslServer(this.m_impl, implementation) != null;
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int ObjectId
		{
			get
			{
				return <Module>.ClsSocket.get_ObjectId(this.m_impl);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncDnsStart(string hostname, int maxWaitMs)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xstring);
				result = (<Module>.ClsSocket.AsyncDnsStart(this.m_impl, ref xstring, maxWaitMs, null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool AsyncDnsFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncDnsFinished(this.m_impl) != null;
			}
		}

		public unsafe string AsyncDnsResult
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.AsyncDnsResult(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public void AsyncDnsAbort()
		{
			<Module>.ClsSocket.AsyncDnsAbort(this.m_impl);
		}

		public unsafe string AsyncDnsLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.AsyncDnsLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool AsyncDnsSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncDnsSuccess(this.m_impl) != null;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncConnectStart(string hostname, int port, [MarshalAs(UnmanagedType.U1)] bool ssl, int maxWaitMs)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xstring);
				result = (<Module>.ClsSocket.AsyncConnectStart(this.m_impl, ref xstring, port, ssl, maxWaitMs, null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool AsyncConnectFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncConnectFinished(this.m_impl) != null;
			}
		}

		public void AsyncConnectAbort()
		{
			<Module>.ClsSocket.AsyncConnectAbort(this.m_impl);
		}

		public unsafe string AsyncConnectLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.AsyncConnectLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool AsyncConnectSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncConnectSuccess(this.m_impl) != null;
			}
		}

		public void SleepMs(int millisec)
		{
			<Module>.ClsSocket.SleepMs(this.m_impl, millisec);
		}

		public unsafe string MyIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_MyIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool BindAndListen(int port, int backlog)
		{
			return <Module>.ClsSocket.BindAndListen(this.m_impl, port, backlog) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect(string hostname, int port, [MarshalAs(UnmanagedType.U1)] bool ssl, int maxWaitMs)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(hostname, &xstring);
				_SocketCallback socketCallback;
				<Module>.SocketCallback.{ctor}(ref socketCallback);
				try
				{
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					*(ref socketCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &socketCallback;
						*(ref socketCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsSocket.Connect(this.m_impl, ref xstring, port, ssl, maxWaitMs, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Socket AcceptNextConnection(int maxWaitMs)
		{
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			Socket result;
			try
			{
				_SocketCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				ClsSocket* ptr2 = <Module>.ClsSocket.AcceptNextConnection(this.m_impl, maxWaitMs, (ProgressEvent*)ptr);
				if (ptr2 != null)
				{
					goto IL_75;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
			IL_75:
			Socket result2;
			try
			{
				ClsSocket* ptr2;
				result2 = new Socket((void*)ptr2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result2;
		}

		public unsafe void Close(int maxWaitMs)
		{
			if (this.m_impl != null)
			{
				_SocketCallback socketCallback;
				<Module>.SocketCallback.{ctor}(ref socketCallback);
				try
				{
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					*(ref socketCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &socketCallback;
						*(ref socketCallback + 4) = this.m_myHashCode;
					}
					<Module>.ClsSocket.Close(this.m_impl, maxWaitMs, (ProgressEvent*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
		}

		public int ConnectFailReason
		{
			get
			{
				return <Module>.ClsSocket.get_ConnectFailReason(this.m_impl);
			}
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsSocket.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_HeartbeatMs(this.m_impl, value);
			}
		}

		public int MaxSendIdleMs
		{
			get
			{
				return <Module>.ClsSocket.get_MaxSendIdleMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_MaxSendIdleMs(this.m_impl, value);
			}
		}

		public int MaxReadIdleMs
		{
			get
			{
				return <Module>.ClsSocket.get_MaxReadIdleMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_MaxReadIdleMs(this.m_impl, value);
			}
		}

		public unsafe string StringCharset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_StringCharset(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocket.put_StringCharset(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe int DebugDnsDelayMs
		{
			get
			{
				return *(int*)(this.m_impl + 3628 / sizeof(ClsSocket));
			}
			set
			{
				*(int*)(this.m_impl + 3628 / sizeof(ClsSocket)) = value;
			}
		}

		public unsafe int DebugConnectDelayMs
		{
			get
			{
				return *(int*)(this.m_impl + 3632 / sizeof(ClsSocket));
			}
			set
			{
				*(int*)(this.m_impl + 3632 / sizeof(ClsSocket)) = value;
			}
		}

		public bool IsConnected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.get_IsConnected(this.m_impl) != null;
			}
		}

		public int RemotePort
		{
			get
			{
				return <Module>.ClsSocket.get_RemotePort(this.m_impl);
			}
		}

		public unsafe string RemoteIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.get_RemoteIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AsyncAcceptStart(int maxWaitMs)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			bool result = false;
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsSocket.AsyncAcceptStart(this.m_impl, maxWaitMs, null) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BB@HNFILPIO@AsyncAcceptStart?$AA@));
						return result;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			return result;
		}

		public unsafe bool AsyncAcceptFinished
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				bool result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ClsSocket.AsyncAcceptFinished(this.m_impl) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BE@HAMJFIKH@AsyncAcceptFinished?$AA@));
							return result;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				return result;
			}
		}

		public void AsyncAcceptAbort()
		{
			<Module>.ClsSocket.AsyncAcceptAbort(this.m_impl);
		}

		public unsafe string AsyncAcceptLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocket.AsyncAcceptLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool AsyncAcceptSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocket.AsyncAcceptSuccess(this.m_impl) != null;
			}
		}

		public unsafe Socket AsyncAcceptSocket()
		{
			ClsSocket* ptr = <Module>.ClsSocket.AsyncAcceptSocket(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Socket((void*)ptr);
		}

		public unsafe string BuildHttpGetRequest(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(url, &xstring2);
					<Module>.ClsSocket.BuildHttpGet(this.m_impl, ref xstring2, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public int SendPacketSize
		{
			get
			{
				return <Module>.ClsSocket.get_SendPacketSize(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_SendPacketSize(this.m_impl, value);
			}
		}

		public int ReceivePacketSize
		{
			get
			{
				return <Module>.ClsSocket.get_ReceivePacketSize(this.m_impl);
			}
			set
			{
				<Module>.ClsSocket.put_ReceivePacketSize(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendString(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				_SocketCallback socketCallback;
				<Module>.SocketCallback.{ctor}(ref socketCallback);
				try
				{
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					*(ref socketCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &socketCallback;
						*(ref socketCallback + 4) = this.m_myHashCode;
					}
					result = (<Module>.ClsSocket.SendString(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendBytes(byte[] data)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(data, ref num);
			_SocketCallback socketCallback;
			<Module>.SocketCallback.{ctor}(ref socketCallback);
			try
			{
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				*(ref socketCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			bool result;
			try
			{
				_SocketCallback* ptr2 = null;
				if (this.m_enableEvents)
				{
					ptr2 = &socketCallback;
					*(ref socketCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocket.SendBytes2(this.m_impl, (byte*)ptr, num, (ProgressEvent*)ptr2) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
				throw;
			}
			socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
			<Module>.SocketCallback.{dtor}(ref socketCallback);
			return result;
		}

		public unsafe string ReceiveString()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				_SocketCallback socketCallback;
				<Module>.SocketCallback.{ctor}(ref socketCallback);
				try
				{
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					*(ref socketCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &socketCallback;
						*(ref socketCallback + 4) = this.m_myHashCode;
					}
					bool flag = false;
					uint exceptionCode;
					try
					{
						flag = (<Module>.ClsSocket.ReceiveString(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0O@JMLFPDGM@ReceiveString?$AA@));
								goto IL_BD;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
					IL_BD:
					if (flag)
					{
						goto IL_FE;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_FE:
			string result2;
			try
			{
				_SocketCallback socketCallback;
				try
				{
					result2 = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string ReceiveUntilMatch(string matchStr)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(matchStr, &xstring2);
					_SocketCallback socketCallback;
					<Module>.SocketCallback.{ctor}(ref socketCallback);
					try
					{
						socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
						*(ref socketCallback + 4) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
						throw;
					}
					try
					{
						_SocketCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &socketCallback;
							*(ref socketCallback + 4) = this.m_myHashCode;
						}
						bool flag = <Module>.ClsSocket.ReceiveUntilMatch(this.m_impl, ref xstring2, ref xstring, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
						throw;
					}
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					<Module>.SocketCallback.{dtor}(ref socketCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_BE:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					_SocketCallback socketCallback;
					try
					{
						result2 = CkMarshal.XToString(&xstring);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
						throw;
					}
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					<Module>.SocketCallback.{dtor}(ref socketCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] ReceiveBytes()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				_SocketCallback socketCallback;
				<Module>.SocketCallback.{ctor}(ref socketCallback);
				try
				{
					socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
					*(ref socketCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				try
				{
					_SocketCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &socketCallback;
						*(ref socketCallback + 4) = this.m_myHashCode;
					}
					<Module>.ClsSocket.ReceiveBytes(this.m_impl, ref dataBuffer, (ProgressEvent*)ptr);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocketCallback.{dtor}), (void*)(&socketCallback));
					throw;
				}
				socketCallback = ref <Module>.??_7_SocketCallback@Chilkat@@6B@;
				<Module>.SocketCallback.{dtor}(ref socketCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] ReceiveBytesN(uint numBytes)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.ClsSocket.ReceiveBytesN(this.m_impl, numBytes, ref dataBuffer, null, false);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Socket.m_lockObject);
						if (Socket.m_objects == null)
						{
							Socket.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Socket.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Socket.m_objects = new Hashtable();
									Socket.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Socket.m_lockObject);
					}
					else
					{
						Monitor.Enter(Socket.m_lockObject);
						object key3 = this.m_myHashCode;
						Socket.m_objects.Remove(key3);
						Monitor.Exit(Socket.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public event Socket.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public event Socket.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsSocket* m_impl;

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
