﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class SocksProxy : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static SocksProxy LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(SocksProxy.m_lockObject);
			SocksProxy result = SocksProxy.m_objects[key];
			Monitor.Exit(SocksProxy.m_lockObject);
			return result;
		}

		public unsafe SocksProxy(void* impl)
		{
			this.m_impl = (ClsSocksProxy*)impl;
			this.OnAbortCheck = null;
		}

		public unsafe SocksProxy()
		{
			this.m_enableEvents = false;
			this.OnAbortCheck = null;
			<Module>.?A0xc9ec3369.NextHashCode++;
			this.m_myHashCode = <Module>.?A0xc9ec3369.NextHashCode;
			ClsSocksProxy* ptr = <Module>.@new(1040U);
			ClsSocksProxy* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsSocksProxy.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
			<Module>.?m_progLang@ClsSocksProxy@@2HA = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsSocksProxy* impl = this.m_impl;
			if (impl != null)
			{
				ClsSocksProxy* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(SocksProxy.m_lockObject);
				object key = this.m_myHashCode;
				SocksProxy.m_objects.Remove(key);
				Monitor.Exit(SocksProxy.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(SocksProxy.m_lockObject);
			ClsSocksProxy* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsSocksProxy.dotNetDispose(impl);
			}
			object key = this.m_myHashCode;
			SocksProxy.m_objects.Remove(key);
			Monitor.Exit(SocksProxy.m_lockObject);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			SocksProxy.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(SocksProxy.m_lockObject);
						if (SocksProxy.m_objects == null)
						{
							SocksProxy.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							SocksProxy.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									SocksProxy.m_objects = new Hashtable();
									SocksProxy.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(SocksProxy.m_lockObject);
					}
					else
					{
						Monitor.Enter(SocksProxy.m_lockObject);
						object key3 = this.m_myHashCode;
						SocksProxy.m_objects.Remove(key3);
						Monitor.Exit(SocksProxy.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsSocksProxy.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsSocksProxy.get_SocksVersion(this.m_impl);
			}
		}

		public bool AuthenticatedSocks5
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocksProxy.get_AuthenticatedSocks5(this.m_impl) != null;
			}
		}

		public bool ConnectionPending
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocksProxy.get_ConnectionPending(this.m_impl) != null;
			}
		}

		public int ClientPort
		{
			get
			{
				return <Module>.ClsSocksProxy.get_ClientPort(this.m_impl);
			}
		}

		public int ServerPort
		{
			get
			{
				return <Module>.ClsSocksProxy.get_ServerPort(this.m_impl);
			}
		}

		public unsafe string ClientIp
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksProxy.get_ClientIp(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string ServerIp
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksProxy.get_ServerIp(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string Login
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksProxy.get_Login(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string Password
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksProxy.get_Password(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool Initialize(int port)
		{
			return <Module>.ClsSocksProxy.Initialize(this.m_impl, port) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WaitForConnection(int maxWaitMs)
		{
			_SocksProxyCallback socksProxyCallback;
			<Module>.SocksProxyCallback.{ctor}(ref socksProxyCallback);
			try
			{
				socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
				*(ref socksProxyCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			bool result;
			try
			{
				_SocksProxyCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socksProxyCallback;
					*(ref socksProxyCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocksProxy.WaitForConnection(this.m_impl, maxWaitMs, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
			<Module>.SocksProxyCallback.{dtor}(ref socksProxyCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AllowConnection()
		{
			_SocksProxyCallback socksProxyCallback;
			<Module>.SocksProxyCallback.{ctor}(ref socksProxyCallback);
			try
			{
				socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
				*(ref socksProxyCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			bool result;
			try
			{
				_SocksProxyCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socksProxyCallback;
					*(ref socksProxyCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocksProxy.AllowConnection(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
			<Module>.SocksProxyCallback.{dtor}(ref socksProxyCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ProceedSocks5()
		{
			_SocksProxyCallback socksProxyCallback;
			<Module>.SocksProxyCallback.{ctor}(ref socksProxyCallback);
			try
			{
				socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
				*(ref socksProxyCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			bool result;
			try
			{
				_SocksProxyCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socksProxyCallback;
					*(ref socksProxyCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocksProxy.ProceedSocks5(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
			<Module>.SocksProxyCallback.{dtor}(ref socksProxyCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RejectConnection()
		{
			_SocksProxyCallback socksProxyCallback;
			<Module>.SocksProxyCallback.{ctor}(ref socksProxyCallback);
			try
			{
				socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
				*(ref socksProxyCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			bool result;
			try
			{
				_SocksProxyCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &socksProxyCallback;
					*(ref socksProxyCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSocksProxy.RejectConnection(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SocksProxyCallback.{dtor}), (void*)(&socksProxyCallback));
				throw;
			}
			socksProxyCallback = ref <Module>.??_7_SocksProxyCallback@Chilkat@@6B@;
			<Module>.SocksProxyCallback.{dtor}(ref socksProxyCallback);
			return result;
		}

		public bool AllowUnauthenticatedSocks5
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSocksProxy.get_AllowUnauthenticatedSocks5(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSocksProxy.put_AllowUnauthenticatedSocks5(this.m_impl, value);
			}
		}

		public unsafe string ListenBindIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksProxy.get_ListenBindIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksProxy.put_ListenBindIpAddress(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string OutboundBindIpAddress
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksProxy.get_OutboundBindIpAddress(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksProxy.put_OutboundBindIpAddress(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int OutboundBindPort
		{
			get
			{
				return <Module>.ClsSocksProxy.get_OutboundBindPort(this.m_impl);
			}
			set
			{
				<Module>.ClsSocksProxy.put_OutboundBindPort(this.m_impl, value);
			}
		}

		public unsafe string GetTunnelsXml()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSocksProxy.GetTunnelsXml(this.m_impl, ref xstring) != null;
				if (flag)
				{
					goto IL_36;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_36:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool StopAllTunnels(int maxWaitMs)
		{
			return <Module>.ClsSocksProxy.StopAllTunnels(this.m_impl, maxWaitMs) != null;
		}

		public event SocksProxy.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsSocksProxy* m_impl;

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
