﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Spider : IDisposable
	{
		public unsafe Spider(void* impl)
		{
			this.m_impl = (ClsSpider*)impl;
			this.m_lockImpl = new object();
		}

		public unsafe Spider()
		{
			ClsSpider* ptr = <Module>.@new(4136U);
			ClsSpider* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsSpider.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 4132) = 2;
		}

		protected unsafe override void Finalize()
		{
			object lockImpl = this.m_lockImpl;
			if (lockImpl != null)
			{
				Monitor.Enter(lockImpl);
			}
			ClsSpider* impl = this.m_impl;
			if (impl != null)
			{
				ClsSpider* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			object lockImpl2 = this.m_lockImpl;
			if (lockImpl2 != null)
			{
				Monitor.Exit(lockImpl2);
			}
			this.m_lockImpl = null;
		}

		public unsafe virtual void Dispose()
		{
			ClsSpider* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsSpider.dotNetDispose(impl);
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string LastHtmlDescription
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_LastHtmlDescription(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastHtmlKeywords
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_LastHtmlKeywords(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastHtmlTitle
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_LastHtmlTitle(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_LastHtml(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool LastFromCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSpider.get_LastFromCache(this.m_impl) != null;
			}
		}

		public unsafe string LastUrl
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.GetLastUrlCrawled(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastModDateStr
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.GetLastModDate(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public void SkipUnspidered(int index)
		{
			<Module>.ClsSpider.SkipUnspidered(this.m_impl, index);
		}

		public unsafe string FetchRobotsText()
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSpider.FetchRobotsText(this.m_impl, ref xstring, null) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public void SleepMs(int millisec)
		{
			<Module>.ClsSpider.SleepMs(this.m_impl, millisec);
		}

		public unsafe string Domain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_Domain(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe void AddMustMatchPattern(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				<Module>.ClsSpider.AddMustMatchPattern(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void AddAvoidOutboundLinkPattern(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				<Module>.ClsSpider.AddAvoidOutPattern(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string GetAvoidPattern(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSpider.GetAvoidPattern(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe void AddAvoidPattern(string pattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				<Module>.ClsSpider.AddAvoidPattern(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string GetOutboundLink(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSpider.GetOutsideUrl(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetFailedUrl(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSpider.GetFailedUrl(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetSpideredUrl(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSpider.GetSpideredUrl(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetUnspideredUrl(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSpider.GetUnspideredUrl(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool RecrawlLast()
		{
			Monitor.Enter(this.m_lockImpl);
			bool result = <Module>.ClsSpider.ReCrawlLast(this.m_impl, null) != null;
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		public unsafe string GetDomain(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsSpider.GetDomain(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetBaseDomain(string domain)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(domain, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsSpider.GetBaseDomain(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string CanonicalizeUrl(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ClsSpider.CanonicalizeUrl(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void ClearOutboundLinks()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsSpider.ClearOutsideUrls(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public void ClearFailedUrls()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsSpider.ClearFailedUrls(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public void ClearSpideredUrls()
		{
			Monitor.Enter(this.m_lockImpl);
			<Module>.ClsSpider.ClearSpideredUrls(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
		}

		public int WindDownCount
		{
			get
			{
				return <Module>.ClsSpider.get_WindDownCount(this.m_impl);
			}
			set
			{
				<Module>.ClsSpider.put_WindDownCount(this.m_impl, value);
			}
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsSpider.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSpider.put_HeartbeatMs(this.m_impl, value);
			}
		}

		public int NumAvoidPatterns
		{
			get
			{
				return <Module>.ClsSpider.get_NumAvoidPatterns(this.m_impl);
			}
		}

		public int NumOutboundLinks
		{
			get
			{
				return <Module>.ClsSpider.get_NumOutsideUrls(this.m_impl);
			}
		}

		public int NumFailed
		{
			get
			{
				return <Module>.ClsSpider.get_NumFailed(this.m_impl);
			}
		}

		public int NumSpidered
		{
			get
			{
				return <Module>.ClsSpider.get_NumSpidered(this.m_impl);
			}
		}

		public int NumUnspidered
		{
			get
			{
				return <Module>.ClsSpider.get_NumUnspidered(this.m_impl);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CrawlNext()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			bool result = false;
			if (this.m_lockImpl == null)
			{
				this.m_lockImpl = new object();
			}
			Monitor.Enter(this.m_lockImpl);
			uint exceptionCode;
			try
			{
				result = (<Module>.ClsSpider.CrawlNext(this.m_impl, null) != null);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_09HJPCFNL@CrawlNext?$AA@));
						result = false;
						goto IL_93;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_93:
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		public bool ChopAtQuery
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSpider.get_ChopAtQuery(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSpider.put_ChopAtQuery(this.m_impl, value);
			}
		}

		public bool AvoidHttps
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSpider.get_AvoidHttps(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSpider.put_AvoidHttps(this.m_impl, value);
			}
		}

		public int MaxResponseSize
		{
			get
			{
				return <Module>.ClsSpider.get_MaxResponseSize(this.m_impl);
			}
			set
			{
				<Module>.ClsSpider.put_MaxResponseSize(this.m_impl, value);
			}
		}

		public int MaxUrlLen
		{
			get
			{
				return <Module>.ClsSpider.get_MaxUrlLen(this.m_impl);
			}
			set
			{
				<Module>.ClsSpider.put_MaxUrlLen(this.m_impl, value);
			}
		}

		public unsafe string CacheDir
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_CacheRoot(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSpider.put_CacheRoot(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string UserAgent
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_UserAgent(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSpider.put_UserAgent(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool UpdateCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSpider.get_UpdateCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSpider.put_UpdateCache(this.m_impl, value);
			}
		}

		public bool FetchFromCache
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSpider.get_FetchFromCache(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSpider.put_FetchFromCache(this.m_impl, value);
			}
		}

		public int ConnectTimeout
		{
			get
			{
				return <Module>.ClsSpider.get_ConnectTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsSpider.put_ConnectTimeout(this.m_impl, value);
			}
		}

		public int ReadTimeout
		{
			get
			{
				return <Module>.ClsSpider.get_ReadTimeout(this.m_impl);
			}
			set
			{
				<Module>.ClsSpider.put_ReadTimeout(this.m_impl, value);
			}
		}

		public unsafe void AddUnspidered(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(url, &xstring);
				Monitor.Enter(this.m_lockImpl);
				<Module>.ClsSpider.AddUnspidered(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void Initialize(string domain)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(domain, &xstring);
				if (this.m_lockImpl == null)
				{
					this.m_lockImpl = new object();
				}
				Monitor.Enter(this.m_lockImpl);
				<Module>.ClsSpider.Initialize(this.m_impl, ref xstring);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string ProxyDomain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_ProxyDomain(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSpider.put_ProxyDomain(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyLogin
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_ProxyLogin(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSpider.put_ProxyLogin(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSpider.get_ProxyPassword(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSpider.put_ProxyPassword(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int ProxyPort
		{
			get
			{
				return <Module>.ClsSpider.get_ProxyPort(this.m_impl);
			}
			set
			{
				<Module>.ClsSpider.put_ProxyPort(this.m_impl, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsSpider* m_impl;

		private object m_lockImpl;
	}
}
