﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Ssh : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Ssh LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Ssh.m_lockObject);
			Ssh result = Ssh.m_objects[key];
			Monitor.Exit(Ssh.m_lockObject);
			return result;
		}

		public unsafe Ssh(void* impl)
		{
			this.m_impl = (ClsSsh*)impl;
			this.OnAbortCheck = null;
		}

		public unsafe Ssh()
		{
			this.m_enableEvents = false;
			this.OnAbortCheck = null;
			<Module>.?A0x026b5683.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x026b5683.NextHashCode;
			ClsSsh* ptr = <Module>.@new(1760U);
			ClsSsh* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsSsh.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
			<Module>.?m_progLang@ClsSsh@@2HA = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsSsh* impl = this.m_impl;
			if (impl != null)
			{
				ClsSsh* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Ssh.m_lockObject);
				object key = this.m_myHashCode;
				Ssh.m_objects.Remove(key);
				Monitor.Exit(Ssh.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(Ssh.m_lockObject);
			ClsSsh* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsSsh.dotNetDispose(impl);
			}
			object key = this.m_myHashCode;
			Ssh.m_objects.Remove(key);
			Monitor.Exit(Ssh.m_lockObject);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Ssh.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				result = (<Module>.ClsSsh.UnlockComponent(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSsh.get_Version(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Ssh.m_lockObject);
						if (Ssh.m_objects == null)
						{
							Ssh.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Ssh.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Ssh.m_objects = new Hashtable();
									Ssh.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Ssh.m_lockObject);
					}
					else
					{
						Monitor.Enter(Ssh.m_lockObject);
						object key3 = this.m_myHashCode;
						Ssh.m_objects.Remove(key3);
						Monitor.Exit(Ssh.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Connect(string hostname, int port)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(hostname, &xstring);
					result = (<Module>.ClsSsh.Connect(this.m_impl, ref xstring, port, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AuthenticatePw(string login, string password)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(login, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(password, &xstring2);
						result = (<Module>.ClsSsh.AuthenticatePw(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public bool KeepSessionLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSsh.get_KeepSessionLog(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSsh.put_KeepSessionLog(this.m_impl, value);
			}
		}

		public unsafe string SessionLog
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSsh.get_SessionLog(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int IdleTimeoutMs
		{
			get
			{
				return <Module>.ClsSsh.get_IdleTimeoutMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSsh.put_IdleTimeoutMs(this.m_impl, value);
			}
		}

		public int ConnectTimeoutMs
		{
			get
			{
				return <Module>.ClsSsh.get_ConnectTimeoutMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSsh.put_ConnectTimeoutMs(this.m_impl, value);
			}
		}

		public int ChannelOpenFailCode
		{
			get
			{
				return <Module>.ClsSsh.get_ChannelOpenFailCode(this.m_impl);
			}
		}

		public int DisconnectCode
		{
			get
			{
				return <Module>.ClsSsh.get_DisconnectCode(this.m_impl);
			}
		}

		public unsafe string DisconnectReason
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSsh.get_DisconnectReason(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string ChannelOpenFailReason
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSsh.get_ChannelOpenFailReason(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int MaxPacketSize
		{
			get
			{
				return <Module>.ClsSsh.get_MaxPacketSize(this.m_impl);
			}
			set
			{
				<Module>.ClsSsh.put_MaxPacketSize(this.m_impl, value);
			}
		}

		public void Disconnect()
		{
			<Module>.ClsSsh.Disconnect(this.m_impl);
		}

		public unsafe int OpenSessionChannel()
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			int result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSsh.OpenSessionChannel(this.m_impl, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe int OpenCustomChannel(string channelType)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			int result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(channelType, &xstring);
					result = <Module>.ClsSsh.OpenCustomChannel(this.m_impl, ref xstring, (ProgressEvent*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public int NumOpenChannels
		{
			get
			{
				return <Module>.ClsSsh.get_NumOpenChannels(this.m_impl);
			}
		}

		public int GetChannelNumber(int index)
		{
			return <Module>.ClsSsh.GetChannelNumber(this.m_impl, index);
		}

		public unsafe string GetChannelType(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsSsh.GetChannelType(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqPty(int channelNum, string xTermEnvVar, int widthInChars, int heightInRows, int pixWidth, int pixHeight)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(xTermEnvVar, &xstring);
					result = (<Module>.ClsSsh.SendReqPty(this.m_impl, channelNum, ref xstring, widthInChars, heightInRows, pixWidth, pixHeight, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqX11Forwarding(int channelNum, [MarshalAs(UnmanagedType.U1)] bool singleConnection, string authProt, string authCookie, int screenNum)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(authProt, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(authCookie, &xstring2);
						result = (<Module>.ClsSsh.SendReqX11Forwarding(this.m_impl, channelNum, singleConnection, ref xstring, ref xstring2, screenNum, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqSetEnv(int channelNum, string name, string value)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(name, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(value, &xstring2);
						result = (<Module>.ClsSsh.SendReqSetEnv(this.m_impl, channelNum, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqShell(int channelNum)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.SendReqShell(this.m_impl, channelNum, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqExec(int channelNum, string command)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(command, &xstring);
					result = (<Module>.ClsSsh.SendReqExec(this.m_impl, channelNum, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqSubsystem(int channelNum, string subsystemName)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(subsystemName, &xstring);
					result = (<Module>.ClsSsh.SendReqSubsystem(this.m_impl, channelNum, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqWindowChange(int channelNum, int widthInChars, int heightInRows, int pixWidth, int pixHeight)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.SendReqWindowChange(this.m_impl, channelNum, widthInChars, heightInRows, pixWidth, pixHeight, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqXonXoff(int channelNum, [MarshalAs(UnmanagedType.U1)] bool clientCanDo)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.SendReqXonXoff(this.m_impl, channelNum, clientCanDo, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendReqSignal(int channelNum, string signalName)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(signalName, &xstring);
					result = (<Module>.ClsSsh.SendReqSignal(this.m_impl, channelNum, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChannelSendData(int channelNum, byte[] data)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				int num = 0;
				void* ptr2 = CkMarshal.ManagedToUnmanaged(data, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr2, num);
					result = (<Module>.ClsSsh.ChannelSendData(this.m_impl, channelNum, ref dataBuffer, (ProgressEvent*)ptr) != null);
					CkMarshal.free(ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChannelSendString(int channelNum, string strData, string charset)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(strData, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						result = (<Module>.ClsSsh.ChannelSendString(this.m_impl, channelNum, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe int ChannelPoll(int channelNum, int pollTimeoutMs)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			int result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSsh.ChannelPoll(this.m_impl, channelNum, pollTimeoutMs, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe int ChannelReadAndPoll(int channelNum, int pollTimeoutMs)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			int result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSsh.ChannelReadAndPoll(this.m_impl, channelNum, pollTimeoutMs, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe int ChannelRead(int channelNum)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			int result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSsh.ChannelRead(this.m_impl, channelNum, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe byte[] GetReceivedData(int channelNum)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.ClsSsh.GetReceivedData(this.m_impl, channelNum, ref dataBuffer);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] GetReceivedStderr(int channelNum)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.ClsSsh.GetReceivedStderr(this.m_impl, channelNum, ref dataBuffer);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool ChannelReceivedEof(int channelNum)
		{
			return <Module>.ClsSsh.ChannelReceivedEof(this.m_impl, channelNum) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool ChannelReceivedClose(int channelNum)
		{
			return <Module>.ClsSsh.ChannelReceivedClose(this.m_impl, channelNum) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChannelSendClose(int channelNum)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.ChannelSendClose(this.m_impl, channelNum, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChannelSendEof(int channelNum)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.ChannelSendEof(this.m_impl, channelNum, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool ChannelIsOpen(int channelNum)
		{
			return <Module>.ClsSsh.ChannelIsOpen(this.m_impl, channelNum) != null;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChannelReceiveToClose(int channelNum)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.ChannelReceiveToClose(this.m_impl, channelNum, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public void ClearTtyModes()
		{
			<Module>.ClsSsh.ClearTtyModes(this.m_impl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetTtyMode(string name, int value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				result = (<Module>.ClsSsh.SetTtyMode(this.m_impl, ref xstring, value) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool IsConnected
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSsh.get_IsConnected(this.m_impl) != null;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ReKey()
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.ReKey(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AuthenticatePk(string username, SshKey privateKey)
		{
			if (privateKey == null)
			{
				return false;
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(username, &xstring);
				_SshCallback sshCallback;
				<Module>.SshCallback.{ctor}(ref sshCallback);
				try
				{
					sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
					*(ref sshCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
					throw;
				}
				try
				{
					_SshCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &sshCallback;
						*(ref sshCallback + 4) = this.m_myHashCode;
					}
					ClsSshKey* implementation = (ClsSshKey*)privateKey.GetImplementation();
					result = (<Module>.ClsSsh.AuthenticatePk(this.m_impl, ref xstring, implementation, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
					throw;
				}
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				<Module>.SshCallback.{dtor}(ref sshCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetReceivedText(int channelNum, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsSsh.GetReceivedText(this.m_impl, channelNum, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_60;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_60:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int GetReceivedNumBytes(int channelNum)
		{
			return <Module>.ClsSsh.GetReceivedNumBytes(this.m_impl, channelNum);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChannelReceiveUntilMatch(int channelNum, string matchPattern, string charset, [MarshalAs(UnmanagedType.U1)] bool caseSensitive)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(matchPattern, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						CkMarshal.StringToX(charset, &xstring2);
						result = (<Module>.ClsSsh.ChannelReceiveUntilMatch(this.m_impl, channelNum, ref xstring, ref xstring2, caseSensitive, (ProgressEvent*)ptr) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SendIgnore()
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsSsh.SendIgnore(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe int OpenDirectTcpIpChannel(string hostname, int port)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			int result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(hostname, &xstring);
					result = <Module>.ClsSsh.OpenDirectTcpIpChannel(this.m_impl, ref xstring, port, (ProgressEvent*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe string GetReceivedTextS(int channelNum, string substr, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(substr, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(charset, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						bool flag = <Module>.ClsSsh.GetReceivedTextS(this.m_impl, channelNum, ref xstring, ref xstring2, ref xstring3) != null;
						if (flag)
						{
							goto IL_89;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_89:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						result2 = CkMarshal.XToString(&xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] GetReceivedDataN(int channelNum, int numBytes)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.ClsSsh.GetReceivedDataN(this.m_impl, channelNum, numBytes, ref dataBuffer);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe string PeekReceivedText(int channelNum, string charset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsSsh.PeekReceivedText(this.m_impl, channelNum, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_60;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_60:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsSsh.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSsh.put_HeartbeatMs(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool ChannelReceivedExitStatus(int channelNum)
		{
			return <Module>.ClsSsh.ChannelReceivedExitStatus(this.m_impl, channelNum) != null;
		}

		public int GetChannelExitStatus(int channelNum)
		{
			return <Module>.ClsSsh.GetChannelExitStatus(this.m_impl, channelNum);
		}

		public unsafe string ClientIdentifier
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSsh.get_ClientIdentifier(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSsh.put_ClientIdentifier(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int ReadTimeoutMs
		{
			get
			{
				return <Module>.ClsSsh.get_ReadTimeoutMs(this.m_impl);
			}
			set
			{
				<Module>.ClsSsh.put_ReadTimeoutMs(this.m_impl, value);
			}
		}

		public bool TcpNoDelay
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSsh.get_TcpNoDelay(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSsh.put_TcpNoDelay(this.m_impl, value);
			}
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsSsh.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsSsh.put_VerboseLogging(this.m_impl, value);
			}
		}

		public unsafe string HostKeyFingerprint
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSsh.get_HostKeyFingerprint(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public int SocksVersion
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksVersion(this.m_impl + 120 / sizeof(ClsSsh));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksVersion(this.m_impl + 120 / sizeof(ClsSsh), value);
			}
		}

		public int SocksPort
		{
			get
			{
				return <Module>.ClsSocksClient.get_SocksPort(this.m_impl + 120 / sizeof(ClsSsh));
			}
			set
			{
				<Module>.ClsSocksClient.put_SocksPort(this.m_impl + 120 / sizeof(ClsSsh), value);
			}
		}

		public unsafe string SocksHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksHostname(this.m_impl + 120 / sizeof(ClsSsh), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksHostname(this.m_impl + 120 / sizeof(ClsSsh), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksUsername(this.m_impl + 120 / sizeof(ClsSsh), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksUsername(this.m_impl + 120 / sizeof(ClsSsh), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string SocksPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsSocksClient.get_SocksPassword(this.m_impl + 120 / sizeof(ClsSsh), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsSocksClient.put_SocksPassword(this.m_impl + 120 / sizeof(ClsSsh), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyAuthMethod
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyAuthMethod(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyAuthMethod(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyUsername
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyUsername(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyUsername(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyPassword(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyPassword(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string HttpProxyHostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsHttpProxyClient.get_HttpProxyHostname(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsHttpProxyClient.put_HttpProxyHostname(this.m_impl + 576 / sizeof(ClsSsh), ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int HttpProxyPort
		{
			get
			{
				return <Module>.ClsHttpProxyClient.get_HttpProxyPort(this.m_impl + 576 / sizeof(ClsSsh));
			}
			set
			{
				<Module>.ClsHttpProxyClient.put_HttpProxyPort(this.m_impl + 576 / sizeof(ClsSsh), value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChannelReceiveUntilMatchN(int channelNum, StringArray matchPatterns, string charset, [MarshalAs(UnmanagedType.U1)] bool caseSensitive)
		{
			if (matchPatterns == null)
			{
				return false;
			}
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			bool result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				ClsStringArray* implementation = matchPatterns.GetImplementation();
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(charset, &xstring);
					result = (<Module>.ClsSsh.ChannelReceiveUntilMatchN(this.m_impl, channelNum, implementation, ref xstring, caseSensitive, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public unsafe int ChannelReadAndPoll2(int channelNum, int pollTimeoutMs, int maxNumBytes)
		{
			_SshCallback sshCallback;
			<Module>.SshCallback.{ctor}(ref sshCallback);
			try
			{
				sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
				*(ref sshCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			int result;
			try
			{
				_SshCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &sshCallback;
					*(ref sshCallback + 4) = this.m_myHashCode;
				}
				result = <Module>.ClsSsh.ChannelReadAndPoll2(this.m_impl, channelNum, pollTimeoutMs, maxNumBytes, (ProgressEvent*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._SshCallback.{dtor}), (void*)(&sshCallback));
				throw;
			}
			sshCallback = ref <Module>.??_7_SshCallback@Chilkat@@6B@;
			<Module>.SshCallback.{dtor}(ref sshCallback);
			return result;
		}

		public event Ssh.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsSsh* m_impl;

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
