﻿using System;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class StringTable : IDisposable
	{
		public unsafe StringTable()
		{
			ClsStringTable* ptr = <Module>.@new(104U);
			ClsStringTable* st;
			try
			{
				if (ptr != null)
				{
					st = <Module>.ClsStringTable.{ctor}(ptr);
				}
				else
				{
					st = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_st = st;
		}

		protected unsafe override void Finalize()
		{
			ClsStringTable* st = this.m_st;
			if (st != null)
			{
				ClsStringTable* ptr = st;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
			}
		}

		public virtual void Dispose()
		{
		}

		public int Count
		{
			get
			{
				return <Module>.ClsStringTable.get_Count(this.m_st);
			}
		}

		public unsafe void Append(string s)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(s, &xstring);
				<Module>.ClsStringTable.Append(this.m_st, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string GetString(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ClsStringTable.GetString(this.m_st, index, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadFromFile(string fname)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fname, &xstring);
				result = (<Module>.ClsStringTable.LoadFromFile(this.m_st, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveToFile(string fname)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fname, &xstring);
				result = (<Module>.ClsStringTable.SaveToFileAnsi(this.m_st, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ClsStringTable* m_st;
	}
}
