﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Tar : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Tar LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Tar.m_lockObject);
			Tar result = Tar.m_objects[key];
			Monitor.Exit(Tar.m_lockObject);
			return result;
		}

		public unsafe Tar(void* impl)
		{
			this.m_impl = (ClsTar*)impl;
			this.OnAbortCheck = null;
			this.OnPercentDone = null;
			this.OnNextTarFile = null;
		}

		public unsafe Tar()
		{
			this.m_enableEvents = false;
			this.OnAbortCheck = null;
			this.OnPercentDone = null;
			this.OnNextTarFile = null;
			<Module>.?A0x5aa2f380.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x5aa2f380.NextHashCode;
			ClsTar* ptr = <Module>.@new(1184U);
			ClsTar* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsTar.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
			<Module>.?m_progLang@ClsTar@@2HA = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsTar* impl = this.m_impl;
			if (impl != null)
			{
				ClsTar* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Tar.m_lockObject);
				object key = this.m_myHashCode;
				Tar.m_objects.Remove(key);
				Monitor.Exit(Tar.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(Tar.m_lockObject);
			ClsTar* impl = this.m_impl;
			if (impl != null)
			{
				<Module>.ClsTar.dotNetDispose(impl);
			}
			object key = this.m_myHashCode;
			Tar.m_objects.Remove(key);
			Monitor.Exit(Tar.m_lockObject);
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Tar.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			Tar.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public void FireNextTarFile(object sender, NextTarFileEventArgs args)
		{
			Tar.NextTarFileEventHandler onNextTarFile = this.OnNextTarFile;
			if (onNextTarFile != null)
			{
				onNextTarFile(sender, args);
			}
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Tar.m_lockObject);
						if (Tar.m_objects == null)
						{
							Tar.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Tar.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Tar.m_objects = new Hashtable();
									Tar.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Tar.m_lockObject);
					}
					else
					{
						Monitor.Enter(Tar.m_lockObject);
						object key3 = this.m_myHashCode;
						Tar.m_objects.Remove(key3);
						Monitor.Exit(Tar.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int Untar(string tarFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(tarFilename, &xstring);
				_TarCallback tarCallback;
				<Module>.TarCallback.{ctor}(ref tarCallback);
				try
				{
					tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
					*(ref tarCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
					throw;
				}
				try
				{
					_TarCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &tarCallback;
						*(ref tarCallback + 4) = this.m_myHashCode;
					}
					result = <Module>.ClsTar.Untar(this.m_impl, ref xstring, (ProgressEvent*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
					throw;
				}
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				<Module>.TarCallback.{dtor}(ref tarCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string UntarFromDir
		{
			get
			{
				return CkMarshal.XToString((XString*)(this.m_impl + 896 / sizeof(ClsTar)));
			}
			set
			{
				CkMarshal.StringToX(value, (XString*)(this.m_impl + 896 / sizeof(ClsTar)));
			}
		}

		public unsafe bool NoAbsolutePaths
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return *(byte*)(this.m_impl + 1177 / sizeof(ClsTar)) != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				*(byte*)(this.m_impl + 1177 / sizeof(ClsTar)) = (value ? 1 : 0);
			}
		}

		public unsafe bool UntarDiscardPaths
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return *(byte*)(this.m_impl + 1176 / sizeof(ClsTar)) != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				*(byte*)(this.m_impl + 1176 / sizeof(ClsTar)) = (value ? 1 : 0);
			}
		}

		public unsafe bool UntarCaseSensitive
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return *(byte*)(this.m_impl + 1168 / sizeof(ClsTar)) != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				*(byte*)(this.m_impl + 1168 / sizeof(ClsTar)) = (value ? 1 : 0);
			}
		}

		public unsafe int UntarMaxCount
		{
			get
			{
				return *(int*)(this.m_impl + 1172 / sizeof(ClsTar));
			}
			set
			{
				*(int*)(this.m_impl + 1172 / sizeof(ClsTar)) = value;
			}
		}

		public unsafe string UntarMatchPattern
		{
			get
			{
				return CkMarshal.XToString((XString*)(this.m_impl + 1032 / sizeof(ClsTar)));
			}
			set
			{
				CkMarshal.StringToX(value, (XString*)(this.m_impl + 1032 / sizeof(ClsTar)));
			}
		}

		public unsafe bool UntarDebugLog
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return *(byte*)(this.m_impl + 1178 / sizeof(ClsTar)) != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				*(byte*)(this.m_impl + 1178 / sizeof(ClsTar)) = (value ? 1 : 0);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				int num = *(int*)this.m_impl + 4;
				result = calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.SByte modopt(System.Runtime.CompilerServices.IsSignUnspecifiedByte) modopt(System.Runtime.CompilerServices.IsConst)*), this.m_impl, <Module>.XString.getUtf8(ref xstring), *num);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int UntarFromMemory(byte[] tarFileBytes)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(tarFileBytes, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			int result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				_TarCallback tarCallback;
				<Module>.TarCallback.{ctor}(ref tarCallback);
				try
				{
					tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
					*(ref tarCallback + 4) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
					throw;
				}
				try
				{
					_TarCallback* ptr2 = null;
					if (this.m_enableEvents)
					{
						ptr2 = &tarCallback;
						*(ref tarCallback + 4) = this.m_myHashCode;
					}
					result = <Module>.ClsTar.UntarFromMemory(this.m_impl, ref dataBuffer, (ProgressEvent*)ptr2);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
					throw;
				}
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				<Module>.TarCallback.{dtor}(ref tarCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] UntarFirstMatchingToMemory(byte[] tarFileBytes, string matchPattern)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(tarFileBytes, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(matchPattern, &xstring);
					DataBuffer dataBuffer2;
					<Module>.DataBuffer.{ctor}(ref dataBuffer2);
					try
					{
						<Module>.ClsTar.UntarFirstMatchingToMemory(this.m_impl, ref dataBuffer, ref xstring, ref dataBuffer2);
						CkMarshal.free(ptr);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer2), <Module>.DataBuffer.getSize(ref dataBuffer2));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddDirRoot(string dirPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				result = (<Module>.ClsTar.AddDirRoot(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public int NumDirRoots
		{
			get
			{
				return <Module>.ClsTar.get_NumDirRoots(this.m_impl);
			}
		}

		public unsafe string GetDirRoot(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				bool flag = <Module>.ClsTar.GetDirRoot(this.m_impl, index, ref xstring) != null;
				if (flag)
				{
					goto IL_37;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_37:
			string result2;
			try
			{
				result2 = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTar(string tarFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(tarFilename, &xstring);
					result = (<Module>.ClsTar.WriteTar(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTarGz(string outFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(outFilename, &xstring);
					result = (<Module>.ClsTar.WriteTarGz(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTarBz2(string outFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(outFilename, &xstring);
					result = (<Module>.ClsTar.WriteTarBz2(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteTarZ(string outFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(outFilename, &xstring);
					result = (<Module>.ClsTar.WriteTarZ(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
		}

		public unsafe string ListXml(string tarFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			string result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(tarFilename, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsTar.ListXml(this.m_impl, ref xstring, ref xstring2, (ProgressEvent*)ptr) != null;
						if (flag)
						{
							goto IL_BE;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
			IL_BE:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result2;
		}

		public unsafe string Charset
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsTar.get_Charset(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsTar.put_Charset(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UntarZ(string tarFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(tarFilename, &xstring);
					result = (<Module>.ClsTar.UntarZ(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UntarGz(string tarFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(tarFilename, &xstring);
					result = (<Module>.ClsTar.UntarGz(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UntarBz2(string tarFilename)
		{
			_TarCallback tarCallback;
			<Module>.TarCallback.{ctor}(ref tarCallback);
			try
			{
				tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
				*(ref tarCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			bool result;
			try
			{
				_TarCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &tarCallback;
					*(ref tarCallback + 4) = this.m_myHashCode;
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(tarFilename, &xstring);
					result = (<Module>.ClsTar.UntarBz2(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._TarCallback.{dtor}), (void*)(&tarCallback));
				throw;
			}
			tarCallback = ref <Module>.??_7_TarCallback@Chilkat@@6B@;
			<Module>.TarCallback.{dtor}(ref tarCallback);
			return result;
		}

		public unsafe string UserName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsTar.get_UserName(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsTar.put_UserName(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string GroupName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsTar.get_GroupName(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsTar.put_GroupName(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int UserId
		{
			get
			{
				return <Module>.ClsTar.get_UserId(this.m_impl);
			}
			set
			{
				<Module>.ClsTar.put_UserId(this.m_impl, value);
			}
		}

		public int GroupId
		{
			get
			{
				return <Module>.ClsTar.get_GroupId(this.m_impl);
			}
			set
			{
				<Module>.ClsTar.put_GroupId(this.m_impl, value);
			}
		}

		public int DirMode
		{
			get
			{
				return <Module>.ClsTar.get_DirMode(this.m_impl);
			}
			set
			{
				<Module>.ClsTar.put_DirMode(this.m_impl, value);
			}
		}

		public int FileMode
		{
			get
			{
				return <Module>.ClsTar.get_FileMode(this.m_impl);
			}
			set
			{
				<Module>.ClsTar.put_FileMode(this.m_impl, value);
			}
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsTar.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsTar.put_VerboseLogging(this.m_impl, value);
			}
		}

		public unsafe string WriteFormat
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsTar.get_WriteFormat(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsTar.put_WriteFormat(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int HeartbeatMs
		{
			get
			{
				return <Module>.ClsTar.get_HeartbeatMs(this.m_impl);
			}
			set
			{
				<Module>.ClsTar.put_HeartbeatMs(this.m_impl, value);
			}
		}

		public event Tar.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public event Tar.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public event Tar.NextTarFileEventHandler OnNextTarFile
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnNextTarFile = Delegate.Combine(this.OnNextTarFile, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnNextTarFile = Delegate.Remove(this.OnNextTarFile, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsTar* m_impl;

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void NextTarFileEventHandler(object sender, NextTarFileEventArgs args);
	}
}
