﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class UnixCompress : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static UnixCompress LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(UnixCompress.m_lockObject);
			UnixCompress result = (UnixCompress)UnixCompress.m_objects[key];
			Monitor.Exit(UnixCompress.m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			UnixCompress.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			UnixCompress.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe UnixCompress(void* impl)
		{
			this.m_impl = (ClsZ*)impl;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
		}

		public unsafe UnixCompress()
		{
			this.m_enableEvents = false;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			<Module>.?A0x6925e2d9.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x6925e2d9.NextHashCode;
			ClsZ* ptr = <Module>.@new(120U);
			ClsZ* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsZ.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsZ* impl = this.m_impl;
			if (impl != null)
			{
				ClsZ* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(UnixCompress.m_lockObject);
				object key = this.m_myHashCode;
				UnixCompress.m_objects.Remove(key);
				Monitor.Exit(UnixCompress.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public virtual void Dispose()
		{
			Monitor.Enter(UnixCompress.m_lockObject);
			object key = this.m_myHashCode;
			UnixCompress.m_objects.Remove(key);
			Monitor.Exit(UnixCompress.m_lockObject);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string unlockCode)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(unlockCode, &xstring);
				int num = *(int*)this.m_impl + 4;
				result = calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.SByte modopt(System.Runtime.CompilerServices.IsSignUnspecifiedByte) modopt(System.Runtime.CompilerServices.IsConst)*), this.m_impl, <Module>.XString.getUtf8(ref xstring), *num);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsUnlocked()
		{
			ClsZ* impl = this.m_impl;
			return calli(System.Byte modopt(System.Runtime.CompilerServices.CompilerMarshalOverride) modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr), impl, *(*(int*)impl + 8));
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressFile(string inFilename, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outFilename, &xstring2);
					result = (<Module>.ClsZ.CompressFile(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressFile(string inFilename, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outFilename, &xstring2);
					result = (<Module>.ClsZ.UncompressFile(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] CompressFileToMem(string inFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.ClsZ.CompressFileToMem(this.m_impl, ref xstring, ref dataBuffer) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe byte[] UncompressFileToMem(string inFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					bool flag = <Module>.ClsZ.UncompressFileToMem(this.m_impl, ref xstring, ref dataBuffer) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressMemToFile(byte[] inData, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(outFilename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					result = (<Module>.ClsZ.CompressMemToFile(this.m_impl, ref dataBuffer, ref xstring) != null);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UncompressMemToFile(byte[] inData, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(outFilename, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					result = (<Module>.ClsZ.UncompressMemToFile(this.m_impl, ref dataBuffer, ref xstring) != null);
					CkMarshal.free(ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] CompressMemory(byte[] inData)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer2, ptr, num);
					bool flag = <Module>.ClsZ.CompressMemory(this.m_impl, ref dataBuffer2, ref dataBuffer) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_73;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_73:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer2;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe byte[] UncompressMemory(byte[] inData)
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer2;
				<Module>.DataBuffer.{ctor}(ref dataBuffer2);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer2, ptr, num);
					bool flag = <Module>.ClsZ.UncompressMemory(this.m_impl, ref dataBuffer2, ref dataBuffer) != null;
					CkMarshal.free(ptr);
					if (flag)
					{
						goto IL_73;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_73:
			byte[] result2;
			try
			{
				DataBuffer dataBuffer2;
				try
				{
					result2 = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer2));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnTarZ(string zFilename, string destDir, [MarshalAs(UnmanagedType.U1)] bool bNoAbsolute)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(zFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(destDir, &xstring2);
					result = (<Module>.ClsZ.UnTarZ(this.m_impl, ref xstring, ref xstring2, bNoAbsolute) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(UnixCompress.m_lockObject);
						if (UnixCompress.m_objects == null)
						{
							UnixCompress.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							UnixCompress.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									UnixCompress.m_objects = new Hashtable();
									UnixCompress.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(UnixCompress.m_lockObject);
					}
					else
					{
						Monitor.Enter(UnixCompress.m_lockObject);
						object key3 = this.m_myHashCode;
						UnixCompress.m_objects.Remove(key3);
						Monitor.Exit(UnixCompress.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public unsafe string UncompressString(byte[] inData, string inCharset)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			string result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(inCharset, &xstring);
					XString xstring2;
					<Module>.XString.{ctor}(ref xstring2);
					try
					{
						bool flag = <Module>.ClsZ.UncompressString(this.m_impl, ref dataBuffer, ref xstring, ref xstring2) != null;
						CkMarshal.free(ptr);
						if (flag)
						{
							goto IL_9C;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
			IL_9C:
			string result2;
			try
			{
				XString xstring;
				try
				{
					XString xstring2;
					try
					{
						result2 = CkMarshal.XToString(&xstring2);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result2;
		}

		public unsafe string UncompressFileToString(string inFilename, string inCharset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(inFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(inCharset, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						bool flag = <Module>.ClsZ.UncompressFileToString(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null;
						if (flag)
						{
							goto IL_88;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_88:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						result2 = CkMarshal.XToString(&xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool CompressStringToFile(string inStr, string outCharset, string outFilename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inStr, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outCharset, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(outFilename, &xstring3);
						result = (<Module>.ClsZ.CompressStringToFile(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] CompressString(string inStr, string outCharset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(inStr, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outCharset, &xstring2);
					DataBuffer dataBuffer;
					<Module>.DataBuffer.{ctor}(ref dataBuffer);
					try
					{
						<Module>.ClsZ.CompressString(this.m_impl, ref xstring, ref xstring2, ref dataBuffer);
						result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
						throw;
					}
					<Module>.DataBuffer.{dtor}(ref dataBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public event UnixCompress.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public event UnixCompress.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsZ* m_impl;

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
