﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Upload : IDisposable
	{
		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Upload LookupObject(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Upload.m_lockObject);
			Upload result = (Upload)Upload.m_objects[key];
			Monitor.Exit(Upload.m_lockObject);
			return result;
		}

		public void FirePercentDone(object sender, PercentDoneEventArgs args)
		{
			Upload.PercentDoneEventHandler onPercentDone = this.OnPercentDone;
			if (onPercentDone != null)
			{
				onPercentDone(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Upload.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public unsafe Upload(void* impl)
		{
			this.m_impl = (ClsUpload*)impl;
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
		}

		public unsafe Upload()
		{
			this.OnPercentDone = null;
			this.OnAbortCheck = null;
			<Module>.?A0x7bb63b50.NextHashCode++;
			this.m_myHashCode = <Module>.?A0x7bb63b50.NextHashCode;
			ClsUpload* ptr = <Module>.@new(1680U);
			ClsUpload* ptr2;
			try
			{
				if (ptr != null)
				{
					ptr2 = <Module>.ClsUpload.{ctor}(ptr);
				}
				else
				{
					ptr2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = ptr2;
			*(ptr2 + 488) = 2;
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			ClsUpload* impl = this.m_impl;
			if (impl != null)
			{
				ClsUpload* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Monitor.Enter(Upload.m_lockObject);
				object key = this.m_myHashCode;
				Upload.m_objects.Remove(key);
				Monitor.Exit(Upload.m_lockObject);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						return;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
		}

		public virtual void Dispose()
		{
			Monitor.Enter(Upload.m_lockObject);
			object key = this.m_myHashCode;
			Upload.m_objects.Remove(key);
			Monitor.Exit(Upload.m_lockObject);
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					if (value)
					{
						Monitor.Enter(Upload.m_lockObject);
						if (Upload.m_objects == null)
						{
							Upload.m_objects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Upload.m_objects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Upload.m_objects = new Hashtable();
									Upload.m_objects.Add(key2, this);
									goto IL_C1;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
						IL_C1:
						Monitor.Exit(Upload.m_lockObject);
					}
					else
					{
						Monitor.Enter(Upload.m_lockObject);
						object key3 = this.m_myHashCode;
						Upload.m_objects.Remove(key3);
						Monitor.Exit(Upload.m_lockObject);
					}
					this.m_enableEvents = value;
				}
			}
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.XString.appendUtf8(ref xstring, (sbyte*)(&<Module>.??_C@_05KGLLLGOB@1?43?46?$AA@));
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public void SleepMs(int millisec)
		{
			<Module>.Sleep(millisec);
		}

		public int ChunkSize
		{
			get
			{
				return <Module>.ClsUpload.get_SendBufferSize(this.m_impl);
			}
			set
			{
				<Module>.ClsUpload.put_SendBufferSize(this.m_impl, value);
			}
		}

		public unsafe int IdleTimeoutMs
		{
			get
			{
				return *(int*)(this.m_impl + 496 / sizeof(ClsUpload));
			}
			set
			{
				*(int*)(this.m_impl + 496 / sizeof(ClsUpload)) = value;
			}
		}

		public unsafe int HeartbeatMs
		{
			get
			{
				return *(int*)(this.m_impl + 500 / sizeof(ClsUpload));
			}
			set
			{
				*(int*)(this.m_impl + 500 / sizeof(ClsUpload)) = value;
			}
		}

		public unsafe bool UploadInProgress
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return *(byte*)(this.m_impl + 504 / sizeof(ClsUpload)) != 0;
			}
		}

		public unsafe bool UploadSuccess
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return *(byte*)(this.m_impl + 505 / sizeof(ClsUpload)) != 0;
			}
		}

		public unsafe void AddCustomHeader(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					<Module>.ClsUpload.AddCustomHeader(this.m_impl, ref xstring, ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void AddParam(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					<Module>.ClsUpload.AddParam(this.m_impl, ref xstring, ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void AddFileReference(string name, string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(filename, &xstring2);
					<Module>.ClsUpload.AddFileReference(this.m_impl, ref xstring, ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe int Port
		{
			get
			{
				return *(int*)(this.m_impl + 668 / sizeof(ClsUpload));
			}
			set
			{
				*(int*)(this.m_impl + 668 / sizeof(ClsUpload)) = value;
			}
		}

		public unsafe bool Ssl
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return *(byte*)(this.m_impl + 672 / sizeof(ClsUpload)) != 0;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				*(byte*)(this.m_impl + 672 / sizeof(ClsUpload)) = (value ? 1 : 0);
			}
		}

		public unsafe string Hostname
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsUpload.get_Hostname(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsUpload.put_Hostname(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Path
		{
			get
			{
				return CkMarshal.XToString((XString*)(this.m_impl + 1368 / sizeof(ClsUpload)));
			}
			set
			{
				CkMarshal.StringToX(value, (XString*)(this.m_impl + 1368 / sizeof(ClsUpload)));
			}
		}

		public unsafe string Login
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsUpload.get_Login(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsUpload.put_Login(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Password
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsUpload.get_Password(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsUpload.put_Password(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyDomain
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsUpload.get_ProxyDomain(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsUpload.put_ProxyDomain(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int ProxyPort
		{
			get
			{
				return <Module>.ClsUpload.get_ProxyPort(this.m_impl);
			}
			set
			{
				<Module>.ClsUpload.put_ProxyPort(this.m_impl, value);
			}
		}

		public unsafe string ProxyLogin
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsUpload.get_ProxyLogin(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsUpload.put_ProxyLogin(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ProxyPassword
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsUpload.get_ProxyPassword(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsUpload.put_ProxyPassword(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe uint TotalUploadSize
		{
			get
			{
				return *(int*)(this.m_impl + 660 / sizeof(ClsUpload));
			}
		}

		public unsafe uint NumBytesSent
		{
			get
			{
				return *(int*)(this.m_impl + 664 / sizeof(ClsUpload));
			}
		}

		public unsafe uint PercentUploaded
		{
			get
			{
				ClsUpload* impl = this.m_impl;
				return (uint)(*(int*)(impl + 664 / sizeof(ClsUpload)) / *(int*)(impl + 660 / sizeof(ClsUpload)) * 100.0);
			}
		}

		public unsafe int ResponseStatus
		{
			get
			{
				return *(int*)(this.m_impl + 1672 / sizeof(ClsUpload));
			}
		}

		public unsafe string ResponseHeader
		{
			get
			{
				return CkMarshal.XToString((XString*)(this.m_impl + 1536 / sizeof(ClsUpload)));
			}
		}

		public byte[] ResponseBody
		{
			get
			{
				return CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(this.m_impl + 1504 / sizeof(ClsUpload)), <Module>.DataBuffer.getSize(this.m_impl + 1504 / sizeof(ClsUpload)));
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool BlockingUpload()
		{
			_UploadCallback uploadCallback;
			<Module>.UploadCallback.{ctor}(ref uploadCallback);
			try
			{
				uploadCallback = ref <Module>.??_7_UploadCallback@Chilkat@@6B@;
				*(ref uploadCallback + 4) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(UploadCallback.{dtor}), (void*)(&uploadCallback));
				throw;
			}
			bool result;
			try
			{
				_UploadCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &uploadCallback;
					*(ref uploadCallback + 4) = this.m_myHashCode;
				}
				result = (<Module>.ClsUpload.BlockingUpload(this.m_impl, (ProgressEvent*)ptr) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._UploadCallback.{dtor}), (void*)(&uploadCallback));
				throw;
			}
			uploadCallback = ref <Module>.??_7_UploadCallback@Chilkat@@6B@;
			<Module>.UploadCallback.{dtor}(ref uploadCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool BeginUpload()
		{
			return <Module>.ClsUpload.BeginUpload(this.m_impl) != null;
		}

		public void AbortUpload()
		{
			<Module>.ClsUpload.AbortUpload(this.m_impl);
		}

		public unsafe byte[] UploadToMemory()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				<Module>.ClsUpload.UploadToMemory(this.m_impl, ref dataBuffer);
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public event Upload.PercentDoneEventHandler OnPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnPercentDone = Delegate.Combine(this.OnPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnPercentDone = Delegate.Remove(this.OnPercentDone, value);
			}
		}

		public event Upload.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_objects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private unsafe ClsUpload* m_impl;

		public delegate void PercentDoneEventHandler(object sender, PercentDoneEventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);
	}
}
