﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace Chilkat
{
	public class Xml : IDisposable
	{
		public unsafe Xml()
		{
			this.m_impl = null;
			ClsXml* ptr = <Module>.@new(160U);
			ClsXml* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ClsXml.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		private Xml(Xml xml)
		{
			this.m_impl = null;
		}

		private unsafe Xml(void* impl)
		{
			this.m_impl = (ClsXml*)impl;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		private unsafe bool clearXml()
		{
			Monitor.Enter(Xml.m_lockImpl);
			ClsXml* impl = this.m_impl;
			if (impl != null)
			{
				ClsXml* ptr = impl;
				this.m_impl = null;
				if (ptr != null)
				{
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				}
			}
			ClsXml* ptr2 = <Module>.@new(160U);
			ClsXml* impl2;
			try
			{
				if (ptr2 != null)
				{
					impl2 = <Module>.ClsXml.{ctor}(ptr2);
				}
				else
				{
					impl2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr2);
				throw;
			}
			this.m_impl = impl2;
			Monitor.Exit(Xml.m_lockImpl);
			return true;
		}

		protected unsafe override void Finalize()
		{
			Monitor.Enter(Xml.m_lockImpl);
			ClsXml* impl = this.m_impl;
			if (impl != null)
			{
				ClsXml* ptr = impl;
				this.m_impl = null;
				if (ptr != null)
				{
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				}
			}
			Monitor.Exit(Xml.m_lockImpl);
		}

		public unsafe virtual void Dispose()
		{
			Monitor.Enter(Xml.m_lockImpl);
			ClsXml* impl = this.m_impl;
			if (impl != null)
			{
				ClsXml* ptr = impl;
				this.m_impl = null;
				if (ptr != null)
				{
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				}
			}
			ClsXml* ptr2 = <Module>.@new(160U);
			ClsXml* impl2;
			try
			{
				if (ptr2 != null)
				{
					impl2 = <Module>.ClsXml.{ctor}(ptr2);
				}
				else
				{
					impl2 = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr2);
				throw;
			}
			this.m_impl = impl2;
			Monitor.Exit(Xml.m_lockImpl);
		}

		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(Xml.m_lockImpl);
					<Module>.ClsBase.GetTextLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(Xml.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(Xml.m_lockImpl);
					<Module>.ClsBase.GetXmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(Xml.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					Monitor.Enter(Xml.m_lockImpl);
					<Module>.ClsBase.GetHtmlLogX(this.m_impl, ref xstring, true);
					Monitor.Exit(Xml.m_lockImpl);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsBase.SaveXmlLogX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void GetRoot2()
		{
			Monitor.Enter(Xml.m_lockImpl);
			ClsXml* ptr = <Module>.ClsXml.GetRoot(this.m_impl);
			if (ptr == null)
			{
				Monitor.Exit(Xml.m_lockImpl);
			}
			else
			{
				ClsXml* impl = this.m_impl;
				if (ptr == impl)
				{
					Monitor.Exit(Xml.m_lockImpl);
				}
				else
				{
					ClsXml* ptr2 = impl;
					if (ptr2 != null)
					{
						object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*(int*)ptr2));
					}
					this.m_impl = ptr;
					Monitor.Exit(Xml.m_lockImpl);
				}
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool PreviousSibling2()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.PreviousSibling2(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool NextSibling2()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.NextSibling2(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool LastChild2()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.LastChild2(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool FirstChild2()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.FirstChild2(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool GetParent2()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.GetParent2(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool FindChild2(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.FindChild2X(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SearchForAttribute2(Xml after, string tag, string attr, string valuePattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(attr, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(valuePattern, &xstring3);
						Monitor.Enter(Xml.m_lockImpl);
						ClsXml* ptr = null;
						if (after != null)
						{
							ptr = after.m_impl;
						}
						result = (<Module>.ClsXml.SearchForAttribute2X(this.m_impl, ptr, ref xstring, ref xstring2, ref xstring3) != null);
						Monitor.Exit(Xml.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SearchAllForContent2(Xml after, string contentPattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(contentPattern, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				ClsXml* ptr = null;
				if (after != null)
				{
					ptr = after.m_impl;
				}
				result = (<Module>.ClsXml.SearchAllForContent2X(this.m_impl, ptr, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SearchForContent2(Xml after, string tag, string contentPattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(contentPattern, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					ClsXml* ptr = null;
					if (after != null)
					{
						ptr = after.m_impl;
					}
					result = (<Module>.ClsXml.SearchForContent2X(this.m_impl, ptr, ref xstring, ref xstring2) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SearchForTag2(Xml after, string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				ClsXml* ptr = null;
				if (after != null)
				{
					ptr = after.m_impl;
				}
				result = (<Module>.ClsXml.SearchForTag2X(this.m_impl, ptr, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetChildContent(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					Monitor.Enter(Xml.m_lockImpl);
					<Module>.ClsXml.GetChildContentX(this.m_impl, ref xstring, ref xstring2);
					Monitor.Exit(Xml.m_lockImpl);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void NewChild2(string tag, string content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(content, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					<Module>.ClsXml.NewChild2X(this.m_impl, ref xstring, ref xstring2);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe Xml HttpGet(string url)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				ClsXml* ptr = <Module>.ClsXml.HttpGetX(this.m_impl, ref xstring, null);
				Monitor.Exit(Xml.m_lockImpl);
				if (ptr != null)
				{
					goto IL_53;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_53:
			Xml result2;
			try
			{
				ClsXml* ptr;
				result2 = new Xml((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Xml GetRoot()
		{
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr = <Module>.ClsXml.GetRoot(this.m_impl);
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public unsafe Xml GetChildWithTag(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = null;
				ClsXml* ptr = <Module>.ClsXml.GetChildWithTagX(this.m_impl, ref xstring);
				if (ptr != null)
				{
					result = new Xml((void*)ptr);
				}
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml PreviousSibling()
		{
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr = <Module>.ClsXml.PreviousSibling(this.m_impl);
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public unsafe Xml NextSibling()
		{
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr = <Module>.ClsXml.NextSibling(this.m_impl);
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public unsafe Xml LastChild()
		{
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr = <Module>.ClsXml.LastChild(this.m_impl);
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public unsafe Xml FirstChild()
		{
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr = <Module>.ClsXml.FirstChild(this.m_impl);
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public void Clear()
		{
			Monitor.Enter(Xml.m_lockImpl);
			<Module>.ClsXml.Clear(this.m_impl);
			Monitor.Exit(Xml.m_lockImpl);
		}

		public unsafe Xml GetParent()
		{
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr = <Module>.ClsXml.GetParent(this.m_impl);
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public unsafe Xml SearchForAttribute(Xml after, string tag, string attr, string valuePattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(attr, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(valuePattern, &xstring3);
						Monitor.Enter(Xml.m_lockImpl);
						result = null;
						ClsXml* ptr = null;
						if (after != null)
						{
							ptr = after.m_impl;
						}
						ClsXml* ptr2 = <Module>.ClsXml.SearchForAttributeX(this.m_impl, ptr, ref xstring, ref xstring2, ref xstring3);
						if (ptr2 != null)
						{
							result = new Xml((void*)ptr2);
						}
						Monitor.Exit(Xml.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml SearchAllForContent(Xml after, string contentPattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(contentPattern, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = null;
				ClsXml* ptr = null;
				if (after != null)
				{
					ptr = after.m_impl;
				}
				ClsXml* ptr2 = <Module>.ClsXml.SearchAllForContentX(this.m_impl, ptr, ref xstring);
				if (ptr2 != null)
				{
					result = new Xml((void*)ptr2);
				}
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml SearchForContent(Xml after, string tag, string contentPattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(contentPattern, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					result = null;
					ClsXml* ptr = null;
					if (after != null)
					{
						ptr = after.m_impl;
					}
					ClsXml* ptr2 = <Module>.ClsXml.SearchForContentX(this.m_impl, ptr, ref xstring, ref xstring2);
					if (ptr2 != null)
					{
						result = new Xml((void*)ptr2);
					}
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml SearchForTag(Xml after, string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = null;
				ClsXml* ptr = null;
				if (after != null)
				{
					ptr = after.m_impl;
				}
				ClsXml* ptr2 = <Module>.ClsXml.SearchForTagX(this.m_impl, ptr, ref xstring);
				if (ptr2 != null)
				{
					result = new Xml((void*)ptr2);
				}
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml FindChild(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = null;
				ClsXml* ptr = <Module>.ClsXml.FindChildX(this.m_impl, ref xstring);
				if (ptr != null)
				{
					result = new Xml((void*)ptr);
				}
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml FindOrAddNewChild(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = null;
				ClsXml* ptr = <Module>.ClsXml.FindOrAddNewChildX(this.m_impl, ref xstring);
				if (ptr != null)
				{
					result = new Xml((void*)ptr);
				}
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml NewChild(string tag, string content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(content, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					ClsXml* ptr = <Module>.ClsXml.NewChildX(this.m_impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_7B;
					}
					Monitor.Exit(Xml.m_lockImpl);
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_7B:
			Xml result2;
			try
			{
				XString xstring2;
				try
				{
					ClsXml* ptr;
					result2 = new Xml((void*)ptr);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Xml GetNthChildWithTag(string tag, int n)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = null;
				ClsXml* ptr = <Module>.ClsXml.GetNthChildWithTagX(this.m_impl, ref xstring, n);
				if (ptr != null)
				{
					result = new Xml((void*)ptr);
				}
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int NumChildrenHavingTag(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = <Module>.ClsXml.NumChildrenHavingTagX(this.m_impl, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml ExtractChildByName(string tag, string attrName, string attrValue)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(attrName, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(attrValue, &xstring3);
						Monitor.Enter(Xml.m_lockImpl);
						result = null;
						ClsXml* ptr = <Module>.ClsXml.ExtractChildByNameX(this.m_impl, ref xstring, ref xstring2, ref xstring3);
						if (ptr != null)
						{
							result = new Xml((void*)ptr);
						}
						Monitor.Exit(Xml.m_lockImpl);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml ExtractChildByIndex(int index)
		{
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr = <Module>.ClsXml.ExtractChildByIndex(this.m_impl, index);
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public unsafe Xml GetChild(int index)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			Monitor.Enter(Xml.m_lockImpl);
			Xml result = null;
			ClsXml* ptr;
			uint exceptionCode;
			try
			{
				ptr = <Module>.ClsXml.GetChild(this.m_impl, index);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08FNFLPFI@GetChild?$AA@));
						goto IL_7E;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_7E:
			if (ptr != null)
			{
				result = new Xml((void*)ptr);
			}
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool GetChild2(int index)
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.GetChild2(this.m_impl, index) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddChildTree(Xml tree)
		{
			Monitor.Enter(Xml.m_lockImpl);
			ClsXml* ptr = null;
			if (tree != null)
			{
				ptr = tree.m_impl;
			}
			bool result = <Module>.ClsXml.AddChildTree(this.m_impl, ptr) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SwapTree(Xml tree)
		{
			Monitor.Enter(Xml.m_lockImpl);
			ClsXml* ptr = null;
			if (tree != null)
			{
				ptr = tree.m_impl;
			}
			bool result = <Module>.ClsXml.SwapTree(this.m_impl, ptr) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SwapNode(Xml node)
		{
			Monitor.Enter(Xml.m_lockImpl);
			ClsXml* ptr = null;
			if (node != null)
			{
				ptr = node.m_impl;
			}
			bool result = <Module>.ClsXml.SwapNode(this.m_impl, ptr) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasAttrWithValue(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					result = (<Module>.ClsXml.HasAttrWithValueX(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetAttrValue(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					Monitor.Enter(Xml.m_lockImpl);
					<Module>.ClsXml.GetAttrValueX(this.m_impl, ref xstring, ref xstring2);
					Monitor.Exit(Xml.m_lockImpl);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int GetAttrValueInt(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = <Module>.ClsXml.GetAttrValueIX(this.m_impl, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public int GetAttributeValueInt(int index)
		{
			Monitor.Enter(Xml.m_lockImpl);
			int result = <Module>.ClsXml.GetAttributeValueI(this.m_impl, index);
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		public unsafe string GetAttributeValue(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.GetAttributeValueX(this.m_impl, index, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetAttributeName(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.GetAttributeNameX(this.m_impl, index, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool RemoveAllAttributes()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.RemoveAllAttributes(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveAttribute(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.RemoveAttributeX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddAttribute(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					result = (<Module>.ClsXml.AddAttributeX(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddAttributeInt(string name, int value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.AddAttributeIntX(this.m_impl, ref xstring, value) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendToContent(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.AppendToContentX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetXml()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(Xml.m_lockImpl);
				uint exceptionCode;
				try
				{
					<Module>.ClsXml.GetXmlX2(this.m_impl, ref xstring);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_06DAKKOIAF@GetXml?$AA@));
							goto IL_84;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_84:
				Monitor.Exit(Xml.m_lockImpl);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveXml(string fileName)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.SaveXmlX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXmlFile(string fileName)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.LoadXmlFileX(this.m_impl, ref xstring, true) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXml(string xmlData)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xmlData, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				this.clearXml();
				result = (<Module>.ClsXml.LoadXmlX2(this.m_impl, ref xstring, true) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXmlFile2(string fileName, [MarshalAs(UnmanagedType.U1)] bool autoTrim)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.LoadXmlFileX(this.m_impl, ref xstring, autoTrim) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool LoadXml2(string xmlData, [MarshalAs(UnmanagedType.U1)] bool autoTrim)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(xmlData, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				this.clearXml();
				result = (<Module>.ClsXml.LoadXmlX2(this.m_impl, ref xstring, autoTrim) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetNthChildWithTag2(string tag, int n)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.GetNthChildWithTag2(this.m_impl, <Module>.XString.getAnsi(ref xstring), n) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int GetChildIntValue(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				int num;
				if (<Module>.ClsXml.GetChildIntValueX(this.m_impl, ref xstring, ref num) == null)
				{
					goto IL_52;
				}
				Monitor.Exit(Xml.m_lockImpl);
				result = num;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_52:
			try
			{
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return 0;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasChildWithTag(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.HasChildWithTagX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool ZipContent()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.ZipContent(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool UnzipContent()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.UnzipContent(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool ZipTree()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.ZipTree(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool UnzipTree()
		{
			Monitor.Enter(Xml.m_lockImpl);
			bool result = <Module>.ClsXml.UnzipTree(this.m_impl) != null;
			Monitor.Exit(Xml.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool EncryptContent(string password)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(password, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.EncryptContentX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DecryptContent(string password)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(password, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.DecryptContentX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void RemoveFromTree()
		{
			Monitor.Enter(Xml.m_lockImpl);
			<Module>.ClsXml.RemoveFromTree(this.m_impl);
			Monitor.Exit(Xml.m_lockImpl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool QEncodeContent(string charset, byte[] inData)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					result = (<Module>.ClsXml.QEncodeContentX(this.m_impl, ref xstring, ref dataBuffer) != null);
					CkMarshal.free(ptr);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool BEncodeContent(string charset, byte[] inData)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(charset, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					result = (<Module>.ClsXml.BEncodeContentX(this.m_impl, ref xstring, ref dataBuffer) != null);
					CkMarshal.free(ptr);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] DecodeContent()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				Monitor.Enter(Xml.m_lockImpl);
				bool flag = <Module>.ClsXml.DecodeContent(this.m_impl, ref dataBuffer) != null;
				Monitor.Exit(Xml.m_lockImpl);
				if (!flag)
				{
					<Module>.DataBuffer.clear(ref dataBuffer);
				}
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UpdateAttribute(string attrName, string attrValue)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(attrName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(attrValue, &xstring2);
					result = (<Module>.ClsXml.UpdateAttributeX(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void UpdateChildContent(string tag, string value)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					<Module>.ClsXml.UpdateChildContentX(this.m_impl, ref xstring, ref xstring2);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UpdateAttributeInt(string attrName, int value)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(attrName, &xstring);
				result = (<Module>.ClsXml.UpdateAttributeIntX(this.m_impl, ref xstring, value) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void UpdateChildContentInt(string tag, int value)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				<Module>.ClsXml.UpdateChildContentIntX(this.m_impl, ref xstring, value);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ContentMatches(string pattern, [MarshalAs(UnmanagedType.U1)] bool caseSensitive)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				result = (<Module>.ClsXml.ContentMatchesX(this.m_impl, ref xstring, caseSensitive) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ChildContentMatches(string tag, string pattern, [MarshalAs(UnmanagedType.U1)] bool caseSensitive)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pattern, &xstring2);
					result = (<Module>.ClsXml.ChildContentMatchesX(this.m_impl, ref xstring, ref xstring2, caseSensitive) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBinaryContent(byte[] inData, [MarshalAs(UnmanagedType.U1)] bool zipFlag, [MarshalAs(UnmanagedType.U1)] bool encryptFlag, string password)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(password, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					result = (<Module>.ClsXml.SetBinaryContentX(this.m_impl, ref dataBuffer, zipFlag, encryptFlag, ref xstring) != null);
					CkMarshal.free(ptr);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SetBinaryContentFromFile(string filename, [MarshalAs(UnmanagedType.U1)] bool zipFlag, [MarshalAs(UnmanagedType.U1)] bool encryptFlag, string password)
		{
			Monitor.Enter(Xml.m_lockImpl);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(password, &xstring2);
					result = (<Module>.ClsXml.SetBinaryContentFromFileX(this.m_impl, ref xstring, zipFlag, encryptFlag, ref xstring2) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] GetBinaryContent([MarshalAs(UnmanagedType.U1)] bool unzipFlag, [MarshalAs(UnmanagedType.U1)] bool decryptFlag, string password)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			byte[] result;
			try
			{
				CkMarshal.StringToX(password, &xstring);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					Monitor.Enter(Xml.m_lockImpl);
					bool flag = <Module>.ClsXml.GetBinaryContentX(this.m_impl, ref dataBuffer, unzipFlag, decryptFlag, ref xstring) != null;
					Monitor.Exit(Xml.m_lockImpl);
					if (!flag)
					{
						<Module>.DataBuffer.clear(ref dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveBinaryContent(string filename, [MarshalAs(UnmanagedType.U1)] bool unzipFlag, [MarshalAs(UnmanagedType.U1)] bool decryptFlag, string password)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(password, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					result = (<Module>.ClsXml.SaveBinaryContentX(this.m_impl, ref xstring, unzipFlag, decryptFlag, ref xstring2) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void SortByTag([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			Monitor.Enter(Xml.m_lockImpl);
			int num = ascending ? 1 : 0;
			<Module>.ClsXml.SortByTag(this.m_impl, num);
			Monitor.Exit(Xml.m_lockImpl);
		}

		public void SortByContent([MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			Monitor.Enter(Xml.m_lockImpl);
			int num = ascending ? 1 : 0;
			<Module>.ClsXml.SortByContent(this.m_impl, num);
			Monitor.Exit(Xml.m_lockImpl);
		}

		public unsafe void SortByAttribute(string attrName, [MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(attrName, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				int num = ascending ? 1 : 0;
				<Module>.ClsXml.SortByAttributeX(this.m_impl, ref xstring, num);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void SortByAttributeInt(string attrName, [MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(attrName, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				int num = ascending ? 1 : 0;
				<Module>.ClsXml.SortByAttributeInt(this.m_impl, <Module>.XString.getUtf8(ref xstring), num);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void NewChildInt2(string tag, int value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.NewChildInt2(this.m_impl, ref xstring, value);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void SortRecordsByContent(string sortTag, [MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(sortTag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				int num = ascending ? 1 : 0;
				<Module>.ClsXml.SortRecordsByContentX(this.m_impl, ref xstring, num);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void SortRecordsByAttribute(string sortTag, string attrName, [MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(sortTag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(attrName, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					int num = ascending ? 1 : 0;
					<Module>.ClsXml.SortRecordsByAttributeX(this.m_impl, ref xstring, ref xstring2, num);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe Xml FindNextRecord(string tag, string contentPattern)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(contentPattern, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					result = null;
					ClsXml* ptr = <Module>.ClsXml.FindNextRecordX(this.m_impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						result = new Xml((void*)ptr);
					}
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void RemoveChild(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.RemoveChildX(this.m_impl, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void Copy(Xml node)
		{
			if (node != null)
			{
				Monitor.Enter(Xml.m_lockImpl);
				ClsXml* impl = node.m_impl;
				if (impl != null)
				{
					<Module>.ClsXml.Copy(this.m_impl, impl);
				}
				Monitor.Exit(Xml.m_lockImpl);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasAttribute(string name)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.HasAttributeX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void AddOrUpdateAttribute(string name, string value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					<Module>.ClsXml.AddOrUpdateAttributeX(this.m_impl, ref xstring, ref xstring2);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void AddOrUpdateAttributeI(string name, int value)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.AddOrUpdateAttributeIX(this.m_impl, ref xstring, value);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void AddToChildContent(string tag, int amount)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.AddToChildContentX(this.m_impl, ref xstring, amount);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void AddToContent(int amount)
		{
			Monitor.Enter(Xml.m_lockImpl);
			<Module>.ClsXml.AddToContent(this.m_impl, amount);
			Monitor.Exit(Xml.m_lockImpl);
		}

		public unsafe void AddToAttribute(string name, int amount)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.AddToAttributeX(this.m_impl, ref xstring, amount);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string GetChildTagByIndex(int index)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(Xml.m_lockImpl);
				uint exceptionCode;
				try
				{
					<Module>.ClsXml.GetChildTagX(this.m_impl, index, ref xstring);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ClsBase.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BD@OODIOLCL@GetChildTagByIndex?$AA@));
							goto IL_85;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				IL_85:
				Monitor.Exit(Xml.m_lockImpl);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string GetChildContentByIndex(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.GetChildContentX(this.m_impl, index, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string AccumulateTagContent(string tag, string skipTags)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(skipTags, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						Monitor.Enter(Xml.m_lockImpl);
						<Module>.ClsXml.AccumulateTagContentX(this.m_impl, ref xstring, ref xstring3, ref xstring2);
						Monitor.Exit(Xml.m_lockImpl);
						result = CkMarshal.XToString(&xstring3);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string DecodeEntities(string str)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(str, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.DecodeEntitiesX(this.m_impl, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void RemoveChildByIndex(int index)
		{
			Monitor.Enter(Xml.m_lockImpl);
			<Module>.ClsXml.RemoveChildByIndex(this.m_impl, index);
			Monitor.Exit(Xml.m_lockImpl);
		}

		public void RemoveAllChildren()
		{
			Monitor.Enter(Xml.m_lockImpl);
			<Module>.ClsXml.RemoveAllChildren(this.m_impl);
			Monitor.Exit(Xml.m_lockImpl);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasChildWithContent(string content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(content, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.HasChildWithContentX(this.m_impl, ref xstring) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool HasChildWithTagAndContent(string tag, string content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(content, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					result = (<Module>.ClsXml.HasChildWithTagAndContentX(this.m_impl, ref xstring, ref xstring2) != null);
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void RemoveChildWithContent(string content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(content, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.RemoveChildWithContentX(this.m_impl, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public int TreeId
		{
			get
			{
				Monitor.Enter(Xml.m_lockImpl);
				int result = <Module>.ClsXml.get_TreeId(this.m_impl);
				Monitor.Exit(Xml.m_lockImpl);
				return result;
			}
		}

		public unsafe string Version
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsXml.get_VersionX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public bool Cdata
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				Monitor.Enter(Xml.m_lockImpl);
				bool result = <Module>.ClsXml.get_Cdata(this.m_impl) != null;
				Monitor.Exit(Xml.m_lockImpl);
				return result;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsXml.put_Cdata(this.m_impl, value);
			}
		}

		public bool SortCaseInsensitive
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsXml.get_SortCaseInsensitive(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsXml.put_SortCaseInsensitive(this.m_impl, value);
			}
		}

		public int NumChildren
		{
			get
			{
				Monitor.Enter(Xml.m_lockImpl);
				int result = <Module>.ClsXml.get_NumChildren(this.m_impl);
				Monitor.Exit(Xml.m_lockImpl);
				return result;
			}
		}

		public int ContentInt
		{
			get
			{
				return <Module>.ClsXml.get_ContentI(this.m_impl);
			}
			set
			{
				<Module>.ClsXml.put_ContentInt(this.m_impl, value);
			}
		}

		public unsafe string Content
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsXml.get_ContentX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsXml.put_ContentX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Tag
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsXml.get_TagX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsXml.put_TagX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int NumAttributes
		{
			get
			{
				return <Module>.ClsXml.get_NumAttributes(this.m_impl);
			}
		}

		public bool Standalone
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ClsXml.get_Standalone(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ClsXml.put_Standalone(this.m_impl, value);
			}
		}

		public unsafe string Encoding
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsXml.get_EncodingX(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsXml.put_EncodingX(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string GetChildTag(int index)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.GetChildTagX(this.m_impl, index, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool GetChildBoolValue(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.getChildBoolValue(this.m_impl, <Module>.XString.getUtf8(ref xstring)) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe Xml GetChildExact(string tag, string content)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			Xml result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(content, &xstring2);
					Monitor.Enter(Xml.m_lockImpl);
					result = null;
					ClsXml* ptr = <Module>.ClsXml.GetChildExactX(this.m_impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						result = new Xml((void*)ptr);
					}
					Monitor.Exit(Xml.m_lockImpl);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool TagEquals(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				result = (<Module>.ClsXml.TagEquals(this.m_impl, <Module>.XString.getUtf8(ref xstring)) != null);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void AddStyleSheet(string styleSheet)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(styleSheet, &xstring);
				Monitor.Enter(Xml.m_lockImpl);
				<Module>.ClsXml.AddStyleSheet(this.m_impl, ref xstring);
				Monitor.Exit(Xml.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void SortRecordsByContentInt(string sortTag, [MarshalAs(UnmanagedType.U1)] bool ascending)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(sortTag, &xstring);
				<Module>.ClsXml.SortRecordsByContentInt(this.m_impl, ref xstring, ascending);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string TagContent(string tag)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(tag, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsXml.TagContent(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe Xml GetSelf()
		{
			ClsXml* ptr = <Module>.ClsXml.GetSelf(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new Xml((void*)ptr);
		}

		public unsafe string DocType
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ClsXml.get_DocType(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ClsXml.put_DocType(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ChilkatPath(string pathCmd)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(pathCmd, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					bool flag = <Module>.ClsXml.ChilkatPath(this.m_impl, ref xstring, ref xstring2) != null;
					if (flag)
					{
						goto IL_5F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_5F:
			string result2;
			try
			{
				XString xstring2;
				try
				{
					result2 = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static object m_lockImpl = new object();

		private unsafe ClsXml* m_impl;
	}
}
