﻿using System;
using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Threading;
using chilkat;

namespace Chilkat
{
	public class Zip : IDisposable
	{
		private void checkCreateImpl()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
		}

		public int GetMyHashCode()
		{
			return this.m_myHashCode;
		}

		public static Zip LookupZip(int hashCode)
		{
			object key = hashCode;
			Monitor.Enter(Zip.m_lockObject);
			Zip result = (Zip)Zip.m_zipObjects[key];
			Monitor.Exit(Zip.m_lockObject);
			return result;
		}

		public void FireWriteZipPercentDone(object sender, WriteZipPercentDoneEventArgs args)
		{
			Zip.WriteZipPercentDoneEventHandler onWriteZipPercentDone = this.OnWriteZipPercentDone;
			if (onWriteZipPercentDone != null)
			{
				onWriteZipPercentDone(sender, args);
			}
		}

		public void FireUnzipPercentDone(object sender, UnzipPercentDoneEventArgs args)
		{
			Zip.UnzipPercentDoneEventHandler onUnzipPercentDone = this.OnUnzipPercentDone;
			if (onUnzipPercentDone != null)
			{
				onUnzipPercentDone(sender, args);
			}
		}

		public void FireToBeAdded(object sender, ToBeAddedEventArgs args)
		{
			Zip.ToBeAddedEventHandler onToBeAdded = this.OnToBeAdded;
			if (onToBeAdded != null)
			{
				onToBeAdded(sender, args);
			}
		}

		public void FireDirToBeAdded(object sender, DirToBeAddedEventArgs args)
		{
			Zip.DirToBeAddedEventHandler onDirToBeAdded = this.OnDirToBeAdded;
			if (onDirToBeAdded != null)
			{
				onDirToBeAdded(sender, args);
			}
		}

		public void FireFileAdded(object sender, FileAddedEventArgs args)
		{
			Zip.FileAddedEventHandler onFileAdded = this.OnFileAdded;
			if (onFileAdded != null)
			{
				onFileAdded(sender, args);
			}
		}

		public void FireToBeZipped(object sender, ToBeZippedEventArgs args)
		{
			Zip.ToBeZippedEventHandler onToBeZipped = this.OnToBeZipped;
			if (onToBeZipped != null)
			{
				onToBeZipped(sender, args);
			}
		}

		public void FireFileZipped(object sender, FileZippedEventArgs args)
		{
			Zip.FileZippedEventHandler onFileZipped = this.OnFileZipped;
			if (onFileZipped != null)
			{
				onFileZipped(sender, args);
			}
		}

		public void FireToBeUnzipped(object sender, ToBeUnzippedEventArgs args)
		{
			Zip.ToBeUnzippedEventHandler onToBeUnzipped = this.OnToBeUnzipped;
			if (onToBeUnzipped != null)
			{
				onToBeUnzipped(sender, args);
			}
		}

		public void FireFileUnzipped(object sender, FileUnzippedEventArgs args)
		{
			Zip.FileUnzippedEventHandler onFileUnzipped = this.OnFileUnzipped;
			if (onFileUnzipped != null)
			{
				onFileUnzipped(sender, args);
			}
		}

		public void FireAddFilesBegin(object sender, EventArgs args)
		{
			Zip.AddFilesBeginEventHandler onAddFilesBegin = this.OnAddFilesBegin;
			if (onAddFilesBegin != null)
			{
				onAddFilesBegin(sender, args);
			}
		}

		public void FireAddFilesEnd(object sender, EventArgs args)
		{
			Zip.AddFilesEndEventHandler onAddFilesEnd = this.OnAddFilesEnd;
			if (onAddFilesEnd != null)
			{
				onAddFilesEnd(sender, args);
			}
		}

		public void FireWriteZipBegin(object sender, EventArgs args)
		{
			Zip.WriteZipBeginEventHandler onWriteZipBegin = this.OnWriteZipBegin;
			if (onWriteZipBegin != null)
			{
				onWriteZipBegin(sender, args);
			}
		}

		public void FireAbortCheck(object sender, AbortCheckEventArgs args)
		{
			Zip.AbortCheckEventHandler onAbortCheck = this.OnAbortCheck;
			if (onAbortCheck != null)
			{
				onAbortCheck(sender, args);
			}
		}

		public void FireWriteZipEnd(object sender, EventArgs args)
		{
			Zip.WriteZipEndEventHandler onWriteZipEnd = this.OnWriteZipEnd;
			if (onWriteZipEnd != null)
			{
				onWriteZipEnd(sender, args);
			}
		}

		public void FireUnzipBegin(object sender, EventArgs args)
		{
			Zip.UnzipBeginEventHandler onUnzipBegin = this.OnUnzipBegin;
			if (onUnzipBegin != null)
			{
				onUnzipBegin(sender, args);
			}
		}

		public void FireUnzipEnd(object sender, EventArgs args)
		{
			Zip.UnzipEndEventHandler onUnzipEnd = this.OnUnzipEnd;
			if (onUnzipEnd != null)
			{
				onUnzipEnd(sender, args);
			}
		}

		public unsafe Zip(void* impl)
		{
			this.m_enableEvents = false;
			this.m_impl = (ZipDn*)impl;
			this.OnWriteZipPercentDone = null;
			this.OnUnzipPercentDone = null;
			this.OnToBeAdded = null;
			this.OnDirToBeAdded = null;
			this.OnFileAdded = null;
			this.OnToBeZipped = null;
			this.OnFileZipped = null;
			this.OnToBeUnzipped = null;
			this.OnFileUnzipped = null;
			this.OnAddFilesBegin = null;
			this.OnAddFilesEnd = null;
			this.OnWriteZipBegin = null;
			this.OnAbortCheck = null;
			this.OnWriteZipEnd = null;
			this.OnUnzipBegin = null;
			this.OnUnzipEnd = null;
			Monitor.Enter(Zip.m_lockObject);
			<Module>.Chilkat.?A0x310f0ede.NextHashCode++;
			this.m_myHashCode = <Module>.Chilkat.?A0x310f0ede.NextHashCode;
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			Monitor.Exit(Zip.m_lockObject);
		}

		public Zip()
		{
			this.m_enableEvents = false;
			this.OnWriteZipPercentDone = null;
			this.OnUnzipPercentDone = null;
			this.OnToBeAdded = null;
			this.OnDirToBeAdded = null;
			this.OnFileAdded = null;
			this.OnToBeZipped = null;
			this.OnFileZipped = null;
			this.OnToBeUnzipped = null;
			this.OnFileUnzipped = null;
			this.OnAddFilesBegin = null;
			this.OnAddFilesEnd = null;
			this.OnWriteZipBegin = null;
			this.OnAbortCheck = null;
			this.OnWriteZipEnd = null;
			this.OnUnzipBegin = null;
			this.OnUnzipEnd = null;
			Monitor.Enter(Zip.m_lockObject);
			this.m_lockImpl = new object();
			<Module>.Chilkat.?A0x310f0ede.NextHashCode++;
			this.m_myHashCode = <Module>.Chilkat.?A0x310f0ede.NextHashCode;
			this.m_impl = null;
			this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			Monitor.Exit(Zip.m_lockObject);
		}

		protected unsafe override void Finalize()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			Monitor.Enter(Zip.m_lockObject);
			ZipDn* impl = this.m_impl;
			if (impl != null)
			{
				ZipDn* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
			uint exceptionCode;
			try
			{
				Zip.m_zipObjects.Remove(this);
			}
			catch when (delegate
			{
				// Failed to create a 'catch-when' expression
				exceptionCode = (uint)Marshal.GetExceptionCode();
				endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
			})
			{
				uint num2 = 0U;
				<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
				try
				{
					try
					{
						goto IL_89;
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
						endfilter(num2 != 0U);
					})
					{
					}
					if (num2 != 0U)
					{
						throw;
					}
				}
				finally
				{
					<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
				}
			}
			IL_89:
			Monitor.Exit(Zip.m_lockObject);
		}

		public virtual void Dispose()
		{
			Monitor.Enter(Zip.m_lockObject);
			Zip.m_zipObjects.Remove(this);
			Monitor.Exit(Zip.m_lockObject);
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString* ptr = <Module>.@new(136U);
				XString* ptr2;
				try
				{
					if (ptr != null)
					{
						ptr2 = <Module>.XString.{ctor}(ptr);
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				ZipDn* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ZipDn.GetLogText(impl, ptr2, true);
				}
				string result = CkMarshal.XToString(ptr2);
				if (ptr2 != null)
				{
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
				}
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString* ptr = <Module>.@new(136U);
				XString* ptr2;
				try
				{
					if (ptr != null)
					{
						ptr2 = <Module>.XString.{ctor}(ptr);
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				ZipDn* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ZipDn.GetLogXml(impl, ptr2, true);
				}
				string result = CkMarshal.XToString(ptr2);
				if (ptr2 != null)
				{
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
				}
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString* ptr = <Module>.@new(136U);
				XString* ptr2;
				try
				{
					if (ptr != null)
					{
						ptr2 = <Module>.XString.{ctor}(ptr);
					}
					else
					{
						ptr2 = 0;
					}
				}
				catch
				{
					<Module>.delete((void*)ptr);
					throw;
				}
				ZipDn* impl = this.m_impl;
				if (impl != null)
				{
					<Module>.ZipDn.GetLogHtml(impl, ptr2, true);
				}
				string result = CkMarshal.XToString(ptr2);
				if (ptr2 != null)
				{
					object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr2, 1, *(*ptr2));
				}
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				ZipDn* impl = this.m_impl;
				if (impl != null)
				{
					goto IL_35;
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return false;
			IL_35:
			bool result;
			try
			{
				ZipDn* impl;
				result = (<Module>.ZipDn.SaveXmlLog(impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool PasswordProtect
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_PasswordProtect(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_PasswordProtect(this.m_impl, value);
			}
		}

		public bool HasZipFormatErrors
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_HasZipFormatErrors(this.m_impl) != null;
			}
		}

		public int Encryption
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_Encryption(this.m_impl);
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_Encryption(this.m_impl, value);
			}
		}

		public int EncryptKeyLength
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_EncryptKeyLength(this.m_impl);
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_EncryptKeyLength(this.m_impl, value);
			}
		}

		public int OemCodePage
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_OemCodePage(this.m_impl);
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_OemCodePage(this.m_impl, value);
			}
		}

		public unsafe string Version
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				StringBuffer stringBuffer;
				<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
				string result;
				try
				{
					<Module>.ZipDn.get_Version(this.m_impl, ref stringBuffer);
					result = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
					throw;
				}
				<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
				return result;
			}
		}

		public unsafe string TempDir
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_TempDir(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_TempDir(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string AppendFromDir
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_AppendFromDir(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_AppendFromDir(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string DecryptPassword
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_DecryptPassword(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_DecryptPassword(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string EncryptPassword
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_EncryptPassword(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_EncryptPassword(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int NumEntries
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_NumEntries(this.m_impl);
			}
		}

		public int FileCount
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_FileCount(this.m_impl);
			}
		}

		public unsafe string FileName
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_FileName(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_FileName(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Comment
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_Comment(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_Comment(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string Proxy
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_Proxy(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_Proxy(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool AutoTemp
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_AutoTemp(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_AutoTemp(this.m_impl, value);
			}
		}

		public bool ClearArchiveAttribute
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_ClearArchiveAttribute(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_ClearArchiveAttribute(this.m_impl, value);
			}
		}

		public bool TextFlag
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_TextFlag(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_TextFlag(this.m_impl, value);
			}
		}

		public bool DiscardPaths
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_DiscardPaths(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_DiscardPaths(this.m_impl, value);
			}
		}

		public unsafe string PathPrefix
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_PathPrefix(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_PathPrefix(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string AutoRun
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_AutoRun(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_AutoRun(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ExeUnzipDir
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_ExeUnzipDir(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_ExeUnzipDir(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ExeTitle
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_ExeTitle(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_ExeTitle(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ExeUnzipCaption
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_ExeUnzipCaption(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_ExeUnzipCaption(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ExeIconFile
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_ExeIconFile(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_ExeIconFile(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string AutoRunParams
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_AutoRunParams(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_AutoRunParams(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public bool ExeNoInterface
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_ExeNoInterface(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_ExeNoInterface(this.m_impl, value);
			}
		}

		public bool ExeWaitForSetup
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_ExeWaitForSetup(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_ExeWaitForSetup(this.m_impl, value);
			}
		}

		public bool ExeSilentProgress
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_ExeSilentProgress(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_ExeSilentProgress(this.m_impl, value);
			}
		}

		public bool ExeFinishNotifier
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_ExeFinishNotifier(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_ExeFinishNotifier(this.m_impl, value);
			}
		}

		public unsafe string ExeDefaultDir
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_ExeDefaultDir(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_ExeDefaultDir(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteExe(string exeFilename)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xstring);
				result = false;
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					uint exceptionCode;
					try
					{
						result = (<Module>.ZipDn.WriteExe(this.m_impl, ref xstring, (ZipCallback*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08NAFNOBNK@WriteExe?$AA@));
								goto IL_EC;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_EC:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteExe2(string inExeFilename, string outExeFilename, [MarshalAs(UnmanagedType.U1)] bool bEncrypt, int keyLength, string password)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(inExeFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(outExeFilename, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(password, &xstring3);
						result = false;
						_ZipCallback zipCallback;
						<Module>.ZipCallback.{ctor}(ref zipCallback);
						try
						{
							zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
							*(ref zipCallback + 8) = 0;
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
							throw;
						}
						try
						{
							_ZipCallback* ptr = null;
							if (this.m_enableEvents)
							{
								ptr = &zipCallback;
								*(ref zipCallback + 8) = this.m_myHashCode;
							}
							uint exceptionCode;
							try
							{
								result = (<Module>.ZipDn.WriteExe2(this.m_impl, ref xstring, ref xstring2, bEncrypt, keyLength, ref xstring3, (ZipCallback*)ptr) != null);
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								exceptionCode = (uint)Marshal.GetExceptionCode();
								endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
							})
							{
								uint num2 = 0U;
								<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
								try
								{
									try
									{
										<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_09ILKGDCFK@WriteExe2?$AA@));
										goto IL_114;
									}
									catch when (delegate
									{
										// Failed to create a 'catch-when' expression
										num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
										endfilter(num2 != 0U);
									})
									{
									}
									if (num2 != 0U)
									{
										throw;
									}
								}
								finally
								{
									<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
								}
							}
						}
						catch
						{
							<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
							throw;
						}
						IL_114:
						zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
						<Module>.ZipCallback.{dtor}(ref zipCallback);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe ZipEntry FirstEntry()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			Monitor.Enter(this.m_lockImpl);
			ZipEntryDn* ptr = <Module>.ZipDn.FirstEntry(this.m_impl);
			Monitor.Exit(this.m_lockImpl);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractOne(ZipEntry entry, string dirPath)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				if (entry != null)
				{
					goto IL_36;
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return false;
			IL_36:
			bool result;
			try
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					ZipEntryDn* implementation = (ZipEntryDn*)entry.GetImplementation();
					uint exceptionCode;
					try
					{
						result = (<Module>.ZipEntryDn.Extract(implementation, ref xstring, (ProgressEvent*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0L@KDIEHHOP@ExtractOne?$AA@));
								goto IL_10A;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_10A:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void ExcludeDir(string dirName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(dirName, &xstring);
				<Module>.ZipDn.ExcludeDir(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void SetCompressionLevel(int level)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			<Module>.ZipDn.SetCompressionLevel(this.m_impl, level);
		}

		public unsafe void SetExeConfigParam(string name, string value)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(value, &xstring2);
					<Module>.ZipDn.SetExeConfigParam(this.m_impl, ref xstring, ref xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe string GetExeConfigParam(string name)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(name, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ZipDn.GetExeConfigParam(this.m_impl, ref xstring, ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string ExeSourceUrl
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_ExeSourceUrl(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_ExeSourceUrl(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public unsafe string ExeXmlConfig
		{
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipDn.get_ExeXmlConfig(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipDn.put_ExeXmlConfig(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsPasswordProtected(string zipFilename)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(zipFilename, &xstring);
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ZipDn.IsPasswordProtected(this.m_impl, ref xstring) != null);
				Monitor.Exit(this.m_lockImpl);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFromMemory(byte[] inData)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				Monitor.Enter(this.m_lockImpl);
				result = (<Module>.ZipDn.OpenFromMemory(this.m_impl, <Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer)) != null);
				Monitor.Exit(this.m_lockImpl);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenEmbedded(string exeFilename, string resourceName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(resourceName, &xstring2);
					result = (<Module>.ZipDn.OpenEmbedded(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenMyEmbedded(string resourceName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(resourceName, &xstring);
				result = (<Module>.ZipDn.OpenMyEmbedded(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AddEmbedded(string exeFilename, string resourceName, string zipFilename)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(resourceName, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(zipFilename, &xstring3);
						result = (<Module>.ZipDn.AddEmbedded(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ReplaceEmbedded(string exeFilename, string resourceName, string zipFilename)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(resourceName, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(zipFilename, &xstring3);
						result = (<Module>.ZipDn.ReplaceEmbedded(this.m_impl, ref xstring, ref xstring2, ref xstring3) != null);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool RemoveEmbedded(string exeFilename, string resourceName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(exeFilename, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(resourceName, &xstring2);
					result = (<Module>.ZipDn.RemoveEmbedded(this.m_impl, ref xstring, ref xstring2) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe void SetPassword(string password)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(password, &xstring);
				<Module>.ZipDn.SetPassword(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public void SetExclusions(StringArray excludePatterns)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			<Module>.ZipDn.SetExclusions(this.m_impl, excludePatterns.GetImplementation());
		}

		public unsafe StringArray GetExclusions()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			ClsStringArray* ptr = <Module>.ZipDn.GetExclusions(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new StringArray((void*)ptr);
		}

		public unsafe ZipEntry FirstMatchingEntry(string pattern)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(pattern, &xstring);
				ZipEntryDn* ptr = <Module>.ZipDn.FirstMatchingEntry(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_52;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_52:
			ZipEntry result2;
			try
			{
				ZipEntryDn* ptr;
				result2 = new ZipEntry((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe string GetDirectoryAsXML()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				<Module>.ZipDn.GetDirectoryAsXML(this.m_impl, ref xstring);
				result = CkMarshal.XToString(&xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractMatching(string dirPath, string pattern)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pattern, &xstring2);
					_ZipCallback zipCallback;
					<Module>.ZipCallback.{ctor}(ref zipCallback);
					try
					{
						zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
						*(ref zipCallback + 8) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
						throw;
					}
					try
					{
						_ZipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &zipCallback;
							*(ref zipCallback + 8) = this.m_myHashCode;
						}
						uint exceptionCode;
						try
						{
							result = (<Module>.ZipDn.ExtractMatching(this.m_impl, ref xstring, ref xstring2, (ZipCallback*)ptr) != null);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BA@PMNLLG@ExtractMatching?$AA@));
									goto IL_FC;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
						throw;
					}
					IL_FC:
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					<Module>.ZipCallback.{dtor}(ref zipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe ZipEntry GetEntryByID(int entryID)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			ZipEntryDn* ptr = <Module>.ZipDn.GetEntryByID(this.m_impl, entryID);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteZip()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			_ZipCallback zipCallback;
			<Module>.ZipCallback.{ctor}(ref zipCallback);
			try
			{
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				*(ref zipCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			bool result;
			try
			{
				_ZipCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &zipCallback;
					*(ref zipCallback + 8) = this.m_myHashCode;
				}
				uint exceptionCode;
				try
				{
					result = (<Module>.ZipDn.WriteZip(this.m_impl, (ZipCallback*)ptr) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_08PCHGIJEA@WriteZip?$AA@));
							goto IL_D8;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			IL_D8:
			zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
			<Module>.ZipCallback.{dtor}(ref zipCallback);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool WriteZipAndClose()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			_ZipCallback zipCallback;
			<Module>.ZipCallback.{ctor}(ref zipCallback);
			try
			{
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				*(ref zipCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			bool result;
			try
			{
				_ZipCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &zipCallback;
					*(ref zipCallback + 8) = this.m_myHashCode;
				}
				result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ZipDn.WriteZipAndClose(this.m_impl, (ZipCallback*)ptr) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BB@FAJLABCG@WriteZipAndClose?$AA@));
							goto IL_D7;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			IL_D7:
			zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
			<Module>.ZipCallback.{dtor}(ref zipCallback);
			return result;
		}

		public unsafe byte[] WriteToMemory()
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				bool flag = false;
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					uint exceptionCode;
					try
					{
						flag = (<Module>.ZipDn.WriteToMemory(this.m_impl, ref dataBuffer, (ZipCallback*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0O@IKBLJEGD@WriteToMemory?$AA@));
								goto IL_D4;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
					IL_D4:
					if (!flag)
					{
						<Module>.DataBuffer.clear(ref dataBuffer);
					}
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool QuickAppend(string ZipFileName)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(ZipFileName, &xstring);
				result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ZipDn.QuickAppend(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0M@DGLACDAP@QuickAppend?$AA@));
							goto IL_A8;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			IL_A8:
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenZip(string ZipFileName)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(ZipFileName, &xstring);
				result = false;
				uint exceptionCode;
				try
				{
					result = (<Module>.ZipDn.OpenZip(this.m_impl, ref xstring) != null);
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_07DELKBBKG@OpenZip?$AA@));
							goto IL_A8;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			IL_A8:
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool NewZip(string ZipFileName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(ZipFileName, &xstring);
				result = (<Module>.ZipDn.NewZip(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public void CloseZip()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			<Module>.ZipDn.CloseZip(this.m_impl);
		}

		public unsafe ZipEntry GetEntryByName(string entryName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(entryName, &xstring);
				ZipEntryDn* ptr = <Module>.ZipDn.GetEntryByName(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_52;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_52:
			ZipEntry result2;
			try
			{
				ZipEntryDn* ptr;
				result2 = new ZipEntry((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry GetEntryByIndex(int index)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			ZipEntryDn* ptr = <Module>.ZipDn.GetEntryByIndex(this.m_impl, index);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry((void*)ptr);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool DeleteEntry(ZipEntry entry)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			if (entry == null)
			{
				return false;
			}
			ZipEntryDn* implementation = (ZipEntryDn*)entry.GetImplementation();
			Monitor.Enter(this.m_lockImpl);
			bool result = <Module>.ZipDn.DeleteEntry(this.m_impl, implementation) != null;
			Monitor.Exit(this.m_lockImpl);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Extract(string dirPath)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = (<Module>.ZipDn.Extract(this.m_impl, ref xstring, (ZipCallback*)ptr) != null);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractInto(string dirPath)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = false;
					uint exceptionCode;
					try
					{
						result = (<Module>.ZipDn.ExtractInto(this.m_impl, ref xstring, (ZipCallback*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0M@EANHDABB@ExtractInto?$AA@));
								goto IL_E9;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_E9:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractNewer(string dirPath)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = false;
					uint exceptionCode;
					try
					{
						result = (<Module>.ZipDn.ExtractNewer(this.m_impl, ref xstring, (ZipCallback*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0N@CAOMHCH@ExtractNewer?$AA@));
								goto IL_E9;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_E9:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendZip(string zipFileName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(zipFileName, &xstring);
				result = (<Module>.ZipDn.AppendZip(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFromWeb(string url)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(url, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = false;
					uint exceptionCode;
					try
					{
						result = (<Module>.ZipDn.OpenFromWeb(this.m_impl, ref xstring, (ProgressEvent*)ptr) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0M@NIJIOFAO@OpenFromWeb?$AA@));
								goto IL_E9;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_E9:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFilesEx(string filePattern, [MarshalAs(UnmanagedType.U1)] bool recurse, [MarshalAs(UnmanagedType.U1)] bool saveExtraPath, [MarshalAs(UnmanagedType.U1)] bool archiveOnly, [MarshalAs(UnmanagedType.U1)] bool includeHidden, [MarshalAs(UnmanagedType.U1)] bool includeSystem)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filePattern, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = false;
					uint exceptionCode;
					try
					{
						int num2;
						result = (<Module>.ZipDn.AppendFilesEx(this.m_impl, ref xstring, recurse, saveExtraPath, archiveOnly, includeHidden, includeSystem, (ZipCallback*)ptr, ref num2) != null);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num3 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0O@LEGLPFDJ@AppendFilesEx?$AA@));
								goto IL_F3;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num3 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num3 != 0U);
							})
							{
							}
							if (num3 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num3);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_F3:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendFiles(string filePattern, [MarshalAs(UnmanagedType.U1)] bool recurse)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			Monitor.Enter(Zip.m_lockObject);
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filePattern, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					int num;
					result = (<Module>.ZipDn.AppendFiles(this.m_impl, ref xstring, recurse, (ZipCallback*)ptr, ref num) != null);
					Monitor.Exit(Zip.m_lockObject);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendOneFileOrDir(string fileOrDirName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileOrDirName, &xstring);
				result = (<Module>.ZipDn.AppendOneFileOrDir(this.m_impl, ref xstring, false) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendOneFileOrDir(string fileOrDirName, [MarshalAs(UnmanagedType.U1)] bool saveExtraPath)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileOrDirName, &xstring);
				result = (<Module>.ZipDn.AppendOneFileOrDir(this.m_impl, ref xstring, saveExtraPath) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendMultiple(StringArray fileSpecs, [MarshalAs(UnmanagedType.U1)] bool recurse)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			if (fileSpecs == null)
			{
				return false;
			}
			_ZipCallback zipCallback;
			<Module>.ZipCallback.{ctor}(ref zipCallback);
			try
			{
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				*(ref zipCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			bool result;
			try
			{
				_ZipCallback* ptr = null;
				if (this.m_enableEvents)
				{
					ptr = &zipCallback;
					*(ref zipCallback + 8) = this.m_myHashCode;
				}
				ClsStringArray* implementation = fileSpecs.GetImplementation();
				int num;
				result = (<Module>.ZipDn.AppendMultiple(this.m_impl, implementation, recurse, (ZipCallback*)ptr, ref num) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
			<Module>.ZipCallback.{dtor}(ref zipCallback);
			return result;
		}

		public unsafe ZipEntry AppendData(string fileName, byte[] inData)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					ZipEntryDn* ptr2 = <Module>.ZipDn.AppendData(this.m_impl, ref xstring, ref dataBuffer);
					CkMarshal.free(ptr);
					if (ptr2 != null)
					{
						goto IL_8F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_8F:
			ZipEntry result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					ZipEntryDn* ptr2;
					result2 = new ZipEntry((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendString2(string fileName, string str, string charset)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(str, &xstring2);
					XString xstring3;
					<Module>.XString.{ctor}(ref xstring3);
					try
					{
						CkMarshal.StringToX(charset, &xstring3);
						ZipEntryDn* ptr = <Module>.ZipDn.AppendString2(this.m_impl, ref xstring, ref xstring2, ref xstring3);
						if (ptr != null)
						{
							goto IL_A4;
						}
						result = null;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_A4:
			ZipEntry result2;
			try
			{
				XString xstring2;
				try
				{
					XString xstring3;
					try
					{
						ZipEntryDn* ptr;
						result2 = new ZipEntry((void*)ptr);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring3));
						throw;
					}
					<Module>.XString.{dtor}(ref xstring3);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendUnicode(string fileName, string str)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(str, &xstring2);
					ZipEntryDn* ptr = <Module>.ZipDn.AppendUnicode(this.m_impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_7B;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_7B:
			ZipEntry result2;
			try
			{
				XString xstring2;
				try
				{
					ZipEntryDn* ptr;
					result2 = new ZipEntry((void*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendAnsi(string fileName, string str)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(str, &xstring2);
					ZipEntryDn* ptr = <Module>.ZipDn.AppendAnsi(this.m_impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_7B;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_7B:
			ZipEntry result2;
			try
			{
				XString xstring2;
				try
				{
					ZipEntryDn* ptr;
					result2 = new ZipEntry((void*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendData2(string fileName, byte[] inData, uint numBytes)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				int num = numBytes;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, numBytes);
					ZipEntryDn* ptr2 = <Module>.ZipDn.AppendData(this.m_impl, ref xstring, ref dataBuffer);
					CkMarshal.free(ptr);
					if (ptr2 != null)
					{
						goto IL_8E;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_8E:
			ZipEntry result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					ZipEntryDn* ptr2;
					result2 = new ZipEntry((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendNew(string fileName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				ZipEntryDn* ptr = <Module>.ZipDn.AppendNew(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_52;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_52:
			ZipEntry result2;
			try
			{
				ZipEntryDn* ptr;
				result2 = new ZipEntry((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendNewDir(string dirName)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(dirName, &xstring);
				ZipEntryDn* ptr = <Module>.ZipDn.AppendNewDir(this.m_impl, ref xstring);
				if (ptr != null)
				{
					goto IL_52;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_52:
			ZipEntry result2;
			try
			{
				ZipEntryDn* ptr;
				result2 = new ZipEntry((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry InsertNew(string fileName, int beforeIndex)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				ZipEntryDn* ptr = <Module>.ZipDn.InsertNew(this.m_impl, ref xstring, beforeIndex);
				if (ptr != null)
				{
					goto IL_53;
				}
				result = null;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_53:
			ZipEntry result2;
			try
			{
				ZipEntryDn* ptr;
				result2 = new ZipEntry((void*)ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendCompressed(string fileName, byte[] inData)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				int num = 0;
				void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
					ZipEntryDn* ptr2 = <Module>.ZipDn.AppendCompressed(this.m_impl, ref xstring, ref dataBuffer);
					CkMarshal.free(ptr);
					if (ptr2 != null)
					{
						goto IL_8F;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_8F:
			ZipEntry result2;
			try
			{
				DataBuffer dataBuffer;
				try
				{
					ZipEntryDn* ptr2;
					result2 = new ZipEntry((void*)ptr2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendHex(string fileName, string encodedCompressedData)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(encodedCompressedData, &xstring2);
					ZipEntryDn* ptr = <Module>.ZipDn.AppendHexX(this.m_impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_7B;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_7B:
			ZipEntry result2;
			try
			{
				XString xstring2;
				try
				{
					ZipEntryDn* ptr;
					result2 = new ZipEntry((void*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		public unsafe ZipEntry AppendBase64(string fileName, string encodedCompressedData)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(encodedCompressedData, &xstring2);
					ZipEntryDn* ptr = <Module>.ZipDn.AppendBase64X(this.m_impl, ref xstring, ref xstring2);
					if (ptr != null)
					{
						goto IL_7B;
					}
					result = null;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
			IL_7B:
			ZipEntry result2;
			try
			{
				XString xstring2;
				try
				{
					ZipEntryDn* ptr;
					result2 = new ZipEntry((void*)ptr);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result2;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool UnlockComponent(string regCode)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(regCode, &xstring);
				result = (<Module>.ZipDn.UnlockComponentX(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool IsUnlocked()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			return <Module>.ZipDn.IsUnlocked(this.m_impl) != null;
		}

		public unsafe int Unzip(string dirPath)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = -1;
					uint exceptionCode;
					try
					{
						result = <Module>.ZipDn.Unzip(this.m_impl, ref xstring, (ZipCallback*)ptr);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_05FIMHMHJF@Unzip?$AA@));
								goto IL_E9;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_E9:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int UnzipInto(string dirPath)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = -1;
					uint exceptionCode;
					try
					{
						result = <Module>.ZipDn.UnzipInto(this.m_impl, ref xstring, (ZipCallback*)ptr);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_09MAPCAEPA@UnzipInto?$AA@));
								goto IL_E9;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_E9:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int UnzipNewer(string dirPath)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				_ZipCallback zipCallback;
				<Module>.ZipCallback.{ctor}(ref zipCallback);
				try
				{
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					*(ref zipCallback + 8) = 0;
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				try
				{
					_ZipCallback* ptr = null;
					if (this.m_enableEvents)
					{
						ptr = &zipCallback;
						*(ref zipCallback + 8) = this.m_myHashCode;
					}
					result = -1;
					uint exceptionCode;
					try
					{
						result = <Module>.ZipDn.UnzipNewer(this.m_impl, ref xstring, (ZipCallback*)ptr);
					}
					catch when (delegate
					{
						// Failed to create a 'catch-when' expression
						exceptionCode = (uint)Marshal.GetExceptionCode();
						endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
					})
					{
						uint num2 = 0U;
						<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
						try
						{
							try
							{
								<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0L@NFIDDAPN@UnzipNewer?$AA@));
								goto IL_E9;
							}
							catch when (delegate
							{
								// Failed to create a 'catch-when' expression
								num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
								endfilter(num2 != 0U);
							})
							{
							}
							if (num2 != 0U)
							{
								throw;
							}
						}
						finally
						{
							<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
						}
					}
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
					throw;
				}
				IL_E9:
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				<Module>.ZipCallback.{dtor}(ref zipCallback);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int UnzipMatching(string dirPath, string pattern, [MarshalAs(UnmanagedType.U1)] bool verbose)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pattern, &xstring2);
					_ZipCallback zipCallback;
					<Module>.ZipCallback.{ctor}(ref zipCallback);
					try
					{
						zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
						*(ref zipCallback + 8) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
						throw;
					}
					try
					{
						_ZipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &zipCallback;
							*(ref zipCallback + 8) = this.m_myHashCode;
						}
						result = -1;
						uint exceptionCode;
						try
						{
							result = <Module>.ZipDn.UnzipMatching(this.m_impl, ref xstring, ref xstring2, verbose, (ZipCallback*)ptr);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0O@EIBGODGA@UnzipMatching?$AA@));
									goto IL_FC;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
						throw;
					}
					IL_FC:
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					<Module>.ZipCallback.{dtor}(ref zipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe int UnzipMatchingInto(string dirPath, string pattern, [MarshalAs(UnmanagedType.U1)] bool verbose)
		{
			int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			int result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(pattern, &xstring2);
					_ZipCallback zipCallback;
					<Module>.ZipCallback.{ctor}(ref zipCallback);
					try
					{
						zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
						*(ref zipCallback + 8) = 0;
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
						throw;
					}
					try
					{
						_ZipCallback* ptr = null;
						if (this.m_enableEvents)
						{
							ptr = &zipCallback;
							*(ref zipCallback + 8) = this.m_myHashCode;
						}
						result = -1;
						uint exceptionCode;
						try
						{
							result = <Module>.ZipDn.UnzipMatchingInto(this.m_impl, ref xstring, ref xstring2, verbose, (ZipCallback*)ptr);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									<Module>.ZipDn.CreateExceptionLog(this.m_impl, (sbyte*)(&<Module>.??_C@_0BC@MLJKOIGD@UnzipMatchingInto?$AA@));
									goto IL_FC;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
						throw;
					}
					IL_FC:
					zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
					<Module>.ZipCallback.{dtor}(ref zipCallback);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe bool EnableEvents
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return this.m_enableEvents;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				if (value != this.m_enableEvents)
				{
					Monitor.Enter(Zip.m_lockObject);
					if (value)
					{
						if (Zip.m_zipObjects == null)
						{
							Zip.m_zipObjects = new Hashtable();
						}
						uint exceptionCode;
						try
						{
							object key = this.m_myHashCode;
							Zip.m_zipObjects.Add(key, this);
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							exceptionCode = (uint)Marshal.GetExceptionCode();
							endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
						})
						{
							uint num2 = 0U;
							<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
							try
							{
								try
								{
									object key2 = this.m_myHashCode;
									Zip.m_zipObjects = new Hashtable();
									Zip.m_zipObjects.Add(key2, this);
									goto IL_CE;
								}
								catch when (delegate
								{
									// Failed to create a 'catch-when' expression
									num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
									endfilter(num2 != 0U);
								})
								{
								}
								if (num2 != 0U)
								{
									throw;
								}
							}
							finally
							{
								<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
							}
						}
					}
					else
					{
						Zip.m_zipObjects.Remove(this);
					}
					IL_CE:
					this.m_enableEvents = value;
					Monitor.Exit(Zip.m_lockObject);
				}
			}
		}

		public unsafe ZipEntry AppendString(string fileName, string str)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			ZipEntry result;
			try
			{
				CkMarshal.StringToX(fileName, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					CkMarshal.StringToX(str, &xstring2);
					result = new ZipEntry(<Module>.ZipDn.AppendData(this.m_impl, ref xstring, <Module>.XString.getAnsi(ref xstring2), <Module>.XString.getSizeAnsi(ref xstring2)));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool OpenFromByteData(byte[] byteData)
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(byteData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				result = (<Module>.ZipDn.OpenFromMemory(this.m_impl, <Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer)) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public bool CaseSensitive
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				return <Module>.ZipDn.get_CaseSensitive(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				if (this.m_impl == null)
				{
					this.m_impl = <Module>.ZipDn.CreateZipDn(2);
				}
				<Module>.ZipDn.put_CaseSensitive(this.m_impl, value);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public bool VerifyPassword()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			return <Module>.ZipDn.VerifyPassword(this.m_impl) != null;
		}

		public unsafe byte[] WriteExeToMemory()
		{
			if (this.m_impl == null)
			{
				this.m_impl = <Module>.ZipDn.CreateZipDn(2);
			}
			_ZipCallback zipCallback;
			<Module>.ZipCallback.{ctor}(ref zipCallback);
			try
			{
				zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
				*(ref zipCallback + 8) = 0;
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			byte[] result;
			try
			{
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.ZipDn.WriteExeToMemory(this.m_impl, ref dataBuffer, null);
					result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(Chilkat._ZipCallback.{dtor}), (void*)(&zipCallback));
				throw;
			}
			zipCallback = ref <Module>.??_7_ZipCallback@Chilkat@@6B@;
			<Module>.ZipCallback.{dtor}(ref zipCallback);
			return result;
		}

		public bool OverwriteExisting
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ZipDn.get_OverwriteExisting(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ZipDn.put_OverwriteExisting(this.m_impl, value);
			}
		}

		public unsafe void AddNoCompressExtension(string fileExtension)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(fileExtension, &xstring);
				<Module>.ZipDn.AddNoCompressExtension(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		public unsafe void RemoveNoCompressExtension(string fileExtension)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			try
			{
				CkMarshal.StringToX(fileExtension, &xstring);
				<Module>.ZipDn.RemoveNoCompressExtension(this.m_impl, ref xstring);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool IsNoCompressExtension(string fileExtension)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(fileExtension, &xstring);
				result = (<Module>.ZipDn.IsNoCompressExtension(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public bool VerboseLogging
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ZipDn.get_VerboseLogging(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ZipDn.put_VerboseLogging(this.m_impl, value);
			}
		}

		public bool IgnoreAccessDenied
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ZipDn.get_IgnoreAccessDenied(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ZipDn.put_IgnoreAccessDenied(this.m_impl, value);
			}
		}

		public bool ClearReadOnlyAttr
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ZipDn.get_ClearReadOnlyAttr(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ZipDn.put_ClearReadOnlyAttr(this.m_impl, value);
			}
		}

		public event Zip.WriteZipPercentDoneEventHandler OnWriteZipPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnWriteZipPercentDone = Delegate.Combine(this.OnWriteZipPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnWriteZipPercentDone = Delegate.Remove(this.OnWriteZipPercentDone, value);
			}
		}

		public event Zip.UnzipPercentDoneEventHandler OnUnzipPercentDone
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnUnzipPercentDone = Delegate.Combine(this.OnUnzipPercentDone, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnUnzipPercentDone = Delegate.Remove(this.OnUnzipPercentDone, value);
			}
		}

		public event Zip.ToBeAddedEventHandler OnToBeAdded
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnToBeAdded = Delegate.Combine(this.OnToBeAdded, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnToBeAdded = Delegate.Remove(this.OnToBeAdded, value);
			}
		}

		public event Zip.DirToBeAddedEventHandler OnDirToBeAdded
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnDirToBeAdded = Delegate.Combine(this.OnDirToBeAdded, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnDirToBeAdded = Delegate.Remove(this.OnDirToBeAdded, value);
			}
		}

		public event Zip.FileAddedEventHandler OnFileAdded
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnFileAdded = Delegate.Combine(this.OnFileAdded, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnFileAdded = Delegate.Remove(this.OnFileAdded, value);
			}
		}

		public event Zip.ToBeZippedEventHandler OnToBeZipped
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnToBeZipped = Delegate.Combine(this.OnToBeZipped, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnToBeZipped = Delegate.Remove(this.OnToBeZipped, value);
			}
		}

		public event Zip.FileZippedEventHandler OnFileZipped
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnFileZipped = Delegate.Combine(this.OnFileZipped, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnFileZipped = Delegate.Remove(this.OnFileZipped, value);
			}
		}

		public event Zip.ToBeUnzippedEventHandler OnToBeUnzipped
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnToBeUnzipped = Delegate.Combine(this.OnToBeUnzipped, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnToBeUnzipped = Delegate.Remove(this.OnToBeUnzipped, value);
			}
		}

		public event Zip.FileUnzippedEventHandler OnFileUnzipped
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnFileUnzipped = Delegate.Combine(this.OnFileUnzipped, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnFileUnzipped = Delegate.Remove(this.OnFileUnzipped, value);
			}
		}

		public event Zip.AddFilesBeginEventHandler OnAddFilesBegin
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAddFilesBegin = Delegate.Combine(this.OnAddFilesBegin, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAddFilesBegin = Delegate.Remove(this.OnAddFilesBegin, value);
			}
		}

		public event Zip.AddFilesEndEventHandler OnAddFilesEnd
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAddFilesEnd = Delegate.Combine(this.OnAddFilesEnd, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAddFilesEnd = Delegate.Remove(this.OnAddFilesEnd, value);
			}
		}

		public event Zip.WriteZipBeginEventHandler OnWriteZipBegin
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnWriteZipBegin = Delegate.Combine(this.OnWriteZipBegin, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnWriteZipBegin = Delegate.Remove(this.OnWriteZipBegin, value);
			}
		}

		public event Zip.AbortCheckEventHandler OnAbortCheck
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnAbortCheck = Delegate.Combine(this.OnAbortCheck, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnAbortCheck = Delegate.Remove(this.OnAbortCheck, value);
			}
		}

		public event Zip.WriteZipEndEventHandler OnWriteZipEnd
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnWriteZipEnd = Delegate.Combine(this.OnWriteZipEnd, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnWriteZipEnd = Delegate.Remove(this.OnWriteZipEnd, value);
			}
		}

		public event Zip.UnzipBeginEventHandler OnUnzipBegin
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnUnzipBegin = Delegate.Combine(this.OnUnzipBegin, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnUnzipBegin = Delegate.Remove(this.OnUnzipBegin, value);
			}
		}

		public event Zip.UnzipEndEventHandler OnUnzipEnd
		{
			[MethodImpl(MethodImplOptions.Synchronized)]
			add
			{
				this.OnUnzipEnd = Delegate.Combine(this.OnUnzipEnd, value);
			}
			[MethodImpl(MethodImplOptions.Synchronized)]
			remove
			{
				this.OnUnzipEnd = Delegate.Remove(this.OnUnzipEnd, value);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private static Hashtable m_zipObjects = new Hashtable();

		private static object m_lockObject = new object();

		private int m_myHashCode;

		private bool m_enableEvents;

		private object m_lockImpl;

		private unsafe ZipDn* m_impl;

		public delegate void WriteZipPercentDoneEventHandler(object sender, WriteZipPercentDoneEventArgs args);

		public delegate void UnzipPercentDoneEventHandler(object sender, UnzipPercentDoneEventArgs args);

		public delegate void ToBeAddedEventHandler(object sender, ToBeAddedEventArgs args);

		public delegate void DirToBeAddedEventHandler(object sender, DirToBeAddedEventArgs args);

		public delegate void FileAddedEventHandler(object sender, FileAddedEventArgs args);

		public delegate void ToBeZippedEventHandler(object sender, ToBeZippedEventArgs args);

		public delegate void FileZippedEventHandler(object sender, FileZippedEventArgs args);

		public delegate void ToBeUnzippedEventHandler(object sender, ToBeUnzippedEventArgs args);

		public delegate void FileUnzippedEventHandler(object sender, FileUnzippedEventArgs args);

		public delegate void AddFilesBeginEventHandler(object sender, EventArgs args);

		public delegate void AddFilesEndEventHandler(object sender, EventArgs args);

		public delegate void WriteZipBeginEventHandler(object sender, EventArgs args);

		public delegate void AbortCheckEventHandler(object sender, AbortCheckEventArgs args);

		public delegate void WriteZipEndEventHandler(object sender, EventArgs args);

		public delegate void UnzipBeginEventHandler(object sender, EventArgs args);

		public delegate void UnzipEndEventHandler(object sender, EventArgs args);
	}
}
