﻿using System;
using <CppImplementationDetails>;
using chilkat;

namespace Chilkat
{
	public class ZipCrc : IDisposable
	{
		public unsafe ZipCrc()
		{
			ZipCRC* ptr = <Module>.@new(8U);
			ZipCRC* impl;
			try
			{
				if (ptr != null)
				{
					impl = <Module>.ZipCRC.{ctor}(ptr);
				}
				else
				{
					impl = 0;
				}
			}
			catch
			{
				<Module>.delete((void*)ptr);
				throw;
			}
			this.m_impl = impl;
		}

		protected unsafe override void Finalize()
		{
			ZipCRC* impl = this.m_impl;
			if (impl != null)
			{
				ZipCRC* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
				this.m_impl = null;
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe string ToHex(uint crc)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				$ArrayType$$$BY03E $ArrayType$$$BY03E = *(ref crc + 3);
				*(ref $ArrayType$$$BY03E + 1) = *(ref crc + 2);
				*(ref $ArrayType$$$BY03E + 2) = *(ref crc + 1);
				*(ref $ArrayType$$$BY03E + 3) = crc;
				DataBuffer dataBuffer;
				<Module>.DataBuffer.{ctor}(ref dataBuffer);
				try
				{
					<Module>.DataBuffer.append(ref dataBuffer, (void*)(&$ArrayType$$$BY03E), 4);
					StringBuffer stringBuffer;
					<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
					try
					{
						<Module>.DataBuffer.toHexString(ref dataBuffer, ref stringBuffer);
						<Module>.XString.setFromAnsi(ref xstring, <Module>.chilkat.StringBuffer.getString(ref stringBuffer));
						result = CkMarshal.XToString(&xstring);
					}
					catch
					{
						<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
						throw;
					}
					<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
					throw;
				}
				<Module>.DataBuffer.{dtor}(ref dataBuffer);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe uint FileCrc(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			uint result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = <Module>.ZipCRC.fileCRC(this.m_impl, ref xstring, null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe uint CalculateCrc(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			uint result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				result = <Module>.ZipCRC.getCRC(this.m_impl, <Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer), null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe void MoreData(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				<Module>.ZipCRC.moreData(this.m_impl, <Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
		}

		public uint EndStream()
		{
			return <Module>.ZipCRC.endStream(this.m_impl);
		}

		public void BeginStream()
		{
			<Module>.ZipCRC.beginStream(this.m_impl);
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ZipCRC* m_impl;
	}
}
