﻿using System;
using System.Runtime.InteropServices;
using chilkat;

namespace Chilkat
{
	public class ZipEntry : IDisposable
	{
		public unsafe ZipEntry(void* impl)
		{
			this.m_impl = (ZipEntryDn*)impl;
		}

		private ZipEntry()
		{
			this.m_impl = null;
		}

		protected unsafe override void Finalize()
		{
			ZipEntryDn* impl = this.m_impl;
			if (impl != null)
			{
				ZipEntryDn* ptr = impl;
				object obj = calli(System.Void* modopt(System.Runtime.CompilerServices.CallConvThiscall)(System.IntPtr,System.UInt32), ptr, 1, *(*(int*)ptr));
			}
		}

		public virtual void Dispose()
		{
		}

		public unsafe void* GetImplementation()
		{
			return (void*)this.m_impl;
		}

		public unsafe string LastErrorText
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipEntryDn.GetLogText(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorXml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipEntryDn.GetLogXml(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		public unsafe string LastErrorHtml
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipEntryDn.GetLogHtml(this.m_impl, ref xstring, true);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool SaveLastError(string filename)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(filename, &xstring);
				result = (<Module>.ZipEntryDn.SaveXmlLog(this.m_impl, ref xstring) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string FileName
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipEntryDn.get_FileName(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipEntryDn.put_FileName(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public uint UncompressedLength
		{
			get
			{
				return <Module>.ZipEntryDn.get_UncompressedLength(this.m_impl);
			}
		}

		public bool TextFlag
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ZipEntryDn.get_TextFlag(this.m_impl) != null;
			}
			[param: MarshalAs(UnmanagedType.U1)]
			set
			{
				<Module>.ZipEntryDn.put_TextFlag(this.m_impl, value);
			}
		}

		public int CompressionLevel
		{
			get
			{
				return <Module>.ZipEntryDn.get_CompressionLevel(this.m_impl);
			}
			set
			{
				<Module>.ZipEntryDn.put_CompressionLevel(this.m_impl, value);
			}
		}

		public int CompressionMethod
		{
			get
			{
				return <Module>.ZipEntryDn.get_CompressionMethod(this.m_impl);
			}
			set
			{
				<Module>.ZipEntryDn.put_CompressionMethod(this.m_impl, value);
			}
		}

		public uint CompressedLength
		{
			get
			{
				return <Module>.ZipEntryDn.get_CompressedLength(this.m_impl);
			}
		}

		public uint Crc
		{
			get
			{
				return <Module>.ZipEntryDn.get_Crc(this.m_impl);
			}
		}

		public unsafe string Comment
		{
			get
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				string result;
				try
				{
					<Module>.ZipEntryDn.get_Comment(this.m_impl, ref xstring);
					result = CkMarshal.XToString(&xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
				return result;
			}
			set
			{
				XString xstring;
				<Module>.XString.{ctor}(ref xstring);
				try
				{
					CkMarshal.StringToX(value, &xstring);
					<Module>.ZipEntryDn.put_Comment(this.m_impl, ref xstring);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring);
			}
		}

		public int EntryType
		{
			get
			{
				return <Module>.ZipEntryDn.get_EntryType(this.m_impl);
			}
		}

		public unsafe DateTime FileDateTime
		{
			get
			{
				int num = (int)stackalloc byte[<Module>.__CxxQueryExceptionSize()];
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				<Module>.ZipEntryDn.get_FileDateTime(this.m_impl, ref year);
				DateTime result = default(DateTime);
				uint exceptionCode;
				try
				{
					DateTime dateTime = new DateTime(year, (int)(*(ref year + 2)), (int)(*(ref year + 6)), (int)(*(ref year + 8)), (int)(*(ref year + 10)), (int)(*(ref year + 12)), (int)(*(ref year + 14)));
					result = dateTime;
				}
				catch when (delegate
				{
					// Failed to create a 'catch-when' expression
					exceptionCode = (uint)Marshal.GetExceptionCode();
					endfilter(<Module>.__CxxExceptionFilter(Marshal.GetExceptionPointers(), null, 0, null) != null);
				})
				{
					uint num2 = 0U;
					<Module>.__CxxRegisterExceptionObject(Marshal.GetExceptionPointers(), num);
					try
					{
						try
						{
							return DateTime.Now;
						}
						catch when (delegate
						{
							// Failed to create a 'catch-when' expression
							num2 = <Module>.__CxxDetectRethrow(Marshal.GetExceptionPointers());
							endfilter(num2 != 0U);
						})
						{
						}
						if (num2 != 0U)
						{
							throw;
						}
					}
					finally
					{
						<Module>.__CxxUnregisterExceptionObject(num, (int)num2);
					}
				}
				return result;
			}
			set
			{
				ChilkatSysTime year;
				<Module>.ChilkatSysTime.{ctor}(ref year);
				year = value.Year;
				*(ref year + 2) = (short)value.Month;
				*(ref year + 6) = (short)value.Day;
				*(ref year + 8) = (short)value.Hour;
				*(ref year + 10) = (short)value.Minute;
				*(ref year + 12) = (short)value.Second;
				<Module>.ZipEntryDn.put_FileDateTime(this.m_impl, ref year);
			}
		}

		public bool IsDirectory
		{
			[return: MarshalAs(UnmanagedType.U1)]
			get
			{
				return <Module>.ZipEntryDn.get_IsDirectory(this.m_impl) != null;
			}
		}

		public int EntryID
		{
			get
			{
				return <Module>.ZipEntryDn.get_EntryID(this.m_impl);
			}
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool Extract(string dirPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				result = (<Module>.ZipEntryDn.Extract(this.m_impl, ref xstring, null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ExtractInto(string dirPath)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			bool result;
			try
			{
				CkMarshal.StringToX(dirPath, &xstring);
				result = (<Module>.ZipEntryDn.ExtractInto(this.m_impl, ref xstring, null) != null);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe string InflateToString([MarshalAs(UnmanagedType.U1)] bool addCR)
		{
			StringBuffer stringBuffer;
			<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
			string result;
			try
			{
				<Module>.ZipEntryDn.InflateToStringAnsi(this.m_impl, addCR, ref stringBuffer);
				result = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
				throw;
			}
			<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
			return result;
		}

		public unsafe string InflateToString2()
		{
			StringBuffer stringBuffer;
			<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
			string result;
			try
			{
				<Module>.ZipEntryDn.InflateToStringAnsi2(this.m_impl, ref stringBuffer);
				result = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
				throw;
			}
			<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
			return result;
		}

		public unsafe string InflateToString3(string srcCharset)
		{
			XString xstring;
			<Module>.XString.{ctor}(ref xstring);
			string result;
			try
			{
				CkMarshal.StringToX(srcCharset, &xstring);
				XString xstring2;
				<Module>.XString.{ctor}(ref xstring2);
				try
				{
					<Module>.ZipEntryDn.InflateToUnicode(this.m_impl, <Module>.XString.getUtf8(ref xstring), ref xstring2);
					result = CkMarshal.XToString(&xstring2);
				}
				catch
				{
					<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring2));
					throw;
				}
				<Module>.XString.{dtor}(ref xstring2);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(XString.{dtor}), (void*)(&xstring));
				throw;
			}
			<Module>.XString.{dtor}(ref xstring);
			return result;
		}

		public unsafe byte[] Inflate()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				if (<Module>.ZipEntryDn.Inflate(this.m_impl, ref dataBuffer) == null)
				{
					<Module>.DataBuffer.clear(ref dataBuffer);
				}
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe byte[] Copy()
		{
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			byte[] result;
			try
			{
				if (<Module>.ZipEntryDn.Copy(this.m_impl, ref dataBuffer) == null)
				{
					<Module>.DataBuffer.clear(ref dataBuffer);
				}
				result = CkMarshal.UnmanagedToManaged(<Module>.DataBuffer.getData2(ref dataBuffer), <Module>.DataBuffer.getSize(ref dataBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool ReplaceData(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				result = (<Module>.ZipEntryDn.ReplaceData(this.m_impl, ref dataBuffer) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		[return: MarshalAs(UnmanagedType.U1)]
		public unsafe bool AppendData(byte[] inData)
		{
			int num = 0;
			void* ptr = CkMarshal.ManagedToUnmanaged(inData, ref num);
			DataBuffer dataBuffer;
			<Module>.DataBuffer.{ctor}(ref dataBuffer);
			bool result;
			try
			{
				<Module>.DataBuffer.borrowData(ref dataBuffer, ptr, num);
				result = (<Module>.ZipEntryDn.AppendData(this.m_impl, ref dataBuffer) != null);
				CkMarshal.free(ptr);
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(DataBuffer.{dtor}), (void*)(&dataBuffer));
				throw;
			}
			<Module>.DataBuffer.{dtor}(ref dataBuffer);
			return result;
		}

		public unsafe string CopyToBase64()
		{
			StringBuffer stringBuffer;
			<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
			string result;
			try
			{
				<Module>.ZipEntryDn.CopyToBase64(this.m_impl, ref stringBuffer);
				result = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
				throw;
			}
			<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
			return result;
		}

		public unsafe string CopyToHex()
		{
			StringBuffer stringBuffer;
			<Module>.chilkat.StringBuffer.{ctor}(ref stringBuffer);
			string result;
			try
			{
				<Module>.ZipEntryDn.CopyToHex(this.m_impl, ref stringBuffer);
				result = CkMarshal.AnsiToString(<Module>.chilkat.StringBuffer.getString(ref stringBuffer));
			}
			catch
			{
				<Module>.___CxxCallUnwindDtor(ldftn(chilkat.StringBuffer.{dtor}), (void*)(&stringBuffer));
				throw;
			}
			<Module>.chilkat.StringBuffer.{dtor}(ref stringBuffer);
			return result;
		}

		public unsafe ZipEntry NextEntry()
		{
			ZipEntryDn* ptr = <Module>.ZipEntryDn.NextEntry(this.m_impl);
			if (ptr == null)
			{
				return null;
			}
			return new ZipEntry((void*)ptr);
		}

		public long CompressedLength64
		{
			get
			{
				return <Module>.ZipEntryDn.get_CompressedLength64(this.m_impl);
			}
		}

		public long UncompressedLength64
		{
			get
			{
				return <Module>.ZipEntryDn.get_UncompressedLength64(this.m_impl);
			}
		}

		public void {dtor}()
		{
			GC.SuppressFinalize(this);
			this.Finalize();
		}

		private unsafe ZipEntryDn* m_impl;
	}
}
