﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Net.Sockets;
using System.Threading;
using System.Windows.Forms;

namespace Server
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			this.InitializeComponent();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			if (this.textBox2.Text.Length > 0)
			{
				if (this.button1.Text == "Start")
				{
					this.tcpListener = new TcpListener(Convert.ToInt32(this.textBox2.Text));
					this.tcpListener.Start();
					this.button1.Text = "Stop";
					this.listBox1.Items.Clear();
					this.listBox1.ForeColor = Color.White;
					this.listBox1.Items.Add("Server Start");
					this.tsend = new Thread(new ThreadStart(this.send));
					this.tsock = new Thread(new ThreadStart(this.sock));
					this.tsock.Start();
				}
				else
				{
					if (this.socketForClient == null)
					{
						this.tsend.Abort();
					}
					else if (this.socketForClient.Connected)
					{
						this.tsend.Abort();
						this.socketForClient.Shutdown(SocketShutdown.Both);
					}
					this.tcpListener.Stop();
					this.button1.Text = "Start";
				}
			}
			else
			{
				MessageBox.Show("Введите порт", "Ошыбка", MessageBoxButtons.OK, MessageBoxIcon.Hand);
			}
		}

		public void send()
		{
			try
			{
				Application.DoEvents();
				if (this.socketForClient.Connected)
				{
					for (;;)
					{
						this.listBox1.TopIndex = this.listBox1.Items.Count - 1;
						this.listBox1.Items.Add(this.streamReader.ReadLine());
					}
				}
			}
			catch
			{
				this.socketForClient.Close();
				this.listBox1.Items.Add("Client disconnected");
				this.listBox1.ForeColor = Color.White;
				this.listBox1.TopIndex = this.listBox1.Items.Count - 1;
				this.tsend = null;
				this.tsock = null;
				this.tsend = new Thread(new ThreadStart(this.send));
				this.tsock = new Thread(new ThreadStart(this.sock));
				this.tsock.Start();
			}
		}

		public void sock()
		{
			try
			{
				this.socketForClient = this.tcpListener.AcceptSocket();
				this.listBox1.ForeColor = Color.YellowGreen;
				this.listBox1.Items.Add("Client Find");
				this.networkStream = new NetworkStream(this.socketForClient);
				this.streamWriter = new StreamWriter(this.networkStream);
				this.streamReader = new StreamReader(this.networkStream);
				this.tsend.Start();
			}
			catch (Exception ex)
			{
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			try
			{
				if (this.socketForClient.Connected)
				{
					this.tsend = null;
					this.tsock = null;
					this.socketForClient.Disconnect(false);
					this.socketForClient.Shutdown(SocketShutdown.Both);
					this.tsend = new Thread(new ThreadStart(this.send));
					this.tsock = new Thread(new ThreadStart(this.sock));
					this.tsock.Start();
				}
			}
			catch (Exception ex)
			{
			}
		}

		private void textBox1_KeyDown(object sender, KeyEventArgs e)
		{
			try
			{
				if (e.KeyValue == 13)
				{
					this.streamWriter.WriteLine(this.textBox1.Text);
					this.listBox1.Items.Add(this.textBox1.Text);
					this.streamWriter.Flush();
					this.textBox1.Text = null;
				}
			}
			catch
			{
			}
		}

		private void Form1_FormClosing(object sender, FormClosingEventArgs e)
		{
			try
			{
				if (this.socketForClient.Connected)
				{
					this.tsend.Abort();
					this.socketForClient.Shutdown(SocketShutdown.Both);
				}
				else
				{
					this.tcpListener.Stop();
				}
			}
			catch
			{
			}
		}

		private void button3_Click(object sender, EventArgs e)
		{
		}

		private TcpListener tcpListener;

		private Socket socketForClient;

		private NetworkStream networkStream;

		private StreamWriter streamWriter;

		private StreamReader streamReader;

		private Thread tsend;

		private Thread tsock;
	}
}
