﻿using System;
using System.Collections.ObjectModel;
using System.Text;

namespace System.Net.PeerToPeer.Collaboration
{
	[Serializable]
	public class PeerContactCollection : Collection<PeerContact>
	{
		internal PeerContactCollection()
		{
		}

		protected override void SetItem(int index, PeerContact item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.SetItem(index, item);
		}

		protected override void InsertItem(int index, PeerContact item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.InsertItem(index, item);
		}

		public override string ToString()
		{
			bool flag = true;
			StringBuilder stringBuilder = new StringBuilder();
			foreach (PeerContact peerContact in this)
			{
				if (!flag)
				{
					stringBuilder.Append(", ");
				}
				else
				{
					flag = false;
				}
				stringBuilder.Append(peerContact.ToString());
			}
			return stringBuilder.ToString();
		}
	}
}
