﻿using System;
using System.Collections.ObjectModel;
using System.Text;

namespace System.Net.PeerToPeer.Collaboration
{
	[Serializable]
	public class PeerEndPointCollection : Collection<PeerEndPoint>, IEquatable<PeerEndPointCollection>
	{
		internal PeerEndPointCollection()
		{
		}

		protected override void SetItem(int index, PeerEndPoint item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.SetItem(index, item);
		}

		protected override void InsertItem(int index, PeerEndPoint item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.InsertItem(index, item);
		}

		public override string ToString()
		{
			bool flag = true;
			StringBuilder stringBuilder = new StringBuilder();
			foreach (PeerEndPoint peerEndPoint in this)
			{
				if (!flag)
				{
					stringBuilder.Append(", ");
				}
				else
				{
					flag = false;
				}
				stringBuilder.Append(peerEndPoint.ToString());
			}
			return stringBuilder.ToString();
		}

		public bool Equals(PeerEndPointCollection other)
		{
			bool result = false;
			if (other != null)
			{
				foreach (PeerEndPoint peerEndPoint in other)
				{
					foreach (PeerEndPoint other2 in this)
					{
						if (!peerEndPoint.Equals(other2))
						{
							return result;
						}
					}
				}
				result = true;
			}
			return result;
		}
	}
}
