﻿using System;
using System.Collections.ObjectModel;
using System.Text;

namespace System.Net.PeerToPeer.Collaboration
{
	[Serializable]
	public class PeerNearMeCollection : Collection<PeerNearMe>
	{
		internal PeerNearMeCollection()
		{
		}

		protected override void SetItem(int index, PeerNearMe item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.SetItem(index, item);
		}

		protected override void InsertItem(int index, PeerNearMe item)
		{
			if (item == null)
			{
				throw new ArgumentNullException("item");
			}
			base.InsertItem(index, item);
		}

		public override string ToString()
		{
			bool flag = true;
			StringBuilder stringBuilder = new StringBuilder();
			foreach (PeerNearMe peerNearMe in this)
			{
				if (!flag)
				{
					stringBuilder.Append(", ");
				}
				else
				{
					flag = false;
				}
				stringBuilder.Append(peerNearMe.ToString());
			}
			return stringBuilder.ToString();
		}
	}
}
