﻿using System;
using System.Security;
using Microsoft.Win32.SafeHandles;

namespace System.Net.PeerToPeer.Collaboration
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafeCertStore : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafeCertStore() : base(true)
		{
		}

		protected override bool ReleaseHandle()
		{
			if (!this.IsInvalid)
			{
				UnsafeCollabNativeMethods.CertCloseStore(this.handle, 0U);
			}
			base.SetHandleAsInvalid();
			base.SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
