﻿using System;
using System.Security;
using Microsoft.Win32.SafeHandles;

namespace System.Net.PeerToPeer.Collaboration
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafeCollabEvent : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafeCollabEvent() : base(true)
		{
		}

		protected override bool ReleaseHandle()
		{
			UnsafeCollabNativeMethods.PeerCollabUnregisterEvent(this.handle);
			base.SetHandleAsInvalid();
			base.SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
