﻿using System;
using System.Security;
using Microsoft.Win32.SafeHandles;

namespace System.Net.PeerToPeer.Collaboration
{
	[SuppressUnmanagedCodeSecurity]
	[SecurityCritical(SecurityCriticalScope.Everything)]
	internal sealed class SafeCollabInvite : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafeCollabInvite() : base(true)
		{
		}

		protected override bool ReleaseHandle()
		{
			if (!this.IsInvalid)
			{
				UnsafeCollabNativeMethods.PeerCollabCloseHandle(this.handle);
			}
			base.SetHandleAsInvalid();
			base.SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
