﻿using System;
using System.Security;
using System.Security.Permissions;

namespace System.Net.PeerToPeer
{
	internal static class PeerToPeerOSHelper
	{
		[SecurityCritical]
		static PeerToPeerOSHelper()
		{
			PeerToPeerOSHelper.s_P2PLibrary = SafeLoadLibrary.LoadLibraryEx("p2p.dll");
			if (!PeerToPeerOSHelper.s_P2PLibrary.IsInvalid)
			{
				IntPtr procAddress = UnsafeSystemNativeMethods.GetProcAddress(PeerToPeerOSHelper.s_P2PLibrary, "PeerCreatePeerName");
				if (procAddress != IntPtr.Zero)
				{
					PeerToPeerOSHelper.s_supportsP2P = true;
				}
			}
		}

		internal static bool SupportsP2P
		{
			get
			{
				return PeerToPeerOSHelper.s_supportsP2P;
			}
		}

		internal static IntPtr P2PModuleHandle
		{
			[SecurityCritical]
			[SecurityPermission(SecurityAction.LinkDemand, UnmanagedCode = true)]
			get
			{
				IntPtr result;
				if (!PeerToPeerOSHelper.s_P2PLibrary.IsClosed && !PeerToPeerOSHelper.s_P2PLibrary.IsInvalid)
				{
					result = PeerToPeerOSHelper.s_P2PLibrary.DangerousGetHandle();
				}
				else
				{
					result = IntPtr.Zero;
				}
				return result;
			}
		}

		private static bool s_supportsP2P = false;

		private static SafeLoadLibrary s_P2PLibrary = null;
	}
}
