﻿using System;
using System.Security;
using System.Security.Permissions;

namespace System.Net.PeerToPeer
{
	[AttributeUsage(AttributeTargets.Assembly | AttributeTargets.Class | AttributeTargets.Struct | AttributeTargets.Constructor | AttributeTargets.Method, AllowMultiple = true, Inherited = false)]
	[Serializable]
	public sealed class PnrpPermissionAttribute : CodeAccessSecurityAttribute
	{
		public PnrpPermissionAttribute(SecurityAction action) : base(action)
		{
		}

		public override IPermission CreatePermission()
		{
			IPermission result;
			if (base.Unrestricted)
			{
				result = new PnrpPermission(PermissionState.Unrestricted);
			}
			else
			{
				result = new PnrpPermission(PermissionState.None);
			}
			return result;
		}
	}
}
