﻿using System;
using System.Runtime.InteropServices;
using System.Security;
using Microsoft.Win32.SafeHandles;

namespace System.Net.PeerToPeer
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafePeerData : SafeHandleZeroOrMinusOneIsInvalid
	{
		private SafePeerData() : base(true)
		{
		}

		internal string UnicodeString
		{
			get
			{
				return Marshal.PtrToStringUni(this.handle);
			}
		}

		protected override bool ReleaseHandle()
		{
			UnsafeP2PNativeMethods.PeerFreeData(this.handle);
			base.SetHandleAsInvalid();
			base.SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
