﻿using System;
using System.Security;
using Microsoft.Win32.SafeHandles;

namespace System.Net.PeerToPeer
{
	[SecurityCritical(SecurityCriticalScope.Everything)]
	[SuppressUnmanagedCodeSecurity]
	internal sealed class SafePeerNameUnregister : SafeHandleZeroOrMinusOneIsInvalid
	{
		internal SafePeerNameUnregister() : base(true)
		{
		}

		protected override bool ReleaseHandle()
		{
			UnsafeP2PNativeMethods.PeerPnrpUnregister(this.handle);
			base.SetHandleAsInvalid();
			base.SetHandle(IntPtr.Zero);
			return true;
		}
	}
}
