﻿using System;
using System.Security;
using Microsoft.Win32.SafeHandles;

namespace System.Net
{
	[SuppressUnmanagedCodeSecurity]
	[SecurityCritical(SecurityCriticalScope.Everything)]
	internal sealed class SafeLoadLibrary : SafeHandleZeroOrMinusOneIsInvalid
	{
		private SafeLoadLibrary() : base(true)
		{
		}

		internal static SafeLoadLibrary LoadLibraryEx(string library)
		{
			SafeLoadLibrary safeLoadLibrary = UnsafeSystemNativeMethods.LoadLibraryExW(library, null, 0U);
			if (safeLoadLibrary.IsInvalid)
			{
				safeLoadLibrary.SetHandleAsInvalid();
			}
			return safeLoadLibrary;
		}

		protected override bool ReleaseHandle()
		{
			return UnsafeSystemNativeMethods.FreeLibrary(this.handle);
		}

		private const string KERNEL32 = "kernel32.dll";
	}
}
