﻿using System;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.Security;

namespace System.Net
{
	[SuppressUnmanagedCodeSecurity]
	internal static class UnsafeSystemNativeMethods
	{
		[SecurityCritical]
		[DllImport("KERNEL32.dll", CharSet = CharSet.Unicode, ExactSpelling = true, SetLastError = true)]
		internal unsafe static extern SafeLoadLibrary LoadLibraryExW(string lpwLibFileName, [In] void* hFile, uint dwFlags);

		[ReliabilityContract(Consistency.WillNotCorruptState, Cer.Success)]
		[DllImport("KERNEL32.dll", ExactSpelling = true, SetLastError = true)]
		[return: MarshalAs(UnmanagedType.Bool)]
		internal static extern bool FreeLibrary(IntPtr hModule);

		[SecurityCritical]
		[DllImport("KERNEL32.dll", BestFitMapping = false, SetLastError = true)]
		internal static extern IntPtr GetProcAddress(SafeLoadLibrary hModule, string entryPoint);

		[DllImport("KERNEL32.dll", CharSet = CharSet.Unicode)]
		internal static extern uint FormatMessage(FormatMessageFlags dwFlags, IntPtr lpSource, uint dwMessageId, uint dwLanguageId, ref IntPtr lpBuffer, uint nSize, IntPtr vaArguments);

		[DllImport("KERNEL32.dll", CharSet = CharSet.Unicode)]
		internal static extern uint LocalFree(IntPtr lpMem);

		private const string KERNEL32 = "KERNEL32.dll";
	}
}
