﻿using System;
using System.Globalization;
using System.Resources;
using System.Threading;

namespace System
{
	internal sealed class SR
	{
		internal SR()
		{
			this.resources = new ResourceManager("System.Net", base.GetType().Assembly);
		}

		private static SR GetLoader()
		{
			if (SR.loader == null)
			{
				SR value = new SR();
				Interlocked.CompareExchange<SR>(ref SR.loader, value, null);
			}
			return SR.loader;
		}

		private static CultureInfo Culture
		{
			get
			{
				return null;
			}
		}

		public static ResourceManager Resources
		{
			get
			{
				return SR.GetLoader().resources;
			}
		}

		public static string GetString(string name, params object[] args)
		{
			SR sr = SR.GetLoader();
			string result;
			if (sr == null)
			{
				result = null;
			}
			else
			{
				string @string = sr.resources.GetString(name, SR.Culture);
				if (args != null && args.Length > 0)
				{
					for (int i = 0; i < args.Length; i++)
					{
						string text = args[i] as string;
						if (text != null && text.Length > 1024)
						{
							args[i] = text.Substring(0, 1021) + "...";
						}
					}
					result = string.Format(CultureInfo.CurrentCulture, @string, args);
				}
				else
				{
					result = @string;
				}
			}
			return result;
		}

		public static string GetString(string name)
		{
			SR sr = SR.GetLoader();
			string result;
			if (sr == null)
			{
				result = null;
			}
			else
			{
				result = sr.resources.GetString(name, SR.Culture);
			}
			return result;
		}

		public static object GetObject(string name)
		{
			SR sr = SR.GetLoader();
			object result;
			if (sr == null)
			{
				result = null;
			}
			else
			{
				result = sr.resources.GetObject(name, SR.Culture);
			}
			return result;
		}

		internal const string NullUserToken = "NullUserToken";

		internal const string DuplicateUserToken = "DuplicateUserToken";

		internal const string InvalidSecurityElem = "InvalidSecurityElem";

		internal const string InvalidSecurityElemNoClass = "InvalidSecurityElemNoClass";

		internal const string InvalidSecurityElemNoType = "InvalidSecurityElemNoType";

		internal const string SynchronizingObject = "SynchronizingObject";

		internal const string MemoryAllocFailed = "MemoryAllocFailed";

		internal const string PnrpPermission_CantUnionWithNonPnrpPermission = "PnrpPermission_CantUnionWithNonPnrpPermission";

		internal const string PnrpPermission_CantIntersectWithNonPnrpPermission = "PnrpPermission_CantIntersectWithNonPnrpPermission";

		internal const string PnrpPermission_TargetNotAPnrpPermission = "PnrpPermission_TargetNotAPnrpPermission";

		internal const string Pnrp_StartupFailed = "Pnrp_StartupFailed";

		internal const string Pnrp_CommentMaxLengthExceeded = "Pnrp_CommentMaxLengthExceeded";

		internal const string Pnrp_CommentCantBeNull = "Pnrp_CommentCantBeNull";

		internal const string Pnrp_CloudNameCantBeNull = "Pnrp_CloudNameCantBeNull";

		internal const string Pnrp_PeerNameCantBeNull = "Pnrp_PeerNameCantBeNull";

		internal const string Pnrp_InvalidPeerName = "Pnrp_InvalidPeerName";

		internal const string Pnrp_InvalidClassifier = "Pnrp_InvalidClassifier";

		internal const string Pnrp_InvalidPeerHostName = "Pnrp_InvalidPeerHostName";

		internal const string Pnrp_MaxRecordsParameterMustBeGreaterThanZero = "Pnrp_MaxRecordsParameterMustBeGreaterThanZero";

		internal const string Pnrp_DataCantBeNull = "Pnrp_DataCantBeNull";

		internal const string Pnrp_DataLengthExceeded = "Pnrp_DataLengthExceeded";

		internal const string Pnrp_PortOutOfRange = "Pnrp_PortOutOfRange";

		internal const string Pnrp_UseUpdateInsteadOfRegister = "Pnrp_UseUpdateInsteadOfRegister";

		internal const string Pnrp_BlobOrEndpointListNeeded = "Pnrp_BlobOrEndpointListNeeded";

		internal const string Pnrp_CallRegisterBeforeUpdate = "Pnrp_CallRegisterBeforeUpdate";

		internal const string Pnrp_CantChangePeerNameAfterRegistration = "Pnrp_CantChangePeerNameAfterRegistration";

		internal const string Pnrp_NoRegistrationFound = "Pnrp_NoRegistrationFound";

		internal const string Pnrp_PeerNameCantBeResolved = "Pnrp_PeerNameCantBeResolved";

		internal const string Pnrp_CouldNotEnumerateClouds = "Pnrp_CouldNotEnumerateClouds";

		internal const string Pnrp_CouldNotCreateUnsecuredPeerName = "Pnrp_CouldNotCreateUnsecuredPeerName";

		internal const string Pnrp_CouldNotCreateSecuredPeerName = "Pnrp_CouldNotCreateSecuredPeerName";

		internal const string Pnrp_CouldNotGetDefaultIdentity = "Pnrp_CouldNotGetDefaultIdentity";

		internal const string Pnrp_CouldNotGetPeerNameFromPeerHostName = "Pnrp_CouldNotGetPeerNameFromPeerHostName";

		internal const string Pnrp_CouldNotCreateRelativePeerName = "Pnrp_CouldNotCreateRelativePeerName";

		internal const string Pnrp_CouldNotGetPeerHostNameFromPeerName = "Pnrp_CouldNotGetPeerHostNameFromPeerName";

		internal const string Pnrp_CouldNotRegisterPeerName = "Pnrp_CouldNotRegisterPeerName";

		internal const string Pnrp_CouldNotResolvePeerName = "Pnrp_CouldNotResolvePeerName";

		internal const string Pnrp_CouldNotStartNameResolution = "Pnrp_CouldNotStartNameResolution";

		internal const string Pnrp_ExceptionWhileResolvingAPeerName = "Pnrp_ExceptionWhileResolvingAPeerName";

		internal const string Pnrp_AtleastOneEvenHandlerNeeded = "Pnrp_AtleastOneEvenHandlerNeeded";

		internal const string P2P_NotAvailable = "P2P_NotAvailable";

		internal const string Collab_StartupFailed = "Collab_StartupFailed";

		internal const string Collab_CredentialsError = "Collab_CredentialsError";

		internal const string Collab_PresenceChangedRegFailed = "Collab_PresenceChangedRegFailed";

		internal const string Collab_GetPresenceChangedDataFailed = "Collab_GetPresenceChangedDataFailed";

		internal const string Collab_PeerNearMeChangedRegFailed = "Collab_PeerNearMeChangedRegFailed";

		internal const string Collab_GetPeerNearMeChangedDataFailed = "Collab_GetPeerNearMeChangedDataFailed";

		internal const string Collab_ApplicationChangedRegFailed = "Collab_ApplicationChangedRegFailed";

		internal const string Collab_GetApplicationChangedDataFailed = "Collab_GetApplicationChangedDataFailed";

		internal const string Collab_ObjectChangedRegFailed = "Collab_ObjectChangedRegFailed";

		internal const string Collab_GetObjectChangedDataFailed = "Collab_GetObjectChangedDataFailed";

		internal const string Collab_ReqStatusChangedRegFailed = "Collab_ReqStatusChangedRegFailed";

		internal const string Collab_SubListChangedRegFailed = "Collab_SubListChangedRegFailed";

		internal const string Collab_GetSubListChangedDataFailed = "Collab_GetSubListChangedDataFailed";

		internal const string Collab_NameChangedRegFailed = "Collab_NameChangedRegFailed";

		internal const string Collab_GetNameChangedDataFailed = "Collab_GetNameChangedDataFailed";

		internal const string Collab_GetContactsFailed = "Collab_GetContactsFailed";

		internal const string Collab_ContactNotFound = "Collab_ContactNotFound";

		internal const string Collab_ContactExists = "Collab_ContactExists";

		internal const string Collab_GetContactFailed = "Collab_GetContactFailed";

		internal const string Collab_NoEndpointFound = "Collab_NoEndpointFound";

		internal const string Collab_NoEndPointInPeerEndPoint = "Collab_NoEndPointInPeerEndPoint";

		internal const string Collab_CreateContactFailed = "Collab_CreateContactFailed";

		internal const string Collab_AddContactFailed = "Collab_AddContactFailed";

		internal const string Collab_AddContactFailedNoXml = "Collab_AddContactFailedNoXml";

		internal const string Collab_DeleteContactFailed = "Collab_DeleteContactFailed";

		internal const string Collab_NoPeerNameInContact = "Collab_NoPeerNameInContact";

		internal const string Collab_UpdateContactFailed = "Collab_UpdateContactFailed";

		internal const string Collab_SubscribeLocalContactFailed = "Collab_SubscribeLocalContactFailed";

		internal const string Collab_DuplicateSubscribeAsync = "Collab_DuplicateSubscribeAsync";

		internal const string Collab_DuplicateRefreshAsync = "Collab_DuplicateRefreshAsync";

		internal const string Collab_UnsubscribeLocalContactFail = "Collab_UnsubscribeLocalContactFail";

		internal const string Collab_GetPresenceFailed = "Collab_GetPresenceFailed";

		internal const string Collab_GetObjectsFailed = "Collab_GetObjectsFailed";

		internal const string Collab_GetAppsFailed = "Collab_GetAppsFailed";

		internal const string Collab_InviteFailed = "Collab_InviteFailed";

		internal const string Collab_AsyncInviteFailed = "Collab_AsyncInviteFailed";

		internal const string Collab_AsyncInviteException = "Collab_AsyncInviteException";

		internal const string Collab_SetLocalPresenceFailed = "Collab_SetLocalPresenceFailed";

		internal const string Collab_SetLocalEndPointNameFailed = "Collab_SetLocalEndPointNameFailed";

		internal const string Collab_SignInWithNone = "Collab_SignInWithNone";

		internal const string Collab_SignInFailed = "Collab_SignInFailed";

		internal const string Collab_SignOutFailed = "Collab_SignOutFailed";

		internal const string Collab_GetPeersNearMeFailed = "Collab_GetPeersNearMeFailed";

		internal const string Collab_AppRegNoPathError = "Collab_AppRegNoPathError";

		internal const string Collab_AppRegFailed = "Collab_AppRegFailed";

		internal const string Collab_AppExists = "Collab_AppExists";

		internal const string Collab_EmptyGuidError = "Collab_EmptyGuidError";

		internal const string Collab_AppUnregFailed = "Collab_AppUnregFailed";

		internal const string Collab_GetLocalAppsFailed = "Collab_GetLocalAppsFailed";

		internal const string Collab_ObjectSetFailed = "Collab_ObjectSetFailed";

		internal const string Collab_ObjectExists = "Collab_ObjectExists";

		internal const string Collab_ObjectDeleteFailed = "Collab_ObjectDeleteFailed";

		internal const string Collab_GetLocalObjectsFailed = "Collab_GetLocalObjectsFailed";

		internal const string Collab_PermissionUnionError = "Collab_PermissionUnionError";

		internal const string Collab_PermissionIntersectError = "Collab_PermissionIntersectError";

		internal const string Collab_BadPermissionTarget = "Collab_BadPermissionTarget";

		internal const string Collab_ContactToXmlFailed = "Collab_ContactToXmlFailed";

		internal const string Collab_ContactFromXmlFailed = "Collab_ContactFromXmlFailed";

		internal const string Collab_NoGuidForCurrApp = "Collab_NoGuidForCurrApp";

		internal const string Collab_EndPointNotIPv6Error = "Collab_EndPointNotIPv6Error";

		internal const string Collab_AddToContactMgrFailed = "Collab_AddToContactMgrFailed";

		internal const string Collab_AddToContactMgrFailedUpdate = "Collab_AddToContactMgrFailedUpdate";

		internal const string Collab_EndPointNotAPeerNearMe = "Collab_EndPointNotAPeerNearMe";

		internal const string Collab_RefreshDataFailed = "Collab_RefreshDataFailed";

		internal const string Collab_SubscribeFailed = "Collab_SubscribeFailed";

		internal const string Collab_UnsubscribeFailed = "Collab_UnsubscribeFailed";

		internal const string Collab_SetPresenceOffline = "Collab_SetPresenceOffline";

		internal const string Collab_ApplicationDataSizeFailed = "Collab_ApplicationDataSizeFailed";

		internal const string Collab_ObjectDataSizeFailed = "Collab_ObjectDataSizeFailed";

		private static SR loader;

		private ResourceManager resources;
	}
}
